/*
#include "myowlall.h"
#include "baptiall.h"
#include "cattoall.h"

#pragma hdrstop
*/

#define MODULE_NAME "ANALTEX.CPP"
 /**********************************************************************
     --------------------------------------------------------------------
         Fonction       : Localisation de code barre 2D par analyse
                              de texture et reconstruction gomtrique
    --------------------------------------------------------------------
        Auteur         : Sbastien Delestaing
        Dvelopp le   : Avril 1996 - Septembre 1996

    *********************************************************************/

//#include <math.h>
//#include <values.h>
#include "wgttsi.h"

   #include "wsysutil.h"
   #include "wappbase.h"

   #include "wmain.h"                 // Librairies Image
   #include "wlmodif.h"
   #include "wlcarpro.h"

   #include "wbase.h"

   #include "wintrac.h"
   //#include "wedtderv.h"
   #include "wsystool.h"
   #include "wgeometr.h"

   #include "sysctr.h"
   #include "scaltool.h"
   #include "symbole.h"
   #include "wiris.h"
   #include "wlfilt.h"

   #include "analtex.h"
//   #include "wcortex.h"
//   #include "ctxsup.h"
   #include "cortex.rch"

   #include "contour.h"
#include "piadiv.h"
#include "poly.h"
#include "analtex.h"
#include "cortex.rch"

//#include "ctxoutil.h"
// ---------------------- Variables Globales -------------------------
// Seuils parametrables pour l'analyse de texture
#define TEX_SCAN_POLY_WithinPolygon 0x80 // 1<<7
#define TEX_SCAN_POLY_TexelTouchesPolygon 0x40 // 1<<6
#define TEX_SCAN_POLY_TexelWithinPolygon 0x20 // 1<<5
#define TEX_SCAN_POLY_TexelGoodTexture 0x10 // 1<<4
#define TEX_CoeffNormContinuite_KO 15
#define TEX_CoeffNormDensite_KN 40
#define TEX_CoeffNormProximite_KP 15

// Valeurs par dfaut.
int           seuilzc = 60 ;

int           seuil1 = 70 ;  // Contuit
int           seuil2 = 140 ; // Densit
int           seuil3 = 140 ; // Proximite

//Affichage des tapes de calcul 0:Non, 1:Source, 2:Destination

unsigned char far VisuDef[5]={ TEX_VISU_SANS, TEX_VISU_SANS
  , TEX_VISU_SANS, TEX_VISU_DESTIN
    , TEX_VISU_DESTIN }, Visu[5]={VisuDef[0],VisuDef[1],VisuDef[2]
     ,VisuDef[3],VisuDef[4]};




//0:Contour de l'objet basse rsolution
//1:Rsultat du dcodage de la chaine de Freeman
//2:Rsultat de la slection du quadrilatre
//3:Rsultat de la correction du quadrilatre
//4:Rsultat de la dtection
unsigned char uFondVisu = TEX_FOND_VISU_SOURCE ; //0:Noir, 1:Source, 2:Blanc
TRect         rTexImage = TRect(0, 0, 31, 31)
  , rTexImageWithBorder = TRect(0, 0, 32, 32);

TTexture      far *pTx = new TTexture ; // Cr au dmarage

//void VisuTextureMap(unsigned char uVisuMode, unsigned char puTextureMap[32*32], TRect r=TRect(0,0,31,31));
void          VisuTextureMap (unsigned char uVisuMode
  , unsigned char puTextureMap [32 * 32], TRect r, unsigned char *puSource
  , unsigned char *puTarget) ;

//---------------- Classe TTexture
//---------------- Classe TTexture
TTexture::TTexture ()
// Cr au dmarage, reste vivant pendant tout le programme.
{
puTexSource =  puTexTarget = puTexContour = NULL ;
}

TTexture::~TTexture () {}

// Slectionne l'image de texture puTexSource
void TTexture::SetTsrc ( int i )
{
switch ( i ) 
  {
  case 1 : 
    Tsrc = TI1 ;
    break ;
  case 2 : 
    Tsrc = TI2 ;
    break ;
  case 3 : 
    Tsrc = TI3 ;
    break ;
  case 4 : 
    Tsrc = auTI4_Vraissemblance ;
    break ;
  default : break ;
  }
}

// Slectionne l'image de texture puTexTargetation
void TTexture::SetTdst ( int i )
{
//Trace("SetTdst ", i, 104);
switch ( i ) 
  {
  
  // Tdst est un pointeur vers la carte de texture destination.
  case 1 : 
    Tdst = TI1 ;
    break ;
  case 2 : 
    Tdst = TI2 ;
    break ;
  case 3 : 
    Tdst = TI3 ;
    break ;
  case 4 : 
    Tdst = auTI4_Vraissemblance ;
    break ;
  default : break ;
  }
}

void TTexture::CallTexture ( WPARAM id, unsigned char *puSource
    , unsigned char *puTarget, unsigned char *puContour )
{

// Empilage des pointeurs actuels de travail de texture
unsigned char *puStackSource = puTexSource, *puStackTarget = puTexTarget
  , *puStackContour = puTexContour ;

// Assignation des pointeurs de travail de texture  aux plans  traiter
puTexSource  =  puSource ;
puTexTarget  =  puTarget ;
puTexContour =  puContour ;
CmTexture(id); // Appel de la fonction prive qui va travailler avec les pointeurs de travail

// Restitution des anciennes valeurs des pointeurs de travail de texture
puTexSource  =  puStackSource ;
puTexTarget  =  puStackTarget ;
puTexContour =  puStackContour ;
}

void TTexture::CmTexture ( WPARAM id )
{
if ( id != CM_COMPACITE ) 
  {
  
  //    pContour=puTexContour; //PlanSuiv( puTexTarget );
  CalculeZCLaplacien(puTexSource, puTexContour, LAPLACIEN_CHAR_4, seuilzc);
  }
SetTdst(1);
SetTsrc(1);
switch ( id ) 
  {
  case CM_DENSITE :
    Densite();
    ShowTI();
    break ;
  case CM_GRANULARITE : 
    Granularite();
    ShowTI();
    break ;
  case CM_DISCONTINUITE : 
    Discontinuite();
    ShowTI();
    break ;
  case CM_CONTINUITE : 
    Continuite();
    ShowTI();
    break ;
  case CM_COMPACITE : 
    Compacite();
    ShowTI();
    break ;
  case CM_PROXIMITE : 
    Proximite();
    ShowTI();
    break ;
  case CM_VRAISSEMBLANCE : 
    CmVraissemblance(2);
    break ;
  /*
        SetTdst(1);
        Continuite();                   // TI1=Carte de continuit
        SetTdst(2);
        Densite();                              // TI2=Carte de densit
        SetTdst(3);
        Proximite();                    // TI3=Carte de Proximite
                    Vraisemblance();
     VisuTextureMap(2, auTI4_Vraissemblance); break;
     */
  case CM_DETECTION : 
    MTrace("Start detection", 166);
    SetTdst(1);
    Continuite(); // TI1=Carte de continuit
    SetTdst(2);
    Densite(); // TI2=Carte de densit
    SetTdst(3);
    MTrace("Enter Proximit", 173);
    Proximite(); // TI3=Carte de Proximite
    MTrace("Enter Detection", 173);
    Detection();
    
    //                        if (pTextureRequestor) pTextureRequestor->PostMessage(WM_COMMAND,EV_TextureReplied);
    //                  Fenetre->Visim( Fenetre, 0, puTexSource );
    MTrace("End detection", 175);
    break ;
  case CM_CONTOUR : break ;
  default : 
    ErreurCode(218);
    break ;
  }
}

// Visualisation: Initialisation du fond
void TTexture::InitFondVisu ( char uFondVisu_ )
{
for ( unsigned long int dwOffset = 0 ; dwOffset < 65536L ; dwOffset++ ) 
  {
  switch ( uFondVisu_ ) 
    {
    case TEX_FOND_VISU_NOIR : 
      puTexTarget [(unsigned int)dwOffset] = 0 ;
      break ;
    case TEX_FOND_VISU_SOURCE : 
      puTexTarget [(unsigned int)dwOffset]
        = puTexSource [(unsigned int)dwOffset];
      break ;
    case TEX_FOND_VISU_BLANC : 
      puTexTarget [(unsigned int)dwOffset] = 255 ;
      break ;
    default : break ;
    }
  }
}

TQuadrilatere TTexture::Detection ()
{
int           i, j, k, l, nobj, nDroite, nFreeman ;
int           iLongmax ;
long int      LongueurTotale, AccLong, Longmax ; //, Offset;
unsigned char nmax, max ;
TVecteur      Coin1, Coin2, milieu ;
TQuadrilatere Quadrilatere = QuadrilatereErreur
  , qResTexture = QuadrilatereErreur ;           /* PositionCode*/ 

//        qResTexture=QuadrilatereErreur;
InitFondVisu(uFondVisu);

// Calcul de la carte de dtection
Vraisemblance();
MTrace("Follow-up Vraisemblance", 208);

// Etiquetage et tri des objets
nobj =  Etiquetage();

//      Slection de l'objet de plus grande surface
if ( nobj ) 
  {
  nmax =  0 ;
  max  =  code [0][1];
  for ( i = 0 ; i < nobj ; i++ ) 
    if ( code [i][1] > max ) 
      {
      nmax =  i ;
      max  =  code [i][1];
      }
  for ( i = 0 ; i < 32 * 32 ; i++ ) 
    auTI4_Vraissemblance [i]
      =  (auTI4_Vraissemblance [i] == code [nmax][0]) ? 255 : 0 ;
  
  // Traitement morphologique
  for ( i = 0 ; i < 32 * 32 ; i++ ) 
    
    // ATTENTION: Init. du buffer OBLIGATOIRE
    TIm [i] =  0 ;
  Tsrc =  auTI4_Vraissemblance ;
  Morphologie();
  
  // Contours de l'objet basse rsolution
  Tsrc =  auTI4_Vraissemblance ;
  Tdst =  TI1 ;
  TErosion(128, 2);
  for ( i = 0 ; i < 32 * 32 ; i++ ) 
    auTI4_Vraissemblance [i] &= ~TI1 [i];
  //Visualisation: Contour en texels de 8*8
  VisuTextureMap(Visu [0], auTI4_Vraissemblance, TRect(0, 0, 31, 31)
    , puTexSource, puTexTarget);
  /*
     if( Visu[0] )
     {  if( Visu[0]==1 )
        {       Tdst=puTexSource;
        }else
        {       Tdst=puTexTarget;
        }
        for( i=0; i<32; i++ )
                for( j=0; j<32; j++)
                        for( k=0; k<8; k++ )
                                for( l=0; l<8; l++ )
                                {       Offset=(i<<3)+k + (((j<<3)+l)<<8);
                                        Tdst[(int)Offset]=auTI4_Vraissemblance[i+(j<<5)]?~Tdst[(int)Offset]:Tdst[(int)Offset];
                                }
     }
     */
  //
  //Interruption ventuelle avant calcul de la chaine de Freeman
  //            return;
  // Calcul de la chane de Freeman
  nFreeman =  Freeman();
  Trace("Freeman: ", nFreeman, 262);
  if ( nFreeman <= 1 ) 
    return QuadrilatereErreur ; // Rajout par BM.
  
  // Vectorisation de la chane de Freeman
  nDroite =  Vectorisation(nFreeman);
  Trace("Nombre de droites: ", nDroite, 268);
  if ( nDroite > 3 ) 
    {
    LongueurTotale =  0 ;
    for ( j = 0 ; j < nDroite ; j++ ) 
      {
      Trace("    Action sur droite: ", j, 273);
      Coin1 
        =  (Droite [j].droite).Intersection(
          Droite [(j + 1) % nDroite].droite);
      Coin2 
        =  (Droite [(j + 1) % nDroite].droite).Intersection(
          Droite [(j + 2) % nDroite].droite);
      
      // Bug: a7n11h15 ->  Coin2 intersec de droites confondues.
      //Visualisation: Rsultat du dcodage de la chaine de Freeman
      if ( Visu [1] ) 
        {
        if ( Visu [1] == 1 ) 
          {
          DessineLigne(puTexSource, TBipoint(Coin1, Coin2), puTexSource);
          }
        else 
          {
          DessineLigne(puTexTarget, TBipoint(Coin1, Coin2), puTexTarget);
          }
        }
      //
      Droite [(j + 1) % nDroite].A       =  Coin1 ;
      Droite [(j + 1) % nDroite].B       =  Coin2 ;
      Droite [(j + 1) % nDroite].vecteur =  TVecteur(Coin2 - Coin1);
      Droite [(j + 1) % nDroite].orglong 
        =  (Droite [(j + 1) % nDroite].vecteur).Module();
      LongueurTotale                     += Droite [(j + 1) % nDroite].orglong ;
      Droite [j].indice                  =  j ;
      }
    
    // Slection du quadrilatre approch
    MTrace("Processed droites", 295);
    LongueurTotale =  LongueurTotale >> 2 ;
    i              =  0 ;
    l              =  0 ;
    AccLong        =  0 ;
    for ( j = 0 ; j < 4 ; j++ ) 
      {
      while ( (AccLong < LongueurTotale * (j + 1)) && (l < nDroite) ) 
        AccLong += Droite [l++].orglong ;
      if ( l > 1 ) 
        if ( labs(AccLong - LongueurTotale * ((long)j + 1))
              > labs(
                AccLong - Droite [l - 1].orglong
                  - LongueurTotale * ((long)j + 1)) ) 
          {
          l-- ;
          AccLong -= Droite [l].orglong ;
          }
      Longmax  =  Droite [i].orglong ;
      iLongmax =  i ;
      k        =  i ;
      milieu   =  TVecteur(0, 0);
      for (; i < l ; i++ ) 
        {
        if ( Droite [i].orglong > Longmax ) 
          {
          Longmax  =  Droite [i].orglong ;
          iLongmax =  i ;
          }
        milieu =  milieu + Droite [i].A ;
        }
      
      // Si ce cot est morcel, on utilise le vecteur moyenne
      if ( Longmax < (LongueurTotale >> 1) ) 
        {
        milieu            =  milieu + Droite [i - 1].B ;
        milieu            =  milieu / (l - k + 1);
        Droite [j].droite 
          =  TDroite(milieu, TVecteur(Droite [l - 1].B - Droite [k].A)
            , DROITE_POINT_VECTEUR);
        }
      else 
        {
        Droite [j] =  Droite [iLongmax];
        }
      }
    MTrace("Processed quad", 329);
    for ( j = 0 ; j < 4 ; j++ ) 
      {
      Trace("\n    --Intersection j=", j, 332);
      Trace("    Droite 1 ", Droite [j].droite, 333);
      Trace("    Droite 2 ", Droite [(j + 1) % 4].droite, 334);
      }
    MTrace("Action for intersections: ", 339);
    for ( j = 0 ; j < 4 ; j++ ) 
      {
      Trace("    Intersection j=", j, 338);
      Trace("    Droite 1 ", Droite [j].droite, 343);
      Trace("    Droite 2 ", Droite [(j + 1) % 4].droite, 340);
      
      //                        Erreur("Intersection j=",j,341);
      if ( (Droite [j].droite).Paralleles(Droite [(j + 1) % 4].droite) ) 
        Erreur("Paralllisme  j=", j, 347);
      Coin1 
        =  (Droite [j].droite).Intersection(Droite [(j + 1) % 4].droite);
      Coin2 
        =  (Droite [(j + 1) % 4].droite).Intersection(
          Droite [(j + 2) % 4].droite);
      //Visualisation: Rsultat de la slection des 4 droites principales
      if ( Visu [2] ) 
        {
        if ( Visu [2] == 1 ) 
          {
          DessineLigne(puTexSource, TBipoint(Coin1, Coin2), puTexSource);
          }
        else 
          {
          DessineLigne(puTexTarget, TBipoint(Coin1, Coin2), puTexTarget);
          }
        }
      //
      Droite [(j + 1) % 4].A        =  Coin1 ;
      Droite [(j + 1) % 4].B        =  Coin2 ;
      Droite [(j + 1) % 4].vecteur  =  TVecteur(Coin2 - Coin1);
      Droite [(j + 1) % 4].longueur 
        =  (Droite [(j + 1) % 4].vecteur).Module();
      }
    //
    MTrace("Call correction", 350);
    
    // Correction des angles du quadrilatre
    Correction();
    MTrace("Follow-up correction", 350);
    for ( j = 0 ; j < 4 ; j++ ) 
      {
      Droite [j].vecteur  =  TVecteur(Droite [j].B - Droite [j].A);
      Droite [j].longueur =  (Droite [j].vecteur).Module();
      }
    Quadrilatere.A =  Droite [0].A ;
    Quadrilatere.B =  Droite [1].A ;
    Quadrilatere.C =  Droite [2].A ;
    Quadrilatere.D =  Droite [3].A ;
    //Dbug: Rsultat de la correction du quadrilatere
    MTrace("Res correction", 366);
    if ( Visu [3] ) 
      for ( j = 0 ; j < 4 ; j++ ) 
        {
        Coin1 
          =  (Droite [j].droite).Intersection(
            Droite [(j + 1) % 4].droite);
        Coin2 
          =  (Droite [(j + 1) % 4].droite).Intersection(
            Droite [(j + 2) % 4].droite);
        if ( Visu [3] == 1 ) 
          {
          DessineLigne(puTexSource, TBipoint(Coin1, Coin2), puTexSource);
          }
        else 
          {
          DessineLigne(puTexTarget, TBipoint(Coin1, Coin2), puTexTarget);
          }
        }
    //
    // Recherche des coins
    RechercheCoins(Quadrilatere, puTexContour, &qResTexture);
    MTrace("Follow-up RechercheCoins", 350);
    //Visualisation du rsultat de la dtection
    if ( Visu [4] == 1 ) 
      {
      DessineRetic(puTexSource, qResTexture.A, puTexSource);
      DessineRetic(puTexSource, qResTexture.B, puTexSource);
      DessineRetic(puTexSource, qResTexture.C, puTexSource);
      DessineRetic(puTexSource, qResTexture.D, puTexSource);
      }
    else if ( Visu [4] == 2 ) 
      {
      DessineRetic(puTexTarget, qResTexture.A, puTexTarget);
      DessineRetic(puTexTarget, qResTexture.B, puTexTarget);
      DessineRetic(puTexTarget, qResTexture.C, puTexTarget);
      DessineRetic(puTexTarget, qResTexture.D, puTexTarget);
      }
    MTrace("Follow-up Visu-Dtect", 350);
    }
  }
return qResTexture ;
}

// Calcule la carte de dtection  partir des images de critre
// puTexSource: TI1, TI2, TI3
// puTexTargetation: auTI4_Vraissemblance
unsigned int TTexture::Vraisemblance ( TRect r )
{
unsigned int  wSom = 0 ;
TPoint        pt ;

memset(auTI4_Vraissemblance, 0, 32 * 32); // reset
for ( pt.y = r.top ; pt.y <= r.bottom ; pt.y++ ) 
  for ( pt.x = r.left ; pt.x <= r.right ; pt.x++ ) 
    {
    unsigned int  w = (pt.y << 5) + pt.x ;
    if ( (TI1 [w] > seuil1) && (TI2 [w] < seuil2) && (TI3 [w] < seuil3) ) 
      {
      wSom++ ;
      auTI4_Vraissemblance [w] =  255 ;
      }
    else 
      auTI4_Vraissemblance [w] =  0 ;
    }
return wSom ;
}

// Etiquette les objets dans la carte de dtection (auTI4_Vraissemblance)
int TTexture::Etiquetage ()
{
int           i, j, nobj = 0 ;
unsigned char etiquette = 2 ;
double        excentricite ;
TGeo          a ;
TGeo2         b ;

for ( j = 0 ; j < 32 ; j++ ) 
  for ( i = 0 ; i < 32 ; i++ ) 
    if ( auTI4_Vraissemblance [i + (j << 5)] == 255 ) 
      {
      a =  TRemplis_CGravite(i, j);
      if ( a.m00 > TSEUIL ) 
        {
        xcg =  (float)a.m10 / (float)a.m00 ;
        ycg =  (float)a.m01 / (float)a.m00 ;
        b   =  TRemplis_Inertie_Etiquette(i, j, etiquette);
        if ( b.mu20 ) 
          {
          excentricite =  b.mu02 / b.mu20 ;
          if ( excentricite > 0.8 && excentricite < 1.4 ) 
            {
            code [nobj][0]   =  etiquette ;
            code [nobj++][1] =  a.m00 ;
            }
          }
        etiquette++ ;
        }
      }
return (nobj);
}

// Traitement morphologique
void TTexture::Morphologie ( void )
{
Tdst =  TIm ;
TDilatation(128, 2);
Tdst =  Tsrc ;
Tsrc =  TIm ;
TErosion(128, 2);
Tsrc =  Tdst ;
Tdst =  TIm ;
TErosion(128, 2);
Tdst =  Tsrc ;
Tsrc =  TIm ;
TDilatation(128, 2);
}

// ATTENTION: On cherche la chaine de Freeman sur un contour FIN et FERME
// c'est  dire qu'un texel du contour a deux voisins (8-voisins), et qu'ils
// ne sont pas eux mmes voisins.
// puTexSource: auTI4_Vraissemblance
// puTexTarget: unsigned char freeman[]
int TTexture::Freeman ()
{
int           i = 0, j = 0, nstx, nsty ;

// Tableaux de conversion ( DeltaX, DeltaY )<=> ( Freeman )
// Attention: DX=Xdest-XpuTexSource+1 et DY=Ydest-YpuTexSource+1
unsigned char DXDYToFreeman [3][3]
  = {{ 5, 4, 3 }, { 6, 0, 2 }, { 7, 0, 1 }};

while ( !auTI4_Vraissemblance [i + (j << 5)] ) 
  if ( !(i = (i + 1) % 32) ) 
    j++ ;
firstx =  i ;
firsty =  j ;
nstx   =  i ;
nsty   =  j ;
i      =  0 ;
voisin_trouve : 
  auTI4_Vraissemblance [nstx + (nsty << 5)] = 200 ;
  if ( (nstx != 31)
        && (auTI4_Vraissemblance [nstx + 1 + (nsty << 5)] == 255) ) 
    {
    freeman [i++] =  0 ;
    nstx++ ;
    goto voisin_trouve ;
    }
  if ( (nsty != 31)
        && (auTI4_Vraissemblance [nstx + ((nsty + 1) << 5)] == 255) ) 
    {
    freeman [i++] =  2 ;
    nsty++ ;
    goto voisin_trouve ;
    }
  if ( nstx && (auTI4_Vraissemblance [nstx - 1 + (nsty << 5)] == 255) ) 
    {
    freeman [i++] =  4 ;
    nstx-- ;
    goto voisin_trouve ;
    }
  if ( nsty && (auTI4_Vraissemblance [nstx + ((nsty - 1) << 5)] == 255) ) 
    {
    freeman [i++] =  6 ;
    nsty-- ;
    goto voisin_trouve ;
    }
  if ( (nstx != 31)
        && (nsty != 31)
        && (auTI4_Vraissemblance [nstx + 1 + ((nsty + 1) << 5)] == 255) ) 
    {
    freeman [i++] =  1 ;
    nstx++ ;
    nsty++ ;
    goto voisin_trouve ;
    }
  if ( nstx
        && (nsty != 31)
        && (auTI4_Vraissemblance [nstx - 1 + ((nsty + 1) << 5)] == 255) ) 
    {
    freeman [i++] =  3 ;
    nstx-- ;
    nsty++ ;
    goto voisin_trouve ;
    }
  if ( nstx
        && nsty
        && (auTI4_Vraissemblance [nstx - 1 + ((nsty - 1) << 5)] == 255) ) 
    {
    freeman [i++] =  5 ;
    nstx-- ;
    nsty-- ;
    goto voisin_trouve ;
    }
  if ( (nstx != 31)
        && nsty
        && (auTI4_Vraissemblance [nstx + 1 + ((nsty - 1) << 5)] == 255) ) 
    {
    freeman [i++] =  7 ;
    nstx++ ;
    nsty-- ;
    goto voisin_trouve ;
    }
  freeman [i++] =  DXDYToFreeman [firstx - nstx + 1][firsty - nsty + 1];
  return (i);
  }

// Segmentation de la chaine de Freeman
// puTexSource: freeman[]
// puTexTarget: TDrt Droite[]
int TTexture::Vectorisation ( int nFreeman )
{
int           j, k, l ;
unsigned char Code, Code1, Code2 ;
unsigned char N, NCPrec, NCC ;
float         DrtA, DrtB, MoyX, MoyY, DeltaX, DeltaY, Sxx, Sxy ;
char          DeltaCode ;
TCoordonnee   Points [100];
TCoordonnee   Moyenne, Delta ;
char          FreemanToDX [8] = { 1, 1, 0, - 1, - 1, - 1, 0, 1 };
char          FreemanToDY [8] = { 0, 1, 1, 1, 0, - 1, - 1, - 1 };

j          =  0 ;
k          =  0 ;
N          =  1 ;
Points [0] =  TCoordonnee((firstx << 3) + 4, (firsty << 3) + 4);
Moyenne    =  Points [0];

// Recherche des points membres du contour
do 
  {
  Code1 =  freeman [j % nFreeman];
  Delta 
    =  TCoordonnee(FreemanToDX [Code1] << 3, FreemanToDY [Code1] << 3);
  NCC   =  0 ;
  while ( freeman [j % nFreeman] == Code1 ) 
    {
    Points [N] =  Points [N - 1] + Delta ;
    Moyenne    += Points [N++];
    j++ ;
    NCC++ ;
    }
  Code2     =  freeman [j % nFreeman];
  DeltaCode =  abs(Code1 - Code2);
  if ( DeltaCode > 4 ) 
    DeltaCode =  8 - DeltaCode ;
  if ( (DeltaCode == 1)
        && ((NCC > 1) || (freeman [(j + 1) % nFreeman] != Code2)) ) 
    {
    for (;;) 
      {
      Code =  freeman [j % nFreeman];
      if ( (Code != Code1) && (Code != Code2) ) 
        break ;
      NCPrec =  NCC ;
      NCC    =  0 ;
      while ( freeman [j % nFreeman] == Code ) 
        {
        j++ ;
        NCC++ ;
        }
      if ( (NCPrec != 1) && (NCC != 1) ) 
        {
        j -= NCC ;
        break ;
        }
      if ( (freeman [j % nFreeman] != Code1)
            && (freeman [j % nFreeman] != Code2) ) 
        if ( (NCC == 1) && (NCPrec > 1) ) 
          {
          j -= NCC ;
          break ;
          }
      Delta
        =  TCoordonnee(FreemanToDX [Code] << 3, FreemanToDY [Code] << 3);
      for ( l = j - NCC ; l < j ; l++ ) 
        {
        Points [N] =  Points [N - 1] + Delta ;
        Moyenne    += Points [N++];
        }
      }
    }
  
  // Interpolation linaire des points membres du contour
  MoyX =  (float)Moyenne.x / (float)N ;
  MoyY =  (float)Moyenne.y / (float)N ;
  Sxx  =  0.0 ;
  Sxy  =  0.0 ;
  for ( l = 0 ; l < N ; l++ ) 
    {
    DeltaX =  ((float)Points [l].x - MoyX);
    DeltaY =  ((float)Points [l].y - MoyY);
    Sxy    += DeltaX * DeltaY ;
    Sxx    += DeltaX * DeltaX ;
    }
  if ( Sxx != 0.0 ) 
    {
    DrtA                =  Sxy / Sxx ;
    DrtB                =  MoyY - DrtA * MoyX ;
    Droite [k++].droite =  TDroite(DrtA, - 1.0, DrtB);
    }
  else 
    Droite [k++].droite =  TDroite(1.0, 0.0, - MoyX);
  Points [0] =  Points [N - 1];
  N          =  1 ;
  Moyenne    =  Points [0];
  } 
while ( j < nFreeman );
if ( j > nFreeman ) 
  {
  k-- ;
  Droite [0] =  Droite [k];
  }
return (k);
}

// Correction des angles du quadrilatere
// puTexSource: TDrt Droite[4]
// puTexTarget: TDrt Droite[4]
void TTexture::Correction ()
{
int       i, j ;
TVecteur  Coin1, Coin2 ;
double    Correction [4];

for ( j = 0 ; j < 4 ; j++ ) 
  {
  Correction [j]
    =  Droite [j].vecteur * Droite [(j + 1) % 4].vecteur
      / (2.0 * Droite [(j + 1) % 4].longueur);
  }
j =  0 ;
while ( (abs(Correction [j]) > TOLERANCE) && (j < 4) ) 
  j++ ;
if ( j != 4 ) 
  {
  i =  j + 1 ;
  while ( (abs(Correction [i % 4]) <= TOLERANCE) && ((i % 4) != j) ) 
    i++ ;
  switch ( (i - j) % 4 ) 
    {
    case 0 : break ;
    case 1 : 
      if ( abs(Correction [(i + 1) % 4]) <= TOLERANCE ) 
        {
        if ( Droite [i % 4].orglong < Droite [(i + 2) % 4].orglong ) 
          i += 2 ;
        }
      i                           = i % 4 ;
      Coin1                       
        = Droite [i].A
          + Droite [i].vecteur
            * (1.0 + Correction [i] / Droite [i].longueur);
      Coin2                       
        = Droite [(i + 3) % 4].B
          - Droite [(i + 3) % 4].vecteur
            * (1.0
              + Correction [(i + 2) % 4] / Droite [(i + 3) % 4].longueur);
      Droite [i].B                = Coin1 ;
      Droite [(i + 1) % 4].A      = Coin1 ;
      Droite [(i + 3) % 4].A      = Coin2 ;
      Droite [(i + 2) % 4].B      = Coin2 ;
      Droite [(i + 1) % 4].droite 
        = TDroite(Coin1, Droite [(i + 3) % 4].vecteur
          , DROITE_POINT_VECTEUR);
      Droite [(i + 2) % 4].droite 
        = TDroite(Coin2, Droite [i].vecteur, DROITE_POINT_VECTEUR);
      Droite [(i + 2) % 4].A      
        = (Droite [(i + 1) % 4].droite).Intersection(
          Droite [(i + 2) % 4].droite);
      Droite [(i + 1) % 4].B      = Droite [(i + 2) % 4].A ;
      break ;
    case 2 : 
      i                           = i % 4 ;
      Coin1                       
        = Droite [i].A
          + Droite [i].vecteur
            * (1.0 + Correction [i] / Droite [i].longueur);
      Coin2                       
        = Droite [(i + 2) % 4].B
          - Droite [(i + 2) % 4].vecteur
            * (1.0
              + Correction [(i + 1) % 4] / Droite [(i + 2) % 4].longueur);
      Droite [(i + 1) % 4].droite 
        = TDroite((Coin2 + Coin1) / 2, Droite [(i + 3) % 4].vecteur
          , DROITE_POINT_VECTEUR);
      Droite [(i + 1) % 4].A      
        = (Droite [(i + 1) % 4].droite).Intersection(
          Droite [i].droite);
      Droite [(i + 1) % 4].B      
        = (Droite [(i + 1) % 4].droite).Intersection(
          Droite [(i + 2) % 4].droite);
      Droite [i].B                = Droite [(i + 1) % 4].A ;
      Droite [(i + 2) % 4].A      = Droite [(i + 1) % 4].B ;
      break ;
    case 3 : 
    default : break ;
    }
  }
}

// Carte de densite
// puTexSource: pContour
// puTexTarget: Tdst
// Compte le nombre de blocs 22 (on ne compte que les blocs ancrs dans le texel par leur pixel bas-gauche)
void TTexture::Densite ( TRect r ) // Donn dans l'chelle des texels
{
int           i, j ;
unsigned char nagglo ;
TPoint        pt ;

for ( pt.y = r.top ; pt.y <= r.bottom ; pt.y++ )
  for ( pt.x = r.left ; pt.x <= r.right ; pt.x++ )
    {

    // Pour chaque texel
    nagglo =  0 ;

    // Pour chaque pixel:
    for ( i = 0 ; i < 8 ; i++ )
      for ( j = 0 ; j < 8 ; j++ )
        if ( puTexContour [(pt.x << 3) + i + (((pt.y << 3) + j) << 8)] // Un contour est prsent
             && ((pt.x << 3) + i < 255)
              && ((pt.y << 3) + j < 255) )

          // Nous ne sommes pas au bord
          if ( puTexContour [(pt.x << 3) + i + 1 + (((pt.y << 3) + j) << 8)] // contour sur voisin (col+1,lgn)
               && puTexContour [
                  (pt.x << 3) + i + (((pt.y << 3) + j + 1) << 8)] // contour sur voisin (col,lgn+1)
               && puTexContour [
                  (pt.x << 3) + i + 1 + (((pt.y << 3) + j + 1) << 8)] ) 
            
            // contour sur voisin (col+1,lgn+1)
            nagglo++ ; // Compte le comme bloc agglomr 22
    Tdst [pt.x + (pt.y << 5)] =  min(TEX_CoeffNormDensite_KN * nagglo, 255);
    }
}

// Carte de granularite
// idem
void TTexture::Granularite ( void )
{
int x, y, i, j, ngr ;

for ( x = 0 ; x < 32 ; x++ ) 
  for ( y = 0 ; y < 32 ; y++ ) 
    {
    
    //               Pour chaque texel (8*8)
    //       Comptage des contours de longueur <=2
    ngr =  0 ;
    for ( i = 0 ; i < 8 ; i++ ) 
      for ( j = 0 ; j < 8 ; j++ ) 
        {
        switch ( pix_test(x * 8 + i, y * 8 + j) & 0x01ff ) 
          {
          case 0x0001 : 
            ngr++ ;
            break ;
          case 0x0003 : 
            if ( !(pix_test(x * 8 + i, y * 8 + j - 1) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0005 : 
            if ( !(pix_test(x * 8 + i + 1, y * 8 + j - 1) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0009 : 
            if ( !(pix_test(x * 8 + i + 1, y * 8 + j) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0011 : 
            if ( !(pix_test(x * 8 + i + 1, y * 8 + j + 1) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0021 : 
            if ( !(pix_test(x * 8 + i, y * 8 + j + 1) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0041 : 
            if ( !(pix_test(x * 8 + i - 1, y * 8 + j + 1) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0081 : 
            if ( !(pix_test(x * 8 + i - 1, y * 8 + j) & 0x0400) ) 
              ngr++ ;
            break ;
          case 0x0101 : 
            if ( !(pix_test(x * 8 + i - 1, y * 8 + j - 1) & 0x0400) ) 
              ngr++ ;
            break ;
          default : break ;
          }
        }
    Tdst [x + (y << 5)] =  (unsigned char)min(50 * ngr, 255);
    }
}

// Carte de discontinuit
// idem
void TTexture::Discontinuite ( void )
{
int x, y, i, j, nxt ;

for ( x = 0 ; x < 32 ; x++ ) 
  for ( y = 0 ; y < 32 ; y++ ) 
    {
    
    //               Pour chaque texel (8*8)
    //       Comptage des extrmits de contour >2
    nxt =  0 ;
    for ( i = 0 ; i < 8 ; i++ ) 
      for ( j = 0 ; j < 8 ; j++ ) 
        {
        switch ( pix_test(x * 8 + i, y * 8 + j) & 0x01ff ) 
          {
          case 0x0003 : 
            if ( pix_test(x * 8 + i, y * 8 + j - 1) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0005 : 
            if ( pix_test(x * 8 + i + 1, y * 8 + j - 1) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0009 : 
            if ( pix_test(x * 8 + i + 1, y * 8 + j) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0011 : 
            if ( pix_test(x * 8 + i + 1, y * 8 + j + 1) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0021 : 
            if ( pix_test(x * 8 + i, y * 8 + j + 1) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0041 : 
            if ( pix_test(x * 8 + i - 1, y * 8 + j + 1) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0081 : 
            if ( pix_test(x * 8 + i - 1, y * 8 + j) & 0x0400 ) 
              nxt++ ;
            break ;
          case 0x0101 : 
            if ( pix_test(x * 8 + i - 1, y * 8 + j - 1) & 0x0400 ) 
              nxt++ ;
            break ;
          default : break ;
          }
        }
    Tdst [x + (y << 5)] =  (unsigned char)min(50 * nxt, 255);
    }
}

// Carte de continuit
// puTexSource: pContour
// puTexTarget: Tdst
void TTexture::Continuite ( TRect r // chelle du texel
)
{
int     i, j, ngr, nctr, pix_status ;
TPoint  pt ;

for ( pt.y = r.top ; pt.y <= r.bottom ; pt.y++ ) 
  for ( pt.x = r.left ; pt.x <= r.right ; pt.x++ ) 
    {
    
    //           Pour chaque texel (8*8) de la zone r (donne en chelle de texels
    //       Comptage des contours de longueur >2
    ngr  =  0 ;
    nctr =  0 ;
    for ( i = 0 ; i < 8 ; i++ ) 
      for ( j = 0 ; j < 8 ; j++ ) 
        {
        
        // Pour chaque pixel du texel
        pix_status =  pix_test((pt.x << 3) + i, (pt.y << 3) + j);
        
        /*                     ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                               pt.x * 8 + i , pt.y * 8 + j (col, lgn)
                               coordonnes du point par rapport  toute l'image
           pix_status est un bit-wise qui contient les infos sur la prsence de contours dans le vosinage du pixel.
           
           // pix_status =     0x 0000 0MF8 7654 3210 ( bit  bit )
           //
           // Signification des bits:
           //                      M: Mutliple, le pixel + plusieurs voisins
           //                      F: Failed, le pixel n'appartient pas au contour
           //                      876543210: carte du contour dans la rgion du pixel:
           //                                                              8  1  2
           //                                                              7  0  3
           //                                                              6  5  4
           
           */
        if ( !(pix_status & 0x0200) ) 
          {
          //pas failed (contour(s) prsent(s))
          nctr++ ; // Somme de tous les pixels de contours (y compris les isols)
          switch ( pix_status & 0x01ff ) 
            {
            case 0x0001 : 
              
              // v0 seul pixel de contour
              ngr++ ; // On enlve les isols
              break ;
            
            /* Les cases ci-dessous examinent les cas de contour sur exclusivement
               v0 et vi (i de 1  8).
                 Pour chacun de ces cas,  condition qu'il n'y ait pas d'autres contours,
                 ngr est incrment si pix-test(vi) a un seul voisin de contour
               
                 ngr compte donc le nombre de pixels p tels que
                   p a 1 et 1 seul voisin
                     qui a lui un seul voisins (qui est p)
                   Ceci est caractristique des chanes de long.2.
               
                    la fin du texel, continuit=ncr-ngr
               
               Continuite calcule donc la quantit de pixels appartenant  des chanes de long > 2.
               
               */
            case 0x0003 : 
              
              // v0 et v1
              if ( !(pix_test((pt.x << 3) + i, (pt.y << 3) + j - 1) // Col; lgn)
                  & 0x0400) ) 
                
                // !(pix_test(v1) & Multiple)
                ngr++ ;
              break ;
            case 0x0005 : 
              
              // v0 et v2
              if ( !(pix_test((pt.x << 3) + i + 1, (pt.y << 3) + j - 1)
                    & 0x0400) ) 
                
                // pix_test(v2) Multiple
                ngr++ ;
              break ;
            case 0x0009 : 
              
              // v0 et v3
              if ( !(pix_test((pt.x << 3) + i + 1, (pt.y << 3) + j)
                    & 0x0400) ) 
                
                // pix_test(v3) multiple
                ngr++ ;
              break ;
            case 0x0011 : 
              
              // v0 et v4
              if ( !(pix_test((pt.x << 3) + i + 1, (pt.y << 3) + j + 1)
                    & 0x0400) ) 
                
                // pix_test (v4) multiple
                ngr++ ;
              break ;
            case 0x0021 : 
              
              // v0 et v5
              if ( !(pix_test((pt.x << 3) + i, (pt.y << 3) + j + 1)
                    & 0x0400) ) 
                ngr++ ;
              break ;
            case 0x0041 : 
              if ( !(pix_test((pt.x << 3) + i - 1, (pt.y << 3) + j + 1)
                    & 0x0400) ) 
                ngr++ ;
              break ;
            case 0x0081 : 
              if ( !(pix_test((pt.x << 3) + i - 1, (pt.y << 3) + j)
                    & 0x0400) ) 
                ngr++ ;
              break ;
            case 0x0101 : 
              if ( !(pix_test((pt.x << 3) + i - 1, (pt.y << 3) + j - 1)
                    & 0x0400) ) 
                ngr++ ;
              break ;
            default : break ;
            }
          }
        }
    
    /*                    if( nctr>32 )
       {  Tdst[x+(y<<5)] = 0;
       }
       else
       */
    Tdst [pt.x + (pt.y << 5)] =  (unsigned char)min(TEX_CoeffNormContinuite_KO * (nctr - ngr), 255);
    //                  ^^^ "<<5" <=> "mult par 32"
    }
}

// Carte de proximit
// idem
void TTexture::Proximite ( TRect r )
{
int     i, j, nisol, pix_status ;
TPoint  pt ;

for ( pt.y = r.top ; pt.y <= r.bottom ; pt.y++ ) 
  for ( pt.x = r.left ; pt.x <= r.right ; pt.x++ ) 
    {
    nisol =  0 ;
    for ( i = 0 ; i < 8 ; i++ ) 
      for ( j = 0 ; j < 8 ; j++ ) 
        {
        
        // pix_status =     0x 0000 0MF8 7654 3210 ( bit  bit )
        //
        // Signification des bits:
        //                      M: Mutliple, le pixel + plusieurs voisins
        //                      F: Failed, le pixel n'appartient pas au contour
        //                      876543210: carte du contour dans la rgion du pixel:
        //                                                              8  1  2
        //                                                              7  0  3
        //                                                              6  5  4
        pix_status =  pix_test((pt.x << 3) + i, (pt.y << 3) + j);
        if ( !(pix_status & 0x0001) ) 
          {

          // Pas de contour sur pt
          if ( (pix_status & 0x0022) == 0x0022 ) 
            
            // v1 et v5
            nisol++ ;
          /*
             if( (pix_status & 0x0044)==0x0044 )
              nisol++;
              */
          if ( (pix_status & 0x0088) == 0x0088 ) 
            
            // v3 et v7
            nisol++ ; /*
                         if( (pix_status & 0x0110)==0x0110 )
                                     nisol++;
                                     */ // NB: Les pixels qui ont v1 et v5 et v3 et v7 comptent double
          }
        }
    Tdst [pt.x + (pt.y << 5)] =  (unsigned char)min(TEX_CoeffNormProximite_KP * nisol, 255);
    }
}

// Carte de compacit
// puTexSource: puTexSource
// Target: Tdst (carte)
/* Compacit: nombre  d'objet de luminance diffrente dans le texel.
   La version en cours est l'oppose de la version de Sbastien qui tait croissante lorsque le nombre d'objet augemnatit (ce qui allait contre le sens prsum du mot "compacit")
   */
void TTexture::Compacite ( void )
{
int x, y, a ;

for ( x = 0 ; x < 32 ; x++ ) 
  for ( y = 0 ; y < 32 ; y++ ) 
    {
    a                   =  RemplisTexel(x, y);
    Tdst [x + (y << 5)] =  255 - (unsigned char)min(40 * a, 255); // Ex:     Tdst [x + (y << 5)] =  255-(unsigned char)min(40 * a, 255);
    }
}

/* Calcule le nombre d'objet de luminance diffrente dans le texel de
   coord (x,y) */
int TTexture::RemplisTexel ( int x, int y )
{
int           i, j ;
unsigned char nremplis, npix ;
unsigned char buffer [10 * 10];  // seuillage de luminance autour du texel.

for ( i = 0 ; i < 10 ; i++ ) 
  for ( j = 0 ; j < 10 ; j++ ) 
    if ( (i == 0) || (j == 0) || (i == 9) || (j == 9) ) 
      buffer [i + j * 10] =  128 ; // Vrouillage du bord.
    else 
      buffer [i + j * 10]
        =  puTexSource [(x << 3) + i + (((y << 3) + j) << 8)] > CSEUIL ? 
             255
          : 0 ;
npix     =  0 ;
nremplis =  0 ;
for ( i = 1 ; i < 9 ; i++ ) 
  for ( j = 1 ; j < 9 ; j++ ) 
    {
    if ( buffer [i + j * 10] != 128 ) 
      {
      
      // Pas ncssairement vrai (la ligne dessous mofie aussi la valeur de 'buffer').
      npix += remplis(buffer, i, j, buffer [i + j * 10]);
      
      // Met  la couleur 128 tous les pixels connexes au pixel courant de la mme couleur que lui ( et != 128).
      // Renvoit le nombre de pixels traits de cette faon.
      nremplis++ ; // Incrmente le nombre d'objets
      }
    }
return (nremplis);
}

unsigned char TTexture::remplis ( unsigned char *buffer, int i, int j
    , unsigned char color ) // On sait que color != 128
{
unsigned char npix ;

// Met  la couleur 128 tous les pixels connexes au pixel courant de la mme couleur que lui ( et != 128).
buffer [i + j * 10] =  128 ; // limination du courant.
npix                =  1 ;
if ( buffer [i + (j - 1) * 10] == color ) 
  
  // Propagation dans les 4 dir.
  npix += remplis(buffer, i, j - 1, color);
if ( buffer [i + 1 + j * 10] == color ) 
  npix += remplis(buffer, i + 1, j, color);
if ( buffer [i + (j + 1) * 10] == color ) 
  npix += remplis(buffer, i, j + 1, color);
if ( buffer [i - 1 + j * 10] == color ) 
  npix += remplis(buffer, i - 1, j, color);
return (npix); // Renvoit le nombre de pixels nettoys
}

// ******* Teste si un pixel et son 8-voisinage appartiennent au contour
// ******* ( gestion des effets de bord )
//
//      appel:  x,y = coordonnes du pixel
// retour =     0x 0000 0MF8 7654 3210 ( bit  bit )
//
// Signification des bits:
//                      M: Mutliple, le pixel + plusieurs voisins
//                      F: Failed, le pixel n'appartient pas au contour
//                      876543210: carte du contour dans la rgion du pixel:
//                                                              8  1  2
//                                                              7  0  3
//                                                              6  5  4
//
int TTexture::pix_test ( int x, int y ) // (col, ligne)
{
unsigned char *ptr_src, pix_attr, voisins ;
unsigned int  retour ;

pix_attr =  0xff ;
ptr_src  =  puTexContour + (x + (y << 8));

// Pointeur sur le pixel concern dans la carte de contours
voisins  =  0 ;
if ( *ptr_src ) 
  retour =  0x0001 ; // Bit 0
else 
  retour =  0x0200 ; // Bit F

// surcharge du masque pour tenir compte des effets de bords
if ( x == 0 ) 
  pix_attr &= 0xf7 ; // (1111 0111)
if ( x == 255 ) 
  pix_attr &= 0xfd ; // 1111 1101
if ( y == 0 ) 
  pix_attr &= 0xfe ;
if ( y == 255 ) 
  pix_attr &= 0xfb ;
if ( pix_attr & 0x01 ) 
  {
  
  // Si les voisins du dessus existent...
  if ( *(ptr_src - 256) ) 
    {
    
    //  si b0010 est un contour...(ptr_src - 256) (v2)
    voisins++ ;
    retour |= 0x0002 ;
    }
  if ( (pix_attr & 0x08) && (*(ptr_src - 257)) ) 
    {
    
    //      ^^^^^^^^^^^^^^^^Les voisins de gauche doivent exister
    // Test sur v8 b00010000
    voisins++ ;
    retour |= 0x0100 ;
    }
  if ( (pix_attr & 0x02) && (*(ptr_src - 255)) ) 
    {
    voisins++ ;
    retour |= 0x0004 ;
    }
  }
if ( (pix_attr & 0x02) && (*(ptr_src + 1)) ) 
  {
  voisins++ ;
  retour |= 0x0008 ;
  }
if ( pix_attr & 0x04 ) 
  {
  if ( *(ptr_src + 256) ) 
    {
    voisins++ ;
    retour |= 0x0020 ;
    }
  if ( (pix_attr & 0x08) && (*(ptr_src + 255)) ) 
    {
    voisins++ ;
    retour |= 0x0040 ;
    }
  if ( (pix_attr & 0x02) && (*(ptr_src + 257)) ) 
    {
    voisins++ ;
    retour |= 0x0010 ;
    }
  }
if ( (pix_attr & 0x08) && (*(ptr_src - 1)) ) 
  {
  voisins++ ;
  retour |= 0x0080 ;
  }
if ( voisins > 1 ) 
  retour |= 0x0400 ;
return (retour);
}

// Routine de remplissage non rcursive
// ( Probleme de pile sinon )
TGeo TTexture::TRemplis_CGravite ( unsigned char i, unsigned char j )
{
TGeo          a ;
int           x, yoff, stack [40 * 2];
unsigned char spin, spout ;
unsigned char u_done, l_done ;

spout     =  0 ; // Index de la premiere racine ( buffer circulaire )
spin      =  1 ; // Index de la racine a venir  (    '        '     )
stack [0] =  (int)i ;
stack [1] =  j << 5 ;
a.m00     =  0 ;
a.m10     =  0 ;
a.m01     =  0 ;
while ( spin != spout ) 
  {
  u_done =  1 ;
  l_done =  1 ;
  x      =  stack [spout << 1];
  yoff   =  stack [(spout << 1) + 1];
  spout  =  (spout + 1) % 40 ;
  while ( x ) 
    {
    if ( auTI4_Vraissemblance [x - 1 + yoff] == 255 ) 
      x-- ;
    else 
      break ;
    }
  while ( (x < 32) && (auTI4_Vraissemblance [x + yoff] == 255) ) 
    {
    auTI4_Vraissemblance [x + yoff] =  1 ;
    a.m00++ ;
    a.m10 += x ;
    a.m01 += (yoff >> 5);
    if ( yoff ) 
      if ( auTI4_Vraissemblance [x + yoff - 32] == 255 ) 
        {
        if ( u_done ) 
          {
          stack [(spin << 1)]     =  x ;
          stack [(spin << 1) + 1] =  yoff - 32 ;
          spin                    =  (spin + 1) % 40 ;
          u_done                  =  0 ;
          }
        }
      else 
        {
        u_done =  1 ;
        }
    if ( yoff != 992 ) 
      //31*32=992
      if ( auTI4_Vraissemblance [x + yoff + 32] == 255 ) 
        {
        if ( l_done ) 
          {
          stack [(spin << 1)]     =  x ;
          stack [(spin << 1) + 1] =  yoff + 32 ;
          spin                    =  (spin + 1) % 40 ;
          l_done                  =  0 ;
          }
        }
      else 
        {
        l_done =  1 ;
        }
    x++ ;
    }
  }
return (a);
}

TGeo2 TTexture::TRemplis_Inertie_Etiquette ( unsigned char i
    , unsigned char j, unsigned char etiquette )
{
TGeo2         a ;
int           x, y, yoff, stack [40 * 2];
unsigned char spin, spout ;
unsigned char u_done, l_done ;

spout     =  0 ; // Index de la premiere racine ( buffer circulaire )
spin      =  1 ; // Index de la racine a venir  (    '        '     )
stack [0] =  (int)i ;
stack [1] =  j << 5 ;
a.mu11    =  0 ;
a.mu20    =  0 ;
a.mu02    =  0 ;
while ( spin != spout ) 
  {
  u_done =  1 ;
  l_done =  1 ;
  x      =  stack [spout << 1];
  yoff   =  stack [(spout << 1) + 1];
  spout  =  (spout + 1) % 40 ;
  while ( x ) 
    {
    if ( auTI4_Vraissemblance [x - 1 + yoff] == 1 ) 
      x-- ;
    else 
      break ;
    }
  while ( (x < 32) && (auTI4_Vraissemblance [x + yoff] == 1) ) 
    {
    auTI4_Vraissemblance [x + yoff] =  etiquette ;
    y                               =  yoff >> 5 ;
    a.mu11                          += ((float)x - xcg) * ((float)y - ycg);
    a.mu20                          += ((float)x - xcg) * ((float)x - xcg);
    a.mu02                          += ((float)y - ycg) * ((float)y - ycg);
    if ( yoff ) 
      if ( auTI4_Vraissemblance [x + yoff - 32] == 1 ) 
        {
        if ( u_done ) 
          {
          stack [(spin << 1)]     =  x ;
          stack [(spin << 1) + 1] =  yoff - 32 ;
          spin                    =  (spin + 1) % 40 ;
          u_done                  =  0 ;
          }
        }
      else 
        {
        u_done =  1 ;
        }
    if ( yoff != 992 ) 
      //31*32=992
      if ( auTI4_Vraissemblance [x + yoff + 32] == 1 ) 
        {
        if ( l_done ) 
          {
          stack [(spin << 1)]     =  x ;
          stack [(spin << 1) + 1] =  yoff + 32 ;
          spin                    =  (spin + 1) % 40 ;
          l_done                  =  0 ;
          }
        }
      else 
        {
        l_done =  1 ;
        }
    x++ ;
    }
  }
return (a);
}

//
// Erosion et  dilatation:
//
// type 1: 8-voisinage
// type 2: 4-voisinage
//
void TTexture::TErosion ( int seuil, char type )
{
int           x, y ;
unsigned char p0, p1, p2, p3, p4, p5, p6, p7, p8 ; /* pixels */ 
unsigned char *pointim, *pointim1 ;

for ( y = 0 ; y < 30 ; y++ ) 
  {
  for ( x = 0 ; x < 30 ; x++ ) 
    {
    pointim  =  Tsrc + ((y << 5) + x);
    p0       =  *pointim++ ;
    p1       =  *pointim++ ;
    p2       =  *pointim ;
    pointim  += 30 ;
    p3       =  *pointim++ ;
    p4       =  *pointim++ ;
    p5       =  *pointim ;
    pointim  += 30 ;
    p6       =  *pointim++ ;
    p7       =  *pointim++ ;
    p8       =  *pointim ;
    pointim1 =  Tdst + (((y + 1) << 5) + x + 1);
    if ( type == 1 ) 
      {
      if ( (p0 < seuil)
            || (p1 < seuil)
            || (p2 < seuil)
            || (p3 < seuil)
            || (p5 < seuil)
            || (p6 < seuil)
            || (p7 < seuil)
            || (p8 < seuil) ) 
        {
        *pointim1 =  0 ;
        }
      else 
        {
        *pointim1 =  p4 ;
        }
      }
    else 
      {
      if ( (p1 < seuil) || (p3 < seuil) || (p5 < seuil) || (p7 < seuil) ) 
        *pointim1 =  0 ;
      else 
        *pointim1 =  p4 ;
      }
    }
  }
}

void TTexture::ShowTI ()
{

// Obsolte: ShowTexture(Tsrc, Tdst);
ShowTexture(Tsrc, puTexTarget);
}

void TTexture::TDilatation ( int seuil, char type )
{
int           x, y ;
unsigned char p0, p1, p2, p3, p4, p5, p6, p7, p8 ; /* pixels */ 
unsigned char *pointim, *pointim1 ;

for ( y = 0 ; y < 30 ; y++ ) 
  {
  for ( x = 0 ; x < 30 ; x++ ) 
    {
    pointim  =  Tsrc + ((y << 5) + x);
    p0       =  *pointim++ ;
    p1       =  *pointim++ ;
    p2       =  *pointim ;
    pointim  += 30 ;
    p3       =  *pointim++ ;
    p4       =  *pointim++ ;
    p5       =  *pointim ;
    pointim  += 30 ;
    p6       =  *pointim++ ;
    p7       =  *pointim++ ;
    p8       =  *pointim ;
    pointim1 =  Tdst + (((y + 1) << 5) + x + 1);
    if ( type == 1 ) 
      {
      if ( (p0 >= seuil)
            || (p1 >= seuil)
            || (p2 >= seuil)
            || (p3 >= seuil)
            || (p5 >= seuil)
            || (p6 >= seuil)
            || (p7 >= seuil)
            || (p8 >= seuil) ) 
        {
        *pointim1 =  255 ;
        }
      else 
        {
        *pointim1 =  p4 ;
        }
      }
    else 
      {
      if ( (p1 >= seuil) || (p3 >= seuil) || (p5 >= seuil) || (p7 >= seuil) ) 
        {
        *pointim1 =  255 ;
        }
      else 
        {
        *pointim1 =  p4 ;
        }
      }
    }
  }
}

// Affiche une carte de texture 32*32
// dans une image 256*256
void ShowTexture ( unsigned char auTexSrc [32 * 32]
    , unsigned char *puTexDest )
{
int x, y, i, j ;

for ( x = 0 ; x < 32 ; x++ ) 
  for ( y = 0 ; y < 32 ; y++ ) 
    for ( i = 0 ; i < 8 ; i++ ) 
      for ( j = 0 ; j < 8 ; j++ ) 
        puTexDest [(x << 3) + i + (((y << 3) + j) << 8)]
          =  auTexSrc [x + (y << 5)];
}

/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TParametres                               */
/*--Systme---------------------------------------------------------------*/
/*-------------------------------------------*/
//Visualisation: Contour en texels de 8*8
// R: rectangle en texels
void VisuTextureMap ( unsigned char uVisuMode
    , unsigned char puTextureMap [32 * 32], TRect r
    , unsigned char *puSource, unsigned char *puTarget )
{
if ( uVisuMode ) 
  {
  unsigned char *puDest ;
  if ( uVisuMode == TEX_VISU_SOURCE ) 
    {
    puDest =  puSource ;
    }
  else if ( uVisuMode == TEX_VISU_DESTIN ) 
    {
    puDest =  puTarget ;
    }
  else 
    {
    ErreurCode(1367);
    return ;
    }
  for ( unsigned int i = r.left ; i <= r.right ; i++ ) 
    for ( unsigned int j = r.top ; j < r.bottom ; j++ ) 
      for ( unsigned int k = 0 ; k < 8 ; k++ ) 
        for ( unsigned int l = 0 ; l < 8 ; l++ ) 
          {
          unsigned int  wOffset = (i << 3) + k + (((j << 3) + l) << 8);
          puDest [(unsigned int)wOffset]
            =  puTextureMap [i + (j << 5)] ? 
                 ~puDest [(unsigned int)wOffset]
              : puDest [(unsigned int)wOffset];
          }
  }
}

unsigned int TTexture::CallVraissemblance ( unsigned char uVisuMode
    , TRect r // rectangle de la zone  analyse, en chelle du texel
    , unsigned char *puSource, unsigned char *puTarget
    , unsigned char *puContour )
{
if ( !rTexImageWithBorder.Contains(r) )
  return MErreur(
    "Texture zone too wide (maybe you used pixel units instead of texel units"
    , 1375);

unsigned char *puStackSource = puTexSource, *puStackTarget = puTexTarget
  , *puStackContour = puTexContour ;

puTexSource  =  puSource ;
puTexTarget  =  puTarget ;
puTexContour =  puContour ;

unsigned int  w = CmVraissemblance(uVisuMode, r);

puTexSource  =  puStackSource ;
puTexTarget  =  puStackTarget ;
puTexContour =  puStackContour ;
return w ;
}

unsigned int TTexture::CmVraissemblance ( unsigned char uVisuMode, TRect r )
{
SetTdst(1); // Affecte la carte de destination par dfaut  T1

// TI1=Carte de continuit
Continuite(r); // Calcule la continuit et mets les rsultats dans TdsT (la carte de rs. par df.).
SetTdst(2);
Densite(r); // TI2=Carte de densit
SetTdst(3);
Proximite(r); // TI3=Carte de Proximite

unsigned int  w = Vraisemblance(r);

InitFondVisu(uFondVisu);
VisuTextureMap(uVisuMode, auTI4_Vraissemblance, r, puTexSource, puTexTarget);
if ( uVisuMode == 3 ) 
  {
  SetTsrc(4);
  ShowTI();
  }
return w ;
}

/*
   Scan the source with texel of size 8, then 16, then 32... until it finds...
   Condition d'arrt: plus de xSeuil (%) du quad.  analyser sont des
       textures de symbole.
   
   Ce calcul est fait en divisant la frquence d'chantillonnage du plan
       source par 2  chaque itration et en appliquant aux rsukltats la
       rechrche de texture par texels de priode 8.
   
   */
int TexVraissemblanceRelativeMaxMultiFrequence ( unsigned int *pwNbTexelsTotal // Valeur retourne
, unsigned int *pwNbTexelsValides
    , // Valeur retourne
      float xSeuilRaportsSurface /* Surface occupe par des texels valides par rapport  surface totale (des texels analyss). Ce
                                    seuil dtermine si la zone est valide ou non. */ 
    , unsigned int wSeuilSurfaceTotale
    , // Surface minimale que doit avoir la zone  analyser (l'esemble des texels  analyser)
      unsigned char *puSource // Plan o se trouve l'image  analyser
    , unsigned char *puTarget
    , // Plan pour afficher le rsultat.
      unsigned char *puContour // Plan o stocker la carte de contours
    , unsigned char *puMultiFreqBuffer
    , // Plan pour stocker l'image  la frquence intermdiaire
      TQuadrilatere q
    , // Quadrilatre  analyser.
      unsigned int *pwPeriodeVraissemblanceMax
    , // Priode pour laquelle la vraissemblance est la meilleur entre toutes les chelles
      unsigned char uVisuMode )
{
int           f ;

//  *pwPeriodeVraissemblanceMax=8*wFrequencyLevel;
/*  int f=TexVraissemblanceRelative(pwNbTexelsTotal,
     pwNbTexelsValides, puSource,
     puTarget, puContour, q/ (*pwPeriodeVraissemblanceMax / 8),
     uVisuMode);
   if ((float) *pwNbTexelsValides/ *pwNbTexelsTotal >= xSeuil)
     return f;
   */
unsigned int  wFrequencyLevel = 1 ; // 1, 2, 4, 8...
/*
   unsigned int wMaxTailleTexture=
       min((UINT)SIZE_OF_PICTURES,
           (UINT)2*NFarRoundR(max(q.A.Distance(q.C),q.B.Distance(q.D)))); // Plus garnde diagonale.
   */
float         dac = q.A.Distance(q.C), dbd = q.B.Distance(q.D); // Longueurs des diagonales.
float         diag = max(dac, dbd);
UINT          w = NFarRoundR(diag);
/*
   Pour que la texture soit bonne, il faut au moins qu'un texel soit
   inclus dans le quadrilatre. Cette condition ne peut pas tre
   ralise si le ct du texel est plus long que la plus grande diagonale,
    ou plus grand que la taille de l'image
      */
unsigned int  wMaxTailleTexture = min((UINT)SIZE_OF_PICTURES, (UINT)w);

// Plus garnde diagonale.
*pwNbTexelsTotal =  0 ;
for ( wFrequencyLevel = 1 ; 
      
      // Si le critre de texture est bon, on accepte et on arrte la boucle
      (!(
         
         // Acceptation d'un rsultat:
         *pwNbTexelsTotal
          > wSeuilSurfaceTotale // La zone analyse doit occuper suffisement de texels pour tre significative
         && *pwNbTexelsValides / (float)*pwNbTexelsTotal
            > xSeuilRaportsSurface)) // dans la zone analyse, la proportion de texls valide doit tre >seuil.
                                    // On continue  boucler jusqu' ce qu'une texture soit bonne ou que l'on dpasse la frquence limite
      && wFrequencyLevel * 8 <= wMaxTailleTexture ; 
      wFrequencyLevel *= 2 ) 
  {
  
  // Pour chaque frquence,  partir de deux, tant que la condition de boucle n'est pas remplie, pour des frquences 2  chaque pas.
  if ( wFrequencyLevel > 1 ) 
    {
    
    // Changement d'chelle
    TReperage rep(complex(0, 0), complex(wFrequencyLevel, 0)
      , complex(0, wFrequencyLevel));
    UseRotat(rep, puSource, puMultiFreqBuffer);
    
    /* Appel du calcul de vraissemblance de texture pour chelle >1
       
       La fonction suivante appelle le calcul des textures sur l'image rchantillonne
       Les donnes retournes sont: pwNbTexelsTotal et pwNbTexelsValides
       */
    f =  TexVraissemblanceRelative(pwNbTexelsTotal
        , // Nombre de texels dans le quadrilatre
          pwNbTexelsValides // Nombre de texels  texture valide dans le quad
        , puMultiFreqBuffer, puTarget, puContour, q / wFrequencyLevel
        , uVisuMode);
    }
  else 
    
    // Appel du calcul de vraissemblance de texture pour chelle == 1
    f =  TexVraissemblanceRelative(pwNbTexelsTotal, pwNbTexelsValides
      , puSource, puTarget, puContour, q / wFrequencyLevel, uVisuMode);
  *pwPeriodeVraissemblanceMax =  8 * wFrequencyLevel ;
  }
return f ;
}

/*
   Calcul de la vraissemblance relative: un rectangle de l'image est-il
   un rectangle de texel?
   
     la zone analyse est le plus petit rectangle de texels qui inclue le rectangle de pixel (avec ancrage en top-left).
   
   */
int TexVraissemblanceRelative (
   unsigned int *pwNbTexelsTotal // Retourne le nombre de texels analyss
   , unsigned int *pwNbTexelsValides
    , // Retourne le nombre de texels valides dans la zone analyse
      unsigned char *puSource // Image
    , unsigned char *puTarget, // Carte des texels  remplir
                               unsigned char *puContour
    , // Plan pour stocker l'image de contours
      TRect r // Rectangle  analyser (dans l'chelle du pixel)
    , TRect *prAnalysed, // Rectangle analys (peut-tre diffrent d''r').
                         unsigned char uVisuMode )
{

/*  unsigned char *puStackSource=puTexSource, *puStackTarget=puTexTarget,
       *puStackContour=puTexContour;
   puTexSource=puSource; puTexTarget=puTarget; puTexContour=puContour;
   */
/*
    Calcul de la carte de contours dans puContours
   pTx est un objet de la classe TTexture.
   */
pTx -> CallTexture(CM_CONTOUR, puSource, puTarget, puContour);
for ( int i = 0, *pi = (int *)&r ; i < 4 ; i++ ) 
  *pi++ >>= 3 ;
/*
------>  Passage d'r dans les coordonnes du texel en divisant
par 8 (dcimales tronques).
   Exemple, pour les carrs de ct horizontal de cote [0;8]  [0;13],
   il est ramen  [0;1].
   Ce qui fait que 2 texels seront examines.
   */
// ------> r est dans les coordonnes du texel
*pwNbTexelsValides
  =  pTx -> CallVraissemblance(uVisuMode, r, puSource, puTarget, puContour);

TRect rIncludeBorder (r) ;

rIncludeBorder.left++ ;
rIncludeBorder.bottom++ ; // Increase +1 for coherent area calculation including border
*pwNbTexelsTotal     =  (unsigned int)rIncludeBorder.Area() / 64 ;
*prAnalysed          =  r ;
prAnalysed -> top    <<= 3 ;
prAnalysed -> left   <<= 3 ;
prAnalysed -> bottom =  (r.bottom << 3) + 7 ;
prAnalysed -> right  =  (r.right << 3) + 7 ;

//  puTexSource=puStackSource;puTexTarget=puStackTarget;puTexContour= puStackContour;
return !!*pwNbTexelsTotal ;
}

inline BOOL HaveOneOf4CornersHigherThan ( TRect r, unsigned char *pu
    , unsigned char u )
{
#if !SIZE_OF_PICTURES - 256

TPoint  tl = r.TopLeft(), bl = r.BottomLeft(), tr = r.TopRight()
  , br = r.BottomRight();

return pu [(unsigned int)(tl.y << 8) + tl.x] > u
        || pu [(unsigned int)(bl.y << 8) + bl.x] > u
        || pu [(unsigned int)(tr.y << 8) + tr.x] > u
        || pu [(unsigned int)(br.y << 8) + br.x] > u ;
#else 
#error Fonction calibre pour 256 pixels
#endif
}

inline BOOL Have4CornersHigherThan ( TRect r, unsigned char *pu
    , unsigned char u )
{
#if !SIZE_OF_PICTURES - 256

TPoint  tl = r.TopLeft(), bl = r.BottomLeft(), tr = r.TopRight()
  , br = r.BottomRight();

return pu [(unsigned int)(tl.y << 8) + tl.x] > u
        && pu [(unsigned int)(bl.y << 8) + bl.x] > u
        && pu [(unsigned int)(tr.y << 8) + tr.x] > u
        && pu [(unsigned int)(br.y << 8) + br.x] > u ;
#else 
#error Fonction calibre pour 256 pixels
#endif
}

void Pinceau ( TPoint pt, void *pArgs )
{
void  **apArgs = (void **)pArgs ;

((unsigned char *)(apArgs [0]))[
    (unsigned int)pt.y * SIZE_OF_PICTURES + pt.x]
  =  *((unsigned char *)(apArgs [1]));
}

/*
   Calcul la vraissemblance dans un rectangle de l'image. Stocke le rsultat dans puDestin (plan de bit)
   */
int TexVraissemblanceRelative ( unsigned int *pwNbTexelsTotal
    , unsigned int *pwNbTexelsValides, unsigned char *puSource
    , unsigned char *puTarget, unsigned char *puContour
    , TQuadrilatere q // chelle du pixel dans l'image r-chantillone
    , unsigned char uVisuMode )
{
TRect   r = q.RectangleCirconscrit(), rScanned ;

// Appel du calcul des textures dans le rectangle circonscrit
int     fRes
  = TexVraissemblanceRelative(pwNbTexelsTotal, pwNbTexelsValides, puSource
    , puTarget, puContour, r, &rScanned, uVisuMode);

/* Texels calcul dans le rectangle circonscrit (limites incluses,
      dbordements ventuels).
   
   Le code ci-dessous analyse la carte des texels et dtermine pwNbTexelsTotal
   et pwNbTexelsValides en tenant compte du fait que le quadrilatre n'est pas
   un rectangle.
   
     Pour cela, on dresse une carte d'appartenance au duadrilatre
   (ScanPolygon).
     Ensuite, pour chaque texel, on regardera s'il est ou nom dans la zone,
   ou s'il la chevauche. Pour cela, on regarde si ses coins appartiennent au
   quad (prsent ou non dans la carte d'appartenance).
       */
TPoint  *aptPolygone = (TPoint *)&q ;

Eff(puTarget);

unsigned char uPinceau = TEX_SCAN_POLY_WithinPolygon ;
void          *apArgs [2] = {(void *)puTarget, (void *)&uPinceau };

ScanPolygon(aptPolygone, 4, r, Pinceau, (void *)apArgs);

// Carte d'appartenance au polygone (puTarget)
TSize sTexel(7, 7);

*pwNbTexelsTotal =  *pwNbTexelsValides = 0 ;
for ( int i = 0 ; i < 32 ; i++ ) 
  for ( int j = 0 ; j < 32 ; j++ ) 
    {
    
    // Pour chaque texel
    TCoordonnee ptTexel = TPoint(j, i) * 8 ;
    TRect       rTexel (ptTexel, sTexel) ;
    int         fGoodTexel = pTx -> auTI4_Vraissemblance [i * 32 + j];
#if !SIZE_OF_PICTURES - 256
    TPoint  tl = rTexel.TopLeft(), bl = rTexel.BottomLeft()
      , tr = rTexel.TopRight(), br = rTexel.BottomRight();
    
    // Coins des texels
    int     fIsTexelWithin
      = // 4 corners within
        puTarget [(unsigned int)(tl.y << 8) + tl.x]
          & puTarget [(unsigned int)(bl.y << 8) + bl.x]
          & puTarget [(unsigned int)(tr.y << 8) + tr.x]
          & puTarget [(unsigned int)(br.y << 8) + br.x]
          & TEX_SCAN_POLY_WithinPolygon ;
    int     fTouchesPolygon
      = // One at least within
        (puTarget [(unsigned int)(tl.y << 8) + tl.x]
            | puTarget [(unsigned int)(bl.y << 8) + bl.x]
            | puTarget [(unsigned int)(tr.y << 8) + tr.x]
            | puTarget [(unsigned int)(br.y << 8) + br.x])
          & TEX_SCAN_POLY_WithinPolygon ;
#else 
#error Fonction calibre pour 256 pixels
#endif
    /*
       int fIsTexelWithin=Have4CornersHigherThan(rTexel,puTarget, TEX_SCAN_POLY_WithinPolygon-1);
       int fTouchesPolygon=HaveOneOf4CornersHigherThan(rTexel,puTarget, TEX_SCAN_POLY_WithinPolygon-1);
       */
    // Dans la surface inspecte (inclousion stricte):
    *pwNbTexelsTotal   += !!fIsTexelWithin ;
    *pwNbTexelsValides += (fIsTexelWithin && fGoodTexel);
    TCoordonnee pt ;
    
    // Rajout  la carte d'appartenance au quad: validit, appartenance du texel...
    for ( pt.y = 0 ; pt.y < 8 ; pt.y++ ) 
      
      // Pour tous les pixels du texel...
      for ( pt.x = 0 ; pt.x < 8 ; pt.x++ ) 
        {
        TPoint  ptHere = pt + ptTexel ;
#if 0
        unsigned char pWP
          = fIsTexelWithin ? TEX_SCAN_POLY_TexelWithinPolygon : 0 ;
        unsigned char tTP
          = fTouchesPolygon ? TEX_SCAN_POLY_TexelTouchesPolygon : 0 ;
        unsigned char tg = fGoodTexel ? TEX_SCAN_POLY_TexelGoodTexture : 0 ;
        unsigned char u = pWP | tTP | tg ;
        puTarget [(unsigned int)(ptHere.y * SIZE_OF_PICTURES + ptHere.x)]
          |= pWP | tTP | tg ;
#else 
        puTarget [(unsigned int)(ptHere.y * SIZE_OF_PICTURES + ptHere.x)]
          |= (fIsTexelWithin ? TEX_SCAN_POLY_TexelWithinPolygon : 0)
            | (fGoodTexel ? TEX_SCAN_POLY_TexelGoodTexture : 0)
            | (fTouchesPolygon ? TEX_SCAN_POLY_TexelTouchesPolygon : 0);
#endif
        }
    /*
       if (Have4CornersHigherThan(TRect(ptTexel,sTexel),puTarget, TEX_SCAN_POLY_WithinPolygon-1))
         {
         (*pwNbTexelsTotal)++;
         int fGoodTexel=pTx->auTI4_Vraissemblance[i*8+j];
         if (fGoodTexel)
           (*pwNbTexelsValides)++;
         }
       */ 
    }
return fRes ;
}

/*-------------------------------------------*/
//Visualisation: Contour en texels de 8*8
#if 0
void TTexture::VisuTextureMap ( unsigned char uVisuMode
    , unsigned char puTextureMap [32 * 32], TRect r )
{
VisuTextureMap(uVisuMode, puTextureMap, r, puTexSource, puTexTarget);
}
#endif
