#ifndef ANALTEX_H
#define ANALTEX_H

#include "wgeometr.h"

#define CSEUIL 128				// seuil pour la carte de compacit
#define TSEUIL 10					// taille minimum du code (carrs de 8*8)
#define TOLERANCE 2.0			// Marge du produit scalaire pour l'angle droit

#define TEX_VISU_SANS   FAUX
#define TEX_VISU_SOURCE 1
#define TEX_VISU_DESTIN 2
//Affichage des tapes de calcul 0:Non, 1:Source, 2:Destination

#define TEX_FOND_VISU_NOIR  0
#define TEX_FOND_VISU_SOURCE     1
#define TEX_FOND_VISU_BLANC      2
// Fond visu: 0:Noir, 1:Source, 2:Blanc



typedef struct TGeo
{	int m00;
	int m01;
	int m10;
}Tgeo;

typedef struct TGeo2
{	float mu11;
	float mu02;
	float mu20;
}Tgeo2;

typedef struct TDrt
{	TDroite droite;
	TVecteur vecteur, A, B;
	long int longueur;
	long int orglong;
	unsigned char indice;
}TDrt;

//----------- Classe des textures

extern TRect rTexImage, //=TRect(0,0,31,31);
             rTexImageWithBorder; //  //=TRect(0,0,32,32);
class TTexture
{
  public :
    unsigned char auTI4_Vraissemblance[32*32];
    TTexture( void );
  void CallTexture( WPARAM id, unsigned char *puSource,
    unsigned char *puTarget, unsigned char *puContour);
  unsigned int CallVraissemblance(unsigned char uVisuMode, TRect r,
    unsigned char *puSource,
    unsigned char *puTarget, unsigned char *puContour);

  private :
  unsigned char *puTexSource, *puTexTarget, *puTexContour;

	// cartes de texture
        unsigned char TI1[32*32]; // Contuit
	unsigned char TI2[32*32]; // Densit
	unsigned char TI3[32*32]; // Proximite

	unsigned char TIm[32*32]; 	// Buffer morphologie ( interne )
	unsigned char freeman[512];
	unsigned char code[10][2];
	TDrt Droite[40];
	float xcg, ycg;
	int firstx, firsty;

//	public:

	unsigned char *Tsrc, *Tdst;//, *pContour;
	~TTexture( void );
	void Morphologie( void );
	void SetTsrc( int );
	void SetTdst( int );
        void ShowTI();
        void InitFondVisu(char uFondVisu_);
	TQuadrilatere Detection( void );
	unsigned int Vraisemblance(TRect r=rTexImage);
        unsigned int CmVraissemblance(unsigned char uVisuMode,TRect r=rTexImage);
///*        void VisuTextureMap(unsigned char uVisuMode,unsigned char puTextureMap[32*32],TRect r);
	int Etiquetage();
	int Freeman();
	int Vectorisation( int );
	void Correction();
	void Granularite( void );
	void Densite(TRect r=rTexImage);
	void Discontinuite( void );
	void Continuite(TRect r=rTexImage);
	void Proximite(TRect r=rTexImage);
	void Compacite( void );
	void CmTexture(WPARAM);

	protected:
	void TErosion( int, char );
	void TDilatation( int, char );
	int pix_test( int, int );
	int RemplisTexel( int, int );
	unsigned char remplis( unsigned char *, int, int, unsigned char );
	TGeo TRemplis_CGravite( unsigned char, unsigned char );
	TGeo2 TRemplis_Inertie_Etiquette( unsigned char, unsigned char, unsigned char );
};

/*---------------------*/
/*--TParametres-------------------------------------------------------------*/
/*
class TParametres : public TDialog
{	TScrollBar *ReSeuil1, *ReSeuil2, *ReSeuil3, *ReSeuil4;
	TStatic *ReCap1, *ReCap2, *ReCap3, *ReCap4;
	int vReSeuil1, vReSeuil2, vReSeuilzc, vReSeuil3;
	public:
	TParametres(TWindow* parent);
//	~TParametres();
	protected:
	void SetupWindow( void );
	void EvA(WPARAM id);
	void EvB(WPARAM id);
	void EvC(WPARAM id);
	void EvD(WPARAM id);
	void EvAppliquer( void );
//	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TParametres);
};
*/
/*-----------------------------------------------------------------------*/
/*--TOptions-------------------------------------------------------------*/
/*
class TOptions : public TDialog
{  TRadioButton *pRB[15];
	TComboBox *ReCombo;
	public:
	TOptions(TWindow* parent);
//	~TOptions();
	protected:
	void SetupWindow( void );
	void EvCombo( void );
	void EvRB1( void );
	void EvRB2( void );
	void EvRB3( void );
	void EvRB4( void );
	void EvRB5( void );
	void EvRB6( void );
	void EvRB7( void );
	void EvRB8( void );
	void EvRB9( void );
	void EvRB10( void );
	void EvRB11( void );
	void EvRB12( void );
	void EvRB13( void );
	void EvRB14( void );
	void EvRB15( void );
	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TOptions);
};
*/
/*-----------------------------------------------------------------------*/
extern int seuilzc;
extern int seuil1;
extern int seuil2;
extern int seuil3;

extern TTexture 			far *pTx;

extern unsigned char far Visu[5], VisuDef[5];
extern unsigned char uFondVisu;	//0:Noir, 1:Source, 2:Blanc

int TexVraissemblanceRelative(unsigned int *pwNbTexelsTotal,
    unsigned int *pwNbTexelsValides, unsigned char *puSource,
    unsigned char *puTarget, unsigned char *puContour, TRect r,
    TRect *prAnalysed, unsigned char uVisuMode=2);
int TexVraissemblanceRelative(unsigned int *pwNbTexelsTotal,
    unsigned int *pwNbTexelsValides, unsigned char *puSource,
    unsigned char *puTarget, unsigned char *puContour, TQuadrilatere q,
    unsigned char uVisuMode=2);
void ShowTexture(unsigned char auTexSrc[32*32],unsigned char *puTexDest);

int TexVraissemblanceRelativeMaxMultiFrequence(unsigned int *pwNbTexelsTotal,
    unsigned int *pwNbTexelsValides, float xSeuilRaportsSurface, unsigned int wSeuilSurfaceTotale,
    unsigned char *puSource,
    unsigned char *puTarget, // Plan pour afficher le rsultat.
    unsigned char *puContour, // Plan pour stocker l'image de contour
    unsigned char *puMultiFreqBuffer, // Plan pour stocker le plan source  la frquence intermdiaire
    TQuadrilatere q, // Quadrilatre  analyser.
    unsigned int *pwPeriodeVraissemblanceMax, unsigned char uVisuMode=2);
#endif // header unicity ANALTEX_H
