#error Obsolete: use wcortex.h and analtex.h
/**********************************************************************/
/*                     C O R T E X . H   	       			             */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions.                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril - Septembre 1996                         */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/
#include <owl/scrollba.h>
#include <owl/radiobut.h>

#include "wgeometr.h"

#define CSEUIL 128				// seuil pour la carte de compacit
#define TSEUIL 10					// taille minimum du code (carrs de 8*8)
#define TOLERANCE 2.0			// Marge du produit scalaire pour l'angle droit


typedef struct TGeo
{	int m00;
	int m01;
	int m10;
}Tgeo;

typedef struct TGeo2
{	float mu11;
	float mu02;
	float mu20;
}Tgeo2;

typedef struct TDrt
{	TDroite droite;
	TVecteur vecteur, A, B;
	long int longueur;
	long int orglong;
	unsigned char indice;
}TDrt;

//----------- Classe des textures
class TTexture
{	unsigned char TI1[32*32]; 	// cartes de texture
	unsigned char TI2[32*32];
	unsigned char TI3[32*32];
	unsigned char TI4[32*32];
	unsigned char TIm[32*32]; 	// Buffer morphologie ( interne )
	unsigned char freeman[512];
	unsigned char code[10][2];
	TDrt Droite[40];
	float xcg, ycg;
	int firstx, firsty;
	public:
	unsigned char *Tsrc, *Tdst, *pContour;
	TTexture( void );
	~TTexture( void );
	void ShowTI( void );
	void Morphologie( void );
	void SetTsrc( int );
	void SetTdst( int );
	void Detection( void );
	unsigned int Vraisemblance(TRect r=TRect(0,0,31,31));
        unsigned int CmVraissemblance(unsigned char uVisuMode,TRect r=TRect(0,0,31,31));
	int Etiquetage();
	int Freeman();
	int Vectorisation( int );
	void Correction();
	void Granularite( void );
	void Densite(TRect r=TRect(0,0,31,31));
	void Discontinuite( void );
	void Continuite(TRect r=TRect(0,0,31,31));
	void Proximite(TRect r=TRect(0,0,31,31));
	void Compacite( void );
	void CmTexture(WPARAM);

	protected:
	void TErosion( int, char );
	void TDilatation( int, char );
	int pix_test( int, int );
	int RemplisTexel( int, int );
	unsigned char remplis( unsigned char *, int, int, unsigned char );
	TGeo TRemplis_CGravite( unsigned char, unsigned char );
	TGeo2 TRemplis_Inertie_Etiquette( unsigned char, unsigned char, unsigned char );
};

/*---------------------*/
/*--TParametres-------------------------------------------------------------*/
class TParametres : public TDialog
{	TScrollBar *ReSeuil1, *ReSeuil2, *ReSeuil3, *ReSeuil4;
	TStatic *ReCap1, *ReCap2, *ReCap3, *ReCap4;
	int vReSeuil1, vReSeuil2, vReSeuilzc, vReSeuil3;
	public:
	TParametres(TWindow* parent);
//	~TParametres();
	protected:
	void SetupWindow( void );
	void EvA(WPARAM id);
	void EvB(WPARAM id);
	void EvC(WPARAM id);
	void EvD(WPARAM id);
	void EvAppliquer( void );
//	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TParametres);
};
/*-----------------------------------------------------------------------*/
/*--TOptions-------------------------------------------------------------*/
class TOptions : public TDialog
{  TRadioButton *pRB[15];
	TComboBox *ReCombo;
	public:
	TOptions(TWindow* parent);
//	~TOptions();
	protected:
	void SetupWindow( void );
	void EvCombo( void );
	void EvRB1( void );
	void EvRB2( void );
	void EvRB3( void );
	void EvRB4( void );
	void EvRB5( void );
	void EvRB6( void );
	void EvRB7( void );
	void EvRB8( void );
	void EvRB9( void );
	void EvRB10( void );
	void EvRB11( void );
	void EvRB12( void );
	void EvRB13( void );
	void EvRB14( void );
	void EvRB15( void );
	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TOptions);
};
/*-----------------------------------------------------------------------*/
extern TTexture 			far *pTx;
extern unsigned char far Visu[5], VisuDef[5];


