/**********************************************************************/
/*                        C T X S U P . C P P	                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Localisation de code barre 2D par analyse      */
/*                     de texture et reconstruction gomtrique       */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril 1996 - Septembre 1996	                   */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/

#include <math.h>
#include <stdio.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
#include <owl\applicat.h>
#include <owl\edit.h>
#include <owl\menu.h>
#include <owl\radiobut.h>
#include <owl\scrollba.h>
#include <owl\combobox.h>

#include "wappbase.h"
#include "wgttsi.h"
#include "wsysutil.h"
#include "wmain.h"

#include "wbase.h"
#include "iris.h"
#include "irsoutil.h"

#include "wcontour.h"
#include "wcontrol.h"
#include "wgeometr.h"

#include "ctxsup.h"
#include "cortex.h"
#include "cortex.rch"
#include "ctxoutil.h"

/*-----------------------------------------------------------------------*/
/*                     Variables globales                                */
/*-----------------------------------------------------------------------*/

TFenCortexPerso	far *pFenetreCortexPerso;
TAppCortexPerso	far *pApplicationCortexPerso;
TCadCortexPerso	far *pCadreCortexPerso;

//----------------------------------------------------------------------------
//						Programme principal : conversationnel TFenCortexPerso
//----------------------------------------------------------------------------


DEFINE_RESPONSE_TABLE1(TFenCortexPerso, TFenIris)
// wconv.cpp wcarconv.cpp wcomconv.cpp
	EV_COMMAND_AND_ID(CM_DENSITE, CmTexture),
	EV_COMMAND_AND_ID(CM_GRANULARITE, CmTexture),
	EV_COMMAND_AND_ID(CM_DISCONTINUITE, CmTexture),
	EV_COMMAND_AND_ID(CM_CONTINUITE, CmTexture),
	EV_COMMAND_AND_ID(CM_COMPACITE, CmTexture),
	EV_COMMAND_AND_ID(CM_PROXIMITE, CmTexture),
	EV_COMMAND_AND_ID(CM_DETECTION, CmTexture),
	EV_COMMAND(CM_PARAMETRES, CmParametres),
	EV_COMMAND(CM_REDUCTION, CmReduction),
	EV_COMMAND(CM_AGRANDISSEMENT, CmAgrandissement),
	EV_COMMAND(CM_VISU, CmVisu),
	EV_COMMAND(CM_OPTIONS, CmOptions),
END_RESPONSE_TABLE;

TFenCortexPerso::TFenCortexPerso():TFenIris()
{	pFenetreCortexPerso=this;
	pMenu_Traitement=new TMenu((HINSTANCE)(*((TApplication*)pApplicationCortexPerso)),"CortexMenu");
}

TFenCortexPerso::~TFenCortexPerso()
{
}

void TFenCortexPerso::SetupWindow()
{	TFenIris::SetupWindow();
	pmnuPrincipal->InsertMenu(5, MF_POPUP | MF_BYPOSITION, *(pFenetreCortexPerso->pMenu_Traitement),
	 "Corte&x");
}

//***** Appel d'une commande de texture
void TFenCortexPerso::CmTexture( WPARAM id )
{	pTx->SetTdst(1);
	pTx->CmTexture( id );
	Visim( this, 1, destin );
}

//******** Boite de dialogue "parametres"
void TFenCortexPerso::CmParametres()
{	(new TParametres(this))->Create();
}

//******* Outils:Rduction
void TFenCortexPerso::CmReduction()
//{	(new TReduction(this))->Create();
{	(new TParametreProgramme("Rduction",1,255,255,Reduction))->Create();
}

//******* Outils:Loupe
void TFenCortexPerso::CmAgrandissement()
{	(new TLoupe(this))->Create();
}

//******* Outils:Preview
void TFenCortexPerso::CmVisu()
{	(new TPreview(this))->Create();
}

//******* boite de dialogue "Options"
void TFenCortexPerso::CmOptions()
{	(new TOptions(this))->Create();
}

TAppCortexPerso::TAppCortexPerso() : TAppIris()
{	pApplicationCortexPerso=this;
}

void TAppCortexPerso::InitMainWindow()
{	new TCadCortexPerso(NULL,TitreApplication,new TFenCortexPerso,TRUE);
	TAppIris::InitMainWindow();
	pCadreCortexPerso->SetIcon( this, "Icone1" );
}

//----------------------------------------------------------------------------
TCadCortexPerso::TCadCortexPerso(TWindow *Parent, char far *Title, TWindow *Client,
							BOOL trackMenuSelection)
						  : TCadIris (Parent, Title, Client, trackMenuSelection)
{	pCadreCortexPerso=this;
}

/*-----------------------------------------------------------------------*/
/*                 Fonctions locales                                     */
/*-----------------------------------------------------------------------*/
void ChargeOptions()
{	GetPrivateProfileString("localisations","accueil",szImageAccueilDef,szImageAccueil,USUALMAXLENSTRING,szINIFileName);
	GetPrivateProfileString("localisations","rpertoire",szRepertoireDepartDef,szRepertoireDepart,USUALMAXLENSTRING,szINIFileName);
	GetPrivateProfileString("localisations","nom traceur",szNomTraceurDef,szNomTraceur,USUALMAXLENSTRING,szINIFileName);
	fTracage=GetPrivateProfileFlag("options","traage",fTracageDef,szINIFileName);
	fRuban=GetPrivateProfileFlag("options","ruban",fTracageDef,szINIFileName);
	wCommandePredefinie=GetPrivateProfileInt("options","commande predefinie",0,szINIFileName);
}
/*-----------------------------------------------------------------------*/
/*       		   Programme OwlMain                             */
/*-----------------------------------------------------------------------*/
int OwlMain(int /*argc*/, char* /*argv*/ [])
{	if (DemarrageCarte())
	{	strcpy(TitreApplication,"Cortex");
		strcpy(TexteAbout,"COde Reader by TEXture analysis\nVersion :2.0Dev - 24/09/96\n\nAuteur : Sbastien Delestaing");
		strcpy(FichierAide,"aide.HLP");
		strcpy(szINIFileName,"wcortex.ini");
		ChargeOptions();
		return TAppCortexPerso().Run();           // Lancement du programme
	}else
		return 0;
}

