#include "myowlall.h"
#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop

#define MODULE_NAME "WCORTEX.CPP"
/**********************************************************************/
/*                        C O R T E X . C P P	                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Localisation de code barre 2D par analyse      */
/*                     de texture et reconstruction gomtrique       */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril 1996 - Septembre 1996	                   */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/

// #include <math.h>
// #include <stdio.h>
// #include <values.h>

/*
#include <owl\combobox.h>
#include <owl\gadgetwi.h>
#include <owl\gdiobjec.h>
#include <owl\menu.h>
#include <owl\olewindo.h>
#include <owl\opensave.h>
#include <owl\scroller.h>
*/

#include "wbase.h"

#include "wintrac.h"
//#include "wedtderv.h"
#include "wsystool.h"
#include "wgeometr.h"

#include "sysctr.h"
#include "scaltool.h"
#include "symbole.h"
#include "contour.h"
#include "wiris.h"
#include "wlfilt.h"
#include "piadiv.h"

#include "analtex.h"
#include "ctxoutil.h"
#include "wcortex.h"
#include "wcortex.h"
//#include "ctxsup.h"
#include "cortex.rch"


// ---------------------- Variables Globales -------------------------
//Affichage des tapes de calcul 0:Non, 1:Source, 2:Destination
//0:Contour de l'objet basse rsolution
//1:Rsultat du dcodage de la chaine de Freeman
//2:Rsultat de la slection du quadrilatre
//3:Rsultat de la correction du quadrilatre
//4:Rsultat de la dtection
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TParametres 	                       */
/*--Systme---------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1(TParametres, TDialog)

  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL1, EvA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL2, EvB),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL3, EvC),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL4, EvD),
  EV_COMMAND(IDC_PUSHBUTTON1, EvAppliquer),
  EV_COMMAND(IDC_PUSHBUTTON3, EvClose),

END_RESPONSE_TABLE;

TParametres::TParametres(TWindow* parent)
 : TDialog(parent, "Parametres")
{
	ReSeuil1=new TScrollBar(this, IDC_HSCROLL1);
	ReSeuil2=new TScrollBar(this, IDC_HSCROLL2);
	ReSeuil3=new TScrollBar(this, IDC_HSCROLL3);
	ReSeuil4=new TScrollBar(this, IDC_HSCROLL4);
	ReCap1=new TStatic(this, ID_AGSEUIL1);
	ReCap2=new TStatic(this, ID_AGSEUIL2);
	ReCap3=new TStatic(this, ID_AGSEUIL3);
	ReCap4=new TStatic(this, ID_AGSEUIL4);
//	pParametres=this;
}

void TParametres::SetupWindow()
{	char string[12];

	TDialog::SetupWindow();
	ReSeuil1->SetRange( 1, 256 );
	ReSeuil1->SetPosition( seuil1 );
	ReSeuil2->SetRange( 1, 256 );
	ReSeuil2->SetPosition( seuil2 );
	ReSeuil3->SetRange( 1, 256 );
	ReSeuil3->SetPosition( seuil3 );
	ReSeuil4->SetRange( 1, 256 );
	ReSeuil4->SetPosition( seuilzc );
	vReSeuil1=seuil1;
	vReSeuil2=seuil2;
	vReSeuil3=seuil3;
	vReSeuilzc=seuilzc;
	sprintf(string, "%d", vReSeuil1);
	ReCap1->SetText(string);
	sprintf(string, "%d", vReSeuil2);
	ReCap2->SetText(string);
	sprintf(string, "%d", vReSeuil3);
	ReCap3->SetText(string);
	sprintf(string, "%d", vReSeuilzc);
	ReCap4->SetText(string);
	EvAppliquer();
}

void TParametres::EvA(UINT)
{	char string[12];

	vReSeuil1=ReSeuil1->GetPosition();
	sprintf(string, "%d", vReSeuil1);
	ReCap1->SetText(string);
}

void TParametres::EvB(UINT)
{	char string[12];

	vReSeuil2=ReSeuil2->GetPosition();
	sprintf(string, "%d", vReSeuil2);
	ReCap2->SetText(string);
}

void TParametres::EvC(UINT)
{	char string[12];

	vReSeuil3=ReSeuil3->GetPosition();
	sprintf(string, "%d", vReSeuil3);
	ReCap3->SetText(string);
}
void TParametres::EvD(UINT)
{	char string[12];

	vReSeuilzc=ReSeuil4->GetPosition();
	sprintf(string, "%d", vReSeuilzc);
	ReCap4->SetText(string);
}

void TParametres::EvAppliquer( void )
{	seuilzc=vReSeuilzc;
	seuil1=vReSeuil1;
	seuil2=vReSeuil2;
	seuil3=vReSeuil3;

//	pTx->pContour=PlanSuiv( destin );
  pTx->CallTexture(CM_CONTOUR,source,destin,PlanSuiv( destin ));
  pTx->CallVraissemblance(TEX_VISU_DESTIN,rTexImage, source, destin,PlanSuiv( destin ));

//	CalculeZCLaplacien( source, pTx->pContour, LAPLACIEN_CHAR_4, seuilzc );
/*	pTx->SetTdst(1);
	pTx->Continuite();			// TI1=Carte de continuit
	pTx->SetTdst(2);
	pTx->Densite();				// TI2=Carte de densit
	pTx->SetTdst(3);
	pTx->Proximite();				// TI3=Carte de Proximite
	pTx->Vraisemblance();
	pTx->SetTsrc(4);
	pTx->Tdst=destin;
	pTx->ShowTI();
*/
	Fenetre->Visim(this,1,destin);
}

/*void TParametres::EvClose( void )
{	TParametres::~TParametres();
} */

/*TParametres::~TParametres()
{	pParametres=NULL;
} */
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TOptions		                       */
/*--Systme---------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1( TOptions, TDialog)

  EV_COMMAND(IDC_RADIOBUTTON4, EvRB1),
  EV_COMMAND(IDC_RADIOBUTTON5, EvRB2),
  EV_COMMAND(IDC_RADIOBUTTON6, EvRB3),
  EV_COMMAND(IDC_RADIOBUTTON7, EvRB4),
  EV_COMMAND(IDC_RADIOBUTTON8, EvRB5),
  EV_COMMAND(IDC_RADIOBUTTON9, EvRB6),
  EV_COMMAND(IDC_RADIOBUTTON10, EvRB7),
  EV_COMMAND(IDC_RADIOBUTTON11, EvRB8),
  EV_COMMAND(IDC_RADIOBUTTON12, EvRB9),
  EV_COMMAND(IDC_RADIOBUTTON13, EvRB10),
  EV_COMMAND(IDC_RADIOBUTTON14, EvRB11),
  EV_COMMAND(IDC_RADIOBUTTON15, EvRB12),
  EV_COMMAND(IDC_RADIOBUTTON16, EvRB13),
  EV_COMMAND(IDC_RADIOBUTTON17, EvRB14),
  EV_COMMAND(IDC_RADIOBUTTON18, EvRB15),
  EV_COMMAND(IDC_PUSHBUTTON6, EvClose),
  EV_CHILD_NOTIFY(IDC_COMBOBOX2, CBN_SELCHANGE, EvCombo),

END_RESPONSE_TABLE;

TOptions::TOptions(TWindow* parent)
 : TDialog(parent, "Options")
{	int i;

	for( i=0; i<15; i++ )
		pRB[i]=new TRadioButton( this, IDC_RADIOBUTTON4+i );

	ReCombo=new TComboBox(this, IDC_COMBOBOX2);

//	pOptions=this;
}

void TOptions::SetupWindow()
{	int i;

	TDialog::SetupWindow();

	for( i=0; i<5; i++ )
		pRB[3*i+Visu[i]]->Check();

	ReCombo->AddString("Noir");
	ReCombo->AddString("Source");
	ReCombo->AddString("Blanc");
	ReCombo->SetSelIndex(uFondVisu);

}

void TOptions::EvCombo()
{	uFondVisu=ReCombo->GetSelIndex();
}

void TOptions::EvRB1()
{	Visu[0]=0;
}
void TOptions::EvRB2()
{	Visu[0]=1;
}
void TOptions::EvRB3()
{	Visu[0]=2;
}
void TOptions::EvRB4()
{	Visu[1]=0;
}
void TOptions::EvRB5()
{	Visu[1]=1;
}
void TOptions::EvRB6()
{	Visu[1]=2;
}
void TOptions::EvRB7()
{	Visu[2]=0;
}
void TOptions::EvRB8()
{	Visu[2]=1;
}
void TOptions::EvRB9()
{	Visu[2]=2;
}
void TOptions::EvRB10()
{	Visu[3]=0;
}
void TOptions::EvRB11()
{	Visu[3]=1;
}
void TOptions::EvRB12()
{	Visu[3]=2;
}
void TOptions::EvRB13()
{	Visu[4]=0;
}
void TOptions::EvRB14()
{	Visu[4]=1;
}
void TOptions::EvRB15()
{	Visu[4]=2;
}

void TOptions::EvClose()
{	TOptions::~TOptions();
}

/*TOptions::~TOptions()
{	pOptions=NULL;
} */

