/*
#include "myowlall.h"
#include "baptiall.h"
#pragma hdrstop
*/
/*******************|*******************************************
*    Fonction       : Petits outils pour strings pour C++     *
*                                                             *
* (contient les objets internes                               *
*  et les corps des objets  exporter)                        *
*-------------------------------------------------------------*
*    Auteur         : Baptise MARCEL                          *
*    Dvelopp le   : hivers 1997                             *
***************************************************************/

// Inclusions bibliothques standards

#include <stdlib.h>
#include <string.h>

//#include "base.h"
#include "strtool.h"

unsigned int CalculeFinDeLigne(char *LongText, unsigned int wNombreCarParLgn, unsigned int wlt);
int IsWrappingSeparator(char c);
inline int OrdreFinDeLigneWrapping(unsigned int wNCdL, unsigned int wNombreCarParLgn)
  {
  return wNCdL>wNombreCarParLgn;
  }

/*-------------------------------------------------------------*/
/*	              variables  exporter                     */
/*-------------------------------------------------------------*/
char acDefaultSeparators[]=" !.,:;()|-#'\"~/";
char *acUsualSeparators=acDefaultSeparators;

int ExtractValue(char *szLigne, int *piValue, char **pszNext)
  {
  if (!szLigne || !*szLigne) return 0;
  char *szTamp=NULL;//, *szLocalNext;
  int i=0;
  szLigne=AvaleEspace(szLigne); // Dcalage pour avaler les espaces.
  if  (!IsNumericInt(*szLigne) || (!IsDigit(*szLigne) && !IsDigit(szLigne[1]))) // Le premier caractere doit etre numrique, et en plus, soit le 1e soit le 2nd doit tre un chiffre: "--1" est refus.
    {
    *piValue=-1;
    if (pszNext) *pszNext=szLigne;
    return 0;
    }
  szTamp=(char *)malloc(strlen(szLigne)+1);
  szTamp[i++]=*szLigne++;
  while (IsDigit(*szLigne))
    szTamp[i++]=*szLigne++;
  if (! *szLigne) // End of line
    {if (pszNext) *pszNext=NULL;}
  else if (IsSeparator(*szLigne)) // The number must be followed by a saparator.
      {if (pszNext) *pszNext=szLigne+1;}
  else
    {
    *piValue=-1;
    if (pszNext) *pszNext=szLigne;
    free(szTamp);
    return 0;
    }
  szTamp[i]=0;
  /* Fermeture de la chane aprs la fin du nombre. */
  *piValue=atoi(szTamp);
  free(szTamp);
  return 1;
  }
/*-------------------------------------------------------------*/
/* AvaleEspace (Avale espaces)
  Renvoit un pointeursur la chane situ sur le premier caractre non espace).
  La chane renvoye est la mme (dcale).
  Renvoit NULL pour NULL.
   */
char *AvaleEspace (char *ligne)
  {
  if (ligne!=NULL)
    while (*ligne==' ')
      ligne++;
  /* ligne pointe sur le caractre suivant le dernier espace  compacter. */
  return ligne;
  }

/* ExtractValue (Prend un flottant)
  Renvoit le flottant situe au dbut de la chane de
caractre (espaces autorises).
  La fonction renvoit 0 en cas de lecture rate.
En cas de ncssit, cette fonction peut tre rcrite avec des sous-prog plus modernes:
    avalespace, isdigit, isseparator...
  */

int ExtractValue (char *szLigne, float *px, char **ppcNext)
  {
  char *arche, *szTampon;
  unsigned long int N=0;

  if (!szLigne || !px)
    return 0;

  szLigne=AvaleEspace(szLigne);
  if (!IsNumericFloat(*szLigne))
    return 0;
  /* Les ' ' sont avals. */
  arche=szLigne; /* Pointeur sur le dbut du nombre. */
  while (IsNumericFloat(*szLigne))
    {szLigne++;N++;}
  if (!IsSeparator(*szLigne)) /* Le nombre doit tre suivie d'un
				  sparateur ou d'une fin de szLigne. */
    return 0;
  else
    {
    if (ppcNext)
      *ppcNext=szLigne+1;
    szTampon = (char *)malloc((unsigned int)(N+1L));
    strNcpy(szTampon,arche,(unsigned int)N+1);
    *px=(float)atof(szTampon);
    free(szTampon);
    return 1;
    }
  }

  // wwt is at least one more than wlt to store last '\n'.
int WrappText (char *LongText // Long text to wrap
    ,unsigned int wlt // Length of LongText
    ,char *WrappedText, // Allocated string to place wrapped text
    unsigned int wwt, // Size of allocation of   WrappedText
     unsigned int wNombreCarParLgn,  // Number of charcater allowed in one line
    unsigned char uTypeWrapping) // Parameter
  {
  if (!wlt && wwt && WrappedText) // Ask to wrap a null text
    {
    *WrappedText=0;
    return 1;
    }
  if (!LongText || !WrappedText || !wwt || !wNombreCarParLgn)
    return 0;

  unsigned int wNCdLT=0; // N de caractre dans le texte complet.
  unsigned int wNCdWT=0; // N de caractre dans le "wrapped" texte .
  unsigned int wNCdL=0; // N de caractre dans la ligne.
  unsigned int wNombreCarCetteLgn=wNombreCarParLgn;
  while (1)
    {
    wNCdL=0;
//    while (wNCdL++<=wNombreCarParLgn)
    if (uTypeWrapping!=CONTINUOUS_WRAPPING)
      wNombreCarCetteLgn=CalculeFinDeLigne(LongText+wNCdLT,wNombreCarParLgn,wlt-wNCdLT);
    while (!OrdreFinDeLigneWrapping(wNCdL++,wNombreCarCetteLgn))
      {
      if (wNCdWT>=wwt-1) // Dernier caractere de la chane resultat.
        {
        WrappedText[wwt-1]=0;
        return 0;
        }
      else if (wNCdLT==wlt) // Chane initiale sans zero terminal.
        {
        WrappedText[wNCdWT]=0;
		  return 1;
        }
      else if (!LongText[wNCdLT]) // Fin de chane source.
        {
        WrappedText[wNCdWT]=0;
		  return 1;
        }
      WrappedText[wNCdWT++]=LongText[wNCdLT++];
      }
    if (wNCdWT>=wwt-1)
      {
      WrappedText[wwt-1]=0; // wwt is
      return 0;
      }
    else if (!LongText[wNCdLT])
      {
      WrappedText[wNCdWT]=0; // Coincidence fin de ligne - fin de chane.
		return 1;
      }
    else
      {
      WrappedText[wNCdWT++]='\r';
      WrappedText[wNCdWT++]='\n';
      }
    }
  }
unsigned int CalculeFinDeLigne(char *LongText, unsigned int wNombreCarParLgn, unsigned int wlt)
  {
  if (!LongText || !wNombreCarParLgn  || !wlt)
    return 0;
  else if (wNombreCarParLgn>= wlt)
    return wlt;
  else
    {
    unsigned int wNombreCarCetteLgn= wNombreCarParLgn;
    while(!IsWrappingSeparator(LongText[wNombreCarCetteLgn]) && wNombreCarCetteLgn)
      wNombreCarCetteLgn--;
    if (!wNombreCarCetteLgn)
      return wNombreCarParLgn;
    else
      return wNombreCarCetteLgn;
    }
  }

  /*-------------------------------------------------------------*/
/* IsWrappingSeparator (Caractre de csure)
  Renvoit 1 (vrai) si le caractre soumis est un caractre sur lequel on
peut couper une ligne (espace, ponctuation...) et 0 (faux) sinon.
  On sait que le caractre est typographique.
  Renvoit FAUX pour "\0".*/
int IsWrappingSeparator(char c)
  {
  switch (c)
    {
    case '!' :
    case '-' :
    case 47  : /* le caractre '/' */
    case 92  : /* le caractre '\' */
    case '_' :
    case '|' :
    case 127 : /* caractre vide */
    case -1  : /* caractre 255 : ' ' */
			 return 1;
    default  :
			 return 0;
    }
  }
int Dewrappe(char *szLongText)
  {
  unsigned int wS=0, wD=0;
  while (szLongText[wS])
    {
    if (szLongText[wS]!='\r' && szLongText[wS]!='\n')
      szLongText[wD++]=szLongText[wS];
    wS++;
    }
  szLongText[wD]=0;
  return 1;
  }

