/**********************************************************************/
/*                       W A N I M N B. C P P		                   */
/*--------------------------------------------------------------------*/
/*    Fonction       : Animation de squences d'images N/B            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			             			      	 		 */
/*    Dvelopp le   : 25/04/1997				                	       */
/*    Dernire modif.: 02/01/1998                                     */
/**********************************************************************/
													// Dos
#include <stdio.h>
#include <dir.h>
#include <stdlib.h>
#include <io.h>
#include <alloc.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlseqnb.h"

#include "wmain.h"
#include "wappbase.h"
#include "wanimnb.h"

#define ID_TIMER_ANIMNB 12386
#define ID_TIMER_CREASEQ 12348
#define ID_TIMER_ANIMA 12347

TSequencenb* TSequencenbPtr = 0; // Fentre sequence
TAnima* TAnimaPtr=0;        		// Fentre animation
TCreaseq* TCreaseqPtr=0;        	// Fentre cration de squence

//----------------------------------------------------------------------------
//						Programme TConveditnb
//----------------------------------------------------------------------------

 class TConveditnb : public TChoix {
 public:

	 TConveditnb(TSequencenb* parent,int firstseq,char *nomfich);
	~TConveditnb();
 protected:
	 void EvCommun(char c);
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void AfficheOptions(void);
	 void Merge(int firstseq,char *nomfich,long numdep, long numarr);

	 int first;
	 char fich[MAXPATH];
	 long numdep,numarr,nbtotimage;
	 TEdit *Aeditnb,*Beditnb;
	 TSequencenb* pere;

	DECLARE_RESPONSE_TABLE(TConveditnb);
};

TConveditnb* TConveditnbPtr;      // Fentre editseq

//----------------------------------------------------------------------------
//						Programme TAffseqnb
//----------------------------------------------------------------------------

class TAffseqnb : public TFramePrint {
  public:

	 TAffseqnb(TWindow* parent,char titre[]);
	~TAffseqnb();
  protected:
	 void Paint(TDC& dc, BOOL, TRect&);
};

TAffseqnb* TAffseqnbPtr = 0; // Fentre affichage sequence

//----------------------------------------------------------------------------
//						Programme TAffseqnb
//----------------------------------------------------------------------------

TAffseqnb::TAffseqnb(TWindow* parent, char titre[])
  : TFramePrint(parent,titre)
{
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376/2;
		Attr.H = 256+27;
}

TAffseqnb::~TAffseqnb()
{
	TAffseqnbPtr=0;
}

void TAffseqnb::Paint(TDC& dc, BOOL, TRect&)
{
int py0=0,px0=100,pas=15;
char string[80];
float taux;

	dc.TextOut(1,py0,      "CODAGE    :");
	dc.TextOut(1,py0+pas,  "QUALITE   :");
	dc.TextOut(1,py0+pas*2,"TOT.IMAGES:");
	dc.TextOut(1,py0+pas*3,"TOT.CODES :");
	dc.TextOut(1,py0+pas*4,"MOY.CODES :");
	dc.TextOut(1,py0+pas*5,"MOY.COMP  :");

	itoa(en_tete_im.type_codage,string,10);
	dc.TextOut(px0,py0,string);
	itoa(en_tete_im.qualite,string,10);
	dc.TextOut(px0,py0+pas,string);
	ltoa(carseqnb.nbtot,string,10);
	dc.TextOut(px0,py0+pas*2,string);
	ltoa(carseqnb.totcod,string,10);
	dc.TextOut(px0,py0+pas*3,string);
	gcvt(carseqnb.codmoyen,6,string);
	dc.TextOut(px0,py0+pas*4,string);
	taux=65536./carseqnb.codmoyen;
	gcvt(taux,6,string);
	dc.TextOut(px0,py0+pas*5,string);

	}

//----------------------------------------------------------------------------
//						Programme TSequencenb
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TSequencenb, TFrameWindow)
  EV_COMMAND_AND_ID(ID_A, EvA),
  EV_COMMAND_AND_ID(ID_A+1, EvB),
  EV_COMMAND_AND_ID(ID_A+2, EvC),
  EV_COMMAND_AND_ID(ID_A+3, EvD),
  EV_COMMAND_AND_ID(ID_A+4, EvE),
  EV_COMMAND_AND_ID(ID_A+5, EvF),
  EV_COMMAND_AND_ID(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_A+7, EvH),
  EV_COMMAND_AND_ID(ID_A+8, EvI),
  EV_COMMAND_AND_ID(ID_A+9, EvJ),
  EV_WM_LBUTTONDOWN,
  EV_WM_MOUSEMOVE,
  EV_WM_LBUTTONUP,
  EV_WM_TIMER,
  EV_WM_MBUTTONDOWN,
  END_RESPONSE_TABLE;

TSequencenb::TSequencenb(TWindow* parent,char titre[])
  : TFrameWindow(parent, titre)
{
int i,x0,y0;
int xmax=640;               	// Largeur cran
int decyfen=0;            	// Dcalage fentres en y
int maxcar;                     //Nb max de caractres
char *tabmes;           	// Table de messages
int py=52;                	// Position de dpart en y
int nb=9;                  	// Nombre de choix
int Fx=54,Fy=25;            	// Tailles fentres

	maxcar=Fx/8;            // 1 caractre = 8 points
	x0=(xmax-Fx*nb)>>1;
	y0=py+decyfen;
	tabmes=(char *)malloc(nb*(maxcar+1)*sizeof(char));
	strcpy(tabmes,"&0 <<");      // messages
	strcpy(tabmes+(maxcar+1),"&1 <");
	strcpy(tabmes+2*(maxcar+1),"&2 >");
	strcpy(tabmes+3*(maxcar+1),"&3 >>");
	strcpy(tabmes+4*(maxcar+1),"&4 PAR");
	strcpy(tabmes+5*(maxcar+1),"&5 NOM");
	strcpy(tabmes+6*(maxcar+1),"&6 PRE");
	strcpy(tabmes+7*(maxcar+1),"&7 SUI");
	strcpy(tabmes+8*(maxcar+1),"&8 EDI");

	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

	Attr.X = 0;
	Attr.Y = 282+OFFSET;
	Attr.W = 640;
	Attr.H = 107;

	for(i=0;i<=nb-1;i++)
	{
  new TButton(this,ID_A+i,tabmes+(maxcar+1)*i,
  x0+i*Fx,y0,Fx-1,Fy-1,FALSE);
	}

  free(tabmes);

  Aseq=new TStatic(this, ID_STATIC, "", 0, 0, 50, 17, 0);     // num
  Bseq=new TStatic(this, ID_STATIC, "", 0, 20, 50, 17, 0);    // vitesse
  Cseq=new TStatic(this, ID_STATIC, "", 570, 0, 70, 17, 0);   // code
  Dseq=new TStatic(this, ID_STATIC, "", 570, 20, 70, 17, 0);  // total
  Eseq=new TStatic(this, ID_STATIC, "", 570, 40, 70, 17, 0);  // date
  Fseq=new TStatic(this, ID_STATIC, "", 570, 60, 70, 17, 0);  // heure
  Gseq=new TStatic(this, ID_STATIC, "", 0, 40, 50, 17, 0);    // pas

  SolidGauge=new TGauge(this, "",ID_STATIC, 50, 0, 512, 10, TRUE, 1);
}

void TSequencenb::SetupWindow()
{
	TFrameWindow::SetupWindow();

	FileData2.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	FileData2.SetFilter("Sequences N/B (*.SNB)|*.SNB");
	FileData5.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	FileData5.SetFilter("Sequences N/B (*.SNB)|*.SNB");

	flagsequence=0;
	numimag=0;
	stop=1;
	pas=1;
	SolidGauge->SetRange(0,512);
	nbtotimage=0;
	modboucle=0;
	SetTimer(ID_TIMER_ANIMNB,1);                // Timer
}

TSequencenb::~TSequencenb()
{
	KillTimer(ID_TIMER_ANIMNB);
	if(in1) {fclose(in1);in1=0;}
	TSequencenbPtr=0;
}

void TSequencenb::EvTimer(UINT)
{
	if(stop==0)
	{
	Calimsuiv();
	Affim();
	}
}

void TSequencenb::EvLButtonDown(UINT a, TPoint& point)
{
	if(!nbtotimage) return;

	flagsequence=1;
	EvMouseMove(a,point);
}

void TSequencenb::EvLButtonUp(UINT a, TPoint& point)
{
int posx0,posy0;

	if(!nbtotimage)return;

	flagsequence=0;

	posx0=point.x;
	posy0=point.y;

	if(posy0>=75&&posy0<75+10)
	{
		if(posx0>=77+54&&posx0<=77+107)
		{
		pas=-1;
		Arret();
		}
		if(posx0>=77+107&&posx0<=77+107+54)
		{
		pas=1;
		Arret();
		}
	}
	EvMouseMove(a,point);
}

void TSequencenb::EvMouseMove(UINT, TPoint& point)
{
int posx0,posy0;
float numero;
int x0,x1,y0,y1;

	posx0=point.x;
	posy0=point.y;

	if(!nbtotimage)return;

if(flagsequence)
{
	x0=50;x1=x0+512;y0=0;y1=y0+50;
	if(posx0>=x0&&posx0<x1&&posy0>=y0&&posy0<y1)
	{
	numero=(float)(nbtotimage-1)*(float)(posx0-x0)/511.;
	numimag=long(numero);
	Affim();
	}

	if(posy0>=75&&posy0<75+10)
	{
		if(posx0>=77&&posx0<=77+54)
		{
		pas=-1+(posx0-77-54)/9;
		stop=0;
		}
		if(posx0>=77+54&&posx0<=77+107)
		{
		pas=-1;
		stop=0;
		}
		if(posx0>=77+107&&posx0<=77+107+54)
		{
		pas=1;
		stop=0;
		}
		if(posx0>=77+107+54&&posx0<=77+107+107)
		{
		pas=1+(posx0-77-107-54)/9;
		stop=0;
		}
	}//if
}//if flag
}

void TSequencenb::EvMButtonDown(UINT, TPoint &)
{
}

void TSequencenb::Affim()
{
long nbcod;

	if(nbtotimage==0) return;
	nbcod=Animaseq(in1,numimag,destin);
	Affcarim(nbcod);
	Calsuiv();
	Fenetre->Visim(this,IM_GAUCHE,source);
}

void TSequencenb::Affcarim(long nbcod)               // Affichage car. image
{
char string[20],s[20];
int setting;
long diff;
float vitesse;
int a;

	ltoa(numimag+1,string,10);
	Aseq->SetText(string);                  // Numro de l'image
	if(stop==0)
	{
	t1=Caltime();
	if(labs(t1-t0)>=100)
		{
		n1=numimag;
		if(pas>0) diff=n1-n0;else diff=n0-n1;
		if(diff<0) diff+=nbtotimage;
		vitesse=100.*(float)diff/(float)(t1-t0);
		t0=t1;
		n0=n1;
		gcvt(vitesse,4,string);
		strcpy(s,"V:");
		strcat(s,string);
		Bseq->SetText(s);               // Vitesse d'animation
		}
  }
	if(nbtotimage==1) setting=1;
	else	setting=(int)(512.*((float)numimag/(float)(nbtotimage-1)));
	SolidGauge->SetValue(setting);

	ltoa(nbcod,string,10);
	strcpy(s,"C:");
	strcat(s,string);
	Cseq->SetText(s);                  // Nb. codes de l'image
	ltoa(nbtotimage,string,10);
	strcpy(s,"T:");
	strcat(s,string);
	Dseq->SetText(s);                  // Nb. total d'images
	itoa(pas,string,10);
	strcpy(s,"P:");
	strcat(s,string);
	Gseq->SetText(s);                  // Pas : pour animation

	strcpy(s,"");
	a=en_tete_im.dateimage.da_day;
	tc.ft_day=a;
	itoa(a,string,10);
	strcat(s,string);
	strcat(s,"/");
	a=en_tete_im.dateimage.da_mon;
	tc.ft_month=a;
	itoa(a,string,10);
	strcat(s,string);
	strcat(s,"/");
	a=en_tete_im.dateimage.da_year;
	tc.ft_year=a-1980;
	itoa(a,string,10);
	strcat(s,string);
	Eseq->SetText(s);                  // Date

	strcpy(s,"");
	a=en_tete_im.timimage.ti_hour;
	tc.ft_hour=a;
	itoa(a,string,10);
	strcat(s,string);
	strcat(s,":");
	a=en_tete_im.timimage.ti_min;
	tc.ft_min=a;
	itoa(a,string,10);
	strcat(s,string);
	strcat(s,":");
	a=en_tete_im.timimage.ti_sec;
	tc.ft_tsec=a/2;
	itoa(a,string,10);
	strcat(s,string);
	Fseq->SetText(s);                  // Heure
}

void TSequencenb::Paint(TDC& dc, BOOL, TRect&)
{
	dc.Rectangle(77,75,77+53,75+10);            // Pour dplacements
	dc.Rectangle(77+54,75,77+107,75+10);
	dc.Rectangle(77+107,75,77+107+53,75+10);
	dc.Rectangle(77+107+54,75,77+107+107,75+10);
}

void TSequencenb::EvA(UINT)
{
	EvCommun('0');
}

void TSequencenb::EvB(UINT)
{
	EvCommun('1');
}

void TSequencenb::EvC(UINT)
{
	EvCommun('2');
}

void TSequencenb::EvD(UINT)
{
	EvCommun('3');
}

void TSequencenb::EvE(UINT)
{
	EvCommun('4');
}

void TSequencenb::EvF(UINT)
{
	EvCommun('5');
}

void TSequencenb::EvG(UINT)
{
	EvCommun('6');
}

void TSequencenb::EvH(UINT)
{
	EvCommun('7');
}

void TSequencenb::EvI(UINT)
{
	EvCommun('8');
}

void TSequencenb::EvJ(UINT)
{
	EvCommun('9');
}

int TSequencenb::EvCommun(char c)
{
char string[MAXPATH],nomfich[MAXPATH];
long numero;

	switch(c)
	{
	case'0':                // recul rapide
				pas=-1;
				t0=Caltime();
				n0=numimag;
				stop=0;
				break;

	case'1':	Arret();		 // recul 1 pas
				pas=-1;
				Calimsuiv();
				Affim();
				break;

	case'2': Arret();	      // avance 1 pas
				pas=1;
				Calimsuiv();
				Affim();
				break;

	case'3':               // avance rapide
				pas=1;
				t0=Caltime();
				n0=numimag;
				stop=0;
				break;

	case'4':
				if(in1)
				{
				if(TAffseqnbPtr) TAffseqnbPtr->ShutDownWindow();
				else(TAffseqnbPtr=new TAffseqnb(this,"CARACTERISTIQUES SEQUENCE"))->Create();
				}
				break;

	case'5':
	case'6':
	case'7':
	case'9':
				if(c=='5')
				{
				//strcpy(FileData2.FileName,"");
				if((TFileOpenDialog(this,FileData2)).Execute()!=IDOK) break;
				strcpy(nomfich,FileData2.FileName);
				}

				if(c=='6'||c=='7')
				{
				strcpy(nomfich,FileData2.FileName);
				fnsplit(nomfich,driveseq2,dirseq2,fileseq2,extseq2);
				Calnum(fileseq2,nomgen2,&numero);
				if(numero<0)
				// break;
				return 1;

				if(c=='7') numero++;
				if(c=='6') if(numero) numero--;
				else
				//break;
				return 1;
				strcpy(fileseq2,nomgen2);
				ltoa(numero,string,10);
				strcat(fileseq2,string);
				fnmerge(nomfich,driveseq2,dirseq2,fileseq2,extseq2);
				}

				if(c=='9')           // lancement automatique
				{
				strcpy(nomfich,FileData.FileName);
				}
				if(c=='5'||c=='6'||c=='7'||c=='9')
				{
				ifstream is(nomfich);
				if(!is)
				{
				MessageBox(nomfich,"Impossible d'ouvrir",
				MB_OK | MB_ICONEXCLAMATION);
				//break;
				return 1;
				}
				}
				if(in1) {fclose(in1);in1=0;nbtotimage=0;}
				if((in1=fopen(nomfich,"rb"))==NULL)
				{
				MessageBox(nomfich,"ERREUR SUR FICHIER",MB_OK);
				SetCaption("Animation de squence NB");
				//break;
				return 1;
				}

				strcpy(FileData2.FileName,nomfich);
				SetCursor(0,IDC_WAIT);
				Carseqnb(in1,&carseqnb);
				nbtotimage=carseqnb.nbtot;
				SetCursor(0,IDC_ARROW);
				numimag=0;
				Affim();
				strcpy(string,"Animation de : ");
				strcat(string,FileData2.FileName);
				SetCaption(string);
				if(TAffseqnbPtr)
				{
				TAffseqnbPtr->Invalidate();
				}
				break;

	case'8':                          // Edit
				Edit();
				break;

		}//switch
		return 0;
}

void TSequencenb::Arret()
{
	stop=1;
	Bseq->SetText("");
}

void TSequencenb::Calnum(char file[],char nomgen[],long *num)
{
int l,i;

	strcpy(nomgen,file);
	l=strlen(file);
	for(i=l-1;i>0;i--)
	{
	if(file[i]<'0'||file[i]>'9') break;
	}
	if(i>=0&&i<l-1) {*num=atol(&file[i+1]);nomgen[i+1]=0;}
	else *num=-1;
}

void TSequencenb::Calimsuiv()           // Calcul numro image suivante
{
long num;

	num=numimag;
	num+=pas;
	if(modboucle)                         // Pour dbut et fin
	{
	if(num<0) num+=nbtotimage;
	if(nbtotimage>0) num%=nbtotimage;
	}
	else
	{
	if(num<0) num=0;
	if(num>=nbtotimage) num=nbtotimage-1;
	}
	numimag=num;
}

void TSequencenb::Goto(long numim)
{
	if(numim>=0&&numim<nbtotimage)
	{
	Arret();
	numimag=numim;
	Affim();
	}
}

void TSequencenb::Goto_Anim(long numim)
{
long t0;

	if(numim>=0&&numim<nbtotimage)
	{
	Arret();
	numimag=numim;
	for(numimag=numim-10;numimag<numim;numimag++)
		{
		t0=Caltime();
		if(numimag>=0)	{Affim();while(Caltime()<=t0+4);}
		}
	Affim();
	}
}

void TSequencenb::Edit()
{
int firstseq;
char c;

	 if(TConveditnbPtr) return;

	 if(AppelChoixDial(this,"TYPE D'EDITION","&0->Cration\n&1->Ajout",&c)!=TRUE)
	 return;
	 if(c=='0')  // cration
	 {
	 if((TFileSaveDialog(this,FileData5)).Execute()!= IDOK) return;

	 if(strcmpi(FileData2.FileName,FileData5.FileName)==0)// test
		{
		MessageBox(FileData2.FileName,"Impossible de modifier la squence en cours",
		MB_OK | MB_ICONEXCLAMATION);
		return;
		}
	 ofstream os(FileData5.FileName);
	 if(!os)
	 {
	 MessageBox(FileData5.FileName,"Impossible d'ouvrir",
	 MB_OK | MB_ICONEXCLAMATION);
	 return;
	 }
	 firstseq=1;
	 }
	 else  //ajout
	 {
	 if((TFileOpenDialog(this,FileData5)).Execute() != IDOK) return;
	 if(strcmpi(FileData2.FileName,FileData5.FileName)==0)// test
	 {
		MessageBox(FileData2.FileName,"Impossible de modifier la squence en cours",
		MB_OK | MB_ICONEXCLAMATION);
		return;
	 }

	 ifstream is(FileData5.FileName);
	 if(!is)
	 {
	 MessageBox(FileData5.FileName,"Impossible d'ouvrir",
	 MB_OK | MB_ICONEXCLAMATION);
	 return;
	 }
	 firstseq=0;
	 }

	 if(!TConveditnbPtr)
	 {
	 (TConveditnbPtr= new TConveditnb(this,firstseq,FileData5.FileName))->Create();
	 }
}

//----------------------------------------------------------------------------
//						Programme TConveditnb
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TConveditnb, TChoix)

  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TConveditnb::TConveditnb(TSequencenb* parent,int firstseq,char *nomfich)
: TChoix(parent,nomfich,"&0 DEBUT\n&1 FIN\n&2 VALIDATION",
TRect(256+8,282+OFFSET-1-125,639,282+OFFSET-1))
{
	pere=parent;
	first=firstseq;
	strcpy(fich,nomfich);
	numdep=pere->numimag+1;
	numarr=pere->numimag+1;
	nbtotimage=pere->nbtotimage;

	Aeditnb=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 12, 0, 80, 25, 10);          // 10->9 car. max
	Beditnb=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 130, 0, 80, 25, 10);
}

TConveditnb::~TConveditnb()
{
	TConveditnbPtr=0;
}

void
TConveditnb::SetupWindow()
{
	TFrameWindow::SetupWindow();
	AfficheOptions();
}

void TConveditnb::EvMButtonDown(UINT, TPoint &)
{
 char string[12];

	Aeditnb->GetText(string,sizeof(string));
	numdep=atol(string);
	Beditnb->GetText(string,sizeof(string));
	numarr=atol(string);
}

void TConveditnb::EvCommun(char c)
{
	switch(c)
	{
		case '0':numdep=pere->numimag+1;
			 break;
		case '1':numarr=pere->numimag+1;
			 break;
		case '2':
				if(numarr<numdep||numarr<1||numdep<1)
				{
				MessageBox("", "Paramtres incorrects",
				MB_OK | MB_ICONEXCLAMATION);break;
				}
				Merge(first,fich,numdep,numarr);
				first=0;
			 break;
	 }
	AfficheOptions();
}

void TConveditnb::AfficheOptions(void)
{
char string[12];

	 ltoa(numdep,string,10);
	 Aeditnb->SetText(string);

	 ltoa(numarr,string,10);
	 Beditnb->SetText(string);
}

void
TConveditnb::Merge(int firstseq,char *nomfich,long numdep,long numarr)
{
long nbcod,nbcodim;
long nbimage;
FILE *outfile;
chaine_seqnb chaine2;                 // chanage

	 outfile=fopen(nomfich,"r+b");

	if(firstseq)
		{
		chaine2.prec=0;chaine2.suiv=0;
		}
	else
		{
		fseek(outfile,-1L*sizeof(chaine_seqnb),SEEK_END);
		fread(&chaine2,1,sizeof(chaine_seqnb),outfile);
		fseek(outfile,-1L*sizeof(chaine_seqnb),SEEK_END);
		}

		nbimage=numdep-1;
		while(nbimage<numarr&&nbimage<nbtotimage)
		{
		nbcod=Animaseq(in1,nbimage,0);   // pas de visu ni de dcodage
		chaine2.suiv=nbcod;
		fwrite(&chaine2,1,sizeof(chaine_seqnb),outfile);
		fwrite(&en_tete_im,sizeof(en_tete_image),1,outfile);
		nbcodim=(long)en_tete_im.nbcodim;
		if(!nbcodim) nbcodim=65536L;
		if(nbcodim!=65536L)
		fwrite(bufim1,(unsigned int)nbcodim,1,outfile);            // criture image code
		else
		{
		fwrite(bufim1,32768U,1,outfile);            // criture image code
		fwrite(bufim1+32768U,32768U,1,outfile);            // criture image code
		}
		chaine2.prec=chaine2.suiv;            // chanage suivant
		chaine2.suiv=0;
		nbimage++;
		}//while
		fwrite(&chaine2,1,sizeof(chaine_seqnb),outfile); //sortie dernier chanage
		fclose(outfile);
}

//----------------------------------------------------------------------------
//						Programme TAnima
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TAnima, TFrameWindow)
  EV_COMMAND_AND_ID(ID_A, EvA),
  EV_COMMAND_AND_ID(ID_A+1, EvB),
  EV_COMMAND_AND_ID(ID_A+2, EvC),
  EV_COMMAND_AND_ID(ID_A+3, EvD),
  EV_COMMAND_AND_ID(ID_A+4, EvE),
  EV_COMMAND_AND_ID(ID_A+5, EvF),
  EV_COMMAND_AND_ID(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_A+7, EvH),
  EV_COMMAND_AND_ID(ID_A+8, EvI),
  EV_WM_LBUTTONDOWN,
  EV_WM_MOUSEMOVE,
  EV_WM_LBUTTONUP,
  EV_WM_TIMER,
  EV_COMMAND(ID_BOUTON, EvClose),
  EV_WM_CLOSE,

  END_RESPONSE_TABLE;

TAnima::TAnima(TWindow* parent)
  : TFrameWindow(parent, "ANIMATION DE SERIE D'IMAGES")
{
char *string1="&FERMER";
int i,x0,y0;
int xmax=640;               	// Largeur cran
int decyfen=0;            	// Dcalage fentres en y
int maxcar;                     //Nb max de caractres
char *tabmes;           	// Table de messages
int py=25;                	// Position de dpart en y
int nb=8;                  	// Nombre de choix
int Fx=60,Fy=25;            	// Tailles fentres

	maxcar=Fx/8;            // 1 caractre = 8 points
	x0=(xmax-Fx*nb)>>1;
	y0=py+decyfen;
	tabmes=(char *)malloc(nb*(maxcar+1)*sizeof(char));
	strcpy(tabmes,"&0 <<");      // messages
	strcpy(tabmes+(maxcar+1),"&1 <");
	strcpy(tabmes+2*(maxcar+1),"&2 >");
	strcpy(tabmes+3*(maxcar+1),"&3 >>");
	strcpy(tabmes+4*(maxcar+1),"&4 GEN");
	strcpy(tabmes+5*(maxcar+1),"&5 DEB");
	strcpy(tabmes+6*(maxcar+1),"&6 FIN");
	strcpy(tabmes+7*(maxcar+1),"&7 AUT");

	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

	Attr.X = 0;
	Attr.Y = 282+OFFSET;
	Attr.W = 640;
	Attr.H = 107;

	for(i=0;i<=nb-1;i++)
	{
  new TButton(this,ID_A+i,tabmes+(maxcar+1)*i,
  x0+i*Fx,y0,Fx-1,Fy-1,FALSE);
	}
  new TButton(this,ID_BOUTON,string1,
  x0,y0+Fy,-1+nb*Fx,Fy-1,FALSE);

  free(tabmes);
  Aseq1=new TStatic(this, ID_STATIC, "", 0, 0, 50, 17, 0);
  Bseq1=new TStatic(this, ID_STATIC, "", 0, 20, 50, 17, 0);
  Gseq1=new TStatic(this, ID_STATIC, "", 0, 40, 50, 17, 0);

 SolidGauge1=new TGauge(this, "", ID_A+10, 50, 0, 512, 10, TRUE, 1);
}

void TAnima::SetupWindow()
{
	TFrameWindow::SetupWindow();
	Fenetre->CmModenb();              // Mise en mode N/B

	FileData6.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	FileData6.SetFilter("Serie N/B(*.IMG)|*.IMG");
	strcpy(extseq,".img");

	numero1=0;
	numero2=0;
	strcpy(nomgen,"");

	numimag1=0;
	flag11=0;
	stop1=1;
	pas1=1;
	sens1=1;
	nbtot1=0;
	finauto=0;
	SolidGauge1->SetRange(0,512);
	SetTimer(ID_TIMER_ANIMA,40);                // Timer
}

TAnima::~TAnima()
{
	KillTimer(ID_TIMER_ANIMA);
	TAnimaPtr=0;
}

void TAnima::EvTimer(UINT)
{
	if(stop1==0)
	{
	if(sens1==1){numimag1+=pas1;}
	else       {numimag1-=pas1;}

	if(numimag1<0) numimag1+=nbtot1;
	if(nbtot1>0) numimag1%=nbtot1;     // Prcaution sur division par zro !
	Affim1();
	}
}

void TAnima::EvLButtonDown(UINT, TPoint& point)
{
float numero;
int x0,x1,y0,y1;
int posx0,posy0;

	x0=50;x1=x0+512;y0=0;y1=y0+50;
	posx0=point.x;
	posy0=point.y;
	if(posx0>=x0&&posx0<x1&&posy0>=y0&&posy0<y1)
	{
	numero=(float)(nbtot1-1)*(float)(posx0-x0)/511.;
	numimag1=long(numero);
	Affim1();
	}
	flag11=1;
}

void TAnima::EvLButtonUp(UINT, TPoint& )
{
	flag11=0;
}

void TAnima::EvMouseMove(UINT a, TPoint& point)
{
	if(flag11)
	{
	 EvLButtonDown(a,point);
	}//if
}

void TAnima::Affim1()
{
char string[80],s[80];
int setting,test;
long diff;

	if(nbtot1>0)
	{
	strcpy(s,driveseq);
	strcat(s,dirseq);
	strcat(s,nomgen);
	ltoa(numimag1+numero1,string,10);
	strcat(s,string);
	strcat(s,extseq);
	test=RMN(s,destin);
	if(test)
	{
	strcpy(string,"IMAGE : ");
	strcat(string,s);
	SetCaption(string);
	if(finauto!=0&&sens1==1)
	{
	numero2++;
	nbtot1=numero2-numero1+1;
	}

	ltoa(numimag1+1,string,10);
	Aseq1->SetText(string);                  // Numro de l'image
	ltoa(nbtot1,string,10);
	Gseq1->SetText(string);         			  // Nb. d'images

	t11=Caltime();
	if(labs(t11-t01)>=100)
		{
		n11=numimag1;
		diff=(n11-n01)*sens1;
		if(diff<0) diff+=nbtot1;
		vit_anim1=100*diff/(t11-t01);
		t01=t11;
		n01=n11;
		ltoa(vit_anim1,string,10);
		strcpy(s,"V:");
		strcat(s,string);
		Bseq1->SetText(s);               // Vitesse d'animation
		}
	if(stop1) Bseq1->SetText("");       // Eff. vitesse

	Calsuiv();
	Fenetre->Visim(this,IM_GAUCHE,source);

	if(nbtot1==1) setting=1;
	else	setting=(int)(512.*((float)numimag1/(float)(nbtot1-1)));
	SolidGauge1->SetValue(setting);

	}//if test
	else
	if(finauto!=0&&sens1==1)
	{
	numero2=numero1+numimag1-1;
	nbtot1=numero2-numero1+1;
	finauto=0;
	}
	}//if nbtot1
}

void TAnima::Paint(TDC&, BOOL, TRect&)
{

}

void TAnima::EvA(UINT)
{
	EvCommun('0');
}

void TAnima::EvB(UINT)
{
	EvCommun('1');
}

void TAnima::EvC(UINT)
{
	EvCommun('2');
}

void TAnima::EvD(UINT)
{
	EvCommun('3');
}

void TAnima::EvE(UINT)
{
	EvCommun('4');
}

void TAnima::EvF(UINT)
{
	EvCommun('5');
}

void TAnima::EvG(UINT)
{
	EvCommun('6');
}

void TAnima::EvH(UINT)
{
	EvCommun('7');
}

void TAnima::EvI(UINT)
{
	EvCommun('8');
}

void TAnima::EvCommun(char c)
{
char inputText[20]="";
int flag;
char string[20];

	switch(c)
	{
	case'0': sens1=-1;stop1=0;pas1=1;
				t01=Caltime();
				n01=numimag1;
				break;

	case'1': stop1=1;pas1=1;
				numimag1--;
				if(numimag1<0) numimag1=nbtot1-1;
				Affim1();
				break;

	case'2': stop1=1;pas1=1;
				numimag1++;
				if(numimag1>=nbtot1) numimag1=0;
				Affim1();
				break;

	case'3': sens1=1;stop1=0;pas1=1;
				t01=Caltime();
				n01=numimag1;
				break;

	case'4':
				strcpy(inputText,nomgen);
				if((TInputDialog(this,"",
								"Nom gnrique ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
				{
				sscanf(inputText,"%s",nomgen);
				}
				else break;

				ltoa(numero1,inputText,10);
				strcat(inputText," ");
				ltoa(numero2,string,10);
				strcat(inputText,string);

								if((TInputDialog(this,"",
								"Numros de dbut et de fin ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
				{
				sscanf(inputText,"%ld %ld",&numero1,&numero2);
				if(numero2<numero1)
				{
				MessageBox("","Valeurs incorrectes",MB_OK | MB_ICONEXCLAMATION);
				break;
				}
				nbtot1=numero2-numero1+1;
				numimag1=0;
            finauto=0;
				}
				else break;

				break;

	case'5':
	case'6':
	case'7':
				 strcpy(FileData6.FileName, "");
				 if((TFileOpenDialog(this, FileData6)).Execute() == IDOK)
				 {
				 ifstream is(FileData6.FileName);
				 if(!is) MessageBox("FileData6.FileName", "Impossible d'ouvrir",
										MB_OK | MB_ICONEXCLAMATION);
				 else
				 {
					flag=RMN(FileData6.FileName,destin);
					if(flag==0)	MessageBox(FileData6.FileName,"Erreur sur lecture",
									MB_OK | MB_ICONEXCLAMATION);
					else
					{
					fnsplit(FileData6.FileName,driveseq,dirseq,fileseq,extseq);
					if(c=='5') {Calnum(fileseq,nomgen,&numero1);finauto=0;}
					if(c=='6') {Calnum(fileseq,nomgen,&numero2);finauto=0;}
					if(c=='7') {Calnum(fileseq,nomgen,&numero1);finauto=1;
									numero2=numero1+1;}
					numimag1=0;
					nbtot1=numero2-numero1+1;
					Calsuiv();                       // Visu image slect.
					Fenetre->Visim(this,IM_GAUCHE,source);
					}
				 }
				}
				break;

		}//switch
	//SetActiveWindow();
}

void TAnima::Calnum(char file[],char nomgen[],long *num)
{
int l,i;

	strcpy(nomgen,file);
	l=strlen(file);
	for(i=l-1;i>0;i--)
	{
	if(file[i]<'0'||file[i]>'9') break;
	}
	if(i>=0&&i<l-1) {*num=atol(&file[i+1]);nomgen[i+1]=0;}
	else *num=0;
}

void TAnima::EvClose()
{
	TAnima::~TAnima();
}

//----------------------------------------------------------------------------
//						Programme TCreaseq
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TCreaseq, TChoixMenu)
  EV_WM_TIMER,

  END_RESPONSE_TABLE;

TCreaseq::TCreaseq(TWindow* parent)
  : TChoixMenu(parent, "CREATION DE SEQUENCE D'IMAGES N/B",
		"&0 GO\n&1 HLT\n&2 VIS\n&3 ACQ\n&4 TST\n&5 MODE\n&6 NOM")
{
  Bseq1=new TStatic(this, ID_STATIC, "", 0, 70, 100, 17, 0);   // vitesse
  Bseq2=new TStatic(this, ID_STATIC, "", 150, 70, 100, 17, 0); // tot codes
  Bseq3=new TStatic(this, ID_STATIC, "", 0, 0, 100, 17, 0);  // num
  Bseq4=new TStatic(this, ID_STATIC, "", 150, 0, 100, 17, 0);  // codes
}

void TCreaseq::SetupWindow()
{
	TWindow::SetupWindow();
	Fenetre->CmModenb();              // Mise en mode N/B

	modecreaseq=0;
	stop2=1;
	numimag1=0;
	indic_visu=1;
	numero11=0;
	numero21=0;
	flag_enr=0;                          // pas d'enregistrement
	mode_test=0;

	en_tete_im1.size=sizeof(en_tete_image);
	en_tete_im1.type_codage=2;   // 0 pas de comp, 1 DCT, 2 DCT Huf, 3 binaire
	en_tete_im1.qualite=0;
	en_tete_im1.xmin=0;
	en_tete_im1.xmax=255;
	en_tete_im1.ymin=0;
	en_tete_im1.ymax=255;

	bufcode=(unsigned char *)farmalloc(65536L);     // allocation

	strcpy(nomgen1,"");
	out1=0;

	FileData2.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	FileData2.SetFilter("Sequences N/B (*.SNB)|*.SNB");

	SetTimer(ID_TIMER_CREASEQ, 1);                // Timer
}

TCreaseq::~TCreaseq()
{
	KillTimer(ID_TIMER_CREASEQ);
	Arret_Enreg();             // pour tre sur de fermer un fichier ouvert
	free(bufcode);
	TCreaseqPtr=0;
}

void TCreaseq::EvTimer(UINT)
{
	if(stop2==0) Enregim();
	if(stop2==0) Enregim();
	if(stop2==0) Enregim();
}

void TCreaseq::EvCommun(char c)
{
char inputText[20]="";
char string[20],s[10]=" )";
char c1;

	switch(c)
	{
	case'0':                               // Go
				n01=numimag1=0;
				t01=Caltime();
				stop2=0;
				break;

	case'1':                          // arrt
				Arret_Enreg();
				break;

	case'2':                             // visu
				 if(indic_visu) indic_visu=0;else indic_visu=1;
				break;

	case'3':                           // acqui
				if(!flag_enr)
				{
				stop2=1;
				numimag1=0;
				Enregim();
				}
				break;

	case'4':                                 // TEST
				if(mode_test||flag_enr)
				{
				mode_test=0;
				if(TAffimPtr[1]) TAffimPtr[1]->ShutDownWindow();
				}
				else
				mode_test=1;
				break;

	case'5':                               // Mode
				Arret_Enreg();
				strcpy(string,"MODE SEQUENCE N/B (");
				s[0]='0'+(char)(modecreaseq&0xFF);
				strcat(string,s);
				if(AppelChoixDial(this, string,
				"&0 Pas d'enr.\n&1 Enr.img\n&2 Enr.seq\n&3 Enr.cmp1\n&4 Enr.cmp2\n&5 Enr.bin",
				&c1)!=TRUE) break;
				modecreaseq=(int)(c1-'0');
				switch(modecreaseq)
				{
				case 0:
					SetCaption("CREATION DE SEQUENCE D'IMAGES N/B");
				break;
				case 1:
					SetCaption("CREATION DE SUITE D'IMAGES N/B");
				break;
				case 2:
					SetCaption("CREATION DE SEQUENCE D'IMAGES N/B type_codage : 0");
				en_tete_im1.type_codage=0;// 0 pas de comp, 1 DCT, 2 DCT Huf, 3 bin
				break;
				case 3:
					SetCaption("CREATION DE SEQUENCE D'IMAGES N/B type_codage : 1");
				en_tete_im1.type_codage=1;
				break;
				case 4:
					SetCaption("CREATION DE SEQUENCE D'IMAGES N/B type_codage : 2");
				en_tete_im1.type_codage=2;
				break;
				case 5:
					SetCaption("CREATION DE SEQUENCE D'IMAGES N/B type_codage : 3");
				en_tete_im1.type_codage=3;
				break;
				}

				switch(modecreaseq)
				{
				case 3:
				case 4:
					int qual_comp=en_tete_im1.qualite;
					itoa(qual_comp,inputText,10);
					if ((TInputDialog(this,"Compression DCT",
								"Facteur de qualit (0 : standard <->20 : faible) ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
					{
					sscanf(inputText,"%d",&qual_comp);
					if(qual_comp<0)  qual_comp=0;
					if(qual_comp>20) qual_comp=20;
					en_tete_im1.qualite=qual_comp;
					}
					break;
				}
				break;

	case'6':                              // nom
				stop2=1;
				if(modecreaseq==1)
				{
				strcpy(inputText,nomgen1);
				if((TInputDialog(this,"Enregistrement suite d'images",
								"Nom gnrique (4 caractres max) ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
				{
				sscanf(inputText,"%s",nomgen1);
				}
				else break;

				nomgen1[4]=0;               // Limitation  4

				ltoa(numero11,inputText,10);
				strcat(inputText," ");
				ltoa(numero21,string,10);
				strcat(inputText,string);

				if((TInputDialog(this,"Enregistrement suite d'images",
					"Numros de dbut et de fin ?",
					inputText,
					sizeof(inputText))).Execute() == IDOK)
				{
				sscanf(inputText,"%ld %ld",&numero11,&numero21);
				//numimag1=0;
				if(numero21<numero11)
				{
				MessageBox("","Valeurs incorrectes",MB_OK | MB_ICONEXCLAMATION);
				break;
				}
				}
				else break;
				}//modecreaseq=1
				else if(modecreaseq)
				{
				strcpy(FileData2.FileName,"");
				if((TFileSaveDialog(this,FileData2)).Execute()!=IDOK) break;
				}
				flag_enr=1;
				break;
		}//switch
}

void TCreaseq::Acq_destin()    // acqui image dans destin
{
	if(presacq&0X01) Acqui();
}

void TCreaseq::Enregim()
{
char string[80],s[MAXPATH];
int test;
long nbcod,nbcodim;
float vitesse;

	Acq_destin();                     // acquisition
	Calsuiv();             				// mise dans source

	if(indic_visu) Fenetre->Visim(this,IM_GAUCHE,source); 	// Visu

	if(numimag1==0)
	{
	nbtotcod=0;
	Bseq2->SetText("");
	Bseq4->SetText("");
	if(modecreaseq==0)
	{
	SetCaption("CREATION DE SEQUENCE D'IMAGES N/B");
	}
	if(modecreaseq==1)          // suite d'images N/B
	{
	SetCaption("CREATION DE SUITE D'IMAGES N/B");
	}
	if(modecreaseq==2||modecreaseq==3||modecreaseq==4||modecreaseq==5)    // Enregistrements comprim ou non
	{
	if(flag_enr)
	{
	chaine1.prec=0;chaine1.suiv=0;
	out1=fopen(FileData2.FileName,"wb");            // on ouvre
	strcpy(string,"ENREGISTREMENT DE : ");
	strcat(string,FileData2.FileName);
	}
	else
	{
	strcpy(string,"CREATION DE SEQUENCE D'IMAGES N/B");
	}
	strcat(string," type_codage : ");
	itoa(en_tete_im1.type_codage,s,10);
	strcat(string,s);
	SetCaption(string);
	}
	}//numimag1

	t11=Caltime();
	if(labs(t11-t01)>=100)
		{
		n11=numimag1;
		vitesse=100.*(float)(n11-n01)/(float)(t11-t01);
		t01=t11;
		n01=n11;
		gcvt(vitesse,4,string);
		strcpy(s,"V:");
		strcat(s,string);
		Bseq1->SetText(s);               // Vitesse d'animation
		}
	if(stop2) Bseq1->SetText("");       // Eff. vitesse

	if(modecreaseq)                   // Enregistrement
	{
	if(modecreaseq==1)          // suite d'images N/B
	{
	if(flag_enr) // enregistrement
	{
	if(numimag1+numero11>numero21||strlen(nomgen1)==0)
	{
	stop2=1;
	MessageBox("","FIN D'ENREGISTREMENT",MB_OK | MB_ICONEXCLAMATION);
	return;
	}
	getcwd(s,MAXPATH);
	strcat(s,"\\");
	fnsplit(s,driveseq1,dirseq1,fileseq1,extseq1);
	strcpy(s,driveseq1);
	strcat(s,dirseq1);
	strcat(s,nomgen1);
	ltoa(numimag1+numero11,string,10);
	strcat(s,string);

	strcat(s,".img");      				// s contient le nom du fichier

	test=WMN(s,source);
	if(test)
	{
	strcpy(string,"ENREGISTREMENT IMAGE : ");
	strcat(string,s);
	SetCaption(string);
	}
	else                            // squence d'images N/B
	{
	stop2=1;
	MessageBox(s, "Erreur d'criture de",MB_OK | MB_ICONEXCLAMATION);
	return;
	}
	}
	} //modecreaseq=1
	else
	{
	nbcodim=Code_nb(&en_tete_im1,source,bufcode);
	if(!nbcodim) nbcodim=65536L;

	nbcod=nbcodim+sizeof(chaine_seqnb)+sizeof(en_tete_image);              // calcul nb codes
	chaine1.suiv=nbcod;                         // chanage
	if(flag_enr) // enregistrement
	{
	fwrite(&chaine1,1,sizeof(chaine_seqnb),out1);
	fwrite(&en_tete_im1,sizeof(en_tete_image),1,out1);
	if(nbcodim!=65536L)
	fwrite(bufcode,(unsigned int)nbcodim,1,out1);            // criture image code
	else
	{
	fwrite(bufcode,32768U,1,out1);            // criture image code
	fwrite(bufcode+32768U,32768U,1,out1);            // criture image code
	}
	}
	chaine1.prec=chaine1.suiv;                                    // chanage suivant
	chaine1.suiv=0;
	nbtotcod+=nbcod;

		ltoa(nbcod,string,10);
		strcpy(s,"C:");
		strcat(s,string);
		Bseq4->SetText(s);               // Nb codes

		ltoa(nbtotcod,string,10);
		strcpy(s,"T:");
		strcat(s,string);
		Bseq2->SetText(s);               // Nb tot codes

	if(indic_visu&&mode_test)    // contrle dcodage
	{                                     // si pas enreg.
		Decode_nb(&en_tete_im1,destin,bufcode);
		Fenetre->Visim(this,IM_DROITE,destin); 	// Visu
		//if(en_tete_im2.type_codage==3) Aff_fen1(IM_DROITE);   // binaire
	}
	}
	}//mode creaseq
	numimag1++;
	ltoa(numimag1,string,10);
	Bseq3->SetText(string);
}

void TCreaseq::Arret_Enreg(void)
{
	stop2=1;                           // arrt
	Bseq1->SetText("");                 // vitesse
	numimag1=0;
	if(flag_enr)
	{
	if(modecreaseq==2||modecreaseq==3||modecreaseq==4||modecreaseq==5)
	{
	if(out1)
	{
	fwrite(&chaine1,1,sizeof(chaine_seqnb),out1);
	fclose(out1);
	out1=0;
	}
	}   //fin fichier
   }
	flag_enr=0;
}

//----------------------------------------------------------------------------

