/*********************************************************************/
/*                       W A P P B A S E . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC et BM			                  			    */
/*    Dvelopp le   : 27/03/1996                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/

// Object Window
#include <owl\applicat.h>
#include <owl\buttonga.h>
#include <owl\gadgetwi.h>

#include <stdio.h>                       // Dos
#include <dir.h>

#include "wgttsi.h"                    // Librairies Image

#include "wmain.h"
#include "wappbase.rh"
#include "wappbase.h"
#include "wmaiconv.h"
#include "wbinconv.h"
#include "wconv.h"
#include "wcarconv.h"
#include "wanimnb.h"
#include "wapphelp.h"

TCad* Cadre = 0;      			// Fentre principale
TFen* Fenetre = 0;      			// Fentre principale
TApp* Applicat = 0;      			// Fentre principale

														// Messages barre status
TTextGadget *pZ0,*pZ1,*pZ2,*pZ3;

char TexteAbout[256]="";                  // Texte  propos
char TitreApplication[256]="";            // Titre de l'application
char FichierAide[256]="";                 // Nom du fichier d'aide
char TableFich[8][80];                    // Table pour nom d'image

TOpenSaveDialog::TData FileData;          // Pour fichiers en lect. et ecr.

int argc_;                              // passages de paramtres OwlMain
char **argv_;

#define ID_TIMER_MEM 12345               // timer ressources mem.

BOOL F1Pressed;                         // pour aide

//----------------------------------------------------------------------------
//						Programme principal : conversationnel TFen
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TFen, TWindow)

	EV_WM_TIMER,
	EV_WM_LBUTTONDOWN,
	EV_WM_LBUTTONUP,
	EV_COMMAND(CM_HELPINDEX, CmHelpIndex),
	EV_COMMAND(CM_HELPHELP, CmHelpHelp),

	EV_COMMAND(CM_ABOUT, CmAbout),
	EV_COMMAND(CM_MODENB, CmModenb),
	EV_COMMAND(CM_MODECOUL, CmModecoul),
	EV_COMMAND(CM_SEQUENCE, CmSequence),
	EV_COMMAND(CM_ACQUI, CmAcqui),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
	EV_COMMAND(CM_SOURCE0, CmSource0),
	EV_COMMAND(CM_SOURCE1, CmSource1),
	EV_COMMAND(CM_SOURCE2, CmSource2),
	EV_COMMAND(CM_SOURCE3, CmSource3),
	EV_COMMAND(CM_MIRE, CmMire),
	EV_COMMAND(CM_NEGAT, CmNegat),
	EV_COMMAND(CM_STAT, CmStat),
	EV_COMMAND(CM_CONNEX, CmConnex),
	EV_COMMAND(CM_INTEG, CmInteg),
	EV_COMMAND(CM_COOCUR, CmCoocur),
	EV_COMMAND(CM_COVAR, CmCovar),
	EV_COMMAND(CM_TACHE, CmTache),
	EV_COMMAND(CM_EFFAC, CmEffac),
	EV_COMMAND(CM_DIFF, CmDiff),
	EV_COMMAND(CM_TRANSFERT, CmTransfert),
	EV_COMMAND(CM_SOURCE4, CmSource4),
	EV_COMMAND(CM_SOURCE5, CmSource5),
	EV_COMMAND(CM_SOURCE6, CmSource6),
	EV_COMMAND(CM_SOURCE7, CmSource7),
	EV_COMMAND(CM_VISU, CmVisu),
	EV_COMMAND(CM_MODEAUTO, CmModeauto),

	EV_COMMAND(CM_ANIMA, CmAnima),
	EV_COMMAND(CM_CREASEQ, CmCreaseq),
	EV_COMMAND(CM_ANIMASEQ, CmAnimaseq),

	EV_COMMAND(CM_HISTO, CmHisto),
	EV_COMMAND(CM_SEUIL, CmSeuil),
	EV_COMMAND(CM_FEN, CmFen),
	EV_COMMAND(CM_PRLIG, CmPrlig),
	EV_COMMAND(CM_PRCOL, CmPrcol),
	EV_COMMAND(CM_PERSPEC, CmPerspec),
	EV_COMMAND(CM_GEOM, CmGeom),
	EV_COMMAND(CM_PSEUDO, CmPseudo),

	EV_COMMAND(CM_FILT, CmFilt),          // Traitements
	EV_COMMAND(CM_MODIF, CmModif),
	EV_COMMAND(CM_CARAC, CmCarac),
	EV_COMMAND(CM_CONTO, CmConto),
	EV_COMMAND(CM_COMPASS, CmCompass),
	EV_COMMAND(CM_MEDIAN, CmMedian),
	EV_COMMAND(CM_QUANTIF, CmQuantif),
	EV_COMMAND(CM_PLANBIT, CmPlanbit),
	EV_COMMAND(CM_RESOL, CmResol),
	EV_COMMAND(CM_MORPHO, CmMorpho),
	EV_COMMAND(CM_MOYEN, CmMoyen),

	END_RESPONSE_TABLE;

TFen::TFen(TWindow *parent)
{
	Init(parent, 0, 0);
	Fenetre=this;
	F1Pressed = FALSE;
	Attr.AccelTable = WAPPBASEACCEL; // AccelTable can be assigned
   modeauto=0;
}

void
TFen::SetupWindow()
{
	TWindow::SetupWindow();
	CalculeCaracteristiquesPolice(this);
	NumeroApplication=4;
// Lettres rserves GTTSI : I, M, O, T , C et  A.
	pmnuPrincipal= new TMenu(*Cadre);
	pmnuImage=new TMenu(pmnuPrincipal->GetSubMenu(0));
	pmnuMesures=new TMenu(pmnuPrincipal->GetSubMenu(1));
	pmnuOutils=new TMenu(pmnuPrincipal->GetSubMenu(2));
	pmnuTraitements=new TMenu(pmnuPrincipal->GetSubMenu(3));
	pmnuConfiguration=new TMenu(pmnuPrincipal->GetSubMenu(4));

	FileData.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;

	CmModenb();                             // init en mode N/B
	num_acqui=0;                          // Numro image acquise

	if(argc_>=2 && !access(argv_[1],04))   // passage nom de fichier image
	{
	Charge_image(argv_[1]);
	} //if
	else
	{
	Eff(source);
	Visim(this,0,source);
	}
	SetTimer(ID_TIMER_MEM, 2000);                // Timer 2s
}

void
TFen::Charge_image(char *string)
{
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];

	fnsplit(string,drive,dir,file,ext);
	if(stricmp(ext,".IMG")==0)
	{
	strcpy(FileData.FileName,string);
	CmModenb();OpenFile();
	}
	if(stricmp(ext,".RVB")==0)
	{
	strcpy(FileData.FileName,string);
	CmModecoul();OpenFile();
	}
	if(stricmp(ext,".SEQ")==0)
	{
	strcpy(FileData.FileName,string);
	CmSequence();OpenFile();
	}
	if(stricmp(ext,".SNB")==0)
	{
	strcpy(FileData.FileName,string);
	CmSequence();OpenFile();
	}
	if(stricmp(ext,".BMP")==0)
	{
	strcpy(FileData.FileName,string);
	OpenFile();
	}
}

BOOL TFen::CanClose()
{
	  return TRUE;
}

void TFen::EvLButtonUp(UINT, TPoint& )
{
	EtatBGSouris=0;
}

void TFen::EvLButtonDown(UINT, TPoint& )
{
	EtatBGSouris=1;
}

void TFen::Efface_TableFich(void)
{
	for(int i=0;i<8;i++) strcpy(TableFich[i],"");
}

void TFen::EvTimer(UINT)
{
char buf[20],string[20]="Mem :";
long mem = GetFreeSpace(0);
int n1 = (int)(mem/1000000L);
int n2 = (int)(mem%1000000L/1000L);
int n3 = (int) (mem%1000L);

	wsprintf(buf, "%d %03d %03d", n1, n2, n3);
	strcat(string,buf);
	pZ3->SetText(string);
}

void
TFen::CmHelpIndex()
{
	WinHelp(FichierAide,HELP_INDEX,0); // Mettre fichier aide
}

void
TFen::CmHelpHelp()
{
	WinHelp("HELP.HLP", HELP_HELPONHELP, 0);
}

void
TFen::CmAbout()
{
	MessageBox(TexteAbout,TitreApplication, MB_OK);
}

BOOL TFen::CmHelp(uint id)
{
  if(F1Pressed)
  {
  F1Pressed = FALSE;
  WinHelp(FichierAide,HELP_CONTEXT,(uint32)id);
  return TRUE;
  }
  return FALSE;
}

void
TFen::Visim(TWindow* parent,int type,unsigned char far *pointim)
{
char titre[40];
int num;

	ptr[type]=pointim;
	if(pointim==image0) {strcpy(titre,"IMAGE 0");num=0;}
	if(pointim==image1) {strcpy(titre,"IMAGE 1");num=1;}
	if(pointim==image2) {strcpy(titre,"IMAGE 2");num=2;}
	if(pointim==image3) {strcpy(titre,"IMAGE 3");num=3;}
	if(nbplan==8)
	{
	if(pointim==image4) {strcpy(titre,"IMAGE 4");num=4;}
	if(pointim==image5) {strcpy(titre,"IMAGE 5");num=5;}
	if(pointim==image6) {strcpy(titre,"IMAGE 6");num=6;}
	if(pointim==image7) {strcpy(titre,"IMAGE 7");num=7;}
	}
	if(modcoul==0&&modseq==0)  // mode N/B uniquement
	{
	if(type==0) pZ0->SetText(TableFich[num]);  // image gauche
	}
	else pZ0->SetText("");     // Efface zone 0

	if(type==0&&modcoul!=0) strcpy(titre,"IMAGE COULEUR");

	if(!TAffimPtr[type])
	 {
	 (TAffimPtr[type] = new TAffim(parent,type,titre))->Create();
	 if(type)
	 {
	 if(parent==this) flag_droit=1;else flag_droit=0;
	 }
	 }
	else
	 {
	 if(flag_droit&&type)
	 {
	 TAffimPtr[type]->ShutDownWindow();
	 (TAffimPtr[type] = new TAffim(parent,type,titre))->Create();
	 flag_droit=0;
	 }
	 TAffimPtr[type]->SetCaption(titre);
	 TAffimPtr[type]->Affiche();
	 }
	 if(TPrevisuPtr) TPrevisuPtr->MiseAJour();
	 if(modeauto)
	 {
	 if(TUtilPtr) TUtilPtr->NouveauPoint();
	 if(type==0&&TAffimPtr[1])
	 GetWindowPtr(TAffimPtr[1]->GetParent())->SendMessage(WM_COMMAND,ID_EXEC);
	 }
}
									/// GESTION
void TFen::CmAcqui()
{
	if (CmHelp(Gestion)) return;

	if(presacq==0)
	{
	MessageBox("", "Carte d'acquisition absente",MB_OK | MB_ICONEXCLAMATION);
	return;
	}

	if(modcoul==0)             // N/B
	{
	if(presacq&0X01)
	{
	SetCursor(0,IDC_WAIT);   // Pour attendre !!!
	Acqui();
	Calsuiv();
	wsprintf(TableFich[plan],"Acquisition Camra N/B N %d",++num_acqui);
	Visim(this,0,source);
	SetCursor(0,IDC_ARROW);
	}
	else
	{
	MessageBox("","Pas de camra N/B sur la voie 0",
	 MB_OK | MB_ICONEXCLAMATION);
	return;
	}
	}
	else                       // couleur
	{
	if(presacq>=0X0E)
	{
	SetCursor(0,IDC_WAIT);   // Pour attendre !!!
	Acqui();
	Visim(this,0,source);
	SetCursor(0,IDC_ARROW);
	}
	else
	{
	MessageBox("","Pas de camra couleur",MB_OK | MB_ICONEXCLAMATION);
	return;
	}
	}
}

void TFen::CmFileOpen()
{
	if (CmHelp(Gestion)) return;
	strcpy(FileData.FileName, "");
	if((TFileOpenDialog(this, FileData)).Execute() == IDOK)	OpenFile();
}

void TFen::CmFileSaveAs()
{
	if (CmHelp(Gestion)) return;
	if(modseq==0)
	{
	strcpy(FileData.FileName, "");
	if((TFileSaveDialog(this, FileData)).Execute() == IDOK) SaveFile();
	}
	else
	 MessageBox("", "Sauvegarde impossible en mode squence",
	 MB_OK | MB_ICONEXCLAMATION);
}

void TFen::SaveFile()
{
char drive[MAXDRIVE];
char file[MAXFILE];
char ext[MAXEXT];

  ofstream os(FileData.FileName);

  if(!os)
	 MessageBox(FileData.FileName, "Impossible d'ouvrir en criture :",
	 MB_OK | MB_ICONEXCLAMATION);
  else
  {
	fnsplit(FileData.FileName,drive,RepertoireCourant,file,ext);
	FileData.InitialDir=RepertoireCourant;
	if(strcmpi(ext,".BMP")==0) Ecr_bmp(FileData.FileName,source);
	else WMN(FileData.FileName,source);
	if(modcoul==0&&modseq==0)
	strcpy(TableFich[plan],FileData.FileName);
	Visim(this,0,source);
	}
}

void TFen::OpenFile()
{
char drive[MAXDRIVE];
char file[MAXFILE];
char ext[MAXEXT];
int flag;
char titre[MAXPATH];

  ifstream is(FileData.FileName);

  if(!is)
  {
	 MessageBox(FileData.FileName, "Impossible d'ouvrir en lecture :",
	 MB_OK | MB_ICONEXCLAMATION);
	return;
  }

	fnsplit(FileData.FileName,drive,RepertoireCourant,file,ext);
	FileData.InitialDir=RepertoireCourant;
	if(modseq==0)
	{
	if(strcmpi(ext,".BMP")==0)
	{
	flag=Lec_bmp(FileData.FileName,destin);
	FileData.FilterIndex=2;
	}
	else
	{
	flag=RMN(FileData.FileName,destin);
	FileData.FilterIndex=1;
	}
	if(flag==0)
	 MessageBox(FileData.FileName, "Erreur sur lecture fichier :",
	 MB_OK | MB_ICONEXCLAMATION);
	else
		{
		if(modcoul==0)
		{
		Calsuiv();
		strcpy(TableFich[plan],FileData.FileName);
		}
		Visim(this,0,source);
		}
	}
	else
	{
	if(strcmpi(ext,".SEQ")==0)               // squences binaires
	{
	FileData.FilterIndex=1;
	if(TSequencePtr) TSequencePtr->ShutDownWindow();
	in=fopen(FileData.FileName,"rb");
	SetCursor(0,IDC_WAIT);
	Carseqbin(in,&id,&carseq);
	SetCursor(0,IDC_ARROW);

	strcpy(titre,"Squence binaire : ");
	strcat(titre,FileData.FileName);
	(TSequencePtr= new TSequence(this,titre))->Create();
	}
	else                                   // squences N/B
	{
	FileData.FilterIndex=2;
	if(TSequencenbPtr) TSequencenbPtr->ShutDownWindow();
	(TSequencenbPtr= new TSequencenb(this,"Animation de squence NB"))->Create();
	if(TSequencenbPtr)
	TSequencenbPtr->PostMessage(WM_COMMAND,ID_A+9); // lancement
	}// else seq N/B
  }//else modseq
}

void TFen::CmTransfert()
{
	if (CmHelp(Gestion)) return;

	SetCursor(0,IDC_WAIT);
	if(modcoul==0) Transfert(source);
	else Transcoul();
	SetCursor(0,IDC_ARROW);
}

void TFen::CmAnima()               // Animation de squences N/B
{
	if (CmHelp(Gestion)) return;
	CmModenb();                            // Pour tre en mode N/B

	if(!TAnimaPtr)
	{
	(TAnimaPtr= new TAnima(this))->Create();
	}
	else
	{
	TAnimaPtr->SetFocus();
	TAnimaPtr->SetActiveWindow();
	}
}

void TFen::CmAnimaseq()               // Animation de squences N/B
{
	if (CmHelp(Gestion)) return;
	CmSequence();                     // Pour tre en mode squence

	if(!TSequencenbPtr)
	{
	(TSequencenbPtr= new TSequencenb(this,"Animation de squence NB"))->Create();
	}
	else
	{
	TSequencenbPtr->SetFocus();
	TSequencenbPtr->SetActiveWindow();
	}
}

void TFen::CmCreaseq()               // Cration de squences N/B
{
	if (CmHelp(Gestion)) return;
	if(presacq&0X01)
	{
	if(modcoul) CmModenb();          // Pour tre en mode N/B

	if(!TCreaseqPtr)
	{
	(TCreaseqPtr= new TCreaseq(this))->Create();
	}
	else
	{
	TCreaseqPtr->SetFocus();
	TCreaseqPtr->SetActiveWindow();
	}
	}
	else
	{
	MessageBox("","Pas de camra N/B sur la voie 0",
	 MB_OK | MB_ICONEXCLAMATION);
	}
}

void TFen::CmSource0()
{
	plan=0;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource1()
{
	plan=1;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource2()
{
	plan=2;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource3()
{
	plan=3;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource4()
{
	plan=4;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource5()
{
	plan=5;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource6()
{
	plan=6;
	Calplans();
	Visim(this,0,source);
}

void TFen::CmSource7()
{
	plan=7;
	Calplans();
	Visim(this,0,source);
}
									///  MESURES
void TFen::CmHisto()
{
	if (CmHelp(Mesures)) return;
	if(modcoul==0)
	{
	//Calhist(bufhist,bufrepa,source);
	NewUtil(7);
	Visim(this,0,source);
	}
	else
	{
	if(!TConvhiscouPtr)
	{
	(TConvhiscouPtr= new TConvhiscou(this))->Create();
	}
	else
	{
	TConvhiscouPtr->SetFocus();
	TConvhiscouPtr->SetActiveWindow();
	}
	}
}

void TFen::CmFen()
{
	if (CmHelp(Mesures)) return;
	NewUtil(1);
	Visim(this,0,source);
}

void TFen::CmPrlig()
{
	if (CmHelp(Mesures)) return;
	NewUtil(2);
	Visim(this,0,source);
}

void TFen::CmPrcol()
{
	if (CmHelp(Mesures)) return;
	NewUtil(3);
	Visim(this,0,source);
}

void TFen::CmPerspec()
{
	if (CmHelp(Mesures)) return;
	NewUtil(4);
	Visim(this,0,source);
}

void TFen::CmStat()
{
	if (CmHelp(Mesures)) return;
	Stat_image();                    // Calcul stat
	NewUtil(5);
}

void TFen::CmCoocur()
{
	if (CmHelp(Mesures)) return;
	if(!TConvocurPtr)
	{
	(TConvocurPtr= new TConvocur(this))->Create();
	}
	else
	{
	TConvocurPtr->SetFocus();
	TConvocurPtr->SetActiveWindow();
	}
}

void TFen::CmCovar()
{
	if (CmHelp(Mesures)) return;
	SetCursor(0,IDC_WAIT);
	Covariance(cov,8);                    // Calcul covariance
	SetCursor(0,IDC_ARROW);
	NewUtil(6);
}

void TFen::NewUtil(int modeutil)
{
char titre[40];
BOOL affichinit;

  switch(modeutil)
	{
	case 1 : strcpy(titre,"FENETRE");break;
	case 2 : strcpy(titre,"PROFIL DE LIGNE");break;
	case 3 : strcpy(titre,"PROFIL DE COLONNE");break;
	case 4 : strcpy(titre,"PERSPECTIVE");break;
	case 5 : strcpy(titre,"STATISTIQUES DE L'IMAGE");break;
	case 6 : strcpy(titre,"MATRICE DE COVARIANCE");break;
	case 7 : strcpy(titre,"HISTOGRAMME");break;
	default :return;
	}
	 if(modeutil>3) affichinit=TRUE;else affichinit=FALSE;
  (TUtilPtr = new TUtil(this,titre,modeutil,affichinit))->Create();
}

									/// OUTILS
void TFen::CmSeuil()
{
	if (CmHelp(Outils)) return;
	if(!TSeuilPtr)
	{
	(TSeuilPtr= new TSeuil(this,"SEUILLAGE D'IMAGE",-255,255,128))->Create();
	}
	else
	{
	TSeuilPtr->SetFocus();
	TSeuilPtr->SetActiveWindow();
	}
}

void TFen::CmGeom()
{
	if (CmHelp(Outils)) return;
	if(!TGeomPtr)
	{
	(TGeomPtr= new TGeom(this))->Create();
	}
	else
	{
	TGeomPtr->SetFocus();
	TGeomPtr->SetActiveWindow();
	}
}

void TFen::CmPseudo()
{
	if (CmHelp(Outils)) return;
	if(!TPseudoPtr)
	{
	(TPseudoPtr= new TPseudo(this))->Create();
	}
	else
	{
	TPseudoPtr->SetFocus();
	TPseudoPtr->SetActiveWindow();
	}
}

void TFen::CmMire()
{
char c;

	if (CmHelp(Outils)) return;
	if(AppelChoixDial(this,"MIRE DE GRIS","&0->Mirex\n&1->Mirey",&c)==TRUE)
	{
	Mirexy(c,destin);
	Calsuiv();
	Visim(this,0,source);
	}
}

void TFen::CmNegat()
{
	if (CmHelp(Outils)) return;
	Negatif();
	if(modcoul==0)	Visim(this,1,destin);
	else 	Visim(this,0,source);
}

void TFen::CmTache()
{
char c;

	if (CmHelp(Outils)) return;
	if(modcoul)
	{
	 MessageBox("","Fonction non disponible en mode couleur",
	 MB_OK | MB_ICONEXCLAMATION);return;
	}

	if(AppelChoixDial(this,
	"CORRECTION DE TACHE","&0->Acqui.Blanc\n&1->Correction",&c)!=TRUE) return;

	if(c=='0')
	{
	if(presacq&0X01)
	{
	if(MessageBox("", "Placer le blanc de rfrence sous la camra",
	 MB_OKCANCEL )==IDCANCEL) return;
	CmAcqui();
	WMN("blanc.img",source);
	MessageBox("dans le fichier : BLANC.IMG","Le blanc de rfrence est sauvegard",
	 MB_OK );
	}
	else
	{
	MessageBox("","Pas de camra N/B sur la voie 0",
	 MB_OK | MB_ICONEXCLAMATION);
	return;
	}
	}
	else  // c='1'
	{
	if(RMN("blanc.img",destin)!=0)
	{
	Correction();
	Visim(this,1,destin);
	}
	else 	 MessageBox("", "Crer le fichier : BLANC.IMG !!!",
	 MB_OK | MB_ICONEXCLAMATION);
	}
}

void TFen::CmEffac()
{
	if (CmHelp(Outils)) return;
	if(modcoul==0)
	{
	Eff(destin);
	Calsuiv();
	}
	else {Eff(image3);Eff(image2);Eff(image1);}
	Visim(this,0,source);
}

void TFen::CmDiff()
{
	if (CmHelp(Outils)) return;
	if(!TConvdiffPtr)
	{
	(TConvdiffPtr= new TConvdiff(this))->Create();
	}
	else
	{
	TConvdiffPtr->SetFocus();
	TConvdiffPtr->SetActiveWindow();
	}
}

void TFen::CmVisu()
{
	if (CmHelp(Outils)) return;
	if(!TPrevisuPtr)
	{
	(TPrevisuPtr= new TPrevisu(this))->Create();
	}
	else
	{
	TPrevisuPtr->SetFocus();
	TPrevisuPtr->SetActiveWindow();
	}
}

void TFen::CmModeauto()
{
TMenu mnu(*Parent);

	if (CmHelp(Outils)) return;

	modeauto++;
	modeauto%=2;
	if(modeauto)
	mnu.CheckMenuItem(CM_MODEAUTO,MF_CHECKED);
	else
	mnu.CheckMenuItem(CM_MODEAUTO,MF_UNCHECKED);
}
									/// CONFIGURATION
void TFen::CmModenb()
{
TMenu mnu(*Parent);

	if (CmHelp(Configuration)) return;

	mnu.CheckMenuItem(CM_MODENB,MF_CHECKED);
	mnu.CheckMenuItem(CM_MODECOUL,MF_UNCHECKED);
	mnu.CheckMenuItem(CM_SEQUENCE,MF_UNCHECKED);
	modseq=0;
	modcoul=0;
	FileData.SetFilter("Images N/B (*.IMG)|*.IMG|Images N/B (*.BMP)|*.BMP|");
	pZ2->SetText("Mode N/B");
	Efface_TableFich();
}

void TFen::CmModecoul()
{
TMenu mnu(*Parent);

	if (CmHelp(Configuration)) return;

	mnu.CheckMenuItem(CM_MODENB,MF_UNCHECKED);
	mnu.CheckMenuItem(CM_MODECOUL,MF_CHECKED);
	mnu.CheckMenuItem(CM_SEQUENCE,MF_UNCHECKED);
	modseq=0;
	modcoul=1;
	FileData.SetFilter("Images couleur (*.RVB)|*.RVB|Images couleur (*.BMP)|*.BMP|");
	pZ2->SetText("Mode Couleur");
	Efface_TableFich();
}

void
TFen::CmSequence()
{
TMenu mnu(*Parent);

	if(CmHelp(Configuration)) return;

	mnu.CheckMenuItem(CM_MODENB,MF_UNCHECKED);
	mnu.CheckMenuItem(CM_MODECOUL,MF_UNCHECKED);
	mnu.CheckMenuItem(CM_SEQUENCE,MF_CHECKED);
	modseq=1;
	modcoul=0;
	FileData.SetFilter("Seq.binaires(*.SEQ)|*.SEQ|Sequences NB(*.SNB)|*.SNB");
	pZ2->SetText("Mode Squence");
	Efface_TableFich();
}

void
TFen::CmConnex()
{
char string[80],s[10]=" )";
char c;

	if (CmHelp(Configuration)) return;
	strcpy(string,"TYPE DE CONNEXITE (");
	s[0]='0'+(char)(connex&0xFF);
	strcat(string,s);
	if(AppelChoixDial(this, string,
	"&0->4-Connexit\n&1->8-Connexit",&c)==TRUE)
	connex=(int)(c-'0');
}

void
TFen::CmInteg()
{
char string[80],s[10]=" )";
char c;

	if (CmHelp(Configuration)) return;
	strcpy(string,"FACTEUR D'INTEGRATIONS (");
	s[0]='0'+(char)(nbint&0xFF);
	strcat(string,s);
	if(AppelChoixDial(this, string,
				"&0->sans\n&1->2\n&2->4\n&3->8\n&4->16\n&5->32",&c)==TRUE)
	nbint=(int)(c-'0');
}

////////////////////////////////////
// Fonctions de traitements		  /
////////////////////////////////////
										/// MODIFICATIONS
void TFen::CmModif()
{
	if (CmHelp(Modifications)) return;
	if(!TConvhistPtr)
	{
	(TConvhistPtr= new TConvhist(this))->Create();
	}
	else
	{
	TConvhistPtr->SetFocus();
	TConvhistPtr->SetActiveWindow();
	}
}

void TFen::CmQuantif()
{
	if (CmHelp(Modifications)) return;
	if(!TConvquantifPtr)
	{
	(TConvquantifPtr= new TConvquantif(this))->Create();
	}
	else
	{
	TConvquantifPtr->SetFocus();
	TConvquantifPtr->SetActiveWindow();
	}
}

void TFen::CmPlanbit()
{
	if (CmHelp(Modifications)) return;
	if(!TConvplanbitPtr)
	{
	(TConvplanbitPtr=new TConvplanbit(this,
	 "PLAN DE BIT","&7\n&6\n&5\n&4\n&3\n&2\n&1\n&0"))->Create();
	}
	else
	{
	TConvplanbitPtr->SetFocus();
	TConvplanbitPtr->SetActiveWindow();
	}
}

void TFen::CmResol()
{
	if (CmHelp(Modifications)) return;
	if(!TConvresolPtr)
	{
	(TConvresolPtr= new TConvresol(this))->Create();
	}
	else
	{
	TConvresolPtr->SetFocus();
	TConvresolPtr->SetActiveWindow();
	}
}

void TFen::CmFilt()
{
	if (CmHelp(Filtrages)) return;
	if(!TConvfiltPtr)
	{
	(TConvfiltPtr= new TConvfilt(this))->Create();
	}
	else
	{
	TConvfiltPtr->SetFocus();
	TConvfiltPtr->SetActiveWindow();
	}
}
										/// FILTRAGES
void TFen::CmConto()
{
	if (CmHelp(Filtrages)) return;
	if(!TConvcontoPtr)
	{
	(TConvcontoPtr= new TConvconto(this))->Create();
	}
	else
	{
	TConvcontoPtr->SetFocus();
	TConvcontoPtr->SetActiveWindow();
	}
}

void TFen::CmCompass()
{
	if (CmHelp(Filtrages)) return;
	if(!TConvcompassPtr)
	{
	(TConvcompassPtr= new TConvcompass(this))->Create();
	}
	else
	{
	TConvcompassPtr->SetFocus();
	TConvcompassPtr->SetActiveWindow();
	}
}

void TFen::CmMedian()
{
	if (CmHelp(Filtrages)) return;
	if(!TConvmedianPtr)
	{
	(TConvmedianPtr= new TConvmedian(this))->Create();
	}
	else
	{
	TConvmedianPtr->SetFocus();
	TConvmedianPtr->SetActiveWindow();
	}
}

void TFen::CmMoyen()
{
	if (CmHelp(Filtrages)) return;
	if(!TConvglisPtr)
	{
	(TConvglisPtr= new TConvglis(this))->Create();
	}
	else
	{
	TConvglisPtr->SetFocus();
	TConvglisPtr->SetActiveWindow();
	}
}
									/// CARACTERISATION
void TFen::CmCarac()
{
	if (CmHelp(Caracterisation)) return;
	if(!TConvcaracPtr)
	{
	(TConvcaracPtr= new TConvcarac(this))->Create();
	}
	else
	{
	TConvcaracPtr->SetFocus();
	TConvcaracPtr->SetActiveWindow();
	}
}

void TFen::CmMorpho()
{
	if (CmHelp(Caracterisation)) return;
	if(!TConvmorphoPtr)
	{
	(TConvmorphoPtr= new TConvmorpho(this))->Create();
	}
	else
	{
	TConvmorphoPtr->SetFocus();
	TConvmorphoPtr->SetActiveWindow();
	}
}

//----------------------------------------------------------------------------
//						Programme TApp
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TApp, TApplication)
  EV_WM_DROPFILES,
END_RESPONSE_TABLE;


TApp::TApp() : TApplication()
{
	Applicat=this;
}

void TApp::InitInstance()
{
		TApplication::InitInstance();
		HAccTable = LoadAccelerators(WAPPBASEACCEL);
		GetMainWindow()->DragAcceptFiles(true);
}

void TApp::InitMainWindow()
{
	 EnableCtl3d();          			// Pour faire joli !!!
	 //EnableCtl3dAutosubclass(TRUE); // Pb !
  // Construct a status bar
  sb = new TStatusBar(Cadre, TGadget::Embossed);
 // Cre les compartiments supplmentaires
 pZ1 = new TTextGadget(0, TGadget::Embossed, TTextGadget::Left);
 sb->Insert(*pZ1);     // accrocher les compartiments  la barre d'tat
 pZ2 = new TTextGadget(0, TGadget::Embossed, TTextGadget::Center);
 sb->Insert(*pZ2);
 pZ3 = new TTextGadget(0, TGadget::Embossed, TTextGadget::Left);
 sb->Insert(*pZ3);
 pZ0= new TTextGadget(0, TGadget::Embossed, TTextGadget::Right,40);
 sb->Insert(*pZ0,TGadgetWindow::Before,pZ1);

  // Construct a control bar
  cb = new TControlBar(Cadre);
  cb->Insert(*new TButtonGadget(CM_ACQUI, CM_ACQUI, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_FILEOPEN, CM_FILEOPEN, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_FILESAVEAS, CM_FILESAVEAS, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_TRANSFERT, CM_TRANSFERT, TButtonGadget::Command));
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_HISTO, CM_HISTO, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_FEN, CM_FEN, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_PRLIG, CM_PRLIG, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_PRCOL, CM_PRCOL, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_PERSPEC, CM_PERSPEC, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SEUIL, CM_SEUIL, TButtonGadget::Command));
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_SOURCE0, CM_SOURCE0, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE1, CM_SOURCE1, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE2, CM_SOURCE2, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE3, CM_SOURCE3, TButtonGadget::Command));
  if(nbplan==8)
  {
  cb->Insert(*new TButtonGadget(CM_SOURCE4, CM_SOURCE4, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE5, CM_SOURCE5, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE6, CM_SOURCE6, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SOURCE7, CM_SOURCE7, TButtonGadget::Command));
  }
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_MODENB, CM_MODENB, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_MODECOUL, CM_MODECOUL, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_SEQUENCE, CM_SEQUENCE, TButtonGadget::Command));
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(LOGON7, CM_ABOUT, TButtonGadget::Command,TRUE));

  cb->SetHintMode(TGadgetWindow::EnterHints);

  // Insert the status bar and control bar into the frame
  Cadre->Insert(*sb, TDecoratedFrame::Bottom);
  Cadre->Insert(*cb, TDecoratedFrame::Top);

  // Set the main window and its menu
  SetMainWindow(Cadre);
  nCmdShow=SW_SHOWMAXIMIZED;   				// Pour fentre maxi
  GetMainWindow()->AssignMenu("COMMANDS");
  GetMainWindow()->EnableKBHandler();    // Navigation clavier
  GetMainWindow()->SetIcon(this, "ICON_1");
	 }

BOOL TApp::CanClose()
{
	return TRUE;
}

void
TApp::EvDropFiles(TDropInfo dropInfo)
{
	int fileLength = dropInfo.DragQueryFileNameLen(0)+1;
	char* filePath = new char [fileLength];
	dropInfo.DragQueryFile(0,filePath,fileLength);
	Fenetre->Charge_image(filePath);
	delete filePath;
	dropInfo.DragFinish();
}

//----------------------------------------------------------------------------
//						Programme TCad
//----------------------------------------------------------------------------

TCad::TCad(TWindow *Parent, const char far *title, TWindow* clientWnd,
			  BOOL trackMenuSelection)
			 : TDecoratedFrame(Parent,title,clientWnd,trackMenuSelection)
{
Cadre=this;
}

void
TCad::EvEnterIdle(UINT source, HWND h)
{
  // if the keystate high bit is set, then the key is pressed
	if (source == MSGF_MENU && (::GetKeyState(VK_F1) & 0x8000))
	{
	F1Pressed = TRUE;
	}
	TDecoratedFrame::EvEnterIdle(source, h);
}

DEFINE_RESPONSE_TABLE1(TCad,TDecoratedFrame)
	EV_WM_ENTERIDLE,
	END_RESPONSE_TABLE;

//----------------------------------------------------------------------------

