/**********************************************************************/
/*                       W A P P C O N V . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 03/10/1997                                    */
/*    Dernire modif.: 06/10/1997                                     */
/**********************************************************************/

// Object Window

#include <alloc.h>                     // Dos
#include <stdio.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlseg.h"
#include "wlcarmai.h"
#include "wlcarpro.h"

#include "wsysutil.h"
#include "wappbase.rh"
#include "wmain.h"
#include "wappbase.h"
#include "wappconv.h"

											// Pointeurs sur les fentres
TChoixMenu* TConvhoughPtr = 0;     // Fentre hough
TChoixMenu* TConvsegreduiPtr = 0;   // Fentre seg couleur rduite
TChoixMenu* TConvcolorPtr = 0;     	// Fentre transf. color.
TSeuil* TSeuilHPtr = 0;      		// Fentre seuil Hough
TSeuil* TSeuilCPtr = 0;      		// Fentre seuil Couleur
TConvseg* TConvsegPtr = 0;     	// Fentre seg couleur

//----------------------------------------------------------------------------
//						Programme TSeuilH
//----------------------------------------------------------------------------

TSeuilH::TSeuilH(TWindow* parent,char titre[],int smin,int smax,int sinit):
					TSeuil(parent,titre,smin,smax,sinit)
{
}

TSeuilH::~TSeuilH()
{
	TSeuilHPtr=0;
}

void
TSeuilH::EvCommun(int seuil)
{
  Houghinv(seuil);
  Fenetre->Visim(this,1,destin);
  SetActiveWindow();
 }

//----------------------------------------------------------------------------
//						Programme TSeuilC
//----------------------------------------------------------------------------

TSeuilC::TSeuilC(TWindow* parent,char titre[],int smin,int smax,int sinit):
					TSeuil(parent,titre,smin,smax,sinit)
{
}

TSeuilC::~TSeuilC()
{
	TSeuilCPtr=0;
}

void
TSeuilC::EvCommun(int seuil)
{
  Seuillage(seuil);
  Fenetre->Visim(this,1,destin);
  SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvcolor
//----------------------------------------------------------------------------

TConvcolor::TConvcolor(TWindow* parent)
		: TChoixMenu(parent,"TRANSFORMATIONS COLORIMETRIQUES",
		 "&0 SAUVEGARDE\n&1 RESTITUTION\n&2 COORD. REDUITES\n&3 I.T.S")
{
	im4=(unsigned char far *)farmalloc(65536L);
	im5=(unsigned char far *)farmalloc(65536L);
	im6=(unsigned char far *)farmalloc(65536L);
}

TConvcolor::~TConvcolor()
{
	farfree(im6);
	farfree(im5);
	farfree(im4);
	TConvcolorPtr=0;
}

void TConvcolor::EvCommun(char c)
{
char inputText[40]="";
int seuil;

	switch(c)
		{
		case '0' :
		Copie_plan(image1,im4);
		Copie_plan(image2,im5);
		Copie_plan(image3,im6);
		Fenetre->Visim(this,0,source);

		break;

		case '1':
		Copie_plan(im4,image1);
		Copie_plan(im5,image2);
		Copie_plan(im6,image3);
		Fenetre->Visim(this,0,source);
		break;

		case '2' :
		if((TInputDialog(this,"COORDONNEES REDUITES",
								"Valeur minimum R+V+B (0-765) ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
		{
		sscanf(inputText,"%d",&seuil);
		Redui(seuil);
		Fenetre->Visim(this,0,source);
		}
		break;

		case '3' :
		if ((TInputDialog(this,"INTENSITE-TEINTE-SATURATION",
								"Valeur minimum R+V+B (0-765) ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
		{
		sscanf(inputText,"%d",&seuil);
		Its(seuil);
		Fenetre->Visim(this,0,source);
		}
		break;

		}//switch
	SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvsegredui
//----------------------------------------------------------------------------

TConvsegredui::TConvsegredui(TWindow* parent)
: TChoixMenu(parent,"SEGMENTATION REDUITE : choix classe : click hiscou seuill",
"&0 SAUVEGARDE\n&1 RESTITUTION\n&2 VISU.HISCOU\n&3 SEUIL.HISCOU\n&4 VISU CLASSE"
		)
{
  im4=(unsigned char far *)farmalloc(65536L);
  im5=(unsigned char far *)farmalloc(65536L);
  im6=(unsigned char far *)farmalloc(65536L);
}

TConvsegredui::~TConvsegredui()
{
	farfree(im6);
	farfree(im5);
	farfree(im4);
	TConvsegreduiPtr=0;
}

void TConvsegredui::EvCommun(char c)
{
int x,y;

		switch(c)
		{
		case '0':
		modcoul=1;
		Redui(20);                    // min = 20
		Copie_plan(image1,im4);
		Copie_plan(image2,im5);
		Copie_plan(image3,im6);
		Fenetre->Visim(this,0,source);

		break;

		case '1' :
		modcoul=1;
		Copie_plan(im4,image1);
		Copie_plan(im5,image2);
		Copie_plan(im6,image3);
		Fenetre->Visim(this,0,source);

		break;

		case '2' :
		modcoul=1;
		Copie_plan(im4,image1);
		Copie_plan(im5,image2);
		Copie_plan(im6,image3);
		Hiscou('1');                       // Plan rouge-vert
		Fenetre->Visim(this,0,source);
		Fenetre->Visim(this,1,image0);

		break;

		case '3' :
		modcoul=1;
		Copie_plan(im4,image1);
		Copie_plan(im5,image2);
		Copie_plan(im6,image3);
		Hiscou('1');                       // Plan rouge-vert
		Copie_plan(image0,image1);
		source=image1;destin=image0;
		modcoul=0;
		Fenetre->Visim(this,0,image1);

		if(!TSeuilCPtr)
		{
	(TSeuilCPtr= new TSeuilC(this,
	"SEUILLAGE HISTOGRAMME COULEUR",0,255,5))->Create();
		}
		else
		{
		TSeuilCPtr->SetFocus();
		TSeuilCPtr->SetActiveWindow();
		}

		break;

		case '4':
		modcoul=0;
		source=image0;destin=image1;
		Seuillage(1);                      // Pour tiquetage ultrieur
		Copie_plan(image1,image0);
		Eti(&nbobj,&nbtrous,tabsur,tabcgx,tabcgy,
			tabxmi,tabxma,tabymi,tabyma,tabtrous);
		Copie_plan(image1,image0);
		x=posx;x&=0XFF;
		y=posy;y&=0XFF;
		eti=256-(*(destin+(y<<8)+x));
		eti&=0XFF;
		modcoul=1;
		Copie_plan(im4,image1);
		Copie_plan(im5,image2);
		Copie_plan(im6,image3);
		Seg_hiscou(eti);
		Fenetre->Visim(this,0,destin);

		break;
		}//switch

	if(c!='3') SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvseg
//----------------------------------------------------------------------------

void Ev_Image_Convseg(TPoint&,int);   // Proto

void Ev_Image_Convseg(TPoint&,int etatsouris)    // une fonction
{
	if(!etatsouris) return;
	if(TConvsegPtr)
	{
	 TConvsegPtr->NouveauPoint();
	}
}

DEFINE_RESPONSE_TABLE1(TConvseg, TFrameWindow)

  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TConvseg::TConvseg(TWindow* parent)
: TFrameWindow(parent,"SEGMENTATION COULEUR RVB : slection bloc sur image couleur")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

	Attr.X = 0;
	Attr.Y = 282+OFFSET;
	Attr.W = 640;
	Attr.H = 107;

	new TStatic(this, ID_STATIC, "Rmin :", 0, 4, 60, 25, 0);
	new TStatic(this, ID_STATIC, "Rmax :", 0, 25+4, 60, 25, 0);
	new TStatic(this, ID_STATIC, "Vmin :", 200, 4, 60, 25, 0);
	new TStatic(this, ID_STATIC, "Vmax :", 200, 25+4, 60, 25, 0);
	new TStatic(this, ID_STATIC, "Bmin :", 400, 4, 60, 25, 0);
	new TStatic(this, ID_STATIC, "Bmax :", 400, 25+4, 60, 25, 0);

	rmin=0;
	rmax=0;
	vmin=0;
	vmax=0;
	bmin=0;
	bmax=0;

	Rmin=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60, 0, 60, 25, 5);          // 5->4 car. max
	Rmax=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60, 25, 60, 25, 5);
	Vmin=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+200, 0, 60, 25, 5);
	Vmax=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+200, 25, 60, 25, 5);
	Bmin=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+400, 0, 60, 25, 5);
	Bmax=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+400, 25, 60, 25, 5);

	modefig=GEO_FENETRE;
	Ajoute_Fonction(Ev_Image_Convseg,modefig,RETIC,this);
}

void
TConvseg::SetupWindow()
{
  TFrameWindow::SetupWindow();
  AfficheOptions();
}

TConvseg::~TConvseg()
{
	Enleve_Fonction(this);
	TConvsegPtr=0;
}

void TConvseg::EvMButtonDown(UINT, TPoint &)
{
char string[12];

	Rmin->GetText(string,sizeof(string));
	rmin=atoi(string);if(rmin<0) rmin=0;if(rmin>255) rmin=255;
	Rmax->GetText(string,sizeof(string));
	rmax=atoi(string);if(rmax<0) rmax=0;if(rmax>255) rmax=255;
	Vmin->GetText(string,sizeof(string));
	vmin=atoi(string);if(vmin<0) vmin=0;if(vmin>255) vmin=255;
	Vmax->GetText(string,sizeof(string));
	vmax=atoi(string);if(vmax<0) vmax=0;if(vmax>255) vmax=255;
	Bmin->GetText(string,sizeof(string));
	bmin=atoi(string);if(bmin<0) bmin=0;if(bmin>255) bmin=255;
	Bmax->GetText(string,sizeof(string));
	bmax=atoi(string);if(bmax<0) bmax=0;if(bmax>255) bmax=255;

	Execute();
}

void TConvseg::NouveauPoint()
{
int i,j;
unsigned char *bufr,*bufv,*bufb;
unsigned int k;
long taille;

	bufr=(unsigned char far *)farmalloc(65536L);
	bufv=(unsigned char far *)farmalloc(65536L);
	bufb=(unsigned char far *)farmalloc(65536L);

	for(k=0,i=rFig.top;i<=rFig.bottom;i++)
	{
		for(j=rFig.left;j<=rFig.right;j++,k++)
		{
		bufr[k]=*(image2+j+(i<<8));
		bufv[k]=*(image3+j+(i<<8));
		bufb[k]=*(image1+j+(i<<8));
		}
	}
	taille=(long)(1+rFig.right-rFig.left)*(long)(1+rFig.bottom-rFig.top);
	Min_max(bufv,&vmin,&vmax,taille);
	Min_max(bufb,&bmin,&bmax,taille);
	Min_max(bufr,&rmin,&rmax,taille);

	farfree(bufb);
	farfree(bufv);
	farfree(bufr);

	Execute();
}

void
TConvseg::Execute()
{
	AfficheOptions();
	Segcou(vmin,vmax,rmin,rmax,bmin,bmax);
	Fenetre->Visim(this,1,image0);
}

void TConvseg::AfficheOptions(void)
{
char string[12];

	 itoa(rmin,string,10);
	 Rmin->SetText(string);
	 itoa(rmax,string,10);
	 Rmax->SetText(string);
	 itoa(vmin,string,10);
	 Vmin->SetText(string);
	 itoa(vmax,string,10);
	 Vmax->SetText(string);
	 itoa(bmin,string,10);
	 Bmin->SetText(string);
	 itoa(bmax,string,10);
	 Bmax->SetText(string);
}

//----------------------------------------------------------------------------
//						Programme TConvhough
//----------------------------------------------------------------------------

TConvhough::TConvhough(TWindow* parent)
		: TChoixMenu(parent,"TRANSFORMATION DE HOUGH","&0 DIRECTE\n&1 INVERSE")
{
}

TConvhough::~TConvhough()
{
	TConvhoughPtr=0;
}

void TConvhough::EvCommun(char c)
{
	switch(c)
	{
		case '0':
					SetCursor(0,IDC_WAIT);   // Pour attendre !!!
					Houghdir();
					SetCursor(0,IDC_ARROW);
					Fenetre->Visim(this,1,destin);
					break;

		case '1':
					if(!TSeuilHPtr)
					{
					(TSeuilHPtr= new TSeuilH(this,
					"SEUILLAGE TRANSFORMATION DE HOUGH",0,255,128))->Create();
					}
					else
					{
					TSeuilHPtr->SetFocus();
					TSeuilHPtr->SetActiveWindow();
					}

					break;
	}//switch
	if(c!='1') SetActiveWindow();
}

//----------------------------------------------------------------------------

