/**********************************************************************/
/*                       W B I N C O N V. C P P		                   */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			             			      	 		 */
/*    Dvelopp le   : 22/01/1996  21/06/96                 	       */
/*    Dernire modif.: 02/01/1998                                     */
/**********************************************************************/

// Object Window

#include <alloc.h>                     // Dos
#include <stdio.h>
#include <math.h>
#include <io.h>

#include "wgttsi.h"                    // Librairies Image
#include "wldecbin.h"
#include "wlsytbin.h"

#include "wmain.h"
#include "wappbase.h"
#include "wbinconv.h"

#define ID_TIMER_SEQ 12346

TSequence* TSequencePtr = 0;     	// Fentre sequence
TFramePrint* TAffseqPtr = 0;      	// Fentre affichage sequence

//----------------------------------------------------------------------------
//						Programme TConveditseq
//----------------------------------------------------------------------------

 class TConveditseq : public TChoix {
 public:

	 TConveditseq(TSequence* parent,int firstseq,char *nomfich);
	~TConveditseq();
 protected:
	 void EvCommun(char c);
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void AfficheOptions(void);
	 void Merge(int firstseq,char *nomfich,long numdep, long numarr);

	 int first;
	 char fich[MAXPATH];
	 long numdep,numarr;
	 TEdit *Aeditseq,*Beditseq;
	 TSequence* pere;

	DECLARE_RESPONSE_TABLE(TConveditseq);
};

TConveditseq* TConveditseqPtr;      // Fentre editseq

//----------------------------------------------------------------------------
//						Programme TSequence
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TSequence, TFrameWindow)
  EV_COMMAND_AND_ID(ID_A, EvA),
  EV_COMMAND_AND_ID(ID_A+1, EvB),
  EV_COMMAND_AND_ID(ID_A+2, EvC),
  EV_COMMAND_AND_ID(ID_A+3, EvD),
  EV_COMMAND_AND_ID(ID_A+4, EvE),
  EV_COMMAND_AND_ID(ID_A+5, EvF),
  EV_COMMAND_AND_ID(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_A+7, EvH),
  EV_COMMAND_AND_ID(ID_A+8, EvI),
  EV_COMMAND_AND_ID(ID_A+9, EvJ),
  EV_WM_LBUTTONDOWN,
  EV_WM_MOUSEMOVE,
  EV_WM_LBUTTONUP,
  EV_WM_TIMER,
  EV_WM_MBUTTONDOWN,
  END_RESPONSE_TABLE;

TSequence::TSequence(TWindow* parent,char titre[])
  : TFrameWindow(parent, titre)
{
int i,x0,y0;
int xmax=640;               	// Largeur cran
int decyfen=0;            	// Dcalage fentres en y
int maxcar;                     //Nb max de caractres
char *tabmes;           	// Table de messages
int py=52;                	// Position de dpart en y
int nb=9;                  	// Nombre de choix
int Fx=54,Fy=25;            	// Tailles fentres

	maxcar=Fx/8;            // 1 caractre = 8 points
	x0=(xmax-Fx*nb)>>1;
	y0=py+decyfen;
	tabmes=(char *)malloc(nb*(maxcar+1)*sizeof(char));
	strcpy(tabmes,"&0 <<");      // messages
	strcpy(tabmes+(maxcar+1),"&1 <");
	strcpy(tabmes+2*(maxcar+1),"&2 >");
	strcpy(tabmes+3*(maxcar+1),"&3 >>");
	strcpy(tabmes+4*(maxcar+1),"&4 PAR");  // mode
	strcpy(tabmes+5*(maxcar+1),"&5 NOM");  // para
	strcpy(tabmes+6*(maxcar+1),"&6 PRE");  // goto
	strcpy(tabmes+7*(maxcar+1),"&7 SUI");  // edit
	strcpy(tabmes+8*(maxcar+1),"&8 EDI");  // reco

	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

	Attr.X = 0;
	Attr.Y = 282+OFFSET;
	Attr.W = 640;
	Attr.H = 107;

	for(i=0;i<=nb-1;i++)
	{
  new TButton(this,ID_A+i,tabmes+(maxcar+1)*i,
  x0+i*Fx,y0,Fx-1,Fy-1,FALSE);
	}

  free(tabmes);

  Aseq=new TStatic(this, ID_STATIC, "", 0, 0, 50, 17, 0);
  Bseq=new TStatic(this, ID_STATIC, "", 0, 20, 50, 17, 0);
  Cseq=new TStatic(this, ID_STATIC, "", 570, 0, 60, 17, 0);
  Dseq=new TStatic(this, ID_STATIC, "", 570, 20, 60, 17, 0);
  Eseq=new TStatic(this, ID_STATIC, "", 570, 40, 60, 17, 0);
  Fseq=new TStatic(this, ID_STATIC, "", 570, 60, 60, 17, 0);
  Gseq=new TStatic(this, ID_STATIC, "", 0, 40, 50, 17, 0);
  Hseq=new TStatic(this, ID_STATIC, "M:", 0, 64, 20, 17, 0);
  Hseq1=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,"0", 20, 60, 50, 25, 6);

  SolidGauge=new TGauge(this, "",ID_STATIC, 50, 0, 512, 10, TRUE, 1);

//  modefich=fich_close;
}

void TSequence::SetupWindow()
{
	TFrameWindow::SetupWindow();

	FileData5.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	FileData5.SetFilter("Sequences(*.SEQ)|*.SEQ");
	FileData2.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	FileData2.SetFilter("Sequences(*.SEQ)|*.SEQ");
	strcpy(FileData2.FileName,FileData.FileName);

	modanim=0;
	flagsequence=0;
	numimag=0;
	stop=1;
	pas=1;
	nbptmin=50;
	SolidGauge->SetRange(0, 512);
	modboucle=1;                  // boucle en fin de squence
	flagrec=0;                    // Pour reconnaissance
	Affim();
	SetTimer(ID_TIMER_SEQ,10);                // Timer
}

TSequence::~TSequence()
{
	KillTimer(ID_TIMER_SEQ);
	//if(modefich==TRUE)
  //	if(in){fclose(in);in=NULL;}
	TSequencePtr=0;
}

void TSequence::EvTimer(UINT)
{
	if(stop==0)
	{
	Calimsuiv();
	Affim();
	}
}

void TSequence::EvLButtonDown(UINT a, TPoint& point)
{
	flagsequence=1;
	EvMouseMove(a,point);
}

void TSequence::EvLButtonUp(UINT a, TPoint& point)
{
int posx0,posy0;

	flagsequence=0;

	posx0=point.x;
	posy0=point.y;

	if(posy0>=75&&posy0<75+10)
	{
		if(posx0>=77+54&&posx0<=77+107)
		{
		pas=-1;
		Arret();
		}
		if(posx0>=77+107&&posx0<=77+107+54)
		{
		pas=1;
		Arret();
		}
	}
	EvMouseMove(a,point);
}

void TSequence::EvMouseMove(UINT, TPoint& point)
{
int posx0,posy0;
float numero;
int x0,x1,y0,y1;

	posx0=point.x;
	posy0=point.y;

if(flagsequence)
{
	x0=50;x1=x0+512;y0=0;y1=y0+50;
	if(posx0>=x0&&posx0<x1&&posy0>=y0&&posy0<y1)
	{
	numero=(float)(carseq.nbtot-1)*(float)(posx0-x0)/511.;
	numimag=long(numero);
	Affim();
	}

	if(posy0>=75&&posy0<75+10)
	{
		if(posx0>=77&&posx0<=77+54)
		{
		pas=-1+(posx0-77-54)/9;
		stop=0;
		}
		if(posx0>=77+54&&posx0<=77+107)
		{
		pas=-1;
		stop=0;
		}
		if(posx0>=77+107&&posx0<=77+107+54)
		{
		pas=1;
		stop=0;
		}
		if(posx0>=77+107+54&&posx0<=77+107+107)
		{
		pas=1+(posx0-77-107-54)/9;
		stop=0;
		}
	}
} //flagsequence
}

void TSequence::EvMButtonDown(UINT, TPoint &)
{
char string[12];
long nbpt;

	Hseq1->GetText(string,sizeof(string));
	nbpt=atol(string);
	if(nbpt<0) nbpt=0;
	if(nbpt==0) modanim=0;else modanim=1;
	if(nbpt>65535L) nbpt=65535L;
	if(nbpt)nbptmin=nbpt;
	Affim();
}

void TSequence::Affim()
{
	if(carseq.nbtot<=0) return;
	Animabin(in,numimag,&carimseq);
	Affcarim();
	if(flagrec) Reconnais();
	Calsuiv();
	Fenetre->Visim(this,0,source);
	if(flagrec) Aff_Recon();
}

void TSequence::Affcarim()               // Affichage car. image
{
char string[20],s[20];
int setting;
long diff;
float vitesse;

	ltoa(numimag+1,string,10);
	Aseq->SetText(string);                  // Numro de l'image

	if(modanim==0) strcpy(string,"0");
	else
	ltoa(nbptmin,string,10);
	Hseq1->SetText(string);
	if(stop==0)
	{
	t1=Caltime();
	if(labs(t1-t0)>=100)
		{
		n1=numimag;
		if(pas>0) diff=n1-n0;else diff=n0-n1;
		if(diff<0) diff+=carseq.nbtot;
		vitesse=100.*(float)diff/(float)(t1-t0);
		t0=t1;
		n0=n1;
		gcvt(vitesse,4,string);
		strcpy(s,"V:");
		strcat(s,string);
		Bseq->SetText(s);               // Vitesse d'animation
		}
	 }

	if(carseq.nbtot==1) setting=1;
	else	setting=(int)(512.*((float)numimag/(float)(carseq.nbtot-1)));
	SolidGauge->SetValue(setting);

	itoa(carimseq.nbcod,string,10);
	strcpy(s,"C:");
	strcat(s,string);
	Cseq->SetText(s);                  // Nb. codes de l'image
	ltoa(carimseq.nbpt,string,10);
	strcpy(s,"S:");
	strcat(s,string);
	Dseq->SetText(s);                  // Nb. points de l'image
	itoa(pas,string,10);
	strcpy(s,"P:");
	strcat(s,string);
	Gseq->SetText(s);                  // Pas : pour animation

	Cal_datim(&ft,&tc,numimag,carseq.vitesse,carseq.nbtot);
	strcpy(s,"");
	itoa(tc.ft_day,string,10);
	strcat(s,string);
	strcat(s,"/");
	itoa(tc.ft_month,string,10);
	strcat(s,string);
	strcat(s,"/");
	itoa(tc.ft_year+80,string,10);
	strcat(s,string);
	Eseq->SetText(s);                  // Date

	strcpy(s,"");
	itoa(tc.ft_hour,string,10);
	strcat(s,string);
	strcat(s,":");
	itoa(tc.ft_min,string,10);
	strcat(s,string);
	strcat(s,":");
	itoa(tc.ft_tsec*2,string,10);
	strcat(s,string);
	Fseq->SetText(s);                  // Heure
}

void TSequence::Paint(TDC& dc, BOOL, TRect&)
{
int x0,y0,y1,i,y2;
float dyn=40.0,echelle,*histseq;
long nbptmax;

	x0=50;y0=0;y1=y0+50;

	nbptmax=carseq.nbptmax;
	histseq=&carseq.histseq[0];

	if(nbptmax==0) nbptmax=1;                  // images vides !
	echelle=sqrt(nbptmax);
	for(i=0;i<512;i++)
	{
	y2=(int)(dyn*sqrt(histseq[i])/echelle);
	dc.MoveTo(x0+i,y1);
	dc.LineTo(x0+i,y1-y2);
	dc.LineTo(x0+i,y1-y2+1);         			 // dernier point

	dc.Rectangle(77,75,77+53,75+10);            // Pour dplacements
	dc.Rectangle(77+54,75,77+107,75+10);
	dc.Rectangle(77+107,75,77+107+53,75+10);
	dc.Rectangle(77+107+54,75,77+107+107,75+10);
	}
}

void TSequence::EvA(UINT)
{
	EvCommun('0');
}

void TSequence::EvB(UINT)
{
	EvCommun('1');
}

void TSequence::EvC(UINT)
{
	EvCommun('2');
}

void TSequence::EvD(UINT)
{
	EvCommun('3');
}

void TSequence::EvE(UINT)
{
	EvCommun('4');
}

void TSequence::EvF(UINT)
{
	EvCommun('5');
}

void TSequence::EvG(UINT)
{
	EvCommun('6');
}

void TSequence::EvH(UINT)
{
	EvCommun('7');
}

void TSequence::EvI(UINT)
{
	EvCommun('8');
}

void TSequence::EvJ(UINT)
{
	EvCommun('9');
}

int TSequence::EvCommun(char c)
{
char inputText[12]="",c1;
char string[MAXPATH],nomfich[MAXPATH];
long numero;

	switch(c)
	{
	case'0':                // recul rapide
				pas=-1;
				t0=Caltime();
				n0=numimag;
				stop=0;
				break;

	case'1': Arret();        // recul 1 pas
				pas=-1;
				Calimsuiv();
				Affim();
				break;

	case'2': Arret();       // avance 1 pas
				pas=1;
				Calimsuiv();
				Affim();
				break;

	case'3':               // avance rapide
				pas=1;
				t0=Caltime();
				n0=numimag;
				stop=0;
				break;

	case'4':                           // param.
				if(AppelChoixDial(this,
				"PARAMETRES","&0->MIN\n&1->CAR.SEQ.\n&2->NORMAL\n&3->AUTO",&c1)
				!=TRUE)
				break;
				switch(c1)
				{
				case'0':
				Arret();
				ltoa(nbptmin,inputText,10);
				if((TInputDialog(this,"",
								"Nombre minimum de points ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)

				sscanf(inputText,"%ld",&nbptmin);
				break;

				case'1':
				if(TAffseqPtr)	TAffseqPtr->ShutDownWindow();
				(TAffseqPtr= new TAffseq(this,"CARACTERISTIQUES SEQUENCE"))->Create();

				break;

				case'2': modanim=0;break;

				case'3': modanim=1;break;
				}

				Affim();
				break;
	case'5':         // nom
	case'6':         // prec
	case'7':         // suiv
	case'9':
				if(c=='5')
				{
				if((TFileOpenDialog(this,FileData2)).Execute()!=IDOK)
				// break;
				return 1;
				strcpy(nomfich,FileData2.FileName);
				}

				if(c=='6'||c=='7')
				{
				strcpy(nomfich,FileData2.FileName);
				fnsplit(nomfich,driveseq2,dirseq2,fileseq2,extseq2);
				Calnum(fileseq2,nomgen2,&numero);
				if(numero<0)
				// break;
				return 1;

				if(c=='7') numero++;
				if(c=='6') if(numero) numero--;
				else
				// break;
				return 1;
				strcpy(fileseq2,nomgen2);
				ltoa(numero,string,10);
				strcat(fileseq2,string);
				fnmerge(nomfich,driveseq2,dirseq2,fileseq2,extseq2);
				}

				if(c=='9')           // lancement automatique
				{
				strcpy(nomfich,FileData.FileName);
				}

				if(c=='5'||c=='6'||c=='7'||c=='9')
				{
				ifstream is(nomfich);
				if(!is)
				{
				MessageBox(nomfich,"Impossible d'ouvrir",
				MB_OK | MB_ICONEXCLAMATION);
				//break;
				return 1;
				}
				}
				if(in) {fclose(in);in=0;}
				if((in=fopen(nomfich,"rb"))==NULL)
				{
				MessageBox(nomfich,"ERREUR SUR FICHIER",MB_OK);
				SetCaption("Animation de squence");
				//break;
				return 1;
				}

				strcpy(FileData2.FileName,nomfich);
				SetCursor(0,IDC_WAIT);
				Carseqbin(in,&id,&carseq);
				SetCursor(0,IDC_ARROW);
				numimag=0;
				Affim();
				strcpy(string,"Animation de : ");
				strcat(string,FileData2.FileName);
				SetCaption(string);
				Invalidate();           // mise  jour
				if(TAffseqPtr)
				{
				TAffseqPtr->Invalidate();
				}
				break;

	case'8':                          // Edit
				Edit();
				break;

		}//switch
		return 0;         // OK
}

void TSequence::Calnum(char file[],char nomgen[],long *num)
{
int l,i;

	strcpy(nomgen,file);
	l=strlen(file);
	for(i=l-1;i>0;i--)
	{
	if(file[i]<'0'||file[i]>'9') break;
	}
	if(i>=0&&i<l-1) {*num=atol(&file[i+1]);nomgen[i+1]=0;}
	else *num=-1;
}

void TSequence::Arret()
{
	stop=1;
	Bseq->SetText("");
}

void TSequence::Calimsuiv()           // Calcul numro image suivante
{
long num;

	if(modanim)
	{
	if(pas>0) numimag=Recimsuiv(in,nbptmin);
	else numimag=Recimprec(in,nbptmin);
	if(abs(pas)==1) return;
	}

	num=numimag;
	num+=pas;
	if(num<0||num>=carseq.nbtot)       // Valide
	{
	if(modboucle)                         // Pour dbut et fin
	{
	if(num<0) num+=carseq.nbtot;
	if(carseq.nbtot>0) num%=carseq.nbtot;
	numimag=num;
	}
	}
	else numimag=num;
}

void TSequence::Edit()
{
int firstseq;
char c;

	 if(TConveditseqPtr) return;

	 if(AppelChoixDial(this,"TYPE D'EDITION","&0->Cration\n&1->Ajout",&c)!=TRUE)
	 return;
	 if(c=='0')  // cration
	 {
	 if((TFileSaveDialog(this, FileData5)).Execute()!= IDOK) return;
	 if(strcmpi(FileData.FileName,FileData5.FileName)==0)// test
	 {
		MessageBox(FileData.FileName,"Impossible de modifier la squence en cours",
		MB_OK | MB_ICONEXCLAMATION);
		return;
	 }
	 ofstream os(FileData5.FileName);
	 if(!os)
	 {
	 MessageBox(FileData5.FileName,"Impossible d'ouvrir",
	 MB_OK | MB_ICONEXCLAMATION);
	 return;
	 }
	 firstseq=1;
	 }
	 else  //ajout
	 {
	 if((TFileOpenDialog(this, FileData5)).Execute() != IDOK) return;
	 if(strcmpi(FileData.FileName,FileData5.FileName)==0)// test
	 {
		MessageBox(FileData.FileName,"Impossible de modifier la squence en cours",
		MB_OK | MB_ICONEXCLAMATION);
		return;
	 }
	 ifstream is(FileData5.FileName);
	 if(!is)
	 {
	 MessageBox(FileData5.FileName,"Impossible d'ouvrir",
	 MB_OK | MB_ICONEXCLAMATION);
	 return;
	 }
	 firstseq=0;
	 }

	if(!TConveditseqPtr)
	{
	(TConveditseqPtr= new TConveditseq(this,firstseq,FileData5.FileName))->Create();
	}
}

void TSequence::Reconnais()
{
}

void TSequence::Aff_Recon()
{
}
void TSequence::Goto(long numim)
{
	if(numim>=0&&numim<carseq.nbtot)
	{
	stop=1;
	numimag=numim;
	Affim();
	}
}

void TSequence::Goto_Anim(long numim)
{
long t0;

	if(numim>=0&&numim<carseq.nbtot)
	{
	stop=1;
	numimag=numim;
	for(numimag=numim-25;numimag<numim;numimag++)
		{
		t0=Caltime();
		if(numimag>=0)	{Affim();while(Caltime()<=t0+4);}
		}
	Affim();
	}
}

//----------------------------------------------------------------------------
//						Programme TAffseq
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TAffseq, TFramePrint)
	EV_WM_SIZE,
	EV_WM_MOUSEMOVE,

  END_RESPONSE_TABLE;

TAffseq::TAffseq(TWindow* parent, char titre[])
  : TFramePrint(parent,titre)
{
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376/2;
		Attr.H = 256+27;
		Scroller = new TScroller(this, 5, 5, 640/5, 1000);  // 640/5, 480/5
		Scroller->SetSBarRange();
}

TAffseq::~TAffseq()
{
	TAffseqPtr=0;
}

void TAffseq::EvSize(UINT sizeType, TSize& size)
{
	TWindow::EvSize(sizeType, size);
	ShowScrollBar(SB_HORZ);
	ShowScrollBar(SB_VERT);
	Scroller->SetSBarRange();
}

void TAffseq::Paint(TDC& dc, BOOL, TRect&)
{
int py0=0,px0=100;
char string[80],s[80];
float vitesse;
long totsec,min,hour,sec;
ldiv_t tampon;

	dc.TextOut(1,py0,   "TOT. IMAGES : ");
	dc.TextOut(1,py0+15,"TOT. CODES  : ");
	dc.TextOut(1,py0+30,"MOY. CODES  : ");
	dc.TextOut(1,py0+45,"MAX. POINTS : ");
	dc.TextOut(1,py0+60,"DUREE : ");

	ltoa(carseq.nbtot,string,10);
	dc.TextOut(px0,py0,string);
	ltoa(carseq.totcod,string,10);
	dc.TextOut(px0,py0+15,string);
	gcvt((double)carseq.codmoyen,6,string);
	dc.TextOut(px0,py0+30,string);
	ltoa(carseq.nbptmax,string,10);
	dc.TextOut(px0,py0+45,string);
	vitesse=Cal_vitesse(&id);
	totsec=(long)((float)carseq.nbtot/vitesse);
	tampon=ldiv(totsec,3600);
	hour=tampon.quot;
	min=tampon.rem;
	tampon=ldiv(min,60);
	min=tampon.quot;
	sec=tampon.rem;
	strcpy(s,"");
	ltoa(hour,string,10);
	strcat(s,string);
	strcat(s,":");
	ltoa(min,string,10);
	strcat(s,string);
	strcat(s,":");
	ltoa(sec,string,10);
	strcat(s,string);
	dc.TextOut(px0,py0+60,s);    // Dure

	Aff_datim(dc,&ft);
	Aff_identseq(dc,&id);

}

void TAffseq::Aff_datim(TDC& dc,struct ftime *tc)
{

char string[80],s[80];
int py=90,px=50;
														//Date
	dc.TextOut(1,py,"DATE :");
	strcpy(s,"");
	itoa(tc->ft_day,string,10);
	strcat(s,string);
	strcat(s,"/");
	itoa(tc->ft_month,string,10);
	strcat(s,string);
	strcat(s,"/");
	itoa(tc->ft_year+80,string,10);
	strcat(s,string);
	strcat(s,"  ");
	itoa(tc->ft_hour,string,10);
	strcat(s,string);
	strcat(s,":");
	itoa(tc->ft_min,string,10);
	strcat(s,string);
	strcat(s,":");
	itoa(tc->ft_tsec*2,string,10);
	strcat(s,string);
	dc.TextOut(px,py,s);
}

void TAffseq::Aff_identseq(TDC& dc,identseq *id)
{

char string[80];
int py=120,px0=100;
float vitesse;

	if(strcmp(id->ident,"SEQ")==0)
	{
	dc.TextOut(1,py,    "VITES. ACQ. : ");
	dc.TextOut(1,py+15, "PAR. TRAME  : ");
	dc.TextOut(1,py+30, "NB. IMAGES  : ");
	dc.TextOut(1,py+45, "XMIN        : ");
	dc.TextOut(1,py+60, "YMIN        : ");
	dc.TextOut(1,py+75, "XMAX        : ");
	dc.TextOut(1,py+90, "YMAX        : ");
	dc.TextOut(1,py+105,"SEUIL       : ");

	vitesse=Cal_vitesse(id);

	gcvt((double)vitesse,6,string);
	dc.TextOut(px0,py,string);

	switch(id->parite)
	{
	case 0 : dc.TextOut(px0,py+15,"IMPAIRE");break;
	case 1 : dc.TextOut(px0,py+15,"PAIRE");break;
	case 2 :
	case 3 : dc.TextOut(px0,py+15,"IGNOREE");break;
	}
	ltoa(id->nbtotimage,string,10);
	dc.TextOut(px0,py+30,string);
	itoa(id->xmin,string,10);
	dc.TextOut(px0,py+45,string);
	itoa(id->ymin,string,10);
	dc.TextOut(px0,py+60,string);
	itoa(id->xmax,string,10);
	dc.TextOut(px0,py+75,string);
	itoa(id->ymax,string,10);
	dc.TextOut(px0,py+90,string);
	itoa(id->seuil,string,10);
	dc.TextOut(px0,py+105,string);
	}
	else
	{
	dc.TextOut(1,py+40,"PARAMETRES D'ENREG.");
	dc.TextOut(1,py+60,"NON DISPONIBLES !!!");
	}
}

//----------------------------------------------------------------------------
//						Programme TConveditseq
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TConveditseq, TChoix)

  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TConveditseq::TConveditseq(TSequence* parent,int firstseq,char *nomfich)
: TChoix(parent,nomfich,"&0 DEBUT\n&1 FIN\n&2 VALIDATION",
TRect(256+8,282+OFFSET-1-125,639,282+OFFSET-1))
{
	pere=parent;
	first=firstseq;
	strcpy(fich,nomfich);
	numdep=pere->numimag+1;
	numarr=pere->numimag+1;
	Aeditseq=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 12, 0, 80, 25, 10);          // 10->9 car. max
	Beditseq=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 130, 0, 80, 25, 10);
}

TConveditseq::~TConveditseq()
{
	TConveditseqPtr=0;
}

void
TConveditseq::SetupWindow()
{
	TFrameWindow::SetupWindow();
	AfficheOptions();
}

void TConveditseq::EvMButtonDown(UINT, TPoint &)
{
 char string[12];

	Aeditseq->GetText(string,sizeof(string));
	numdep=atol(string);
	Beditseq->GetText(string,sizeof(string));
	numarr=atol(string);
}

void TConveditseq::EvCommun(char c)
{
	switch(c)
	{
		case '0':numdep=pere->numimag+1;
			 break;
		case '1':numarr=pere->numimag+1;
			 break;
		case '2':
				if(numarr<numdep||numarr<1||numdep<1)
				{
				MessageBox("", "Paramtres incorrects",
				MB_OK | MB_ICONEXCLAMATION);break;
				}
				Merge(first,fich,numdep,numarr);
				first=0;
			 break;
	 }
	AfficheOptions();
}

void TConveditseq::AfficheOptions(void)
{
char string[12];

	 ltoa(numdep,string,10);
	 Aeditseq->SetText(string);

	 ltoa(numarr,string,10);
	 Beditseq->SetText(string);
}

void
TConveditseq::Merge(int firstseq,char *nomfich,long numdep,long numarr)
{
int nbcod;
unsigned char *buf;
long nbimage;
FILE *outfile;

	 buf=(unsigned char *)farmalloc(TAILBUF*sizeof(char));
	 outfile=fopen(nomfich,"r+b");

	if(firstseq)
		{
		buf[0]=0;buf[1]=0;                  // Init pour 1re image
		buf[2]=0;buf[3]=0;
		}
	else
		{
		fseek(outfile,-4L,SEEK_END);   // on suppose qu'il n'y a pas ident
		fread(buf,4*sizeof(char),1,outfile);
		fseek(outfile,-4L,SEEK_END);
		}

		nbimage=numdep-1;
		while(nbimage<numarr&&nbimage<carseq.nbtot)
		{
		Animabin2(in,nbimage,&carimseq,&buf[4]);
		nbcod=carimseq.nbcod;
		buf[2]=nbcod>>8;buf[3]=nbcod&0XFF;
		fwrite(buf,nbcod,1,outfile);
		buf[0]=buf[2];buf[1]=buf[3];	// chanage suivant
		buf[2]=0;buf[3]=0;
		nbimage++;
		}
		fwrite(buf,4,1,outfile);  	// sortie dernier chanage
		fclose(outfile);
		farfree(buf);
}

//----------------------------------------------------------------------------


