/**********************************************************************/
/*                       W C A R C O N V . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995  07/02/96                           */
/*    Dernire modif.: 10/10/1997                                     */
/**********************************************************************/

// Object Window

#include <alloc.h>                     // Dos
#include <stdio.h>
#include <math.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlcarmai.h"
#include "wlcarpro.h"
#include "wlfft.h"

#include "wmain.h"
#include "wappbase.rh"
#include "wappbase.h"
#include "wcarconv.h"

											// Pointeurs sur les fentres
TConvcarac* TConvcaracPtr = 0;     	// Fentre carac
TConvcarobj* TConvcarobjPtr = 0;     // Fentre carobj
TCarvis* TCarvisPtr=0;          	// Fentre visu carac
TSeuil* TSeuilPolyPtr = 0;      		// Fentre seuil Polygone
TSeuil* TSeuilFFTPtr = 0;      		// Fentre seuil FFT

													  // Pour caractrisation gomtrique
unsigned int sort[2048];                 // Pour FFT contour
unsigned int Nb_interp;

//----------------------------------------------------------------------------
//						Programme TSeuilFFT
//----------------------------------------------------------------------------

TSeuilFFT::TSeuilFFT(TWindow* parent,char titre[],int smin,int smax,int sinit):
					TSeuil(parent,titre,smin,smax,sinit)

{
}

void
TSeuilFFT::EvCommun(int seuil)
{
int parite,param,j;
float *TAB1_X,*TAB1_Y;
unsigned char far *pointim;
scomplex *entree;                   // Pour FFT
scomplex *sortie;
int modecar;

		entree=(scomplex *)calloc(Nb_interp,sizeof(scomplex));
		sortie=(scomplex *)calloc(Nb_interp,sizeof(scomplex));

		param=seuil;
		if(param==((param>>1)<<1)) parite=0; else parite=1;
		param>>=1;

		 TAB1_X=(float *)malloc(Nb_interp*sizeof(float));
		 TAB1_Y=(float *)malloc(Nb_interp*sizeof(float));

		 // calcul des coordonnes des points d'interpolation
		  Const_Tab_Inter(TABX,Nb_cont,Nb_interp,TAB1_X);
		  Const_Tab_Inter(TABY,Nb_cont,Nb_interp,TAB1_Y);

		for (j=0;j<Nb_interp;j++) 	// Transfert buffers
		{
		entree[j].re=TAB1_X[j];
		entree[j].im=TAB1_Y[j];
		}

		free(TAB1_X);free(TAB1_Y);

		fft(Nb_interp,entree,sortie);

		// filtrage paramtr

		for(j=0;j<param+parite;j++)
		{
		sort[j]=(int)(modf_m(sortie[j]));
		}

		for(;j<Nb_interp-param;j++)
		{
		sort[j]=0;
		sortie[j].re=0;
		sortie[j].im=0;
		}

		for(j=Nb_interp-param;j<Nb_interp;j++)
		{
		sort[j]=(int)(modf_m(sortie[j]));
		}

		ifft(Nb_interp,sortie,entree);

		// reconstruction du contour de l'objet aprs FFT inverse

		Eff(destin);

		Const_Obj(xmin,xmax,ymin,ymax,eti,16); 	// Visu obj

		for(j=0;j<Nb_interp;j++)
		{
		pointim=destin+(((int)(entree[j].re+0.5))&0XFF)+
		((((int)(entree[j].im+0.5))&0XFF)<<8);
		*pointim|=128;
		}

		free(sortie);free(entree);

  modecar=2;
  if(TConvcaracPtr) TConvcaracPtr->ShowCarvis(this,modecar);  // Visu spectre
  Fenetre->Visim(this,1,destin);
  SetActiveWindow();
 }

TSeuilFFT::~TSeuilFFT()
{
	TSeuilFFTPtr=0;
}

//----------------------------------------------------------------------------
//						Programme TSeuilPoly
//----------------------------------------------------------------------------

TSeuilPoly::TSeuilPoly(TWindow* parent,char titre[],int smin,int smax,int sinit):
					TSeuil(parent,titre,smin,smax,sinit)

{
}

TSeuilPoly::~TSeuilPoly()
{
	TSeuilPolyPtr=0;
}

void
TSeuilPoly::EvCommun(int seuil)
{
	 Eff(destin);
	 seuil_dis=seuil;
	 seuil_dis*=seuil_dis;               // carr
	 Const_Obj(xmin,xmax,ymin,ymax,eti,16);
	 Remp_tabsom(Nb_cont);
	 Decod_tabsom(destin,64,Nb_cont);
	 Decod_som(destin,128,Nb_cont);

	 Fenetre->Visim(this,1,destin);
	 SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvcarobj
//----------------------------------------------------------------------------

TConvcarobj::TConvcarobj(TWindow* parent)
		: TChoixMenu(parent,"VISUALISATION DES COMPOSANTES D'UN OBJET",
"&0 OBJET\n&1 SQUELET.\n&2 E.CONV.\n&3 CONCAV.\n&4 CONTOUR\n&5 POLYGON\n&6 FOURIER")
{
}

TConvcarobj::~TConvcarobj()
{
	TConvcarobjPtr=0;
}

void TConvcarobj::EvCommun(char c)
{
	Eff(destin);
	switch(c)
	{
		case '0':Const_Obj(xmin,xmax,ymin,ymax,eti,128);
			 break;

		case '1':Const_Obj(xmin,xmax,ymin,ymax,eti,128+16);
			 SetCursor(0,IDC_WAIT);   // Pour attendre !!!
			 Const_squel(xmin,xmax,ymin,ymax,128,64);
			 SetCursor(0,IDC_ARROW);
			 break;

		case '2':Const_Obj(xmin,xmax,ymin,ymax,eti,16);
			 Const_Obj_Equ(xmin,xmax,ymin,ymax,16,taboeg,taboed);
			 Const_Pce(ymin,ymax,taboeg,taboed,tabpceg,tabpced);
			 Decod_Seg(ymin,ymax,128,tabpceg,tabpced);
			 break;

		case '3':Const_Obj(xmin,xmax,ymin,ymax,eti,16);
			 Const_Obj_Equ(xmin,xmax,ymin,ymax,16,taboeg,taboed);
			 Const_Pce(ymin,ymax,taboeg,taboed,tabpceg,tabpced);
			 Decod_Seg(ymin,ymax,1,tabpceg,tabpced);
			 Const_Concav(xmin,xmax,ymin,ymax,16,1,128);
			 break;

		case '4':Const_Obj(xmin,xmax,ymin,ymax,eti,16);
			 Conto(xmin,xmax,ymin,ymax,16,128);
			 break;

		case '5':                         // Polygone
					if(!TSeuilPolyPtr)
					{
					(TSeuilPolyPtr= new TSeuilPoly(this,
					"SEUILLAGE APPROXIMATION POLYGONALE",0,360,0))->Create();
					}
					else
					{
					TSeuilPolyPtr->SetFocus();
					TSeuilPolyPtr->SetActiveWindow();
					}

			 break;

		case '6':                         // Descripteurs de Fourier
				if(Nb_cont==1)
				{
				MessageBox("", "Surface=1 --> calcul FFT impossible !!",
				MB_OK | MB_ICONEXCLAMATION);break;
				}
				// calcul du nombre de points d'interpolation
				int puiss=(log((double)(Nb_cont))/log((double)2))+1;
				Nb_interp=(int)pow((double)2,(double)puiss);

					if(!TSeuilFFTPtr)
					{
					(TSeuilFFTPtr= new TSeuilFFT(this,
					"SEUILLAGE DESCRIPTEURS DE FOURIER",1,Nb_interp-1,1))->Create();
					}
					else
					{
					TSeuilFFTPtr->SetFocus();
					TSeuilFFTPtr->SetActiveWindow();
					}

			break;
	} //switch

		if(c!='5'&&c!='6')
		{
		Fenetre->Visim(this,1,destin);
		SetActiveWindow();
		}
}

//----------------------------------------------------------------------------
//						Programme TConvcarac
//----------------------------------------------------------------------------

void Ev_Image_Convcarac(TPoint&,int);   // Proto

void Ev_Image_Convcarac(TPoint&,int etatsouris)    // une fonction
{
	if(etatsouris==0X02)      // Click bouton gauche
	if(TConvcaracPtr)
	{
	 TConvcaracPtr->EvCommun('2');
	}
}

TConvcarac::TConvcarac(TWindow* parent)
		: TChoixMenu(parent,"SELECTION OBJET : CLICK PLAN SOURCE",
		"&0 ETIQUETAGE\n&1 TAB.CARAC.\n&2 OBJET\n&3 CAR.OBJ\n&4 VISU COMP.")
{
	modefig=0;
	Ajoute_Fonction(Ev_Image_Convcarac,modefig,RETIC,this);
}

TConvcarac::~TConvcarac()
{
	Enleve_Fonction(this);
	TConvcaracPtr=0;
}

void TConvcarac::EvCommun(char c)
{
long sur,cgx,cgy;                        // Surface, barycentre
float per,compacite,per_ext;
int x,y;
int modecar;

	obj=&OBJ;
	ec=&EC;

	switch(c)
	{
	case '0':                             // Etiquettes

				dep=Eti(&nbobj,&totaltrous,tabsur,tabcgx,tabcgy,
							tabxmi,tabxma,tabymi,tabyma,tabtrous);
				Calsuiv();
				Fenetre->Visim(this,0,source);
				//break;

	case '1':                             // Carac. Objets
				modecar=0;
				ShowCarvis(this,modecar);
				break;

	case '2':                             // 1 objet
				  // slection sur image source
					x=posx;x&=0XFF;
					y=posy;y&=0XFF;

					eti=256-(*(source+(y<<8)+x));
					eti&=0XFF;
					if(eti==0||eti>nbobj)
					{
					MessageBox("", "Objet non slectionn",
					MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
					break;
					}
					// Affectation des paramtres calculs

					 xmin=(int)tabxmi[eti];
					 ymin=(int)tabymi[eti];
					 xmax=(int)tabxma[eti];
					 ymax=(int)tabyma[eti];
					 sur=tabsur[eti];
					 cgx=tabcgx[eti];
					 cgy=tabcgy[eti];
					 nbtrous=tabtrous[eti];

			// Calcul des paramtres suivants

			Eff(destin);     // Pour construire objet
			Const_Obj(xmin,xmax,ymin,ymax,eti,128);
			Perim(xmin,xmax,ymin,ymax,&per,128);
			compacite=(per*per)/(4.0*PI*((float)sur));

					 // Affectation de la structure

					 obj->xmin=xmin;
					 obj->ymin=ymin;
					 obj->xmax=xmax;
					 obj->ymax=ymax;
					 obj->sur=sur;
					 obj->cgx=cgx;
					 obj->cgy=cgy;
					 obj->nbtrous=nbtrous;
					 obj->per=per;
					 obj->compac=compacite;

			Moments(obj,128);
			Cal_orien(obj);
			Nb_cont=Constab_context(obj,128,destin,TABX,TABY,connex,&per_ext);
			Cal_l_h_rectmin(obj,Nb_cont,TABX,TABY);

			// Calcul des paramtres de l'EC

			Const_Obj_Equ(xmin,xmax,ymin,ymax,128,taboeg,taboed);
			Conto(xmin,xmax,ymin,ymax,128,32);
			Const_Pce(ymin,ymax,taboeg,taboed,tabpceg,tabpced);
			Decod_Seg(ymin,ymax,64,tabpceg,tabpced);
			Surf(xmin,xmax,ymin,ymax,&sur,&cgx,&cgy,64);
			Perim(xmin,xmax,ymin,ymax,&per,64);
			compacite=(per*per)/(4.0*PI*((float)sur));

			// Visu rectangle et CG

			Trfen(xmin,xmax,ymin,ymax,32,destin);
			Trfret(destin,(int)obj->cgx,(int)obj->cgy);

			ec->sur=sur;
			ec->cgx=cgx;
			ec->cgy=cgy;
			ec->per=per;
			ec->compac=compacite;
			ec->t_concav=(float)ec->sur/(float)obj->sur;
			obj->t_concav=(float)ec->sur/(float)obj->sur;

				// Visu objet
				Fenetre->Visim(this,1,destin);
				//break;

	case '3':                             // Carac. d'un objet
				if(eti==0||eti>nbobj)
				{
				MessageBox("", "Objet non slectionn",
				MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
				break;
				}
				modecar=1;
				ShowCarvis(this,modecar);
				break;

	case '4':                             // Visu comp
				if(eti==0||eti>nbobj)
				{
				MessageBox("", "Objet non slectionn",
				MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
				break;
				}

				if(!TConvcarobjPtr)
				{
				(TConvcarobjPtr= new TConvcarobj(this))->Create();
				}
				else
				{
				TConvcarobjPtr->SetFocus();
				TConvcarobjPtr->SetActiveWindow();
				}

				break;
	} // switch
	if(c!='4') SetActiveWindow();
}

void
TConvcarac::ShowCarvis(TWindow* parent,int modecar)
{
char titre[80];

	switch(modecar)
	{
	case 0 : strcpy(titre,"CARACTERISTIQUES DES OBJETS");break;
	case 1 : strcpy(titre,"CARACTERISTIQUES D'UN OBJET");break;
	case 2 : strcpy(titre,"FFT DU CONTOUR EXTERIEUR D'UN OBJET");break;
	}

	if(!TCarvisPtr) (TCarvisPtr = new TCarvis(parent,titre,modecar))->Create();
	else
	{
	 TCarvisPtr->SetCaption(titre);
	 TCarvisPtr->modecar=modecar;
	 TCarvisPtr->Invalidate();       // Pour forcer l'affichage
	}
}

//----------------------------------------------------------------------------
//						Programme TCarvis
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TCarvis, TFramePrint)
	EV_WM_SIZE,
	EV_WM_MOUSEMOVE,

  END_RESPONSE_TABLE;

TCarvis::TCarvis(TWindow* parent, char far titre[],int mode)
  : TFramePrint(parent,titre)
{
		modecar=mode;
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376;
		Attr.H = 256+27;
		Scroller = new TScroller(this, 5, 5, 640/5, 1000);  // 640/5, 480/5
		Scroller->SetSBarRange();
}

TCarvis::~TCarvis()
{
	TCarvisPtr=0;
}

void TCarvis::EvMouseMove(UINT, TPoint& )
{
}

void TCarvis::EvSize(UINT sizeType, TSize& size)
{
	TFrameWindow::EvSize(sizeType, size);
	ShowScrollBar(SB_HORZ);
	ShowScrollBar(SB_VERT);
	Scroller->SetSBarRange();
}

void TCarvis::Paint(TDC& dc, BOOL, TRect&)
{
int i,b;
char string[80];
int pasx,pasy,px0,py0,px1,px2,px3;

	switch(modecar)
	{
	case 0:             // Caractristiques  des objets

	pasx=71;pasy=16;px0=10;py0=100;

	if(dep!=0) dc.TextOut(px0,0,"Nb d'tiquettes > 255 !!!");

	dc.TextOut(px0,20,"Nombre d'objets  = ");
	dc.TextOut(px0,40,"Nombre de trous  = ");

	itoa(nbobj,string,10);
	dc.TextOut(px0+2*pasx,20,string);
	itoa(totaltrous,string,10);
	dc.TextOut(px0+2*pasx,40,string);

	dc.TextOut(px0,70,"OBJET");
	dc.TextOut(px0+pasx,70,"SURF");
	dc.TextOut(px0+2*pasx,70,"NBTROU");
	dc.TextOut(px0+3*pasx,70,"XCG");
	dc.TextOut(px0+4*pasx,70,"YCG");
	dc.TextOut(px0+5*pasx,70,"Xmin");
	dc.TextOut(px0+6*pasx,70,"Xmax");
	dc.TextOut(px0+7*pasx,70,"Ymin");
	dc.TextOut(px0+8*pasx,70,"Ymax");

	for(b=0,i=1;i<nbobj+1;i++,b++)
		{
		itoa(i,string,10);
		dc.TextOut(px0,py0+pasy*b,string);
		ultoa(tabsur[i],string,10);
		dc.TextOut(px0+pasx,py0+pasy*b,string);
		itoa(tabtrous[i],string,10);
		dc.TextOut(px0+2*pasx,py0+pasy*b,string);
		ultoa(tabcgx[i],string,10);
		dc.TextOut(px0+3*pasx,py0+pasy*b,string);
		ultoa(tabcgy[i],string,10);
		dc.TextOut(px0+4*pasx,py0+pasy*b,string);
		itoa((unsigned int)tabxmi[i],string,10);
		dc.TextOut(px0+5*pasx,py0+pasy*b,string);
		itoa((unsigned int)tabxma[i],string,10);
		dc.TextOut(px0+6*pasx,py0+pasy*b,string);
		itoa((unsigned int)tabymi[i],string,10);
		dc.TextOut(px0+7*pasx,py0+pasy*b,string);
		itoa((unsigned int)tabyma[i],string,10);
		dc.TextOut(px0+8*pasx,py0+pasy*b,string);
		}

	break;

	case 1:             // Caractristiques  d'un objet

			pasy=20;px0=10;py0=10;
			px1=150;px2=340;px3=480;

			dc.TextOut(px0,py0,"OBJET N : ");
			dc.TextOut(px0,py0+2*pasy,"NB DE TROUS :");
			dc.TextOut(px0,py0+3*pasy,"SURFACE : ");
			dc.TextOut(px0,py0+4*pasy,"XCG :");
			dc.TextOut(px0,py0+5*pasy,"YCG :");
			dc.TextOut(px0,py0+6*pasy,"XMIN :");
			dc.TextOut(px0,py0+7*pasy,"XMAX :");
			dc.TextOut(px0,py0+8*pasy,"YMIN :");
			dc.TextOut(px0,py0+9*pasy,"YMAX :");
			dc.TextOut(px0,py0+10*pasy,"PERIMETRE :");
			dc.TextOut(px0,py0+11*pasy,"COMPACITE :");
			dc.TextOut(px0,py0+12*pasy,"MOMENT (1,1) :");
			dc.TextOut(px0,py0+13*pasy,"MOMENT (2,0) :");
			dc.TextOut(px0,py0+14*pasy,"MOMENT (0,2) :");
			dc.TextOut(px0,py0+15*pasy,"ORIENTATION :");
			dc.TextOut(px0,py0+16*pasy,"LONGUEUR :");
			dc.TextOut(px0,py0+17*pasy,"LARGEUR :");

			itoa(eti,string,10);
			dc.TextOut(px1,py0,string);
			itoa(obj->nbtrous,string,10);
			dc.TextOut(px1,py0+2*pasy,string);
			ultoa(obj->sur,string,10);
			dc.TextOut(px1,py0+3*pasy,string);
			ultoa(obj->cgx,string,10);
			dc.TextOut(px1,py0+4*pasy,string);
			ultoa(obj->cgy,string,10);
			dc.TextOut(px1,py0+5*pasy,string);
			itoa(obj->xmin,string,10);
			dc.TextOut(px1,py0+6*pasy,string);
			itoa(obj->xmax,string,10);
			dc.TextOut(px1,py0+7*pasy,string);
			itoa(obj->ymin,string,10);
			dc.TextOut(px1,py0+8*pasy,string);
			itoa(obj->ymax,string,10);
			dc.TextOut(px1,py0+9*pasy,string);
			gcvt((double)obj->per,6,string);
			dc.TextOut(px1,py0+10*pasy,string);
			gcvt((double)obj->compac,6,string);
			dc.TextOut(px1,py0+11*pasy,string);
			ltoa(obj->mu11,string,10);
			dc.TextOut(px1,py0+12*pasy,string);
			ltoa(obj->mu20,string,10);
			dc.TextOut(px1,py0+13*pasy,string);
			ltoa(obj->mu02,string,10);
			dc.TextOut(px1,py0+14*pasy,string);
			gcvt((double)obj->orien,6,string);
			dc.TextOut(px1,py0+15*pasy,string);
			itoa(obj->longueur,string,10);
			dc.TextOut(px1,py0+16*pasy,string);
			itoa(obj->largeur,string,10);
			dc.TextOut(px1,py0+17*pasy,string);

													// Enveloppe convexe
			dc.TextOut(px2,py0,"PARAMETRES ENVELOPPE CONVEXE");
			dc.TextOut(px2,py0+3*pasy,"SURFACE : ");
			dc.TextOut(px2,py0+4*pasy,"XCG :");
			dc.TextOut(px2,py0+5*pasy,"YCG :");
			dc.TextOut(px2,py0+10*pasy,"PERIMETRE :");
			dc.TextOut(px2,py0+11*pasy,"COMPACITE :");
			dc.TextOut(px2,py0+12*pasy,"TAUX CONCAV. :");

			ultoa(ec->sur,string,10);
			dc.TextOut(px3,py0+3*pasy,string);
			ultoa(ec->cgx,string,10);
			dc.TextOut(px3,py0+4*pasy,string);
			ultoa(ec->cgy,string,10);
			dc.TextOut(px3,py0+5*pasy,string);
			gcvt((double)ec->per,6,string);
			dc.TextOut(px3,py0+10*pasy,string);
			gcvt((double)ec->compac,6,string);
			dc.TextOut(px3,py0+11*pasy,string);
			gcvt((double)ec->t_concav,6,string);
			dc.TextOut(px3,py0+12*pasy,string);

	break;

	case 2:             // Visu FFT

float fex,fey;
unsigned int j,min=0XFFFF,max=0;
unsigned int taille;
int posx0=10,posy0=10;           // dcalage du diagramme
int maxi_x=512,maxi_y=200;      	// Etendue des axes

	taille=Nb_interp;

// axes des abscisses et des ordonnes

	dc.MoveTo(posx0,posy0+maxi_y);     // axe des ordonnes
	dc.LineTo(posx0,posy0);
	dc.MoveTo(posx0,posy0+maxi_y);     // axe des abscisses
	dc.LineTo(posx0+maxi_x+10,posy0+maxi_y);

	// recherche du minimum et du maximum de la courbe

	for (j=0;j<taille;j++)
	{
		if (sort[j]>max) max=sort[j];
		if (sort[j]<min) min=sort[j];
	}

	fex=(float)maxi_x/(float)taille;          //512
	fey=(float)maxi_y/(float)sqrt(max);       //400

	ultoa(max,string,10);
	dc.TextOut(posx0+40,posy0,string);

	dc.TextOut(posx0,posy0+maxi_y+10,"0");
	// Max en abscisse

	itoa((int) taille,string,10);
	dc.TextOut(posx0+maxi_x,posy0+maxi_y+10,string);

	// Trac de la courbe en chelle puissance 1/2

	for(j=0;j<taille;j++)
	{
	dc.MoveTo(posx0+(j*fex),posy0+maxi_y-fey*sqrt(sort[j]));
	dc.LineTo(posx0+(j*fex),posy0+maxi_y);
	dc.LineTo(posx0+(j*fex),posy0+maxi_y+1);
	}

	 break;

	}//switch
}

//----------------------------------------------------------------------------

