/**********************************************************************/
/*                       W C O M C O N V . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995  07/02/96                           */
/*    Dernire modif.: 06/10/1997                                     */
/**********************************************************************/

// Object Window

#include <stdio.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlcomp.h"

#include "wmain.h"
#include "wappbase.rh"
#include "wappbase.h"
#include "wcomconv.h"

											// Pointeurs sur les fentres
TChoixMenu* TChoixcompPtr = 0;     // Fentre comp
TConvcomp* TConvcompPtr = 0;     	// Fentre comp
TCompvis* TCompvisPtr=0;          // Fentre visu compression

int qualite=0;
char modcal='0';
long totbit;

//----------------------------------------------------------------------------
//						Programme TConvcomp
//----------------------------------------------------------------------------

void Ev_Image_Convcomp(TPoint&,int);   // Proto

void Ev_Image_Convcomp(TPoint&,int etatsouris)    // une fonction
{
	if(!etatsouris) return;
	if(TConvcompPtr)
	{
	 TConvcompPtr->NouveauPoint();
	}
}

TConvcomp::TConvcomp(TWindow* parent)
		: TChoixMenu(parent,"SELECTION BLOC 8*8 : CLICK PLAN SOURCE",
"&0 BLOC\n&1 DCT\n&2 RCONST\n&3 COMPR\n&4 COEFF\n&5 CODES\n&6 STAT\n&7 MATRIX")
{
	if(TCompvisPtr) TCompvisPtr->ShutDownWindow();
	modefig=0;
	Ajoute_Fonction(Ev_Image_Convcomp,modefig,FEN8,this);
}

TConvcomp::~TConvcomp()
{
	Enleve_Fonction(this);
	TConvcompPtr=0;
}

void TConvcomp::NouveauPoint()
{
	if(TCompvisPtr)
	 TCompvisPtr->Invalidate();
	 else
   EvCommun('0');
}


void TConvcomp::EvCommun(char c)
{
int modecomp;

	modecomp=(int)(c-'0');
	if(!TCompvisPtr)
	{
	(TCompvisPtr= new TCompvis(this,"COMPRESSION PAR DCT",modecomp,TRUE))->Create();
	}
  else
	{
		TCompvisPtr->modecomp=modecomp;
		TCompvisPtr->Invalidate();       // Pour forcer l'affichage
	}
	SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TChoixcomp
//----------------------------------------------------------------------------

TChoixcomp::TChoixcomp(TWindow* parent)
		: TChoixMenu(parent,"COMPRESSION D'IMAGES PAR DCT",
	 "&0 TEST BLOC\n&1 COMPRESSION\n&2 QUALITE\n&3 MODE CALCUL\n&4 STATISTIQUE")
{
	Inicoeff();                        // initialisation de coeff
	Iniquant(qualite);                 // matrice de quantification
}

TChoixcomp::~TChoixcomp()
{
	TChoixcompPtr=0;
}

void TChoixcomp::EvCommun(char c)
{
char inputText[40]="";
char titre[40];
char string[80];
char s[10]=" )";
char c1;

	switch(c)
	{
		case '0':
				if(!TConvcompPtr)
					{
					(TConvcompPtr= new TConvcomp(this))->Create();
					}
					else
					{
					 TConvcompPtr->SetFocus();
					 TConvcompPtr->SetActiveWindow();
					}
				break;

		case '1':
					SetCursor(0,IDC_WAIT);   // Pour attendre !!!
					totbit=Compress(modcal,qualite);
					SetCursor(0,IDC_ARROW);
					Fenetre->Visim(this,1,destin);

				 break;

		case '2':
					itoa(qualite,inputText,10);
					if ((TInputDialog(this,"COMPRESSION PAR DCT",
								"Facteur de qualit (0 : standard <->20 : faible) ?",
								inputText,
								sizeof(inputText))).Execute() == IDOK)
					{
					sscanf(inputText,"%d",&qualite);
					if(qualite<0)  qualite=0;
					if(qualite>20) qualite=20;
					Iniquant(qualite);
					}
					break;

		case '3':
					strcpy(string,"MODE DE CALCUL (");
					if(modcal==1||modcal==2)
					s[0]=(char)modcal+'1';
					else
					s[0]=(char)modcal;
					strcat(string,s);
					AppelChoixDial(this,string,
					"&0->flottant\n&1->entier\n&2->test1\n&3->test2",&c1);
					switch(c1)
					{
					case'0':
					case'1':   modcal=(int)c1;
								break;

					case'2':
					case'3':  modcal=(int)(c1-'1');
								break;
					}
					break;

		case '4':
				strcpy(titre,"STATISTIQUE COMPRESSION PAR DCT");
				int modecomp=8;

				if(!TCompvisPtr)
				{
				(TCompvisPtr= new TCompvis(this,titre,modecomp,TRUE))->Create();
				}
				else
				{
				TCompvisPtr->SetCaption(titre);
				TCompvisPtr->modecomp=modecomp;
				TCompvisPtr->Invalidate();       // Pour forcer l'affichage
				}
					break;
	} //switch
	if(c!='0') SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TCompvis
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TCompvis, TFramePrint)
	EV_WM_SIZE,
	EV_WM_MOUSEMOVE,
  END_RESPONSE_TABLE;

TCompvis::TCompvis(TWindow* parent, char far titre[],int mode,BOOL affichinit)
  : TFramePrint(parent,titre)
{
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376;
		Attr.H = 256+27;
		Scroller = new TScroller(this, 5, 5, 640/5, 480/5);  // 640/5, 480/5
		Scroller->SetSBarRange();
		fConsistanceComp=affichinit;
		modecomp=mode;
}

TCompvis::~TCompvis()
{
	TCompvisPtr=0;
}

void TCompvis::EvMouseMove(UINT, TPoint& )
{
}

void TCompvis::EvSize(UINT sizeType, TSize& size)
{
	TFrameWindow::EvSize(sizeType, size);
	ShowScrollBar(SB_HORZ);
	ShowScrollBar(SB_VERT);
	Scroller->SetSBarRange();
}

void TCompvis::Paint(TDC& dc, BOOL, TRect&)
{
int i,j,x,y;
char string[33];
float imr[8][8],tcos[8][8];
long tcosint[8][8],coef[8][8],coefint[8][8],imrint[8][8];
int k;
event tabev[65];
char nbcod;
unsigned int nbit;
int pred;

	if (!fConsistanceComp) return;        // Pas d'affichage
	if(modecomp>=0&&modecomp<=7)
	{
											 // Position click souris
			x=posx;if(x<0)x=0;if(x>248)x=248;
			y=posy;if(y<0)y=0;if(y>248)y=248;

			itoa(x,string,10);
			dc.TextOut(0,0," X = ");
			dc.TextOut(40,0,string);
			itoa(y,string,10);
			dc.TextOut(78,0," Y = ");
			dc.TextOut(78+40,0,string);

			dc.TextOut(240,0,"BLOC IMAGE (8*8)");

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				im[i][j]=(float)*(source+(y<<8)+x+j+(i<<8))-128;
				imint[i][j]=(long)*(source+(y<<8)+x+j+(i<<8))-128;
				itoa((int)im[i][j]+128,string,10);
				dc.TextOut(j*78,15+i*15,string);
				}
			}

	switch(modecomp)
		{
		case 1:
			Fdct1(im,tcos,C,Base);
			Fdctint1(imint,tcosint,Cint,Baseint);

			dc.TextOut(220,150,"TRANSFORMEE (8*8) (FLOTTANT)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					gcvt((double)tcos[i][j],6,string);
					dc.TextOut(j*78,165+i*15,string);
					}
				}

			dc.TextOut(220,300,"TRANSFORMEE (8*8) (ENTIER)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					ltoa(tcosint[i][j],string,10);
					dc.TextOut(j*78,315+i*15,string);
					}
				}

			break;

		case 2:
			Fdct1(im,tcos,C,Base);
			Idct1(imr,tcos,C,Base);
			Fdctint1(imint,tcosint,Cint,Baseint);
			Idctint1(imrint,tcosint,Cint,Baseint);

			dc.TextOut(220,150,"BLOC RECONST. (8*8) (FLOTTANT)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					gcvt((double)imr[i][j]+128,6,string);
					dc.TextOut(j*78,165+i*15,string);
					}
				}

			dc.TextOut(220,300,"BLOC RECONST. (8*8) (ENTIER)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					ltoa(imrint[i][j]+128,string,10);
					dc.TextOut(j*78,315+i*15,string);
					}
				}

			break;

		case 3:
			Fdct1(im,tcos,C,Base);
			Quantif(coef,tcos,Q);
			Dequant(coef,tcos,Q);
			Idct1(imr,tcos,C,Base);
			Fdctint1(imint,tcosint,Cint,Baseint);
			Quantifint(coefint,tcosint,Q);
			Dequantint(coefint,tcosint,Q);
			Idctint1(imrint,tcosint,Cint,Baseint);

			dc.TextOut(220,150,"BLOC COMPRIME (8*8) (FLOTTANT)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					gcvt((double)imr[i][j]+128,6,string);
					dc.TextOut(j*78,165+i*15,string);
					}
				}

			dc.TextOut(220,300,"BLOC COMPRIME (8*8) (ENTIER)");

				for(i=0;i<8;i++)
				{
					for(j=0;j<8;j++)
					{
					ltoa(imrint[i][j]+128,string,10);
					dc.TextOut(j*78,315+i*15,string);
					}
				}

			break;

			case 4:
			Fdct1(im,tcos,C,Base);
			Fdctint1(imint,tcosint,Cint,Baseint);
			Quantif(coef,tcos,Q);
			Quantifint(coefint,tcosint,Q);

			dc.TextOut(220,150,"COEFFICIENTS (8*8) (FLOTTANT)");

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				ltoa(coef[i][j],string,10);
				dc.TextOut(j*78,165+i*15,string);
				}
			}

			dc.TextOut(220,300,"COEFFICIENTS (8*8) (ENTIER)");

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				ltoa(coefint[i][j],string,10);
				dc.TextOut(j*78,315+i*15,string);
				}
			}

			break;

		case 5:
			Fdct1(im,tcos,C,Base);
			Fdctint1(imint,tcosint,Cint,Baseint);
			Quantif(coef,tcos,Q);
			Quantifint(coefint,tcosint,Q);

			dc.TextOut(220,150,"CODES (RUN,LEVEL) (FLOTTANT)");
			pred=0;
			nbcod=Codzz(coef,tabev,&nbit,&pred);

			for(k=0,i=0,j=0;k<nbcod;k++)
			{
				itoa(tabev[k].run,string,10);
				dc.TextOut(j*39,165+i*15,string);
				j++;
				itoa(tabev[k].level,string,10);
				dc.TextOut(j*39,165+i*15,string);
				j++;
				if(j==16){j=0;i++;}
			}
			dc.TextOut(j*39,165+i*15,"EOB");

			dc.TextOut(220,385,"NB DE BITS DE CODE (FLOTTANT) =");
			itoa(nbit,string,10);
			dc.TextOut(480,385,string);
			dc.TextOut(220,400,"TAUX DE COMPRESSION (FLOTTANT) =");
			gcvt((double)(512./nbit),6,string);
			dc.TextOut(480,400,string);

			dc.TextOut(220,270,"CODES (RUN,LEVEL) (ENTIER)");
			pred=0;
			nbcod=Codzz(coefint,tabev,&nbit,&pred);

			for(k=0,i=0,j=0;k<nbcod;k++)
			{
				itoa(tabev[k].run,string,10);
				dc.TextOut(j*39,295+i*15,string);
				j++;
				itoa(tabev[k].level,string,10);
				dc.TextOut(j*39,295+i*15,string);
				j++;
				if(j==16){j=0;i++;}
			}
			dc.TextOut(j*39,295+i*15,"EOB");

			dc.TextOut(220,415,"NB DE BITS DE CODE (ENTIER) =");
			itoa(nbit,string,10);
			dc.TextOut(480,415,string);
			dc.TextOut(220,430,"TAUX DE COMPRESSION (ENTIER) =");
			gcvt((double)(512./nbit),6,string);
			dc.TextOut(480,430,string);

			break;

		case 6:
			switch(modcal)
			{
			case '0':
			Fdct1(im,tcos,C,Base);
			Quantif(coef,tcos,Q);
			Razstat();
			pred=0;
			Codzz(coef,tabev,&nbit,&pred);
			break;

			case '1':
			Fdctint1(imint,tcosint,Cint,Baseint);
			Quantifint(coefint,tcosint,Q);
			Razstat();
			pred=0;
			Codzz(coefint,tabev,&nbit,&pred);
			break;
			}
													// Affichage statistiques
			if(modcal=='0')	dc.TextOut(250,140,"STATISTIQUE (FLOTTANT)");
			else        dc.TextOut(250,140,"STATISTIQUE (ENTIER)");

			dc.TextOut(1,155,"CAT.(DC)");
			for(j=0;j<12;j++)
			{
			itoa(j,string,10);
			dc.TextOut(78+j*39,155,string);
			itoa(Statdc[j],string,10);
			dc.TextOut(78+j*39,170,string);
			}

			dc.TextOut(1,190,"RUN(AC)");

			for(i=0;i<16;i++)
			{
			for(j=0;j<11;j++)
			{
			itoa(Statac[i][j],string,10);
			dc.TextOut(78+j*39,210+i*14,string);
			}
			itoa(i,string,10);
			dc.TextOut(1,210+i*14,string);
			}

			break;

		case 7:

			dc.TextOut(250,150,"MATRICE DE BASE");

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				gcvt((double)Base[i][j],3,string);
				dc.TextOut(j*78,165+i*15,string);
				}
			}

			dc.TextOut(220,300,"MATRICE DE QUANTIFICATION");

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				ltoa(Q[i][j],string,10);
				dc.TextOut(j*78,315+i*15,string);
				}
			}

			break;
		} //switch
	}//if
	else
	{                                   // Affichage taux de compression

			switch(modcal)
			{
			case '0' :
			dc.TextOut(0,10,"NB DE BITS DE CODE (FLOTTANT) =");
			dc.TextOut(0,30,"TAUX DE COMPRESSION (FLOTTANT) =");
			break;

			case '1' :
			dc.TextOut(0,10,"NB DE BITS DE CODE (ENTIER) =");
			dc.TextOut(0,30,"TAUX DE COMPRESSION (ENTIER) =");
			break;
			}

			ltoa(totbit,string,10);
			dc.TextOut(260,10,string);
			if(totbit!=0)
			{
			gcvt((double)(512.*1024.)/((double)totbit),6,string);
			dc.TextOut(260,30,string);
			}
													// Affichage statistiques

			if(modcal=='0')	dc.TextOut(250,140,"STATISTIQUE (FLOTTANT)");
			else        dc.TextOut(250,140,"STATISTIQUE (ENTIER)");

			dc.TextOut(1,155,"CAT.(DC)");
			for(j=0;j<12;j++)
			{
			itoa(j,string,10);
			dc.TextOut(78+j*39,155,string);
			itoa(Statdc[j],string,10);
			dc.TextOut(78+j*39,170,string);
			}

			dc.TextOut(1,190,"RUN(AC)");

			for(i=0;i<16;i++)
			{
			for(j=0;j<11;j++)
			{
			itoa(Statac[i][j],string,10);
			dc.TextOut(78+j*39,210+i*14,string);
			}
			itoa(i,string,10);
			dc.TextOut(1,210+i*14,string);
			}
	}
}

//----------------------------------------------------------------------------

