/**********************************************************************/
/*                       W C O N V . C P P                            */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/

// Object Window

#include <stdio.h>                     // Dos

#include "wgttsi.h"                    // Librairies Image
#include "wlfilt.h"
#include "wlmodif.h"

#include "wsysutil.h"
#include "wappbase.rh"
#include "wmain.h"
#include "wappbase.h"
#include "wconv.h"

											// Pointeurs sur les fentres
TWindow*	TConvglisPtr=0;            // Fentre filt  moyen glis
TWindow* TConvfiltPtr = 0;       	// Fentre filt
TChoixMenu* TConvhistPtr = 0;       // Fentre modif histo
TChoixMenu* TConvcontoPtr = 0;      // Fentre contours
TChoixMenu* TConvcompassPtr = 0;    // Fentre compass
TChoixMenu* TConvplanbitPtr = 0;    // Fentre plan bit
TChoixMenu* TConvquantifPtr = 0;    // Fentre quantif
TChoixMenu* TConvresolPtr = 0;      // Fentre resol
TChoixMenu* TConvmorphoPtr = 0;     // Fentre morpho
TChoixMenu* TConvmedianPtr = 0;     // Fentre mdian

//----------------------------------------------------------------------------
//						Programme TConvmedian
//----------------------------------------------------------------------------

TConvmedian::TConvmedian(TWindow* parent)
		: TChoixMenu(parent,"FILTRAGES MEDIANS",
		"&0 -> 3*3\n&1 -> 3 hori.\n&2 -> 3 vert.")
{
}

TConvmedian::~TConvmedian()
{
	TConvmedianPtr=0;
}

void TConvmedian::EvCommun(char c)
{
	Median(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvmorpho
//----------------------------------------------------------------------------

TConvmorpho::TConvmorpho(TWindow* parent)
		: TChoixMenu(parent,"MORPHOLOGIQUES",
		"&0 EROSION\n&1 DILATATION\n&2 FERMETURE\n&3 OUVERTURE")
{
}

TConvmorpho::~TConvmorpho()
{
	TConvmorphoPtr=0;
}

void TConvmorpho::EvCommun(char c)
{
	Morpho(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvresol
//----------------------------------------------------------------------------

TConvresol::TConvresol(TWindow* parent)
		: TChoixMenu(parent,"RESOLUTION",
		"&0 -> 256*256\n&1 -> 128*128\n&2 -> 64*64\n&3 -> 32*32\n&4 -> 16*16")
{
}

TConvresol::~TConvresol()
{
	TConvresolPtr=0;
}

void TConvresol::EvCommun(char c)
{
	Testres(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvplanbit
//----------------------------------------------------------------------------
//char * TConvplanbit::AffichageBoutons ="&0\n&1\n&2\n&3\n&4\n&5\n&6\n&7";
TConvplanbit::TConvplanbit(TWindow* parent, char *titre, char *AffichageBoutons)
		: TChoixMenu(parent,titre,AffichageBoutons)
{
}

TConvplanbit::~TConvplanbit()
{
	TConvplanbitPtr=0;
}

void TConvplanbit::EvCommun(char c)
{
unsigned char msk;

	msk=1;
	msk<<=(c-'0');
	Planbit(msk);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvquantif
//----------------------------------------------------------------------------

TConvquantif::TConvquantif(TWindow* parent)
		: TChoixMenu(parent,"QUANTIFICATION",
"&0->1 bit\n&1->2 bits\n&2->3 bits\n&3->4 bits\n&4->5 bits\n&5->6 bits\n&6->7 bits\n&7->8 bits")
{
}

TConvquantif::~TConvquantif()
{
	TConvquantifPtr=0;
}

void TConvquantif::EvCommun(char c)
{
unsigned char msk;

	msk=0XFF;
	msk=msk<<('7'-c);
	Mask(msk);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvcompass
//----------------------------------------------------------------------------

TConvcompass::TConvcompass(TWindow* parent)
		: TChoixMenu(parent,"COMPASS",
"&0 -> N\n&1 -> S\n&2 -> E\n&3 -> W\n&4 -> S-E\n&5 -> N-W\n&6 -> S-W\n&7 -> N-E")
{
}

TConvcompass::~TConvcompass()
{
	TConvcompassPtr=0;
}

void TConvcompass::EvCommun(char c)
{
	Compass(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvconto
//----------------------------------------------------------------------------

TConvconto::TConvconto(TWindow* parent)
		: TChoixMenu(parent,"CONTOURS",
						"&0 ROBERTS\n&1 SOBEL\n&2 PREWITT\n&3 LAPLACIEN")
{
}

TConvconto::~TConvconto()
{
	TConvcontoPtr=0;
}

void TConvconto::EvCommun(char c)
{
	Contour(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvhist
//----------------------------------------------------------------------------

TConvhist::TConvhist(TWindow* parent)
		: TChoixMenu(parent,"MODIFICATIONS D'HISTOGRAMME",
		"&0 -> --\n&1 -> /\n&2 -> \\\n&3 -> \\/\n&4 -> /\\")
{
}

TConvhist::~TConvhist()
{
	TConvhistPtr=0;
}

void TConvhist::EvCommun(char c)
{
unsigned int tab0[256];

	Modhist(c,tab0,bufhist,bufrepa);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TConvfilt
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TConvfilt, TFrameWindow)

  EV_CHILD_NOTIFY_ALL_CODES(ID_A, EvA),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+1, EvB),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+2, EvC),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+3, EvD),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+4, EvE),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+5, EvF),
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),
  EV_WM_MBUTTONDOWN,
  END_RESPONSE_TABLE;

TConvfilt::TConvfilt(TWindow* parent)
  : TFrameWindow(parent, "FILTRAGE CONVOLUTIONNEL 3*3")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		A0=0;A1=0;A2=0;
		A3=0;A4=1;A5=0;
		A6=0;A7=0;A8=0;

	PB0=new TRadioButton(this, ID_A, "PASSE-BAS 0", 10, 5, 150, 20, 0);
	PB1=new TRadioButton(this, ID_A+1, "PASSE-BAS 1", 10, 30, 150, 20, 0);
	PB2=new TRadioButton(this, ID_A+2, "PASSE-BAS 2", 10, 55, 150, 20, 0);
	PH0=new TRadioButton(this, ID_A+3, "PASSE-HAUT 0", 500, 5, 150, 20, 0);
	PH1=new TRadioButton(this, ID_A+4, "PASSE-HAUT 1", 500, 30, 150, 20, 0);
	PH2=new TRadioButton(this, ID_A+5, "PASSE-HAUT 2", 500, 55, 150, 20, 0);

	PB0->Uncheck();PB1->Uncheck();PB2->Uncheck();
	PH0->Uncheck();PH1->Uncheck();PH2->Uncheck();

	CA0=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25-50, 5, 50, 25, 5);
	CA1=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25, 5, 50, 25, 5);
	CA2=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320+25, 5, 50, 25, 5);
	CA3=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25-50, 30, 50, 25, 5);
	CA4=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25, 30, 50, 25, 5);
	CA5=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320+25, 30, 50, 25, 5);
	CA6=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25-50, 55, 50, 25, 5);
	CA7=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320-25, 55, 50, 25, 5);
	CA8=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320+25, 55, 50, 25, 5);
	commande=0;
}

TConvfilt::~TConvfilt()
{
	TConvfiltPtr=0;
}

void
TConvfilt::SetupWindow()
{
  TFrameWindow::SetupWindow();
  AfficheCoeff();
}

void TConvfilt::EvA(UINT)
{
	commande='0';
	EvCommun(commande);
}

void TConvfilt::EvB(UINT)
{
	commande='1';
	EvCommun(commande);
}

void TConvfilt::EvC(UINT)
{
	commande='2';
	EvCommun(commande);
}

void TConvfilt::EvD(UINT)
{
	commande='3';
	EvCommun(commande);
}

void TConvfilt::EvE(UINT)
{
	commande='4';
	EvCommun(commande);
}

void TConvfilt::EvF(UINT)
{
	commande='5';
	EvCommun(commande);
}

void TConvfilt::EvMButtonDown(UINT, TPoint &)
{
	commande='6';
	EvCommun(commande);
}

void TConvfilt::EvExec(UINT)
{
	EvCommun(commande);
}

void TConvfilt::EvCommun(char c)
{
  char string[12];

	switch(c)
	{
	case '0':				// PASSE-BAS

	A0=1;	A1=1;	  A2=1;
	A3=1;	A4=1;	  A5=1;
	A6=1;	A7=1;	  A8=1;

	break;

	case '1':

	A0=1;	A1=1;	  A2=1;
	A3=1;	A4=2;	  A5=1;
	A6=1;	A7=1;	  A8=1;

	break;

	case '2':

	A0=1;	A1=2;	  A2=1;
	A3=2;	A4=4;	  A5=2;
	A6=1;	A7=2;	  A8=1;

	break;

	case '3':    				// PASSE HAUT

	A0=0;	A1=-1; A2=0;
	A3=-1;A4=5;	 A5=-1;
	A6=0;	A7=-1; A8=0;

	break;

	case '4':

	A0=-1;	A1=-1;  A2=-1;
	A3=-1;	A4=9;	  A5=-1;
	A6=-1;	A7=-1;  A8=-1;

	break;

	case '5':

	A0=1;	A1=-2;   A2=1;
	A3=-2; A4=5;   A5=-2;
	A6=1;	A7=-2;   A8=1;

	break;

	case '6':
				PB0->Uncheck();PB1->Uncheck();PB2->Uncheck();
				PH0->Uncheck();PH1->Uncheck();PH2->Uncheck();

	CA0->GetText(string,sizeof(string));
	A0=atoi(string);
	if(A0<-128) A0=-128;else if(A0>127) A0=127;
	CA1->GetText(string,sizeof(string));
	A1=atoi(string);
	if(A1<-128) A1=-128;else if(A1>127) A1=127;
	CA2->GetText(string,sizeof(string));
	A2=atoi(string);
	if(A2<-128) A2=-128;else if(A2>127) A2=127;
	CA3->GetText(string,sizeof(string));
	A3=atoi(string);
	if(A3<-128) A3=-128;else if(A3>127) A3=127;
	CA4->GetText(string,sizeof(string));
	A4=atoi(string);
	if(A4<-128) A4=-128;else if(A4>127) A4=127;
	CA5->GetText(string,sizeof(string));
	A5=atoi(string);
	if(A5<-128) A5=-128;else if(A5>127) A5=127;
	CA6->GetText(string,sizeof(string));
	A6=atoi(string);
	if(A6<-128) A6=-128;else if(A6>127) A6=127;
	CA7->GetText(string,sizeof(string));
	A7=atoi(string);
	if(A7<-128) A7=-128;else if(A7>127) A7=127;
	CA8->GetText(string,sizeof(string));
	A8=atoi(string);
	if(A8<-128) A8=-128;else if(A8>127) A8=127;
	break;
	} //switch

	AfficheCoeff();
	Convol('m',&(char)A0,&(char)A1,&(char)A2,&(char)A3,&(char)A4,
	&(char)A5,&(char)A6,&(char)A7,&(char)A8);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

void TConvfilt::AfficheCoeff(void)
{
  char string[12];

	 itoa(A0,string,10);
	 CA0->SetText(string);
	 itoa(A1,string,10);
	 CA1->SetText(string);
	 itoa(A2,string,10);
	 CA2->SetText(string);
	 itoa(A3,string,10);
	 CA3->SetText(string);
	 itoa(A4,string,10);
	 CA4->SetText(string);
	 itoa(A5,string,10);
	 CA5->SetText(string);
	 itoa(A6,string,10);
	 CA6->SetText(string);
	 itoa(A7,string,10);
	 CA7->SetText(string);
	 itoa(A8,string,10);
	 CA8->SetText(string);
}

//----------------------------------------------------------------------------
//						Programme TConvglis
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TConvglis, TFrameWindow)

  EV_WM_MBUTTONDOWN,
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),
  END_RESPONSE_TABLE;

TConvglis::TConvglis(TWindow* parent)
  : TFrameWindow(parent,"FILTRAGE MOYENNEUR GLISSANT")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		ordrel=1;
		ordrec=1;

		new TStatic(this, ID_STATIC, " Ordre Ligne :", 150, 8, 150, 25, 0);
		new TStatic(this, ID_STATIC, " Ordre Colonne :", 150, 33, 150, 25, 0);
		Lig=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 320-25, 5, 50, 25, 5);
		Col=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 320-25, 30, 50, 25, 5);
}

TConvglis::~TConvglis()
{
	TConvglisPtr=0;
}

void
TConvglis::SetupWindow()
{
  TFrameWindow::SetupWindow();
  AfficheCoeff();
}

void TConvglis::EvExec(UINT)
{
	EvMButtonDown(0,TPoint(0,0));
}

void TConvglis::EvMButtonDown(UINT, TPoint &)
{
  char string[12];

	Lig->GetText(string,sizeof(string));
	ordrel=atoi(string);
	Col->GetText(string,sizeof(string));
	ordrec=atoi(string);
	if(ordrel<1) ordrel=1;else if(ordrel>20) ordrel=20;
	if(ordrec<1) ordrec=1;else if(ordrec>20) ordrec=20;
	AfficheCoeff();
	Moyenneur_glissant(ordrel,ordrec);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

void TConvglis::AfficheCoeff(void)
  {
  char string[12];

	 itoa(ordrel,string,10);
	 Lig->SetText(string);
	 itoa(ordrec,string,10);
	 Col->SetText(string);
}

//----------------------------------------------------------------------------

