/**********************************************************************/
/*                       W G T T S I . C P P                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC	                  			      	       */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 02/01/1998                                     */
/**********************************************************************/

#include <dos.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <alloc.h>
#include <math.h>
#include <sys\stat.h>
#include <fcntl.h>

#include "wgttsi.h"

/*----------------------------------------------*/
/*			  						   						*/
/*		Variables du programme          	  			 */
/*									   						*/
/*----------------------------------------------*/

int piax=0X300;		/* Adresse PIA          */
int piay=0X302;
int piaze=0X304;
int piazs=0X306;

/*----------------------------------------------*/
/*									   						*/
/*		Structures du programme  		       	   */
/*									   						*/
/*----------------------------------------------*/

typedef struct                                   	/* Entte BMP */
	{	unsigned int bfType;
		unsigned long bfSize;
		unsigned int bfReserved1;
		unsigned int bfReserved2;
		unsigned long bfOffBits;
	} FILEHEADER;

typedef struct                                   	/* Entte BMP */
	{ 	unsigned long biSize;
		unsigned long biWidth;
		unsigned long biHeight;
		unsigned int biPlanes;
		unsigned int biBitCount;
		unsigned long biCompression;
		unsigned long biSizeImage;
		unsigned long biXpelsPerMeter;
		unsigned long biYpelsPerMeter;
		unsigned long biClrUsed;
		unsigned long biClrImportant;
	}  INFOHEADER;

/*----------------------------------------------*/
/*									   					   */
/*									  							*/
/*----------------------------------------------*/

int modseq=0;          // Squences
int presacq;           // Pour test acquisition

int modvis=0;		     //  mode de visualisation   // non utilis
int modcoul=0;  	     //  N-B ou couleur
int modsor=0;          //  !!! Non utilis !!!
int visnb=1;           //  visu NB
int parite=0;  		  //  parit acquisition par dfaut : impaire
int voiecam=0;		     //  numro voie camra
int nbint=0;        	  //  nombre d'intgrations
int camcoul=0;         //  prsence camra couleur  // non utilis
int connex=0;    	     //  type de connexit
int nbplan;            // nb. de plans allous */
int plan;		     	  //  plan courant
int planvis=0;               //  plan visualis
int plantrav=0;              //  plan accd en visu
unsigned long timage=65536L;     // taille image
unsigned int timage_2=0X8000;		// taille 1/2 image

float moy_image;          /* statistique des images 	     */
float ec_type_image;
float entropie_image;
int min_image;
int max_image;
													  // Pour stat
float cov[8][8];
unsigned int bufhist[256],bufrepa[256];
													  // Pour geom
int xcent=128,ycent=128;
float angle=0,grandx=1.0,grandy=1.0;
char typeinter='1';

unsigned char *image0;          /* zone image0 */
unsigned char *image1;          /* zone image1 */
unsigned char *image2;          /* zone image2 */
unsigned char *image3;          /* zone image3 */
unsigned char *image4;          /* zone image4 */
unsigned char *image5;          /* zone image5 */
unsigned char *image6;          /* zone image6 */
unsigned char *image7;          /* zone image7 */

unsigned char *source;          /* pointeur source */
unsigned char *destin;          /* pointeur destination */

struct ftime ft,tc;            // date & heure

/*----------------------------------------------*/
/*									   						*/
/*  	     Fonctions prototypes			   		*/
/*									  							*/
/*----------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :               I N I C A R T E                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Initialisation du VSC de la carte VISU et de la carte PIA   */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Inicarte(void)

{
  Inipia();
  Inivsc();
}

/*-------------------------------------------------------------------------*/
/*  Fonction :               I N I P I A 	                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Initialisation de la carte PIA   						*/
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Inipia(void)
{
	outportb(piax+1,0);
	outportb(piay+1,0);
	outportb(piaze+1,0);
	outportb(piazs+1,0);
	outportb(piax,255);
	outportb(piay,255);
	outportb(piaze,0);
	outportb(piazs,255);
	outportb(piax+1,0X34);
	outportb(piay+1,0X3C);
	outportb(piaze+1,0X3C);
	outportb(piazs+1,0X2C);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :               I N I V S C	                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Initialisation du VSC de la carte VISU					*/
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Inivsc(void)
{
int tabini[36],i;

	tabini[0]=18;			tabini[1]=0;
	tabini[2]=34+40;		tabini[3]=0;
	tabini[4]=34+40+128;	tabini[5]=0;
	tabini[6]=240-1;    	tabini[7]=0;
	tabini[8]=2;        	tabini[9]=0;
	tabini[10]=36;      	tabini[11]=0;
	tabini[12]=36;      	tabini[13]=1;
	tabini[14]=56;      	tabini[15]=1;
	tabini[16]=4;       	tabini[17]=0;
	tabini[18]=0;       	tabini[19]=0;
	tabini[20]=0;       	tabini[21]=0;
	tabini[22]=0;       	tabini[23]=0;
	tabini[24]=0;       	tabini[25]=32;
	tabini[26]=0;       	tabini[27]=0;
	tabini[28]=16;      	tabini[29]=0;
	tabini[30]=0;       	tabini[31]=0;
	tabini[32]=0;       	tabini[33]=0;
	tabini[34]=0;       	tabini[35]=0;

	outportb(piax+1,0X34);	/* accs registres */

	for(i=0;i<36;i++)
	{
	outportb(piax,i<<1);
	outportb(piazs,tabini[i]);
	}

	outportb(piax,255);
	outportb(piazs,0);	/* Raz PAN */
	Regplan();
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                  R E G P L A N                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert registres carte visu                              */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Regplan(void)

{
	outportb(piax+1,0X34);		/* accs registres */
	outportb(piax,0XDF);     	/* accs registre de plan */
	outportb(piazs,plantrav|(planvis<<2)|(visnb<<4));
	outportb(piax+1,0X3C); 		/* accs mmoire */
}
/*-------------------------------------------------------------------------*/
/*  Fonction :               I N I I M A G E                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Allocation des plans mmoire RAM pour recevoir les          */
/*             images   							                              */
/*  Paramtres en entre : Aucun											          	*/
/*  Valeur retourne : 0 OK 1 erreur                                       */
/*  Rem : si l'allocation est impossible on sort par la procdure d'erreur */
/*-------------------------------------------------------------------------*/

int far Iniimage(int nbplan2)
{
if(nbplan2==8)
{
	image7=(unsigned char*) farmalloc(timage);if(image7==NULL) return(1);
	image6=(unsigned char*) farmalloc(timage);if(image6==NULL) return(1);
	image5=(unsigned char*) farmalloc(timage);if(image5==NULL) return(1);
	image4=(unsigned char*) farmalloc(timage);if(image4==NULL) return(1);
	plan=7;
}
	image3=(unsigned char*) farmalloc(timage);if(image3==NULL) return(1);
	image2=(unsigned char*) farmalloc(timage);if(image2==NULL) return(1);
	image1=(unsigned char*) farmalloc(timage);if(image1==NULL) return(1);
	image0=(unsigned char*) farmalloc(timage);if(image0==NULL) return(1);

if(nbplan2==4)
{
	image7=image3;
	image6=image2;
	image5=image1;
	image4=image0;
	plan=3;
}
if (nbplan2==4 || nbplan2==8)
  {
  nbplan=nbplan2;
	return(0);
	}
else return 1;
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A C M N                                  */
/*-------------------------------------------------------------------------*/
/*  Fonction : Acquisition d'images par PIA                                */
/*  Paramtres en entre : pointim : pointeur de l'image recevant          */
/*                                   l'acquisition                         */
/*  Valeur retourne : 0 ->OK, 1 -> pas de carte, 2 -> arrt               */
/*-------------------------------------------------------------------------*/

int far Acmn(unsigned char far *pointim)

{
int a,x,y,motacq,par;

	if(Atim()!=0)          // Si carte prsente
	{
	if(pointim==image3||pointim==image7) {plantrav=3;planvis=3;motacq=3;}
	else
	if(pointim==image1||pointim==image5) {plantrav=1;planvis=1;motacq=1;}
	else
	if(pointim==image2||pointim==image6) {plantrav=2;planvis=2;motacq=2;}
	else		     	{plantrav=0;planvis=0;motacq=0;}

	Regplan();

	if(modcoul==0) {motacq=voiecam;par=parite;} else par=0;
	outportb(piazs,motacq|(nbint<<2)|(par<<5));

	if(nbint==0)
	{                                  	/* commande relais */
	outportb(piaze+1,0X34);
	outportb(piaze+1,0X3C);
	}

	inportb(piaze);
	outportb(piay+1,0X34);                  /* Dclenchement acq. */

	for(y=0;y<256;y++)
	{  outportb(piay,y);
		for(x=0;x<256;x++)
		{
		outportb(piax,x);
		do
		{
		}
		while(inportb(piaze+1)<128);
		a=inportb(piaze);
		outportb(piazs,a);
		*pointim++=a;
		}
	}

	outportb(piay+1,0X3C);                  /* Arrt acq. */

	if(nbint!=0)
	{                              		/* commande relais */
	outportb(piaze+1,0X34);
	outportb(piaze+1,0X3C);
	}
	return(0);
	}
	else return(1);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A C Q U I                                */
/*-------------------------------------------------------------------------*/
/*  Fonction : Acquisition d'images par PIA selon modcoul                  */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : celle de Acmn(), 										      */
/*-------------------------------------------------------------------------*/

int far Acqui(void)

{
int i;

	if(modcoul==0)
	{
	visnb=1;return(Acmn(destin));
	}
	else
	{
	visnb=0;
	i=Acmn(image3);if(i!=0) return(i);      // vert
	i=Acmn(image1);if(i!=0) return(i);      // bleu
	i=Acmn(image2);return(i);     	   	// rouge
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                  A T I M                                    */
/*-------------------------------------------------------------------------*/
/*  Fonction : Synchro trame                                               */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : 0 pas de carte ; 1 carte prsente                   */
/*-------------------------------------------------------------------------*/

int far Atim(void)

{
	return(1);
}
/*-------------------------------------------------------------------------*/
/*  Fonction :               T R A N S F E R T                             */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert du buffer image vers l'extrieur par la carte PIA */
/*  Paramtres en entre : image = pointeur sur le buffer image            */
/*                                  transfrer                            */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Transfert(unsigned char far *image)

{
unsigned char far *pointim;
int x,y;

	//if(Atim()!=0)          // Si carte prsente
	{
	pointim=image;visnb=1;
	if(pointim==image3||pointim==image7) plantrav=3;
	else
	if(pointim==image2||pointim==image6) plantrav=2;
	else
	if(pointim==image1||pointim==image5) plantrav=1;
	else
	plantrav=0;

	Regplan();

		for(y=0;y<256;y++)
		{
		outportb(piay,y);
		for(x=0;x<256;x++)
			{
			outportb(piax,x);
			outportb(piazs,*pointim++);
			}
		}
	pointim=image;

	if(pointim==image3||pointim==image7) planvis=3;
	else
	if(pointim==image1||pointim==image5) planvis=1;
	else
	if(pointim==image2||pointim==image6) planvis=2;
	else
	planvis=0;

	Atim();
	Regplan();
	}
	//else	Affimvga(image);

}
/*-------------------------------------------------------------------------*/
/*  Fonction :                    E F F                                    */
/*-------------------------------------------------------------------------*/
/*  Fonction : Effacement du buffer image                                  */
/*  Paramtres en entre : image = pointeur sur l'image  effacer          */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Eff(unsigned char far *image)

{
long far *p;
register unsigned int i=16384;    /* 65536/4 */

	p=(long far *)image;

	do
	{
	*p++=0;
	}
	while(--i);

}
/*-------------------------------------------------------------------------*/
/*  Fonction :               M I R E X Y                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Ecriture d'une mire de gris suivant X ou Y dans le buffer   */
/*             image							   */
/*  Paramtres en entre : image = pointeur sur le buffer                  */
/*                           c   = '0' mire suivant X                      */
/*                               = '1' mire suivant Y                      */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Mirexy(char c,unsigned char far *image)

{
unsigned char far *pointim;
int x,y;

	pointim=image;

	for(y=0;y<256;y++)
	{
		for(x=0;x<256;x++)
		{
		if(c=='0') *pointim++=x;else *pointim++=y;
		}
	}
}
/*-------------------------------------------------------------------------*/
/*  Fonction :                   H I S T O                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul et visualisation d'histogramme                       */
/*  Paramtres en entre : bufhist et bufrepa                              */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Histo(unsigned int bufhist[256],unsigned int bufrepa[256],
		unsigned char far *ptsource,unsigned char far *ptdestin)
{
	Calhist(bufhist,bufrepa,ptsource);
	Vishist(bufhist,bufrepa,ptdestin);
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                   C A L H I S T                             */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul d'histogramme du plan source                         */
/*  Paramtres en entre : bufhist,bufrepa,pointeur image                  */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Calhist(unsigned int bufhist[256],unsigned int bufrepa[256],
				unsigned char far *image)

{

unsigned int i,a,b;
int x;
unsigned char far *pointim;

	for(i=0;i<256;i++) bufhist[i]=0; 	/* eff. zone histo */

	pointim=image;
								/* construction histo */

	for(i=0;i<(unsigned int)65535L;i++) {a=*pointim++;bufhist[a]++;}

								/* const. f.rpartition */

	for(x=0,b=0;x<256;x++) {a=bufhist[x];b+=a;bufrepa[x]=b;}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   V I S H I S T                             */
/*-------------------------------------------------------------------------*/
/*  Fonction : Visualisation d'histogramme dans le plan destination        */
/*  Paramtres en entre : bufhist,bufrepa                                 */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Vishist(unsigned int bufhist[256],unsigned int bufrepa[256],
			unsigned char far *ptdestin)
{
unsigned int a,c;
double d;
int x,y;
unsigned char far *pointim;

	if(ptdestin==0) ptdestin=destin;

	Eff(ptdestin);

	for(x=0;x<256;x++) 	/* Visu hist. et rep. */
	{
	a=bufhist[x];
	d=sqrt((float)a);
	a=(unsigned int)d;

		for(y=255;y>=255-(int)a;y--)
		{
		pointim=ptdestin+((y<<8)+x);
		*pointim=127;
		}

	c=255-(bufrepa[x]>>8);
	pointim=ptdestin+((c<<8)+x);
	*pointim=255;
	}
}
/*-------------------------------------------------------------------------*/
/*  Fonction :                 S E U I L L A G E                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Seuillage d'une image source vers destin.                   */
/*  Paramtres en entre : seuil = seuil de dcision                       */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Seuillage(int seuil,unsigned char far *ptsource,
			unsigned char far *ptdestin)
{
unsigned int i=0;
unsigned char sgn,s;
unsigned char far *pointim1,*pointim;   	/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	if(seuil>=0) {s=seuil;sgn=0;} else {s=-seuil;sgn=255;}

	pointim=ptsource;
	pointim1=ptdestin;

		do
		{
		if((*pointim++)>=s)	*pointim1++=255-sgn;
		else 			*pointim1++=sgn;
		}
		while(++i);

}
/*-------------------------------------------------------------------------*/
/*  Fonction :               C A L P L A N S                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de l'image selon la variable plan		 	   */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Calplans(void)

{
	plan%=nbplan;
	switch(plan)
		{
		case 0:source=image0;destin=image1;break;
		case 1:source=image1;destin=image2;break;
		case 2:source=image2;destin=image3;break;
		case 3:source=image3;if(nbplan==4) destin=image0;
									else destin=image4;break;
		case 4:source=image4;destin=image5;break;
		case 5:source=image5;destin=image6;break;
		case 6:source=image6;destin=image7;break;
		case 7:source=image7;destin=image0;break;
		}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :               C A L S U I V                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Incrmentation de plan et calcul de l'image suivante        */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*  Info : Cette fonction fait appel  la procdure Calplan()              */
/*-------------------------------------------------------------------------*/

void far Calsuiv(void)

{
	plan++;
	Calplans();
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   C O P I E _ P L A N                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Copie d'un plan dans un autre					          */
/*  Paramtres en entre : source,destin			                    */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Copie_plan(unsigned char far *ptsource,unsigned char far *ptdestin)

{
unsigned char far *pointim1,*pointim2;
unsigned int i=0;

	pointim1=ptsource;
	pointim2=ptdestin;
	do
	{
	*pointim2++=*pointim1++;
	}
	while(++i);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                       W M N                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Ecriture sur disque d'une image                             */
/*  Paramtres en entre : image = pointeur sur le buffer image            */
/*                         nomfich = nom du fichier                        */
/*  Valeur retourne : 0 -> erreur ; 1 -> OK                               */
/*-------------------------------------------------------------------------*/

int far WMN(char nomfich[20],unsigned char far *image)

{
int handle;
unsigned char far *pointim;

	if((handle=creat(nomfich,S_IREAD|S_IWRITE))==-1) return(0);
	else
	{
		if(modcoul==0)
		{
			pointim=image;
			_rtl_write(handle,pointim,timage_2);
			pointim+=timage_2;
			_rtl_write(handle,pointim,timage_2);
		}
		else
		{
			pointim=image3;
			_rtl_write(handle,pointim,timage_2);
			pointim+=timage_2;
			_rtl_write(handle,pointim,timage_2);
			pointim=image2;
			_rtl_write(handle,pointim,timage_2);
			pointim+=timage_2;
			_rtl_write(handle,pointim,timage_2);
			pointim=image1;
			_rtl_write(handle,pointim,timage_2);
			pointim+=timage_2;
			_rtl_write(handle,pointim,timage_2);
		}
		_rtl_close(handle);
		return(1);
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                       R M N                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Lecture sur disque d'une image                              */
/*  Paramtres en entre : image = pointeur sur le buffer image            */
/*                         nomfich = nom du fichier                        */
/*  Valeur retourne : 0 -> erreur ; 1 -> OK                               */
/*-------------------------------------------------------------------------*/

int far RMN(char nomfich[20],unsigned char far *image)

{
int handle;
unsigned char far *pointim;
unsigned bytes;

	if(_dos_open(nomfich,O_RDWR,&handle)) return(0);
	else
	{
		if(modcoul==0)
		{
			pointim=image;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim+=timage_2;
			_dos_read(handle,pointim,timage_2,&bytes);
		}
		else
		{
			pointim=image3;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim+=timage_2;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim=image2;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim+=timage_2;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim=image1;
			_dos_read(handle,pointim,timage_2,&bytes);
			pointim+=timage_2;
			_dos_read(handle,pointim,timage_2,&bytes);
		}
		_dos_close(handle);
		return(1);
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    T R A N S C O U L                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert couleur                                           */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Transcoul(void)

{
int x,y;
unsigned char far *pointim3,*pointim1,*pointim2;	/* pointeurs image */

	if(Atim()!=0)    // Si carte prsente
	{
	pointim3=image3;pointim1=image1;pointim2=image2;
	planvis=3;visnb=0;

	for(y=0;y<256;y++)
	{
	outportb(piay,y);
	plantrav=1;
	Regplan();
		for(x=0;x<256;x++)
		{
		outportb(piax,x);
		outportb(piazs,*pointim1++);
		}
	outportb(piay,y);
	plantrav=2;
	Regplan();
		for(x=0;x<256;x++)
		{
		outportb(piax,x);
		outportb(piazs,*pointim2++);
		}
	outportb(piay,y);
	plantrav=3;
	Regplan();
		for(x=0;x<256;x++)
		{
		outportb(piax,x);
		outportb(piazs,*pointim3++);
		}
	}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    H I S C O U                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Histogramme couleur                                         */
/*  Paramtres en entre : c mode de reprsentation                        */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Hiscou(char c)

{
unsigned int x,y,a,offset,i=0,k;
unsigned char far *pointim0,*pointx,*pointy; /* pointeurs image */

	Eff(image0);

	if(c>='0'&&c<='2')
	{
	switch(c)
		{
		case '0' :
			pointy=image3;pointx=image1;break;   /* bleu vert */
		case '1' :
			pointy=image3;pointx=image2;break;   /* rouge vert */
		case '2' :
			pointy=image2;pointx=image1;break;   /* bleu rouge */
		}

			 do
			 {
				y=*pointy++;
				x=*pointx++;
				pointim0=image0+(y<<8)+x;
				a=*pointim0;a++;if(a>255) a=255;*pointim0=a;
			}
			while(++i);
	}

	if(c=='3')
	{
	for(k=0;k<3;k++)
		{
		switch(k)
		{
		case 0:pointy=image3;pointx=image1;offset=0;break;
		case 1:pointy=image3;pointx=image2;offset=128;break;
		case 2:pointy=image2;pointx=image1;offset=(unsigned int)0X8000;break;
		}
			 do
			 {
				y=*pointy++;
				x=*pointx++;
				y>>=1;x>>=1;
				pointim0=image0+(y<<8)+x+offset;
				a=*pointim0;a++;if(a>255) a=255;*pointim0=a;
			}
			while(++i);
		}
	  }
}

/*-------------------------------------------------------------------------*/
/*  Fonction :               E C R _ B M P				   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Ecriture sur disque d'une image au format BMP               */
/*  Paramtres en entre : image = pointeur sur le buffer image            */
/*                         nomfich = nom du fichier                        */
/*  Valeur retourne : 0 -> erreur ; 1 -> OK                               */
/*-------------------------------------------------------------------------*/

int far Ecr_bmp(char nomfich[20],unsigned char far *image)

{
FILEHEADER fileheader={
		      19778,0,0,0,0
			 };

INFOHEADER infoheader={
				40,256,256,1,8,0,0,0,0,0,0
			 };
FILE *outfile;
int x,y;
unsigned char far *pointim1,*pointim2,*pointim3,*pointim;
unsigned char buffer[768],lut[1024];

	if(modcoul==0)
	{
		fileheader.bfOffBits=54+1024;
		infoheader.biBitCount=8;
		infoheader.biClrUsed=256;
		infoheader.biClrImportant=256;
		for(x=0;x<1024;x+=4)
		{lut[x]=x>>2;lut[x+1]=x>>2;lut[x+2]=x>>2;lut[x+3]=0;}
	}
	else
	{
		fileheader.bfOffBits=54;
		infoheader.biBitCount=24;
		infoheader.biClrUsed=0;
		infoheader.biClrImportant=0;
	}
	infoheader.biSizeImage=(infoheader.biWidth*infoheader.biHeight)
				*infoheader.biBitCount/8;
	fileheader.bfSize=fileheader.bfOffBits+infoheader.biSizeImage;

	if((outfile=fopen(nomfich,"wb"))==NULL) {return(0);}
	fwrite(&fileheader,sizeof(FILEHEADER),1,outfile);
	fwrite(&infoheader,sizeof(INFOHEADER),1,outfile);
	if(modcoul==0)
	{
	fwrite(lut,sizeof(unsigned char),1024,outfile);
	for(y=255;y>=0;y--)
	{
	pointim=image+(y<<8);
	for(x=0;x<256;x++) buffer[x]=*pointim++;
	fwrite(buffer,sizeof(unsigned char),256,outfile);
	}
	}

	else
	{
	for(y=255;y>=0;y--)
	{
	pointim1=image1+(y<<8);
	pointim2=image2+(y<<8);
	pointim3=image3+(y<<8);
	for(x=0;x<768;)
		 {
		 buffer[x++]=*pointim1++;
		 buffer[x++]=*pointim3++;
		 buffer[x++]=*pointim2++;
		 }
	fwrite(buffer,sizeof(unsigned char),768,outfile);
	}
	}
	fclose(outfile);
	return(1);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 V A R I A N C E _ C O U R B E               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de la variance d'une courbe contenue dans x[i]	   */
/*  Paramtres en entre : buffer,taille	                           */
/*  Valeur retourne : variance                                            */
/*-------------------------------------------------------------------------*/

float far Variance_courbe(unsigned char *x,long taille)

{
long i;
float moyenne,Var,j,tampon=0;

	moyenne=Moyenne_courbe(&x[0],taille);
	for (i=0;i<taille;i++)
	{
		 j=x[(unsigned int)i]-moyenne;
		 tampon+=j*j;
	}
	Var=tampon/(float)taille;
	return(Var);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 M O Y E N N E _ C O U R B E                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de la moyenne d'une courbe contenue dans x[i]	   */
/*  Paramtres en entre : buffer,taille	                           */
/*  Valeur retourne : moyenne                                             */
/*-------------------------------------------------------------------------*/

float far Moyenne_courbe(unsigned char *x,long taille)

{
long i,tampon=0;
float moyenne;

	for(i=0;i<taille;i++) {tampon+=x[(unsigned int)i];}
	moyenne=(float)(tampon)/(float)(taille);
	return(moyenne);
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                    N E G A T I F                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Ngatif N/B ou couleur selon modcoul	                   */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Negatif(unsigned char far *ptsource,unsigned char far *ptdestin)

{
unsigned int r,v,b,i=0;
unsigned char far *pointim3,*pointim1,*pointim2;	/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	if(modcoul==0)
	{
	pointim1=ptsource;
	pointim2=ptdestin;

		do
		{
		b=*pointim1++;
		*pointim2++=255-b;
		}
		while(++i);
	}
	else
	{
	pointim3=image3;pointim1=image1;pointim2=image2;

		do
		{
		v=*pointim3;
		b=*pointim1;
		r=*pointim2;
		*pointim3++=255-v;
		*pointim1++=255-b;
		*pointim2++=255-r;
		}
		while(++i);
	}
}
/*-------------------------------------------------------------------------*/
/*  Fonction :                   R O T A T                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Rotation et zoom d'image                                    */
/*  Paramtres en entre : angle = angle de rotation                       */
/*                         xcent,ycent= centre de rotation	           */
/* 			   grandx,grandy = grandissements		   */
/*			   type = type d'interpolation			   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/
// Notation courte:   a         Cx        Cy           Gx           Gy
void far Rotat(float angle,int xcent,int ycent,float grandx,float grandy,
	char type,unsigned char far *ptsource,unsigned char far *ptdestin)

{
//  Nx=Ny=256 =N;
int u,v,u0=128,v0=128; // u0=Nx/2; v0=Ny/2;
long x,y,x0=128,y0=128,c0,s0,c1,s1;
float theta;
unsigned char far *pointim,*pointim1;   	/* pointeurs image */
unsigned char a,b,c,d;
unsigned int p,p1,p2,dx,dy;

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	x0=xcent; // Cx
	y0=ycent; // Cy
	theta=-3.14159*angle/180.0; // -a (rad)
	c0=(long)(256*cos((double)theta)/grandx); // = N/Gx cos(a)
	s0=(long)(256*sin((double)theta)/grandy); // = -N/Gy sin(a)
	c1=(long)(256*cos((double)theta)/grandy); // = N/Gy cos(a)
	s1=(long)(256*sin((double)theta)/grandx); // = -N/Gx sin(a)

	pointim=ptsource;
	pointim1=ptdestin;

	for(v=0;v<256;v++) // y'
	{
		for(u=0;u<256;u++) // x'
		{
		x=(u-u0)*c0+(v-v0)*s0;
		x+=(x0<<8);
		y=-(u-u0)*s1+(v-v0)*c1;
		y+=(y0<<8);

/*
 x= (x'-N/2)cos(a)/Gx + (y'-N/2)sin(-a)/Gy + Cx;
 y= (x'-N/2)sin(a)/Gx + (y'-N/2)cos( a)/Gy + Cy;

 Forme matricielle:
| x |  |ca  -sa| |1/Gx   0 |    |x'|      |Nx|      |Cx|
|   |= |       |*|         |* ( |  |- 1/2 |  | ) +  |  |
| y |  |sa   ca| | 0   1/Gy|    |y'|      |Ny|      |Cy|
*/
		if((x>=0)&&(x<65536L)&&(y>=0)&&(y<65536L))
		{
		dx=(unsigned int)(x&0XFF);dy=(unsigned int)(y&0XFF);
		x>>=8;y>>=8;
			switch(type)
			{
			case '0':
				{
				if(dx>=128){x++;if(x>255){*pointim1++=0;break;}}
				if(dy>=128){y++;if(y>255){*pointim1++=0;break;}}
				*pointim1++=*(pointim+(((unsigned int)y)<<8)+(unsigned int)x);
				break;
				}

				 case '1':
				{
				a=*(pointim+(((unsigned int)y)<<8)+(unsigned int)x);
				if(x<255)
				b=*(pointim+(((unsigned int)y)<<8)+(unsigned int)x+1);
				else{if(dx==0)b=a;else{*pointim1++=0;break;}}
				if(y<255)
				d=*(pointim+(((unsigned int)(y+1))<<8)+(unsigned int)x);
				else{if(dy==0)d=a;else{*pointim1++=0;break;}}
				if((x<255)&&(y<255))
				c=*(pointim+(((unsigned int)(y+1))<<8)+(unsigned int)x+1);
				else{if(dx==0&&dy==0)c=a;else{*pointim1++=0;break;}}
				p1=(255-dx)*a+dx*b;
				p1/=255;
				p2=(255-dx)*d+dx*c;
				p2/=255;
				p=(255-dy)*p1+dy*p2;
				p/=255;
				*pointim1++=(unsigned char)p;
				break;
				}
			}
		}
		else *pointim1++=0;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 D R O I T E                                 */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction d'une droite				   */
/*  Paramtres en entre : (x0, y0, x1, y1) = coordonnes des extrmits   */
/*                         pointim = pointeur sur image                    */
/*                         msk= masque pour calcul                         */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Droite(int x0,int y0,int x1,int y1,unsigned char far *pointim,
			int msk)

{
int x,y,xdeb,xfin,ydeb,yfin,sx,sy,dx,dy,e;

	if(x1-x0>=0) dx=x1-x0;else dx=x0-x1;
	if(y1-y0>=0) dy=y1-y0;else dy=y0-y1;

	if(dx>=dy)		/* selon x */
	{
	if(x1>=x0){xdeb=x0;xfin=x1;ydeb=y0;yfin=y1;}
	else		{xdeb=x1;xfin=x0;ydeb=y1;yfin=y0;}
	if(yfin>=ydeb) sy=1;else sy=-1;

	for(x=xdeb,y=ydeb,e=0;x!=xfin+1;x++,e+=dy)
		{
		if((e<<1)-dx>=0){y+=sy;e-=dx;}
		*(pointim+x+(y<<8))|=msk;
		}
	}
	else                    /* selon y */
	{
	if(y1>=y0){ydeb=y0;yfin=y1;xdeb=x0;xfin=x1;}
	else		{ydeb=y1;yfin=y0;xdeb=x1;xfin=x0;}
	if(xfin>=xdeb) sx=1;else sx=-1;

	for(x=xdeb,y=ydeb,e=0;y!=yfin+1;y++,e+=dx)
		{
		if((e<<1)-dy>=0){x+=sx;e-=dy;}
		*(pointim+x+(y<<8))|=msk;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    R E M P _ R E C T                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Remplissage du buffer image par une valeur                  */
/*  Paramtres en entre : xmin,xmax,ymin,ymax : cadre, z:valeur           */
/* 			   image = pointeur sur l'image 		   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Remp_rect(int xmin,int xmax,int ymin,int ymax,int z,unsigned char far *image)

{
unsigned char far *pointim;
int x,y;

	for(y=ymin;y<=ymax;y++)
	{
	pointim=image+(y<<8);
	for(x=xmin;x<=xmax;x++) {*(pointim+x)=z;}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    Z E R O _ R E C T                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Mise  0 d'un ou plusieurs plans de bit                     */
/*  Paramtres en entre : xmin,xmax,ymin,ymax : cadre, msk:masque de bit  */
/* 			   image = pointeur sur l'image 		   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Zero_rect(int xmin,int xmax,int ymin,int ymax,int msk,unsigned char far *image)
{
unsigned char far *pointim;
int x,y;

	msk=(~msk)&0XFF;
	for(y=ymin;y<=ymax;y++)
	{
	pointim=image+(y<<8);
	for(x=xmin;x<=xmax;x++) {*(pointim+x)&=msk;}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    U N _ R E C T                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Mise  1 d'un ou plusieurs plans de bit                     */
/*  Paramtres en entre : xmin,xmax,ymin,ymax : cadre, msk:masque de bit  */
/* 			   image = pointeur sur l'image 		   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Un_rect(int xmin,int xmax,int ymin,int ymax,int msk,unsigned char far *image)
{
unsigned char far *pointim;
int x,y;

	for(y=ymin;y<=ymax;y++)
	{
	pointim=image+(y<<8);
	for(x=xmin;x<=xmax;x++) {*(pointim+x)|=msk;}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 T R F E N                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfre une fentre dans le plan indiqu                  */
/*  Paramtres en entre :  xmin, xmax		        		   */
/*                          ymin, ymax					   */
/*                          msk= niveau de gris                            */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Trfen(int xmin,int xmax,int ymin,int ymax,int msk,
		unsigned char far *image)
{
int x, y;
unsigned char far *pointim,p;

	pointim=image+xmin+(ymin<<8);
	for(y=ymin;y<ymax+1;y++,pointim+=256)
	{
	p=*pointim;*pointim=(msk|p);
	if(xmax>xmin) {p=*(pointim+xmax-xmin);*(pointim+xmax-xmin)=(msk|p);}
	}

	pointim=image+xmin+(ymin<<8);
	for(x=xmin;x<xmax+1;x++,pointim++)
	{
	p=*pointim;*pointim=(msk|p);
	if(ymax>ymin) {p=*(pointim+((ymax-ymin)<<8));
			  *(pointim+((ymax-ymin)<<8))=(msk|p);}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 T R F R E T	                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert d'un rticule dans plan indiqu                   */
/*  Paramtres en entre : image = image de visu du rticule               */
/*                         xretic, yretic = position rticule              */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Trfret(unsigned char far *image,int xretic,int yretic)
{
unsigned char far *pointim;
int x,y,tabx[9],taby[9],i;

	Initabret(tabx,taby);
	x=xretic;y=yretic;
	for(i=0;i<9;i++)
	{
	x+=tabx[i];x&=0XFF;
	y+=taby[i];
	pointim=image+((y<<8)+x);
	if(*pointim>127) *pointim=0; else *pointim=255;
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 I N I T A B R E T                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Intialisation table rticule                                */
/*  Paramtres en entre : tables x e y pour rticule		               */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Initabret(int tabx[9],int taby[9])
{

	tabx[0]=0;taby[0]=-2;
	tabx[1]=0;taby[1]=1;
	tabx[2]=-2;taby[2]=1;
	tabx[3]=1;taby[3]=0;
	tabx[4]=1;taby[4]=0;
	tabx[5]=1;taby[5]=0;
	tabx[6]=1;taby[6]=0;
	tabx[7]=-2;taby[7]=1;
	tabx[8]=0;taby[8]=1;

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 S T A T _ I M A G E                         */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul des grandeurs stat. de l'image source		   */
/*  Paramtres en entre : aucun		                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Stat_image(unsigned char far *ptsource)
{
unsigned int bufhist[256],bufrepa[256];
int i;
float j,Ln2,tampon=0;

	if(ptsource==0) ptsource=source;

	Calhist(bufhist,bufrepa,ptsource);

	for(i=0;i<256;i++) {tampon+=(float)bufhist[i]*(float)i;}
	moy_image=((float)(tampon))/65535.0;

	tampon=0;
	for(i=0;i<256;i++)
		{
		j=(float)i-moy_image;
		tampon+=j*j*(float)bufhist[i];
		}
	tampon/=65535.0;
	ec_type_image=sqrt(tampon);

	tampon=0;
	Ln2=log(2.0);
	for(i=0;i<256;i++)
		{
		j=(float)bufhist[i];
		if(j!=0)
			{
			j/=65535.0;
			j=log((double)j)/Ln2;
			tampon+=(float)bufhist[i]*j;
			}
		}
	entropie_image=-((float)(tampon))/65535.0;

	Min_max(ptsource,&min_image,&max_image,65536L);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 M I N _ M A X                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul min et max d'une courbe contenu dans x[i]		   */
/*  Paramtres en entre : buffer,min,max,taille                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Min_max(unsigned char *x,int *min,int *max,long taille)

{
long i;

	*max=0;*min=0;
	for(i=1;i<taille;i++)
	{
		if (x[(unsigned int)i]>x[*max]) *max=(int)i;
		if (x[(unsigned int)i]<x[*min]) *min=(int)i;
	}
	*min=x[*min];*max=x[*max];
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   COOCCURENCE                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Matrice de cooccurence                                      */
/*  Paramtres en entre : dplacements en x et y                          */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Cooccurence(int depx,int depy,unsigned char far *ptsource,
unsigned char far *ptdestin)

{
int x,y;
unsigned int a,b,p;
unsigned char far *pointim,*pointim1;	/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	Eff(ptdestin);
	for(y=0;y<256-depy;y++)
	{
		 for(x=0;x<256-depx;x++)
		 {
			pointim=ptsource+x+(y<<8);
			a=*pointim;
			b=*(pointim+depx+(depy<<8));
			pointim1=ptdestin+(b<<8)+a;
			p=*pointim1;p++;if(p>255) p=255;*pointim1=p;
		}
	  }
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C O V A R I A N C E                         */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de la matrice de covariance d'une image              */
/*  Paramtres en entre : matrice 8*8, taille                             */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Covariance(float cov[8][8],int taille,unsigned char far *ptsource)

{
int x,y;
unsigned int a,b,i,j;
unsigned char far *pointim;	/* pointeurs image */
unsigned long accu;
float total;

	if(ptsource==0) ptsource=source;

	Stat_image(ptsource);    /* pour calcul moyenne et variance */

	for(i=0;i<taille;i++)
	{
		for(j=0;j<taille;j++)
		{
				for(y=0,accu=0;y<256-i;y++)
				{
					for(x=0;x<256-j;x++)
					{
					pointim=ptsource+x+(y<<8);
					a=*pointim;
					b=*(pointim+j+(i<<8));
					accu+=a*b;
					}
				}
			total=(float)accu;
			total/=(float)((unsigned long)(256-i)*(unsigned long)(256-j));
			cov[i][j]=total-(moy_image*moy_image);
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    C O R R E C T I O N                      */
/*-------------------------------------------------------------------------*/
/*  Fonction : Correction de tache plan source par plan destin -> destin   */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Correction(unsigned char far *ptsource,
unsigned char far *ptdestin)
{
unsigned int i=0,j,p;
unsigned char far *pointim1,*pointim2;

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	pointim1=ptsource;
	pointim2=ptdestin;
	do
	{
		if((p=*pointim2)==0) p=1;
		j=((int)(*pointim1++)<<8);
		j/=(int)p;
		if(j>255) j=255;
		*pointim2++=j;
	}
	while(++i);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   O P E R A 	                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Opration entre 2 plans	(|source - c| -> destin)           */
/*  Paramtres en entre : c = Numro du plan concern                     */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Opera(char c,unsigned char far *ptsource,
			unsigned char far *ptdestin)
{
unsigned char far *pointim1,*pointim2,*pointim3;
int a,b;
unsigned int i=0;

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	pointim1=ptsource;

	switch(c)
	{
	case '0':pointim2=image0;break;
	case '1':pointim2=image1;break;
	case '2':pointim2=image2;break;
	case '3':pointim2=image3;break;
	case '4':pointim2=image4;break;
	case '5':pointim2=image5;break;
	case '6':pointim2=image6;break;
	case '7':pointim2=image7;break;
	}

	pointim3=ptdestin;

	do
	{
	a=*pointim1++;
	b=*pointim2++;
	*pointim3++=abs(a-b);
	}
	while(++i);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :               L E C _ B M P				   						*/
/*-------------------------------------------------------------------------*/
/*  Fonction : Lecture sur disque d'une image au format BMP               */
/*  Paramtres en entre : image = pointeur sur le buffer image            */
/*                         nomfich = nom du fichier                        */
/*  Valeur retourne : 0 -> erreur ; 1 -> OK                               */
/*-------------------------------------------------------------------------*/

int far Lec_bmp(char nomfich[20],unsigned char far *image)

{
FILEHEADER fileheader;//={19778,0,0,0,0 };

INFOHEADER infoheader;//={40,256,256,1,8,0,0,0,0,0,0};

FILE *in;
int x,y;
unsigned char far *pointim1,*pointim2,*pointim3,*pointim;
unsigned char buffer[768],lut[1024];

	if((in=fopen(nomfich,"rb"))==NULL) return(0);
	fread(&fileheader,sizeof(FILEHEADER),1,in);
	fread(&infoheader,sizeof(INFOHEADER),1,in);

	if(fileheader.bfType!=19778) {fclose(in);return(0);}    // tests type
	if(infoheader.biWidth!=256||infoheader.biHeight!=256)
	{fclose(in);return(0);}
	if(modcoul==0)
	{
	if(infoheader.biBitCount!=8) {fclose(in);return(0);}
	}
	else
	{
	if(infoheader.biBitCount!=24){fclose(in);return(0);}
	}

	fread(lut,sizeof(unsigned char),fileheader.bfOffBits-54,in);
	if(modcoul==0)
	{
	for(y=255;y>=0;y--)
	{
	fread(buffer,sizeof(unsigned char),256,in);
	pointim=image+(y<<8);
	for(x=0;x<256;x++) *pointim++=buffer[x];
	}
	}

	else
	{
	for(y=255;y>=0;y--)
	{
	pointim1=image1+(y<<8);
	pointim2=image2+(y<<8);
	pointim3=image3+(y<<8);
	fread(buffer,sizeof(unsigned char),768,in);
	for(x=0;x<768;)
		 {
		 *pointim1++=buffer[x++];
		 *pointim3++=buffer[x++];
		 *pointim2++=buffer[x++];
		 }
	}
	}
	fclose(in);
	return(1);
}

/*-------------------------------------------------------------------------*/

// Calcule l'heure en centimes de seconde

long far Caltime(void)

{
struct time t;
long t1;

	gettime(&t);
	t1=(long)t.ti_hour*360000L+(long)t.ti_min*6000+
	(long)t.ti_sec*100+(long)t.ti_hund;    // en centime de s.
	return(t1);

}

/*-------------------------------------------------------------------------*/
// Delay de x centimes de seconde : remplace delay (dos)

void far delay100(unsigned int temp)
{
long t0,t1;

	t0=Caltime();
	do
	{
	t1=Caltime();
	}
	while(labs(t1-t0)<=(long)temp);    // Pour garantir au moins 10 ms
}

/*-------------------------------------------------------------------------*/

// Teste la prsence de la carte d'acquisition : 0 pas de carte

int far Testacq(void)
{
int test,testcam;

	inportb(piaze);            // RAZ indicateurs
	if(inportb(piaze+1)>=128) return(0);    // Pas de PIA !!

	testcam=0;

	Reset_carte();

	test=Testvoie(0);
	testcam|=test;
	Reset_carte();

	test=Testvoie(1);
	test<<=1;
	testcam|=test;
	Reset_carte();

	test=Testvoie(2);
	test<<=2;
	testcam|=test;
	Reset_carte();

	test=Testvoie(3);
	test<<=3;
	testcam|=test;
	Reset_carte();

	return (testcam);
}

/*-------------------------------------------------------------------------*/

int far Testvoie(int voie)
{
int a;

	outportb(piazs,voie|(parite<<5));
	inportb(piaze);
	outportb(piay+1,0X34);      	// Dclenchement acq.
	delay100(10);
	a=inportb(piaze+1);
	outportb(piay+1,0X3C);      	// Arrt acq.
	if(a>=128) return(1);else return(0);
}

/*-------------------------------------------------------------------------*/

void Reset_carte(void)
{
	outportb(piax+1,0X34);        //FS=0  Reset carte
	delay100(10);
	outportb(piax+1,0X3C);        //FS=1
	delay100(10);
}

/*-------------------------------------------------------------------------*/

unsigned char *PlanSuiv(unsigned char *puCourant, char cN)
  {
  cN= (cN+128)% nbplan;
  if (!cN)
	 return puCourant;
  else
	 {
	 if (nbplan==4)
		{
		if (puCourant==image0) return PlanSuiv(image1,cN-1);
		else if (puCourant==image1) return PlanSuiv(image2,cN-1);
		else if (puCourant==image2) return PlanSuiv(image3,cN-1);
		else if (puCourant==image3) return PlanSuiv(image0,cN-1);
		else
		  return NULL;
		}
	 else if (nbplan==8)
		{
		if (puCourant==image0) return PlanSuiv(image1,cN-1);
		else if (puCourant==image1) return PlanSuiv(image2,cN-1);
		else if (puCourant==image2) return PlanSuiv(image3,cN-1);
		else if (puCourant==image3) return PlanSuiv(image4,cN-1);
		else if (puCourant==image4) return PlanSuiv(image5,cN-1);
		else if (puCourant==image5) return PlanSuiv(image6,cN-1);
		else if (puCourant==image6) return PlanSuiv(image7,cN-1);
		else if (puCourant==image7) return PlanSuiv(image0,cN-1);
		else
		  return NULL;
		}
	 else
		return NULL;
	 }
  }

/*-------------------------------------------------------------------------*/

void Calsuiv(char cN)
  {
  cN =(cN+128)% nbplan;
  if (!cN)
	 return ;
  else
	 {
	 Calsuiv();
	 Calsuiv(cN-1);
	 return;
	 }
  }

/*-------------------------------------------------------------------------*/

char Numeroplan(unsigned char *plan)
  {
  if (!plan) 	 return 0;

	 if(nbplan==4)
		{
		if (plan==image0) return '0';
		else if (plan==image1) return '1';
		else if (plan==image2) return '2';
		else if (plan==image3) return '3';
		else return 0;
		}
		if (nbplan==8)
		{
		if (plan==image0) return '0';
		else if (plan==image1) return '1';
		else if (plan==image2) return '2';
		else if (plan==image3) return '3';
		else if (plan==image4) return '4';
		else if (plan==image5) return '5';
		else if (plan==image6) return '6';
		else if (plan==image7) return '7';
		else return 0;
		}
	return 0;
}

/*-------------------------------------------------------------------------*/

unsigned char DemarrageCarte(int nbplan2)
  {
  if(Iniimage(nbplan2)!=0) return 0;      // Allocation des images
  Inicarte();                      // Initialisations PIA et VSC
  Calplans();                      // Initialisation plan et pointeurs
  presacq=Testacq();               // Test prsence carte acquisition
  return 1;
  }

/*-------------------------------------------------------------------------*/

unsigned char far *Adresseplan(char c)

{
  if (c-'0' >= 4 && nbplan==4) return NULL;
	switch(c)
		{
		case '0':return image0;
		case '1':return image1;
		case '2':return image2;
		case '3':return image3;
		case '4':return image4;
		case '5':return image5;
		case '6':return image6;
		case '7':return image7;
		default : return NULL;
		}
}

/*-------------------------------------------------------------------------*/


