/**********************************************************************/
/*                       W L C A R M A I . C P P                         */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour la          */
/*                     caractrisation d'images                       */
/*--------------------------------------------------------------------*/
/*    Auteurs        : MC            			  							    */
/*    Dvelopp le   : 22/12/1995                                     */
/*    Dernire modif.: 16/06/1997                                     */
/**********************************************************************/

#include "wgttsi.h"
#include "wlcarmai.h"

/*----------------------------------------------*/
/*																*/
/*		Constantes du programme        				 */
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*						*/
/*		Variables du programme          */
/*						*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*						*/
/*		Structures du programme         */
/*						*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*						*/
/*		Variables externes  		*/
/*						*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*						*/
/*  	     Fonctions prototypes		*/
/*						*/
/*----------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*                         Procdures du programme                         */
/*       								   													*/
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :                 E T I                                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Etiquetage d'une image binaire contenue dans le plan source */
/*             Rsultat dans plan destination                              */
/*             Calcul des tableaux de surface,                             */
/*             de coordonnes du barycentre, de rectangle  		   */
/*             d'encadrement et du nombre de trous des objets etiquets    */
/*  Valeur en entre : 						           */
/*                     *nbobj= nombre d'objets                             */
/*                     *nbtrous= nombre de trous                           */
/*                     tabsur[]= tableau des surfaces des objets           */
/*                     tabcgx[], tabcgy[]= tableau des barycentres         */
/*                     tabxmi[], tabxma[]=    "  abscisses rectangle       */
/*                     tabymi[], tabyma[]=    "  ordonnes rectangle       */
/*		       tabtrous[i]	 = tableau des trous		   */
/*  Valeur retourne : dpassement de la capacit d'tiquetage             */
/*-------------------------------------------------------------------------*/

int far Eti(int *nbobj,int *nbtrous,
	unsigned long tabsur[256],
	unsigned long tabcgx[256],unsigned long tabcgy[256],
	unsigned char tabxmi[256],unsigned char tabxma[256],
	unsigned char tabymi[256],unsigned char tabyma[256],
	int tabtrous[256])

{

unsigned int xg,x,y;
unsigned char far *pointim;
int fen,eti,etir,a0=0,a1=0,a2=0,a3=0;
int flagd,flagr,flagf,a,b,i,j;
int dep=0;
unsigned char tabeti[256];
int nveti;				/* Etiquette courante */

for (i=0;i<256;i++)
    {
    tabeti[i]=0;      		/* Effacement table etiquette */
	 tabsur[i]=0;   		/* Effacement table surface */
    tabcgx[i]=0;   		/* Effacement table cgx */
    tabcgy[i]=0;   		/* Effacement table cgy */
    tabxmi[i]=255;
	 tabxma[i]=0;  		/* Initialisation abscisses rectangle */
	 tabyma[i]=0;
    tabtrous[i]=0;              /* Initialisation table trous */
    }

nveti=1;
*nbtrous=0;
*nbobj=0;

Eff(destin);

for (y=0;y<257;y++)
    {
    flagr=flagd=flagf=0;pointim=source+(y<<8);
    for (x=0;x<257;x++,pointim++)
	{
	a2=a0;
	a3=a1;
	if (x==256) {a0=a1=0;}
	if ((y!=256)&&(x!=256)) {a0=*pointim;a0>>=7;}
	if ((y!=0)&&(x!=256)) {a1=*(pointim-256);a1>>=7;}

	fen=a0+(a1<<1)+(a2<<2)+(a3<<3);

	switch(fen)
		{
		case 0:	break;

		case 15:break;

		case 1:	flagd=1;flagr=0;flagf=0;xg=x;break;

		case 2:	flagf=1;break;

		case 3:
		case 11:flagd=0;flagf=0;xg=x;
			eti=*(destin+((y-1)<<8)+x);
			eti=tabeti[eti];
			break;

		case 12:
		case 14:for(a=xg;a<x;a++){*(destin+(y<<8)+a)=eti;}
			if ((unsigned int)tabxmi[eti]>xg)tabxmi[eti]=xg;
			if ((unsigned int)tabxma[eti]<x)
					tabxma[eti]=(unsigned char)(x-1);
			flagd=flagr=0;
			break;

		case 9: eti=*(destin+((y-1)<<8)+x-1);
			eti=tabeti[eti];
			if(connex==0)
				{flagd=1;flagr=0;xg=x;
				if(flagf==1)tabyma[eti]=(unsigned char)(y-1);
				flagf=0;
				}
			else 	{flagd=0;flagr=1;flagf=0;xg=x;}
			break;

		case 7: if(flagr==1)
				{
				etir=*(destin+((y-1)<<8)+x);
				etir=tabeti[etir];
				if(eti<etir)tabeti[etir]=eti;
				else
					{if(eti>etir){tabeti[eti]=etir;eti=etir;}
					else {(*nbtrous)++;tabtrous[eti]++;}
					}
				}
			else	{eti=*(destin+((y-1)<<8)+x);eti=tabeti[eti];}
			flagr=flagd=0;
			break;

		case 8: if(flagf==1)
				{eti=*(destin+((y-1)<<8)+x-1);eti=tabeti[eti];
				tabyma[eti]=(unsigned char)(y-1);flagf=0;}
			break;

		case 13:flagd=0;flagr=1;
			eti=*(destin+((y-1)<<8)+x-1);eti=tabeti[eti];
			break;

		case 6: if(connex==0)
			{
			if(flagd==1)
				{
				if(nveti<256)	{eti=nveti++;}
				else		{eti=255;dep=1;}
				tabeti[eti]=eti;
				tabymi[eti]=(unsigned char)y;
				}
			if((unsigned int)tabxmi[eti]>xg)tabxmi[eti]=xg;
			if((unsigned int)tabxma[eti]<x)
					tabxma[eti]=(unsigned char)(x-1);
			flagf=1;
			}
			else
			{
				if(flagr==1)
				{
				etir=*(destin+((y-1)<<8)+x);
				etir=tabeti[etir];
					if(eti<etir)tabeti[etir]=eti;
					else
					{if(eti>etir){tabeti[eti]=etir;eti=etir;}
					else {(*nbtrous)++;tabtrous[eti]++;}
					}
				}
				else	{eti=*(destin+((y-1)<<8)+x);
					eti=tabeti[eti];
					if((unsigned int)tabxmi[eti]>xg)
					tabxmi[eti]=xg;
					}
			}
			for(a=xg;a<x;a++){*(destin+(y<<8)+a)=eti;}
			flagr=flagd=0;
			break;

		case 4:	if(flagd==1)
				{
				if(nveti<256)eti=nveti++;else{eti=255;dep=1;}
				tabeti[eti]=eti;
				tabymi[eti]=y;
				}
			for(a=xg;a<x;a++){*(destin+(y<<8)+a)=eti;}
			if((unsigned int)tabxmi[eti]>xg)tabxmi[eti]=xg;
			if((unsigned int)tabxma[eti]<x)
					tabxma[eti]=(unsigned char)(x-1);
			flagd=flagr=0;
			break;
		}
	}
    }

/* Rsolution des quivalences */


if (nveti!=1)
   {
   for (i=1;i<nveti;i++)
       {
       j=tabeti[i];
       if (j!=i)
	  {
	  while (tabeti[j]!=j)
		{j=tabeti[j];}
	  if (tabxmi[j]>tabxmi[i]) tabxmi[j]=tabxmi[i];
	  if (tabxma[j]<tabxma[i]) tabxma[j]=tabxma[i];
	  if (tabyma[j]<tabyma[i]) tabyma[j]=tabyma[i];
	  tabtrous[j]+=tabtrous[i];
	  tabeti[i]=j;
	  }
       }

/* Calcul des tiquettes ordonnes et renumrotation de 1  nbobj */


   for (i=1;i<nveti;i++)
       {
       j=tabeti[i];
       if (j==i)
	  {
	  (*nbobj)++;
	  tabxmi[*nbobj]=tabxmi[i];
	  tabxma[*nbobj]=tabxma[i];
	  tabymi[*nbobj]=tabymi[i];
	  tabyma[*nbobj]=tabyma[i];
	  tabtrous[*nbobj]=tabtrous[i];
	  tabeti[i]=(unsigned char)*nbobj;
	  }
       else tabeti[i]=tabeti[j];
       }

/* Re-tiquetage et calcul paramtres gomtriques */

   pointim=destin;

   for (y=0;y<256;y++)
		 {
       for (x=0;x<256;x++,pointim++)
	   {
	   a=*pointim;
	   b=tabeti[a];
	   *pointim=256-b;
	   tabsur[b]++;
	   tabcgx[b]+=x;
	   tabcgy[b]+=y;
	   }
       }

	for (i=1;i<=*nbobj;i++)
		 {
		 tabcgx[i]/=tabsur[i];
		 tabcgy[i]/=tabsur[i];
		 }
	}

return(dep);

}

