/**********************************************************************/
/*                       L C A R P R O P . C                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour la          */
/*                     caractrisation d'images                       */
/*--------------------------------------------------------------------*/
/*    Auteurs        : MC						              			      */
/*    Dvelopp le   : 22/12/1995                                     */
/*    Dernire modif.: 16/06/1997                                     */
/**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "wgttsi.h"
#include "wlcarpro.h"

/*----------------------------------------------*/
/*																*/
/*		Constantes du programme    			     */
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*															  	*/
/*		Structures du programme      				   */
/*																*/
/*----------------------------------------------*/
/*
typedef struct {int xmin,xmax,ymin,ymax,nbtrous,longueur,largeur;
		long sur,cgx,cgy,mu11,mu20,mu02,mu12,mu21,mu03,mu30;
		float per,compac,orien,t_concav;
		double n11,n20,n02,n12,n21,n30,n03,q1,q2,q3,q4,q5,q6;
		} car_obj;
*/
/*----------------------------------------------*/
/*																*/
/*		Variables du programme    				      */
/*																*/
/*----------------------------------------------*/

unsigned long far tabsur[256];               // Table de surfaces
unsigned long far tabcgx[256],tabcgy[256];   // Tables C.G.
unsigned char far tabxmi[256],tabxma[256],   // Rect. d'encadrement 				  tabymi[256],tabyma[256];
				  tabymi[256],tabyma[256];
int far tabtrous[256];                       // Table Nb de trous
int eti,dep;                             // Etiquette, dpas.
int nbobj;                               // Nombre d'objets
int nbtrous;                             // Nombre de trous
int totaltrous;                          // Nb total de trous
int far taboeg[256],taboed[256];    			  // Obj. equ.
int far tabpceg[256],tabpced[256];  			  // PCE
int xmin,xmax,ymin,ymax;                 // Pour rectangle
unsigned int Nb_cont;                    // Nb de pts de contour

car_obj OBJ,EC;                          // Structures objet
car_obj *obj,*ec;

int far TABX[2048],TABY[2048];  /* Tables coordonnes contour extrieur */
char far TABSOM[2048];	    /* Table des sommets    */
long seuil_dis;             /* Seuil distance 	    */

/*----------------------------------------------*/
/*																*/
/*  	     Fonctions prototypes						*/
/*																*/
/*----------------------------------------------*/
void far Const_Cote_Pce(int ymin,int ymax,int taboe[256],
			int tabpce[256],int cote);

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*                         Procdures du programme                         */
/*       								   													*/
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :                 P E R I M                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul du primtre de Freeman dans plan destin.		   	*/
/*  Paramtres en entre : (xmi, xma, ymi, yma) = coordonnes du cadre     */
/*                         *per= variable primtre de Freeman             */
/*                         msk=masque pour calcul 			  						 */
/*  Valeur retourne : Nombre de codes de Freemann                         */
/*-------------------------------------------------------------------------*/

unsigned int far Perim(int xmi,int xma,int ymi,int yma,float *per,int msk)

{

int a0=0,a1=0,a2,a3;
unsigned char far *pointim;
int x,y,fen;
unsigned int l=0,m=0;

for (y=ymi;y<yma+2;y++)
    {
    pointim=destin+xmi+(y<<8);

    for (x=xmi;x<xma+2;x++,pointim++)
	{
	a2=a0;a3=a1;
	if (x==xma+1) {a0=a1=0;}
	if ((y!=yma+1)&&(x!=xma+1)) {a0=*pointim;a0&=msk;if(a0!=0) a0=1;}
	if ((y!=ymi)&&(x!=xma+1)) {a1=*(pointim-256);a1&=msk;if(a1!=0) a1=1;}

	fen=a0+(a1<<1)+(a2<<2)+(a3<<3);

	switch(fen)
	    {
	    case  3:
	    case  5:
	    case  10:
	    case  12:l++;break;

	    case  6:
	    case  7:
	    case  9:
	    case  11:
	    case  13:
	    case  14:m++;break;

	    default :break;
	    }
	}
    }
*per=(float)(l)+(float)(m)*RAC2;if(*per==0) *per=1;

return(l+m);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C O N T O                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul du contour d'un objet dans plan destin.		   		*/
/*  Paramtres en entre : (xmi, xma, ymi, yma) = coordonnes du cadre     */
/*                         msk=masque pour objet			 					  */
/*                         msk2=masque pour contour							   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Conto(int xmi,int xma,int ymi,int yma,int msk,int msk2)

{

int a0=0,a1=0,a2,a3;
unsigned char far *pointim;
int x,y,fen;

for (y=ymi;y<yma+2;y++)
    {
    pointim=destin+xmi+(y<<8);

    for (x=xmi;x<xma+2;x++,pointim++)
	{
	a2=a0;a3=a1;
	if (x==xma+1) {a0=a1=0;}
	if ((y!=yma+1)&&(x!=xma+1)) {a0=*pointim;a0&=msk;if(a0!=0) a0=1;}
	if ((y!=ymi)&&(x!=xma+1)) {a1=*(pointim-256);a1&=msk;if(a1!=0) a1=1;}

	fen=a0+(a1<<1)+(a2<<2)+(a3<<3);
	switch(fen)
	    {             
		 case  1 :*pointim|=msk2;break;
	    case  3 :*pointim|=msk2;break;
	    case  5 :*pointim|=msk2;break;
	    case  7 :if(connex==0)*pointim|=msk2;break;
	    case  9 :*pointim|=msk2;break;
	    case  10:*(pointim-256)|=msk2;break;
	    case  11:*pointim|=msk2;if(connex==0)*(pointim-256)|=msk2;break;
	    case  12:*(pointim-1)|=msk2;break;
	    case  13:*pointim|=msk2;if(connex==0)*(pointim-1)|=msk2;break;
	    case  14:*(pointim-1)|=msk2;*(pointim-256)|=msk2;
		     if(connex==0)*(pointim-257)|=msk2;break;
	    default :break;
	    }
	}
    }

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 S U R F                                     */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul  de la surface et du CG d'un objet dans le plan      */
/*             destination                                                 */
/*  Paramtres en entre : (xmi, xma, ymi, yma) = coordonnes du cadre     */
/*                         *sur= surface                                   */
/*                         *cgx= centre de gravit x                       */
/*                         *cgy= centre de gravit y                       */
/*                         msk= masque pour calcul                         */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Surf(int xmin,int xmax,int ymin,int ymax,
		long *sur,long *cgx,long *cgy,int msk)
{

int x,y;
unsigned char far *pointim,p;

	*sur=*cgx=*cgy=0;
	for(y=ymin;y<ymax+1;y++)
	{pointim=destin+(y<<8)+xmin;
		for(x=xmin;x<xmax+1;x++)
		{
		p=*pointim++;p&=msk;
		if(p!=0){(*sur)++;(*cgx)+=x;(*cgy)+=y;}
		}
	 }
if((*sur)!=0){(*cgx)/=(*sur);(*cgy)/=(*sur);}

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 M O M E N T S                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul  des moments d'un objet dans le plan  		  		 */
/*             destination                                                 */
/*  Paramtres en entre : msk = masque pour calcul 			  				 */
/*                         obj = pointeur sur structure objet		 		  */
/*  Valeur retourne : Aucune                                              */
/*  Remarque : cette procdure ncessite l'initialisation pralable de     */
/*		la structure objet 					 											  */
/*-------------------------------------------------------------------------*/

void far Moments(car_obj *obj,int msk)
{

int xmin,xmax,ymin,ymax,x,y;
unsigned char far *pointim,p;
long cgx,cgy,mu11,mu20,mu02,mu12,mu21,mu03,mu30,dx,dy,dx2,dy2;

	mu11=mu20=mu02=mu12=mu21=mu03=mu30=0;

	cgx=obj->cgx;
	cgy=obj->cgy;
	ymin=obj->ymin;
	ymax=obj->ymax;
	xmin=obj->xmin;
	xmax=obj->xmax;

	for(y=ymin;y<ymax+1;y++)
	{pointim=destin+(y<<8)+xmin;
		for(x=xmin;x<xmax+1;x++)
		{
		p=*pointim++;p&=msk;
		if(p!=0)
			{
			dx=x-cgx;
			dy=y-cgy;
			dx2=dx*dx;
			dy2=dy*dy;
			mu11+=dx*dy;
			mu20+=dx2;
			mu02+=dy2;
			mu12+=dx*dy2;
			mu21+=dx2*dy;
			mu30+=dx*dx2;
			mu03+=dy*dy2;
			}
		}
	 }
	obj->mu11=mu11;
	obj->mu20=mu20;
	obj->mu02=mu02;
	obj->mu12=mu12;
	obj->mu21=mu21;
	obj->mu30=mu30;
	obj->mu03=mu03;

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 M O M E N T S _ G E N                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul des moments gnraliss		  		  						 */
/*  Paramtres en entre : obj = pointeur sur structure objet		   		*/
/*  Valeur retourne : Aucune                                              */
/*  Remarque : cette procdure doit tre appele aprs Moments 			   */
/*-------------------------------------------------------------------------*/

void far Moments_gen(car_obj *obj)

{

double m00,z=2.5;

	 m00=(double)obj->sur;

	 obj->n20= ((double) (obj->mu20))/(m00*m00);

	 obj->n02= ((double) (obj->mu02))/(m00*m00);

	 obj->n11= ((double) (obj->mu11))/(m00*m00);

	 obj->n12= ((double) obj->mu12)/(pow(m00,z));

	 obj->n21= ((double) obj->mu21)/(pow(m00,z));

	 obj->n30= ((double) obj->mu30)/(pow(m00,z));

	 obj->n03= ((double) obj->mu03)/(pow(m00,z));

	 obj->q1=obj->n20+obj->n02;

	 obj->q2=(obj->n20 - obj->n02)*(obj->n20 - obj->n02)+
		4 * obj->n11 * obj->n11;

	 obj->q3=(obj->n30 - 3 * obj->n12)*(obj->n30 - 3 * obj->n12)+
		(obj->n03 - 3 * obj->n21)*(obj->n03 - 3 * obj->n21);

	 obj->q4= (obj->n30 + obj->n12)*(obj->n30 + obj->n12)+
		(obj->n03 + obj->n21)*(obj->n03 + obj->n21);

	 obj->q5=(obj->n30-3*obj->n12)*(obj->n30 + obj->n12) *
		( (obj->n30 + obj->n12)*(obj->n30 + obj->n12)-
		3 * ( (obj->n03 + obj->n21)*(obj->n03 + obj->n21)))+
		(3*obj->n21-obj->n03)*(obj->n03 + obj->n21) *
		( 3*((obj->n30 + obj->n12)*(obj->n30 + obj->n12))-
		( (obj->n03 + obj->n21)*(obj->n03 + obj->n21)))  ;

	 obj->q6=(obj->n20-obj->n02)*((obj->n30+obj->n12)*(obj->n30+obj->n12)
		-(obj->n21 + obj->n03)*(obj->n21 + obj->n03) )
		+4 * obj->n11 * (obj->n30 + obj->n12)*(obj->n21 + obj->n03);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C A L _O R I E N 	            		       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de l'orientation d'un objet	 		  						 */
/*  Paramtres en entre : obj = pointeur sur structure objet				   */
/*  Valeur retourne : Aucune		                               			    */
/*  Remarque : cette procdure ncessite l'initialisation pralable de     */
/*		la structure objet 					   */
/*-------------------------------------------------------------------------*/

void far Cal_orien(car_obj *obj)

{

float orientation;
int indi1,indi2;

	if(obj->mu20!=obj->mu02)
	{
		orientation=-2.0*(double)(obj->mu11)/
		((double)(obj->mu20)-(double)(obj->mu02));
		orientation=0.5*atan((double)orientation);
		if(-2.0*(double)obj->mu11<0) indi2=0; else indi2=1;
		if(sin(2.0*(double)orientation)<0) indi1=0; else indi1=1;
		if (indi1!=indi2) orientation+=PI/2;
		orientation*=180/PI;
	}
	else orientation=0;

	obj->orien=orientation;

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 Const_Obj                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction de l'objet  dans le plan destination           */
/*              partir des tiquettes du plan source                      */
/*  Paramtres en entre : (xmi, xma, ymi, yma) = coordonnes du cadre     */
/*                         eti= tiquette                                  */
/*                         msk= masque pour calcul                         */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Const_Obj(int xmin,int xmax,int ymin,int ymax,int eti,int msk)

{

int x,y,b;
unsigned char far *pointim,*pointim1;

	for (y=ymin;y<ymax+1;y++)
	{
	pointim1=source+xmin+(y<<8);
	pointim=destin+xmin+(y<<8);
	for (x=xmin;x<xmax+1;x++)
		{
		b=*pointim1++;
		if(eti==(unsigned char)(256-b)) *pointim=msk;
		pointim++;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 Const_Obj_Equ                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction de l'objet  quivalent de l'objet situ        */
/*                       dans le plan destination		          				 */
/*  Paramtres en entre : (xmin, xmax, ymin, ymax) = coordonnes du cadre */
/*                         msk= masque pour calcul                         */
/*                        taboeg[256],taboed[256] = tableaux de l'OE 	   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Const_Obj_Equ(int xmin,int xmax,int ymin,int ymax,int msk,
	int taboeg[256],int taboed[256])

{

int x,y,xd,xg;
int a0,a1,flagd,fen;
unsigned char far *pointim;

	for (y=ymin;y<ymax+1;y++)
	{
	pointim=destin+xmin+(y<<8);
	a1=0;flagd=0;
	for (x=xmin;x<xmax+1;x++)
		{
		a0=*pointim++;a0&=msk;if(a0!=0) a0=1;
		fen=a0+(a1<<1);
			switch(fen)
			{
			case 1 : if (flagd==0){xg=x;flagd=1;}break;
			case 2 : xd=x-1;break;
			default: break;
			}
		a1=a0;
		}

	if(a0!=0) xd=x-1;
	taboeg[y]=xg;
	taboed[y]=xd;
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 Const_Pce                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction du PCE					   								*/
/*  Paramtres en entre : (ymin, ymax) = coordonnes y                    */
/*                        taboeg[256],taboed[256] = tableaux de l'OE 	   */
/*                        tabpceg[256],tabpced[256] = tableaux du PCE      */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Const_Pce(int ymin,int ymax,int taboeg[256],int taboed[256],
			    int tabpceg[256],int tabpced[256])

{
	Const_Cote_Pce(ymin,ymax,taboeg,tabpceg,1);
	Const_Cote_Pce(ymin,ymax,taboed,tabpced,-1);
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                 Const_Cote_Pce                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction d'un ct du PCE				  							 */
/*  Paramtres en entre : (ymin, ymax) = coordonnes y                    */
/*                        taboe[256] = tableau de l'OE 						   */
/*                        tabpce[256] = tableau du PCE  						   */
/*			   cote = 1 -> gauche ; -1 ->droit               					  */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Const_Cote_Pce(int ymin,int ymax,int taboe[256],
			int tabpce[256],int cote)

{

int i,j,k,a,imin,imax;
int A[256];
long b,c;

	if(ymax>ymin+1)
	{
	for(i=ymin;i<ymax+1;i++) {A[i]=0;}

	i=ymin;j=i+1;k=i+2;
	do
	{
	b=( (long)( taboe[j] - taboe[i] ) * (long)(k-j) ) -
	  ( (long)( taboe[k] - taboe[j] ) * (long)(j-i) );

	if(cote==-1) b=-b;   /* ct droit */

	if(b<=0) a=0;else a=1;
	switch(a)
		{
		case 0:i=j;j=k++;break;
		case 1:A[j]=1;if(i==ymin){j=k++;break;}
				else{j=i;do{i--;}while(A[i]!=0);}break;
		}
	}
	while(k<=ymax);

	for(i=ymin;i<ymax+1;)
	{
	if(A[i]==0) 	{tabpce[i]=taboe[i];i++;}
	else		{
			imin=i-1;do{i++;}while(A[i]!=0);
			imax=i;
			for(j=imin;j<imax+1;j++)
				{
				c=taboe[imax]-taboe[imin];
				c*=(j-imin);
				c/=(imax-imin);
				c+=taboe[imin];
				tabpce[j]=(int)c;
				}
			}
	}

	}
	else	{for(i=ymin;i<ymax+1;i++) tabpce[i]=taboe[i];}

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 Decod_Seg                                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction d'un objet (plan destin.)  partir de segments */
/*  Paramtres en entre : (ymin, ymax) = coordonnes y                    */
/*                         msk= masque pour calcul                         */
/*                         tabg[256] = tableau des extrmits gauches 	   */
/*                         tabd[256] = tableau des extrmits droites      */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Decod_Seg(int ymin,int ymax,int msk,int tabg[256],int tabd[256])

{

unsigned char far *pointim,p;
int xmin,xmax,x,y;

	for(y=ymin;y<ymax+1;y++)
	{
	xmin=tabg[y];xmax=tabd[y];
	pointim=destin+xmin+(y<<8);
		for(x=xmin;x<xmax+1;x++)
		{
		p=*pointim;p|=msk;*pointim++=p;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 Const_Concav                                */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction des concavits dans le plan destination        */
/*  Paramtres en entre : (xmi, xma, ymi, yma) = coordonnes du cadre     */
/*                         msk1= masque pour Objet                         */
/*                         msk2= masque pour EC                            */
/*                         msk3= masque pour Concavits                    */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Const_Concav(int xmin,int xmax,int ymin,
	    int ymax,int msk1,int msk2,int msk3)

{

int x,y,a,b,p;
unsigned char far *pointim;

	for (y=ymin;y<ymax+1;y++)
	{
	for (x=xmin;x<xmax+1;x++)
		{
		pointim=destin+x+(y<<8);
		p=*pointim;
		a=p&msk1;
		b=p&msk2;
		if((b!=0)&&(a==0)){p|=msk3;*pointim=p;}
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              C O N S T A B _ C O N T E X T                  */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction des tableaux des coordonnes du contour ext.   */
/*  Paramtres en entre : obj = pointeur sur structure objet		 			*/
/*                         msk= masque pour calcul                         */
/*		           image = pointeur sur image			  								 */
/*                         TABX[] = tableau des abscisses	     		  	   */
/*                         TABY[] = tableau des ordonnes					   */
/*                         connex = connexit					 					*/
/*                        *per_ext = perimtre extrieur		 					   */
/*  Valeur retourne : Nombre de pts du cont. ext.		        				   */
/*-------------------------------------------------------------------------*/

unsigned int far Constab_context(car_obj *obj,int msk,
			unsigned char far *image,int TABX[],int TABY[],
			int connex,float *per_ext)

{

int x,y,x0,y0,C1=0,C2=0,xmin,xmax,ymin,ymax;
unsigned int i=0;
int absi,ord,dir;
unsigned char far *pointim;

	if(obj->sur==1)	{TABX[0]=TABY[0]=obj->xmin;*per_ext=1;return(1);}

xmin=obj->xmin;ymin=obj->ymin;
xmax=obj->xmax;ymax=obj->ymax;

/* Dtection des points de contour */

	x=obj->xmin;y=obj->ymin;
	pointim=image+x+(y<<8);
	while(((*pointim)&msk)==0)
	{
	x++;
	pointim++;
	};

	TABX[i]=x;TABY[i]=y;	/* coordonnes du premier point de contour */
	x0=x;y0=y;
	i++;
	dir=4;
	pointim=image+(x-1)+(y<<8);
	absi=x-1;ord=y;

do
{
	while((((*pointim)&msk)==0)||(absi<xmin)||(absi>xmax)||(ord<ymin)||(ord>ymax))
	{
		absi=x;ord=y;

		switch(connex)  /* prise en compte de la connexit */
			{
			case 0:dir+=2;if(dir==8){dir=0;};break; /* 4_voisins */
			case 1:dir++;if(dir==8){dir=0;}; break; /* 8_voisins */
			}

		switch(dir)
			{
			case 0:absi++;break;
			case 1:absi++;ord--;break;
			case 2:ord--;break;
			case 3:absi--;ord--;break;
			case 4:absi--;break;
			case 5:absi--;ord++;break;
			case 6:ord++;break;
			case 7:absi++;ord++;break;
			}

		pointim=image+absi+(ord<<8);

	}

	TABX[i]=absi;
	TABY[i]=ord;
	x=absi;y=ord;

	switch(dir)
		{
		case 0:C1++;ord++;dir=6;break;
		case 1:C2++;ord++;dir=6;break;
		case 2:C1++;absi++;dir=0;break;
		case 3:C2++;absi++;dir=0;break;
		case 4:C1++;ord--;dir=2;break;
		case 5:C2++;ord--;dir=2;break;
		case 6:C1++;absi--;dir=4;break;
		case 7:C2++;absi--;dir=4;break;
		}

	pointim=image+absi+(ord<<8);
	i++;
}
while(((x!=x0)||(y!=y0))&&(i<2048));

i--;  /* nbre de pts du contour extrieur */
*per_ext=C1+C2*RAC2;

return(i);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :              D E C O D _C O N T E X T                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Restitution du contour extrieur d'un objet                 */
/*		 partir des tableaux de coordonnes			   							*/
/*  Paramtres en entre : tabx[] = tableau des abscisses	       		   */
/*                         taby[] = tableau des ordonnes		 				*/
/*		           image = pointeur sur image			   							*/
/*                         msk = masque pour calcul                        */
/*                         Nb =  nombre de points du tableau		   		*/
/*  Valeur retourne : Aucune					         							  */
/*-------------------------------------------------------------------------*/

void far Decod_context(int tabx[],int taby[],unsigned char far *image,
		int msk,unsigned int Nb)

{

int k;
unsigned char far *pointim;

	for (k=0;k<=Nb-1;k++)
		{
		pointim=image+tabx[k]+(taby[k]<<8);
		(*pointim)|=msk;
		}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :          C A L _ L _ H _ R E C T M I N                      */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de la largeur et de la hauteur d'un objet            */
/*	        partir du calcul des bornes de son rectangle minimum      */
/*	       d'encadrement                                               */
/*  Paramtres en entre : obj = pointeur sur structure objet		   */
/*                         Nb = nbre de pts de contour ext   		   */
/*                         TAB_X[] = tableau des abscisses du contour ext  */
/*                         TAB_Y[] = tableau des ordonnes du contour ext  */
/*  Valeur retourne : Aucune                                              */
/*  Remarque : cette procdure ncessite l'initialisation pralable de     */
/*		la structure objet 					   */
/*-------------------------------------------------------------------------*/

void far Cal_l_h_rectmin(car_obj *obj,unsigned int Nb,
			int TAB_X[],int TAB_Y[])

{

int t,z,tmin=500,tmax=-500,zmin=500,zmax=-500,cgx,cgy;
unsigned int i;
float cos0,sin0;

	cos0=(float)cos((double)(obj->orien)*PI/180.);
	sin0=(float)sin((double)(obj->orien)*PI/180.);
	cgx=(int)obj->cgx;
	cgy=(int)obj->cgy;

	for(i=0;i<=Nb-1;i++)
	{
	t=(int) ((TAB_X[i]-cgx)*cos0-(TAB_Y[i]-cgy)*sin0+cgx);
	z=(int) ((TAB_X[i]-cgx)*sin0+(TAB_Y[i]-cgy)*cos0+cgy);
	if(t<tmin) tmin=t;if(z<zmin) zmin=z;
	if(t>tmax) tmax=t;if(z>zmax) zmax=z;
	}
	obj->longueur=tmax-tmin;
	obj->largeur=zmax-zmin;

}

/*-------------------------------------------------------------------------*/
/*  Fonction :              D I S T _ M A X		                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul distance max pour un doublet d'indice i,j            */
/*  Paramtres en entre : i,j,*k = indices				   */
/*  Valeur retourne : Distance	(carr) max			           */
/*-------------------------------------------------------------------------*/

long far Dist_max(int i,int j,int *k)

{

float d2ab,d2a,d2b,d2,max=0;
int xa,xb,ya,yb,z,x,y;

	xa=TABX[i];xb=TABX[j];
	ya=TABY[i];yb=TABY[j];
	d2ab=((float)(xa-xb)*(float)(xa-xb))+
		  ((float)(ya-yb)*(float)(ya-yb));

	for(*k=i+1;*k<j;(*k)++)
	{
	x=TABX[*k];y=TABY[*k];
	d2a=((float)(xa-x)*(float)(xa-x))+((float)(ya-y)*(float)(ya-y));
	d2b=((float)(x-xb)*(float)(x-xb))+((float)(y-yb)*(float)(y-yb));
	d2=(4*d2a*d2b)-((d2ab-d2a-d2b)*(d2ab-d2a-d2b));
	if(d2>max) {max=d2;z=*k;}
	}
	d2=max;
	if (d2ab!=0) d2/=4*d2ab;
	*k=z;
	return((long)d2);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              R E M P _ T A B S O M 	                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Remplissage du tableau d'indices des sommets                */
/*	       de l'approx. polygonale 					   */
/*  Paramtres en entre : 						   */
/*                         Nb = nombre de points du contour		   */
/*  Valeur retourne : Aucune					           */
/*-------------------------------------------------------------------------*/

void far Remp_tabsom(int Nb)

{

int i,j;

	for(i=0;i<Nb;i++) TABSOM[i]=0;
	TABSOM[0]=1;
	i=0;j=Nb-1;
	Decoup_tabsom(i,j);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              D E C O U P _ T A B S O M 	                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcoupage d'un arc en 2 segments				   */
/*  Paramtres en entre : i,j = indices				   */
/*  Valeur retourne : Aucune					           */
/*  Cette fonction est rcursive                                           */
/*-------------------------------------------------------------------------*/

void far Decoup_tabsom(int i,int j)

{

int k;

	if(Dist_max(i,j,&k)>seuil_dis)
	{
		TABSOM[k]=1;
		Decoup_tabsom(i,k);
		Decoup_tabsom(k,j);
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              D E C O D _ T A B S O M 	                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcodage table sommets					   */
/*  Paramtres en entre : 						   */
/*		           image = pointeur sur image			   */
/*                         msk = masque pour calcul                        */
/*                         Nb =  nombre de points du tableau		   */
/*  Valeur retourne : Nb de sommets				           */
/*-------------------------------------------------------------------------*/

unsigned int far Decod_tabsom(unsigned char far *image,
				int msk,unsigned int Nb)

{

int x0,y0,x1,y1,i=0;
unsigned int k,nbsom=0;

	for(k=0;k<=Nb-1;k++)
	{
		if(TABSOM[k]==1)
		{
			x0=TABX[i];x1=TABX[k];
			y0=TABY[i];y1=TABY[k];
			Droite(x0,y0,x1,y1,image,msk);
			i=k;
			nbsom++;
		 }
	}
	x0=TABX[i];x1=TABX[0];          /* Pour revenir au dpart */
	y0=TABY[i];y1=TABY[0];
	Droite(x0,y0,x1,y1,image,msk);
	return(nbsom);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              D E C O D _ S O M    	                   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcodage sommets	  					   */
/*  Paramtres en entre : 						   */
/*		           image = pointeur sur image			   */
/*                         msk = masque pour calcul                        */
/*                         Nb =  nombre de points du tableau		   */
/*  Valeur retourne : Nb de sommets				           */
/*-------------------------------------------------------------------------*/

unsigned int far Decod_som(unsigned char far *image,int msk,unsigned int Nb)

{

unsigned int k,nbsom=0;
unsigned char far *pointim;

	for(k=0;k<=Nb-1;k++)
	{
		if(TABSOM[k]==1)
		{
			pointim=image+TABX[k]+(TABY[k]<<8);
			(*pointim)|=msk;
			nbsom++;
		}
	}
	return(nbsom);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :              C A L  _ N B S O M    	     		              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul nb de points sommets		 								  */
/*  Paramtres en entre : 						 									  */
/*                         Nb =  nombre de points du tableau		  			 */
/*  Valeur retourne : Nb de sommets				          						 */
/*-------------------------------------------------------------------------*/

unsigned int far Cal_nbsom(unsigned int Nb)

{

unsigned int k,nbsom=0;

	for(k=0;k<=Nb-1;k++)
	{
		if(TABSOM[k]==1) nbsom++;
	}
	return(nbsom);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :           C O N S T _ T A B _ I N T E R                     */
/*-------------------------------------------------------------------------*/
/*  Fonction : Construction des tableaux de coordonnes des points         */
/*					d'interpolation			   */
/*  Paramtres en entre : TAB=Table des pts de la fonction  interpoler   */
/*			   Nb_cont=nbre de pts du contour extrieur        */
/*                         Nb_interp=nombre de points d'interpolation      */
/*                         TAB1=Table des pts de la fonction interpole    */
/*  Valeur retourne : Aucune					           */
/*-------------------------------------------------------------------------*/


void far Const_Tab_Inter(int TAB[], unsigned int Nb_cont,
				unsigned int Nb_interp,float *TAB1)

{

unsigned int i,j;
float k,a,b;

	k=(float)(Nb_cont-1)/(float)(Nb_interp-1);

	TAB1[Nb_interp-1]=(float)TAB[Nb_cont-1];   /* dernier point */

	for(j=0;j<Nb_interp-1;j++)
		{
		a=(float)j*k;
		i=(unsigned int)a;
		b=a-(float)i;
		TAB1[j]=(float)TAB[i]*(1-b)+(float)TAB[i+1]*b;
		}

}

/*-------------------------------------------------------------*/
/*  Fonction :                 C O N S T _S Q U E L            */
/*-------------------------------------------------------------*/
/*  Fonction : Construction du squelette d'un objet -> destin. */
/*  Paramtres en entre : xmin,xmax,ymin,ymax,		       */
/*                         msk1,msk2 : plans de travail        */
/*  Valeur retourne : aucune	                               */
/*-------------------------------------------------------------*/

void far Const_squel(int xmin,int xmax,int ymin,int ymax,int msk1,int msk2)

{

int i,msk,chang,xmi,xma,ymi,yma;

	xmi=xmin;xma=xmax;ymi=ymin;yma=ymax;

	do
	{
	for(chang=0,i=1;i<=8;i++)
		{
		chang+=Erod(xmin,xmax,ymin,ymax,i,msk1,msk2);
		msk=msk1;msk1=msk2;msk2=msk;   /* permut. plans */
		}
	//Transfert(destin);                   // pour voir l'avancement
	xmin++;ymin++;xmax--;ymax--;           /* rduction zone de travail */
	}
	while(chang!=0);
							/* Eff. plan intermdiaire */
	Zero_rect(xmi,xma,ymi,yma,msk2,destin);

}

/*-------------------------------------------------------------*/
/*  Fonction :                 E R O D                         */
/*-------------------------------------------------------------*/
/*  Fonction : Attaque pour squel. d'un objet -> destin.       */
/*  Paramtres en entre : xmin,xmax,ymin,ymax		       */
/*                         num : type de masque d'rosion      */
/*                         msk1,msk2 plans de travail          */
/*  Valeur retourne : changement                              */
/*-------------------------------------------------------------*/

int far Erod(int xmin,int xmax,int ymin,int ymax,int num,int msk1,int msk2)

{

unsigned char far *pointim;
int x,y,chang=0,msk2b;
int pos10,pos20,pos30,pos11,pos21,pos31;
int xtest0,xtest1,ytest0,ytest1;

  msk2b=(~msk2)&0XFF;

  switch(num)
  {

  case 1:pos10=-257;pos20=-1;pos30=+255;pos11=-255;pos21=+1;pos31=+257;
	 xtest0=xmin;xtest1=xmax;break;

  case 2:pos10=-255;pos20=+1;pos30=+257;pos11=-257;pos21=-1;pos31=+255;
	 xtest0=xmax;xtest1=xmin;break;

  case 3:pos10=+255;pos20=+256;pos30=+257;pos11=-255;pos21=-256;pos31=-257;
	 ytest0=ymax;ytest1=ymin;break;

  case 4:pos10=-255;pos20=-256;pos30=-257;pos11=+255;pos21=+256;pos31=+257;
	 ytest0=ymin;ytest1=ymax; break;

  case 5:pos10=-257;pos20=-256;pos30=-1;pos11=+1;pos21=+256;pos31=+257;
	 xtest0=xmin;xtest1=xmax;ytest0=ymin;ytest1=ymax;break;

  case 6:pos10=+1;pos20=+256;pos30=+257;pos11=-257;pos21=-256;pos31=-1;
	 xtest0=xmax;xtest1=xmin;ytest0=ymax;ytest1=ymin;break;

  case 7:pos10=-256;pos20=-255;pos30=+1;pos11=-1;pos21=+255;pos31=+256;
	 xtest0=xmax;xtest1=xmin;ytest0=ymin;ytest1=ymax;break;

  case 8:pos10=-1;pos20=+255;pos30=+256;pos11=-256;pos21=-255;pos31=+1;
	 xtest0=xmin;xtest1=xmax;ytest0=ymax;ytest1=ymin;break;
  }

  switch(num)
  {

  case 1:
  case 2:

  for(y=ymin;y<=ymax;y++)
  {
  pointim=destin+(y<<8)+xmin;

    for(x=xmin;x<=xmax;x++,pointim++)
    {
		if(((*pointim) & msk1)!=0)
      {
      if((y!=ymin && y!=ymax && x!=xtest1)
      && (x==xtest0 || (*(pointim+pos10) & msk1)==0
      && (*(pointim+pos20) & msk1)==0 && (*(pointim+pos30) & msk1)==0)
	 && (*(pointim+pos11) & msk1)!=0 && (*(pointim+pos21) & msk1)!=0
      && (*(pointim+pos31) & msk1)!=0)
		{
		(*pointim)&=msk2b;
		chang=1;
		}
      else (*pointim)|=msk2;
      }
      else (*pointim)&=msk2b;
    }
  }

  break;

  case 3:
  case 4:

  for(y=ymin;y<=ymax;y++)
  {
  pointim=destin+(y<<8)+xmin;

    for(x=xmin;x<=xmax;x++,pointim++)
    {
      if(((*pointim) & msk1)!=0)
      {
      if((x!=xmin && y!=ytest1 && x!=xmax)
	 && (y==ytest0 || (*(pointim+pos10) & msk1)==0
      && (*(pointim+pos20) & msk1)==0 && (*(pointim+pos30) & msk1)==0)
      && (*(pointim+pos11) & msk1)!=0 && (*(pointim+pos21) & msk1)!=0
      && (*(pointim+pos31) & msk1)!=0)
		{
		(*pointim)&=msk2b;
		chang=1;
		}
      else (*pointim)|=msk2;
		}
      else (*pointim)&=msk2b;
    }
  }

  break;

  case 5:
  case 6:
  case 7:
  case 8:

  for(y=ymin;y<=ymax;y++)
  {
  pointim=destin+(y<<8)+xmin;

    for(x=xmin;x<=xmax;x++,pointim++)
    {
      if(((*pointim) & msk1)!=0)
      {
		if((y!=ytest1 && x!=xtest1)
      && (x==xtest0 || y==ytest0 || (*(pointim+pos10) & msk1)==0
	 && (*(pointim+pos20) & msk1)==0 && (*(pointim+pos30) & msk1)==0)
      && (*(pointim+pos11) & msk1)!=0 && (*(pointim+pos21) & msk1)!=0
      && (*(pointim+pos31) & msk1)!=0)
		{
		(*pointim)&=msk2b;
		chang=1;
		}
      else (*pointim)|=msk2;
	 }
      else (*pointim)&=msk2b;
    }
  }

  break;

  }

  return(chang);
}

/*-------------------------------------------------------------------------*/
