/**********************************************************************/
/*                         W L C O M P . C P P                      	 */
/*--------------------------------------------------------------------*/
/*    Fonction       :   Compression d'images par DCT                 */
/*--------------------------------------------------------------------*/
/*    Auteur         :   MC                			     					 */
/*    Dvelopp le   :   26/12/95                                     */
/*    Dernire modif.:   23/05/97                                     */
/**********************************************************************/

#include <math.h>
#include <alloc.h>

#include "wgttsi.h"
#include "wlcomp.h"
#include "whuffman.h"

/*----------------------------------------------*/
/*																*/
/*		Constantes du programme        				*/
/*															  	*/
/*----------------------------------------------*/


typedef int DCTELEM;

void jpeg_fdct_ifast (DCTELEM * in);

/*----------------------------------------------*/
/*																*/
/*		Variables du programme     			     */
/*																*/
/*----------------------------------------------*/

float C[8][8],Base[8][8];      // matrices de base   C=(Base) T
long Cint[8][8],Baseint[8][8]; // matrices de base   Cint=(Baseint) T
long Q[8][8];           		 // matrice de quantif
long Q8[8][8];           		 // matrice de quantif pour codage

int Z[64];                     // indices du zig-zag
int Statac[16][16],Statdc[16];  	  // Statistique des vnements
int Tabac0[16][16],Tabdc0[16];   // Tableaux de longueur de code
int qual=-1;                     // qualit initiale
int test_ini_huff=0;
char csize[] = {                // table de nombre de bits
0,1,2,2,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8};

long extend_mask[]={       /* Used for sign extensions. */
0xFFFFFFFEL,
0xFFFFFFFCL,
0xFFFFFFF8L,
0xFFFFFFF0L,
0xFFFFFFE0L,
0xFFFFFFC0L,
0xFFFFFF80L,
0xFFFFFF00L,
0xFFFFFE00L,
0xFFFFFC00L,
0xFFFFF800L,
0xFFFFF000L,
0xFFFFE000L,
0xFFFFC000L,
0xFFFF8000L,
0xFFFF0000L,
0xFFFE0000L,
0xFFFC0000L,
0xFFF80000L,
0xFFF00000L
};

/*----------------------------------------------*/
/*																*/
/*		Variables externes  								*/
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*																*/
/*  	     Fonctions prototypes						*/
/*																*/
/*----------------------------------------------*/

void far Lit_bloc(int x,int y,float *im,unsigned char far *ptsource);
void far Lit_blocint(int x,int y,long *imint,unsigned char far *ptsource);
void far Lit_blocint(int x,int y,int *imint,unsigned char far *ptsource);
void far Ecrit_bloc(int x,int y,float *im,unsigned char far *ptdestin);
void far Ecrit_blocint(int x,int y,long *imint,unsigned char far *ptdestin);
void far Ecrit_blocint(int x,int y,int *imint,unsigned char far *ptdestin);

void ChenDct(long *,long *);
void ChenIDct(long *,long *);

void far Codzz1(long coef[8][8],unsigned int *nbit,int *pred);
void far Decodzz1(long coef[8][8],int *pred);

void far Quantifint(long coef[8][8],int tcosint[8][8],long Q[8][8]);

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*                         Procdures du programme                         */
/*       								   													*/
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C O M P R E S S                             */
/*-------------------------------------------------------------------------*/
/*  Fonction : Compression d'une image par DCT                             */
/*  Paramtres en entre : mode de calcul '0' -> flottant '1' -> entier    */
/*                         qualite, pointeurs s et d                       */
/*  Valeur retourne : Nb de bits                                          */
/*-------------------------------------------------------------------------*/

long far Compress(char modcal,int qualite,
unsigned char far *ptsource,unsigned char far *ptdestin)
{
long totbit;
unsigned char *tabcode;

tabcode=(unsigned char *)farmalloc(65536L);

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	Razstat();

	totbit=8*(long)Code_dct(modcal,qualite,ptsource,tabcode);
	Decode_dct(modcal,qualite,ptdestin,tabcode);
	farfree(tabcode);

	return(totbit);
}

/*-------------------------------------------------------------------------*/

unsigned int far Code_dct(char modecod,int qualite,unsigned char far *image,unsigned char *tabcode)
{
int x,y;
float im[8][8],tcos[8][8];     // bloc image ; bloc transform
long imint[8][8],tcosint[8][8];// bloc image ; bloc transform
long coef[8][8];       			 //  coef
unsigned int nbit;            // nb de bits
int pred;                     // prdicteur
char nbcouple=0;
event *pointcode;
unsigned char *pt;
unsigned int nbcode=0;
unsigned int nbcodebloc;
long totbit=0;
//int imint1[8][8];

	bufcomp=tabcode;                // initialise buffer pour huffman
	Inicodec();

	if(qualite!=qual)
	{
	Iniquant(qualite);  // pour gagner du temps
	}

	if(!test_ini_huff)  {IniTables();test_ini_huff=1;} // Init tables Huffmann

	pt=tabcode;

	for(y=0;y<256;y+=8)
	{
	pred=0;	    	  // prdicteur = 0 en dbut de ligne
		for(x=0;x<256;x+=8)
		{
			switch(modecod)
			{
			case '0' :                       // flottant

			Lit_bloc(x,y,&im[0][0],image);
			Fdct1(im,tcos,C,Base);         	// Tf. directe
			Quantif(coef,tcos,Q);          	// Quantification
			break;

			case '1':                        // entier
			case 1:
			case 2:

			Lit_blocint(x,y,&imint[0][0],image);
			ChenDct(&imint[0][0],&tcosint[0][0]); // T rapide
			Quantifint(coef,tcosint,Q8);
			//Lit_blocint(x,y,&imint1[0][0],image);
			//jpeg_fdct_ifast((DCTELEM *)&imint1[0][0]);
			//Quantifint(coef,imint1,Q8);

			break;
			}//switch

			if(modecod==1||modecod=='0'||modecod=='1')
			{
			pointcode=(event *)(pt+1);
			nbcouple=Codzz(coef,pointcode,&nbit,&pred);// Codage ZZ
			totbit+=nbit;
			*pt=nbcouple;
			nbcodebloc=nbcouple*sizeof(event)+1;
			pt+=nbcodebloc;
			nbcode+=nbcodebloc;
			if(nbcode>TAILBUF1-535)
			{
			if(modecod!=1)
			{
			nbcode=(unsigned int)(totbit/8);
			if(totbit!=(long)nbcode*8) nbcode++;
			}
			return(nbcode); // limite le nombre de codes
			}
			}
			else  //modecod=2
			{
			Codzz1(coef,&nbit,&pred);// Codage ZZ avec huffman
			totbit+=nbit;
			nbcode=(unsigned int)(totbit/8);
			if(totbit!=(long)nbcode*8) nbcode++;
			if(nbcode>TAILBUF1-535) return(nbcode); // limite le nombre de codes
			}
		}
	}
	if(modecod==2)
	Codzz1(coef,&nbit,&pred);// Recodage dernier bloc pour vider buf

	if(modecod!=1)
	{
	nbcode=(unsigned int)(totbit/8);
	if(totbit!=(long)nbcode*8) nbcode++;
	}
	return(nbcode);
}

/*-------------------------------------------------------------------------*/

void far Decode_dct(char modecod,int qualite,unsigned char far *image,unsigned char *tabcode)
{
int x,y;
float im[8][8],tcos[8][8];     // bloc image ; bloc transform
long imint[8][8],tcosint[8][8];// bloc image ; bloc transform
long coef[8][8];       			 //  coef
int pred;                     // prdicteur
char nbcouple;
event *pointcode;
unsigned char *pt;
unsigned int nbcodebloc;
unsigned int nbcode=0;

	bufcomp=tabcode;            // initialise buffer pour huffman
	Inicodec();

	if(qualite!=qual)
	{
	Iniquant(qualite); // pour gagner du temps
	}

	if(!test_ini_huff)  {IniTables();test_ini_huff=1;} // Init tables Huffmann

	pt=tabcode;

	for(y=0;y<256;y+=8)
	{
	pred=0;	    	  // prdicteur = 0 en dbut de ligne
		for(x=0;x<256;x+=8)
		{
			if(modecod==1||modecod=='0'||modecod=='1')
			{
			nbcouple=*pt;
			pointcode=(event *)(pt+1);
			Decodzz(coef,pointcode,&pred,nbcouple);        // dcodage
			}
			else
			Decodzz1(coef,&pred);        // dcodage

			switch(modecod)
			{
			case '0' :                       // flottant

			Dequant(coef,tcos,Q);          // Dquantif.
			Idct1(im,tcos,C,Base);         	// Tf. inverse
			Ecrit_bloc(x,y,&im[0][0],image);

			break;

			case '1' :
			case 1:
			case 2:

			Dequantint(coef,tcosint,Q);
			//Idctint1(imint,tcosint,Cint,Baseint);
			ChenIDct(&tcosint[0][0],&imint[0][0]); // T rapide
			Ecrit_blocint(x,y,&imint[0][0],image);
			break;
			}//switch
			if(modecod==1||modecod=='0'||modecod=='1')
			{
			nbcodebloc=nbcouple*sizeof(event)+1;
			pt+=nbcodebloc;
			nbcode+=nbcodebloc;
			if(nbcode>TAILBUF1-535) return;      // limite le nombre de codes
			}
		}//x
	 }//y
}

/*-------------------------------------------------------------------------*/

void far Lit_bloc(int x,int y,float *im,unsigned char far *ptsource)
{
int i,j,k=0;
unsigned char far *pointim;

			for(i=0;i<8;i++)          	// lecture bloc
			{
			pointim=ptsource+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				im[k++]=(float)(*pointim++)-128;
				}
			}
}

/*-------------------------------------------------------------------------*/

void far Lit_blocint(int x,int y,long *imint,unsigned char far *ptsource)
{
int i,j,k=0;
unsigned char far *pointim;

			for(i=0;i<8;i++)           	// lecture bloc
			{
			pointim=ptsource+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				imint[k++]=(long)(*pointim++)-128;
				}
			}
}

/*-------------------------------------------------------------------------*/

void far Lit_blocint(int x,int y,int *imint,unsigned char far *ptsource)
{
int i,j,k=0;
unsigned char far *pointim;

			for(i=0;i<8;i++)           	// lecture bloc
			{
			pointim=ptsource+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				imint[k++]=(int)(*pointim++)-128;
				}
			}
}

/*-------------------------------------------------------------------------*/

void far Ecrit_bloc(int x,int y,float *im,unsigned char far *ptdestin)
{
int i,j,k=0;
unsigned char far *pointim;
int p;

			for(i=0;i<8;i++)              	// Ecriture bloc
			{
				pointim=ptdestin+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				p=(int)(im[k++]+128.5);
				if(p<0)p=0;else if(p>255)p=255;
				*pointim++=(unsigned char)p;
				}
			}
}

/*-------------------------------------------------------------------------*/

void far Ecrit_blocint(int x,int y,long *imint,unsigned char far *ptdestin)
{
int i,j,k=0;
unsigned char far *pointim;
int p;

			for(i=0;i<8;i++)
			{
				pointim=ptdestin+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				p=(int)(imint[k++]+128);
				if(p<0)p=0;else if(p>255)p=255;
				*pointim++=(unsigned char)p;
				}
			}
}

/*-------------------------------------------------------------------------*/
/*
void far Ecrit_blocint(int x,int y,int *imint,unsigned char far *ptdestin)
{
int i,j,k=0;
unsigned char far *pointim;
int p;

			for(i=0;i<8;i++)
			{
				pointim=ptdestin+(x+((i+y)<<8));
				for(j=0;j<8;j++)
				{
				p=(int)(imint[k++]+128);
				if(p<0)p=0;else if(p>255)p=255;
				*pointim++=(unsigned char)p;
				}
			}
}
*/
/*-------------------------------------------------------------------------*/
void far Iniquant(int qualite)
{
int i,j;

	if(qual<0) Inicoeff();   // la premire fois, on initialise tout

	qual=qualite;            // stockage pour initialisation

	if(qualite==0)
	{
		 /* Matrice de quantification JPEG (luminance) */
	Q[0][0]=16;Q[0][1]=11;Q[0][2]=10;Q[0][3]=16;
	Q[0][4]=24;Q[0][5]=40;Q[0][6]=51;Q[0][7]=61;
	Q[1][0]=12;Q[1][1]=12;Q[1][2]=14;Q[1][3]=19;
	Q[1][4]=26;Q[1][5]=58;Q[1][6]=60;Q[1][7]=55;
	Q[2][0]=14;Q[2][1]=13;Q[2][2]=16;Q[2][3]=24;
	Q[2][4]=40;Q[2][5]=57;Q[2][6]=69;Q[2][7]=56;
	Q[3][0]=14;Q[3][1]=17;Q[3][2]=22;Q[3][3]=29;
	Q[3][4]=51;Q[3][5]=87;Q[3][6]=80;Q[3][7]=62;
	Q[4][0]=18;Q[4][1]=22;Q[4][2]=37;Q[4][3]=56;
	Q[4][4]=68;Q[4][5]=109;Q[4][6]=103;Q[4][7]=77;
	Q[5][0]=24;Q[5][1]=35;Q[5][2]=55;Q[5][3]=64;
	Q[5][4]=81;Q[5][5]=104;Q[5][6]=113;Q[5][7]=92;
	Q[6][0]=49;Q[6][1]=64;Q[6][2]=78;Q[6][3]=87;
	Q[6][4]=103;Q[6][5]=121;Q[6][6]=120;Q[6][7]=101;
	Q[7][0]=72;Q[7][1]=92;Q[7][2]=95;Q[7][3]=98;
	Q[7][4]=112;Q[7][5]=100;Q[7][6]=103;Q[7][7]=99;
	}
	else
	{
	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
		Q[i][j]=1+((1+i+j)*qualite);      // Q calcul
		}
	}
	}

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
		Q8[i][j]=8*Q[i][j];
		}
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 I NI C O E F F                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Initialisation de tableaux pour DCT                         */
/*  Paramtres en entre : qualite 														*/
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Inicoeff(void)
{
int i,j;

	for(i=0;i<8;i++)             /* calcul des coeff de cos */
	{
		for(j=0;j<8;j++)
		{
		C[i][j]=(float)cos((double)((2*i+1)*j)*0.196349)/2.;
		if(j==0) C[i][j]/=1.414214;
		if(C[i][j]>=0) Cint[i][j]=(long)(C[i][j]*256.+0.5);
		else Cint[i][j]=(long)(C[i][j]*256.-0.5);
		}
	}

	Transpmat(C,Base);
	Transpmatint(Cint,Baseint);

		/* Vecteur de Zig-zag */
		/* Z[k] -> 8*i +j     */

	Z[0]=0;Z[1]=1;Z[2]=8;Z[3]=16;
	Z[4]=9;Z[5]=2;Z[6]=3;Z[7]=10;
	Z[8]=17;Z[9]=24;Z[10]=32;Z[11]=25;
	Z[12]=18;Z[13]=11;Z[14]=4;Z[15]=5;
	Z[16]=12;Z[17]=19;Z[18]=26;Z[19]=33;
	Z[20]=40;Z[21]=48;Z[22]=41;Z[23]=34;
	Z[24]=27;Z[25]=20;Z[26]=13;Z[27]=6;
	Z[28]=7;Z[29]=14;Z[30]=21;Z[31]=28;
	Z[32]=35;Z[33]=42;Z[34]=49;Z[35]=56;
	Z[36]=57;Z[37]=50;Z[38]=43;Z[39]=36;
	Z[40]=29;Z[41]=22;Z[42]=15;Z[43]=23;
	Z[44]=30;Z[45]=37;Z[46]=44;Z[47]=51;
	Z[48]=58;Z[49]=59;Z[50]=52;Z[51]=45;
	Z[52]=38;Z[53]=31;Z[54]=39;Z[55]=46;
	Z[56]=53;Z[57]=60;Z[58]=61;Z[59]=54;
	Z[60]=47;Z[61]=55;Z[62]=62;Z[63]=63;

		 /* Tableau de longueur de code AC n0 */

	Tabac0[0][0]=4;Tabac0[0][1]=2;Tabac0[0][2]=2;Tabac0[0][3]=3;
	Tabac0[0][4]=4;Tabac0[0][5]=5;Tabac0[0][6]=6;Tabac0[0][7]=7;
	Tabac0[0][8]=10;Tabac0[0][9]=16;Tabac0[0][10]=16;

	Tabac0[1][1]=4;Tabac0[1][2]=6;Tabac0[1][3]=7;Tabac0[1][4]=9;
	Tabac0[1][5]=11;Tabac0[1][6]=16;Tabac0[1][7]=16;
	Tabac0[1][8]=16;Tabac0[1][9]=16;Tabac0[1][10]=16;

	Tabac0[2][1]=5;Tabac0[2][2]=8;Tabac0[2][3]=10;
	Tabac0[2][4]=16;Tabac0[2][5]=16;Tabac0[2][6]=16;
	Tabac0[2][7]=16;Tabac0[2][8]=16;Tabac0[2][9]=16;Tabac0[2][10]=16;

	Tabac0[3][1]=6;Tabac0[3][2]=9;Tabac0[3][3]=11;
	Tabac0[3][4]=16;Tabac0[3][5]=16;Tabac0[3][6]=16;Tabac0[3][7]=16;
	Tabac0[3][8]=16;Tabac0[3][9]=16;Tabac0[3][10]=16;

	Tabac0[4][1]=6;Tabac0[4][2]=10;Tabac0[4][3]=16;
	Tabac0[4][4]=16;Tabac0[4][5]=16;Tabac0[4][6]=16;Tabac0[4][7]=16;
	Tabac0[4][8]=16;Tabac0[4][9]=16;Tabac0[4][10]=16;

	Tabac0[5][1]=7;Tabac0[5][2]=10;Tabac0[5][3]=16;
	Tabac0[5][4]=16;Tabac0[5][5]=16;Tabac0[5][6]=16;Tabac0[5][7]=16;
	Tabac0[5][8]=16;Tabac0[5][9]=16;Tabac0[5][10]=16;

	Tabac0[6][1]=7;Tabac0[6][2]=11;Tabac0[6][3]=16;
	Tabac0[6][4]=16;Tabac0[6][5]=16;Tabac0[6][6]=16;Tabac0[6][7]=16;
	Tabac0[6][8]=16;Tabac0[6][9]=16;Tabac0[6][10]=16;

	Tabac0[7][1]=8;Tabac0[7][2]=11;Tabac0[7][3]=16;
	Tabac0[7][4]=16;Tabac0[7][5]=16;Tabac0[7][6]=16;Tabac0[7][7]=16;
	Tabac0[7][8]=16;Tabac0[7][9]=16;Tabac0[7][10]=16;

	Tabac0[8][1]=8;Tabac0[8][2]=15;Tabac0[8][3]=16;
	Tabac0[8][4]=16;Tabac0[8][5]=16;Tabac0[8][6]=16;Tabac0[8][7]=16;
	Tabac0[8][8]=16;Tabac0[8][9]=16;Tabac0[8][10]=16;

	Tabac0[9][1]=9;Tabac0[9][2]=16;Tabac0[9][3]=16;
	Tabac0[9][4]=16;Tabac0[9][5]=16;Tabac0[9][6]=16;Tabac0[9][7]=16;
	Tabac0[9][8]=16;Tabac0[9][9]=16;Tabac0[9][10]=16;

	Tabac0[10][1]=9;Tabac0[10][2]=16;Tabac0[10][3]=16;
	Tabac0[10][4]=16;Tabac0[10][5]=16;Tabac0[10][6]=16;Tabac0[10][7]=16;
	Tabac0[10][8]=16;Tabac0[10][9]=16;Tabac0[10][10]=16;

	Tabac0[11][1]=9;Tabac0[11][2]=16;Tabac0[11][3]=16;
	Tabac0[11][4]=16;Tabac0[11][5]=16;Tabac0[11][6]=16;Tabac0[11][7]=16;
	Tabac0[11][8]=16;Tabac0[11][9]=16;Tabac0[11][10]=16;

	Tabac0[12][1]=10;Tabac0[12][2]=16;Tabac0[12][3]=16;
	Tabac0[12][4]=16;Tabac0[12][5]=16;Tabac0[12][6]=16;Tabac0[12][7]=16;
	Tabac0[12][8]=16;Tabac0[12][9]=16;Tabac0[12][10]=16;

	Tabac0[13][1]=11;Tabac0[13][2]=16;Tabac0[13][3]=16;
	Tabac0[13][4]=16;Tabac0[13][5]=16;Tabac0[13][6]=16;Tabac0[13][7]=16;
	Tabac0[13][8]=16;Tabac0[13][9]=16;Tabac0[13][10]=16;

	Tabac0[14][1]=12;Tabac0[14][2]=16;Tabac0[14][3]=16;
	Tabac0[14][4]=16;Tabac0[14][5]=16;Tabac0[14][6]=16;Tabac0[14][7]=16;
	Tabac0[14][8]=16;Tabac0[14][9]=16;Tabac0[14][10]=16;

	Tabac0[15][0]=12;Tabac0[15][1]=16;Tabac0[15][2]=16;Tabac0[15][3]=16;
	Tabac0[15][4]=16;Tabac0[15][5]=16;Tabac0[15][6]=16;Tabac0[15][7]=16;
	Tabac0[15][8]=16;Tabac0[15][9]=16;Tabac0[15][10]=16;

	  /* Tableau de longueur de code DC n0 */

	Tabdc0[0]=3;Tabdc0[1]=3;Tabdc0[2]=3;Tabdc0[3]=2;Tabdc0[4]=3;
	Tabdc0[5]=3;Tabdc0[6]=4;Tabdc0[7]=5;Tabdc0[8]=6;Tabdc0[9]=7;
	Tabdc0[10]=8;Tabdc0[11]=9;
}

/*-------------------------------------------------------------------------*/

void far Razstat(void)
{
int i,j;

	for(j=0;j<16;j++) {Statdc[j]=0;}

	for(i=0;i<16;i++)
	{
		for(j=0;j<16;j++)
		{
		Statac[i][j]=0;
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Mulmat(float X[8][8],float Y[8][8],float Z[8][8])
{
int i,j,k;
float p;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
		p=0;
			for(k=0;k<8;k++)
			{
				p+=X[i][k]*Y[k][j];
			}
		Z[i][j]=p;
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Transpmat(float X[8][8],float Y[8][8])
{
int i,j;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
			Y[i][j]=X[j][i];
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Fdct1(float im[8][8],float tcos[8][8],float C[8][8],float Base[8][8])
{
float A[8][8];

	Mulmat(Base,im,A);
	Mulmat(A,C,tcos);
}

/*-------------------------------------------------------------------------*/

void far Idct1(float im[8][8],float tcos[8][8],float C[8][8],float Base[8][8])
{
float A[8][8];

	Mulmat(C,tcos,A);
	Mulmat(A,Base,im);
}

/*-------------------------------------------------------------------------*/

void far Mulmatint(long X[8][8],long Y[8][8],long Z[8][8])
{
int i,j,k;
long p;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
		p=0;
			for(k=0;k<8;k++)
			{
				p+=X[i][k]*Y[k][j];
			}
		Z[i][j]=p;
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Transpmatint(long X[8][8],long Y[8][8])
{
int i,j;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
			Y[i][j]=X[j][i];
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Divmatint(long X[8][8])
{
int i,j;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
		X[i][j]>>=16;
		}
	}
}

/*-------------------------------------------------------------------------*/

void far Fdctint1(long imint[8][8],long tcosint[8][8],long Cint[8][8],
		long Baseint[8][8])
{
long A[8][8];

	Mulmatint(Baseint,imint,A);
	Mulmatint(A,Cint,tcosint);
	Divmatint(tcosint);
}

/*-------------------------------------------------------------------------*/

void far Idctint1(long imint[8][8],long tcosint[8][8],long Cint[8][8],
		long Baseint[8][8])
{
long A[8][8];

	Mulmatint(Cint,tcosint,A);
	Mulmatint(A,Baseint,imint);
	Divmatint(imint);
}

/*-------------------------------------------------------------------------*/

void far Quantif(long coef[8][8],float tcos[8][8],long Q[8][8])
{
int i;
long q,*Q1,*coef1;
float t,*tcos1;

	tcos1=&tcos[0][0];
	Q1=&Q[0][0];
	coef1=&coef[0][0];

	for(i=0;i<64;i++)
	{
		t=tcos1[i];
		q=Q1[i];
		if(t>=0)
		coef1[i]=((long)(t+(q>>1)))/q;
		else
		coef1[i]=((long)(t-(q>>1)))/q;
	}
}

/*-------------------------------------------------------------------------*/

void far Dequant(long coef[8][8],float tcos[8][8],long Q[8][8])
{
int i;
long t,*Q1,*coef1;
float *tcos1;

	tcos1=&tcos[0][0];
	Q1=&Q[0][0];
	coef1=&coef[0][0];
	for(i=0;i<64;i++)
	{
		t=coef1[i];
		if(t==0) tcos1[i]=0;
		else 	 tcos1[i]=(float)(t*Q1[i]);
	}
}

/*-------------------------------------------------------------------------*/

void far Quantifint(long coef[8][8],long tcosint[8][8],long Q[8][8])
{
int i;
long t,q,*Q1,*coef1,*tcosint1;

	tcosint1=&tcosint[0][0];
	Q1=&Q[0][0];
	coef1=&coef[0][0];

	for(i=0;i<64;i++)
	{
		t=tcosint1[i];
		q=Q1[i];
		if(t>=0)
		coef1[i]=(t+(q>>1))/q;
		else
		coef1[i]=(t-(q>>1))/q;
	}
}

/*-------------------------------------------------------------------------*/

void far Quantifint(long coef[8][8],int tcosint[8][8],long Q[8][8])
{
int i;
long q,*Q1,*coef1;
int t,*tcosint1;

	tcosint1=&tcosint[0][0];
	Q1=&Q[0][0];
	coef1=&coef[0][0];

	for(i=0;i<64;i++)
	{
		t=tcosint1[i];
		q=Q1[i];
		if(t>=0)
		coef1[i]=(t+(q>>1))/q;
		else
		coef1[i]=(t-(q>>1))/q;
	}
}

/*-------------------------------------------------------------------------*/

void far Dequantint(long coef[8][8],long tcosint[8][8],long Q[8][8])
{
int i;
long t,*Q1,*coef1,*tcosint1;

	tcosint1=&tcosint[0][0];
	Q1=&Q[0][0];
	coef1=&coef[0][0];

	for(i=0;i<64;i++)
	{
		t=coef1[i];
		if(t==0) tcosint1[i]=0;
		else
		tcosint1[i]=t*Q1[i];
	}
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C O D Z Z	                       			   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Codage zig-zag d'un bloc	                                 */
/*  Paramtres en entre : tableaux coef,level,run,*nbit,*pred				   */
/*  Valeur retourne : nombre de couples (run,level)                       */
/*-------------------------------------------------------------------------*/

char far Codzz(long coef[8][8],event *tabev,unsigned int *nbit,int *pred)
{
int k,a,i,j,l,n,m,cat;
char r;

	k=0;
	r=0;
	n=0;      // indice pour les (run,level)
	*nbit=0;  // nb de bits du bloc

	/* Code DC */

	l=(int)coef[0][0]-(*pred);
	*pred=(int)coef[0][0];       // nouvelle valeur de prdiction
	tabev[n].level=l;tabev[n].run=0;n++;
					 /* Calcul nb de bits pour DC */
	//if(l<0) l=-l;
	//for(cat=0;l!=0;l>>=1,cat++){}   // calcul catgorie
	m=abs(l);
	if(m<256) cat=csize[m];
	else {m>>=8;cat=8+csize[m];}

	(*nbit)+=Tabdc0[cat];
	(*nbit)+=cat;
	Statdc[cat]++;             // mise  jour stat

	/* Codes AC */

	while(k!=63)
	{
	k++;
	a=Z[k];i=a>>3;j=a-(i<<3);
	l=(int)coef[i][j];
	if(l!=0)
	 {
		while(r>15)
		 {
		 tabev[n].level=0;tabev[n].run=15;r-=16;n++;
		 (*nbit)+=Tabac0[15][0];
		 Statac[15][0]++;       // mise  jour stat
		 }
		 tabev[n].level=l;tabev[n].run=r;

		 //if(l<0) l=-l;           /* Calcul nb de bits pour AC */
		 //for(cat=0;l!=0;l>>=1,cat++){} // calcul catgorie
		 m=abs(l);
		 if(m<256) cat=csize[m];
		 else {m>>=8;cat=8+csize[m];}
		 (*nbit)+=Tabac0[r][cat];
		 (*nbit)+=cat;
		 Statac[r][cat]++;     // mise  jour stat
		 r=0;n++;
	 }  //if
	else          // l=0
	 {
			if(k==63)
			{
			//tabev[n].level=0;                // marqueur fin de bloc
			//tabev[n].run=0;
			//n++;
			(*nbit)+=Tabac0[0][0];          // EOB -> 4 bits
			Statac[0][0]++;        // mise  jour stat
			}
			else r++;
	 } //else
	 } //while
	return(n);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 D E C O D Z Z	                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcodage zig-zag d'un bloc                                  */
/*  Paramtres en entre : tableaux coef,Z,level,run			   */
/*  Valeur retourne : aucune			                           */
/*-------------------------------------------------------------------------*/

void far Decodzz(long coef[8][8],event *tabev,int *pred,char nbcouple)
{
int i,j;
int k=0,r,n=0,a,l;
long * coef1;

	// RAZ coeff
	coef1=&coef[0][0];
	for(i=0;i<64;i++) coef1[i]=0;

	/* DC */

	coef[0][0]=(long)(tabev[0].level+(*pred));
	*pred=(int)coef[0][0];       // nouvelle valeur de prdiction

	n++;k++;

	/* AC */

	while(n<nbcouple)
	{
	r=tabev[n].run;l=tabev[n].level;
	//if(r==0&&l==0) break;
	k+=r;
	a=Z[k];i=a>>3;j=a-(i<<3);
	coef[i][j]=(long)l;
	n++;k++;
	}
	}

/*-------------------------------------------------------------------------*/
/*chendct.c

A simple DCT algorithm that seems to have fairly nice arithmetic
properties.

W. H. Chen, C. H. Smith and S. C. Fralick "A fast computational
algorithm for the discrete cosine transform," IEEE Trans. Commun.,
vol. COM-25, pp. 1004-1009, Sept 1977.

*/

/* Standard Macros */

#define NO_MULTIPLY

#ifdef NO_MULTIPLY
#define LS(r,s) ((r) << (s))
#define RS(r,s) ((r) >> (s))       /* Caution with rounding... */
#else
#define LS(r,s) ((r) * (1 << (s)))
#define RS(r,s) ((r) / (1 << (s))) /* Correct rounding */
#endif

#define MSCALE(expr)  RS((expr),9)

/* Cos constants */

#define c1d4 362L

#define c1d8 473L
#define c3d8 196L

#define c1d16 502L
#define c3d16 426L
#define c5d16 284L
#define c7d16 100L

/*
  VECTOR_DEFINITION makes the temporary variables vectors.
  Useful for machines with small register spaces.

*/
#define VECTOR_DEFINITION

#ifdef VECTOR_DEFINITION
#define a0 a[0]
#define a1 a[1]
#define a2 a[2]
#define a3 a[3]
#define b0 b[0]
#define b1 b[1]
#define b2 b[2]
#define b3 b[3]
#define c0 c[0]
#define c1 c[1]
#define c2 c[2]
#define c3 c[3]
#endif

/*START*/
/*BFUNC

ChenDCT() implements the Chen forward dct. Note that there are two
input vectors that represent x=input, and y=output, and must be
defined (and storage allocated) before this routine is called.

EFUNC*/

void ChenDct(long *x,long *y)
	  {
  register int i;
  register long *aptr,*bptr;
#ifdef VECTOR_DEFINITION
  register long a[4];
  register long b[4];
  register long c[4];
#else  
  register long a0,a1,a2,a3;
  register long b0,b1,b2,b3;
  register long c0,c1,c2,c3;
#endif

  /* Loop over columns */

  for(i=0;i<8;i++)
    {
      aptr = x+i;
		bptr = aptr+56;

      a0 = LS((*aptr+*bptr),2);
      c3 = LS((*aptr-*bptr),2);
		aptr += 8;
      bptr -= 8;
      a1 = LS((*aptr+*bptr),2);
      c2 = LS((*aptr-*bptr),2);
      aptr += 8;
      bptr -= 8;
      a2 = LS((*aptr+*bptr),2);
      c1 = LS((*aptr-*bptr),2);
		aptr += 8;
		bptr -= 8;
      a3 = LS((*aptr+*bptr),2);
		c0 = LS((*aptr-*bptr),2);
      
      b0 = a0+a3;
      b1 = a1+a2;
      b2 = a1-a2;
      b3 = a0-a3;

		aptr = y+i;

      *aptr = MSCALE(c1d4*(b0+b1));
      aptr[32] = MSCALE(c1d4*(b0-b1));

      aptr[16] = MSCALE((c3d8*b2)+(c1d8*b3));
      aptr[48] = MSCALE((c3d8*b3)-(c1d8*b2));

      b0 = MSCALE(c1d4*(c2-c1));
      b1 = MSCALE(c1d4*(c2+c1));

      a0 = c0+b0;
		a1 = c0-b0;
		a2 = c3-b1;
      a3 = c3+b1;

      aptr[8] = MSCALE((c7d16*a0)+(c1d16*a3));
      aptr[24] = MSCALE((c3d16*a2)-(c5d16*a1));
      aptr[40] = MSCALE((c3d16*a1)+(c5d16*a2));
      aptr[56] = MSCALE((c7d16*a3)-(c1d16*a0));
    }
  
  for(i=0;i<8;i++)
    {       /* Loop over rows */
      aptr = y+LS(i,3);
      bptr = aptr+7;

      c3 = RS((*(aptr)-*(bptr)),1);
      a0 = RS((*(aptr++)+*(bptr--)),1);
      c2 = RS((*(aptr)-*(bptr)),1);
      a1 = RS((*(aptr++)+*(bptr--)),1);
      c1 = RS((*(aptr)-*(bptr)),1);
      a2 = RS((*(aptr++)+*(bptr--)),1);
      c0 = RS((*(aptr)-*(bptr)),1);
		a3 = RS((*(aptr)+*(bptr)),1);

      b0 = a0+a3;
		b1 = a1+a2;
      b2 = a1-a2;
      b3 = a0-a3;

      aptr = y+LS(i,3);
      
      *aptr = MSCALE(c1d4*(b0+b1));
		aptr[4] = MSCALE(c1d4*(b0-b1));
      aptr[2] = MSCALE((c3d8*b2)+(c1d8*b3));
      aptr[6] = MSCALE((c3d8*b3)-(c1d8*b2));

		b0 = MSCALE(c1d4*(c2-c1));
      b1 = MSCALE(c1d4*(c2+c1));

      a0 = c0+b0;
      a1 = c0-b0;
      a2 = c3-b1;
      a3 = c3+b1;

		aptr[1] = MSCALE((c7d16*a0)+(c1d16*a3));
		aptr[3] = MSCALE((c3d16*a2)-(c5d16*a1));
      aptr[5] = MSCALE((c3d16*a1)+(c5d16*a2));
		aptr[7] = MSCALE((c7d16*a3)-(c1d16*a0));
    }

  /* We have an additional factor of 8 in the Chen algorithm. */

//  for(i=0,aptr=y;i<64;i++,aptr++)
//    *aptr = (((*aptr<0) ? (*aptr-4) : (*aptr+4))/8);
}

/*-------------------------------------------------------------------------*/

/*BFUNC

ChenIDCT() implements the Chen inverse dct. Note that there are two
input vectors that represent x=input, and y=output, and must be
defined (and storage allocated) before this routine is called.

EFUNC*/

void ChenIDct(long *x,long *y)
	  {
  register int i;
  register long *aptr;
#ifdef VECTOR_DEFINITION
  register long a[4];
  register long b[4];
  register long c[4];
#else  
  register long a0,a1,a2,a3;
  register long b0,b1,b2,b3;
  register long c0,c1,c2,c3;
#endif

  /* Loop over columns */

  for(i=0;i<8;i++)
	 {
      aptr = x+i;
      b0 = LS(*aptr,2);
      aptr += 8;
		a0 = LS(*aptr,2);
      aptr += 8;
      b2 = LS(*aptr,2);
		aptr += 8;
		a1 = LS(*aptr,2);
		aptr += 8;
      b1 = LS(*aptr,2);
      aptr += 8;
      a2 = LS(*aptr,2);
      aptr += 8;
      b3 = LS(*aptr,2);
      aptr += 8;
		a3 = LS(*aptr,2);
      
      /* Split into even mode  b0 = x0  b1 = x4  b2 = x2  b3 = x6.
	 And the odd terms a0 = x1 a1 = x3 a2 = x5 a3 = x7.
	 */

		c0 = MSCALE((c7d16*a0)-(c1d16*a3));
      c1 = MSCALE((c3d16*a2)-(c5d16*a1));
      c2 = MSCALE((c3d16*a1)+(c5d16*a2));
      c3 = MSCALE((c1d16*a0)+(c7d16*a3));

      /* First Butterfly on even terms.*/

		a0 = MSCALE(c1d4*(b0+b1));
		a1 = MSCALE(c1d4*(b0-b1));

      a2 = MSCALE((c3d8*b2)-(c1d8*b3));
      a3 = MSCALE((c1d8*b2)+(c3d8*b3));

      b0 = a0+a3;
      b1 = a1+a2;
      b2 = a1-a2;
		b3 = a0-a3;

      /* Second Butterfly */

      a0 = c0+c1;
      a1 = c0-c1;
		a2 = c3-c2;
      a3 = c3+c2;

      c0 = a0;
		c1 = MSCALE(c1d4*(a2-a1));
      c2 = MSCALE(c1d4*(a2+a1));
      c3 = a3;

		aptr = y+i;
		*aptr = b0+c3;
      aptr += 8;
      *aptr = b1+c2;
      aptr += 8;
      *aptr = b2+c1;
      aptr += 8;
      *aptr = b3+c0;
		aptr += 8;
      *aptr = b3-c0;
      aptr += 8;
      *aptr = b2-c1;
      aptr += 8;
      *aptr = b1-c2;
		aptr += 8;
      *aptr = b0-c3;
    }

  /* Loop over rows */

  for(i=0;i<8;i++)
	 {
		aptr = y+LS(i,3);
		b0 = *(aptr++);
      a0 = *(aptr++);
      b2 = *(aptr++);
      a1 = *(aptr++);
      b1 = *(aptr++);
      a2 = *(aptr++);
      b3 = *(aptr++);
		a3 = *(aptr);
      
      /*
	Split into even mode  b0 = x0  b1 = x4  b2 = x2  b3 = x6.
	And the odd terms a0 = x1 a1 = x3 a2 = x5 a3 = x7.
	*/

      c0 = MSCALE((c7d16*a0)-(c1d16*a3));
      c1 = MSCALE((c3d16*a2)-(c5d16*a1));
      c2 = MSCALE((c3d16*a1)+(c5d16*a2));
		c3 = MSCALE((c1d16*a0)+(c7d16*a3));

      /* First Butterfly on even terms.*/

		a0 = MSCALE(c1d4*(b0+b1));
		a1 = MSCALE(c1d4*(b0-b1));

      a2 = MSCALE((c3d8*b2)-(c1d8*b3));
      a3 = MSCALE((c1d8*b2)+(c3d8*b3));

      /* Calculate last set of b's */

		b0 = a0+a3;
      b1 = a1+a2;
      b2 = a1-a2;
      b3 = a0-a3;

      /* Second Butterfly */

      a0 = c0+c1;
      a1 = c0-c1;
      a2 = c3-c2;
		a3 = c3+c2;

      c0 = a0;
		c1 = MSCALE(c1d4*(a2-a1));
		c2 = MSCALE(c1d4*(a2+a1));
		c3 = a3;

      aptr = y+LS(i,3);
      *(aptr++) = b0+c3;
      *(aptr++) = b1+c2;
      *(aptr++) = b2+c1;
      *(aptr++) = b3+c0;
		*(aptr++) = b3-c0;
      *(aptr++) = b2-c1;
		*(aptr++) = b1-c2;
      *(aptr) = b0-c3;
    }
  
  /*
    Retrieve correct accuracy. We have additional factor
    of 16 that must be removed.
	*/

  for(i=0,aptr=y;i<64;i++,aptr++)
  *aptr = (((*aptr<0) ? (*aptr-8) : (*aptr+8)) /16);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 C O D Z Z	                       			   */
/*-------------------------------------------------------------------------*/
/*  Fonction : Codage zig-zag d'un bloc	                                 */
/*  Paramtres en entre : tableaux coef,*nbit,*pred							   */
/*  Valeur retourne : aucune									                     */
/*-------------------------------------------------------------------------*/

void far Codzz1(long coef[8][8],unsigned int *nbit,int *pred)
{
int k,a,i,j,l,m,cat;
char r;
//int n;

	k=0;
	r=0;
  //	n=0;      // indice pour les (run,level)
	*nbit=0;  // nb de bits du bloc

	/* Code DC */

	l=(int)coef[0][0]-(*pred);
	*pred=(int)coef[0][0];       // nouvelle valeur de prdiction

					 /* Calcul nb de bits pour DC */
	m=abs(l);
	if(m<256) cat=csize[m];
	else {m>>=8;cat=8+csize[m];}

	UseDCHuffman();

	(*nbit)+= EncodeHuffman(cat);     /* Encode size */
	if (l < 0)                  /* Encode difference */
	 {
			l--;
	 }
	meputv(cat,l);

	(*nbit)+=cat;

  //n++;                          // pour compter les vnements

	/* Codes AC */

	UseACHuffman();

	while(k!=63)
	{
	k++;
	a=Z[k];i=a>>3;j=a-(i<<3);
	l=(int)coef[i][j];
	if(l!=0)
	 {
		while(r>15)
		 {
		 r-=16;
		 //n++;
		 (*nbit)+=EncodeHuffman(240);
		 }

		  /* Calcul nb de bits pour AC */
		 m=abs(l);
		 if(m<256) cat=csize[m];
		 else {m>>=8;cat=8+csize[m];}

		(*nbit)+=EncodeHuffman(16*r+cat);             /* Encode RLE code */
		if (l < 0)                /* Encode difference */
		{
		l--;
		}
		meputv(cat,l);
		(*nbit)+=cat;
		r=0;
		//n++;                          // pour compter les vnements
	 }  //if
	else          // l=0
	 {
			if(k==63)
			{
			(*nbit)+=EncodeHuffman(0);
			//n++;                          // pour compter les vnements
			}
			else r++;
	 } //else
	 } //while
 //	return(n);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                 D E C O D Z Z	                    		      */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcodage zig-zag d'un bloc                                 	*/
/*  Paramtres en entre : tableaux coef,pred					 				   */
/*  Valeur retourne : aucune			                          			      */
/*-------------------------------------------------------------------------*/

void far Decodzz1(long coef[8][8],int *pred)
{
int i,j;
int k=0,r,a,cat;
long l;
long * coef1;
int s;
long diff;

	// RAZ coeff
	coef1=&coef[0][0];
	//for(i=1;i<64;i++)
	i=63;
	while(i)
	{
	 coef1[i--]=0;
	}
	/* DC */

	UseDCHuffman();

  s=(int)DecodeHuffman();
  diff=0;
  if(s)
	 {
		diff=megetv(s);
		s--;                                  /* 2's Bit Align */
		if((diff & bit_set_mask[s])==0)
		{
		diff |= extend_mask[s];
		diff++;
		}
	 }
	coef[0][0]=diff+(long)(*pred);
	*pred=(int)coef[0][0];       // nouvelle valeur de prdiction

   k++;

	/* AC */

	UseACHuffman();

  while(k<64)  /* JPEG Mistake */
  {
  s =(int)DecodeHuffman();                         /* Decode Huffman */
  cat = s & 0xf;                                 /* Find significant bits */
  r = (s >> 4) & 0xf;                          /* r = run-length */
  if(cat)
		{
		if((k += r)>=64) break;          	/* JPEG Mistake */
		l=megetv(cat);                    		/* Get s bits */
		cat--; /* Align s */
		if((l& bit_set_mask[cat])==0)  		/* Also (1 << s) */
			{
			l |= extend_mask[cat];         	/* Also  (-1 << s) + 1 */
			l++;                         		/* Increment 2's c */
			}
		a=Z[k];i=a>>3;j=a-(i<<3);
		coef[i][j]=l;
		k++;                                     /* Goto next element */
		}//if
  else if(r==15)                      /* Zero run length code extnd */
		k+=16;
		else
		{
		break;
		}
  } //while
}


/*-------------------------------------------------------------------------*/


// Perform the forward DCT on one block of samples.


typedef long INT32;
#define DCTSIZE 8

#define CONST_BITS  8

#define FIX_0_382683433  ((INT32)   98)
#define FIX_0_541196100  ((INT32)  139)
#define FIX_0_707106781  ((INT32)  181)
#define FIX_1_306562965  ((INT32)  334)

#define RIGHT_SHIFT(x,shft)	((x) >> (shft))

#define DESCALE(x,n)  RIGHT_SHIFT(x, n)

#define MULTIPLY(var,const)  ((DCTELEM) DESCALE((var) * (const), CONST_BITS))

// Perform the forward DCT on one block of samples.

void jpeg_fdct_ifast(DCTELEM * data)
{
  DCTELEM tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7;
  DCTELEM tmp10, tmp11, tmp12, tmp13;
  DCTELEM z1, z2, z3, z4, z5, z11, z13;
  DCTELEM *dataptr;
  int ctr;
  //SHIFT_TEMPS

  // Pass 1: process rows.

  dataptr = data;
  for (ctr = DCTSIZE-1; ctr >= 0; ctr--) {
	 tmp0 = dataptr[0] + dataptr[7];
	 tmp7 = dataptr[0] - dataptr[7];
	 tmp1 = dataptr[1] + dataptr[6];
	 tmp6 = dataptr[1] - dataptr[6];
	 tmp2 = dataptr[2] + dataptr[5];
	 tmp5 = dataptr[2] - dataptr[5];
	 tmp3 = dataptr[3] + dataptr[4];
	 tmp4 = dataptr[3] - dataptr[4];

	 // Even part

	 tmp10 = tmp0 + tmp3;	// phase 2
	 tmp13 = tmp0 - tmp3;
	 tmp11 = tmp1 + tmp2;
	 tmp12 = tmp1 - tmp2;

	 dataptr[0] = tmp10 + tmp11; // phase 3
	 dataptr[4] = tmp10 - tmp11;

	 z1 = MULTIPLY(tmp12 + tmp13, FIX_0_707106781); // c4
	 dataptr[2] = tmp13 + z1;	// phase 5
	 dataptr[6] = tmp13 - z1;

	 // Odd part

	 tmp10 = tmp4 + tmp5;	// phase 2
	 tmp11 = tmp5 + tmp6;
	 tmp12 = tmp6 + tmp7;

	 // The rotator is modified from fig 4-8 to avoid extra negations.
	 z5 = MULTIPLY(tmp10 - tmp12, FIX_0_382683433); // c6
	 z2 = MULTIPLY(tmp10, FIX_0_541196100) + z5; // c2-c6
	 z4 = MULTIPLY(tmp12, FIX_1_306562965) + z5; // c2+c6
	 z3 = MULTIPLY(tmp11, FIX_0_707106781); // c4

	 z11 = tmp7 + z3;		// phase 5
	 z13 = tmp7 - z3;

	 dataptr[5] = z13 + z2;	// phase 6
	 dataptr[3] = z13 - z2;
	 dataptr[1] = z11 + z4;
	 dataptr[7] = z11 - z4;

	 dataptr += DCTSIZE;		// advance pointer to next row
  }

  // Pass 2: process columns.

  dataptr = data;
  for (ctr = DCTSIZE-1; ctr >= 0; ctr--) {
	 tmp0 = dataptr[DCTSIZE*0] + dataptr[DCTSIZE*7];
	 tmp7 = dataptr[DCTSIZE*0] - dataptr[DCTSIZE*7];
	 tmp1 = dataptr[DCTSIZE*1] + dataptr[DCTSIZE*6];
	 tmp6 = dataptr[DCTSIZE*1] - dataptr[DCTSIZE*6];
	 tmp2 = dataptr[DCTSIZE*2] + dataptr[DCTSIZE*5];
	 tmp5 = dataptr[DCTSIZE*2] - dataptr[DCTSIZE*5];
	 tmp3 = dataptr[DCTSIZE*3] + dataptr[DCTSIZE*4];
	 tmp4 = dataptr[DCTSIZE*3] - dataptr[DCTSIZE*4];

	 // Even part

	 tmp10 = tmp0 + tmp3;	// phase 2
	 tmp13 = tmp0 - tmp3;
	 tmp11 = tmp1 + tmp2;
	 tmp12 = tmp1 - tmp2;

	 dataptr[DCTSIZE*0] = tmp10 + tmp11; // phase 3
	 dataptr[DCTSIZE*4] = tmp10 - tmp11;

	 z1 = MULTIPLY(tmp12 + tmp13, FIX_0_707106781); // c4
	 dataptr[DCTSIZE*2] = tmp13 + z1; // phase 5
	 dataptr[DCTSIZE*6] = tmp13 - z1;

	 // Odd part

	 tmp10 = tmp4 + tmp5;	// phase 2
	 tmp11 = tmp5 + tmp6;
	 tmp12 = tmp6 + tmp7;

	 // The rotator is modified from fig 4-8 to avoid extra negations.
	 z5 = MULTIPLY(tmp10 - tmp12, FIX_0_382683433); // c6 
	 z2 = MULTIPLY(tmp10, FIX_0_541196100) + z5; // c2-c6 
	 z4 = MULTIPLY(tmp12, FIX_1_306562965) + z5; // c2+c6 
	 z3 = MULTIPLY(tmp11, FIX_0_707106781); // c4 

	 z11 = tmp7 + z3;		// phase 5 
	 z13 = tmp7 - z3;

	 dataptr[DCTSIZE*5] = z13 + z2; // phase 6
	 dataptr[DCTSIZE*3] = z13 - z2;
	 dataptr[DCTSIZE*1] = z11 + z4;
	 dataptr[DCTSIZE*7] = z11 - z4;

	 dataptr++;			// advance pointer to next column
  }

//  for(int i=0;i<64;i++)
//	 data[i]=(((data[i]<0) ? (data[i]-4) : (data[i]+4))/8);
}

/*-------------------------------------------------------------------------*/


