/***************************************************************/
/*                   W L D E C B I N . C                       */
/*-------------------------------------------------------------*/
/*    Fonction       : Dcodage - codage d'images binaires     */
/*-------------------------------------------------------------*/
/*    Auteur         : MC                                      */
/*    Dvelopp le   : 22/04/93                                */
/*    Dernire modif.: 03/06/97                                */
/***************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "wgttsi.h"
#include "wldecbin.h"

/*----------------------------------------------*/
/*                                              */
/*              Constantes du programme         */
/*                                              */
/*----------------------------------------------*/

//#define TAILBUF 8192      	/* Taille du buffer de codes */

/*----------------------------------------------*/
/*                                              */
/*              Variables du programme          */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*              Variables externes              */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*           Fonctions prototypes               */
/*                                              */
/*----------------------------------------------*/

/*-------------------------------------------------------------*/
/*                                                             */
/*                   Procdures du programme                   */
/*                                                             */
/*-------------------------------------------------------------*/

void far Incr_buf(int *i,int *flag,int *taille,FILE *in,int *compt,
		unsigned char far bufim[])
{
long poscur,posmax;

	if((*i)>=(*taille)) (*i)-=(*taille);
	fread(bufim,TAILBUF,1,in);            //&bufim[0] TAILBUF
	poscur=ftell(in);
	posmax=(long)TAILBUF*(long)(*compt);
	if(poscur!=posmax) {*flag=1;*taille=(int)(poscur-(posmax-TAILBUF));}
	else {*flag=0;*taille=TAILBUF;}
	(*compt)++;
}

/*-------------------------------------------------------------------------*/

void far Decr_buf(int *i,int *flag,int *taille,FILE *in,int *compt,
	     unsigned char far bufim[])
{
long offset;

	(*i)+=TAILBUF;
	if(*flag==0)	{offset=-2*TAILBUF;}
	else		{offset=-(TAILBUF+(*taille));*taille=TAILBUF;}
	fseek(in,offset,SEEK_CUR);
	fread(bufim,TAILBUF,1,in);      //&bufim[0]
	(*compt)--;*flag=0;
}

/*-------------------------------------------------------------------------*/

void far Calprec_suiv(int *prec,int *suiv,int *i,int *flag,int *taille,
		FILE *in,int *compt,unsigned char far bufim[])

{
unsigned char p1,p2;

	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
	*prec=(p1<<8)+p2;
	if(*i>=(*taille)&&(*flag)==0) Incr_buf(i,flag,taille,in,compt,bufim);
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
	*suiv=(p1<<8)+p2;
	if(*i>=(*taille)&&(*flag)==0) Incr_buf(i,flag,taille,in,compt,bufim);

}

/*-------------------------------------------------------------------------*/

void far Init_debut(long *nbimage,int *prec,int *suiv,int *i,int *flag,int *taille,
		FILE *in,int *compt,unsigned char far bufim[])

{
	*nbimage=0;*prec=0;*suiv=0;
	*i=0;*flag=0;*compt=1;*taille=TAILBUF;
	rewind(in);
	Incr_buf(i,flag,taille,in,compt,bufim);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   D E C O D B I N                           */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dcodage par segment d'images binaires  partir du disque   */
/*  Paramtres en entre : buffer, image, ....                             */
/*  Valeur retourne : nb de points de l'image                             */
/*-------------------------------------------------------------------------*/

long far Decodbin(int nbcodim,int *i,int *flag,int *taille,FILE *in,
		int *compt,unsigned char far bufim[],unsigned char far *image)
{
unsigned char p1,p2;
unsigned int p,j,nbseg,n,y;
unsigned char far *pointim;
long nbpt=0;

	Eff(image);
	for(j=0;j<nbcodim;)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;j+=2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	nbseg=(unsigned int)p1;y=(unsigned int)p2;
	pointim=image+(y*256);

	for(n=0;n<nbseg;n++)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;j+=2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	for(p=p1;p<=p2;p++) {*(pointim+p)=255;}  	/* trac segment */
	nbpt+=(long)(p2-p1)+1;
	}

	}
	return(nbpt);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   C A L N B P T B I N                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul nb pts d'une image binaire			   			*/
/*  Paramtres en entre : buffer, image, ...	                         */
/*  Valeur retourne : nb pts						   				*/
/*-------------------------------------------------------------------------*/

long far Calnbptbin(int nbcodim,int *i,int *flag,int *taille,FILE *in,
		int *compt,unsigned char far bufim[])
{
unsigned char p1,p2;
int j,nbseg,n;
long nbpt=0;

	for(j=0;j<nbcodim;)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;j+=2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	nbseg=(int)p1;

	for(n=0;n<nbseg;n++)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;j+=2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	nbpt+=(long)(p2-p1)+1;
	}
	}
	return(nbpt);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   S Y N T B I N                             */
/*-------------------------------------------------------------------------*/
/*  Fonction : Synthse d'une image binaire  partir d'un buffer de codes  */
/*  Paramtres en entre : nb de codes, buffer, image                      */
/*  Valeur retourne : aucune			          		               */
/*-------------------------------------------------------------------------*/

void far Syntbin(int nbcodim,unsigned char far bufim[],unsigned char far *image)
{
unsigned char p1,p2;
int p,i,nbseg,n,y;
unsigned char far *pointim;

	Eff(image);
	for(i=0;i<nbcodim;)
	{
	p1=bufim[i];i++;
	p2=bufim[i];i++;
	nbseg=(int)p1;y=(int)p2;
	pointim=image+(y<<8);

	for(n=0;n<nbseg;n++)
	{
	p1=bufim[i];i++;
	p2=bufim[i];i++;
	for(p=p1;p<=p2;p++) {*(pointim+p)=255;}  	/* trac segment */
	}
	}
}
/*-------------------------------------------------------------------------*/
/*  Fonction :                   C O D B I N                               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Codage par segment d'images binaires 			   				*/
/*  Paramtres en entre : buffer, image , cadre, seuil, image seuil 		*/
/*  Valeur retourne : nombre de codes                                     */
/*-------------------------------------------------------------------------*/

int far Codbin(unsigned char far bufim[],unsigned char far *image,
					int xmin,int xmax,int ymin,int ymax,int seuil,
					unsigned char far *image_seuil)
{

int y,x,nbcod=0,nbtrl;
unsigned char far *pointim,*debbuf,*pseuil;
unsigned char p,prec;
int flag;
unsigned char sgn,s;

	if(seuil>=0) {s=seuil;sgn=0;} else {s=-seuil;sgn=255;}

	if(image_seuil==NULL) flag=0;else flag=1;

	for(y=ymin;y<=ymax&&nbcod<=TAILBUF-256;y++)
	{
	pointim=image+(y<<8)+xmin;
	pseuil=image_seuil+(y<<8)+xmin;
	prec=0;nbtrl=0;
	debbuf=bufim;
	bufim+=2;                   		/* place pour codes ligne */
	for(x=xmin;x<=xmax;x++)
		{
		p=*pointim++;
		if(flag==0)                      // seuillage
		{
		if(p>=s) p=255-sgn;else p=sgn;
		}
		else                             //seuillage dynamique
		{
		if(p>=*pseuil++) //p=255;else p=0;
		 p=255-sgn;else p=sgn;
		}

		if(p!=prec)                     /* transition */
			{
			if(p!=0) *bufim++=x;else *bufim++=x-1;
			nbtrl++;nbcod++;
			}
		//if(x==xmax&&p!=0){*bufim++=x;nbtrl++;nbcod++;} /* b.droit */
		prec=p;
		}
		if(p!=0){*bufim++=x-1;nbtrl++;nbcod++;} /* b.droit */

		if(nbtrl!=0)
		{
		*debbuf++=nbtrl>>1;*debbuf++=y; /* nb segments et ordonne */
		nbcod+=2;
		}
	else bufim=debbuf;                      /* rinit pointeur */
	}

	return(nbcod);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    C A L S E U D Y N                      	*/
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul du seuil dynamique du plan source -> destin   		*/
/*  Paramtres en entre : Seuil                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Calseudyn(int seuil,unsigned char far *psour,unsigned char far *pdest)
{
unsigned int i=0;
unsigned char far *pointim1,*pointim2;
float pixel,fact;

	seuil=abs(seuil);
	fact=(float)seuil/255.;

	pointim1=psour;
	pointim2=pdest;
	do
	{
	pixel=(float)(*pointim1++)*fact;
	*pointim2++=(unsigned char)pixel;
	}
	while(++i);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   T R F _ A F F B I N                       */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert de la partie de bufim correspondant  l'image	*/
/*			actuelle dans bufdest, calcul du nombre de points de l'   	*/
/*			image actuelle et du plan destination pour affichage        */
/*			imagette											*/
/*                                                                         */
/*  Paramtres en entre : bufim, bufdest, ....                            */
/*  Valeur retourne : nb de points de l'image                             */
/*-------------------------------------------------------------------------*/

long far Trf_affbin(int nbcodim,int *i,int *flag,int *taille,FILE *in,
		int *compt,unsigned char far bufim[],unsigned char far *image,
		unsigned char far *bufdest)
{
unsigned char p1,p2;
int p,j,nbseg,n,y;
unsigned char far *pointim;
long nbpt=0;

	Eff(image);
	for(j=0;j<nbcodim;)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
	bufdest[j++]=p1;bufdest[j++]=p2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	nbseg=(int)p1;y=(int)p2;
	pointim=image+(y<<8);

	for(n=0;n<nbseg;n++)
		{
		p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
		bufdest[j++]=p1;bufdest[j++]=p2;
		if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
		for(p=p1;p<=p2;p++) {*(pointim+p)=255;}  	/* trac segment */
		nbpt+=(long)(p2-p1)+1;
		}

	}
	return(nbpt);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                   T R F _ B I N       		               */
/*-------------------------------------------------------------------------*/
/*  Fonction : Transfert de la partie de bufim correspondant  l'image	*/
/*			actuelle dans bufdest, calcul du nombre de points de l'   	*/
/*			image actuelle 									*/
/*                                                                         */
/*  Paramtres en entre : bufim, bufdest, ....                            */
/*  Valeur retourne : nb de points de l'image                             */
/*-------------------------------------------------------------------------*/

long far Trf_bin(int nbcodim,int *i,int *flag,int *taille,FILE *in,
		int *compt,unsigned char far bufim[],unsigned char far *bufdest)
{
unsigned char p1,p2;
int j,nbseg,n;
long nbpt=0;

	for(j=0;j<nbcodim;)
	{
	p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
	bufdest[j++]=p1;bufdest[j++]=p2;
	if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
	nbseg=(int)p1;

	for(n=0;n<nbseg;n++)
		{
		p1=bufim[*i];p2=bufim[*i+1];(*i)+=2;
		bufdest[j++]=p1;bufdest[j++]=p2;
		if((*i>=*taille)&&(*flag==0)) Incr_buf(i,flag,taille,in,compt,bufim);
		nbpt+=(long)(p2-p1)+1;
		}

	}
	return(nbpt);
}

/*-------------------------------------------------------------------------*/
