/**********************************************************************/
/*                          W L F I L T . C                           */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'image                             */
/*--------------------------------------------------------------------*/
/*    Auteurs         : MC				                 			      	*/
/*    Dvelopp le   : 17/11/1995                                    */
/*    Dernire modif.: 16/06/1997                                     */
/**********************************************************************/

#include <alloc.h>
#include "wgttsi.h"
#include "wlfilt.h"

/*----------------------------------------------*/
/*																*/
/*		Constantes du programme        				*/
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*																*/
/*		Variables du programme       				   */
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*																*/
/*		Variables externes  								*/
/*																*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*																*/
/*  	     Fonctions prototypes						*/
/*																*/
/*----------------------------------------------*/

void far Ero_dil(char c,unsigned char far *ptsource=0,unsigned char far *ptdestin=0);

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*                         Procdures du programme                         */
/*       																					   */
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :                    C O M P A S S                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage Compass		                                   		*/
/*  Paramtres en entre : type de compass                                 */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Compass(char c,unsigned char far *ptsource,unsigned char far *ptdestin)

{
char A0,A1,A2,A3,A4,A5,A6,A7,A8;    /*  Coeff. de convolution  */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	switch(c)
	{
	case '0' :
			A0=-1;A1=-1;A2=-1;       /* North */
			A3=0;A4=0;A5=0;
			A6=1;A7=1;A8=1;
			break;
	case '1' :
			A0=1;A1=1;A2=1;          /* South */
			A3=0;A4=0;A5=0;
			A6=-1;A7=-1;A8=-1;
			break;
	case '2' :
			A0=1;A1=0;A2=-1;         /* East */
			A3=1;A4=0;A5=-1;
			A6=1;A7=0;A8=-1;
			break;
	case '3' :
			A0=-1;A1=0;A2=1;         /* West */
			A3=-1;A4=0;A5=1;
			A6=-1;A7=0;A8=1;
			break;
	case '4' :
			A0=1;A1=1;A2=0;         /* S-E */
			A3=1;A4=0;A5=-1;
			A6=0;A7=-1;A8=-1;
			break;
	case '5' :
			A0=-1;A1=-1;A2=0;       /* N-W */
			A3=-1;A4=0;A5=1;
			A6=0;A7=1;A8=1;
			break;
	case '6' :
			A0=0;A1=1;A2=1;         /* S-W */
			A3=-1;A4=0;A5=1;
			A6=-1;A7=-1;A8=0;
			break;
	case '7' :
			A0=0;A1=-1;A2=-1;        /* N-E */
			A3=1;A4=0;A5=-1;
			A6=1;A7=1;A8=0;
			break;
	}
	c='m';
	Convol(c,&A0,&A1,&A2,&A3,&A4,&A5,&A6,&A7,&A8,ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                      C O N V O L                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Convolution de l'image source vers l'image destination      */
/*  Paramtres en entre : c = choix de filtre                             */
/*                         A0..A8 = coefficients du filtre                 */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Convol(char c,char *A0,char *A1,char *A2,char *A3,char *A4,char *A5,
		char *A6,char *A7,char *A8,unsigned char far *ptsource,unsigned char far *ptdestin)

{
unsigned char p;                                /* pixel */
int SA,x,y,X,Y;                                     /* Somme coeff */
long s; 	                                /* Accu */
int flag=0;                                       /* Contours */
unsigned char far *pointim1,*pointim;   	/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	switch(c)
	{

	case '0':				/* PASSE-BAS */

	*A0=1;	*A1=1;	  *A2=1;
	*A3=1;	*A4=1;	  *A5=1;
	*A6=1;	*A7=1;	  *A8=1;

	break;

	case '1':

	*A0=1;	*A1=1;	  *A2=1;
	*A3=1;	*A4=2;	  *A5=1;
	*A6=1;	*A7=1;	  *A8=1;

	break;

	case '2':

	*A0=1;	*A1=2;	  *A2=1;
	*A3=2;	*A4=4;	  *A5=2;
	*A6=1;	*A7=2;	  *A8=1;

	break;

	case '3':    				/* PASSE HAUT */

	*A0=0;	*A1=-1;	  *A2=0;
	*A3=-1;	*A4=5;	  *A5=-1;
	*A6=0;	*A7=-1;	  *A8=0;

	break;

	case '4':

	*A0=-1;	*A1=-1;	  *A2=-1;
	*A3=-1;	*A4=9;	  *A5=-1;
	*A6=-1;	*A7=-1;	  *A8=-1;

	break;

	case '5':

	*A0=1;	*A1=-2;	  *A2=1;
	*A3=-2;	*A4=5;	  *A5=-2;
	*A6=1;	*A7=-2;	  *A8=1;

	break;

	case '6':flag=1;Roberts(ptsource,ptdestin);break;  		/* ROBERTS CROSS */

	case '7':flag=1;Sobel(ptsource,ptdestin);break;		/* SOBEL */

	case '8':flag=1;Prewitt(ptsource,ptdestin);break;		/* PREWITT */

	case '9':    					/* LAPLACIEN */

	*A0=0;	*A1=-1;	  *A2=0;
	*A3=-1;	*A4=4;	  *A5=-1;
	*A6=0;	*A7=-1;	  *A8=0;

	break;
	}

	if(flag==0)
	{
	SA=(*A0+*A1+*A2+*A3+*A4+*A5+*A6+*A7+*A8);

		for(y=0;y<256;y++)
		{
		for(x=0;x<256;x++)
		{
		s=0;
		X=x-1;if(X<0)X=0;
		Y=y-1;if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A0);

		X=x;
		Y=y-1;
		if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A1);

		X=x+1;if(X>255)X=255;
		Y=y-1;if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A2);

		X=x-1;if(X<0)X=0;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A3);

		X=x;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A4);

		X=x+1;if(X>255)X=255;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A5);

		X=x-1;if(X<0)X=0;
		Y=y+1;if(Y>255)Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A6);

		X=x;
		Y=y+1;if(Y>255)Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A7);

		X=x+1;if(X>255)X=255;
		Y=y+1;if(Y>255)Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s+=(p**A8);

		pointim1=ptdestin+(y<<8)+x;

		if(SA!=0) s/=SA;else s+=128;
		if(s>255) s=255;
		if(s<0)   s=0;
		*pointim1=(unsigned char)s;
		}//forx
		}//fory
	} //if
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                      C O N T O U R                          */
/*-------------------------------------------------------------------------*/
/*  Fonction : Contour de l'image source vers l'image destination          */
/*  Paramtres en entre : c = choix de filtre                             */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Contour(char c,unsigned char far *ptsource,unsigned char far *ptdestin)

{

char A0,A1,A2,A3,A4,A5,A6,A7,A8;    /*  Coeff. de convolution  */
char B0,B1,B2,B3,B4,B5,B6,B7,B8;    /*  Coeff. de convolution  */
int flag=0;
unsigned char p;                                /* pixel */
int x,y,X,Y;
long s1,s2; 	                                /* Accus */
unsigned char far *pointim1,*pointim;   	/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	switch(c)
	{
	case '0':                            	/* ROBERTS CROSS */
			A0=0;		A1=1;  	A2=0;
			A3=-1;	A4=0;	 	A5=0;
			A6=0;		A7=0;	 	A8=0;

			B0=1;		B1=0;  	B2=0;
			B3=0;		B4=-1;   B5=0;
			B6=0;		B7=0;	 	B8=0;

	break;

	case '1':                             	/* SOBEL */
			A0=1;		A1=0;  	A2=-1;
			A3=2;		A4=0;	 	A5=-2;
			A6=1;		A7=0;	 	A8=-1;

			B0=-1;  	B1=-2;  	B2=-1;
			B3=0;		B4=0;   	B5=0;
			B6=1;		B7=2;	 	B8=1;

	break;

	case '2':                              /* PREWITT */

			A0=1;		A1=0;  	A2=-1;
			A3=1;		A4=0;	 	A5=-1;
			A6=1;		A7=0;	 	A8=-1;

			B0=-1;  	B1=-1;  	B2=-1;
			B3=0;		B4=0;   	B5=0;
			B6=1;		B7=1;	 	B8=1;

	break;

	case '3':    				/* LAPLACIEN */
			flag=1;
			A0=0;		A1=-1;	A2=0;
			A3=-1;	A4=4;	  	A5=-1;
			A6=0;		A7=-1;	A8=0;

			c='m';
			Convol(c,&A0,&A1,&A2,&A3,&A4,&A5,&A6,&A7,&A8,ptsource,ptdestin);
			break;
	}

	if(flag==0)
	{
		for(y=0;y<256;y++)
		{
		for(x=0;x<256;x++)
		{
		s1=0;s2=0;
		X=x-1;if(X<0) X=0;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A0);
		s2+=(p*B0);

		X=x;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A1);
		s2+=(p*B1);

		X=x+1;if(X>255) X=255;
		Y=y-1;if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A2);
		s2+=(p*B2);

		X=x-1;if(X<0) X=0;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A3);
		s2+=(p*B3);

		X=x;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A4);
		s2+=(p*B4);

		X=x+1;if(X>255) X=255;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A5);
		s2+=(p*B5);

		X=x-1;if(X<0) X=0;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A6);
		s2+=(p*B6);

		X=x;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A7);
		s2+=(p*B7);

		X=x+1;if(X>255) X=255;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p=*pointim;
		s1+=(p*A8);
		s2+=(p*B8);

		pointim1=ptdestin+(y<<8)+x;
		if(s1<0) s1=-s1;
		if(s2<0) s2=-s2;
		s1+=s2;
		if(s1>255) s1=255;
		*pointim1=(unsigned char)s1;
		} //forx
		} //fory
	 }  //if
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                      M E D I A N                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage mdian   					  									*/
/*  Paramtres en entre : Type de mdian	                   		        */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Median(char c,unsigned char far *ptsource,unsigned char far *ptdestin)

{

int x,y,X,Y,i,j,min;
unsigned char m[9];                       	/* tableau */
unsigned char far *pointim1,*pointim;  		/* pointeurs image */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	for(y=0;y<256;y++)
	{
		for(x=0;x<256;x++)
		{
		X=x-1;if(X<0) X=0;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		m[0]=*pointim;

		X=x;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		m[1]=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y-1;if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		m[2]=*pointim;

		X=x-1;if(X<0) X=0;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		m[3]=*pointim;

		X=x;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		m[4]=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		m[5]=*pointim;

		X=x-1;if(X<0) X=0;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		m[6]=*pointim;

		X=x;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		m[7]=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		m[8]=*pointim;

			switch(c)
			{
			case '0' :                          // 3*3
			for(j=0;j<5;j++)
			{
				min=j;
				for(i=j;i<9;i++)
				{
					if(m[i]<m[min]) min=i;
				}
				if(j!=4) m[min]=m[j];
			}
			break;

			case '1':
			m[0]=m[3];
			m[1]=m[4];
			m[2]=m[5];
			for(j=0;j<2;j++)
			{
				min=j;
				for(i=j;i<3;i++)
				{
					if(m[i]<m[min]) min=i;
				}
				if(j!=1) m[min]=m[j];
			}
			break;

			case '2':
			m[0]=m[1];
			m[1]=m[4];
			m[2]=m[7];
			for(j=0;j<2;j++)
			{
				min=j;
				for(i=j;i<3;i++)
				{
					if(m[i]<m[min]) min=i;
				}
				if(j!=1) m[min]=m[j];
			}
			}
			pointim1=ptdestin+(y<<8)+x;
			*pointim1=m[min];
		} //forx
	} //fory
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    R O B E R T S                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage de Roberts                                         */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Roberts(unsigned char far *ptsource,unsigned char far *ptdestin)

{
	Contour('0',ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    S O B E L                                */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage de Sobel                                           */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Sobel(unsigned char far *ptsource,unsigned char far *ptdestin)
{
	Contour('1',ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    P R E W I T T                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage de Prewitt                                         */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Prewitt(unsigned char far *ptsource,unsigned char far *ptdestin)
{
	Contour('2',ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :          M O Y E N N E U R _ G L I S S A N T                */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage par moyenneur glissant                             */
/*  Paramtres en entre : ordrel : ordre du filtre suivant les lignes     */
/*                         ordrec : ordre du filtre suivant les colonnes   */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Moyenneur_glissant(unsigned int ordrel,unsigned int ordrec,
			unsigned char far *ptsource,unsigned char far *ptdestin)

{
unsigned int i,k,j,filtre;
unsigned char far *pointim2,*pointim1,*p;

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	p=(unsigned char far *)farmalloc(65536L*sizeof(char));

	for(k=0;k<256;k++)                /* lignes */
	{
		for(i=0;i<ordrel;i++)
		{
			pointim2=ptdestin+i+(k<<8);
			filtre=0;
			for(j=0;j<(i+1);j++)
			{
				pointim1=ptsource+j+(k<<8);
				filtre+=(*pointim1);
			}
			*pointim2=((int)(filtre/j));
		}
		for(i=ordrel;i<256;i++)
		{
			pointim2=ptdestin+i+(k<<8);
			filtre=0;
			for(j=0;j<ordrel;j++)
			{
				pointim1=ptsource+i-j+(k<<8);
				filtre+=(*pointim1);
			}
			*pointim2=((int)(filtre/ordrel));
		}
	}

	Copie_plan(ptdestin,p);

	for(k=0;k<256;k++)                /* colonnes */
	{
		for(i=0;i<ordrec;i++)
		{
			pointim2=ptdestin+(i<<8)+k;
			filtre=0;
			for(j=0;j<(i+1);j++)
			{
				pointim1=p+(j<<8)+k;
				filtre+=(*pointim1);
			}
			*pointim2=((int)(filtre/j));
		}
		for(i=ordrec;i<256;i++)
		{
			pointim2=ptdestin+(i<<8)+k;
			filtre=0;
			for(j=0;j<ordrec;j++)
			{
				pointim1=p+((i-j)<<8)+k;
				filtre+=(*pointim1);
			}
			*pointim2=((int)(filtre/ordrec));
		}
	}
	farfree(p);
}


/*-------------------------------------------------------------------------*/
/*  Fonction :                    M O R P H O                              */
/*-------------------------------------------------------------------------*/
/*  Fonction : Filtrage morphologique                                      */
/*  Paramtres en entre : type de morpho                                  */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Morpho(char c,unsigned char far *ptsource,unsigned char far *ptdestin)
{
unsigned char far *p;

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

	p=(unsigned char far *)farmalloc(65536L*sizeof(char));

	switch(c)
	{
	case '0':										/* EROSION */
		Erosion(ptsource,ptdestin);
		break;

	case '1':                              /* DILATATION */
		Dilatation(ptsource,ptdestin);
		break;

	case '3':                            // OUVERTURE
		Erosion(ptsource,p);
		Dilatation(p,ptdestin);
		break;

	case '2':                             // FERMETURE
		Dilatation(ptsource,p);
		Erosion(p,ptdestin);
		break;

	}
	farfree(p);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    E R O S I O N                            */
/*-------------------------------------------------------------------------*/
/*  Fonction : Erosion                                                     */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Erosion(unsigned char far *ptsource,unsigned char far *ptdestin)

{
	Ero_dil('0',ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    D I L A T A T I O N                      */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dilatation                                                  */
/*  Paramtres en entre : Aucun                                           */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Dilatation(unsigned char far *ptsource,unsigned char far *ptdestin)
{
	Ero_dil('1',ptsource,ptdestin);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    E R O _D I L			                     */
/*-------------------------------------------------------------------------*/
/*  Fonction : Erosion ou Dilatation                                       */
/*  Paramtres en entre : c='0' rosion ; c='1' dilatation                */
/*  Valeur retourne : Aucune                                              */
/*-------------------------------------------------------------------------*/

void far Ero_dil(char c,unsigned char far *ptsource,unsigned char far *ptdestin)
{
int x,y,X,Y;
unsigned char far *pointim1,*pointim;   	/* pointeurs image */
unsigned char p0,p1,p2,p3,p4,p5,p6,p7,p8;  /* pixels */

	if(ptsource==0) ptsource=source;
	if(ptdestin==0) ptdestin=destin;

		for(y=0;y<256;y++)
		{
		for(x=0;x<256;x++)
		{
		X=x-1;if(X<0) X=0;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		p0=*pointim;

		X=x;
		Y=y-1;if(Y<0) Y=0;
		pointim=ptsource+(Y<<8)+X;
		p1=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y-1;if(Y<0)Y=0;
		pointim=ptsource+(Y<<8)+X;
		p2=*pointim;

		X=x-1;if(X<0) X=0;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p3=*pointim;

		X=x;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p4=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y;
		pointim=ptsource+(Y<<8)+X;
		p5=*pointim;

		X=x-1;if(X<0) X=0;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p6=*pointim;

		X=x;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p7=*pointim;

		X=x+1;if(X>255) X=255;
		Y=y+1;if(Y>255) Y=255;
		pointim=ptsource+(Y<<8)+X;
		p8=*pointim;

		pointim1=ptdestin+(y<<8)+x;
		if(c=='0')
		{
		if((p0<128)||(p1<128)||(p2<128)||(p3<128)||(p5<128)
			||(p6<128)||(p7<128)||(p8<128))
			 *pointim1=0;
		else  *pointim1=p4;
		}
		else
		{
		if((p0>=128)||(p1>=128)||(p2>=128)||(p3>=128)
			||(p5>=128)||(p6>=128)||(p7>=128)||(p8>=128))
				*pointim1=255;
		else 	*pointim1=p4;
		} //if
		} //forx
		} //fory
}

/*-------------------------------------------------------------------------*/
