/***************************************************************/
/*                    W L S Y T B I N . C                      */
/*-------------------------------------------------------------*/
/*    Fonction       : Codage et dcodage d'images binaires    */
/*-------------------------------------------------------------*/
/*    Auteur         : MC                                      */
/*    Dvelopp le   : 15/12/95                                */
/*    Dernire modif.: 02/01/98					    				   */
/***************************************************************/

#include <stdio.h>
#include <alloc.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>

#include "wgttsi.h"
#include "wldecbin.h"
#include "wlsytbin.h"

/*----------------------------------------------*/
/*                                              */
/*              Constantes du programme         */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*									   						*/
/*		Structures du programme      			  	   */
/*									   						*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*              Variables du programme          */
/*                                              */
/*----------------------------------------------*/

//struct ftime ft,tc;            // date & heure
identseq id;                   // Identification squence
caracseq carseq;               // Car. squence
carimagseq carimseq;           // Car. image squence

int prec,suiv,flagseq,iseq,taille,compt;
long nbimage;
unsigned char far bufim[TAILBUF];
FILE *in=0;                      // Fichier squence
int ident;                       // identification seq.

/*----------------------------------------------*/
/*                                              */
/*           Fonctions prototypes               */
/*                                              */
/*----------------------------------------------*/

int far Animabin3(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[],int flag);

/*-------------------------------------------------------------*/
/*                                                             */
/*                   Procdures du programme                   */
/*                                                             */
/*-------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A N I M A B I N                          */
/*-------------------------------------------------------------------------*/
/*  Fonction : Animation d'images binaires codes                          */
/*  Paramtres en entre : Fichier,numero,structure                        */
/*  Valeur retourne : 1 erreur 0 OK 		        	     					      */
/*-------------------------------------------------------------------------*/

int far Animabin(FILE *in,long numero,carimagseq *carimseq)
{
	return(Animabin3(in,numero,carimseq,bufim,0));  // bufim = bidon
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A N I M A B I N 1                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Animation d'images binaires codes                          */
/*  Paramtres en entre : Fichier,numero,structure,buf                    */
/*  Valeur retourne : 1 erreur 0 OK 		        	     					      */
/*-------------------------------------------------------------------------*/

int far Animabin1(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[])
{
	return(Animabin3(in,numero,carimseq,bufdest,1));
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A N I M A B I N 2                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Animation d'images binaires codes                          */
/*  Paramtres en entre : Fichier,numero,structure,buf                    */
/*  Valeur retourne : 1 erreur 0 OK 		        	     					      */
/*-------------------------------------------------------------------------*/

int far Animabin2(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[])
{
	return(Animabin3(in,numero,carimseq,bufdest,2));
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    A N I M A B I N 3                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Animation d'images binaires codes                          */
/*  Paramtres en entre : Fichier,numero,structure,buf,flag               */
/*  Valeur retourne : 1 erreur 0 OK 		        	     					      */
/*-------------------------------------------------------------------------*/

int far Animabin3(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[],int flag)

{

int nbcod,nbcodim;
long nbpt;

			if(nbimage<numero)
			{
			while(nbimage!=numero)
			{
			Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
			iseq+=suiv-4;
			if(iseq>=taille&&flagseq==0) Incr_buf(&iseq,&flagseq,&taille,in,&compt,bufim);
			nbimage++;
			}
			}

			if(nbimage>numero)
			{
			while(nbimage!=numero)
			{
			Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
			iseq-=prec+4;
			if(iseq<0) Decr_buf(&iseq,&flagseq,&taille,in,&compt,bufim);
			nbimage--;
			}
			}

	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	if(suiv==0)
	{
	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	}

	nbcod=suiv;

	if(nbcod!=0)                             // Test fin squence
	{
	nbcodim=nbcod-4;
	if(flag==0)	nbpt=Decodbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim,destin);
	if(flag==1) nbpt=Trf_affbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim,destin,bufdest);
   if(flag==2) nbpt=Trf_bin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim,
					bufdest);

	}

	nbimage++;

	if(iseq>=taille&&flagseq==1)                   // Fin de squence
	{
	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	}

	carimseq->nbcod=nbcod;
	carimseq->nbpt=nbpt;
	return(0);

}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    C A R S E Q B I N                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Dtermination des carctristiques de squences binaires     */
/*  Paramtres en entre : Fichier,structure,structure                     */
/*  Valeur retourne : 1 erreur 0 OK 		        	           					*/
/*-------------------------------------------------------------------------*/

int far Carseqbin(FILE *in,identseq *id,caracseq *carseq)
{

int nbcod,nbcodim;
long nbtot,numero,totcod;
long nbpt,nbptmax,nbpt0;
int j;
float pas,a,*histseq,codmoyen,vitesse=25.;  // Par dfaut : 25 images/s

	histseq=&carseq->histseq[0];

											  // Calcul nb d'images et nb codes
	totcod=0;nbptmax=0;

	getftime(fileno(in),&ft);

	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);

	do
	{
	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	nbcod=suiv;
	if(nbcod!=0)
	{
	nbcodim=nbcod-4;
	nbpt=Calnbptbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim);
	if(nbpt>nbptmax) nbptmax=nbpt;
	}
	nbimage++;
	totcod+=suiv;
	}
	while(suiv!=0);
	totcod+=4;

	nbtot=nbimage-1;
	codmoyen=(float)totcod/(float)nbtot;

	// Remplissage du buffer d'histogramme de la squence

	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);

	pas=(float)(nbtot-1)/511.;
	nbpt=0;nbpt0=0;
	for(j=0;j<512;j++)
	{
	a=(float)j*pas;
	numero=(long)a;
	nbpt=0;
	while(nbimage<=numero)
	{
	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	if(suiv!=0)
	{
	nbcodim=suiv-4;
	nbpt0=Calnbptbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim);
	}
	if(nbpt0>nbpt) nbpt=nbpt0;
	nbimage++;
	}
	histseq[j]=(float)nbpt;         // max dans l'intervalle
	}

	// Lecture identificateur squence

	ident=Lect_identseq(id,in);
	if(ident==0) vitesse=Cal_vitesse(id);

	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);

	carseq->nbtot=nbtot;
	carseq->totcod=totcod;
	carseq->nbptmax=nbptmax;
	carseq->codmoyen=codmoyen;
	carseq->vitesse=vitesse;

	return(0);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    R E C I M S U I V                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Recherche image suivante											   */
/*  Paramtres en entre : Fichier,nb min de pt			                     */
/*  Valeur retourne : numro de l'image        	           					*/
/*-------------------------------------------------------------------------*/

long far Recimsuiv(FILE *in,long nbptmin)
{

int nbcod,nbcodim;
long nbpt;

	if(nbimage==carseq.nbtot)
	Init_debut(&nbimage,&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	do
	{
	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	nbcod=suiv;
	if(nbcod!=0)
	{
	nbcodim=nbcod-4;
	nbpt=Calnbptbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim);
	}
	else nbpt=0;             // image vide
	nbimage++;
	}
	while(nbpt<nbptmin&&nbimage<carseq.nbtot);
	nbimage--;
	iseq-=suiv;
	if(iseq<0) Decr_buf(&iseq,&flagseq,&taille,in,&compt,bufim);

	return(nbimage);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    C A L _ D A T I M                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcul de la date des images squence                       */
/*  Paramtres en entre : Structures,numro image,vitesse,nb total im.    */
/*  Valeur retourne : aucun		 		                   						*/
/*-------------------------------------------------------------------------*/

void far Cal_datim(struct ftime *ft,struct ftime *tc,long nbimage,
						float vitesse,long nbtot)

{

unsigned int jourmax;
long totsec,min;
ldiv_t tampon;
int year,month,day,hour,tsec,monthprec;

	year=ft->ft_year;
	month=ft->ft_month;
	day=ft->ft_day;
	hour=ft->ft_hour;
	min=ft->ft_min;
	tsec=ft->ft_tsec;
	monthprec=month-1;
	if(monthprec==0) monthprec=12;

	switch(monthprec)
		{
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12: jourmax=31;break;
		case 4:
		case 6:
		case 9:
		case 11: jourmax=30;break;
		case 2: tampon=ldiv((long)year,4);
			if(tampon.rem==0) jourmax=29;else jourmax=28;break;
		}

	totsec=(long)tsec*2+(long)min*60+(long)hour*3600+(long)((float)(nbimage-nbtot)/vitesse);
	tampon=ldiv(totsec,3600);
	if(totsec==0) {hour=(int)min=tsec=0;}
	else
	{
	hour=(int)tampon.quot;
	if(totsec<0)
		{
		hour+=23;
		tampon.rem+=3600;
		day--;
		if(day==0)
			{day=jourmax;
			 month--;
			 if(month==0) {month=12;year--;}
			}
		}

	min=tampon.rem;
	tampon=ldiv(min,60);
	min=tampon.quot;
	tsec=(int)tampon.rem/2;
	}
	tc->ft_hour=hour;
	tc->ft_min=(int)min;
	tc->ft_tsec=tsec;
	tc->ft_year=year;
	tc->ft_month=month;
	tc->ft_day=day;

}

/*-------------------------------------------------------------------------*/
/*  Fonction :           L E C T _ I D E N T S E Q                   		*/
/*-------------------------------------------------------------------------*/
/*  Fonction : Lecture de l'identificateur de fichier								*/
/*  Paramtres en entre : Structure, fichier				       			   */
/*  Valeur retourne : 0 reconnu 			                   					*/
/*-------------------------------------------------------------------------*/

int far Lect_identseq(identseq *id,FILE *in)
{
	fseek(in,-256L,SEEK_END);
	fread(id,sizeof(identseq),1,in);
	return(strcmp(id->ident,"SEQ"));
}

/*-------------------------------------------------------------------------*/
/*  Fonction :           C A L _ V I T E S S E 	                	   		*/
/*-------------------------------------------------------------------------*/
/*  Fonction : Calcule la vitesse d'acqui. des images	          		 		*/
/*  Paramtres en entre : Structure						    				      */
/*  Valeur retourne : vitesse			                   						*/
/*-------------------------------------------------------------------------*/

float far Cal_vitesse(identseq *id)

{

float tabvit1[15]={50,25,16.6,12.5,10,8.33,6.25,5,2.5,1.66,1.25,1,0.5,0.25,0.2};
float tabvit2[15]={25,12.5,8.33,6.25,5,4.15,3.12,2.5,1.25,0.83,0.62,0.5,0.25,0.125,0.1};
float *tab,vitesse;

	switch(id->parite)
	{
	case 0 :
	case 1 : tab=&tabvit2[0];
		 break;
	case 2 :
	case 3 : tab=&tabvit1[0];
		 break;
	}
	if(id->modevit>0&&id->modevit<=15) vitesse=tab[id->modevit-1];
	else vitesse=25;

	return(vitesse);
}

/*-------------------------------------------------------------------------*/
/*  Fonction :                    R E C I M P R E C                        */
/*-------------------------------------------------------------------------*/
/*  Fonction : Recherche image prcdente											   */
/*  Paramtres en entre : Fichier,nb min de pt			                     */
/*  Valeur retourne : numro de l'image        	           					*/
/*-------------------------------------------------------------------------*/

long far Recimprec(FILE *in,long nbptmin)
{

int nbcod,nbcodim;
long nbpt;
int step;

	do
	{
	step=2;                // remonte 2 images avant
		while(step!=0)           // Traiter effet de bord
		{
			Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
			iseq-=prec+4;
			if(iseq<0) Decr_buf(&iseq,&flagseq,&taille,in,&compt,bufim);
			if(prec!=0) nbimage--;else nbimage=0;
		step--;
		}

	Calprec_suiv(&prec,&suiv,&iseq,&flagseq,&taille,in,&compt,bufim);
	nbcod=suiv;
	if(nbcod!=0)
	{
	nbcodim=nbcod-4;
	nbpt=Calnbptbin(nbcodim,&iseq,&flagseq,&taille,in,&compt,bufim);
	}
	else nbpt=0;             // image vide
	nbimage++;
	}
	while(nbpt<nbptmin&&nbimage>1);
	nbimage--;
	iseq-=suiv;             // recaler  l'image
	if(iseq<0) Decr_buf(&iseq,&flagseq,&taille,in,&compt,bufim);
	return(nbimage);
}

//-------------------------------------------------------------------------
