/**********************************************************************/
/*                       W M A I C O N V . C P P                            */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 18/11/1996                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/

#include <stdio.h>                       // Dos
#include <math.h>
#include <alloc.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlmodif.h"

#include "wsysutil.h"
#include "wappbase.rh"
#include "wappbase.h"
#include "wmain.h"
#include "wmaiconv.h"

											// Pointeurs sur les fentres
TGeom* TGeomPtr = 0;     			// Fentre geom
TChoixMenu* TConvhiscouPtr = 0;  // Fentre histo couleur
TPseudo* TPseudoPtr;          	// Fentre pseudo
TWindow*	TConvocurPtr=0;         // Fentre coocur
TChoixMenu* TConvdiffPtr = 0;    // Fentre diffrence
TPrevisu* TPrevisuPtr=0;         // Fentre prvisu

//--------------------------------------------------------------------------
//						 Programme TPrevisu
//--------------------------------------------------------------------------

#define DIM_IMAGETTE 64

DEFINE_RESPONSE_TABLE1(TPrevisu,TFrameWindow )

	EV_COMMAND(ID_BOUTON,MiseAJour),
	EV_WM_LBUTTONDOWN,
	EV_WM_RBUTTONDOWN,
	EV_WM_LBUTTONUP,
	EV_WM_RBUTTONUP,
	EV_WM_MOUSEMOVE,

END_RESPONSE_TABLE;

TPrevisu::TPrevisu(TWindow* parent)
 : TFrameWindow(parent,"VISUALISATION ET COPIE DE PLANS")
{
float xMargeVert, xMargeHoriz;

	Attr.X = 0;
	Attr.Y = 282+OFFSET;
	Attr.W = 640;
	Attr.H = 107;
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

  int xmax=Attr.W-GetSystemMetrics(SM_CXBORDER)*2;
	xMargeVert=(xmax-8*DIM_IMAGETTE)/11.0;       // 10 + 1 (bouton)
	xMargeHoriz=8;

	new TButton(this,
					ID_BOUTON,"",xMargeVert+(DIM_IMAGETTE+xMargeVert)*8,
					xMargeHoriz,xMargeVert,DIM_IMAGETTE+2,FALSE);

	for(int i=0;i<8;i++)     // cadres imagettes
		cad_imag[i]=TRect
		(xMargeVert+(DIM_IMAGETTE+xMargeVert)*i,xMargeHoriz,
		(DIM_IMAGETTE+xMargeVert)*(i+1),xMargeHoriz+DIM_IMAGETTE);

	EtatBG=0;
	EtatBD=0;
	DragBD=0;
	DragBG=0;
	ClickUpBG=0;
	ClickUpBD=0;
}

void TPrevisu::SetupWindow()
{
unsigned char lut[1024];

	TFrameWindow::SetupWindow();
	hloc = LocalAlloc(LMEM_ZEROINIT | LMEM_MOVEABLE,
	 sizeof(BITMAPINFOHEADER)+1024);
	pbmi=(PBITMAPINFO) LocalLock(hloc);

	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi->bmiHeader.biWidth = DIM_IMAGETTE;
	pbmi->bmiHeader.biHeight = DIM_IMAGETTE;
	pbmi->bmiHeader.biPlanes = 1;
	pbmi->bmiHeader.biCompression = BI_RGB;
	pbmi->bmiHeader.biBitCount = 8;
	pbmi->bmiHeader.biClrUsed=256;
	pbmi->bmiHeader.biClrImportant=256;
	pbmi->bmiHeader.biSizeImage=(pbmi->bmiHeader.biWidth*
										 pbmi->bmiHeader.biHeight)*
										 pbmi->bmiHeader.biBitCount/8;

	for(int x=0;x<1024;x+=4)             // Lut linaire
	{
		lut[x]=x>>2;
		lut[x+1]=x>>2;
		lut[x+2]=x>>2;
		lut[x+3]=0;
	}
	memcpy(pbmi->bmiColors,lut,1024);
}

void TPrevisu::Paint(TDC& dc, BOOL , TRect& )
{
TRect dest;
int i,j,k,l;
TColor colorj,colork,colorl,color=TColor::LtYellow;

	Reduit();

	if(modcoul)
	{
	colorj=TColor::LtBlue;j=1;
	colork=TColor::LtRed;k=2;
	colorl=TColor::LtGreen;l=3;
	}
	else
	{
	j=Numeroplan(source)-'0';
	k=Numeroplan(destin)-'0';
	l=8;
	colorj=TColor::LtMagenta;
	colork=TColor::LtCyan;
	}

	for(i=0;i<8;i++)            // cadres imagettes
	{
	if(i==j)	dc.FrameRect(cad_imag[i],TBrush(colorj));
	else
	if(i==k)	dc.FrameRect(cad_imag[i],TBrush(colork));
	else
	if(i==l) dc.FrameRect(cad_imag[i],TBrush(colorl));
	else     dc.FrameRect(cad_imag[i],TBrush(color));
	}

	for(i=0;i<8;i++)
	{
	dest=TRect(cad_imag[i].InflatedBy(-1,-1));
	SetDIBitsToDevice(                           // Windows
		dc,
		dest.left,dest.top,dest.Width(),dest.Height(),
		0, 0, 0, DIM_IMAGETTE,
		ecran+4096*i,(LPBITMAPINFO)pbmi,DIB_RGB_COLORS);
	}
}

void TPrevisu::Reduit()
{
unsigned char *ptr;
int i, j;

	ptr=ecran;

	for(i=0;i<DIM_IMAGETTE;i++)
	{
		for(j=0;j<DIM_IMAGETTE;j++)
		{	ptr[i+((63-j)<<6)]=image0[(i<<2)+(j<<10)];
			ptr[4096+i+((63-j)<<6)]=image1[(i<<2)+(j<<10)];
			ptr[8192+i+((63-j)<<6)]=image2[(i<<2)+(j<<10)];
			ptr[12288+i+((63-j)<<6)]=image3[(i<<2)+(j<<10)];
			ptr[16384+i+((63-j)<<6)]=image4[(i<<2)+(j<<10)];
			ptr[20480+i+((63-j)<<6)]=image5[(i<<2)+(j<<10)];
			ptr[24576+i+((63-j)<<6)]=image6[(i<<2)+(j<<10)];
			ptr[28672+i+((63-j)<<6)]=image7[(i<<2)+(j<<10)];
		}
   }
}

void TPrevisu::MiseAJour(void)
{
	Invalidate(false);
}

void TPrevisu::EvLButtonDown(UINT a,TPoint& point)
{
	EtatBG=1;
	DragBG=0;
	ClickUpBG=0;
	EvSouris(a,point);
}

void TPrevisu::EvLButtonUp(UINT a,TPoint& point)
{
	EtatBG=0;
	DragBG=0;
	ClickUpBG=1;
	EvSouris(a,point);
}

void TPrevisu::EvRButtonDown(UINT a,TPoint& point)
{
	EtatBD=1;
	DragBD=0;
	ClickUpBD=0;
	EvSouris(a,point);
}

void TPrevisu::EvRButtonUp(UINT a,TPoint& point)
{
	EtatBD=0;
	DragBD=0;
	ClickUpBD=1;
	EvSouris(a,point);
}

void TPrevisu::EvMouseMove(UINT a,TPoint& point)
{
	if(EtatBD) DragBD=1;
	if(EtatBG) DragBG=1;
	EvSouris(a,point);
}

void TPrevisu::EvSouris(UINT, TPoint& point)
{
char string[20]="";
int i;
unsigned char far *pt1,*pt2;

	for(i=0;i<8;i++)
	{
	if(cad_imag[i].Contains(point))
	{
	sprintf(string,"Image %i",i);
	break;
	}
	}

	pZ1->SetText(string);

	if(EtatBD&&!DragBD&&i!=8)         // click BD
	Fenetre->Visim(this,1,Adresseplan('0'+i));

	if(EtatBG&&!DragBG)        // click BG
	{
	ImagePointee=i;            // mmorise
	if(i!=8)
	{
	plan=i;
	Calplans();
	Fenetre->Visim(this,0,source);
	}
	}

	if(ClickUpBG)
	{
	if(i!=8&&i!=ImagePointee&&ImagePointee!=8)
	{
	pt1=Adresseplan('0'+ImagePointee);
	pt2=Adresseplan('0'+i);
	Copie_plan(pt1,pt2);
	Fenetre->Visim(this,1,pt2);
	}
	}
	ClickUpBD=ClickUpBG=0;      // rinit
}

TPrevisu::~TPrevisu()
{
	LocalUnlock(hloc);
	LocalFree(hloc);
	TPrevisuPtr=0;
}

//----------------------------------------------------------------------------
//						Programme TConvdiff
//----------------------------------------------------------------------------

TConvdiff::TConvdiff(TWindow* parent)
		: TChoixMenu(parent,"DIFFERENCE ABSOLUE ENTRE PLAN SOURCE ET PLAN ?",
		"&0\n&1\n&2\n&3\n&4\n&5\n&6\n&7")
{
}

void TConvdiff::EvCommun(char c)
{
	Opera(c);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

TConvdiff::~TConvdiff()
{
	TConvdiffPtr=0;
}

//----------------------------------------------------------------------------
//						Programme TConvocur
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TConvocur, TFrameWindow)

  EV_WM_MBUTTONDOWN,
  END_RESPONSE_TABLE;

TConvocur::TConvocur(TWindow* parent)
  : TFrameWindow(parent, "MATRICE DE COOCCURRENCE")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		depx=0;
		depy=0;

		new TStatic(this, ID_STATIC, "Dplacement en x :", 150, 8, 150, 25, 0);
		new TStatic(this, ID_STATIC, "Dplacement en y :", 150, 33, 150, 25, 0);
		Lig=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 320-25, 5, 50, 25, 5);
		Col=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 320-25, 30, 50, 25, 5);
}

TConvocur::~TConvocur()
{
	TConvocurPtr=0;
}

void
TConvocur::SetupWindow()
{
  TFrameWindow::SetupWindow();
  AfficheCoeff();
}

void TConvocur::EvMButtonDown(UINT, TPoint &)
{
char string[12];

	Lig->GetText(string,sizeof(string));
	depx=atoi(string);
	Col->GetText(string,sizeof(string));
	depy=atoi(string);
	if(depx<0) depx=0;else if(depx>255) depx=255;
	if(depy<0) depy=0;else if(depy>255) depy=255;
	AfficheCoeff();
	Cooccurence(depx,depy);
	Fenetre->Visim(this,1,destin);
	//SetActiveWindow();
}

void TConvocur::AfficheCoeff(void)
{
char string[12];

	 itoa(depx,string,10);
	 Lig->SetText(string);
	 itoa(depy,string,10);
	 Col->SetText(string);
}

//----------------------------------------------------------------------------
//						Programme TPseudo
//----------------------------------------------------------------------------

void Ev_Image_Pseudo(TPoint&,int);   // Proto

void Ev_Image_Pseudo(TPoint&,int etatsouris)    // une fonction
{
	if(!etatsouris) return;
	if(TPseudoPtr)
	{
	 TPseudoPtr->NouveauPoint();
	}
}

DEFINE_RESPONSE_TABLE1(TPseudo, TFrameWindow)

  EV_CHILD_NOTIFY_ALL_CODES(ID_A, EvA),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+1, EvB),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+2, EvC),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+3, EvD),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+4, EvE),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+5, EvF),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),

  END_RESPONSE_TABLE;

TPseudo::TPseudo(TWindow* parent)
  : TFrameWindow(parent, "PSEUDO-COULEUR")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		Minx = new TScrollBar(this, ID_A, 60, 0, 150, 0, TRUE);
		Maxx = new TScrollBar(this, ID_A+1, 380, 0, 150, 0, TRUE);
		new TStatic(this, ID_STATIC, " Min", 0, 0, 60, 25, 0);
		new TStatic(this, ID_STATIC, " Max", 320, 0, 60, 25, 0);

	Apseu=new TStatic(this, ID_STATIC,"", 60+150+10, 0, 60, 25, 0);
	Bpseu=new TStatic(this, ID_STATIC,"", 320+60+150+10, 0, 60, 25, 0);

	Fpseu=new TRadioButton(this, ID_A+2, "Table 0", 10, 50+5, 100, 20, 0);
	Gpseu=new TRadioButton(this, ID_A+3, "Table 1", 120, 50+5, 100, 20, 0);
	Hpseu=new TRadioButton(this, ID_A+4, "Table 2", 240, 50+5, 100, 20, 0);
	Ipseu=new TRadioButton(this, ID_A+5, "Table 3", 360, 50+5, 100, 20, 0);
	Jpseu=new TRadioButton(this, ID_A+6, "Table 4", 480, 50+5, 100, 20, 0);

	modefig=GEO_FENETRE;
	Ajoute_Fonction(Ev_Image_Pseudo,modefig,RETIC,this);
	commande='0';
}

void
TPseudo::SetupWindow()
{
  TFrameWindow::SetupWindow();

  Minx->SetRange(0,255);
  Maxx->SetRange(0,255);
  AfficheOptions();
}

TPseudo::~TPseudo()
{
	pseudo=0;           // Retour au N/B !!!!
	Enleve_Fonction(this);
	TPseudoPtr=0;
}

void TPseudo::EvA(UINT)
{
	commande='0';
	EvCommun(commande);
}

void TPseudo::EvB(UINT)
{
	commande='1';
	EvCommun(commande);
}

void TPseudo::EvC(UINT)
{
	commande='2';
	EvCommun(commande);
}

void TPseudo::EvD(UINT)
{
	commande='3';
	EvCommun(commande);
}

void TPseudo::EvE(UINT)
{
	commande='4';
	EvCommun(commande);
}

void TPseudo::EvF(UINT)
{
	commande='5';
	EvCommun(commande);
}

void TPseudo::EvG(UINT)
{
	commande='6';
	EvCommun(commande);
}

void TPseudo::EvExec(UINT)
{
	EvCommun(commande);
}

void TPseudo::EvCommun(char c)
{
	switch(c)
	{
	case '0': seuinf=Minx->GetPosition();break;
	case '1': seusup=Maxx->GetPosition();break;
	case '2':pseudo=0;break;
	case '3':pseudo=1;break;
	case '4':pseudo=2;break;
	case '5':pseudo=3;break;
	case '6':pseudo=4;break;
	}
	Execute();
}

void TPseudo::AfficheOptions(void)
{
char string[12];

  Minx->SetPosition(seuinf);
  Maxx->SetPosition(seusup);

	switch(pseudo)
	{
	case 0: Fpseu->Check();break;
	case 1: Gpseu->Check();break;
	case 2: Hpseu->Check();break;
	case 3: Ipseu->Check();break;
	case 4: Jpseu->Check();break;
	}
	sprintf(string, "%d", seuinf);
	Apseu->SetText(string);
	sprintf(string, "%d", seusup);
	Bpseu->SetText(string);
}

void
TPseudo::NouveauPoint()
{
unsigned char far *pointim,*buf;
unsigned int i,j,k=0;
int min,max;
long taille;

	buf=(unsigned char far *)farmalloc(65536L);

	for(i=rFig.top;i<=rFig.bottom;i++)
	{
		for(j=rFig.left;j<=rFig.right;j++)
		{
		pointim=source+j+(i<<8);
		buf[k++]=*pointim;
		}
	}
	taille=(long)(1+rFig.right-rFig.left)*(long)(1+rFig.bottom-rFig.top);
	Min_max(buf,&min,&max,taille);
	seuinf=min;
	seusup=max;

	farfree(buf);

	Execute();
}

void
TPseudo::PointImage(TPoint&,int)
{
}

void
TPseudo::Execute()
{
	AfficheOptions();
	Copie_plan(source,destin);
	Echelle(destin);             //Echelle des gris
	Fenetre->Visim(this,1,destin);
}

//----------------------------------------------------------------------------
//						Programme TConvhiscou
//----------------------------------------------------------------------------

TConvhiscou::TConvhiscou(TWindow* parent)
		: TChoixMenu(parent,"HISTOGRAMME COULEUR",
		"&0 : b -> v\n&1 : r -> v\n&2 : b -> r\n&3 : 0-1-2")
{
}

TConvhiscou::~TConvhiscou()
{
	TConvhiscouPtr=0;
}

void TConvhiscou::EvCommun(char c)
{
	Hiscou(c);
	Fenetre->Visim(this,1,image0);
	//SetActiveWindow();
}

//----------------------------------------------------------------------------
//						Programme TGeom
//----------------------------------------------------------------------------

void Ev_Image_Geom(TPoint&,int);   // Proto

void Ev_Image_Geom(TPoint&,int etatsouris)    // une fonction
{
	if(!etatsouris) return;
	if(TGeomPtr)
	{
	 TGeomPtr->NouveauPoint();
	}
}

DEFINE_RESPONSE_TABLE1(TGeom, TFrameWindow)

  EV_CHILD_NOTIFY_ALL_CODES(ID_A, EvA),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+1, EvB),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+2, EvC),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+3, EvD),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+4, EvE),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+5, EvF),
  EV_CHILD_NOTIFY_ALL_CODES(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),
  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TGeom::TGeom(TWindow* parent)
  : TFrameWindow(parent, "TRANSFORMATIONS GEOMETRIQUES")
{
	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		Angle = new TScrollBar(this, ID_A, 60, 0, 150, 0, TRUE);
		Xcent = new TScrollBar(this, ID_A+1, 60, 25, 150, 0, TRUE);
		Ycent = new TScrollBar(this, ID_A+2, 60, 50, 150, 0, TRUE);
		Xgrand = new TScrollBar(this, ID_A+3, 380, 0, 150, 0, TRUE);
		Ygrand = new TScrollBar(this, ID_A+4, 380, 25, 150, 0, TRUE);
		new TStatic(this, ID_STATIC, " Angle", 0, 0, 60, 25, 0);
		new TStatic(this, ID_STATIC, " CentX", 0, 25, 60, 25, 0);
		new TStatic(this, ID_STATIC, " CentY", 0, 50, 60, 25, 0);
		new TStatic(this, ID_STATIC, " GrandX", 320, 0, 60, 25, 0);
		new TStatic(this, ID_STATIC, " GrandY", 320, 25, 60, 25, 0);

	angle=0.0;
	xcent=128;
	ycent=128;
	grandx=1.0;
	grandy=1.0;
	typeinter='1';

	Ageom=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+150+10, 0, 80, 25, 10);          // 10->9 car. max
	Bgeom=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+150+10, 25, 80, 25, 10);
	Cgeom=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 60+150+10, 50, 80, 25, 10);
	Dgeom=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320+60+150+10, 0, 80, 25, 10);
	Egeom=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
	"", 320+60+150+10, 25, 80, 25, 10);
	Fgeom=new TRadioButton(this, ID_A+5, "VPP", 320+10, 50+5, 100, 20, 0);
	Ggeom=new TRadioButton(this, ID_A+6, "Bilinaire", 320+200, 50+5, 100, 20, 0);

	modefig=GEO_FENETRE;
	Ajoute_Fonction(Ev_Image_Geom,modefig,RETIC,this);
	commande='0';
}

void
TGeom::SetupWindow()
{
  TFrameWindow::SetupWindow();
  Angle->SetRange(0, 360);
  Xcent->SetRange(0, 255);
  Ycent->SetRange(0, 255);
  Xgrand->SetRange(1, 1024);
  Ygrand->SetRange(1, 1024);
  AfficheOptions();
}

TGeom::~TGeom()
{
	Enleve_Fonction(this);
	TGeomPtr=0;
}

void TGeom::EvMButtonDown(UINT, TPoint &)
{
	commande='7';
	EvCommun(commande);
}

void TGeom::EvA(UINT)
{
	commande='0';
	EvCommun(commande);
}

void TGeom::EvB(UINT)
{
	commande='1';
	EvCommun(commande);
}

void TGeom::EvC(UINT)
{
	commande='2';
	EvCommun(commande);
}

void TGeom::EvD(UINT)
{
	commande='3';
	EvCommun(commande);
}

void TGeom::EvE(UINT)
{
	commande='4';
	EvCommun(commande);
}

void TGeom::EvF(UINT)
{
	commande='5';
	EvCommun(commande);
}

void TGeom::EvG(UINT)
{
	commande='6';
	EvCommun(commande);
}

void TGeom::EvExec(UINT)
{
	EvCommun(commande);
}

void TGeom::EvCommun(char c)
{
char string[12];
int a;

	switch(c)
	{
	case '0':
				 angle=Angle->GetPosition();
				 break;
	case '1': xcent=Xcent->GetPosition();
				 break;
	case '2': ycent=Ycent->GetPosition();
				 break;
	case '3':
				a=Xgrand->GetPosition();
				grandx=((float)a)/128.;
				break;
	case '4':
				a=Ygrand->GetPosition();
				grandy=((float)a)/128.;
				break;
	case '5':
	case '6':
	case '7':
				if (c!='7') typeinter=c-5;
				Ageom->GetText(string,sizeof(string));
				angle=(float)atof(string);

				Bgeom->GetText(string,sizeof(string));
				xcent=atoi(string);

				Cgeom->GetText(string,sizeof(string));
				ycent=atoi(string);

				Dgeom->GetText(string,sizeof(string));
				grandx=(float)atof(string);

				Egeom->GetText(string,sizeof(string));
				grandy=(float)atof(string);

				break;
	}//switch

	if(c!='5'&&c!='6')
	if (TAffimPtr[0]) TAffimPtr[0]->Affiche();  // Restaure image gauche
	Execute();
	//SetActiveWindow();
}

void TGeom::AfficheOptions(void)
{
char string[12];

  if(typeinter=='0') Fgeom->Check();else Ggeom->Check();
  gcvt((double)angle,6,string);
  Ageom->SetText(string);
  Angle->SetPosition((int)angle);

	 itoa(xcent,string,10);
	 Bgeom->SetText(string);
	 Xcent->SetPosition(xcent);

	 itoa(ycent,string,10);
	 Cgeom->SetText(string);
	 Ycent->SetPosition(ycent);

	 if(grandx==0) grandx=0.000001;         // Pour div par 0
	 gcvt((double)grandx,6,string);
	 Dgeom->SetText(string);
	 Xgrand->SetPosition((int)128.*grandx);

	 if(grandy==0) grandy=0.000001;         // Pour div par 0
	 gcvt((double)grandy,6,string);
	 Egeom->SetText(string);
	 Ygrand->SetPosition((int)128.*grandy);
}

void
TGeom::Execute()
{
	AfficheOptions();
	Rotat(angle,xcent,ycent,grandx,grandy,typeinter);
	Fenetre->Visim(this,1,destin);
}

void
TGeom::PointImage(TPoint&,int)
{
}

void
TGeom::NouveauPoint()
{
	angle=0;
	grandx=grandy=1;
	if(rFig.right!=rFig.left) grandx=255./(float)(rFig.right-rFig.left);
	if(rFig.bottom!=rFig.top) grandy=255./(float)(rFig.bottom-rFig.top);
	xcent=(rFig.left+rFig.right)/2;
	ycent=(rFig.bottom+rFig.top)/2;

	Execute();
}

//----------------------------------------------------------------------------
//						Programme TUtil
//----------------------------------------------------------------------------

void Ev_Image_Util(TPoint&,int);   // Proto

void Ev_Image_Util(TPoint&,int etatsouris)    // une fonction
{
	if(!etatsouris) return;
	if(TUtilPtr)
	{
	 TUtilPtr->NouveauPoint();
	}
}

DEFINE_RESPONSE_TABLE1(TUtil, TUtilitaire)
	EV_WM_SIZE,
	EV_WM_MOUSEMOVE,
  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TUtil::TUtil(TWindow* parent, char far titre[],int mode,BOOL affichinit)
  : TUtilitaire(parent,titre)
{
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376;
		Attr.H = 256+27+106;
		Scroller = new TScroller(this, 5, 5, 640/5, 480/5);  // 640/5, 1000
		Scroller->SetSBarRange();
		fConsistanceUtil=affichinit;
		modeutil=mode;
		if(modeutil>=1&&modeutil<=3)
		{
		new TStatic(this, ID_STATIC, "X :", 10, 256+30+40, 50, 25, 0);
		new TStatic(this, ID_STATIC, "Y :", 150, 256+30+40, 50, 25, 0);
		Px=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 10+30, 256+30+40-5, 50, 25, 5);
		Py=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		"", 150+30, 256+30+40-5, 50, 25, 5);
		}

		if(modeutil==1) IdCurseur=FEN16;else IdCurseur=RETIC;
		switch(modeutil)
		{
		case 2:modefig=GEO_LIGNE;
		break;
		case 3:modefig=GEO_COLONNE;
		break;
		default :modefig=0;
		break;
		}

		Ajoute_Fonction(Ev_Image_Util,modefig,IdCurseur,this);
}

TUtil::~TUtil()
{
	Enleve_Fonction(this);
}

void TUtil::EvMButtonDown(UINT, TPoint &)
{
char string[12];

  Px->GetText(string,sizeof(string));
  posx=atoi(string);
  if(posx>255) posx=255;
  if(posx<0) posx=0;
  itoa(posx,string,10);
  Px->SetText(string);

  Py->GetText(string,sizeof(string));
  posy=atoi(string);
  if(posy>255) posy=255;
  if(posy<0) posy=0;
  itoa(posy,string,10);
  Py->SetText(string);
  NouveauPoint();

	xfen0=xfen1=posx;
	yfen0=yfen1=posy;
	taillex=tailley=0;

		if(TAffimPtr[0])
		{
		TAffimPtr[0]->Affiche();     // Restaure image gauche
		TAffimPtr[0]->Traitfig(SAUVE,modefig,TAffimPtr[0]->buffen,xfen0,yfen0,xfen1,yfen1);
		TAffimPtr[0]->Traitfig(ECRI,modefig,TAffimPtr[0]->buffen,xfen0,yfen0,xfen1,yfen1);
		}
}

void TUtil::EvMouseMove(UINT , TPoint& point)
{
char buf[20];
long a,b,px,py;
int px0=0,py0=0;
int deltax=35,deltay=16;
long i,j;
int decx,decy;

 a=(Scroller->YPos)*5+point.y;
 b=(Scroller->XPos)*5+point.x;

 switch(modeutil)
	{
	case 1:             // Fentre
			 px=b;
			 py=a;
			 j=(px-(px0+deltax))/deltax;
			 i=(py-(py0+2*deltay))/deltay;
			 a=(long)posy+i;b=(long)posx+j;
			 if(a<0) a=0;//if(a>255) a=255;
			 if(b<0) b=0;//if(b>255) b=255;

		//dc.TextOut(px0+deltax+(j*deltax),py0+(2*deltay)+(i*deltay),s);
	break;

	case 2:             // Ligne
	case 3:             // Colonne
			decx=10;decy=5;
			b-=decx;
			a=-a+256+decy;
	if(a>=0&&a<256&&b>=0&&b<256) SetCursor(Applicat, RETIC);
	else SetCursor(0, IDC_ARROW);
	break;

	case 7:             // Histogramme
			decx=50;decy=300;
			b-=decx;
			a=-a+decy;
	if(a>=0&&a<256&&b>=0&&b<256) SetCursor(Applicat, RETIC);
	else SetCursor(0, IDC_ARROW);
	break;
	}
 wsprintf(buf, "X=%ld   Y=%ld", b, a);
 pZ1->SetText(buf);   // affichage dans le deuxime compartiment
}

void TUtil::EvSize(UINT sizeType, TSize& size)
{
	TWindow::EvSize(sizeType, size);
	ShowScrollBar(SB_HORZ);
	ShowScrollBar(SB_VERT);
	Scroller->SetSBarRange();
}

void TUtil::NouveauPoint()
{
  if(modeutil==1||modeutil==2||modeutil==3||modeutil==4||modeutil==7)
	 {
	 fConsistanceUtil=TRUE;
	 Invalidate();
    }
}

void TUtil::PointImage(TPoint&,int)
{
}

void TUtil::Paint(TDC& dc, BOOL, TRect&)
{

unsigned char buf[256];
unsigned char far *pointim;
int i,j,taillex=16,tailley=16,px0=0,py0=0;
char s[80],string[80];
int decx,decy,py;
long a;
int pasx=1,pasy=1;
int x,y,z,u,v,u0,v0,ymax=255,xmax=255,zmax=255;
int tabmin[512],tabmax[512],aut,autprec;
int deltax=35,deltay=16;

float Var,Moy;
double Ectype;
int min,max;

	if (!fConsistanceUtil) return;        // Pas d'affichage

	switch(modeutil)
	{
	case 1:             // Fentre

			dc.MoveTo(px0,py0+(2*deltay)-5);
			dc.LineTo(px0+deltax-5+(16*deltax),py0+(2*deltay)-5);
			dc.MoveTo(px0+deltax-5,py0);
			dc.LineTo(px0+deltax-5,py0+(2*deltay)-5+(16*deltay));

			for(i=0;i<tailley;i++)
			{
				for(j=0;j<taillex;j++)
				{
				 if(posx+j<256&&posy+i<256)
					{
					pointim=source+((posy<<8)+posx+j+(i<<8));
					buf[j+i*tailley]=*pointim;
					itoa(*pointim,s,10);
					//dc.SetTextColor(TColor::Black);
					dc.TextOut(px0+deltax+(j*deltax),py0+(2*deltay)+(i*deltay),s);
					}
				}
				// Coordonnes
				//dc.SetTextColor(TColor::LtBlue);
				itoa(posx+i,s,10);
				dc.TextOut(px0+deltax+(i*deltax),py0, s);
				itoa(posy+i,s,10);
				dc.TextOut(px0,py0+(2*deltay)+(i*deltay), s);
			}
			//dc.SetTextColor(TColor::Black);

			break;

	case 2:             // Ligne
	case 3:             // Colonne

			decx=10;decy=5;

			if(modeutil==2)
			{
			pointim=source+posy*256;
			for(i=0;i<256;i++) buf[i]=*pointim++;
			}
			else
			{
			pointim=source+posx;
			for(i=0;i<256;i++) {buf[i]=*pointim;pointim+=256;}
			}
														 // Rectangle
			dc.Rectangle(decx-1,decy-1,decx+256+1,decy+256+1+1);

			for(i=0;i<=8;i++)                // Graduations x
			{
			dc.MoveTo(decx+i*32,decy+1+256);
			dc.LineTo(decx+i*32,1+decy+5+256);
			itoa(i*32,string,10);
			dc.TextOut(decx+i*32-4*strlen(string),decy+10+256,string);
			}

			for(i=0;i<=8;i++)                 // Graduations y
			{
			py=decy+256-(i*32);
			dc.MoveTo(decx+256+1,py);
			dc.LineTo(1+decx+256+1+5,py);
			itoa(i*32,string,10);
			dc.TextOut(decx+256+13,py-3,string);
			}

			dc.MoveTo(decx+0,decy+256-buf[0]);

			for(i=0;i<256;i++)
			{
			dc.LineTo(decx+i,decy+256-buf[i]);
			}
			break;

			case 4:             // Perspective

			decx=0;decy=0;

			for(u=0;u<=511;u++){tabmax[u]=-1;tabmin[u]=256;}

			for(y=ymax;y>=0;y-=pasy)
			{
			for(x=xmax;x>=0;x-=pasx)
			{
			pointim=source+x+(y<<8);
			z=(int)*pointim;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;

			if(x==xmax) {u0=u;v0=v;autprec=0;}
			aut=0;
			if(v>tabmax[u]){tabmax[u]=v;aut=1;}
			if(v<tabmin[u]){tabmin[u]=v;aut=1;}
			if(aut==1)
				{
				if(autprec==0) {u0=u;v0=v;}
				dc.MoveTo(decx+u0,decy+v0);
				dc.LineTo(decx+u,decy+v);
				dc.LineTo(decx+u+1,decy+v);
				autprec=1;
				}
			else autprec=0;
			u0=u;v0=v;
			}
			}

			for(y=ymax;y>=0;y--)         	// synthse plans 0 et max
			{
				for(x=xmax;x>=0;x--)
				{
			if(x==xmax||y==ymax||x==0||y==0)
			{
			z=0;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;
			dc.SetPixel(decx+u,decy+v,TColor::LtBlue);
			z=zmax;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;
			dc.SetPixel(decx+u,decy+v,TColor::LtGreen);
			}
			}
			}
													// Axes
			dc.TextOut(decx+384+10,decy+128,"X");
			dc.TextOut(decx,decy+256+10,"Y");
			dc.TextOut(decx+128-28,decy,"Z");

			break;

	case 5:             // Statistique

		  dc.TextOut(1,0,"MOYENNE    : ");
		  dc.TextOut(1,15,"ECART TYPE : ");
		  dc.TextOut(1,30,"ENTROPIE   : ");
		  dc.TextOut(1,45,"MINIMUM    : ");
		  dc.TextOut(1,60,"MAXIMUM    : ");
		  gcvt(moy_image,6,string);
		  dc.TextOut(120,0,string);
		  gcvt(ec_type_image,6,string);
		  dc.TextOut(120,15,string);
		  gcvt(entropie_image,6,string);
		  dc.TextOut(120,30,string);
		  itoa(min_image,string,10);
		  dc.TextOut(120,45,string);
		  itoa(max_image,string,10);
		  dc.TextOut(120,60,string);

			break;

	case 6:             // Covariance

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				gcvt((double)cov[i][j],6,string);
				dc.TextOut(1+j*80,i*20,string);
				}
			}
			break;

	case 7:             // Histogramme

   		Calhist(bufhist,bufrepa,source);
			decx=50;
			decy=300;

			dc.Rectangle(decx-1,decy-256,decx+256+1,decy+1);
			dc.SetTextColor(TColor::Black);
			dc.TextOut(decx,decy-256-20,"HISTOGRAMME");
			dc.SetTextColor(TColor::LtBlue);
			dc.TextOut(decx+112,decy-256-20,"HISTOGRAMME CUMULE");

			dc.SetTextColor(TColor::Black);

			for(i=0;i<=8;i++)                // Graduations x
			{
			dc.MoveTo(decx+i*32,decy+1);
			dc.LineTo(decx+i*32,1+decy+5);
			itoa(i*32,string,10);
			dc.TextOut(decx+i*32-4*strlen(string),decy+10,string);
			}

			for(i=0;i<=8;i++)                 // Graduations histo
			{
			a=8192*(long)i;
			py=decy-(int)sqrt((double)a);
			dc.MoveTo(decx-5-1,py);
			dc.LineTo(1+decx-1,py);
			itoa(i,string,10);
			strcat(string,"/8");
			dc.TextOut(decx-13-8*strlen(string),py-3,string);
			}

			dc.SetTextColor(TColor::LtBlue);

			for(i=0;i<=8;i++)                 // Graduations F.repa
			{
			a=8192*(long)i;
			py=decy-(int)(a>>8);
			dc.MoveTo(decx+256+1,py);
			dc.LineTo(1+decx+256+1+5,py);
			itoa(i,string,10);
			strcat(string,"/8");
			dc.TextOut(decx+256+13,py-3,string);
			}

			for(i=0;i<256;i++)                // Trac histo
			{
			y=(int)sqrt((double)bufhist[i]);
			dc.MoveTo(decx+i,decy);
			dc.LineTo(decx+i,decy-y);
			dc.LineTo(decx+i+1,decy-y);
			}

			for(i=0;i<256;i++)                // Trac F.repa
			{
			dc.SetPixel(decx+i,decy-(bufrepa[i]>>8),TColor::LtBlue);
			}

			break;

	}// switch

							// Affichage commun min max moyenne & ec.type

			if((posx+j<256&&posy+i<256&&modeutil==1)||modeutil==2||modeutil==3)
			{
			if(modeutil==1) Min_max(buf,&min,&max,(long)(taillex*tailley));
			else Min_max(buf,&min,&max,256);
			strcpy(s,"Minimum = ");
			itoa(min,string,10);
			strcat(s,string);
			dc.TextOut(px0+10,py0+256+30, s);
			strcpy(s,"Maximum = ");
			itoa(max,string,10);
			strcat(s,string);
			dc.TextOut(px0+10,py0+256+30+20, s);
			Moy=Moyenne_courbe(buf,(long)(taillex*tailley));
			gcvt((double)Moy,6,string);
			strcpy(s,"Moyenne = ");
			strcat(s,string);
			dc.TextOut(px0+150,py0+256+30, s);
			Var=Variance_courbe(buf,(long)(taillex*tailley));
			Ectype=sqrt((double)Var);
			gcvt(Ectype,6,string);
			strcpy(s,"Ecart type = ");
			strcat(s,string);
			dc.TextOut(px0+150,py0+256+30+20,s);

			}
			if(modeutil>=1&&modeutil<=3)
			{
			 itoa(posx,string,10);
			 Px->SetText(string);
			 itoa(posy,string,10);
			 Py->SetText(string);
			}
}

//----------------------------------------------------------------------------

