/**********************************************************************/
/*                       W M A I N . C P P                            */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 19/12/1997                                     */
/**********************************************************************/

#include <stdio.h>                       // Dos
#include <alloc.h>

#include "wgttsi.h"                    // Librairies Image
#include "wlmodif.h"

#include "wappbase.rh"
#include "wappbase.h"
#include "wmain.h"

											// Pointeurs sur les fentres
TAffim* TAffimPtr[] = { 0, 0 }; // Fentres images
TWindow* TSeuilPtr = 0;      		// Fentre seuil
TUtilitaire* TUtilPtr=0;        	// Fentre utilitaire

int EtatBGSouris=0;               // Fentres images
int EtatBDSouris=0;
int DragBDSouris=0;
int DragBGSouris=0;
int ClickUpBGSouris=0,ClickUpBDSouris=0;
int fAutoSouris;
int fShift,fTrack,
	 fFirstTrack,fFirstShift;

int fSauvegardeAutoDef=0;

int xfen0=0,yfen0=0;
int xfen1=0,yfen1=0;
int taillex=0,tailley=0;

TRect rFig;                       // rectangle dlimitant la figure

int modefig=0;                    // figure dessine sur l'image

int posx,posy;                    // Position curseur souris

unsigned char far* ptr[2];        // Pointeurs image

TResId IdCurseur=RETIC;        
int pseudo=0;                             // Pseudo
int seuinf=0,seusup=255;

typeFonction1 TAB_FONCTION[10];        // tableau des fonctions
int TAB_MODEFIG[10];           // tableau des modes
TResId TAB_CURSEUR[10];           // tableau des curseurs
TWindow* TAB_FENETRE[10];      // tableau des fentres associes
int iFonction=0;               // indice tableau

//----------------------------------------------------------------------------
//						Programme Fonctions paramtrables
//----------------------------------------------------------------------------

void Fonction_Vide(TPoint&,int);

void Fonction_Vide(TPoint&,int)
{
}

void Ev_ClicNouveauPoint(TPoint &,int);

void Ev_ClicNouveauPoint(TPoint &,int w)
{
  if (w & SOURIS_STATE_BG)
  Indique_Fonction()->SendMessage(WM_COMMAND,CM_NouveauPoint);
}

//----------------------------------------------------------------------------

typeFonction1 fAffPtr=Fonction_Vide;

//----------------------------------------------------------------------------

void Ajoute_Fonction(typeFonction1 p,int modefig,TResId IdCurseur,TWindow* pt);

void Ajoute_Fonction(typeFonction1 p,int mode,TResId IdCurseur,TWindow* pt)
{
TModule* module=0;

  modefig=mode;
	if(iFonction<10)                      // limite a 10
		{
		TAB_FONCTION[iFonction]=p;
		fAffPtr=p;
		TAB_MODEFIG[iFonction]=mode;
		TAB_CURSEUR[iFonction]=IdCurseur;
		TAB_FENETRE[iFonction]=pt;
		iFonction++;
  if(TAffimPtr[0])
  {
  if(IdCurseur==(TResId)RETIC||IdCurseur==(TResId)FEN8||IdCurseur==(TResId)FEN16)
	module=Applicat;
  TAffimPtr[0]->SetCursor(module,IdCurseur);
  TAffimPtr[0]->Affiche();     // Restaure image gauche
  }
		}
		else {}                           // opration non ralise
}

//----------------------------------------------------------------------------

TWindow* Indique_Fonction(void);

TWindow* Indique_Fonction(void)
{
return iFonction?TAB_FENETRE[iFonction-1]:NULL;
}

//----------------------------------------------------------------------------

void Enleve_Fonction(TWindow* pt);

void Enleve_Fonction(TWindow* pt)
{
int i,j;
TResId IdCurseur;
TModule* module=0;

	for(i=0;i<iFonction;i++)            // recherche
	{
	if(TAB_FENETRE[i]==pt) break;
	}

	if(i==10) return;                    // chec

	for(j=i;j<iFonction;j++)
		{
		TAB_FONCTION[j]=TAB_FONCTION[j+1];   //translation
		TAB_MODEFIG[j]=TAB_MODEFIG[j+1];
		TAB_FENETRE[j]=TAB_FENETRE[j+1];
		TAB_CURSEUR[j]=TAB_CURSEUR[j+1];
		}
	iFonction--;

		if(iFonction==0)
		{
		modefig=0;
		fAffPtr=Fonction_Vide;
		IdCurseur=RETIC;
		}
		else
		{
		modefig=TAB_MODEFIG[iFonction-1];    // la plus rcente
		fAffPtr=TAB_FONCTION[iFonction-1];
		IdCurseur=TAB_CURSEUR[iFonction-1];
		}
	if (TAffimPtr[0])
	{
	if(IdCurseur==(TResId)RETIC||IdCurseur==(TResId)FEN8||IdCurseur==(TResId)FEN16)
	module=Applicat;
	TAffimPtr[0]->SetCursor(module,IdCurseur);
	TAffimPtr[0]->Affiche();     // Restaure image gauche
	}
}

//----------------------------------------------------------------------------
//						Programme NouveauCurseur
//----------------------------------------------------------------------------

void NouveauCurseur(int NouvelId)
  {
  IdCurseur=NouvelId;
  if (TAffimPtr[0]) TAffimPtr[0]->SetCursor(Applicat, IdCurseur);
  }

/*-----------------------------------------------------------------------*/
/*                   Nouvelle classe TAssociatif                         */
/*--Systme--------------------------------------------------------------*/

TAssociatif::TAssociatif(TWindow* parent, char *szTitre, char cType)
  : TFramePrint(parent, szTitre), sEspaceUtile()

{
  Attr.Style =WS_MINIMIZEBOX | WS_BORDER | WS_CAPTION |WS_VISIBLE |
		WS_OVERLAPPED |WS_CHILD | WS_SYSMENU | WS_CLIPSIBLINGS;
  Attr.Style &= ~(WS_MAXIMIZEBOX);

  fOptionsPresentes=FALSE;fSauvegardeAuto=FALSE;
  switch (cType)
	 {
	 case ASS_BAS :
		Attr.X = 0;
		Attr.Y = HAUTEUR_AFFIM;
		Attr.W = iLargeurEcran;
		Attr.H = iHauteurEcran-HAUTEUR_AFFIM-HAUTEUR_SYSTEME;
		break;
	 case ASS_DROITE_HAUT :
		Attr.X=LARGEUR_AFFIM;
		Attr.Y=0;
		Attr.W=iLargeurEcran-LARGEUR_AFFIM;
		Attr.H=HAUTEUR_AFFIM;
		break;
	 case ASS_DROITE_BAS :
		Attr.X = LARGEUR_AFFIM;
		Attr.Y = HAUTEUR_AFFIM;
		Attr.W = iLargeurEcran-LARGEUR_AFFIM;
		Attr.H = iHauteurEcran-HAUTEUR_AFFIM-HAUTEUR_SYSTEME;
		break;
	 case ASS_GAUCHE_BAS :
		Attr.X = 0;
		Attr.Y = HAUTEUR_AFFIM;
		Attr.W = LARGEUR_AFFIM;
		Attr.H = iHauteurEcran-HAUTEUR_AFFIM-HAUTEUR_SYSTEME;
		break;
	 default :
	 case ASS_DROITE :
		Attr.X=LARGEUR_AFFIM;
		Attr.Y=0;
		Attr.W=iLargeurEcran-LARGEUR_AFFIM;
		Attr.H=iHauteurEcran-HAUTEUR_SYSTEME;
		break;
	 }
  sEspaceUtile=TSize(Attr.W-2*uLargeurBordureFine,
							Attr.H-2*uHauteurBordureFine-uHauteurMenu);
  }

void TAssociatif::SetupWindow()
{
  TFramePrint::SetupWindow();

  if (fOptionsPresentes) ChargeOptions();

  TSystemMenu mnuSys(HWindow);
  pmnuConfig=new TMenu;

  if (fOptionsPresentes)
	 {
	 pmnuConfig->AppendMenu(MF_STRING, CM_ASS_SauvegOptionsAuto, "&Sauvegarde options en quittant");
	 pmnuConfig->AppendMenu(MF_STRING, CM_ASS_SauvegOptionsMaintenant, "Sauvegarde options &maintenant");
	 mnuSys.AppendMenu(MF_POPUP, *pmnuConfig, "&Configurations");
	 }
	 BringWindowToTop();
}

TAssociatif::~TAssociatif()
{
  delete pmnuConfig;
  if(fSauvegardeAuto)
	 {
	 ReleveOptions();
	 SauvegardeOptions();
    }
}

void TAssociatif::EvInitMenuPopup(HMENU hPopupMenu, UINT index,BOOL sysMenu)
{
  TFramePrint::EvInitMenuPopup(hPopupMenu,index,sysMenu);
  if ((HMENU)(*pmnuConfig)==hPopupMenu)
    {
	 pmnuConfig->CheckMenuItem(CM_ASS_SauvegOptionsAuto, fSauvegardeAuto ? MF_CHECKED : MF_UNCHECKED);
    }
}

void TAssociatif::EvRButtonDown(UINT, TPoint& p)
  {
  TPopupMenu mnuFlot;                  // crer un objet "menu flottant"
  GenereMenuFlottant(&mnuFlot);
  ClientToScreen(p);
  mnuFlot.TrackPopupMenu(TPM_RIGHTBUTTON, p, 0, HWindow, NULL);
  }

void TAssociatif::EvLButtonUp(UINT, TPoint& )
{
	EtatBGSouris=0;
}

void TAssociatif::EvLButtonDown(UINT, TPoint& )
{
	EtatBGSouris=1;
}

void TAssociatif::EvMouseMove(UINT a, TPoint& point)
{
  char buf[20];
  if(a) {}
  wsprintf(buf, "X=%d   Y=%d", point.x, point.y);
  pZ1->SetText(buf);
}

void  TAssociatif::ChargeOptions(void)
  {
  fSauvegardeAuto=GetPrivateProfileInt(Title,"sauvegarde automatique",fSauvegardeAutoDef,szINIFileName);
  }

void  TAssociatif::ReleveOptions(void)
  {
  }

void  TAssociatif::SauvegardeOptions(void)
  {
  WritePrivateProfileString(Title,"sauvegarde automatique",fSauvegardeAuto?"1":"0",szINIFileName);
  }

void TAssociatif::CmConfig(WPARAM id)
  {
  switch (id)
	 {
	 case CM_ASS_SauvegOptionsAuto:
		fSauvegardeAuto=!fSauvegardeAuto;
		break;
	 case CM_ASS_SauvegOptionsMaintenant:
		ReleveOptions();
		SauvegardeOptions();
		break;
	 }
  }

void TAssociatif::EvSysCommand(UINT cmdType,TPoint& p)
  {
  switch(cmdType)
	{
	case CM_ASS_SauvegOptionsAuto : CmConfig(CM_ASS_SauvegOptionsAuto);break;
	case CM_ASS_SauvegOptionsMaintenant : CmConfig(CM_ASS_SauvegOptionsMaintenant);break;
	default :TFramePrint::EvSysCommand(cmdType,p);break;
	}
}

DEFINE_RESPONSE_TABLE1(TAssociatif, TFramePrint)
  EV_WM_RBUTTONDOWN,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_MOUSEMOVE,
  EV_WM_SYSCOMMAND,
  EV_WM_INITMENUPOPUP,
END_RESPONSE_TABLE;

/*-Nouvelles fonctionnalits---------------------------------------------*/

void TAssociatif::GenereMenuFlottant(TPopupMenu *pmnuFlot)
{
  if (pmnuFlot)
	 {  // Pas de menu gnrique (pour l'instant).
	 }
}

/*-----------------------------------------------------------------------*/
/*                   Nouvelle classe TUtilitaire                         */
/*--Systme--------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1(TUtilitaire, TAssociatif)
  EV_COMMAND(CM_NouveauPoint, NouveauPoint),
END_RESPONSE_TABLE;
TUtilitaire::TUtilitaire(TWindow* parent, char *szTitre, char cType)
  : TAssociatif(parent, szTitre,cType)
  {
  if (TUtilPtr) TUtilPtr->ShutDownWindow();      // destruction ancien
  TUtilPtr=this;
  Ajoute_Fonction(Ev_ClicNouveauPoint,modefig=0,RETIC,this);   // wmain
  }

TUtilitaire::~TUtilitaire()
{
  Enleve_Fonction(this);   // wmain
	TUtilPtr=NULL;
}

/*-Nouvelles fonctionnalits---------------------------------------------*/

void TUtilitaire::NouveauPoint()
{
}

void TUtilitaire::PointImage(TPoint&,int)
{
}

//----------------------------------------------------------------------------
//						Programme AppelChoixDial
//----------------------------------------------------------------------------

BOOL AppelChoixDial(TWindow *Parent,char titre[],char tabchoix[], char *pcRes, TRect fen)
{
  int iRes=TChoixDial(Parent,titre,tabchoix,fen).Execute();
  if (!pcRes || iRes == 'f'|| iRes == 'F'	|| iRes == 0x02)// Annulation ou
	 return FALSE;                                         // Fermeture
  else
	 {
	 *pcRes=iRes & 0xFF;
	 return TRUE;
	 }
}

//----------------------------------------------------------------------------
//						Programme TChoixDial
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TChoixDial, TDialog)
  EV_COMMAND(ID_A, EvA),
  EV_COMMAND(ID_A+1, EvB),
  EV_COMMAND(ID_A+2, EvC),
  EV_COMMAND(ID_A+3, EvD),
  EV_COMMAND(ID_A+4, EvE),
  EV_COMMAND(ID_A+5, EvF),
  EV_COMMAND(ID_A+6, EvG),
  EV_COMMAND(ID_A+7, EvH),
  EV_COMMAND(ID_A+8, EvI),
  EV_COMMAND(ID_A+9, EvJ),
  EV_COMMAND(ID_BOUTON, EvBouton),

  END_RESPONSE_TABLE;

TChoixDial::TChoixDial(TWindow *Parent,char titre[],char tabchoix[],TRect fen)
	: TDialog(Parent, "DIALBOX")
  {
int TailleBouton;
int LargeurFen;
int maxl=0;
int i,x0,y0,l,j;
int xmax,ymax;             // Largeur & hauteur fentre
int Fx,Fy=25;            	// Tailles fentres
char *pt,*tab;
int nbchoix;

	SetCaption(titre);
	l=strlen(tabchoix);
	tab=(char *)malloc(l+1);
	pt=tab;
	strcpy(pt,tabchoix);
	nbchoix=1;
	for(i=0;i<l;i++)
	if(pt[i]=='\n') {pt[i]=0;nbchoix++;}
	if(nbchoix>10) nbchoix=10;     // Limite le nb total de choix
  if(fen.IsNull())               // On calcule le format
  {
  for(i=0;i<nbchoix;i++)         // calcul du max
	 {
	 l=strlen(pt);
	 maxl= (l > maxl) ? l : maxl;
	 pt+=l+1;
	 }
  TailleBouton=maxl*8+8;
  LargeurFen=TailleBouton*nbchoix+30;
  l=strlen(titre)*8+100;          // Min 100
  if(LargeurFen<l) LargeurFen=l;
  Format=TRect(320-LargeurFen/2,200,320+LargeurFen/2,300)&TRect(0,0,640,480);
  }
  else Format=fen;              // On prend le format

  xmax=Format.Width()-GetSystemMetrics(SM_CXBORDER)*2;
  ymax=Format.Height()-GetSystemMetrics(SM_CYBORDER)*2
		  -GetSystemMetrics(SM_CYMENU);

	Fx=(xmax-30)/nbchoix;
	if(Fx>160) Fx=160;         // Si trop grand : pas joli !!!

	x0=(xmax-Fx*nbchoix)>>1;  // centre horizontal
	y0=(ymax-2*Fy)>>1;        // position verticale

	pt=tab;
	for(i=0;i<nbchoix;i++)
	{
	new TButton(this,ID_A+i,pt,x0+i*Fx,y0,Fx-1,Fy-1,FALSE);
	l=strlen(pt);
	tabret[i]=pt[0];  // Par dfaut
	for(j=0;j<l;j++) if(pt[j]=='&') tabret[i]=pt[j+1];
	pt+=l+1;
	}
	new TButton(this,ID_BOUTON,"&FERMER",x0,y0+Fy,-1+nbchoix*Fx,Fy-1,FALSE);
	free(tab);
  }

void TChoixDial::EvA()
{
	EvCommun(tabret[0]);
}

void TChoixDial::EvB()
{
	EvCommun(tabret[1]);
}

void TChoixDial::EvC()
{
	EvCommun(tabret[2]);
}

void TChoixDial::EvD()
{
	EvCommun(tabret[3]);
}

void TChoixDial::EvE()
{
	EvCommun(tabret[4]);
}

void TChoixDial::EvF()
{
	EvCommun(tabret[5]);
}

void TChoixDial::EvG()
{
	EvCommun(tabret[6]);
}

void TChoixDial::EvH()
{
	EvCommun(tabret[7]);
}

void TChoixDial::EvI()
{
	EvCommun(tabret[8]);
}

void TChoixDial::EvJ()
{
	EvCommun(tabret[9]);
}

void TChoixDial::EvBouton()
{
	CloseWindow(int('F'));          // F-> FERMER
}

void TChoixDial::EvCommun(char c)
{
	CloseWindow(int(c));
}

void TChoixDial::SetupWindow()
{
	TDialog::SetupWindow();
	MoveWindow(Format, FALSE);
}

void TChoixDial::CloseWindow(int ret)
{
	TDialog::CloseWindow(ret);            // fermer la bote de dialogue
}

//----------------------------------------------------------------------------
//						Programme TChoix
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TChoix, TFrameWindow)

  EV_COMMAND_AND_ID(ID_A, EvA),
  EV_COMMAND_AND_ID(ID_A+1, EvB),
  EV_COMMAND_AND_ID(ID_A+2, EvC),
  EV_COMMAND_AND_ID(ID_A+3, EvD),
  EV_COMMAND_AND_ID(ID_A+4, EvE),
  EV_COMMAND_AND_ID(ID_A+5, EvF),
  EV_COMMAND_AND_ID(ID_A+6, EvG),
  EV_COMMAND_AND_ID(ID_A+7, EvH),
  EV_COMMAND_AND_ID(ID_A+8, EvI),
  EV_COMMAND_AND_ID(ID_A+9, EvJ),
  EV_COMMAND(ID_BOUTON, EvClose),
  EV_WM_CLOSE,
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),
  END_RESPONSE_TABLE;

TChoix::TChoix(TWindow* parent,char titre[],char tabchoix[],TRect rFen)
			: TFrameWindow(parent,titre)
{
int i,x0,y0,l,j;
int xmax,ymax;             // Largeur & hauteur fentre
int Fx,Fy=25;            	// Tailles fentres
char *pt,*tab;

	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;
	Attr.X = rFen.left;
	Attr.Y = rFen.top;
	Attr.W = rFen.Width();
	Attr.H = rFen.Height();

	xmax=rFen.Width()-GetSystemMetrics(SM_CXBORDER)*2;
	ymax=rFen.Height()-GetSystemMetrics(SM_CYBORDER)*2
		  -GetSystemMetrics(SM_CYMENU);

	l=strlen(tabchoix);
	tab=(char *)malloc(l+1);

	pt=tab;
	strcpy(pt,tabchoix);

	nbchoix=1;
	for(i=0;i<l;i++)
	if(pt[i]=='\n') {pt[i]=0;nbchoix++;}
	if(nbchoix>10) nbchoix=10;     // Limite le nb total de choix

	Fx=(xmax-20)/nbchoix;
	if(Fx>160) Fx=160;         // Si trop grand : pas joli !!!

	x0=(xmax-Fx*nbchoix)>>1;  // centre horizontal
	y0=(ymax-2*Fy)>>1;        // position verticale

	for(i=0;i<nbchoix;i++)
	{
	tab_bt[i+1]=new TButton(this,ID_A+i,pt,x0+i*Fx,y0,Fx-1,Fy-1,FALSE);
	l=strlen(pt);
	tabret[i]=pt[0];  // Par dfaut
	for(j=0;j<l;j++) if(pt[j]=='&') tabret[i]=pt[j+1];
	pt+=l+1;
	}
	for (;i<10;i++) tab_bt[i+1]=NULL;

	free(tab);
	tab_bt[0]=new TButton(this,ID_BOUTON,"&FERMER",
							x0,y0+Fy,-1+nbchoix*Fx,Fy-1,FALSE);
	commande='0';
}

void TChoix::EvA(UINT)
{
	commande=tabret[0];
	EvCommun(commande);
}

void TChoix::EvB(UINT)
{
	commande=tabret[1];
	EvCommun(commande);
}

void TChoix::EvC(UINT)
{
	commande=tabret[2];
	EvCommun(commande);
}

void TChoix::EvD(UINT)
{
	commande=tabret[3];
	EvCommun(commande);
}

void TChoix::EvE(UINT)
{
	commande=tabret[4];
	EvCommun(commande);
}

void TChoix::EvF(UINT)
{
	commande=tabret[5];
	EvCommun(commande);
}

void TChoix::EvG(UINT)
{
	commande=tabret[6];
	EvCommun(commande);
}

void TChoix::EvH(UINT)
{
	commande=tabret[7];
	EvCommun(commande);
}

void TChoix::EvI(UINT)
{
	commande=tabret[8];
	EvCommun(commande);
}

void TChoix::EvJ(UINT)
{
	commande=tabret[9];
	EvCommun(commande);
}

void TChoix::EvExec(UINT)
{
	EvCommun(commande);
}

void TChoix::EvCommun(char )
{
}

void TChoix::EvClose()
{
	TChoix::~TChoix();
}

TChoix::~TChoix()
{
}

//----------------------------------------------------------------------------
//						Programme TChoixMenu
//----------------------------------------------------------------------------

TChoixMenu::TChoixMenu(TWindow* parent,char titre[],char tabchoix[])
  : TChoix(parent,titre,tabchoix,TRect(0,282+OFFSET,640,107+282+OFFSET))
{
}

TChoixMenu::~TChoixMenu()
{
}

void TChoixMenu::EvCommun(char)
{
}

//----------------------------------------------------------------------------
//						Programme TSeuil
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TSeuil, TFrameWindow)
  EV_CHILD_NOTIFY_ALL_CODES(ID_SEUIL, EvSeuil),
  EV_CHILD_NOTIFY_ALL_CODES(ID_BOUTON, EvBouton),
  EV_COMMAND_AND_ID(ID_EXEC, EvExec),
  EV_WM_CLOSE,
  EV_WM_MBUTTONDOWN,

  END_RESPONSE_TABLE;

TSeuil::TSeuil(TWindow* parent,char titre[],int smin,int smax,int sinit)
  : TFrameWindow(parent, titre)
{
char string[20];

		seuilmin=smin;
		seuilmax=smax;
		seuil=sinit;

	Attr.Style = WS_VISIBLE | WS_POPUP | WS_OVERLAPPED |
					WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX;

		Attr.X = 0;
		Attr.Y = 282+OFFSET;
		Attr.W = 640;
		Attr.H = 107;

		Seuil = new TScrollBar(this, ID_SEUIL, 0, 30, 256, 0, TRUE);
		itoa(seuilmin,string,10);
		new TStatic(this, ID_STATIC, string, 0, 5, 50, 17, 0);
		itoa(seuil,string,10);
		Eseuil=new TEditNumRC(WM_MBUTTONDOWN,this, ID_STATIC,
		string, 126, 0, 50, 25, 5);
		itoa(seuilmax,string,10);
		new TStatic(this, ID_STATIC, string, 240, 5, 50, 17, 0);
		new TButton(this,ID_BOUTON,"OK",280,30,30,30,FALSE);
}

void
TSeuil::SetupWindow()
{
  TFrameWindow::SetupWindow();
  Seuil->SetRange(seuilmin,seuilmax);
  AfficheSeuil(seuil);
}

void
TSeuil::AfficheSeuil(int seuil)
{
 char string[12];

  sprintf(string, "%d", seuil);
  Eseuil->SetText(string);
  Seuil->SetPosition(seuil);
}

void
TSeuil::EvSeuil(UINT)
{
//int seuil;

  seuil=Seuil->GetPosition();
  AfficheSeuil(seuil);
  EvCommun(seuil);
}

void
TSeuil::EvExec(UINT)
{
	EvCommun(seuil);
}

void
TSeuil::EvCommun(int seuil)
{
  Seuillage(seuil);
  Fenetre->Visim(this,1,destin);
  SetActiveWindow();
}

void TSeuil::EvMButtonDown(UINT, TPoint &)
{
  char string[12];
//  int seuil;

  Eseuil->GetText(string,sizeof(string));
  seuil=atoi(string);
  if(seuil<seuilmin) seuil=seuilmin;
  if(seuil>seuilmax) seuil=seuilmax;

  AfficheSeuil(seuil);
  EvCommun(seuil);
}

void TSeuil::EvClose()
{
	TSeuil::~TSeuil();
}

void TSeuil::EvBouton(UINT)
{
	TSeuil::~TSeuil();
}

TSeuil::~TSeuil()
{
	TSeuilPtr=0;
}

//----------------------------------------------------------------------------
//						Programme TAffim
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TAffim, TFrameWindow)
	 EV_WM_GETMINMAXINFO,
	 EV_WM_MOUSEMOVE,
	 EV_WM_LBUTTONDOWN,
	 EV_WM_LBUTTONUP,
	 EV_WM_RBUTTONDOWN,
	 EV_WM_RBUTTONUP,
END_RESPONSE_TABLE;

TAffim::TAffim(TWindow* parent, int type,char far titre[])
  : TFrameWindow(parent,titre),
	 Type (type)
	 {
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW;
		Attr.Y =OFFSET;
		Attr.W = 256+8;
		Attr.H = 256+27;
		switch(type)
		{
		case 0:             //Image 1
		Attr.X = 0;
		break;

		case 1:             //Image 2
		Attr.X = 320;
		break;
		}//switch

		EtatBGSouris=0;
		EtatBDSouris=0;
		DragBDSouris=0;
		DragBGSouris=0;
		fAutoSouris=1;
		fShift=fTrack=0;
		fFirstTrack=fFirstShift=0;
}

BOOL TAffim::CanClose()
{
	  return TRUE;
}


void
TAffim::SetupWindow()
{
  TFrameWindow::SetupWindow();
  SetCursor(Applicat, RETIC);   // Par dfaut rticule sur image
}

void
TAffim::EvGetMinMaxInfo(MINMAXINFO far& MinMaxInfo)
{
	MinMaxInfo.ptMaxSize.x = 256+8;          // limite taille fentre
	MinMaxInfo.ptMaxSize.y = 256+27;
	MinMaxInfo.ptMaxTrackSize.x = 256+8;
	MinMaxInfo.ptMaxTrackSize.y = 256+27;
}

void
TAffim::Affiche()
{
TClientDC* pdc;

	pdc=new TClientDC(*this);
	Paint(*pdc, FALSE, TRect(0,0,256,256));
	delete pdc;
}

//
// Affiche les images
//
void
TAffim::Paint(TDC& dc, BOOL, TRect& )
{
TDib *dib;
TPoint *src;
unsigned char far *pointim,*pointim1,*pointim2,*pointim3,*p;
unsigned int x,y;
unsigned char lut[1024];
int a,mode;
unsigned char huge *im3;
void huge *im4;
HANDLE hloc,hgl;
PBITMAPINFO pbmi;
HBITMAP hbm;
TRect dest;

	if(Type==0) indic_first=1;    // Pour figure

	if(Type==1) mode=0;         // N/B
	else mode=modcoul;

	p=ptr[Type];
	hgl = GlobalAlloc(LMEM_MOVEABLE,65536L*3);
	im3=(unsigned char huge *) GlobalLock(hgl);
	im4=(void huge *)im3;

	if(im3!=NULL)
	{
	if(mode==0)
	{
	hloc = LocalAlloc(LMEM_ZEROINIT | LMEM_MOVEABLE,
	 sizeof(BITMAPINFOHEADER) + (1024));
	}
	else
	{
	hloc = LocalAlloc(LMEM_ZEROINIT | LMEM_MOVEABLE,
	 sizeof(BITMAPINFOHEADER)+ (1024));
	}
	pbmi = (PBITMAPINFO) LocalLock(hloc);

	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi->bmiHeader.biWidth = 256;
	pbmi->bmiHeader.biHeight = 256;
	pbmi->bmiHeader.biPlanes = 1;
	pbmi->bmiHeader.biCompression = BI_RGB;

	if(mode==0)
	{
	pbmi->bmiHeader.biBitCount = 8;
	pbmi->bmiHeader.biClrUsed=256;
	pbmi->bmiHeader.biClrImportant=256;
	}
	else
	{
	pbmi->bmiHeader.biBitCount = 24;
	pbmi->bmiHeader.biClrUsed=0;
	pbmi->bmiHeader.biClrImportant=0;
	}
	pbmi->bmiHeader.biSizeImage=(pbmi->bmiHeader.biWidth*
	pbmi->bmiHeader.biHeight)*pbmi->bmiHeader.biBitCount/8;

	if(mode==0)   // N/B
	{
	if(pseudo==0||Type==0)	for(x=0;x<1024;x+=4)             // Lut linaire
		{lut[x]=x>>2;lut[x+1]=x>>2;lut[x+2]=x>>2;lut[x+3]=0;}
	else
	{
	Callut((char)pseudo+'0',seuinf,seusup);
	for(x=0;x<1024;x+=4)             // Lut pseudo
		{
		lut[x]=(unsigned char)(lutb[x>>2]>>8);
		lut[x+1]=(unsigned char)(lutv[x>>2]>>8);
		lut[x+2]=(unsigned char)(lutr[x>>2]>>8);
		lut[x+3]=0;
		}
	}
	memcpy(pbmi->bmiColors, lut, 1024);

	for(y=0;y<256;y++)
		{
		pointim=p+(y*256);
		pointim1=(unsigned char far *)im3+(255-y)*256;
		memcpy(pointim1,pointim,256);
		}
	}
	else         // Couleur
	{
		for(x=0;x<1024;x+=4)             // Lut linaire
		{lut[x]=x>>2;lut[x+1]=x>>2;lut[x+2]=x>>2;lut[x+3]=0;}
		memcpy(pbmi->bmiColors, lut, 1024);

		for(a=255;a>=0;a--)
		{
		y=(unsigned int)a;
		pointim1=image1+(y*256);
		pointim2=image2+(y*256);
		pointim3=image3+(y*256);
		for(x=0;x<256;x++)
		 {
		 *im3++=*pointim1++;
		 *im3++=*pointim3++;
		 *im3++=*pointim2++;
		 }
		}
	}

if(mode==0)    // N/B
	{
	SetDIBitsToDevice(                           // Windows
		dc,
		0, 0, 256, 256,
		0, 0, 0, 256,
		im3,(LPBITMAPINFO)pbmi, DIB_RGB_COLORS);
	}
else            // Couleur
	{
	hbm = CreateDIBitmap(dc, (BITMAPINFOHEADER FAR*) pbmi, CBM_INIT,
								im4, pbmi, DIB_RGB_COLORS);
	if(hbm!=NULL)
	{
	dest = TRect(0,0,256,256);
	src = new TPoint(0,0);
	dib= new TDib(hbm,FALSE);
	if(dib->IsOK()==TRUE) dc.SetDIBitsToDevice(dest,*src,*dib);
	delete dib;
	delete src;
	DeleteObject(hbm);
	} //if
	}//else
	LocalFree(hloc);
	GlobalFree(hgl);
	}
}

void TAffim::EvMouseMove(UINT a, TPoint& point)
{
	if(EtatBDSouris) DragBDSouris=1;
	if(EtatBGSouris) DragBGSouris=1;
	EvSouris(a,point);
}

void TAffim::EvLButtonUp(UINT a, TPoint& point)
{
	EtatBGSouris=0;
	DragBGSouris=0;
  ClickUpBGSouris=1;
  if (fAutoSouris) fSetTracking(0);
  EvSouris(a,point);
}

void TAffim::EvRButtonUp(UINT a, TPoint& point)
{
	EtatBDSouris=0;
	DragBDSouris=0;
  ClickUpBDSouris=1;
  if (fAutoSouris) fSetShifting(0);
  EvSouris(a,point);
}

void TAffim::EvRButtonDown(UINT a, TPoint& point)
{
	EtatBDSouris=1;
	DragBDSouris=0;
	ClickUpBDSouris=0;
  if (fAutoSouris) fSetShifting(1);
	EvSouris(a,point);
}

void TAffim::EvLButtonDown(UINT a, TPoint& point)
{
	EtatBGSouris=1;
	DragBGSouris=0;
	ClickUpBGSouris=0;
  if (fAutoSouris) fSetTracking(1);
	EvSouris(a,point);
}

void fSetTracking(int f)
  {
  fShift=fTrack=fFirstShift=0;
  fFirstTrack=f;
  }

void fSetShifting(int f)
  {
  fShift=fTrack=fFirstTrack=0;
  fFirstShift=f;
  }

void TAffim::EvSouris(UINT, TPoint& point)
{
char buf[20];
int x,y;
int etatsouris;

	wsprintf(buf, "X=%d   Y=%d", point.x, point.y);  // affichage
	pZ1->SetText(buf);

	if(fShift || fTrack || fFirstShift || fFirstTrack ) // pour la surcharge manuelle.
	{
	posx=point.x;                                    // mise  jour pos.
	posy=point.y;

	if(modefig&&Type==0)                            // figure  dessiner
	{
	  if(indic_first)
	  {
	  Affiche();
	  Traitfig(SAUVE,modefig,buffen,xfen0,yfen0,xfen1,yfen1);
	  indic_first=0;
	  }
	  Traitfig(RESTI,modefig,buffen,xfen0,yfen0,xfen1,yfen1);

// Ce ne sont plus les tats supposs de la souris qui grent la surcharge.
// Ce sont des signaux Shift, Track, FirstShift et FirstTrack qui sont grs
// conjointement par les clicks et move de souris et par le signal Surcharge rgl sur "Auto" ou "Manuel".
/*
  Par dfaut, Surcharge=Auto.
	 Clic souris gauche=> First Track
	 Clic souris droit=>  First Shift
	 move et gauche enfonc => Track
	 move et droit enfonc => Shift
  Passage Surcharge=Manuel.
	 Les clics de souris sont sans effet sur la surchage:
		-ils sont tout de mme signals  la fonction empile)
		-les signaux Shift, Track, FirstShift et FirstTrack ne sont pas mofifis
	 2 fonctions publiques de TAffim permettent de grer les signaux Shift, Track, FirstShift et FirstTrack
		- SetTracking(int fState)
		  fSate est TRUE => met FirstTrack  1 et les autres  0; EvSouris mettra FirstTrack  0 et Track  1
		  fSate est FALSE => met tous  0.
		- SetShifting(int fState)
		  fSate est TRUE => met FirstShift  1 et les autres  0; EvSouris mettra FirstShift  0 et Shift  1
		  fSate est FALSE => met tous  0.
*/
		if(fTrack)
		{
			taillex=(posx-xfen1);
			tailley=(posy-yfen1);
			xfen0=xfen1+taillex;
			yfen0=yfen1+tailley;
		}

		if(fFirstTrack) // If ()        // position (clic)
		{
		 // FirstTrack est activ par ActiveTracking et dsactiv ici mme
		fFirstTrack=0; fFirstShift=0;
		fTrack=1;  fShift=0;
			xfen1=posx;
			yfen1=posy;
			taillex=0;
			tailley=0;
			xfen0=xfen1+taillex;
			yfen0=yfen1+tailley;
		}

		if(fFirstShift)          // mmorisation pos.
	  // FirstShift est activ par ActiveShifting et dsactiv ici mme
		{
		fFirstTrack=0; fFirstShift=0;
		fShift=1; fTrack=0;
		xbd=posx;
		ybd=posy;
		xmem1=xfen1;
		ymem1=yfen1;
		}

		 if (fShift)
		{
		 x=xmem1+posx-xbd;
		 if(x>=0&&x<256&&x+taillex>=0&&x+taillex<256)
		 {xfen1=x;xfen0=xfen1+taillex;} else {xbd=posx;xmem1=xfen1;}
		 y=ymem1+posy-ybd;
		 if(y>=0&&y<256&&y+tailley>=0&&y+tailley<256)
		 {yfen1=y;yfen0=yfen1+tailley;} else {ybd=posy;ymem1=yfen1;}
		}

		rFig.left=xfen0;
		rFig.top=yfen0;
		rFig.right=xfen1;
		rFig.bottom=yfen1;
		rFig=rFig.Normalize();

		Traitfig(SAUVE,modefig,buffen,xfen0,yfen0,xfen1,yfen1);
		Traitfig(ECRI,modefig,buffen,xfen0,yfen0,xfen1,yfen1);
	}//if
	}//if

	if(Type==0)
	{
	etatsouris=EtatBDSouris+(EtatBGSouris<<1)+
				  (DragBDSouris<<2)+(DragBGSouris<<3)+
				  (ClickUpBDSouris<<4)+(ClickUpBGSouris<<5) ;

	// if(EtatBGSouris||EtatBDSouris || ClickUpBDSouris || ClickUpBGSouris )
		{if(fAffPtr) fAffPtr(point,etatsouris);
		ClickUpBDSouris=ClickUpBGSouris=0;}
	}
}

void TAffim::Ecp(int x,int y,TColor color,TClientDC* pdc)
{
	pdc->SetPixel(x,y,color);
}

TColor TAffim::Lecp(int x,int y,TClientDC* pdc)
{
TColor color=pdc->GetPixel(x,y);
	return(color);
}

void TAffim::Traitfig(int modetrait,int modefig,TColor buffen[1024],int x0,int y0,
							int x1,int y1)
{
int x,y,tabx[9],taby[9],i;
TColor color;
int xdeb,xfin,ydeb,yfin,sx,sy,dx,dy,e;
TClientDC* pdc;

	pdc=new TClientDC(*this);

	switch(modefig) // type de figure
	{
	case GEO_FENETRE:
	if(x1>=x0){xdeb=x0;xfin=x1;}
	else		{xdeb=x1;xfin=x0;}
	if(y1>=y0){ydeb=y0;yfin=y1;}
	else		{ydeb=y1;yfin=y0;}

	for(i=0,x=xdeb;x<=xfin;x++)               	// horizontales
	{
		switch(modetrait)  // type de traitement
		{
		case ECRI:
		color=Cal_Color(buffen[i++]);
		Ecp(x,ydeb,color,pdc);
		color=Cal_Color(buffen[i++]);
		Ecp(x,yfin,color,pdc);
		break;
		case SAUVE:
		buffen[i++]=Lecp(x,ydeb,pdc);
		buffen[i++]=Lecp(x,yfin,pdc);
		break;
		case RESTI:
		Ecp(x,ydeb,buffen[i++],pdc);
		Ecp(x,yfin,buffen[i++],pdc);
		break;
		}//switch
	}//for

	for(y=ydeb+1;y<=yfin-1;y++)           		// verticales
	{
		switch(modetrait)
		{
		case ECRI:
		color=Cal_Color(buffen[i++]);
		Ecp(xdeb,y,color,pdc);
		color=Cal_Color(buffen[i++]);
		Ecp(xfin,y,color,pdc);
		break;
		case SAUVE:
		buffen[i++]=Lecp(xdeb,y,pdc);
		buffen[i++]=Lecp(xfin,y,pdc);
		break;
		case RESTI:
		Ecp(xdeb,y,buffen[i++],pdc);
		Ecp(xfin,y,buffen[i++],pdc);
		break;
		}//switch
	}//for
	break;

		case GEO_LIGNE:
		for(i=0;i<256;i++)
		{
		switch(modetrait)
		{
		case ECRI:
		color=Cal_Color(buffen[i]);
		Ecp(i,y0,color,pdc);
		break;
		case SAUVE:
		for(i=0;i<256;i++) buffen[i]=Lecp(i,y0,pdc);
		break;
		case RESTI:
		for(i=0;i<256;i++) Ecp(i,y0,buffen[i],pdc);
		break;
		}//switch
		}//for
		break;

		case GEO_COLONNE:
		for(i=0;i<256;i++)
		{
		switch(modetrait)
		{
		case ECRI:
		color=Cal_Color(buffen[i]);
		Ecp(x0,i,color,pdc);
		break;
		case SAUVE:
		for(i=0;i<256;i++) buffen[i]=Lecp(x0,i,pdc);
		break;
		case RESTI:
		for(i=0;i<256;i++) Ecp(x0,i,buffen[i],pdc);
		break;
		}//switch
		}//for
		break;

	case GEO_RETICULE:
	Initabret(tabx,taby);
	x=x0;y=y0;
	for(i=0;i<9;i++)
	{
	x+=tabx[i];
	y+=taby[i];
	switch(modetrait)
	{
	case ECRI:
	color=Cal_Color(buffen[i]);
	Ecp(x,y,color,pdc);
	break;
	case SAUVE:
	buffen[i]=Lecp(x,y,pdc);
	break;
	case RESTI:
	Ecp(x,y,buffen[i],pdc);
	break;
	}//switch
	}//for
	break;

	case GEO_DROITE :

	if(x1-x0>=0) dx=x1-x0;else dx=x0-x1;
	if(y1-y0>=0) dy=y1-y0;else dy=y0-y1;
	if(dx>=dy)		/* selon x */
	{
	if(x1>=x0){xdeb=x0;xfin=x1;ydeb=y0;yfin=y1;}
	else		{xdeb=x1;xfin=x0;ydeb=y1;yfin=y0;}
	if(yfin>=ydeb) sy=1;else sy=-1;
	for(i=0,x=xdeb,y=ydeb,e=0;x!=xfin+1;x++,e+=dy,i++)
		{
		if((e<<1)-dx>=0){y+=sy;e-=dx;}
		switch(modetrait)
		{
		case ECRI:
		color=Cal_Color(buffen[i]);
		Ecp(x,y,color,pdc);
		break;
		case SAUVE:
		buffen[i]=Lecp(x,y,pdc);
		break;
		case RESTI:
		Ecp(x,y,buffen[i],pdc);
		break;
		}//switch
		}//for
	}//if
	else                    /* selon y */
	{
	if(y1>=y0){ydeb=y0;yfin=y1;xdeb=x0;xfin=x1;}
	else		{ydeb=y1;yfin=y0;xdeb=x1;xfin=x0;}
	if(xfin>=xdeb) sx=1;else sx=-1;

	for(i=0,x=xdeb,y=ydeb,e=0;y!=yfin+1;y++,e+=dx,i++)
		{
		if((e<<1)-dy>=0){x+=sx;e-=dy;}
		switch(modetrait)
		{
		case ECRI:
		color=Cal_Color(buffen[i]);
		Ecp(x,y,color,pdc);
		break;
		case SAUVE:
		buffen[i]=Lecp(x,y,pdc);
		break;
		case RESTI:
		Ecp(x,y,buffen[i],pdc);
		break;
		}//switch
		}//for
	}//else
	break;
	}//switch

	delete pdc;
}

TColor TAffim::Cal_Color(TColor color)
{
long z,r,g,b;               //49152 =128*128*3

	r=(long) color.Red();
	g=(long) color.Green();
	b=(long) color.Blue();

	z=r*r+g*g+b*b;
	if(z>=49152L) return(TColor(0,0,0));else return(TColor(255,255,255));
}

TAffim::~TAffim()
{
  TAffimPtr[Type] = 0;
}

//----------------------------------------------------------------------------

