/**********************************************************************/
/*                       W T P I M A G   . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         :  MC			                  			      	 */
/*    Dvelopp le   :  28/03/96                                      */
/*    Dernire modif.:  20/12/97                                      */
/**********************************************************************/

#include "wgttsi.h"                    // Librairies Image

#include "wmain.h"
#include "wappbase.h"
#include "wconv.h"
#include "wcomconv.h"
#include "wappconv.h"
#include "wtpimag.rc"
#include "wtpimag.h"
#include "wtpihelp.h"

TFenPerso *FenetrePerso;
TAppPerso *ApplicationPerso;
TCadPerso *CadrePerso;

//----------------------------------------------------------------------------
//						Programme principal : conversationnel TFenPerso
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TFenPerso, TFen)

	EV_COMMAND(CM_HOUGH, CmHough),
	EV_COMMAND(CM_COMP, CmComp),
	EV_COMMAND(CM_COLOR, CmColor),
	EV_COMMAND(CM_SEGCOUL, CmSegcoul),
	EV_COMMAND(CM_SEGREDUI, CmSegredui),

END_RESPONSE_TABLE;

TFenPerso::TFenPerso(TWindow *Parent):TFen(Parent)
{
  FenetrePerso=this;
  pmnuApplications=new TMenu((HINSTANCE)(*((TApplication*)ApplicationPerso)),
  "TheApplication");
}

void TFenPerso::SetupWindow()
{
  TFen::SetupWindow();
  pmnuPrincipal->InsertMenu(NumeroApplication, MF_POPUP | MF_BYPOSITION,
	*(FenetrePerso->pmnuApplications),"&Applications");
}

void TFenPerso::CmHough()
{
	if(FenetrePerso->CmHelp(Hough)) return;
	if(!TConvhoughPtr)
	{
	(TConvhoughPtr= new TConvhough(this))->Create();
	}
	else
	{
	TConvhoughPtr->SetFocus();
	TConvhoughPtr->SetActiveWindow();
	}
}

void TFenPerso::CmComp()
{
	if(FenetrePerso->CmHelp(Compression)) return;
	if(!TChoixcompPtr)
	{
	(TChoixcompPtr= new TChoixcomp(this))->Create();
	}
	else
	{
	TChoixcompPtr->SetFocus();
	TChoixcompPtr->SetActiveWindow();
	}
}

void TFenPerso::CmColor()
{
	if(FenetrePerso->CmHelp(Couleur)) return;
  if(modcoul)
  {
	if(!TConvcolorPtr)
	{
	(TConvcolorPtr= new TConvcolor(this))->Create();
	}
	else
	{
	TConvcolorPtr->SetFocus();
	TConvcolorPtr->SetActiveWindow();
	}
  }
}

void TFenPerso::CmSegcoul()
{
	if(FenetrePerso->CmHelp(Couleur)) return;
 if(modcoul)
  {
	if(!TConvsegPtr)
	{
	(TConvsegPtr= new TConvseg(this))->Create();
	}
	else
	{
	TConvsegPtr->SetFocus();
	TConvsegPtr->SetActiveWindow();
	}
  }
}

void TFenPerso::CmSegredui()
{
	if(FenetrePerso->CmHelp(Couleur)) return;
 if(modcoul)
  {
	if(!TConvsegreduiPtr)
	{
	(TConvsegreduiPtr= new TConvsegredui(this))->Create();
	}
	else
	{
	TConvsegreduiPtr->SetFocus();
	TConvsegreduiPtr->SetActiveWindow();
	}
  }
}

//----------------------------------------------------------------------------

TAppPerso::TAppPerso() : TApp()
{
  ApplicationPerso=this;
}

void TAppPerso::InitMainWindow()
{
  new TCadPerso(NULL,TitreApplication,new TFenPerso,TRUE);
  TApp::InitMainWindow();
}

//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TCadPerso, TCad)

	EV_WM_INITMENUPOPUP,

END_RESPONSE_TABLE;

TCadPerso::TCadPerso(TWindow *Parent, char far *Title, TWindow *Client,
							BOOL trackMenuSelection)
						  : TCad (Parent, Title, Client, trackMenuSelection)
{
  CadrePerso=this;
}

void TCadPerso::EvInitMenuPopup(HMENU hPopupMenu, UINT index,BOOL sysMenu)
{
	TCad::EvInitMenuPopup(hPopupMenu,index,sysMenu);
	 if(modcoul)
		 {
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_COLOR,MF_ENABLED);
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_SEGCOUL,MF_ENABLED);
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_SEGREDUI,MF_ENABLED);
		 }
	 else
		 {
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_COLOR,MF_GRAYED);
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_SEGCOUL,MF_GRAYED);
			FenetrePerso->pmnuApplications->EnableMenuItem(CM_SEGREDUI,MF_GRAYED);
		 }
}

//----------------------------------------------------------------------------
//						Programme OwlMain
//----------------------------------------------------------------------------

int OwlMain(int argc, char* argv[])
{
  if(DemarrageCarte())               	// Initialisations
  {											  // Titre, version, auteur
  strcpy(TitreApplication,"Logiciel de traitement d'images");
  strcpy(TexteAbout,
"Version : 2.4\n\nAuteur : MICHEL CATTOEN\n\nCopyright (c) GTTSI-ENSEEIHT 1996-97");
  strcpy(FichierAide,"WTPIMAG.HLP");

  argc_=argc;
  argv_=argv;

  return TAppPerso().Run();           // Lancement du programme
  }
  else
  {
  MessageBox(0,"","ERREUR D'INITIALISATION",MB_OK | MB_ICONEXCLAMATION);
  return 0;                      	// Erreur
  }
}

//----------------------------------------------------------------------------

