/*******************|*******************************************/
/*                  L T A T O U     . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions de travail de Tatou.C.        */
/*                                                             */
/*                                                             */
/* Fichier prototype LTATOU  .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1994/1995                        */
/***************************************************************/
#ifndef ANLFREQ_H
#define ANLFREQ_H

#include "wgeometr.h"
/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define HAUT 1
#define BAS  0
#define PARTITION 8
#define QUAD_APPLICATION   0
#define QUAD_INSPECTION 1
#define ANLFREQ_FrequenceImpaire  0
#define ANLFREQ_ToutesFrequences  1
#define ANLFREQ_UneTranche        2
#define ANLFREQ_LocaliseTranche   3
/* 0x01  0x04: 2 bits poids faible codent la position de l'origine,
   0x01  0x02 pour une ligne.
*/
#define SMB_PROP_OriginA     0x00
#define SMB_PROP_OriginB     0x01
#define SMB_PROP_OriginC     0x03
#define SMB_PROP_OriginD     0x04

#define SMB_PROP_Id2OriginA_D(c) (SMB_PROP_OriginA+(c)-'A')
#define SMB_PROP_OriginA_D2Id(w) ((w) - SMB_PROP_OriginA + 'A')

#define SMB_PROP_OriginA_D   0x07
#define SMB_PROP_Origin      0x08 // bit 3 est vrai si la position de l'origine est connue
#define SMB_PROP_AppPositive 0x10 // bit 4: code positif (noir sur blanc) ou ngatif
#define SMB_PROP_Appearance  0x20 // bit 5: est vrai si 0x10 est renseign
#define SMB_PROP_ClockWise   0x40 // bit 6: sens de parcours anti-trigo ou pas du quadrilatre
#define SMB_PROP_Clock       0x80 // bit 7: est vrai si 0x40 est renseign
#define SMB_PROP_Parity    0x0100 // bit 8: Pair. Est valable si 0x0200 est renseign
#define SMB_PROP_Even      0x0200 // bit 9: frequ paire ou impaire

#define ANLFREQ_MSG_NonCompatible                                 0x01
#define ANLFREQ_MSG_RaccAveugle   (0x01 << 1)

/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
void ReOrgQuadMaxMax(TQuadrilatere *pABCD, unsigned int *pwSymbolReadingProperties);
BOOL AnalBiFreqQuadGeneriquePM (TQuadrilatere ABCD
                            , unsigned int *pwFreq,
                            unsigned char *puSource
                            ,unsigned int wSymbolReadingProperties
                            , unsigned char uMode
                            ,unsigned char *puTabFreqSvg,
                            unsigned char *puTabCritSvg,
                            unsigned int *pwNbCoupes,
                            float *axCellTable_AB,
                            float *axCellTable_BC,
                            TBipoint *pbipCellBearerAB,
                            TBipoint *pbipCellBearerBC);
BOOL AnalFreqQuadGenerique (TQuadrilatere ABCD,
                            unsigned int *freq,
                            unsigned char *puSource,
                            unsigned int wSymbolReadingProperties,
                            unsigned char uMode=QUAD_APPLICATION,
                            unsigned char *puTabFreqSvg=NULL,
                            unsigned char *puTabCritSvg=NULL,
                            unsigned int *pwNbCoupes=NULL,
                            float *axCellTable=NULL,
                            TBipoint *pbipCellBearerAB=NULL);
BOOL AnalyseFrequenceLigne(unsigned char *auLigne,
      unsigned int  wLongueurLigne,
      float xValeurSeuil, int *piFrequence,
      float *pxPeriode, float *pxEcartTypePeriode,
      unsigned int  *pwPeriodeMin,
      unsigned int  *pwPeriodeMax,
      BOOL *pfCompatibilite,
      BOOL *pRacourcissementD,
      BOOL *pRacourcissementF,
      float *pxSeuilRaccourcissement,
      unsigned int wProperties,
      float *axCellTable=NULL);
BOOL CritereValiditeFrequenceDUneLigne(int iFrequence, float xPeriode,
       float xEcartTypePeriode, unsigned char uPeriodeMin,
       unsigned char uPeriodeMax, float *pxCritere);
void DecCirc ( TQuadrilatere *pABCD
    , unsigned int *pwSymbolReadingProperties );
#endif // WANLFREQ_H
