//#include "myowlall.h"
//#include "baptiall.h"

#pragma hdrstop

#define MODULE_NAME "CONTOUR"
 /*******************|******************************************
                      W C O N T O U R . C P P
    -------------------------------------------------------------
        Fonction       : Fonction de traitement d'image pour
                         Anagnostes, calcul de contours

     Fichier source WLCONTOU.CPP.
     (contient les objets internes
      et les corps des objets  exporter)
    -------------------------------------------------------------
        Auteur         : Baptise MARCEL
        Dvelopp le   : hivers 1995/1996
    *************************************************************/

    // Inclusions bibliothques standards
    #include <math.h>
    #include <values.h>

    // Inclusions bibliothques Object Windows
    #include <owl\point.h>

    // Inclusions bibliothques DOS
    #include <stdlib.h>


// Inclusion bibliothques Image
#include "wgttsi.h"
#include "wlcarpro.h"
#include "wlfilt.h"

//  Inclusions bibliothques Iris
#include "base.h"
#include "contour.h"
#include "sysctr.h"
#include "scaltool.h"
#include "wgeometr.h"

#define TryPassBugMmgr 1

#include "wlstutil.h"

/*-------------------------------------------------------------
   		       constantes locales
   -------------------------------------------------------------*/
#define DIRECT VRAI
#define RETROGRADE FAUX
//#define SEUIL_TAILLE_MINIMALE_SYMBOLE 10
//#define SEUIL_RAPPORT_LONGUEUR_COTE_MIN 0.6
//#define SEUIL_RAPPORT_LONGUEUR_COTE_MAX 1/SEUIL_RAPPORT_LONGUEUR_COTE_MIN
#define SEUIL_DISTANCE_VECTORISATEUR 1
#define CTR_Exploration 0x01
#define CTR_SuccessorExist 0x08
#define CTR_SuccessorDir 0x07
#define CTR_AnySuccessor (CTR_SuccessorExist | CTR_SuccessorDir)
#define CTR_PredecessorExist 0x80
#define CTR_PredecessorDir 0x70
#define CTR_AnyPredecessor (CTR_PredecessorExist | CTR_PredecessorDir)
 /*-------------------------------------------------------------
    	                   variables  exporter
    -------------------------------------------------------------*/

unsigned int      wNbl = 0 ;
unsigned int      NLA ;                                         /* Nombre de lignes autorises. */
unsigned int      wLongueurMaximaleChaine = 2047, wLongueurMinimaleChaine = 4 ;
ligne_AB          far *algnTableLignes = NULL ;
//#if TryPassBugMmgr
TListImp<TPoint>  *plptForbidenLink = NULL ;
//#endif
/*-------------------------------------------------------------
   		      nouveaux types locaux
   -------------------------------------------------------------
   -------------------------------------------------------------
   		       variables locales
   -------------------------------------------------------------*/
unsigned char     *amplitude, *direction, *chainage, *exploration, *image ;
ligne_AB          sLigne_00 = { 0, { 0, 0 }, { 0, 0 }};
int               partition ;
unsigned char     base_partition ;                              // Nombre de classes / 8
float             table_tangentes [32];
unsigned char     uSeuilRaccordement = SEUIL_RACCORDEMENT_DEFAUT;
/*
,
                  uSeuilRaccordementCarre = SEUIL_RACCORDEMENT_DEFAUT*SEUIL_RACCORDEMENT_DEFAUT ;
*/
float             xSeuil_tanEcartAngulaireRaccordement0 = tan(5.0 / 180.0 * M_PI);
float             xSeuil_tanEcartAngulaireRaccordement90 = tan(85.0 / 180.0 * M_PI);
float             xSeuil_tanEcartangulaireUnification
  = xSeuil_tanEcartAngulaireRaccordement0 ;
float             xSeuilAngulaireReconnaissanceSymbole = 65.0 ; // degrs.
float             xSeuil_cosEcartAngulaireSymbole
  = cos(xSeuilAngulaireReconnaissanceSymbole / 180 * M_PI);
BOOL              ObsProc = FAUX ;

unsigned int      wSeuil_TailleMinimaleSymbole=10;
float             xSeuilRapportDeLongueursMaxSymbole=5.0/3.0;

/*-------------------------------------------------------------
                 prototypes des fonctions locales
   -------------------------------------------------------------*/
int               InterpretationObjetsContoursGTTSI (int iLongChaine) ;
char              ConvolutionFlottante (unsigned char *puSource
  , unsigned char *puCible, float A0, float A1, float A2, float A3
  , float A4, float A5, float A6, float A7, float A8) ;
int               ConvolutionLocale (unsigned char *puSource, TPoint pt
  , int i0, int i1, int i2, int i3, int i4, int i5, int i6, int i7, int i8) ;
char              ConvolutionFlottante4x4 (unsigned char *puSource
  , unsigned char *puCible, float A1, float A2, float A3, float A4
  , float B1, float B2, float B3, float B4, float C1, float C2, float C3
  , float C4, float D1, float D2, float D3, float D4) ;
BOOL              RemplaceNBord (unsigned char *puImage
  , unsigned char uLB /* uLargeurBord */ ) ;
BOOL              ChercheChainage (TCoordonnee p, unsigned char sens_direct) ;
BOOL              SuitChainageSansContrainte (TCoordonnee p, unsigned char uSensDirect) ;
BOOL              SuitChainageSansContrainte_Iterative (TCoordonnee p
  , unsigned char uSensDirect) ;
BOOL              SuitChainageDirectionnel_Iterative (TCoordonnee p
  , unsigned char uSensDirect) ;
char              triplet_ordonne_designe (int i, int j
  , unsigned char direction_courante, TCoordonnee *vA, unsigned char *dA
  , TCoordonnee *vB, unsigned char *dB, TCoordonnee *vC, unsigned char *dC) ;
int               CompatibiliteChainageDirectionnel (TCoordonnee p
  , TCoordonnee v, unsigned char uSensDirect) ;

inline int CompatibiliteChainageLibre ( TPoint v )
{
#if IMG256
unsigned int  nv = (v.y << 8) + v.x ;
#else 
unsigned int  nv = v.y * SIZE_OF_PICTURES + v.x ;
#endif
return rImageBorder.Contains(v)
        && !(exploration [nv] & CTR_Exploration)
        && amplitude [nv];
}

BOOL          Directions_vectorielles (unsigned char uNoDeDirection
  , char *di, char *dj) ; // TPoint == (j,i)
BOOL          Directions_vectorielles (unsigned char uNoDeDirection
  , TSize *ps_didj) ;
char          Enchaine_iter (TCoordonnee p0, TCoordonnee p1, unsigned char d) ;
int           FindNextNeigbor (TPoint pt, TPoint *pptVoisin
  , unsigned char *puDirection, unsigned int wModeChainage
  , unsigned char uDirectionContourCourante = 0
  , unsigned char uSensDirect = 0) ;                          // TPoint (j,i)
char          ConstructionObjetsContoursGTTSI (TPoint depart, int *Nb) ;
BOOL          VectorisateurGTTSI (TPoint depart) ;            // TPoint (j,i)
int           fcmp_DifferenceDeLongueur (const void *L1, const void *L2) ;
BOOL          RemplissageTableTangentes (unsigned char base_partition_user) ;
BOOL          CoincidePointLigne (TCoordonnee M, ligne_AB *sAB, BOOL *pfErreur) ;
BOOL          RestaurationUnificatriceLignesGTTSI (unsigned int &wNbElim) ;
BOOL          RetablissementLongueursLignesGTTSI () ;
BOOL          AnalyseSupportSymbole (unsigned int wi, unsigned int &wj) ;
//BOOL InitialiseObjetsContours(unsigned int partition_user);
unsigned char NSPH (int u, int v) ;
BOOL          RemplaceBord (unsigned char *puImage, unsigned char uValeurBord) ;
/*BIT RecaleSpecifiqueSurCoins(TQuadrilatere *pABCD, int iSeuilSaturation,
   unsigned char uTailleNoyau, unsigned char *puImage); */
BOOL          RecaleSpecifiqueDernierCoin (TQuadrilatere *pqABCD
  , unsigned char uTailleNoyau, unsigned char *puImage
  , int iSeuilSaturation, unsigned char uDroit) ;
BOOL          RecaleSpecifiqueHeliophobeUnCoin (TVecteur xyCentre
  , TCoordonnee *pptM, unsigned char uTailleNoyau, unsigned char *puImage
  , int iSeuilSaturation, unsigned char uDroit) ;
void          CalculeContoursDImageBinaire (unsigned char *puSource_user
  , unsigned char *puAmplitude_user, unsigned char *puDiffBuffer) ;

/*-------------------------------------------------------------
   	              fonctions  exporter                     
   -------------------------------------------------------------*/
int AlloueTableDeLignes ( unsigned int w )
{
if ( !w ) 
  {
  free(algnTableLignes);
  //#if TryPassBugMmgr
  plptForbidenLink -> Flush();
  delete plptForbidenLink ;
  plptForbidenLink =  NULL ;
  //#endif
  algnTableLignes  =  NULL ;
  return 0 ;
  }
else 
  {
  if ( algnTableLignes ) 
    return MErreur("Tableau non vide.", 551);
  else 
    {
    NLA              =  1500 ;
    algnTableLignes  =  (ligne_AB *)malloc(NLA * sizeof(ligne_AB));
    //#if TryPassBugMmgr
    plptForbidenLink =  new TListImp<TPoint> ;
    //#endif
    return NLA ;
    }
  }
}

ligne_AB *TableDeLignes ()
{
return algnTableLignes ;
}

/*
   void ChargeTableLignes(unsigned char *pu) //,algnTableLignes);
     {
     ChargeTableLignes(pu,algnTableLignes);
     }
   
    CalculeGradPolaire_2comp (Calcule gradient polaire  2 composantes)
     Calcule le vecteur gradient et le renvoit dans deux images: une image du
   module et une image des direction. L'unit de direction est celle qui code
   360 en 256 niveaux, avec 0 pour 0.
     Le terme "2 composante" signifie que le gradient est calcul en calculant
   uniquement la composante verticale et la composante horizontale.
   */
BOOL CalculeGradPolaire_2comp ( unsigned char *puSource_user
    , unsigned char *puModule_user, unsigned char *puDirection_user
    , int iPartitionUser ) // Nombre de partitions exiges par la procdure appelante
{
long          N = SIZE_OF_PICTURES ;
int           Gx, Gy, i, j ;
double        G ;
int           iRapportPart = 256 / iPartitionUser ; // Puissance de 2.
unsigned char uPuissRapportPart
  = i2uc(NFarRoundR(log(iRapportPart) / M_LN2));

if ( puSource_user == NULL
      || puModule_user == NULL
      || puDirection_user == NULL ) 
  return (MErreur("Images non alloues.", 35));

unsigned char (*ClasseArctan)(int u, int v) ; // Objet de type fonction

if ( iPartitionUser == 8 ) 
  ClasseArctan =  Fast8ClasseArctan ;
else 
  {
  ClasseArctan =  FastClasseArctan ;
  if ( !InitialiseObjetsContours(iPartitionUser) ) 
    return MErreur("Initialisation des donnes de contour impossible.", 90);
  }
for ( i = 0 ; i < N ; i++ ) 
  for ( j = 0 ; j < N ; j++ ) 
    {
    
    /* Plusieurs cas particuliers, effets de bord. Dans ces cas, on considre
       que la composante associe est nulle. */
    if ( i == 0 && j == N - 1 ) 
      {
      Gx =  0 ;
      Gy =  0 ;
      }
    else if ( i == 0 ) 
      {
      Gx =  puSource_user [(unsigned int)(i * N + j + 1)]
        - puSource_user [(unsigned int)(i * N + j)];
      Gy =  0 ;
      }
    else if ( j == N - 1 ) 
      {
      Gx =  0 ;
      Gy =  puSource_user [(unsigned int)((i - 1) * N + j)]
        - puSource_user [(unsigned int)(i * N + j)];
      }
    else 
      {
      Gx =  puSource_user [(unsigned int)(i * N + j + 1)]
        - puSource_user [(unsigned int)(i * N + j)];
      Gy =  puSource_user [(unsigned int)((i - 1) * N + j)]
        - puSource_user [(unsigned int)(i * N + j)];
      }
    
    /* puModule_user cartsien. */
    G                                            =  sqrt(
      (long)Gx * Gx + (long)Gy * Gy);
    puModule_user [(unsigned int)(i * N + j)]    
      =  NFarRoundR(RReduceR(G, 0.0, 255.0));
    puDirection_user [(unsigned int)(i * N + j)] 
      =  ClasseArctan(Gx, Gy) << uPuissRapportPart ; //      AvanceRuban((unsigned char)((i*N+j)*100/N/N));
    }

/*  if (!FermeRuban())
   return Erreur_gt("Anomalie ruban.",131); */
return SUCCES ;
}

BOOL CalculeGrad_xy ( unsigned char *source_user
    , unsigned char *puComposante_x, unsigned char *puComposante_y )
{
unsigned char *puSource = source, *puDestin = destin ;

source =  source_user ;
destin =  puComposante_x ;
Compass('0');
destin =  puComposante_y ;
Compass('2');
source =  puSource ;
destin =  puDestin ;
return SUCCES ;
}

/* CalculeDirectionGrad_2comp (Calcule direction gradient  2 composantes)
     Calcule le vecteur gradient et renvoit sa direction dans un plan. L'unit
   de direction est celle qui code 360 en 256 niveaux, avec 0 pour 0.
     Le terme "2 composante" signifie que le gradient est calcul en calculant
   uniquement la composante verticale et la composante horizontale.
   */
BOOL CalculeDirectionGrad_2comp ( unsigned char *puSource_user
    , unsigned char *puDirection_user, int iPartitionUser )
{
int           i, j ;
int           iRapportPart = 256 / iPartitionUser ; // Puissance de 2.
unsigned char uPuissRapportPart
  = i2uc(NFarRoundR(log(iRapportPart) / M_LN2));

if ( puSource_user == NULL || puDirection_user == NULL ) 
  return (MErreur("Images non alloues.", 35));
if ( !InitialiseObjetsContours(iPartitionUser) ) 
  return MErreur("Initialisation des donnes de contour impossible.", 90);
if ( !ActiveRuban("Direction Gradient") ) 
  return MErreur("AnomalieRuban", 161);

/* Plusieurs cas particuliers, effets de bord. Dans ces cas, on considre
   que la composante associe est nulle. */
puDirection_user [SIZE_OF_PICTURES - 2] =  0 ;
for ( j = 0 ; j < SIZE_OF_PICTURES - 1 ; j++ ) 
  
  // side effect
  puDirection_user [j]
    =  FastClasseArctan(puSource_user [j + 1] - puSource_user [j], 0)
      << uPuissRapportPart ;
for ( i = 1 ; i < SIZE_OF_PICTURES ; i++ ) 
  
  // side effect
  puDirection_user [i * SIZE_OF_PICTURES + SIZE_OF_PICTURES - 1]
    =  FastClasseArctan(0
        , puSource_user [i * SIZE_OF_PICTURES - 1]
          - puSource_user [i * SIZE_OF_PICTURES + SIZE_OF_PICTURES - 1])
      << uPuissRapportPart ;

unsigned int  n = 0 ;

for ( i = 1 ; i < SIZE_OF_PICTURES ; i++ ) 
  {
  if ( fRuban ) 
    AvanceRuban(i * 100 / SIZE_OF_PICTURES);
  for ( j = 0 ; j < SIZE_OF_PICTURES - 1 ; j++ ) 
    {
    puDirection_user [n]
      =  FastClasseArctan(puSource_user [n + 1] - puSource_user [n]
          , puSource_user [n - 1 * SIZE_OF_PICTURES] - puSource_user [n])
        << uPuissRapportPart ;
    n++ ;
    }
  }
if ( !FermeRuban() ) 
  return MErreur("AnomalieRuban", 190);
return SUCCES ;
}

/* CalculeDirectionGrad_2comp (Calcule direction gradient  2 composantes)
     Calcule le vecteur gradient et renvoit sa direction dans un plan. L'unit
   de direction est celle qui code 360 en 256 niveaux, avec 0 pour 0.
     Le terme "2 composante" signifie que le gradient est calcul en calculant
   uniquement la composante verticale et la composante horizontale.
   */
BOOL OldCalculeDirectionGrad_2comp ( unsigned char *puSource_user
    , unsigned char *puDirection_user, int iPartitionUser )
{
long          N = SIZE_OF_PICTURES ;
int           Gx, Gy, i, j ;
int           iRapportPart = 256 / iPartitionUser ; // Puissance de 2.
unsigned char uPuissRapportPart
  = i2uc(NFarRoundR(log(iRapportPart) / M_LN2));

if ( puSource_user == NULL || puDirection_user == NULL ) 
  return (MErreur("Images non alloues.", 35));
if ( !InitialiseObjetsContours(iPartitionUser) ) 
  return MErreur("Initialisation des donnes de contour impossible.", 90);
if ( !ActiveRuban("Direction Gradient") ) 
  return MErreur("AnomalieRuban", 161);
for ( i = 0 ; i < N ; i++ ) 
  for ( j = 0 ; j < N ; j++ ) 
    {
    
    /* Plusieurs cas particuliers, effets de bord. Dans ces cas, on considre
       que la composante associe est nulle. */
    if ( i == 0 && j == N - 1 ) 
      {
      Gx =  0 ;
      Gy =  0 ;
      }
    else if ( i == 0 ) 
      {
      Gx =  puSource_user [(unsigned int)(i * N + j + 1)]
        - puSource_user [(unsigned int)(i * N + j)];
      Gy =  0 ;
      }
    else if ( j == N - 1 ) 
      {
      Gx =  0 ;
      Gy =  puSource_user [(unsigned int)((i - 1) * N + j)]
        - puSource_user [(unsigned int)(i * N + j)];
      }
    else 
      {
      Gx =  puSource_user [(unsigned int)(i * N + j + 1)]
        - puSource_user [(unsigned int)(i * N + j)];
      Gy =  puSource_user [(unsigned int)((i - 1) * N + j)]
        - puSource_user [(unsigned int)(i * N + j)];
      }
    puDirection_user [(unsigned int)(i * N + j)]
      =  FastClasseArctan(Gx, Gy) << uPuissRapportPart ;
    if ( fRuban ) 
      AvanceRuban((unsigned char)(((long)i * N + j) * 100 / N / N));
    }
if ( !FermeRuban() ) 
  return MErreur("AnomalieRuban", 190);
return SUCCES ;
}

/*-------------------------------------------------------------
    CalculeZCLaplacien (Calcule "zero crossing" du laplacien)
     Le paramtre "type" indique si l'on utilise un laplacien  2 composantes
   ou  4 composantes.
   */
inline unsigned char ZCSur2Pixels ( unsigned char uL, unsigned char uLv
    , unsigned char uSeuilZC )
{
unsigned char uL0, uL1, uZC ;

if ( uL < uLv ) 
  {
  uL0 =  uL ;
  uL1 =  uLv ;
  }
else 
  {
  uL0 =  uLv ;
  uL1 =  uL ;
  } // uL0<uL1
if ( uL0 < 128 && uL1 > 128 && (uZC = uL1 - uL0) > uSeuilZC ) 
  return uZC ; // Contour  uZC strict (garanti de minceur).
else if ( uL == 128 && (uZC = uL1 - uL0) > uSeuilZC ) 
  
  /* Contour non strict. Autoris dans un seul sens :
     cellule  128 et cellule voisine > 128 */
  return uZC ; /* Contour si uZC strict. */ 
else 
  return 0 ;
}

BOOL CalculeZCLaplacien ( unsigned char *puSource_user
    , unsigned char *puDestin_user, char cType, unsigned char uSeuilZC )
{
unsigned int  i, j, ndx ;
unsigned char Lc, Ld, Lh, L0, L1, ZC ;

if ( puSource_user == NULL || puDestin_user == NULL ) 
  return (MErreur("Erreur d'allocation.", 92));
if ( !CalculeLaplacien(cType, puSource_user, puDestin_user)
      || !RemplaceBord(puDestin_user) ) 
  return (MErreur("Erreur au calcul du laplacien.", 102));
if ( fHardCopy ) 
  WMN(szHardCopyFile, puDestin_user);
for ( i = SIZE_OF_PICTURES - 1 ; i >= 1 ; i-- ) 
  for ( j = 0 ; j < SIZE_OF_PICTURES - 1 ; j++ ) 
    {
    ndx                 =  i * SIZE_OF_PICTURES + j ;
    Lc                  =  puDestin_user [ndx]; /* Laplacien sur la cellule. */ 
    Ld                  =  puDestin_user [ndx + 1]; /* Laplacien  droite. */ 
    Lh                  =  puDestin_user [ndx - SIZE_OF_PICTURES]; /* Laplacien en haut. */ 
    
    // Analyse horizontale:
    //      puDestin_user[ndx]=ZCSur2Pixels(Lc,Ld);
    puDestin_user [ndx] 
      =  max(ZCSur2Pixels(Lc, Ld, uSeuilZC)
        , ZCSur2Pixels(Lc, Lh, uSeuilZC));
#if 0 // Obsolete: fonction "inline unsigned char ZCSur2Pixels(unsigned char uL,unsigned char uLv, unsigned char uSeuilZC)" en remplacement
    if ( Lc < Ld ) 
      {
      L0 =  Lc ;
      L1 =  Ld ;
      }
    else 
      {
      L0 =  Ld ;
      L1 =  Lc ;
      } // L0<L1
    if ( L0 < 128 && L1 > 128 && (ZC = L1 - L0) > uSeuilZC ) 
      puDestin_user [ndx] =  ZC ; /* Contour  ZC strict (garanti de minceur). */ 
    else if ( Lc == 128 && (ZC = L1 - L0) > uSeuilZC ) 
      
      /* Contour non strict. Autoris dans un seul sens :
         cellule  128 et cellule voisine > 128 */
      puDestin_user [ndx] =  ZC ; /* Contour si ZC strict. */ 
    else 
      puDestin_user [ndx] =  0 ; /* A priori: par de contou. */ 
    
    // Analyse verticale:
    if ( Lc < Lh ) 
      {
      L0 =  Lc ;
      L1 =  Lh ;
      }
    else 
      {
      L0 =  Lh ;
      L1 =  Lc ;
      }
    if ( L0 < 128 && L1 > 128 && (ZC = L1 - L0) > uSeuilZC ) 
      puDestin_user [ndx] =  max(ZC, puDestin_user [ndx]); /* Contour si ZC. */ 
    else if ( Lc == 128 && (ZC = L1 - L0) > uSeuilZC ) 
      puDestin_user [ndx] =  max(ZC, puDestin_user [ndx]); /* Contour si ZC strict. */ 
#endif
    }

// Colonne j=SIZE_OF_PICTURES-1
for ( i = SIZE_OF_PICTURES - 1 ; i >= 1 ; i-- ) 
  {
  ndx =  i * SIZE_OF_PICTURES + SIZE_OF_PICTURES - 1 ;
  Lc  =  puDestin_user [ndx]; /* Laplacien sur la cellule. */ 
  Lh  =  puDestin_user [ndx - SIZE_OF_PICTURES]; /* Laplacien en haut. */ 
  if ( Lc < Lh ) 
    {
    L0 =  Lc ;
    L1 =  Lh ;
    }
  else 
    {
    L0 =  Lh ;
    L1 =  Lc ;
    }
  if ( L0 < 128 && L1 > 128 && (ZC = L1 - L0) > uSeuilZC ) 
    puDestin_user [ndx] =  ZC ; /* Contour si ZC. */ 
  else 
    puDestin_user [ndx] =  0 ; /* A priori: par de contou. */ 
  }

// Ligne i=0
for ( ndx = 0 ; ndx < SIZE_OF_PICTURES - 1 ; ndx++ ) 
  {
  Lc =  puDestin_user [ndx]; /* Laplacien sur la cellule. */ 
  Ld =  puDestin_user [ndx + 1]; /* Laplacien  droite. */ 
  if ( Lc < Ld ) 
    {
    L0 =  Lc ;
    L1 =  Ld ;
    }
  else 
    {
    L0 =  Ld ;
    L1 =  Lc ;
    }
  if ( L0 < 128 && L1 > 128 && (ZC = L1 - L0) > uSeuilZC ) 
    puDestin_user [ndx] =  ZC ; /* Contour si ZC. */ 
  else 
    puDestin_user [ndx] =  0 ; /* A priori: par de contou. */ 
  }

// Point (i=0,j=SIZE_OF_PICTURES)
puDestin_user [SIZE_OF_PICTURES] =  0 ;
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL CalculeLaplacien ( char cTypeLaplacien, unsigned char *source_user
    , unsigned char *destin_user )
{
unsigned char *source_svg, *destin_svg ;

switch ( cTypeLaplacien ) 
  {
  case LAPLACIEN_CHAR_4 : 
    source_svg = source ;
    destin_svg = destin ;
    source     = source_user ;
    destin     = destin_user ;
    Contour('3');
    source = source_svg ;
    destin = destin_svg ;
    return SUCCES ;
  case LAPLACIEN_FLOAT_8 : return ConvolutionFlottante(source_user
                            , destin_user, M_SQRT_2, 1.0, M_SQRT_2, 1.0
                            , - 4 - 2 * M_SQRT2, 1.0, M_SQRT_2, 1.0
                            , M_SQRT_2);
  case LAPLACIEN_4x4_v4 : return ConvolutionFlottante4x4(source_user
                            , destin_user, 0, 1, 1, 0, 1, - 2, - 2, 1, 1
                            , - 2, - 2, 1, 0, 1, 1, 0);
  default : 
    
    //    MErreur("Erreur de code.",109);
    return ECHEC ;
  }
}

/*-------------------------------------------------------------*/
BOOL AmincissementGradientFilaire ( unsigned char *puAmplitude_user
    , unsigned char *puDirection_user )
{
int           i, j ;
long          N = SIZE_OF_PICTURES ;
unsigned int  n ;
char          di, dj ;
unsigned char no_de_direction, G ;
long          nv1, nv2 ;

for ( i = 1 ; i < N - 1 ; i++ ) 
  for ( j = 1 ; j < N - 1 ; j++ ) 
    {
    
    // Pour tous les points
#if SIZE_OF_PICTURES - 256
    n =  (unsigned int)(i * N + j);
#else 
    
    // N==256
    n =  (i << 8) + j ;
#endif
    
    /* "puDirection_user[n]" est la direction reprsente sur [0;255[;
       "puDirection_user[n] & 0xFE" est idem avec une incertitude sur l'LSB;
       "(puDirection_user[n] & 0xFE)+16" est idem dcal de 16, c'est  dire un
       demi secteur pour une partition des directions en 8 (256/8=32);
       "((int)(puDirection_user[n] & 0xFE)+16)/32)" est le numro de direction pour
       une partition des directions en 8;
       "(((int)(puDirection_user[n] & 0xFE)+16)/32)%4" donne l'un des 4 etats :
       0 : horizontal, 1 : 1e diagonale, 2 : vertical, 3 : 2e diagonale.
       */
    no_de_direction // 0 : horizontal, 1 : 1e diagonale, 2 : vertical, 3 : 2e diagonale.
    =  (((int)(puDirection_user [n] & ~CTR_Exploration) + 16) / 32) % 4 ;
    if ( !Directions_vectorielles(no_de_direction, &di, &dj) ) 
      return (MErreur("Erreur", 256));
    G   =  puAmplitude_user [n];
    
    /* Elimination du contour si un de ses voisins est plus grand. */
    nv1 =  n + di * N + dj ; // Adresse du voisin  1
    nv2 =  n - di * N - dj ; // Adresse du voisin  2
    
    //      if (nv1<0 || nv1 >= N*N || nv2<0 || nv2 >= N*N)
    //        return Erreur("Dpassement de tableau avec G=",G,333);
    if ( G && (puAmplitude_user [(unsigned int)nv1] > G
                || puAmplitude_user [(unsigned int)nv2] > G) ) 
      puAmplitude_user [n] =  0 ;
    }

/* Anihilation des contours des bords. */
for ( i = 0 ; i < N ; i++ ) 
  {
#if SIZE_OF_PICTURES - 256
  puAmplitude_user [(unsigned int)(i * N)]           =  0 ;
  puAmplitude_user [(unsigned int)(i * N + (N - 1))] =  0 ;
  puAmplitude_user [i]                               =  0 ;
  puAmplitude_user [(unsigned int)((N - 1) * N + i)] =  0 ;
#else 
  
  // N==256
  puAmplitude_user [i << 8]                   =  0 ;
  puAmplitude_user [(i << 8) + 255]           =  0 ;
  puAmplitude_user [i]                        =  0 ;
  puAmplitude_user [(unsigned int)65280L + i] =  0 ;
#endif
  }
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL ContoursEtChaineurContoursIteratif ( char cTypeLaplacien
    , unsigned char *puSource_user, unsigned char *puAmplitude_user
    , unsigned char *puDirectionExploration_user
    , unsigned char *puChainage_user, int iPartUser, unsigned char uSeuilZC
    , unsigned int wChainageMode )
{
switch ( cTypeLaplacien ) 
  {
  case LAPLACIEN_FLOAT_8 : 
  case LAPLACIEN_CHAR_4 : 
  case LAPLACIEN_4x4_v4 : 
    {
    if ( !CalculeContoursChaineurIteratif(cTypeLaplacien, puSource_user
          , puAmplitude_user, puDirectionExploration_user, iPartUser
          , uSeuilZC) ) 
      return (MErreur("Echec au calcul des contours.", 235));
    if ( !AmincissementGradientFilaire(puAmplitude_user
          , puDirectionExploration_user) ) 
      return (MErreur("Echec  l'amincissement.", 244));
    }
  break ;
  case CONTOUR_BIN : 
    CalculeContoursDImageBinaire(puSource_user, puAmplitude_user
      , puDirectionExploration_user);
    break ;
  default : return MErreur("Laplacien indfini", 601);
  }
Transfert(puAmplitude_user);

/*  if (fTracage)
   WMN("contours.img",puAmplitude_user); */
Transfert(puAmplitude_user);
return ChaineurContours(puAmplitude_user, puDirectionExploration_user
  , puChainage_user, wChainageMode);
}

/*-------------------------------------------------------------*/
BOOL ChaineurContours ( unsigned char *puAmplitude_user
    , unsigned char *puDirectionExploration_user
    , unsigned char *puChainage_user, unsigned int wModeChainage )
{
long        n ;
TCoordonnee p ;

amplitude   =  puAmplitude_user ;
exploration =  puDirectionExploration_user ; // LSB 0x01 contient la carte d'exploration
direction   =  puDirectionExploration_user ;
chainage    =  puChainage_user ; // Poids forts 0xF0 contiennent info prcession, 0x0F succession

//                                          0x80 | 0x08 existence
//                                          0x70 | 0x07 direction
for ( n = 0 ; n < (long)SIZE_OF_PICTURES * SIZE_OF_PICTURES ; n++ ) 
  exploration [(unsigned int)(n)] &= ~CTR_Exploration ; // Mise  zro du LSB (carte d'exploration).
Eff(chainage);
if ( !ActiveRuban("Chanage") ) 
  return MErreur("Anomalie ruban", 295);

BOOL  (*funcChercheChainage)(TCoordonnee, unsigned char)
  = wModeChainage == CTR_ChainageLibre ? 
       SuitChainageSansContrainte_Iterative
    : SuitChainageDirectionnel_Iterative ;

for ( p.y = 0 ; p.y < SIZE_OF_PICTURES ; p.y++ ) 
  {
  for ( p.x = 0 ; p.x < SIZE_OF_PICTURES ; p.x++ ) 
    {
#if IMG256
    n =  (p.y << 8) + p.x ;
#else 
    n =  p.y * (long)SIZE_OF_PICTURES + p.x ;
#endif
    if ( !(exploration [(unsigned int)(n)] & CTR_Exploration) ) 
      {
      exploration [(unsigned int)(n)] |= CTR_Exploration ;
      if ( amplitude [(unsigned int)(n)] ) 
        {
        //BOOL SuitChainageSansContrainte(TCoordonnee p, unsigned char uSensDirect)
        if ( !funcChercheChainage(p, RETROGRADE) ) 
          return MErreur("Echec au chanage de prcession.", 380);
        if ( !funcChercheChainage(p, DIRECT) ) 
          return MErreur("Echec au chanage de succession.", 300);
        }
      }
    }
  if ( fRuban ) 
    AvanceRuban((unsigned char)(p.y * 100 / SIZE_OF_PICTURES));
  }
if ( !FermeRuban() ) 
  return MErreur("Anomalie ruban", 320);
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL ValidationChainageCoherent ( unsigned char *puChainage_user )
{
int           i, j ;
long          N = SIZE_OF_PICTURES ;
char          di, dj, dib, djb ;
unsigned char chain_loc, chain_suiv ;

chainage =  puChainage_user ;
for ( i = 0 ; i < N ; i++ ) 
  for ( j = 0 ; j < N ; j++ ) 
    {
    chain_loc =  chainage [(unsigned int)(i * N + j)];
    
    /* Si (i,j) possde un successeur...*/
    if ( chain_loc & CTR_AnySuccessor ) 
      {
      if ( !Directions_vectorielles(chain_loc & CTR_SuccessorDir, &di, &dj) ) 
        return MErreur("Erreur au contrle de validation.", 262);
      if ( i + di < 0 || i + di > 255 || j + dj < 0 || j + dj > 255 ) 
        return MErreur("Sortie lors de pointage.", 265);
      chain_suiv =  chainage [(unsigned int)((i + di) * N + j + dj)];
      if ( !(chain_suiv & CTR_AnyPredecessor) ) 
        return MErreur("Successeur sans prdecesseur.", 268);
      if ( !Directions_vectorielles((chain_suiv & CTR_PredecessorDir) >> 4
            , &dib, &djb) ) 
        return MErreur("Erreur au contrle de validation.", 270);
      if ( di != - dib || dj != - djb ) 
        return MErreur("Successeur sans pointage retour rgulier.", 268);
      }
    
    /* Si (i,j) possde un prdecesseur...*/
    if ( chain_loc & CTR_AnySuccessor ) 
      {
      if ( !Directions_vectorielles((chain_loc & CTR_PredecessorDir) >> 4
            , &di, &dj) ) 
        return MErreur("Erreur au contrle de validation.", 277);
      if ( i + di < 0 || i + di > 255 || j + dj < 0 || j + dj > 255 ) 
        return MErreur("Sortie lors de pointage.", 279);
      chain_suiv =  chainage [(unsigned int)((i + di) * N + j + dj)];
      if ( !(chain_suiv & CTR_AnyPredecessor) ) 
        return MErreur("Prdecesseur sans successeur.", 282);
      if ( !Directions_vectorielles(chain_suiv & CTR_SuccessorDir, &dib
            , &djb) ) 
        return MErreur("Erreur au contrle de validation.", 270);
      if ( di != - dib || dj != - djb ) 
        return MErreur("Prdecesseur sans pointage retour rgulier.", 286);
      }
    }
return SUCCES ;
}

/*--AppelRestaurationUnificatriceLignesGTTSI-------------------*/
BOOL AppelRestaurationUnificatriceLignesGTTSI ()
{
unsigned int  wNbElim ;

if ( !RestaurationUnificatriceLignesGTTSI(wNbElim) ) 
  return MErreur("Erreur unification de ligne", 485);
if ( !RetablissementLongueursLignesGTTSI() ) 
  return MErreur("Erreur rtablissement longueurs", 485);
qsort(algnTableLignes, wNbl, sizeof(ligne_AB), fcmp_DifferenceDeLongueur);
return SUCCES ;
}

/*-------------------------------------------------------------
                              Fonctions locales                 
   -------------------------------------------------------------*/
// Ne vrifie pas que les points sont bien intra-muros.
int ConvolutionLocale ( unsigned char *puSource, TPoint pt, int i0, int i1
    , int i2, int i3, int i4, int i5, int i6, int i7, int i8 )
{
unsigned int  wN = SIZE_OF_PICTURES, w = pt.y * wN + pt.x ;

return i0 * puSource [w - wN - 1] + i1 * puSource [w - wN]
  + i2 * puSource [w - wN + 1] + i3 * puSource [w - 1] + i4 * puSource [w]
  + i5 * puSource [w + 1] + i6 * puSource [w + wN - 1]
  + i7 * puSource [w + wN] + i8 * puSource [w + wN + 1];
}

char ConvolutionFlottante ( unsigned char *puSource, unsigned char *puCible
    , float A0, float A1, float A2, float A3, float A4, float A5, float A6
    , float A7, float A8 )
{
unsigned int      N = SIZE_OF_PICTURES, i, j ;
unsigned long int k ;
unsigned int      n ;
float             s, SA ;
BOOL              fNorm ;

if ( puSource == NULL || puCible == NULL ) 
  {
  MErreur("Erreur d'allocation.", 127);
  return ECHEC ;
  }
SA    =  A0 + A1 + A2 + A3 + A4 + A5 + A6 + A7 + A8 ;
fNorm =  fabs(SA) > 0.01 ;
for ( i = 1 ; i < N - 1 ; i++ ) 
  for ( j = 1 ; j < N - 1 ; j++ ) 
    {
    n           =  i * N + j ;
    s           =  A0 * puSource [n - N - 1] + A1 * puSource [n - N]
      + A2 * puSource [n - N + 1] + A3 * puSource [n - 1]
      + A4 * puSource [n] + A5 * puSource [n + 1]
      + A6 * puSource [n + N - 1] + A7 * puSource [n + N]
      + A8 * puSource [n + N + 1];
    
    /* Si la matrice de convolution a une moyenne non nulle, il faut la
       renormaliser.  (s/SA)
        Si la matrice de convolution a une moyenne nulle, il faut recentrer son
       rsultat autour de 128 (s+128.0). */
    puCible [n] 
      =  (unsigned char)NReduceR(fNorm ? s / SA : s + 128.0, 0, 255);
    }
for ( k = 1 ; k < N - 1 ; k++ ) 
  {
  j           =  0 ;
  i           =  (unsigned int)k ;
  n           =  i * N + j ;
  s           =  A1 * puSource [n - N] + A2 * puSource [n - N + 1]
    + A4 * puSource [n] + A5 * puSource [n + 1] + A7 * puSource [n + N]
    + A8 * puSource [n + N + 1];
  puCible [n] 
    =  (unsigned char)NFarRoundR(
      RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));
  j           =  N - 1 ;
  i           =  (unsigned int)k ;
  n           =  i * N + j ;
  s           =  A0 * puSource [n - N - 1] + A1 * puSource [n - N]
    + A3 * puSource [n - 1] + A4 * puSource [n]
    + A6 * puSource [n + N - 1] + A7 * puSource [n + N];
  puCible [n] 
    =  (unsigned char)NFarRoundR(
      RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));
  j           =  (unsigned int)k ;
  i           =  0 ;
  n           =  i * N + j ;
  s           =  A3 * puSource [n - 1] + A4 * puSource [n]
    + A5 * puSource [n + 1] + A6 * puSource [n + N - 1]
    + A7 * puSource [n + N] + A8 * puSource [n + N + 1];
  puCible [n] 
    =  (unsigned char)NFarRoundR(
      RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));
  j           =  (unsigned int)k ;
  i           =  N - 1 ;
  n           =  i * N + j ;
  s           =  A0 * puSource [n - N - 1] + A1 * puSource [n - N]
    + A2 * puSource [n - N + 1] + A3 * puSource [n - 1]
    + A4 * puSource [n] + A5 * puSource [n + 1];
  puCible [n] 
    =  (unsigned char)NFarRoundR(
      RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));
  }

// n=i=j=0;
s               =  A4 * puSource [0] + A5 * puSource [1]
  + A7 * puSource [N] + A8 * puSource [N + 1];
puCible [0]     
  =  (unsigned char)NFarRoundR(
    RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));

// i=0,j=N-1,n=N-1
s               =  A3 * puSource [N - 2] + A4 * puSource [N - 1]
  + A6 * puSource [N + N - 2] + A7 * puSource [N + N - 1];
puCible [N - 1] 
  =  (unsigned char)NFarRoundR(
    RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));

// i=N-1,j=0;
n               =  (N - 1) * N ;
s               =  A1 * puSource [n - N] + A2 * puSource [n - N + 1]
  + A4 * puSource [n] + A5 * puSource [n + 1];
puCible [n]     
  =  (unsigned char)NFarRoundR(
    RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));

// i=j=N-1; n=(N-1)*N+N-1=N-1;
n               =  (unsigned int)(long)N * N - 1 ;
s               =  A0 * puSource [n - N - 1] + A1 * puSource [n - N]
  + A3 * puSource [n - 1] + A4 * puSource [n];
puCible [n]     
  =  (unsigned char)NFarRoundR(
    RReduceR(fNorm ? s / SA : s + 128.0, 0.0, 255.0));
return SUCCES ;
}

/*-------------------------------------------------------------*/
char ConvolutionFlottante4x4 ( unsigned char *puSource
    , unsigned char *puCible, float A1, float A2, float A3, float A4
    , float B1, float B2, float B3, float B4, float C1, float C2, float C3
    , float C4, float D1, float D2, float D3, float D4 )
{
const unsigned int  N = SIZE_OF_PICTURES ;
unsigned int        i, j, n ;

//                 unsigned long int k;
float               s, S ;
BOOL                fNorm ;

if ( !puSource || !puCible ) 
  return MErreur("Erreur d'allocation.", 127);
S     =  A1 + A2 + A3 + A4 + B1 + B2 + B3 + B4 + C1 + C2 + C3 + C4 + D1
  + D2 + D3 + D4 ;
fNorm =  fabs(S) > 0.01 ;
for ( i = 2 ; i < N - 1 ; i++ ) 
  for ( j = 1 ; j < N - 2 ; j++ ) 
    {
    n           =  i * N + j ;
    s           =  A1 * puSource [n - 1 - 2 * N]
      + A2 * puSource [n - 2 * N] + A3 * puSource [n + 1 - 2 * N]
      + A4 * puSource [n + 2 - 2 * N] + B1 * puSource [n - 1 - N]
      + B2 * puSource [n - N] + B3 * puSource [n + 1 - N]
      + B4 * puSource [n + 2 - N] + C1 * puSource [n - 1]
      + C2 * puSource [n] + C3 * puSource [n + 1] + C4 * puSource [n + 2]
      + D1 * puSource [n - 1 + N] + D2 * puSource [n + N]
      + D3 * puSource [n + 1 + N] + D4 * puSource [n + 2 + N];
    
    /* Si la matrice de convolution a une moyenne non nulle, il faut la
       renormaliser.  (s/SA)
        Si la matrice de convolution a une moyenne nulle, il faut recentrer son
       rsultat autour de 128 (s+128.0). */
    puCible [n] 
      =  (unsigned char)NReduceR(fNorm ? s / S : s + 128.0, 0, 255);
    }
RemplaceNBord(puCible, 2);
return SUCCES ;
}

/*-------------------------------------------------------------*/
//void far Ero_dil(char c);
void CalculeContoursDImageBinaire ( unsigned char *puSource_user
    , unsigned char *puAmplitude_user, unsigned char *puDiffBuffer )
{
Dilatation(puSource_user, puDiffBuffer);
Opera(Numeroplan(puSource_user), puDiffBuffer, puAmplitude_user);
return ;
}

BOOL CalculeContoursChaineurIteratif ( char type_laplacien
    , unsigned char *puSource_user, unsigned char *puAmplitude_user
    , unsigned char *puDirection_user, int iPartUser
    , unsigned char uSeuilZC )
{

// Code les directions sur 256 niveaux.
if ( !CalculeDirectionGrad_2comp(puSource_user, puDirection_user, iPartUser) ) 
  return (MErreur("Echec au calcul des directions", 223));
if ( !CalculeZCLaplacien(puSource_user, puAmplitude_user, type_laplacien
      , uSeuilZC) ) 
  return (MErreur("Echec au calcul du ZC laplacien", 225));
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL SuitChainageDirectionnel_Iterative ( TCoordonnee p
    , unsigned char uSensDirect ) // TPoint (j,i)
{
TCoordonnee   ptTrack = p ;
unsigned int  wN ;

#if IMG256
wN =  (ptTrack.y << 8) + ptTrack.x ;
#else 
wN =  ptTrack.y * SIZE_OF_PICTURES + ptTrack.x ;
#endif
#if SwitchManyCheckers
if ( !Numeroplan(chainage) ) 
  return Erreur("Mauvais plan en n=", wN, 832);
#endif
exploration [wN] |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 

unsigned char uDirectionContourCourante
  = (direction [wN] & ~CTR_Exploration) + (uSensDirect ? 64 : - 64);
TPoint        vChain ;
unsigned char dChain ;

while ( FindNextNeigbor(ptTrack, &vChain, &dChain, CTR_ChainageDirectionnel
        , uDirectionContourCourante, uSensDirect) ) 
  {
  
  // Fabrique l'enchanement
  if ( uSensDirect ) 
    Enchaine_iter(ptTrack, vChain, dChain);
  else 
    Enchaine_iter(vChain, ptTrack, (dChain + 4) % 8);
  ptTrack =  vChain ;
#if IMG256
  wN =  (ptTrack.y << 8) + ptTrack.x ;
#else 
  wN =  ptTrack.y * SIZE_OF_PICTURES + ptTrack.x ;
#endif
  exploration [wN]          |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 
  uDirectionContourCourante 
    =  (direction [wN] & ~CTR_Exploration) + (uSensDirect ? 64 : - 64);
  }
Enchaine_iter(ptTrack, ptTrack, uSensDirect ? 0x08 : 0xFF);
return SUCCESS ;
}

#if 0 // Obsolte
#endif

/*
    "direction" reprsente la direction telle que 256 code 360 et 0 code 0
   (quel que soit le nombre de classe utilis multiple de 8), et malgr
   l'imprcision sur l'LSB.
     256 fait 360
     128 fait 180
     64 fait   90.     CTR_Exploration=0x01
     direction[wN] & ~CTR_Exploration : filtre l'LSB et rend la direction paire.
     (direction[wN] & ~CTR_Exploration)+64 ajoute 90
     (direction[wN] & ~CTR_Exploration)-64 ajoute 90 puis retranche 180): chanage  rebours.
   
               uDirectionContourCourante=(direction[wN] & ~CTR_Exploration)+
                   (uSensDirect?64:-64);
             // uDirectionContourCourante indique la direction privilgie
               if (!triplet_ordonne_designe(p.y,p.x,uDirectionContourCourante,
             					 &vA,&dA,&vB,&dB,&vC,&dC))
             // triplet_ordonne_designe renvoit dans l'ordre de prfrence les 3 directions autorises de la direction dsigne privilgie.
             	 return (MErreur("Echec au calcul de chainage",321));
             // CompatibiliteChainageDirectionnel indique pour chaque couple soumis si le chanage est compatblie.
               if (CompatibiliteChainageDirectionnel(p,vA,uSensDirect))
             	 {vChain=vA;dChain=dA;}
               else if (CompatibiliteChainageDirectionnel(p,vB,uSensDirect))
             	 {vChain=vB;dChain=dB;}
               else if (CompatibiliteChainageDirectionnel(p,vC,uSensDirect))
             	 {vChain=vC;dChain=dC;}
               else
             	 fChaine=FAUX;
               if (fChaine)
               // Fabrique l'enchanement
             	 {
             	 if (uSensDirect)
             		Enchaine_iter(p,vChain,dChain);
             	 else
             		Enchaine_iter(vChain,p,(dChain+4)%8);
                // Suit l'enchanement
             	 return SuitChainageDirectionnel_Iterative(vChain,uSensDirect);
             	 }
               else
               // Ferme la chane
             	 {
                      Enchaine_iter(p,p,uSensDirect?8:255);
               // Termine l'enchanement
             	 return SUCCES;
             	 }
               }
             */
/*-------------------------------------------------------------*/
char triplet_ordonne_designe ( int i, int j
    , unsigned char direction_courante, TCoordonnee *vA, unsigned char *dA
    , TCoordonnee *vB, unsigned char *dB, TCoordonnee *vC
    , unsigned char *dC ) // TPoint (j,i)
{
char          di, dj ;
unsigned char no_de_direction, double_no_de_direction ;

no_de_direction =  (((int)direction_courante + 16) / 32) % 8 ;

/* 0 : droit,  1 : haut-droit, 2 : haut, 3 : haut-gauche,
   4 : gauche, 5 : gauche-bas, 6 : bas,  7 : bas-droite. */
*dA             =  no_de_direction ;
if ( !Directions_vectorielles(no_de_direction, &di, &dj) ) 
  return (MErreur("Erreur", 256));
vA -> y                =  i + di ;
vA -> x                =  j + dj ;
double_no_de_direction =  direction_courante / 16 ;

/* 15-0 : droit,  1-2  : haut-droit, 3-4  : haut,  5-6 : haut-gauche,
   7-8  : gauche, 9-10 : gauche-bas, 11-12 : bas,  13-14 : bas-droite. */
if ( double_no_de_direction == (2 * (int)no_de_direction) ) 
  {
  *dB =  (no_de_direction + 1) % 8 ;
  *dC =  (no_de_direction + 7) % 8 ;
  }
else if ( double_no_de_direction == (2 * (int)no_de_direction + 15) % 16 ) 
  {
  *dB =  (no_de_direction + 7) % 8 ;
  *dC =  (no_de_direction + 1) % 8 ;
  }
else 
  return (MErreur("Erreur de code.", 361));
if ( !Directions_vectorielles(*dB, &di, &dj) ) 
  return (MErreur("Erreur", 365));
vB -> y =  i + di ;
vB -> x =  j + dj ;
if ( !Directions_vectorielles(*dC, &di, &dj) ) 
  return (MErreur("Erreur", 369));
vC -> y =  i + di ;
vC -> x =  j + dj ;
return SUCCES ;
}

/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int CompatibiliteChainageDirectionnel ( TCoordonnee p, TCoordonnee v
    , unsigned char uSensDirect ) // TPoint (j,i)
{

//  int iv, jv;
unsigned char dA, dB, dC, direction_AR_v ;
TCoordonnee   pA, pB, pC ;
unsigned int  nv = v.y * SIZE_OF_PICTURES + v.x ;

//  iv=v.x; jv=v.y;  nv=iv*SIZE_OF_PICTURES+jv;
if ( (exploration [nv] & CTR_Exploration) || !amplitude [nv] ) 
  return FAUX ;
if ( uSensDirect ) 
  direction_AR_v =  (direction [nv] & ~CTR_Exploration) - 64 ;
else 
  direction_AR_v =  (direction [nv] & ~CTR_Exploration) + 64 ;
if ( !triplet_ordonne_designe(v.y, v.x, direction_AR_v, &pA, &dA, &pB, &dB
      , &pC, &dC) ) 
  return FAUX ;
else 
  return p == pA || p == pB || p == pC ;
}

/*-------------------------------------------------------------*/
BOOL Directions_vectorielles ( unsigned char uNoDeDirection, TSize *ps_dji )
{

// TPoint (j,i)
switch ( uNoDeDirection ) 
  {
  
  /* Dfinition des directions vectorielles. */
  case 0 : 
    ps_dji -> cy = 0 ;
    ps_dji -> cx = 1 ;
    break ;
  case 1 : 
    ps_dji -> cy = - 1 ;
    ps_dji -> cx = 1 ;
    break ;
  case 2 : 
    ps_dji -> cy = - 1 ;
    ps_dji -> cx = 0 ;
    break ;
  case 3 : 
    ps_dji -> cy = - 1 ;
    ps_dji -> cx = - 1 ;
    break ;
  case 4 : 
    ps_dji -> cy = 0 ;
    ps_dji -> cx = - 1 ;
    break ;
  case 5 : 
    ps_dji -> cy = + 1 ;
    ps_dji -> cx = - 1 ;
    break ;
  case 6 : 
    ps_dji -> cy = + 1 ;
    ps_dji -> cx = 0 ;
    break ;
  case 7 : 
    ps_dji -> cy = + 1 ;
    ps_dji -> cx = + 1 ;
    break ;
  default : return (MErreur("Erreur de code", 374));
  }
return SUCCES ;
}

BOOL Directions_vectorielles ( unsigned char uNoDeDirection, char *di
    , char *dj )
{
TSize s_dji ;
int   f = Directions_vectorielles(uNoDeDirection, &s_dji);

*di =  s_dji.cy ;
*dj =  s_dji.cx ;
return f ;
}

char Enchaine_iter ( TCoordonnee p0, TCoordonnee p1, unsigned char d ) // TPoint (j,i)
{

//  int i0=p0.x, j0=, i1=, j1=;
unsigned int  n0 = p0.y * SIZE_OF_PICTURES + p0.x
  , n1 = p1.y * SIZE_OF_PICTURES + p1.x ;

/*  if (!Numeroplan(chainage))
   return Erreur("Mauvais plan en n=",n0,795); */
// un octet de chnage contient : PpppSsss
/* o P=1 si il existe un prdecesseur,
         S=1 si il existe un successeur,
         ppp : direction du prdecesseur,
         sss : direction du successeur.
   Si le contour est droit, ppp = -sss (mod 8).
   */
if ( d == 8 ) 
  
  /* Fin de chane. */
  chainage [n0] &= ~CTR_AnySuccessor ; /* RAZ du successeur de p0. */ 
else if ( d == 255 ) 
  
  /* Dbut de chane. */
  chainage [n1] &= ~CTR_AnyPredecessor ; /* RAZ du prdecesseur de p1. */ 
else if ( d > 7 ) 
  return MErreur("Erreur de code.", 501);
else 
  {
  chainage [n0] &= ~CTR_AnySuccessor ; /* RAZ du successeur de p0. */ 
  chainage [n0] += CTR_SuccessorExist + d ; /* Validation de la succession (8) et mise  jour (d). */ 
  chainage [n1] &= ~CTR_AnyPredecessor ; /* RAZ du prdecesseur de p1. */ 
  chainage [n1] += (((d + 4) % 8) << 4) + CTR_PredecessorExist ; // (((d+4)%8)+8)<<4;
                                                                /* Dans les MSB ("<<4"), validation de la prcession ("+8") et mise  jour
                                                                   (-d=(d+4)%8). */ 
  }
return SUCCES ;
}

/*-------------------------------------------------------------
                  
   SuitChainageSansContrainte effectue un chanage sans se servir des directions de gradient.
                  
                  */
BOOL SuitChainageSansContrainte ( TCoordonnee p, unsigned char uSensDirect )
{
exploration [p.x * SIZE_OF_PICTURES + p.y] |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 
#if SwitchManyCheckers
if ( !Numeroplan(chainage) ) 
  return Erreur("Mauvais plan en n=", p.x * SIZE_OF_PICTURES + p.y, 655);
#endif

// Il n'y a pas de "uDirectionContourCourante" (direction privilgie)
// On cherche  se connecter  un 4-voisin, puis  un 8-voisin.
TPoint        vChain ;
unsigned char dChain ;

if ( FindNextNeigbor(p, &vChain, &dChain, CTR_ChainageLibre) ) // Fabrique l'enchanement
                                                                {
  if ( uSensDirect ) 
    Enchaine_iter(p, vChain, dChain);
  else 
    Enchaine_iter(vChain, p, (dChain + 4) % 8);
  
  // Suit l'enchanement
  return SuitChainageSansContrainte(vChain, uSensDirect);
                                                                }
else 

// Ferme la chane
  {
  Enchaine_iter(p, p, uSensDirect ? 0x08 : 0xFF);
  
  // Termine l'enchanement
  return SUCCES ;
  }
}

BOOL SuitChainageSansContrainte_Iterative ( TCoordonnee p
    , unsigned char uSensDirect ) // TPoint (j,i)
{
TCoordonnee ptTrack = p ;

exploration [ptTrack.y * SIZE_OF_PICTURES + ptTrack.x] |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 

TPoint        vChain ;
unsigned char dChain ;

while ( FindNextNeigbor(ptTrack, &vChain, &dChain, CTR_ChainageLibre) ) 
  {
  
  // Fabrique l'enchanement
  if ( uSensDirect ) 
    Enchaine_iter(ptTrack, vChain, dChain);
  else 
    Enchaine_iter(vChain, ptTrack, (dChain + 4) % 8);
  ptTrack                                                =  vChain ;
  exploration [ptTrack.y * SIZE_OF_PICTURES + ptTrack.x] 
    |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 
  }
Enchaine_iter(ptTrack, ptTrack, uSensDirect ? 0x08 : 0xFF);
return SUCCESS ;
}

int FindNextNeigbor ( TPoint pt, TPoint *pptVoisin
    , unsigned char *puDirection, unsigned int wModeChainage
    , unsigned char uDirectionContourCourante, unsigned char uSensDirect ) // TPoint (j,i)
{
if ( wModeChainage == CTR_ChainageLibre ) 
  {
  
  // CompatibiliteChainageDirectionnel indique pour chaque couple soumis si le chanage est compatblie.
  if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy(1, 0)) ) 
    *puDirection =  0 ;
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy(0, - 1)) ) 
    *puDirection =  2 ;
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy( - 1, 0)) ) 
    *puDirection =  4 ;
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy(0, 1)) ) 
    *puDirection =  6 ; // 8 voisins:
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy(1, - 1)) ) 
    *puDirection =  1 ;
  else if ( CompatibiliteChainageLibre(
            (*pptVoisin) = pt.OffsetBy( - 1, - 1)) ) 
    *puDirection =  3 ;
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy( - 1, 1)) ) 
    *puDirection =  5 ;
  else if ( CompatibiliteChainageLibre((*pptVoisin) = pt.OffsetBy(1, - 1)) ) 
    *puDirection =  7 ;
  else 
    return 0 ;
  return 1 ;
  }
else 
  {
  /*
       uDirectionContourCourante=(direction[wN] & ~CTR_Exploration)+
           (uSensDirect?64:-64);
     
      "direction" reprsente la direction telle que 256 code 360 et 0 code 0
     (quel que soit le nombre de classe utilis multiple de 8), et malgr
     l'imprcision sur l'LSB.
       256 fait 360
       128 fait 180
       64 fait   90.     CTR_Exploration=0x01
       direction[wN] & ~CTR_Exploration : filtre l'LSB et rend la direction paire.
       (direction[wN] & ~CTR_Exploration)+64 ajoute 90
       (direction[wN] & ~CTR_Exploration)-64 ajoute 90 puis retranche 180): chanage  rebours.
       */
  // uDirectionContourCourante indique la direction privilgie
  TCoordonnee   vA, vB, vC ;
  unsigned char dA, dB, dC ;
  if ( !triplet_ordonne_designe(pt.y, pt.x, uDirectionContourCourante, &vA
        , &dA, &vB, &dB, &vC, &dC) ) 
    
    // triplet_ordonne_designe renvoit dans l'ordre de prfrence les 3 directions autorises de la direction dsigne privilgie.
    return (MErreur("Echec au calcul de chainage", 321));
  
  // CompatibiliteChainageDirectionnel indique pour chaque couple soumis si le chanage est compatblie.
  // pptVoisin, unsigned char *puDirection
  if ( CompatibiliteChainageDirectionnel(pt, vA, uSensDirect) ) 
    {
    *pptVoisin   =  vA ;
    *puDirection =  dA ;
    }
  else if ( CompatibiliteChainageDirectionnel(pt, vB, uSensDirect) ) 
    {
    *pptVoisin   =  vB ;
    *puDirection =  dB ;
    }
  else if ( CompatibiliteChainageDirectionnel(pt, vC, uSensDirect) ) 
    {
    *pptVoisin   =  vC ;
    *puDirection =  dC ;
    }
  else 
    return FALSE ;
  return SUCCESS ;
  }
}

/*-------------------------------------------------------------*/
char DumpObjetsContoursGTTSI ( TPoint pt ) // (j,i)
{
unsigned char uChainon ;
TSize         s_dji ; //char dj, di;
TPoint        ptCurrent = pt ;

#if SwitchManyCheckers
if ( chainage [(unsigned int)(pt.y * SIZE_OF_PICTURES + pt.x)]
      & CTR_AnyPredecessor ) 
  
  /* Si (i,j) possde un prdecesseur...*/
  return MErreur("Dtection d'un prdecesseur en tte de chane.", 561);
#endif

unsigned int  wN ;

#if IMG256

// Tant que le pixel (i,j) a un successeur)
while ( (uChainon = chainage [wN = (ptCurrent.y << 8) + ptCurrent.x])
        & CTR_AnySuccessor ) 
  {
  if ( !Directions_vectorielles(uChainon & CTR_SuccessorDir, &s_dji)
        || !rImageBorder.Contains(ptCurrent + s_dji) ) 
    
    // Calcule le prochain pixel
    // La direction du prdecesseur n'est pas utilis.
    return MErreur("Erreur au suivi du chanage.", 566);
  else 
    {
    chainage [wN] =  CTR_PredecessorDir ; // Traage
    ptCurrent     =  ptCurrent + s_dji ;
    }
  }
#else 

// Tant que le pixel (i,j) a un successeur)
while ( (uChainon
          = chainage [wN = ptCurrent.y * SIZE_OF_PICTURES + ptCurrent.x])
        & CTR_AnySuccessor ) 
  {
  if ( !Directions_vectorielles(uChainon & CTR_SuccessorDir, &s_dji)
        || !rImageBorder.Contains(ptCurrent + s_dji) ) 
    
    // Calcule le prochain pixel
    // La direction du prdecesseur n'est pas utilis.
    return MErreur("Erreur au suivi du chanage.", 566);
  else 
    {
    chainage [wN] =  CTR_PredecessorDir ; // Traage
    ptCurrent     =  ptCurrent + s_dji ;
    }
  }
#endif
if ( !rImageBorder.Contains(ptCurrent + s_dji) ) 
  return MErreur("Erreur au suivi du chanage.", 1155);
else 
  chainage [wN] =  CTR_PredecessorDir ; // Traage
return SUCCESS ;
}

char ConstructionObjetsContoursGTTSI ( TPoint pt, int *Nb )
{

//  int i=depart.y, j=depart.x,

TPoint        ptCurrent = pt ; // (j,i)
unsigned char uChainon ;

//  long N=SIZE_OF_PICTURES;
TSize         s_dji ;          //char dj, di;

*Nb =  0 ; // Nombre de pixels de la chane
#if SwitchManyCheckers
if ( chainage [(unsigned int)(pt.y * SIZE_OF_PICTURES + pt.x)]
      & CTR_AnyPredecessor ) 
  
  /* Si (i,j) possde un prdecesseur...*/
  return MErreur("Dtection d'un prdecesseur en tte de chane.", 561);
#endif
#if IMG256

// Tant que le pixel (i,j) a un successeur)
while ( ((uChainon
              = chainage [(unsigned int)((ptCurrent.y << 8) + ptCurrent.x)])
            & CTR_AnySuccessor)
          && *Nb < wLongueurMaximaleChaine ) 
  {
  
  //    unsigned char u=CTR_SuccessorDir, uu=uChainon & u;
  //    unsigned int w=(ptCurrent.y << 8) +ptCurrent.x;
  if ( !Directions_vectorielles(uChainon & CTR_SuccessorDir, &s_dji)
        || !rImageBorder.Contains(ptCurrent + s_dji) ) 
    
    // Calcule le prochain pixel
    // La direction du prdecesseur n'est pas utilis.
    return MErreur("Erreur au suivi du chanage.", 1191);
  TABX [*Nb] =  ptCurrent.x ;
  TABY [*Nb] =  ptCurrent.y ;
  ptCurrent  += s_dji ;
  (*Nb)++ ;
  }
#else 

// Tant que le pixel (i,j) a un successeur)
while ( ((uChainon
              = chainage [
                (unsigned int)(ptCurrent.y * SIZE_OF_PICTURES + ptCurrent.x)])
            & CTR_AnySuccessor)
          && *Nb < wLongueurMaximaleChaine ) 
  {
  
  //    unsigned char u=CTR_SuccessorDir, uu=uChainon & u;
  //    unsigned int w=(ptCurrent.y << 8) +ptCurrent.x;
  if ( !Directions_vectorielles(uChainon & CTR_SuccessorDir, &s_dji)
        || !rImageBorder.Contains(ptCurrent + s_dji) ) 
    
    // Calcule le prochain pixel
    // La direction du prdecesseur n'est pas utilis.
    return MErreur("Erreur au suivi du chanage.", 1191);
  TABX [*Nb] =  ptCurrent.x ;
  TABY [*Nb] =  ptCurrent.y ;
  ptCurrent  += s_dji ;
  (*Nb)++ ;
  }
#endif

// Si il y a eu au moins un pixel, alors il faut rajouter le dernier qui est un pixel terminateur sans successeur.
if ( *Nb < wLongueurMaximaleChaine ) 
  {
  TABX [*Nb] =  ptCurrent.x ;
  TABY [*Nb] =  ptCurrent.y ;
  (*Nb)++ ;
  }
else 
  {
  
  //    Trace dans les bits de direction du prdecesseur le contour qui a bloqu.
  if ( fTracage ) 
    DumpObjetsContoursGTTSI(pt);
  return MErreur("Dpassement de taille limite de chane", 568);
  }
return SUCCESS ;
}

TPoint NextPixel ( TPoint ptCurrent, unsigned char LinkingMap )
{
char  di, dj ;

#if SwitchManyCheckers
int f = Directions_vectorielles(LinkingMap & CTR_SuccessorDir, &di, &dj);
#else 
Directions_vectorielles(LinkingMap & CTR_SuccessorDir, &di, &dj);
#endif
#if SwitchManyCheckers
if ( !f || !rImageBorder.Contains(
      TPoint(ptCurrent.x + dj, ptCurrent.y + di)) ) 
  MErreur("Erreur (peut-tre chanon hors limite)", 997);
#endif
return TPoint(ptCurrent.x + dj, ptCurrent.y + di);
}

/*-------------------------------------------------------------*/
int InterpretationObjetsContoursGTTSI ( int iLongChaine )
{
TLigne  AB ;
int     k ;

if ( !TABSOM [0] ) 
  return MErreur("Pas de ligne sur cette chane.", 572);
AB.A =  TCoordonnee((unsigned char)TABX [0], (unsigned char)TABY [0]);
for ( k = 1 ; k < iLongChaine ; k++ ) 
  if ( TABSOM [k] || k == iLongChaine - 1 ) /* ligne d'A au point courant. */ 
                                              {
                                              AB.B
                                                =  TCoordonnee(
                                                  i2uc(TABX [k])
                                                  , i2uc(TABY [k]));
  // Initialisation interne d'lg dans "AB.Longueur()"
  if ( AB.Longueur() >= wLongueurMinimaleChaine ) 
    {
    if ( wNbl == NLA ) 
      {
      throw 5 ;
      ;
      ; //EXCEPT_LineQuantityLimitExceeded;
      }
    else 
      algnTableLignes [wNbl++] =  Cv_ligne(AB);
    }                                         
                                              AB.A =  AB.B ;
                                              }
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL InitialiseObjetsContours ( unsigned int partition_user )
{
static unsigned char  init = FAUX ;
unsigned char         new_bp ;

if ( !init || partition_user != partition ) 
  {
  new_bp =  partition_user >> 3 ;
  if ( partition_user < 8
        || partition_user > 256
        || ((new_bp << 3) != partition_user)
        || !EstUnePuissanceDe2(partition_user) ) 
    return MErreur("Nombre de classes non conforme.", 615);
  if ( !RemplissageTableTangentes(new_bp) ) 
    return MErreur("Echec  l'initialisation des classes.", 616);
  partition      =  partition_user ;
  base_partition =  new_bp ;
  init           =  VRAI ;
  }
return SUCCES ;
}

/*-------------------------------------------------------------
    VectorisateurGTTSI (vectorisateur construit sur routines GTTSI)
     A partir d'un pixel de dbut de chane, et du nombre de lignes existantes
   (index de la prochaine ligne), cette procdure vectorise la chane et la
   met en mmoire.
   */
BOOL VectorisateurGTTSI ( TPoint depart ) // TPoint (j,i)
{
int iLongChaine ;

seuil_dis =  SEUIL_DISTANCE_VECTORISATEUR ;
if ( !ConstructionObjetsContoursGTTSI(depart, &iLongChaine) ) 
  return MErreur("Echec  la construction des objets GTTSI.", 293);
if ( iLongChaine >= wLongueurMinimaleChaine ) 
  {
  Remp_tabsom(iLongChaine);
  if ( !InterpretationObjetsContoursGTTSI(iLongChaine) ) 
    return MErreur("Echec  l'interprtation des objets GTTSI.", 297);
  }
return SUCCES ;
}

/*-------------------------------------------------------------*/
int fcmp_DifferenceDeLongueur ( const void *L1, const void *L2 )
{

//  ligne_AB *LL1, *LL2;
//  LL1=(ligne_AB *)L1; LL2=(ligne_AB *)L2;
return (int)(((ligne_AB *)L2) -> lg) - ((ligne_AB *)L1) -> lg ;
}

/*-------------------------------------------------------------*/
BOOL CompositionDeLignesGTTSI ( unsigned char *puChainage_user )
{

//  int i, j;

TPoint        pt ; // (j,i)

//  long N=SIZE_OF_PICTURES;
unsigned char chainon ;

#if SwitchManyCheckers
if ( !Numeroplan(puChainage_user) ) 
  return ECHEC ;
#endif
chainage =  puChainage_user ;
wNbl     =  0 ;

int eProcess = 0 ;

try
  {
  for ( pt.y = 0 ; pt.y < SIZE_OF_PICTURES ; pt.y++ ) 
    for ( pt.x = 0 ; pt.x < SIZE_OF_PICTURES ; pt.x++ ) 
      {
#if IMG256
      chainon =  chainage [(pt.y << 8) + pt.x];
#else 
      chainon =  chainage [(unsigned int)(pt.y * N + pt.x)];
#endif
      if ( (chainon & CTR_SuccessorExist)
            && !(chainon & CTR_PredecessorExist) )
                                                    {
/* Un successeur et pas de prdecesseur. */
                                                    if ( !VectorisateurGTTSI(pt) )
                                                      return MErreur("Erreur  la vectorisation.", 638);
                                                    }
      }
  } catch ( int e )
  {
  if ( e == EXCEPT_LineQuantityLimitExceeded )
    eProcess =  e ;
  else
    {
    throw e ;
    ;
    }
  }
qsort(algnTableLignes, wNbl, sizeof(ligne_AB), fcmp_DifferenceDeLongueur);

// All links;
AuthorizeLink();
if ( eProcess )
  {
  throw eProcess ;
  ;
  }
return SUCCES ;
}

/*-------------------------------------------------------------*/
unsigned char NSPH ( int u, int v )
{

float         tan_alpha ; /*=0.0;*/
unsigned char k ;

/*
   if (!u)
     {
     MErreur("Division par zro",936,TERMINAL);
     tan_alpha=M_PI/2.0;
     }
   else                   */
tan_alpha =  (float)v / u ;
for ( k = 0 ; k < base_partition ; k++ ) 
  if ( tan_alpha < table_tangentes [k] ) 
    return k ;
return base_partition ;
}

/*-------------------------------------------------------------*/
BOOL RemplissageTableTangentes ( unsigned char base_partition_user )
{
unsigned char k ;

if ( base_partition_user > 32 || base_partition_user == 0 ) 
  return MErreur("Echec  l'initialisation", 682);
for ( k = 0 ; k < base_partition_user ; k++ ) 
  table_tangentes [k]
    =  (float)tan(M_PI / 4.0 / base_partition_user * (0.5 + k));
return SUCCES ;
}

/*-------------------------------------------------------------*/
unsigned char FastClasseArctan ( int u, int v )
{
/*
   On prend ventuellement les symtriques de la droite port par (u v) pour qu'elle passe dans la 1e moiti du e 1e quadrant: (max(abs(u),abs(v)),min(abs(u),abs(v)))
   On calcule la classe dans cette partie et on en dduit la classe originale.
   
   Note: ce procd marche bien quel que soit le nombre de classes, mais pour 8classes, il y a srement plus rapide
   */

unsigned char NSPQ ;    // N de secteur premier quadran.
char          NSPDP ;   // N de secteur premier demi-plan.
char          sgn_umv ; //, sgnu;

if ( u == 0 ) 
  return (partition + signe(v) * base_partition * 2) % partition ;
else if ( v == 0 ) 
  return (partition + base_partition * (2 - 2 * signe(u))) % partition ;
sgn_umv =  signe(abs(u) - abs(v));

//  sgnu=signe(u);
//  NSPQ=(partition+sgn_umv*(char)NSPH(max(abs(u),abs(v)),min(abs(u),abs(v)))+(1-sgn_umv)*base_partition)%partition;
NSPQ    
  =  (partition
      + sgn_umv * (char)NSPH(max(abs(u), abs(v)), min(abs(u), abs(v)))
      + ((sgn_umv > 0 ? 0 : 2) * base_partition))
    % partition ;
NSPDP   =  signe(v) * NSPQ ;

/*  return (unsigned char) (((int)(2-2*signe(u))*base_partition+signe(v)*NSPQ)%partition); */
// u!=0 => (2-2*sgnu)= u>0?0:4
//  return (partition+NSPDP*(u>0?1:-1)+base_partition*(u>0?0:4))%partition;
return (partition + (u > 0 ? NSPDP : - NSPDP)
    + (u > 0 ? 0 : 4 * base_partition))
  % partition ;
}

/*-------------------------------------------------------------*/
unsigned char Fast8ClasseArctan ( int u, int v )
{
static float  x_tan_22_5 = tan(22.5 / 180 * M_PI);
static float  x_tan_67_5 = tan(67.5 / 180 * M_PI);

if ( u == 0 && v == 0 ) 
  return 0 ;
else if ( u == 0 ) 
  return signe(v) > 0 ? 2 : 6 ;
else if ( v == 0 ) 
  return signe(u) > 0 ? 0 : 4 ; // Demi-plan de droite
else if ( u > 0 ) 
  {
  
  // 1e quadrant
  if ( v > 0 ) 
    {
    if ( (float)v / u <= x_tan_22_5 ) 
      return 0 ;
    else if ( (float)v / u <= x_tan_67_5 ) 
      return 1 ;
    else 
      return 2 ;
    } //4e quadrant
  else 
    {
    if ( - (float)v / u <= x_tan_22_5 ) 
      return 0 ;
    else if ( - (float)v / u <= x_tan_67_5 ) 
      return 7 ;
    else 
      return 6 ;
    }
  }
else 

// Demi-plan de gauche
  {
  
  // 2e quadrant
  if ( v > 0 ) 
    {
    if ( - (float)v / u <= x_tan_22_5 ) 
      return 4 ;
    else if ( - (float)v / u <= x_tan_67_5 ) 
      return 3 ;
    else 
      return 2 ;
    }
  else 
  
  // u et v <0   3e quadrant
    {
    if ( (float)v / u <= x_tan_22_5 ) 
      return 4 ;
    else if ( (float)v / u <= x_tan_67_5 ) 
      return 5 ;
    else 
      return 6 ;
    }
  }
}

/*-------------------------------------------------------------*/
BOOL DesigneLigne ( TCoordonnee Point_extraction, TLigne *pLigne, int *pi )
{
BOOL  fErreur = FAUX ;

*pLigne =  TLigne();
for ( *pi = 0 ; *pi < wNbl ; (*pi)++ ) 
  if ( CoincidePointLigne(Point_extraction, algnTableLignes + *pi, &fErreur) ) 
    {
    *pLigne =  Cv_TLigne(algnTableLignes [*pi]);
    return SUCCES ;
    }
  else if ( fErreur ) 
    {
    *pi =  - 1 ;
    return ECHEC ;
    }
*pi =  - 1 ;
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL CoincidePointLigne ( TCoordonnee M, ligne_AB *sAB, BOOL *pfErreur )
{
TVecteur  vA(Cv_TCoordonnee(sAB -> A)), vB(Cv_TCoordonnee(sAB -> B))
  , vM (M) ;
TDroite   drAB (vA, vB) ;
float     xAbsc, xDist ;

if ( !sAB -> lg ) 
  
  // Calcul de la longueur en cas d'lg non calcul.
  sAB -> lg =  Cv_TLigne(*sAB).Longueur();
if ( !sAB -> lg ) 
  
  // A=B
  return (M == Cv_TCoordonnee(sAB -> A));
else 
  
  // A != B
  xAbsc =  ((vB - vA) * (vM - vA)) / sAB -> lg ;
if ( (xDist = drAB.Distance(vM)) == MAXFLOAT ) 
  return !(*pfErreur = !MErreur("Echec  la concidence de la ligne.", 809));
*pfErreur =  FAUX ;
if ( xDist <= 1.1 && xAbsc >= - 1.1 && xAbsc <= sAB -> lg + 1.1 ) 
  return VRAI ;
else 
  return FAUX ;
}

/*-------------------------------------------------------------*/
/*
   char CoincidePointLigne_v(TPoint M, ligne_AB sAB, BIT *pfErreur)
     {
     vecteur sxyA, sxyB, sxyM;
     triplet sxyDroite_AB;
     float xyAbsc, xyDist;
   
     sxyA=Cv_2ReelsVecteur(sAB.A.x,sAB.A.y);
     sxyB=Cv_2ReelsVecteur(sAB.B.x,sAB.B.y);
     sxyM=Cv_2ReelsVecteur(M.y, M.x);
     xyAbsc=ProdScal(Cv_2PointsVecteur(sxyA,sxyB),Cv_2PointsVecteur(sxyA,sxyM));
     if (!sAB.lg)
       return *pfErreur=FAUX;
     else
       xyAbsc=xyAbsc/sAB.lg;
     if (!Droite2pts(sxyA, sxyB, &sxyDroite_AB))
       return !(*pfErreur=!MErreur("Grave echec  la recherche de la ligne.",807));
     if (!DistanceCarreePointDroite(sxyM, sxyDroite_AB, &xyDist))
       return !(*pfErreur=!MErreur("Grave echec  la recherche de la ligne.",809));
     *pfErreur=FAUX;
     return xyDist<=1.1 && xyAbsc >= -1.1 && xyAbsc <= sAB.lg+1.1;
     }
   */
/*-------------------------------------------------------------*/
BOOL AncienneRestaurationJointiveLignesGTTSI ()
{
unsigned char uSeuilRaccordementCarre=uSeuilRaccordement * uSeuilRaccordement;
unsigned int  wi, wj, wDM ;
unsigned long wDistCar = 0, wMinDistCar ;
uCoordonnee   sMilieu ;

for ( wi = 0 ; wi < wNbl ; wi++ ) 
  {
  wMinDistCar =  2L * SIZE_OF_PICTURES * SIZE_OF_PICTURES ;
  for ( wj = 0 ; wj < wNbl ; wj++ ) 
    
    // Recherche du noeud le plus proche
    if ( wi != wj
          && (wDistCar
              = TVecteur(Cv_TCoordonnee(algnTableLignes [wi].B))
                .DistanceCarree(
                TVecteur(Cv_TCoordonnee(algnTableLignes [wj].A))))
            < wMinDistCar ) 
      {
      wDM         =  wj ;
      wMinDistCar =  wDistCar ;
      }
  if ( wMinDistCar && wMinDistCar <= uSeuilRaccordementCarre ) // Raccordement si suffisdament proche.
                                                                {
  sMilieu
    =  Cv_uCoordonnee(
      (TVecteur(Cv_TCoordonnee(algnTableLignes [wi].B))
          + TVecteur(Cv_TCoordonnee(algnTableLignes [wDM].A)))
        / 2.0);                                                 
  algnTableLignes [wi].B =  sMilieu ;                           
  algnTableLignes [wDM].A =  sMilieu ;                          
  algnTableLignes [wi].lg =  algnTableLignes [wj].lg = 0 ;      
                                                                }
  }
return SUCCES ;
}

/*--------------------------------------------------------------------------------------------------------------------------*/
BOOL RestaurationJointiveLignesGTTSI ()

//  Jonction des Normales et parallles uniquement
{
unsigned char uSeuilRaccordementCarre=uSeuilRaccordement * uSeuilRaccordement;

unsigned int  wi, wj, wDM ;
unsigned long dwDistCar = 0, dwMinDistCar ;
uCoordonnee   sMilieu ;
char          *pfLinkedLines = (char *)malloc(wNbl);

memset(pfLinkedLines, 0, wNbl);
for ( wi = 0 ; wi < wNbl ; wi++ ) 
  {
  dwMinDistCar =  2L * SIZE_OF_PICTURES * SIZE_OF_PICTURES ;
  for ( wj = 0 ; wj < wNbl ; wj++ ) 
    
    // Recherche du noeud le plus proche
    if ( wi != wj
          && (dwDistCar
              = TVecteur(Cv_TCoordonnee(algnTableLignes [wi].B))
                .DistanceCarree(
                TVecteur(Cv_TCoordonnee(algnTableLignes [wj].A))))
            < dwMinDistCar
          && !pfLinkedLines [wj] ) // La ligne ne doit pas dj avoir t raccorde.
                                    {
                                    wDM =  wj ;
                                    dwMinDistCar =  dwDistCar ;
                                    }
  TVecteur  xyLigneProche (Cv_TLigne(algnTableLignes [wDM]))
    , xyCetteLigne (Cv_TLigne(algnTableLignes [wi])) ;
  if ( !dwMinDistCar ) 
    pfLinkedLines [wDM] =  TRUE ; // Si la plus proche est une ligne jointe, on mmorise cette jonction afin que wj ne soit pas dtourne par un autre raccordement avec une ligne plus courte que wi.
  else if ( dwMinDistCar <= uSeuilRaccordementCarre )
    {
    
    /* Obsolte:
       float xca=cosAngle(xyCetteLigne,xyLigneProche),
             ysa=sinAngle(xyCetteLigne,xyLigneProche);
            */
    /* Nouvelle version:
       Test R0: l'angle a est proche de 0;
       Test R9: l'angle a est proche de 90
       Seuils:
         SR0 et tan(SR0): xSeuil_tanEcartAngulaireRaccordement0
         SR9 et tan(SR9): xSeuil_tanEcartAngulaireRaccordement90
       Note: Il est recommand de prendre SR0 le seuil dangle plat  compris
       strictement entre 0 et 45;  SR9 le seuil dangle droit compris
       strictement entre 45 et 90, car ces pour ces valeurs qu'a t faite la
       dmonstration. En particulier, Ni SR0 ni SR9 ne doivent valoir 90.
       tant donn que les seules valeurs connues dans le programme sont les tangentes
       de ces angles, le problme ne se pose pas (sauf ventuellement dpassement de
       capacit lors de la multiplication (x1x2+y1y2) tan(SR0) ou |x1x2+y1y2| tan(SR9)
       (attraper l'interruption dans ce cas).

       Validation:
         Test R0:
                         |a| <= SR0 <=> |x1y2-x2y1| <= (x1x2+y1y2) tan(SR0)
         Test R9:
             180-SR9 <= |a| <= SR9 <=> |x1y2-x2y1| >= |x1x2+y1y2| tan(SR9)
         Pour raliser ce calcul, nous utilisons
           Le produit vectoriel Li^Lj= x1y2-x2y1
           Le produit scalaire  Li.Lj= x1x2+y1y2
         Note, pour le test R0, le signe d'Li.Lj est important.
                                le signe d'Li^Lj n'est pas important.
         Ralisation du test:
           Variables: xPScal=Li.Lj, yPVecto=Li^Lj
           Jonction si:
             (fabs(yPVecto) >= fabs(xPScal) * xSeuil_tanEcartAngulaireRaccordement90) || // Test R9
             xPScal>0 && fabs(yPVecto) <= xPScal * xSeuil_tanEcartAngulaireRaccordement0 // Test R0
             ^^^^^^ <- raccourci pour viter la multiplication si xPScal<0.
       
       */
    float xPScal = xyCetteLigne * xyLigneProche
      , //ProduitScalaire (inline)
        yPVecto = xyCetteLigne ^ xyLigneProche ; // ProduitVectoriel (inline)
    if ( (fabs(yPVecto)
            >= fabs(xPScal) * xSeuil_tanEcartAngulaireRaccordement90)
          || // Test R9
             (xPScal > 0
                && fabs(yPVecto)
                  <= xPScal * xSeuil_tanEcartAngulaireRaccordement0) )
      {
      
      // Test R0
      /* Obsolte:
         
         (fabs(ysa)> // Test angles.
             xSeuil_sinEcartAngulaireRaccordementOrthogonal ||
          xca>xSeuil_cosEcartAngulaireRaccordementParallele )
              */
      // Raccordement si suffisament proche.
      // Pas d'"fabs" dans le cas parallle (angle 180 refus).
      sMilieu                 
        =  Cv_uCoordonnee(
          (TVecteur(Cv_TCoordonnee(algnTableLignes [wi].B))
              + TVecteur(Cv_TCoordonnee(algnTableLignes [wDM].A)))
            / 2.0);
      algnTableLignes [wi].B  =  sMilieu ;
      algnTableLignes [wDM].A =  sMilieu ;
      algnTableLignes [wi].lg =  algnTableLignes [wDM].lg = 0 ; // Faon de dire que cette valeur n'est pas renseigne
      pfLinkedLines [wDM]     =  TRUE ; // Interdire  wj de se faire raccorder par un autre
      }
    }
  }
free(pfLinkedLines);
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL RetablissementLongueursLignesGTTSI ()
{
unsigned int  wi ;

for ( wi = 0 ; wi < wNbl ; wi++ ) 
  if ( !algnTableLignes [wi].lg ) 
    algnTableLignes [wi].lg =  Cv_TLigne(algnTableLignes [wi]).Longueur();
return SUCCES ;
}

/*-------------------------------------------------------------*/
BOOL RestaurationUnificatriceLignesGTTSI ( unsigned int &wNbElim )
{
TVecteur      u, v ;
float         uv_cos, uv_sin ;
unsigned int  wi, wj ;

wNbElim =  0 ;
for ( wi = 0 ; wi < wNbl ; wi++ ) 
  {
  for ( wj = 0 ; wj < wNbl ; wj++ ) 
    if ( wi != wj && algnTableLignes [wi].B == algnTableLignes [wj].A ) 
      {
      u      =  TVecteur(Cv_TLigne(algnTableLignes [wi]));
      v      =  TVecteur(Cv_TLigne(algnTableLignes [wj]));
      uv_cos =  u * v ;
      uv_sin =  u ^ v ;
      if ( uv_cos > 0
            && fabs(uv_sin) / uv_cos < xSeuil_tanEcartangulaireUnification ) 
        {
        
        // Supprimmer la ligne wi, allonger la wj.
        algnTableLignes [wj].A  =  algnTableLignes [wi].A ;
        algnTableLignes [wi].A  =  algnTableLignes [wi].B ;
        algnTableLignes [wi].lg =  algnTableLignes [wj].lg = 0 ;
        wNbElim++ ;
        break ;
        }
      }
  }
return SUCCES ;
}

/*-------------------------------------------------------------*/
// Le symbole renvoye a le point A sur l'intersection des deux lignes.
BOOL AnalyseLignesRechercheSymbole ( TQuadrilatere *pqSymbole
    , unsigned int *pwFirst, unsigned int *pwSecond )
{
if ( !pqSymbole ) 
  return MErreur("Pointeur nul.", 1106);

TCoordonnee   C ;
unsigned int  wi = 0, wj = 0 ;

for ( wi = 0 ; wi < wNbl ; wi++ ) 
  if ( AnalyseSupportSymbole(wi, wj /* Passage par ref. */ ) )
    {
    *pwFirst  =  wi ;
    *pwSecond =  wj ;
    TLigne  AB = Cv_TLigne(algnTableLignes [wi])
      , BC = Cv_TLigne(algnTableLignes [wj]);
    
    //      pqSymbole->Set(AB.A,AB.B,BC.B,AB.A+(BC.B-BC.A));
// Le premier point est l'angle du quand:
    pqSymbole -> Set(BC.A, BC.B, AB.A + (BC.B - BC.A), AB.A);
    
    //      Trace("Appel d'AnalyseSymboleDetecte, symbole: ",*pqSymbole,1184);
    return SUCCES ;
    }
*pqSymbole =  QuadrilatereErreur ;
return SUCCES ;
}

int IsAuthorizedLink ( unsigned int wi, unsigned int wj )
{
#if TryPassBugMmgr
return !Contains(plptForbidenLink, TPoint(wi, wj));
#else 
return TRUE ;
#endif
}

void AuthorizeLink ( unsigned int wi, unsigned int wj, int f )
{
#if TryPassBugMmgr

TPoint  ptLink (wi, wj) ;

if ( f ) 
  
  // Set to yes
  plptForbidenLink -> Detach(ptLink);
else // Set to NO
     if ( !Contains(plptForbidenLink, ptLink) ) 
      plptForbidenLink -> Add(ptLink);
#else 
return ;
#endif
}

void AuthorizeLink ()
{
#if TryPassBugMmgr
plptForbidenLink -> Flush();
#endif
}

BOOL AnalyseSupportSymbole ( unsigned int wi, unsigned int &wj )
{

// Ncessite des longueur connues .lg.
//  unsigned int wk;
float     xyk ;
TLigne    AB = Cv_TLigne(algnTableLignes [wi]), BC ;
TVecteur  vAB (AB), vB=TVecteur(AB.B) ;

if ( AB.lg < wSeuil_TailleMinimaleSymbole ) // (def: 10)
  return FAUX ;
for ( wj = 0 ; wj < wNbl ; wj++ )
  {
  BC =  Cv_TLigne(algnTableLignes [wj]);
  TVecteur vBC=TVecteur(BC);
  //                    #if 1
  if ( BC.A == AB.B
        && (xyk = (float)BC.lg / AB.lg) < xSeuilRapportDeLongueursMaxSymbole
        && xyk > 1.0/xSeuilRapportDeLongueursMaxSymbole
        && wj != wi
        && fabs(vAB * vBC / BC.lg / AB.lg)
          < xSeuil_cosEcartAngulaireSymbole
        && TVecteur(BC.B).DroiteOuGaucheDroite(TVecteur(AB.A), vB)
          == DROITE // Confirme que C (BC.B) est  droite de l'axe orient (A, A->B)
        && IsAuthorizedLink(wi, wj)
        && rImage.Contains(TCoordonnee(vB-vAB+vBC)) // Vrifie que le coin d'horloge nominal D (D=B+vecteur BA + vecteur BC) est dans l'image
        )

    /*                    #else
       //    Trace("RS, wj=",wj,1116);
           BOOL fT0= BC.A==AB.B &&
               (xyk=(float)BC.lg/AB.lg) > SEUIL_RAPPORT_LONGUEUR_COTE_MIN &&
               xyk < SEUIL_RAPPORT_LONGUEUR_COTE_MAX &&
               wj != wi &&
                       IsAuthorizedLink(wi,wj);

           BOOL fT1=FAUX, fT2=FAUX;
           if (fT0)
             {
             float xProdScal=vAB*TVecteur(BC);
             float x_cosEcartAngulaire=xProdScal/BC.lg/AB.lg;
             float xVAcosEcartAngulaire=fabs(x_cosEcartAngulaire);
             float xVAcosEcartAngulaire2=fabs(vAB*TVecteur(BC)/BC.lg/AB.lg);
             fT1=xVAcosEcartAngulaire2< xSeuil_cosEcartAngulaireSymbole;
             if (fT1) fT2=TVecteur(BC.B).DroiteOuGaucheDroite
                 (TVecteur(AB.A),TVecteur(AB.B))==DROITE;
             }
           if ( fT0 && fT1 && fT2)
       #endif
       */
    return VRAI ; // wj pointe sur la seconde ligne.
  }
return FAUX ;
}

/*
   int ListeFastClasseArctan(float *aAngles, unsigned char *aClasses, unsigned int wNbAngles, unsigned int wPartitionUser)
   {
   unsigned int i;
   if (!aAngles)
     return MErreur("Table non alloues",1153);
   else if (!InitialiseObjetsContours(wPartitionUser))
     return MErreur("Initialisation des donnes de contour impossible",1155);
   else
     for (i=wNbAngles; i;i--)
       *aClasses++ =FastClasseArctan(NFarRoundR(cos(*aAngles)*1000.0),
                                    NFarRoundR(sin(*aAngles++)*1000.0));
   return SUCCES;
   }
                       */
BOOL RemplaceBord ( unsigned char *puImage )
{
int i, j = 0 ;

if ( !puImage || SIZE_OF_PICTURES != 256 ) 
  return MErreur("Echec dans RemplaceBord");

// Annulation des effets de bords
for ( i = 0 ; i < 256 ; i++ ) 
  {
  j                                 += 256 ;
  puImage [i]                       =  puImage [i + 256]; // haut: copie de la valeur de la lignes d'aprs
  puImage [(int)((long)i + 65280L)] =  puImage [(int)((long)i + 65024L)]; // bas
  puImage [j]                       =  puImage [j + 1]; // gauche
  puImage [j + 255]                 =  puImage [j + 254]; // droite
  }
return SUCCES ;
}

/* Procdure rcursive ddie  l'limination des bords.
   
    Le bord uLB est le carr concentrique  l'image tel que les bandes de pixels hors de ce
    carr font une largeur d'uLB pixels.
   La bord uLB de l'image
   est remplac par le bord uLB+1.
   
                       */
BOOL RemplaceNBord ( unsigned char *puImage
    , unsigned char uLB /* uLargeurBord */ )
{
if ( !uLB ) 
  return SUCCESS ;
else if ( uLB == 1 ) 
  return RemplaceBord(puImage);
else if ( uLB > 127 ) 
  return MErreur("Bord trop large dans RemplaceNBord");
if ( !puImage ) 
  return MErreur("Echec dans RemplaceNBord");

const unsigned int  N = SIZE_OF_PICTURES ;

for ( unsigned int k = uLB ; k < N - uLB ; k++ ) 
  {
  puImage [(unsigned int)uLB * N + k - N]           
    =  puImage [(unsigned int)uLB * N + k]; // Recopie vers le haut (-N).
  puImage [(unsigned int)k * N + uLB - 1]           
    =  puImage [(unsigned int)k * N + uLB]; // Recopie vers la gauche (-1).
  puImage [(unsigned int)(N - uLB - 1) * N + k + N] 
    =  puImage [(unsigned int)(N - uLB - 1) * N + k]; // Recopie vers le bas (+N).
  puImage [(unsigned int)k * N + N - uLB]           
    =  puImage [(unsigned int)k * N + N - uLB - 1]; // Recopie vers la droite (+1).
  }
puImage [(unsigned int)uLB * N + uLB - N - 1]                   
  =  puImage [(unsigned int)uLB * N + uLB]; // Recopie HG
puImage [(unsigned int)uLB * N + N - uLB - 1 - N + 1]           
  =  puImage [(unsigned int)uLB * N + N - uLB - 1]; // Recopie HD
puImage [(unsigned int)uLB * N + N - uLB - 1 - 1 + N]           
  =  puImage [(unsigned int)uLB * N + N - uLB - 1]; // Recopie BG
puImage [(unsigned int)(N - uLB - 1) * N + N - uLB - 1 + N + 1] 
  =  puImage [(unsigned int)(N - uLB - 1) * N + N - uLB - 1]; // Recopie BD
return RemplaceNBord(puImage, uLB - 1);
}

BOOL RemplaceBord ( unsigned char *puImage, unsigned char uValeurBord )
{
int i, j = 0 ;

if ( !puImage || SIZE_OF_PICTURES != 256 ) 
  return MErreur("Echec dans RemplaceBord");

// Annulation des effets de bords
for ( i = 0 ; i < 256 ; i++ ) 
  {
  j                                 += 256 ;
  puImage [i]                       =  uValeurBord ; // haut
  puImage [(int)((long)i + 65280L)] =  uValeurBord ; // bas
  puImage [j]                       =  uValeurBord ; // gauche
  puImage [j + 255]                 =  uValeurBord ; // droite
  }
return SUCCES ;
}

// Ne vrifie pas que les points sont bien Intra-muros.
int EstimateurPixelCoin ( unsigned char *puImage, TPoint pt, int iSeuil
    , unsigned char uDroit )
{
return uDroit ? 
     EstimateurPixelCoinDroit(puImage, pt, iSeuil)
  : EstimateurPixelCoinOblique(puImage, pt, iSeuil);
}

int EstimateurPixelCoinDroit ( unsigned char *puImage, TPoint pt
    , int iSeuil )
{
return NReduceN(
    abs(ConvolutionLocale(puImage, pt, - 1, - 1, - 1, 0, 0, 0, 1, 1, 1)), 0
    , iSeuil)
  + NReduceN(
    abs(ConvolutionLocale(puImage, pt, 1, 0, - 1, 1, 0, - 1, 1, 0, - 1)), 0
    , iSeuil);
}

int EstimateurPixelCoinOblique ( unsigned char *puImage, TPoint pt
    , int iSeuil )
{
return NReduceN(
    abs(ConvolutionLocale(puImage, pt, - 1, - 1, 0, - 1, 0, 1, 0, 1, 1)), 0
    , iSeuil)
  + // Compass NW
    NReduceN(
      abs(ConvolutionLocale(puImage, pt, 0, 1, 1, - 1, 0, 1, - 1, - 1, 0)), 0
      , iSeuil); // Compass SW
}

BOOL EstimateurImageCoinDroit ( unsigned char *puS, int iSeuils
    , unsigned char *puC )
{
return EstimateurImageCoin(puS, iSeuils, puC, DROIT);
}

BOOL EstimateurImageCoinOblique ( unsigned char *puS, int iSeuils
    , unsigned char *puC )
{
return EstimateurImageCoin(puS, iSeuils, puC, OBLIQUE);
}

BOOL EstimateurImageCoin ( unsigned char *puS, int iSeuils
    , unsigned char *puC, unsigned char uDroit )
{
if ( uDroit ) 
  {
  for ( unsigned int i = 1 ; i < SIZE_OF_PICTURES - 1 ; i++ ) 
    for ( unsigned int j = 1 ; j < SIZE_OF_PICTURES - 1 ; j++ ) 
      puC [i * SIZE_OF_PICTURES + j]
        =  EstimateurPixelCoinDroit(puS, TPoint(j, i), iSeuils)
          >= iSeuils * 2 ? 
             255
          : 0 ;
  //                NReduceN(EstimateurPixelCoin(puS,TPoint(j,i),iSeuils),0,255);
  }
else 
  {
  for ( unsigned int i = 1 ; i < SIZE_OF_PICTURES - 1 ; i++ ) 
    for ( unsigned int j = 1 ; j < SIZE_OF_PICTURES - 1 ; j++ ) 
      puC [i * SIZE_OF_PICTURES + j]
        =  EstimateurPixelCoinOblique(puS, TPoint(j, i), iSeuils)
          >= iSeuils * 2 ? 
             255
          : 0 ;
  //                NReduceN(EstimateurPixelCoin(puS,TPoint(j,i),iSeuils),0,255);
  }
return RemplaceBord(puC, 0);
}

/* RecaleSurCoin (Recale sur coin)
     Recale le coin C loin du triangle BAC. Pour cela, on estime la somme des
   distances CB et CD.
   */
BOOL RecaleSpecifiqueDernierCoin ( TQuadrilatere *pqABCD
    , unsigned char uTailleNoyau, unsigned char *puImage
    , int iSeuilSaturation, unsigned char uDroit )
{
if ( !pqABCD || !puImage ) 
  return MErreur("Pointeur creux.", 1247);

//  TPoint ptCoin();
/*
   int iMaxEstimateur=EstimateurPixelCoin(puImage,pqABCD->D,iSeuilSaturation),
       iEstimateur; */
//  unsigned int wNpPointsPossibles=(uTailleNoyau+1)^2, wNpPoints=0;
/*  TCoordonnee *aptListeCoinsPossibles=(TCoordonnee *)malloc
       (wNpPointsPossibles);
   unsigned int *awListeCriteresDistance=(unsigned int *)malloc
       (wNpPointsPossibles), */
unsigned int  wDistance
  , wMaxDistance
    = (unsigned int)(pqABCD -> C.DistanceCarree(pqABCD -> B)
      + pqABCD -> C.DistanceCarree(pqABCD -> D));
int           ix0 = pqABCD -> C.x - uTailleNoyau
  , ixf = pqABCD -> C.x + uTailleNoyau, iy0 = pqABCD -> C.y - uTailleNoyau
  , iyf = pqABCD -> C.y + uTailleNoyau ;
int           x, y ;
TPoint        p ;

for ( x = ix0 ; x <= ixf ; x++ ) 
  for ( y = iy0 ; y <= iyf ; y++ ) 
    if ( x >= 1 && x <= 254 && y >= 1 && y <= 254 ) /* Limites pour le masquage. */ 
                                                      {
                                                      p.x =  x ;
                                                      p.y =  y ;
  if ( EstimateurPixelCoin(puImage, p, iSeuilSaturation, uDroit)
        >= 2 * iSeuilSaturation ) 
    {
    wDistance
      =  (unsigned int)(pqABCD -> B.DistanceCarree(p)
        + pqABCD -> D.DistanceCarree(p));
    if ( wDistance > wMaxDistance ) 
      {
      pqABCD -> C  =  p ;
      wMaxDistance =  wDistance ;
      }
    }                                                 
                                                      }
return SUCCES ;
}

/* Dcale les points B et D du quadrilatere vers des coins vers l'exterieur
   de celui-ci.
     On considere que le quadrilatere est dcrit de manire trigonomtrique.
   */
BOOL RecaleSpecifiqueCoinCote ( TQuadrilatere *pqABCD
    , unsigned char uNoCoin, unsigned char uTailleNoyau
    , unsigned char *puImage, int iSeuilSaturation, unsigned char uDroit ) // uNoCoin = 2 -> recalage de B vers la droite de la ligne oriente AB.
                                                                          // uNoCoin = 4 -> recalage de D vers la gauche de la ligne oriente AD.
{
if ( !pqABCD || !puImage || (uNoCoin != 2 && uNoCoin != 4) ) 
  return MErreur("Pointeur creux ou erreur code", 1305);

// Point autour duquel se fait le balayage.
/* 2 -> B  droite => on cherche la dist. algbrique la plus leve entre B et
   la droite oriente (AB). */
// 4 -> D  gauche => on cherche la dist. algbrique la plus ngative
// Pour un repre classique inverse d'un repre d'image.
char        cSigneCorectif = uNoCoin == 2 ? 1 : - 1 ;
TCoordonnee *pptAncrage(uNoCoin == 2 ? &(pqABCD -> B) : &(pqABCD -> D));

// Droite de rfrence pour savoir si on est  droite o  gauche :
//  TDroite drMaitraisse(A,ptAncrage);
TVecteur    vA(pqABCD -> A), vAncrage(*pptAncrage);
float       xDistance, xMaxDistance = - MAXFLOAT ;

//  =NFarRoundR(drMaitraisse.Distance(ptAncrage));
int         ix0 = pptAncrage -> x - uTailleNoyau
  , ixf = pptAncrage -> x + uTailleNoyau
  , iy0 = pptAncrage -> y - uTailleNoyau
  , iyf = pptAncrage -> y + uTailleNoyau ;
int         x, y ;
TPoint      p ;

for ( x = ix0 ; x <= ixf ; x++ ) 
  for ( y = iy0 ; y <= iyf ; y++ ) 
    if ( x >= 1 && x <= 254 && y >= 1 && y <= 254 ) /* Limites pour le masquage. */ 
                                                      {
                                                      p.x =  x ;
                                                      p.y =  y ;
  if ( EstimateurPixelCoin(puImage, p, iSeuilSaturation, uDroit)
        >= 2 * iSeuilSaturation ) 
    {
    
    /* La distance renvoyee est algbrique positive pour le point  droite de la
       droite oriente dans un repre classique, c'est  dire invers par rapport  un
       repre d'image.
         Donc, pour D, on cherche le point le plus  gauche sur l'image, et donc la
       distance la plus ngative. Ce point apparatra a droite sur l'image.
       */
    xDistance
      =  TVecteur(p).DistanceCarreeAlgebriqueDroite(vA, vAncrage)
        * cSigneCorectif ;
    
    // cSigneCorectif positif pour le point  droite (pas de correction).
    if ( xDistance > xMaxDistance ) 
      {
      pptAncrage -> Set(p);
      xMaxDistance =  xDistance ;
      }
    }                                                 
                                                      }
return SUCCES ;
}

BOOL RecaleSurCoin ( TCoordonnee *pptM, unsigned char uTailleNoyau
    , unsigned char *puImage, int iSeuilSaturation )
{
if ( !pptM || !puImage ) 
  return MErreur("Pointeur creux.", 1247);

//  TPoint ptCoin();
int     iMaxEstimateur
    = EstimateurPixelCoinDroit(puImage, *pptM, iSeuilSaturation)
      + EstimateurPixelCoinOblique(puImage, *pptM, iSeuilSaturation)
  , iEstimateur ;
int     ix0 = pptM -> x - uTailleNoyau, ixf = pptM -> x + uTailleNoyau
  , iy0 = pptM -> y - uTailleNoyau, iyf = pptM -> y + uTailleNoyau ;
int     x, y ;
TPoint  p ;

for ( x = ix0 ; x <= ixf ; x++ ) 
  for ( y = iy0 ; y <= iyf ; y++ ) 
    if ( x >= 1 && x <= 254 && y >= 1 && y <= 254 )
/* Limites pour le masquage. */
                                                      {
                                                      p.x         =  x ;
                                                      p.y         =  y ;
  iEstimateur
    =  EstimateurPixelCoinDroit(puImage, p, iSeuilSaturation)
      + EstimateurPixelCoinOblique(puImage, p, iSeuilSaturation);
  if ( iEstimateur > iMaxEstimateur ) 
    {
    pptM -> x      =  x ;
    pptM -> y      =  y ;
    iMaxEstimateur =  iEstimateur ;
    }                                                 
                                                      }
return SUCCES ;
}

BOOL RecaleSurCoins ( TQuadrilatere *ABCD, int iSeuilSaturation
    , unsigned char uTailleNoyau, unsigned char *puImage )
{
return RecaleSurCoin(&(ABCD -> A), uTailleNoyau, puImage, iSeuilSaturation)
        && RecaleSurCoin(&(ABCD -> B), uTailleNoyau, puImage
          , iSeuilSaturation)
        && RecaleSurCoin(&(ABCD -> C), uTailleNoyau, puImage
          , iSeuilSaturation)
        && RecaleSurCoin(&(ABCD -> D), uTailleNoyau, puImage
          , iSeuilSaturation);
}

/* Pour un quadrilatere ABCD reconnu comme porteur de symbole, avec A fixe 
   l'intersection des deux lignes.
     RecaleSpecifiqueSurCoins recale B et D loin du centre du symbole dans la
   direction normale  leur ct d'avec A, et recale C loin du triangle DAB.
   */
BOOL RecaleSpecifiqueSurCoins ( TQuadrilatere *pABCD, int iSeuilSaturation
    , unsigned char uTailleNoyau, unsigned char *puImage
    , unsigned char uDroit )
{
pABCD -> FlipParcoursTrigo();
return RecaleSpecifiqueCoinCote(pABCD, 2, uTailleNoyau, puImage
        , iSeuilSaturation, uDroit) // B  droite
       && RecaleSpecifiqueCoinCote(pABCD, 4, uTailleNoyau, puImage
          , iSeuilSaturation, uDroit) // D  gauche
       && RecaleSpecifiqueDernierCoin(pABCD, uTailleNoyau, puImage
          , iSeuilSaturation, uDroit);
}

/* Pour un quadrilatere ABCD reconnu comme porteur de symbole, avec A fixe 
   l'intersection des deux lignes.
     RecaleSpecifiqueHeliophobeCoins recale B, C  D dans la direction oppose au
   centre du symbole.
   */
BOOL RecaleSpecifiqueHeliophobeCoins ( TQuadrilatere *pABCD
    , int iSeuilSaturation, unsigned char uTailleNoyau
    , unsigned char *puImage, unsigned char uDroit )
{
TVecteur  xyCentre = pABCD -> Centre();

return RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> B)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit)
        && RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> C)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit)
        && RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> D)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit);
}

BOOL RecaleSpecifiqueHeliophobe4Coins ( TQuadrilatere *pABCD
    , int iSeuilSaturation, unsigned char uTailleNoyau
    , unsigned char *puImage, unsigned char uDroit )
{
TVecteur  xyCentre = pABCD -> Centre();

return RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> B)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit)
        && RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> A)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit)
        && RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> C)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit)
        && RecaleSpecifiqueHeliophobeUnCoin(xyCentre, &(pABCD -> D)
          , uTailleNoyau, puImage, iSeuilSaturation, uDroit);
}

/* Dcale les points B et D du quadrilatere vers des coins vers l'exterieur
   de celui-ci.
     On considere que le quadrilatere est dcrit de manire trigonomtrique.
   
   
     Chaque point est dcal en prenant parmis le voisinage le pixel de
   coignature suffisante le plus loign du centre.
   */
BOOL RecaleSpecifiqueHeliophobeUnCoin ( TVecteur xyCentre
    , TCoordonnee *pptM, unsigned char uTailleNoyau, unsigned char *puImage
    , int iSeuilSaturation, unsigned char uDroit )
{
if ( !puImage ) 
  return MErreur("Pointeur creux ou erreur code", 1305);

float   xDistance, xMaxDistance = - MAXFLOAT ;

//  =NFarRoundR(drMaitraisse.Distance(ptAncrage));
int     ix0 = pptM -> x - uTailleNoyau, ixf = pptM -> x + uTailleNoyau
  , iy0 = pptM -> y - uTailleNoyau, iyf = pptM -> y + uTailleNoyau ;
int     x, y ;
TPoint  p ;

/*
   Dans un certain voisinage, on prend le pixel de coignature suffisante
   le plus loign du centre.
   
                       */
for ( x = ix0 ; x <= ixf ; x++ ) 
  for ( y = iy0 ; y <= iyf ; y++ ) 
    if ( x >= 1 && x <= 254 && y >= 1 && y <= 254 ) /* Limites pour le masquage. */ 
                                                      {
                                                      p.x =  x ;
                                                      p.y =  y ;
  if ( EstimateurPixelCoin(puImage, p, iSeuilSaturation, uDroit)
        >= 2 * iSeuilSaturation ) 
    {
    xDistance =  TVecteur(p).DistanceCarree(xyCentre);
    
    // cSigneCorectif positif pour le point  droite (pas de correction).
    if ( xDistance > xMaxDistance ) 
      {
      pptM -> Set(p);
      xMaxDistance =  xDistance ;
      }
    }                                                 
                                                      }
return SUCCES ;
}

void RechercheCoins ( TQuadrilatere Depart, unsigned char *pImage
    , TQuadrilatere *Arrivee, char Recul )
{
int         i, j, k, l, TestX, TestY ;
long int    Offset ;
char        TestDx, TestDy, swap, Found ;
double      CosAlpha ;
TVecteur    Coin1, Coin2 ;
TCoordonnee Sommets [2][5];

Sommets [0][0] =  Depart.A ;
Sommets [0][1] =  Depart.B ;
Sommets [0][2] =  Depart.C ;
Sommets [0][3] =  Depart.D ;
Sommets [0][4] =  Depart.A ;
for ( j = 0 ; j < 4 ; j++ ) 
  {
  CosAlpha
    =  (double)(Sommets [0][j + 1].x - Sommets [0][j].x)
      / sqrt(Sommets [0][j].DistanceCarree(Sommets [0][j + 1]));
  if ( CosAlpha < - 0.92388 ) 
    {
    TestDx =  1 ;
    TestDy =  - 1 ;
    }
  else if ( CosAlpha < - 0.38268 ) 
    {
    TestDx =  1 ;
    TestDy =  0 ;
    }
  else if ( CosAlpha < 0.38268 ) 
    {
    TestDx =  1 ;
    TestDy =  1 ;
    }
  else if ( CosAlpha < 0.92388 ) 
    {
    TestDx =  0 ;
    TestDy =  1 ;
    }
  else 
    {
    TestDx =  - 1 ;
    TestDy =  1 ;
    }
  if ( Sommets [0][j + 1].y > Sommets [0][j].y ) 
    {
    swap   =  TestDx ;
    TestDx =  - TestDy ;
    TestDy =  - swap ;
    }
  TestX =  NUpRoundR(Sommets [0][j + 1].x) - Recul * TestDx ;
  TestY =  NUpRoundR(Sommets [0][j + 1].y) - Recul * TestDy ;
  TestX =  max(1, TestX);
  TestY =  max(1, TestY);
  TestX =  min(254, TestX);
  TestY =  min(254, TestY);
  i     =  1 ;
  Found =  0 ;
  do 
    {
    for ( k = - i ; k < (i + 1) ; k++ ) 
      {
      Offset =  TestX + k * TestDy + ((TestY - k * TestDx) << 8);
      if ( pImage [(unsigned int)Offset] ) 
        {
        for ( l = i ; l > k ; l-- ) 
          if ( pImage [TestX + l * TestDy + ((TestY - l * TestDx) << 8)] ) 
            {
            Found =  1 ;
            break ;
            }
        break ;
        }
      else 
        {
        if ( pImage [(unsigned int)Offset + 1] ) 
          {
          for ( l = i ; l > k ; l-- ) 
            if ( pImage [
                  TestX + l * TestDy + ((TestY - l * TestDx) << 8) + 1] ) 
              {
              Found =  2 ;
              break ;
              }
          break ;
          }
        }
      }
    i++ ;
    TestX += TestDx ;
    TestY += TestDy ;
    } 
  while ( !Found );
  l              =  (l + k) / 2 ;
  Sommets [1][j] 
    =  TCoordonnee(TestX + l * TestDy + Found - 1, TestY - l * TestDx);
  }
Arrivee -> A =  Sommets [1][0];
Arrivee -> B =  Sommets [1][1];
Arrivee -> C =  Sommets [1][2];
Arrivee -> D =  Sommets [1][3];
}

//---------
BOOL RecursiveChercheChainage ( TCoordonnee p, unsigned char uSensDirect ) // TPoint (j,i)
{

//  unsigned int i=p.x, j=p.y;
TCoordonnee   vA, vB, vC, vChain ;
unsigned int  wN = p.y * SIZE_OF_PICTURES + p.x ;
int           fChaine = VRAI ;
unsigned char dA, dB, dC, dChain, uDirectionContourCourante ;

exploration [wN] |= CTR_Exploration ; /* Forcage  1 du LSB d'exploration[n]. */ 
#if SwitchManyCheckers
if ( !Numeroplan(chainage) ) 
  return Erreur("Mauvais plan en n=", wN, 655);
#endif
/*
    "direction" reprsente la direction telle que 256 code 360 et 0 code 0
   (quel que soit le nombre de classe utilis multiple de 8), et malgr
   l'imprcision sur l'LSB.
     256 fait 360
     128 fait 180
     64 fait   90.     CTR_Exploration=0x01
     direction[wN] & ~CTR_Exploration : filtre l'LSB et rend la direction paire.
     (direction[wN] & ~CTR_Exploration)+64 ajoute 90
     (direction[wN] & ~CTR_Exploration)-64 ajoute 90 puis retranche 180): chanage  rebours.
     */
uDirectionContourCourante
  =  (direction [wN] & ~CTR_Exploration) + (uSensDirect ? 64 : - 64);

// uDirectionContourCourante indique la direction privilgie
if ( !triplet_ordonne_designe(p.y, p.x, uDirectionContourCourante, &vA, &dA
      , &vB, &dB, &vC, &dC) ) 
  
  // triplet_ordonne_designe renvoit dans l'ordre de prfrence les 3 directions autorises de la direction dsigne privilgie.
  return (MErreur("Echec au calcul de chainage", 321));

// CompatibiliteChainageDirectionnel indique pour chaque couple soumis si le chanage est compatblie.
if ( CompatibiliteChainageDirectionnel(p, vA, uSensDirect) ) 
  {
  vChain =  vA ;
  dChain =  dA ;
  }
else if ( CompatibiliteChainageDirectionnel(p, vB, uSensDirect) ) 
  {
  vChain =  vB ;
  dChain =  dB ;
  }
else if ( CompatibiliteChainageDirectionnel(p, vC, uSensDirect) ) 
  {
  vChain =  vC ;
  dChain =  dC ;
  }
else 
  fChaine =  FAUX ;

// Fabrique l'enchanement
if ( fChaine ) 
  {
  if ( uSensDirect ) 
    Enchaine_iter(p, vChain, dChain);
  else 
    Enchaine_iter(vChain, p, (dChain + 4) % 8);
  
  // Suit l'enchanement
  return RecursiveChercheChainage(vChain, uSensDirect);
  }
else 

// Ferme la chane
  {
  Enchaine_iter(p, p, uSensDirect ? 8 : 255);
  
  // Termine l'enchanement
  return SUCCES ;
  }
}
