/*******************|*******************************************/
/*                  W C O N T O U R . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions de calculs de contours        */
/*                                                             */
/*                                                             */
/* Fichier prototype LCONTOUR.H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1995/1996                        */
/***************************************************************/
#ifndef CONTOUR_H
#define CONTOUR_H

#include "base.h"

#include "wgeometr.h"
/*-------------------------------------------------------------
	                  constantes
-------------------------------------------------------------*/
#define LAPLACIEN_NON_DEF 0
#define LAPLACIEN_FLOAT_8 8
#define LAPLACIEN_CHAR_4  4
#define CONTOUR_BIN       1
#define LAPLACIEN_4x4_v4  2

#define CTR_ChainageLibre        1
#define CTR_ChainageDirectionnel 2

#define EXCEPT_LineQuantityLimitExceeded (EXCEPT_CONTOUR+10)


#define SEUIL_RACCORDEMENT_DEFAUT 1
/*-------------------------------------------------------------*/
/*	          	    nouveaux types  exporter          */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de variables                         */
/*-------------------------------------------------------------*/
extern unsigned int wNbl, wLongueurMinimaleChaine;
extern unsigned int NLA; /* Nombre de lignes autorises. */
//extern char cTypeLaplacien;
//extern float xSeuil_cosEcartAngulaireRaccordementParallele;
//extern float xSeuil_sinEcartAngulaireRaccordementOrthogonal;
extern float xSeuil_tanEcartAngulaireRaccordement0;
extern float xSeuil_tanEcartAngulaireRaccordement90;
extern float xSeuil_tanEcartangulaireUnification;
extern unsigned char uSeuilRaccordement;
extern unsigned int wSeuil_TailleMinimaleSymbole;
extern float             xSeuilRapportDeLongueursMaxSymbole;


/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                         */
/*-------------------------------------------------------------*/
int AlloueTableDeLignes(unsigned int w);
//void ChargeTableLignes(unsigned char *pu); //,algnTableLignes);
ligne_AB *TableDeLignes();



BOOL InitialiseObjetsContours(unsigned int partition_user);
BOOL CalculeGradPolaire_2comp(unsigned char *puSource_user,
                              unsigned char *puModule_user,
                              unsigned char *puDirection_user,
                              int iPartUser);
BOOL CalculeGrad_xy(unsigned char *source_user, unsigned char *puComposante_x, unsigned char *puComposante_y);
BOOL CalculeDirectionGrad_2comp(unsigned char *source_user,
                                unsigned char *direction_user,
                                int iPartUser);
BOOL CalculeLaplacien(char cTypeLaplacien,unsigned char *source, unsigned char *destin);
BOOL CalculeZCLaplacien(unsigned char *puSource_user, unsigned char *puDestin_user, char cType, unsigned char uSeuilZC);
BOOL AmincissementGradientFilaire(unsigned char *amplitude, unsigned char *direction);
BOOL ValidationChainageCoherent(unsigned char *user_chainage);
unsigned char FastClasseArctan(int u, int v);
unsigned char Fast8ClasseArctan(int u, int v);
BOOL CompositionDeLignesGTTSI(unsigned char *puChainage_user);
BOOL AppelDetectionDeLignesGTTSI(unsigned char *puSource_user,
  unsigned char *puAmplitude_user, unsigned char *puDirectionExploration_user,
  unsigned char *puChainage_user,
  unsigned char *puCible, int iPartUser, char cTypeLaplacien);
BOOL DesigneLigne(TCoordonnee Point_extraction, TLigne *pLigne, int *pi);
BOOL CalculeContoursChaineurIteratif(char type_laplacien,
				     unsigned char *puSource_user,
                                     unsigned char *puAmplitude_user,
                                     unsigned char *puDirection_user,
                                     int iPartUser, unsigned char uSeuilZC);
BOOL ChaineurContours(
		 unsigned char *puAmplitude_user,
                 unsigned char *puDirectionExploration_user,
		 unsigned char *puChainage_user,
                 unsigned int wModeChainage=CTR_ChainageDirectionnel);

BOOL ContoursEtChaineurContoursIteratif(
		 char type_laplacien,unsigned char *puSource_user,
		 unsigned char *puAmplitude_user,
                 unsigned char *puDirectionExploration_user,
		 unsigned char *puChainage_user, int iPartUser,
                 unsigned char uSeuilZC,
                 unsigned int wChainageMode=CTR_ChainageDirectionnel);
BOOL AncienneRestaurationJointiveLignesGTTSI();
BOOL RestaurationJointiveLignesGTTSI();
BOOL AppelRestaurationUnificatriceLignesGTTSI();
BOOL  AnalyseLignesRechercheSymbole(TQuadrilatere *pqSymbole,
     unsigned int *pwFirst, unsigned int *pwSecond);
BOOL ListeFastClasseArctan(float *aAngles, unsigned char *aClasses,
                          unsigned int wNbAngles, unsigned int wPartitionUser);
BOOL RemplaceBord(unsigned char *puImage);
//int EstimateurPixelCoin(unsigned char *puImage,TPoint pt, int iSeuil);

BOOL EstimateurImageCoin(unsigned char *puS, int iSeuils, unsigned char *puC,
    unsigned char uDroit);
BOOL EstimateurImageCoinDroit(unsigned char *puS, int iSeuils, unsigned char *puC);
BOOL EstimateurImageCoinOblique(unsigned char *puS, int iSeuils, unsigned char *puC);
//BIT EstimateurImageCoin(unsigned char *puS, int iSeuils, unsigned char *puC);
BOOL RecaleSurCoin(TCoordonnee *pM, unsigned char uTailleNoyau,
    unsigned char *puImage, int iSeuilSaturation);
/*BIT RecaleSurCoins(TQuadrilatere *ABCD, int iSeuilSaturation,
    unsigned char uTailleNoyau, unsigned char *puImage); */
int EstimateurPixelCoinOblique(unsigned char *puImage,TPoint pt, int iSeuil);
int EstimateurPixelCoinDroit(unsigned char *puImage,TPoint pt, int iSeuil);
int EstimateurPixelCoin(unsigned char *puImage,TPoint pt, int iSeuil, unsigned char uDroit);
BOOL RecaleSpecifiqueSurCoins(TQuadrilatere *ABCD, int iSeuilSaturation,
    unsigned char uTailleNoyau, unsigned char *puImage,
    unsigned char uDroit);
BOOL RecaleSpecifiqueHeliophobeCoins(TQuadrilatere *pABCD, int iSeuilSaturation,
    unsigned char uTailleNoyau, unsigned char *puImage, unsigned char uDroit);
BOOL RecaleSpecifiqueHeliophobe4Coins(TQuadrilatere *pABCD, int iSeuilSaturation,
    unsigned char uTailleNoyau, unsigned char *puImage, unsigned char uDroit);

void RechercheCoins( TQuadrilatere Depart, unsigned char *pImage,
	 TQuadrilatere *Arrivee, char Recul=4 );
int IsAuthorizedLink(unsigned int wi,unsigned int wj);
void AuthorizeLink(unsigned int wi,unsigned int wj, int f);
void AuthorizeLink();

#endif // SYSCTR_H

