#pragma message ("This should not be compiled")
// (inhibition provided by freeware INHBCP.BAT)
/**********************************************************************/
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef IRSOUTIL_H
#define IRSOUTIL_H

#ifndef WBASE_H
#include "wbase.h"
#endif

#ifndef WGEOMETR_H
#include "wgeometr.h"
#endif

#ifndef WEDTDRV_H
#include "wsysutil.h"
#endif

#ifndef WSYMBOLE_H
#include "symbole.h"
#endif

#define UTIL_DETECTLIGNES    10
#define UTIL_LECTURESYMBOLE  11
#define DL_RecalageAbsent            0
#define DL_RecalageVoisinageSelectif 1
#define DL_RecalagePremierRecul      2

#define STRING_TitreClasseLectureSymbole "LECTURE DE SYMBOLE"
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
//--TPickupPolygone---------------------------------------------------------
class TPickupPolygone : public TUtilitaire
  {
  public:
    static unsigned char uLargeurAffichagePolygone;
    unsigned char uNbPoints;
    char szLibellePolygone[USUALMAXLENSTRING];
    TRect rAffichagePolygone;
    TCoordonnee *aptPolygone;
    TEditCR **apstAffichagePolygone;
    TPickupPolygone(TWindow* parent, char szTitre[], unsigned char uNbPoints,
      char *szLibellePolygone_in, char cType=0);
    TIcon *picn;
    ~TPickupPolygone();
    virtual void GetWindowClass( WNDCLASS& wc );
    char *GetClassName();
    void SetAffichagePolygone(int cmdShow,TPoint ptAffichagePolygone);
    void CmMenuEnvironnement(WPARAM id);
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void SetupWindow();
    virtual void ModificationCoordonnee();
    virtual void NouveauPoint();
    virtual void NouveauPolygone();
    DECLARE_RESPONSE_TABLE(TPickupPolygone);
  };
/*--TPickupPoint----------------------------------------------------------*/
class TPickupPoint : public TPickupPolygone
  {
  public:
    TCoordonnee pM;
    TPickupPoint(char szTitre[], char cType=0);
    void NouveauPolygone();
  };
/*--TPickupLine----------------------------------------------------------*/
class TPickupLine : public TPickupPolygone
  {
  public:
    TLigne lgn;
    TPickupLine(TWindow* parent, char szTitre[], char cType=0);
    virtual void NouveauPolygone();
    virtual void NouvelleLigne();
  };
/*--TPickupQuad----------------------------------------------------------*/
class TPickupQuad : public TPickupPolygone
  {
  public:
    TQuadrilatere ABCD;
    TPickupQuad(TWindow* parent, char szTitre[], char cType=0);
    virtual void NouveauPolygone();
    virtual void NouveauQuad();
  };

class TParametreProgramme : public TAssociatif {
  public:
    TParametreProgramme(char *szTitre, int iMin_in, int
        iMax_in, int iInit_in,
        BIT (*fAction)(unsigned char *puSource, int iParametre, unsigned
            char *puDestination)    );
     virtual void Action(int iParametre, BIT fApplication=OFF);
  protected:
    virtual void SetupWindow();
    virtual void EvKeyBValue();
    virtual void EvApplication();
    virtual void EvTempsReel();
    virtual void EvAscenseur(UINT);
    virtual void AfficheParametres(int uValue);
    int iMin, iMax, iInit;
    TScrollBar *pscrParametre;
    TEditNumCR *peParametre;
    TCheckBox *pchkTempsReel;
    TButton *pbtApplication;
    BIT (*fAction)(unsigned char *puSource, int iParametre,
      unsigned char *puDestination);
  DECLARE_RESPONSE_TABLE(TParametreProgramme);
};
/*--TDetectLignes--------------------------------------------------------*/
class TDetectLignes : public TUtilitaire
  {
  public:
    char cTypeLaplacienCalcule;
    char cTypeLaplacien;
    int iNoLigneEnCours;
    int iPartition, iCoinsSeuil, iTypeRecalage;
    unsigned char uSeuilZC, uNoPlanImage, uNoPlanAmpl, uNoPlanDirExp,
        uNoPlanChain, uCoinsNoyau;
    unsigned int wSepVert, wSepVert2, wSepHor1, wSepHor2, wSepHor3;
    BIT fConsistance;
    char szImageUtilisee[USUALMAXLENSTRING];
    TRadioButton far *pOptionLaplacienChar4;
    TRadioButton far *pOptionLaplacienFloat8;
    TEditParametre far *pestDetecteCoinsSeuil, *pestDetecteCoinsNoyau;
    TComboBoxItems far *pcmbRecalageQuad;
    TQuadrilatere ABCD;
    TDetectLignes(TWindow* parent);
    ~TDetectLignes();
    void CmMenu(WPARAM id);
    virtual void NouveauPoint();
    void SaveDatasToLectureSymbole();
    void OutsiderReleveOptions();
  protected:
    TEditNumCR far *pNbPart;
    TEditNumCR far *pParametreSeuilZC, *peSeuilEARaccPar, *peSeuilEARaccOrth;
//        *peSeuilEAUnification;
    TLigne Ligne;
    TRect rRechGlob, rConfig, rPteLgn, rRechSmb;
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void SetupWindow();
    virtual bool CanClose();
    virtual void ReleveOptions(void);
    virtual void AfficheOptions(void);
    virtual void SauvegardeOptions(void);
    virtual void ChargeOptions(void);
    BIT SauvegardeTableLignes(ligne_AB *algnTable,unsigned char *puCible);
    BIT ChargeTableLignes(unsigned char *puSource,ligne_AB *algnTable);
    void CmSuicideMenu(WPARAM id);
    DECLARE_RESPONSE_TABLE(TDetectLignes);
 };
/*--TAnalyseQuad---------------------------------------------------------*/
class TAnalyseQuad : public TPickupQuad
  {
  public :
    unsigned int wFreq, wNbCoupes, wSizeOfTables;
    unsigned char auTabFreq[SIZE_OF_PICTURES], auTabCrit[SIZE_OF_PICTURES];
    TRect rFigTabCrit,rFigTabFreq,rTracTabCrit,rTracTabFreq;
    TStatic *pstFreq;
    TButton *pbHistTraceTabCrit, *pbHistTraceTabFreq;
    TReperage repCrit,repFreq;
    TAnalyseQuad(TWindow* parent);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void NouveauQuad();
    virtual void EvMouseMove(UINT a, TPoint& point);
    void DessineFlecheDAnalQuad();
    void Cm_HistTracTabFreq();
    void Cm_HistTracTabCrit();
    DECLARE_RESPONSE_TABLE(TAnalyseQuad);
  };
/*--TCadIris-------------------------------------------------------------*/
class TLectureSymbole : public TPickupQuad
  {
  public:
    TDataMatrix Symbole;
    TLectureSymbole(TWindow* parent);
    ~TLectureSymbole();
    void CmMenu(WPARAM id);
    virtual void NouveauPoint();
    virtual void NouveauQuad();
    void NouvelleMatrice();
    void CmUserIntervention(WPARAM id);
    void InvalidateMatrice();
    void Ev_ModifTexteSymbole();
    void Ev_ModifNumeriqueSymbole();
  protected :
    unsigned int wSepVert, wSepHor0, wSepHor1, wSepHor2;
    BIT fConsistance;
    char szImageUtilisee[USUALMAXLENSTRING];
    TRect rEspaceTxt, rTxt,rEspaceNum,rNum, rEspaceDivComment,rDivComment,
          rValFreq,rValNbOct,rEspaceSymbole,rSymbole,rButtModifTxt,
          rButtModifNum;
    TReperage repSymbole;
    TEdit *peTxtSmb;
    TEditNumCR *peNumSmb, *peFreq, *peNbOct;
    TButton *pbModifTxt,*pbModifNum;
    virtual void SetupWindow();
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void EvMouseMove(UINT a, TPoint& point);
    virtual void EvLButtonDblClk(uint modKeys, TPoint& point);
    DECLARE_RESPONSE_TABLE(TLectureSymbole);
 };

//--------------------------------------------------------------------------
//                     Nouvelles classes
//--TDetecteCoin-----------------------------------------------------------
class TDetecteCoin : public TPickupPoint
  {
  public :
    TDetecteCoin();
    ~TDetecteCoin();
    virtual void NouveauPolygone();
    TEditParametre *psteNoyau, *psteSeuilSat;
  };
//--TAnalyseLigne-----------------------------------------------------------
class TAnalyseLigne : public TPickupLine
  {
  public:
    unsigned int wHSep1, wHSep2, wVSep1;//, wVSep2, wVSep3;
    unsigned int wLongueurLigne;
    float xValeurSeuilAnalyseFreq;
    TStatic *pstLL, *pstFL, *pstPL, *pstET, *pstPm, *pstPM, *pstRac, *pstSRac,
        *pstCritere;
    TRect rTraceLigne;
    TReperage repIntensiteLigne;
    unsigned char auLigne[SIZE_OF_PICTURES*2];
    TAnalyseLigne(TWindow *parent);
    virtual void NouvelleLigne();
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void TAnalyseLigne::EvMouseMove(UINT a, TPoint& point);
  };
//--TAnalyseFreqQuad-----------------------------------------------------
class TAnalyseFreqQuad : public TPickupQuad
  {
  public:
    TAnalyseFreqQuad::TAnalyseFreqQuad(TWindow *parent);
    virtual void NouveauQuad();
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
  };

/*-----------------------------------------------------------------------*/
/*                     Variables  exporter                              */
/*-----------------------------------------------------------------------*/
extern TDetectLignes far *pDetectLignes;
extern TLectureSymbole far *pLectureSymbole;


/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*/
BIT SelectHardCopyFile();
#endif // IRSOUTIL_H
