#define MODULE_NAME "WSmbMana"
/**********************************************************************/
/*                       W A P P I R I S . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Perso des classes d'Iris.                      */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      */
/*    Dvelopp le   : Printemps 1996                                 */
/**********************************************************************/
// Inclusions bibliothques standards

#include <math.h>
#include <values.h>

//  Inclusions bibliothques Object Windows

#include <owl\applicat.h>
#include <owl\combobox.h>
// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wsysutil.h"
#include "wappbase.h"
#include "wgttsi.h"
#include "wmain.h"

//  Inclusions bibliothques Iris
#include "base.h"

#include "wintrac.h"
#include "sysctr.h"
#include "wgeometr.h"
#include "scaltool.h"
#include "symbole.h"

#include "anlfreq.h"
#include "wiris.h"
//#include "wirstool.h"
#include "wirssymb.h"
#include "iris.rc"

#include "wappiris.h"
#include "wappiris.rc"
/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Variables globales                                */
/*-----------------------------------------------------------------------*/
TFenIrisPerso *pFenetreIrisPerso;
TAppIrisPerso *pApplicationIrisPerso;
TCadIrisPerso *pCadreIrisPerso;
/*-----------------------------------------------------------------------*/
/*               Prototypes fonctions locales                            */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classe Fenetre (TFenIris)                         */
/*--Systme--------------------------------------------------------------*/
TFenIrisPerso::TFenIrisPerso():TFenIris()
  {
  pFenetreIrisPerso=this;
  pMenu_Traitement=new TMenu((HINSTANCE)(*((TApplication*)pApplicationIrisPerso)),"Symbole");
  }

void TFenIrisPerso::SetupWindow()
  {
  TFenIris::SetupWindow();
  TMenu mnu(*pCadreIrisPerso);
  pmnuPrincipal->DeleteMenu(NumeroApplication,MF_POPUP | MF_BYPOSITION);  // version bride.
  pmnuPrincipal->DeleteMenu(NumeroApplication,MF_POPUP | MF_BYPOSITION);  // version bride.
  mnu.InsertMenu(4, MF_POPUP | MF_BYPOSITION, *(pFenetreIrisPerso->pMenu_Traitement),
  "&Symboles");
  }

DEFINE_RESPONSE_TABLE1(TFenIrisPerso, TFenIris)
	EV_COMMAND(CM_T0, CmT0),
  EV_WM_RBUTTONDOWN,
/*	EV_COMMAND(CM_T1, CmT1),
	EV_COMMAND(CM_T2, CmT2),
	EV_COMMAND(CM_T3, CmT3),*/
END_RESPONSE_TABLE;
/*-----------------------------------------------------------------------*/
/*                     Classe application (TAppIris)                     */
/*--Systme--------------------------------------------------------------*/
TAppIrisPerso::TAppIrisPerso() : TAppIris()
  {
  pApplicationIrisPerso=this;
  }

void TAppIrisPerso::InitMainWindow()
  {
  new TCadIrisPerso(NULL,TitreApplication,new TFenIrisPerso,TRUE);
  TAppIris::InitMainWindow();
  }
/*-----------------------------------------------------------------------*/
/*                     Classe Cadre (TCadIris)                           */
/*--Systme--------------------------------------------------------------*/
TCadIrisPerso::TCadIrisPerso(TWindow *Parent, char far *Title, TWindow *Client,
                   BOOL trackMenuSelection)
    : TCadIris (Parent, Title, Client, trackMenuSelection)
  {
  pCadreIrisPerso=this;
  }
/*-----------------------------------------------------------------------*/
/*                     Classe Fenetre (TFenIris)                         */
/*--Nouvelles fonctionalits---------------------------------------------*/
void TFenIrisPerso::CmT0()
  {
  CmMenuSymboles(CM_UtilitaireSymbole);
  pLectureSymbole->fShowMenu=OFF;
  pLectureSymbole->fShowPolygon=OFF;
  pLectureSymbole->fLinkAffim=OFF;
  pLectureSymbole->fImageProcess=0;
  pLectureSymbole->SetAffichagePolygone(SW_HIDE,CoordonneeErreur);
  pLectureSymbole->AfficheOptions();
  }
/*void TFenIrisPerso::CmT1(){MessageBox("Traitement 1",TitreApplication,MB_OK);}
void TFenIrisPerso::CmT2(){MessageBox("Traitement 2",TitreApplication,MB_OK);}
void TFenIrisPerso::CmT3(){MessageBox("Traitement 3",TitreApplication,MB_OK);}
*/
/*-----------------------------------------------------------------------*/
/*                     Classe application (TAppIris)                     */
/*--Nouvelles fonctionalits---------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classe Cadre (TCadIris)                           */
/*--Nouvelles fonctionalits---------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                 Fonctions locales                                     */
/*-----------------------------------------------------------------------*/
/*void ChargeOptions()
  {
  GetPrivateString("localisations","accueil",szImageAccueilDef,szImageAccueil,USUALMAXLENSTRING,szINIFileName);
  GetPrivateString("localisations","rpertoire",szRepertoireDepartDef,szRepertoireDepart,USUALMAXLENSTRING,szINIFileName);
  GetPrivateString("localisations","nom traceur",szNomTraceurDef,szNomTraceur,USUALMAXLENSTRING,szINIFileName);
  GetPrivateFlag("options","dmarrage plein cran",fFullScreenStartDef,szINIFileName);
  GetPrivateString("localisations","nom copie physique",szHardCopyFileNameDef,szHardCopyFile,USUALMAXLENSTRING,szINIFileName);
  GetPrivateFlag("options","copie physique",fHardCopyDef,szINIFileName);
  fTracage=GetPrivateFlag("options","traage",fTracageDef, szINIFileName);
  wCommandePredefinie=GetPrivateInt("options","commande predefinie",0,szINIFileName);
  }*/
/*-----------------------------------------------------------------------*/
/*       		   Programme OwlMain                             */
/*-----------------------------------------------------------------------*/
int OwlMain(int /*argc*/, char* /*argv*/ [])
{
  if (DemarrageCarte())
    {
    strcpy(TitreApplication,"Iris - Gnration de symboles Data Matrix");
    strcpy(TexteAbout,"Version : 1996\n\nAuteur : Baptiste MARCEL");
    strcpy(FichierAide,"aide.HLP");
    strcpy(szINIFileName,"smbmanag.ini");
    fFullScreenStartDef=TRUE;

    wReadingSymbolPropertiesDef &=  ~SMB_PROP_Clock;
    wReadingSymbolPropertiesDef &=  ~SMB_PROP_Origin;
    wReadingSymbolPropertiesDef |=  SMB_PROP_Appearance | SMB_PROP_AppPositive;
    wReadingSymbolPropertiesDef &=  ~SMB_PROP_Parity;


    return TAppIrisPerso().Run();           // Lancement du programme
    }
  else
    return 0;
}
/*-----------------------------------------------------------------------*/
/*       						Fonctions  exporter                          */
/*-----------------------------------------------------------------------*/





