#error Obsolete: use symbole.*

#define MODULE_NAME "WSYMBOLE.CPP"
 /*******************|******************************************                  W S Y M B O L E . C                        -------------------------------------------------------------    Fonction       : Fonction de traitement symbolique pour                       symboles pour Iris       	                                                                     Fichier source wsymbole.C.                                  */ 

// Inclusions bibliothques standards
#include <io.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>

// Inclusions bibliothques Object Windows
//#include <owl\dc.h>
#include <owl\framewin.h>
#include <owl\point.h>

// Inclusions bibliothques DOS
#include <stdio.h>

// Inclusion bibliothques Image
//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "scaltool.h"
#include "wgeometr.h"
#include "filutil.h"
#include "wsystool.h"
#include "strutil.h"
#include "wsymbole.h"

/*-------------------------------------------------------------*/
/*		       constantes locales                      */
/*-------------------------------------------------------------*/
/*
  #define LONG_LGN_ECR 80
  */
#define LONG_LGN_IMP 78
#define haut_col_ecr 60
 /*-------------------------------------------------------------	              variables  exporter                     --------------------------------------------------------------------------------------------------------------------------		      nouveaux types locaux                    -------------------------------------------------------------*/ 

enum REF_LEC { STD, MAT, NUM, TXT, ERR };
/*-------------------------------------------------------------*/
/*		       variables locales                       */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/
enum REF_LEC  PrendRefLec (char *ligne) ;
enum REF_LEC  ReconnRefLec (char *ligne) ;
/*
  void AffContenuTxt_oct (char *catalogos, int n_oct, int lgn);
  char Compar(data_matrix smb1, data_matrix smb2, unsigned long *Pdelta_int, unsigned long *Pdelta_ext); */
BIT          ChargeSymboleNouveauFormat (char *szFileName, TDataMatrix *smb) ;
BIT          ChargeSymboleAncienFormat (TDataMatrix *pSmb
    , char *szFileName, char fSymboleUnique) ;

/*-------------------------------------------------------------*/
/*	              fonctions locales inline                 */
/*-------------------------------------------------------------*/
/* CarAutAff (Caractre autoris en affichage)
    Renvoit le caractre lui mme s'il est affichable, un code
  conventionnel dans les autres cas. Pour l'affichage sur cran graphique,
  le caractre 0 n'est pas affichable dans une chane mais est reprsent
  par l'espace (' ').
    stoicheion : le caractre. */
inline char CarAutAff ( char c )
{
    return c ? c : ' ';
}

TDataMatrix::TDataMatrix ( unsigned int f ) // f=0 par dfaut
{
    if ( f ) 
        Matrice = (unsigned char *)malloc(f * f);
    else 
        Matrice = NULL ;
    if ( Matrice ) 
        wFrequence = f ;
    else 
        wFrequence = 0 ;
}

void TDataMatrix::Set ( unsigned int f )
{
    if ( wFrequence && !Matrice ) {
        MErreur("Erreur de cohrence", 86);
        wFrequence = 0 ;
        Matrice = NULL ;
    }
    if ( wFrequence != f ) // Seul cas o l'on doive intervenir.
                           {
                            wFrequence = f ;
                            if ( Matrice != NULL ) 
                                free(Matrice);
                            if ( !f ) 
                                Matrice = NULL ;
                            else {
                                Matrice = (unsigned char *)malloc(f * f);
                                if ( !Matrice ) {
                                    MErreur("Erreur d'allocation", 95);
                                    wFrequence = 0 ;
                                }
                            }
                           }
}

TDataMatrix::~TDataMatrix ()
{
    if ( wFrequence && !Matrice ) 
        MErreur("Erreur de cohrence", 119);
    else if ( Matrice ) 
        free(Matrice);
}

void TDataMatrix::Copie ( TDataMatrix *pSmb )
{
    if ( wFrequence != pSmb -> wFrequence ) 
        Set(pSmb -> wFrequence);
    
    unsigned int    w ;
    
    for ( w = 0 ; w < wFrequence * wFrequence ; w++ ) 
        Matrice [w] = pSmb -> Matrice [w];
}

BIT TDataMatrix::PivoteHorlogeRail ()
{
    unsigned int    wPoidHaut = 0, wPoidBas = 0, wPoidDroite = 0
        , wPoidGauche = 0, i ;
    
    for ( i = 0 ; i < wFrequence ; i++ ) {
        wPoidGauche += Matrice [wFrequence * i]; // Rail vertical.
        wPoidBas += Matrice [i + (wFrequence - 1) * wFrequence]; // Rail horizontal
        wPoidHaut += Matrice [i]; // Horloge horizontale: i=0 (rail) fait 1 (noir) et ainsi de suite.
        wPoidDroite += Matrice [wFrequence - 1 + i * wFrequence]; // Horloge verticale
    }
    
    unsigned int    wPoidHG = wPoidHaut + wPoidGauche
        , wPoidHD = wPoidHaut + wPoidDroite
        , wPoidBG = wPoidBas + wPoidGauche
        , wPoidBD = wPoidBas + wPoidDroite
        , wPoidMax = max(max(wPoidHG, wPoidHD), max(wPoidBG, wPoidBD));
    
    // Les sens de rotation sont par raport  un repre orthogonal direct li  la
    // matrice, indpendant du repre de l'image.
    if ( wPoidMax == wPoidBG ) 
        return SUCCES ;
    else if ( wPoidMax == wPoidBD ) 
        return Rotation90deg( - 1);
    else if ( wPoidMax == wPoidHD ) 
        return Rotation90deg(2);
    else if ( wPoidMax == wPoidHG ) 
        return Rotation90deg(1);
    else 
        return MErreur("Erreur Code", 154);
}

BIT TDataMatrix::Rotation90deg ( char cRotat )
{
    if ( !cRotat % 4 // Rotation de 0.
        || !wFrequence ) 
        return SUCCES ;
    
    TDataMatrix dmSymb2 (wFrequence) ;
    
    if ( !dmSymb2.wFrequence ) 
        return MErreur("Erreur d'allocation", 166);
    if ( !RotationMatriceMod90(Matrice, dmSymb2.Matrice, wFrequence
            , (int)cRotat) ) 
        return MErreur("Erreur  la rotation", 169);
    
    unsigned char   *puSwap = Matrice ;
    
    Matrice = dmSymb2.Matrice ;
    dmSymb2.Matrice = puSwap ; // Echange des matrices avant fin.
    
    // Lors de la fin de cette procdure, la matrice de dmSymb2 sera
    // automatiquement libre.
    return SUCCES ;
}

BIT TDataMatrix::Transpositon ()
{
    if ( !wFrequence ) 
        return SUCCES ;
    
    TDataMatrix dmSymb2 (wFrequence) ;
    
    if ( !dmSymb2.wFrequence ) 
        return MErreur("Erreur d'allocation", 166);
    if ( !Transposition_MAT(Matrice, dmSymb2.Matrice, wFrequence
            , wFrequence) ) 
        return MErreur("Erreur  la transposition", 169);
    
    unsigned char   *puSwap = Matrice ;
    
    Matrice = dmSymb2.Matrice ;
    dmSymb2.Matrice = puSwap ; // Echange des matrices avant fin.
    
    // Lors de la fin de cette procdure, la matrice de dmSymb2 sera
    // automatiquement libre.
    return SUCCES ;
}
// Fonctions du menu Accs systme
    
    /* SortieFichier (Sortie vers un fichier)
      Sort dans un fichier le symbole dsign sous ses trois formes.
      n_oct : 	nombre d'octets,
      arithmos :    caractre courant,
      catalogos :	liste des octets,
      Psmb :	pointeur sur symbole  sortir,
      */
    BIT SauvegardeSymbole(TDataMatrix *pSmb, char *szFileName)
      {
      FILE *pExetasis; /* pointeur sur le fichier de sortie */
      if (!pSmb || !IsFileExtension(szFileName,".smb"))
        return ECHEC;
      pExetasis = fopen (szFileName, "wt");
      if (!pExetasis)
        return ECHEC;
      fclose(pExetasis); // Vidange du fichier.
      WritePrivateInt("configuration","nombre de symboles",1,szFileName);
      WritePrivateInt("configuration","taille",pSmb->wFrequence,szFileName);
      WritePrivateString("configuration","type","STD",szFileName);
      pExetasis = fopen (szFileName, "at");
      fprintf (pExetasis, "--------------------------------------------------------------------------------\n");
      fprintf (pExetasis, "-- Forme matricielle.\n");
      fprintf (pExetasis, "MAT\n\n");
      unsigned int wi, wj;
      for (wi=0; wi<pSmb->wFrequence; wi++)
        {
        for (wj=0; wj<pSmb->wFrequence; wj++)
          fprintf (pExetasis, "%c", pSmb->Matrice[wi*pSmb->wFrequence+wj]?'X':' ');
        fprintf (pExetasis, "\n");
        }
      unsigned int wNbOct=NbOctetsPourTelleFrequence(pSmb->wFrequence);
      char far *acTamponTexte=(char *)malloc(wNbOct+1);
      char far *szTamponNumerique=(char *)malloc(4*wNbOct+1);
      char far *acTamponWrappedText=(char *)malloc(wNbOct+15+1);
      char far *acTamponWrappedNumerList=(char *)malloc(4*wNbOct+15+1);
      BIT fRes=SUCCES;
      do
        {
        if (!(fRes=Octavisation(pSmb,acTamponTexte,wNbOct)))
          break;
    /* Fabrique la liste des valeurs.*/
        if (!(fRes=NumeraliseListeOctets(szTamponNumerique,acTamponTexte,wNbOct)))
          break;
    /* Fabrique le texte imprimmable.TextualiseListeOctets doit se faire apres car il modifie les caractres pour
    les rendre imprimmables.*/
        if (!(fRes=TextualiseListeOctets(acTamponTexte,NbROctetsPourTelleFrequence(pSmb->wFrequence))))
          break;
        unsigned int wNumberOfCharPerLine=LONG_LGN_IMP;
        if (!(fRes=WrappText(acTamponTexte,wNbOct,acTamponWrappedText,wNbOct+15,
                  wNumberOfCharPerLine,
                  IsIntelligentText(acTamponTexte)?CONTINUOUS_WRAPPING:SEPARATOR_WRAPPING)))
          break;
        if (!(fRes=WrappText(szTamponNumerique,4*wNbOct,acTamponWrappedNumerList,
                  4*wNbOct+15,wNumberOfCharPerLine,SEPARATOR_WRAPPING)))
          break;
        }
      while (FAUX);
      if (fRes)
        {
        fprintf (pExetasis, "\n-- Forme numrique.\n");
        fprintf (pExetasis, "NUM\n");
        fprintf (pExetasis, "%s",acTamponWrappedNumerList);
        fprintf (pExetasis, "\n-- Forme textuelle.\n");
        fprintf (pExetasis, "TXT\n");
        fprintf (pExetasis, "%s",acTamponWrappedText);
        }
      free(acTamponWrappedNumerList);
      free(acTamponWrappedText);
      free(szTamponNumerique);
      free(acTamponTexte);
      fclose(pExetasis);
      return fRes;
      }
    
    
    /* ChargeSymbole (Chargement d'un symbole)
      Lit dans un fichier un symbole unique selon le format dfinit
    dans la cahier de code. Seul le premier symbole du fichier est lu.
      En cas d'erreur terminale, un symbole vide est renvoy.
      La matrice du symbole est allou par la procdure elle mme.
    
      n_oct : 	nombre d'octets,
      arithmos :    caractre courant,
      catalogos :	liste des octets,
      mat :		matrice rsulat.
      Psmb :	pointeur sur symbole rsultant,
      pmat		pointeur sur matrice rsultante (sans le cadre).
      */
    /* FORMAT :
      Le nombre de caractres par lignes est limit  LONG_LGN_IMP pour l'en-tte.
      Le format est similaire  un format de fichier .INI.
      [configuration]
      nombre de symboles= ...
      taille= ...   (-1 pour frquence adaptative)
      type= ... (STD, MAT, TXT ou NUM)
      puis le type en majuscule seul sur une ligne, puis une ligne vide, puis le contenu.
    */
    BIT ChargeSymbole (char *szFileName, TDataMatrix *smb)
      {
      if (!ChargeSymboleNouveauFormat(szFileName,smb))
        return ChargeSymboleAncienFormat(smb,szFileName,VRAI);
      else
        return SUCCES;
      }
    BIT ChargeSymboleNouveauFormat (char *szFileName, TDataMatrix *smb)
      {
      FILE *Pexetasis=NULL;
      char szType[USUALMAXLENSTRING];
      unsigned char *catalogos=NULL;
      int nombre_SMB=0, n_oct=0, n=0, i=0, j=0, arithmos=0,longueur_ligne=0;
      enum REF_LEC ref=ERR, anaphero=ERR;
      unsigned char *Psmb=NULL;
    
       /* pointeur sur le fichier de chargement */
      char *stichos=NULL, *rema=NULL;
      /* ligne courante, ligne aux espaces compacts et mot intermdiaire */
    
      if (access(szFileName,04))
        return ECHEC;
    
    /* Acquisition du nombre de symboles. */
      longueur_ligne=LONG_LGN_IMP ; /* Limite de la taille des lignes de la zone
    			prliminaire. */
    
        /* Acquisition du nombre de symboles. */
      nombre_SMB=GetPrivateInt("configuration","nombre de symboles",1,szFileName);
      if (!nombre_SMB)
        nombre_SMB=1;
    
      if (nombre_SMB!=1)
        return ECHEC;
      n=GetPrivateInt("configuration","taille",0,szFileName);
      if (!n || n< -1)
        return ECHEC;
      GetPrivateString("configuration","type","STD",szType,sizeof(szType),szFileName);
      ref = ReconnRefLec(strupr(szType));
      if (ref==ERR || (Pexetasis=fopen (szFileName, "rt"))==NULL)
        return ECHEC;
    // Ouverture Pexetasis
      if (n==-1) /* Taille adaptative */
        {
        if (ref!=TXT)
          {
          fclose(Pexetasis);
          return ECHEC;
          }
        /* Taille adaptative en texte. */
        anaphero = ERR;
        /* Entre : stichos est libre. */
        stichos=(char *)malloc(longueur_ligne+2);
    // Allocation stichos;
        while (anaphero!=TXT)
          {
          fgetlaline(Pexetasis, longueur_ligne, stichos);
          anaphero=ReconnRefLec(stichos);
          }
        /* Texte localis et point */
        fgetlaline(Pexetasis, longueur_ligne, stichos);
        /* Acquisition du '\n' restant. */
        n_oct=fcontchar(Pexetasis);
        if (n_oct<0)
          {
          fclose(Pexetasis);
          free(stichos);
          return ECHEC;
          }
    //    n=2+NCeilR(sqrt(n_oct*8));
        n=FrequencePourTantDOctets(n_oct);
        if ((n+1)%2) /* Si n+1 impair (n pair)... */
          n++; /* ...n est incrment. */
        fseek(Pexetasis, 0, 0);
        anaphero = ERR;
        while (anaphero!=TXT)
          {
          fgetlaline(Pexetasis, longueur_ligne, stichos);
          anaphero=ReconnRefLec(stichos);
          }
        /* Le fichier est repositionn sur la dclaration de la rfrence. */
        free(stichos);
    // stichos libr
        }
    /*  else if ((n+1)%2) // (n+1)%2 vaut 1 (VRAI) si taille est pair
        {
        fclose(Pexetasis);
        return ECHEC;
        } */
      else if (n==1)
        {
        fclose(Pexetasis);
        return ECHEC;
        }
      else
        {
        if (ref==STD)
          ref=MAT;
        /* Recherche de la bonne rfrence. */
        anaphero = ERR;
        stichos=(char *)malloc(longueur_ligne+2);
    // stichos allou
        while (anaphero!=ref)
          {
          fgetlaline(Pexetasis, longueur_ligne,stichos);
          anaphero=ReconnRefLec(stichos);
          }
        free(stichos);
    // stichos libr
        /* Rfrence atteinte */
        }
      if (ref==MAT)
        {
        smb->Set(n);
    // Symbole allou  n*n.
        Psmb=smb->Matrice;
        if (smb->Matrice==NULL)
          {
          fclose(Pexetasis);
          smb->Set();
          return ECHEC;
          }
        longueur_ligne=n;
        stichos=fgetlline(Pexetasis, longueur_ligne);
    // stichos allou
        if (stichos!=NULL) free(stichos);
    // stichos libr
        stichos=fgetlline(Pexetasis, longueur_ligne);
    // stichos allou
        /* On saute une ligne avant de lire les valeurs. */
        if (stichos==NULL)
          {
          fclose(Pexetasis);
          smb->Set();
          return ECHEC;
          }
        for (i=0; i<n; i++)
          {
          for (j=0; j<n; j++)
    	if ( (stichos[j]==' ')||(stichos[j]=='0') )
    	  Psmb[i*n+j]=BLANC;
    	else if ( (stichos[j]=='X')||(stichos[j]=='1') )
    	  Psmb[i*n+j]=NOIR;
    	else if (stichos[j]=='\0')
    	  /* Fin de ligne avant la fin dernire colonne, il faut complter
               avec des 0. */
    	  for (;j<n; j++)
    	    Psmb[i*n+j]=BLANC;
    	else
    	  Psmb[i*n+j]=NB_INCONNU;
    	/* Prendre la ligne suivante. */
          free(stichos);
          stichos=fgetlline(Pexetasis, longueur_ligne);
          if (stichos==NULL)
    	{
    	fclose(Pexetasis);
            smb->Set();
    	return ECHEC;
    	}
          }
        /* Lecture du symbole matriciel termine */
        fclose(Pexetasis);
        free(stichos);
        return SUCCES;
        }
      else if (ref==NUM)
        {
    //    n_oct=(n-2)*(n-2)/8+1;
        n_oct=NbOctetsPourTelleFrequence(n);
        catalogos=(unsigned char *)malloc(n_oct*sizeof(char));
    // catalogos allou
        if (catalogos==NULL)
          {
          fclose(Pexetasis);
          smb->Set();
          return ECHEC;
          }
        rema=(char *)malloc(n_oct*sizeof(char));
    // rema allou
        if (rema==NULL)
          {
          fclose(Pexetasis);
          smb->Set();
          free (catalogos);
          return ECHEC;
          }
        for (i=0; i<n_oct; i++)
          {
          j=fscanf(Pexetasis, "%s", rema);
          if (j==EOF)
    	{
    //	MErreur("Erreur au chargement : liste numrique incomplte (complte avec 0).");
    	for(;i<n_oct; i++)
    	  catalogos[i]=0;
    	}
          else if (j==0)
    	{
    	fclose(Pexetasis);
    	free(rema);
    	free(catalogos);
            smb->Set();
    	return ECHEC;
    	}
          else if (j==1)
    	{
    	arithmos=atoi(rema); /* (manuel p33) */
    /*	if (arithmos < 0)
    	  MErreur("Erreur au chargement : valeur ngative repre (lecture poursuivie).");
    	else if (arithmos >= 256)
    	  MErreur("Erreur au chargement : valeur suprieure  255 repre (lecture poursuivie).");
    */	catalogos[i]=(unsigned char)arithmos;
    	}
          else
    	{
    	fclose(Pexetasis);
    	free(rema);
    	free(catalogos);
            smb->Set();
    	return ECHEC;
    	}
          }
        free(rema);
        free(catalogos);
    // rema et catalogos libres.
        smb->Binarisation(catalogos, n);
        smb->Encadrement();
        fclose(Pexetasis);
        return SUCCES;
        }
      else /* ref=TXT */
        {
        n_oct=NbOctetsPourTelleFrequence(n);
        catalogos=(unsigned char *)fgetltext(Pexetasis, n_oct);
    // catalogos allou.
        j=strlen((char *)catalogos);
        /* "catalogos" est une chane de caractres d'au plus "n_oct" octets
        avec '\0' en fin de chane. */
        if (j<n_oct)
          {
    //      Erreur("Rapport de chargement : texte incomplet (complt avec ' ').",LEGER);
          rema=(char *)catalogos;
    // rema recoit catalmogos (allou)
          catalogos=(unsigned char *)malloc((n_oct+1)*sizeof(char));
    // catalogos allou
          if (catalogos==NULL)
            {
            fclose (Pexetasis);
            smb->Set();
            return ECHEC;
            }
          for(i=0; i<j; i++)
    	catalogos[i]=*rema++;
          for(;i<n_oct-1; i++)
    	catalogos[i]=' ';
          catalogos[n_oct-1]=0; /* "catalogos" n'a plus  tre considre comme
    				une chane mais une suite de "n_oct" octets
    				dont le dernier vaut 0 ou 1. */
    
          free(rema);
    // rema libr
          }
        smb->Binarisation(catalogos, n);
        free(catalogos);
    // catalogos libre.
        smb->Encadrement();
        fclose(Pexetasis);
        return SUCCES;
        }
      }
    
    
    /* Affcontenu
      Affichage du contenu d'un symbole sous ses trois formes :
      - matricielle (en haut  gauche)
      - numrique (en haut  droite)
      - textuelle (en bas).
    
      Une frise spare les lments. Si la taille du symbole est trop lev,
    l'utilisateur choisit une forme parmis les trois.
    
    Pour le numrique ou le textuel, l'ensemble des bits de la matrice
    est regroup en octets (ie en caractres).
    
    Les bits manquants au dernier octets sont considrs commes tants
    les bits de poids fort et affects  zro.
    
      smb       : data matrix  diter,
      n         : taille de la matrice,
      n_oct     : nombre d'octets contenus dans la matrice.
    */
    /*
    void AffContenu (data_matrix smb)
      {
      int n=smb.taille, n_oct=(n-2)*(n-2)/8+1;
      unsigned char *Psmb=smb.matrice, *dromeus;
      int i, j, l, ui;
      int larg_numerique=(72-n)/4;
      /* nombre d'octets par ligne de l'affichage numrique,
    l'arrondi est par dfaut 
      int metron=1; /* chelle verticale  un chiffre (=0 pour deux chiffres) 
      char *diazoma; /* Frise sparatrice 
      char *catalogos;
      /* Chane de caractres des octets, caractre courant et ligne courante. 
      unsigned char arithmos;
      /* Valeur du caractre courant (pour la version numrique et textuelle). 
    
      if (Psmb==NULL)
        Erreurr("Tentative d'affichage d'un symbole nul.",204);
      larg_numerique=(72-n)/4; /* L'arrondi est par dfaut 
      if (n > 47)
      /* Il n'y a pas la place pour l'affichage des trois formes 
        {
        Aff_mes_cent (NIVEAUMESSAGE,"Il n'y a pas la place pour l'affichage des trois formes");
        }
      else
        {
    /* Trac des Frises. 
        diazoma=Frise(1); /* Allocation de diazoma. 
        clearviewport();
        setcolor(YELLOW);
        for (i=0; i<n+7; i++) /* Frise verticale 
          outtextxy((n+6)*larg_car,i*haut_car, diazoma);
        free(diazoma);
        diazoma=Frise(LONG_LGN_ECR);
        /* Frise horizontale 
        outtextxy(0,(n+6)*haut_car, diazoma);
        free(diazoma);
    
    /* Construction des chelles 
        setcolor(YELLOW);
        for (i=0; i<n; i++)
          {
          ui=i%10; /* unit de i (eg. i=14 => ui=4) 
          outentNxy(4+i, 2, ui); /* chelle horizontalle 
          if ((ui==0) && (i!=0))
    	outentNxy(4+i, 1, (i-ui)/10);
    
          if (i==10)
    	metron=0; /* Passage  deux chiffres 
          outentNxy(1+metron, i+4, i); /* chelle verticale 
          }
    
    /* Remplissage de l'espace matriciel 
        setcolor(WHITE);
    /* Remplissage du fond 
        for(i=0; i<n+2; i++)
          {
          outcarNxy(3+i,3,219);
          outcarNxy(3,3+i,219);
          outcarNxy(3+i,4+n,219);
          outcarNxy(4+n,3+i,219);
          }
    /* Inscription des bits 
        dromeus=Psmb; /* Initialisation du pointeur qui parcourira smb. 
        for (i=0; i<n; i++)
          for (j=0; j<n; j++)
    	outcarNxy(4+j, 4+i, CoulDeCarGraph(*dromeus++));
    
    
    /* Le remplissage de l'espace numrique et/ou textuel passe par le
    regroupement en octets. C'est la fonction Octavisation. 
    
    /* Remplissage de l'espace numrique 
        catalogos = malloc (n_oct+1 * sizeof(char));
        if (!Octavisation(smb,catalogos, n_oct))
          {
          Erreurr("Octavisation choue.",632);
          return ;
          }
        for(l=0; l<n_oct; l++)
        /* l : numro de l'octet (premier octet/nombre : 0) avec
    	- l%larg_numerique est le n de colonne,
    	- l/larg_numerique est le n de ligne. 
          {
          arithmos = catalogos[l];
          outentNxy(n+8+4*(l%larg_numerique),
    		4  +   l/larg_numerique , (int)arithmos);
          }
        AffContenuTxt_oct(catalogos, n_oct,n+8);
        free(catalogos);
        }
      Att_sour_clav();
      clearviewport();
      }
    /*-------------------------------------------------------------------------
    /*TransfertVisu (Prepare Visualisation)
    Transforme un symbole en son image sous forme bitmap.
      La procdure reoit le symbole du data matrix et construit sous forme
    de damier l'image correspondante en ajustant la taille des cases de
    faon  ce que le damier occupe toute l'image.
      Paramtre V : selon que la visualisation est destine  l'impression ('I')
    ou  la visualiosation ('V');
    
      pimg  : pointeur sur l'image rsultat (tableau carr de taille 256,
    	    dja allou),
      Psmb  : pointeur sur le symbole source,
      n     : taille du symbole,
      N     : taille de l'image (N=256).
    */
    
    BIT TDataMatrix::TransfertVisu(unsigned char *puCible)
     {
     unsigned int l, i, j;
     // int N, i, j, k, l, n;
    // unsigned char *Psmb;
     float r;
    
    // N=256;
    // n=smb.taille;
    // Psmb=smb.matrice;
     if (!wFrequence || !Matrice)
       return ECHEC;
    
     r=(float)wFrequence/(float)SIZE_OF_PICTURES;
     for(unsigned int k=0; k<SIZE_OF_PICTURES; k++)
       for(l=0; l<SIZE_OF_PICTURES; l++)
    	{
    	i=NFloorR(k*r);
    	j=NFloorR(l*r);
    	*puCible++ =CouleurDePoint(Matrice[i*wFrequence+j], ECRAN);
    	}
     return SUCCES;
     }
    /*-------------------------------------------------------------------------
    /* Dupliq
      Duplique un symbole ( l'issue, les deux symboles pointent sur deux matrices
    d'adresse diffrente mais aux mmes valeurs).
      La matrice rsultante est alloue par la procdure Dupliq.
    	smb1, smb2      : data matrix des symbole source et cible,
    	Psmb2           : pointeur sur le symbole cible
    	n               : taille des symboles.
    
    data_matrix Dupliq (data_matrix smb1)
      {
      data_matrix smb2;
      unsigned char *Psmb2;
      int n, i;
    
      n=smb1.taille;
      Psmb2=malloc (n*n*sizeof(unsigned char));
      if (Psmb2==NULL) Erreur("Erreur d'allocation (ref. 509)",TERMINAL);
      smb2.taille=n;
      smb2.matrice=Psmb2;
      for (i=0; i<n*n; i++)
        *Psmb2++=*(smb1.matrice)++;
      return smb2;
      }
    /*-------------------------------------------------------------------------
    /*-------------------------------------------------------------------------
    /* Transposition
      Calcule la transposition d'un symbole.
      La matrice rsultante est la mme.
    	smb1, smb2      : data matrix des symbole source et cible,
    	Psmb2           : pointeur sur le symbole cible
    	n               : taille des symboles.
    
    data_matrix Transposition_SMB(data_matrix smb)
      {
      data_matrix smb2;
      unsigned long n;
    
      smb2.taille=n=smb.taille;
      smb2.matrice=malloc (n*n*sizeof(unsigned char));
      if (smb2.matrice==NULL)
        {
        Erreur("Erreur d'allocation (ref. 749)");
        return smb;
        }
      if (!Transposition_MAT(smb.matrice,smb2.matrice,n,n))
        {
        Erreur("Erreur  la transposition (ref. 758)");
        free(smb2.matrice);
        return smb;
        }
      LibereSymbole(smb);
      return smb2;
      }
    /*-------------------------------------------------------------------------
    /* Rotation 90
      Calcule la rotation modulo 90 d'un symbole.
      La matrice rsultante est la mme.
    	smb1, smb2      : data matrix des symbole source et cible,
    	Psmb2           : pointeur sur le symbole cible,
    	n               : taille des symboles,
    	rotat, rot	: nombre de rotations  faire
    
    data_matrix Rotation_SMB(data_matrix smb, char rotat)
      {
      data_matrix smb2;
      int n;
      if (!rotat%4)
        return smb;
      smb2.taille=n=smb.taille;
      smb2.matrice=malloc (n*n*sizeof(unsigned char));
      if (smb2.matrice==NULL)
        {
        Erreur("Erreur d'allocation (ref. 785)");
        return smb;
        }
      if (!Rotation_mod90_MAT(smb.matrice,smb2.matrice,n,rotat))
        {
        Erreur("Erreur  la transposition (ref. 790)");
        free(smb2.matrice);
        return smb;
        }
      LibereSymbole(smb);
      return smb2;
      }
    /*-------------------------------------------------------------------------
    /* ConvCompar
      Compare un symvbole avec un autre. Rend la quantit de cases communes dans la partie interne et dans la zone de reprage.
    	smb1, smb2      : data matrix des symbole 1 et 2,
    	Psmb2           : pointeur sur le symbole 2,
    	n               : taille des symboles.
    
    char ConvCompar(data_matrix smb1, data_matrix smb2)
      {
      unsigned long compteur_int=0, compteur_periph=0;
      bipoint fenetre={0,354,639,421};
      char *(PCvaleurs[9]);
      char *Cval0, *Cval1;
      char *(Pnoms[9]);
      char nom1[32]="Frquence :      ", nom4[32]="Surface :        ", nom7[32]="Surface (%) :    ",
           nom2[32]="S. com. :        ", nom5[32]="S. int. :        ", nom8[32]="S. priph. :     ",
           nom3[32]="Err. totale (%) :", nom6[32]="Err. interne (%) :",nom9[32]="Err. priph. (%) :";
      char i;
      unsigned int n=smb1.taille;
      unsigned long S=n*n, Si=(n-2)*(n-2), Sp=4*(n-1);
      unsigned long Delta;
      float Eci, Ecp, Ect;
    
      if (!Compar(smb1, smb2, &compteur_int, &compteur_periph))
        {
        Erreurr("Echec de la compraraison",748);
        return ECHEC;
        }
      Delta=compteur_periph+compteur_int;
      Eci=1.0-(float)compteur_int/Si; Ecp=1.0-(float)compteur_periph/Sp; Ect=1.0-(float)Delta/S;
      Cval0=malloc(32*sizeof(char));
      if (Cval0==NULL) {Erreur("Erreur d'allocation (ref. 763)");return ECHEC;}
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 765)");return ECHEC;}
    
      Pnoms[0]=nom1;
      PCvaleurs[0]=strcpy(Cval1, itoa(n, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 7618)");return ECHEC;}
      Pnoms[1]=nom2;
      PCvaleurs[1]=strcpy(Cval1, itoa(S-Delta, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 773)");return ECHEC;}
      Pnoms[2]=nom3;
      PCvaleurs[2]=strcpy(Cval1, gcvt(100.0-Ect*100,4, Cval0));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 777)");return ECHEC;}
      Pnoms[3]=nom4;
      PCvaleurs[3]=strcpy(Cval1, itoa(S, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 781)");return ECHEC;}
      Pnoms[4]=nom5;
      PCvaleurs[4]=strcpy(Cval1, itoa(Si-compteur_int, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 785)");return ECHEC;}
      Pnoms[5]=nom6;
      PCvaleurs[5]=strcpy(Cval1, gcvt(100.0-Eci*100,4, Cval0));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 792)");return ECHEC;}
      Pnoms[6]=nom7;
      PCvaleurs[6]=strcpy(Cval1, itoa(100, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 797)");return ECHEC;}
      Pnoms[7]=nom8;
      PCvaleurs[7]=strcpy(Cval1, itoa(Sp-compteur_periph, Cval0, 10));
      Cval1=malloc(32*sizeof(char));
      if (Cval1==NULL) {Erreur("Erreur d'allocation (ref. 801)");return ECHEC;}
      Pnoms[8]=nom9;
      PCvaleurs[8]=strcpy(Cval1, gcvt(100.0-Ecp*100,4, Cval0));
    
      AffTabDonneesAdapt ("Quantits communes et erreurs", 3, 3, Pnoms,
    		      PCvaleurs, fenetre);
      Att_sour_clav();
      Eff_fen(fenetre.gauche, fenetre.haut, fenetre.droit, fenetre.bas);
      for(i=8;i>=0;i--)
        {
        free(PCvaleurs[i]);
        if (i>8) {Erreurr("Erreur structurelle.",812);return ECHEC;}
        }
      free(Cval0);
      return SUCCES;
      }
    
    /*-------------------------------------------------------------------------
    char Compar(data_matrix smb1, data_matrix smb2, unsigned long *Pdelta_int, unsigned long *Pdelta_ext)
      {
      unsigned char *Msmb2=smb2.matrice, *Msmb1=smb1.matrice;
      unsigned int n1, n2, i, j;
      unsigned long compteur_int=0, compteur_ext=0;
    
    
      n1=smb1.taille;
      n2=smb2.taille;
      if (n1 != n2)
        {
        Erreurr("Les tailles ne sont pas identiques.",752);
        return ECHEC;
        }
    
      for (i=1; i<n1-1; i++)
        for (j=1; j<n1-1; j++) /* Comparaison des zones internes. 
          if (Msmb1[i*n1+j]!=Msmb2[i*n1+j])
    	compteur_int++;
    
       for (i=0; i<n1; i++)
        {
        if (Msmb1[i*n1]!=Msmb2[i*n1])
          compteur_ext++;
        if (Msmb1[i*n1+n1-1]!=Msmb2[i*n1+n1-1])
          compteur_ext++;
        }
       for (j=1; j<n1-1; j++)
         {
        if (Msmb1[j]!=Msmb2[j])
          compteur_ext++;
        if (Msmb1[(n1-1)*n1+j]!=Msmb2[(n1-1)*n1+j])
          compteur_ext++;
        }
      *Pdelta_int=compteur_int;
      *Pdelta_ext=compteur_ext;
    
      if (compteur_int+compteur_ext > n1*n1)
        {
        Erreurr("Erreur grave d'algorithme.", 779, INTEMPESTIF);
        return ECHEC;
        }
      else
        return SUCCES;
      }
    /*-------------------------------------------------------------------------
    /* AffcontenuTxt (Affichage contenu texte)
      Affichage du contenu d'un symbole sous forme de texte.
    
      L'ensemble des bits de la matrice
    est regroup en octets (ie en caractres).
    
    Le bit manquants au dernier octets est 0 ou 1 remplac par ' ' ou '_'.
    
      smb       : data matrix  diter,
      n         : taille de la matrice,
      n_oct     : nombre d'octets contenus dans la matrice.
    
    void AffContenuTxt (data_matrix smb, int lgn)
      {
      int n=smb.taille, n_oct=(n-2)*(n-2)/8+1;
      unsigned char *Psmb=smb.matrice;
      char *catalogos;
    
      if (Psmb==NULL)
        Erreurr("Tentative d'affichage d'un symbole nul.",832,TERMINAL);
      if (n > 197)
        Aff_mes_cent (NIVEAUMESSAGE,"Il n'y a pas la place pour l'affichage textuel");
      else
        {
        clearviewport();
    /* Le remplissage de l'espace numrique et/ou textuel passe par le
    regroupement en octets. C'est la fonction Octavisation. 
        catalogos = malloc (n_oct+1 * sizeof(char));
        if (!Octavisation(smb,catalogos, n_oct))
          {
          Erreurr("Echec d'octavisation.",746);
          return;
          }
        AffContenuTxt_oct (catalogos, n_oct, lgn);
        free(catalogos);
        }
      Att_sour_clav();
      clearviewport();
      }
    /*-------------------------------------------------------------------------
    /*-------------------------------------------------------------
    /*		       fonctions locales                       
    /*-------------------------------------------------------------
    int DemandezoTaille_SMB(void)
      {
      int n=0;
    /*  if (P_execution_predefinie!=NULL)
        return P_execution_predefinie->frequence; */                   /*
      do
        {
        Ent_mes_val(buf,"Taille du symbole ? (frquence; impaire ou 0): ");
        sscanf(buf,"%d",&n);
        }
      while (n<0 || (n && !(n&1)) || n==1);   /* n est impair et suprieur  2 
      return n;
      }
    */
    /* RAZ_MAT
    Renvoit la...Initialise une matrice  zro :
    	taille : 1x1;
    	contenu de la matrice : BLANC.
      La matrice est alloue par la procdure elle-mme.
    
    data_matrix RAZ_MAT (void)
      {
      data_matrix zero;
      zero.taille = 1;
      if ((zero.matrice= malloc(1))==NULL) Erreurr("Erreur d'allocation",1371,TERMINAL);
      (zero.matrice)[0]=0;
      return zero;
      }
    
    /* GeneSpont_MAT
      Gnration d'une matrice de manire alatoire quiprobable indpendante
    (AEI). Cette fonction reoit la taille de la matrice de donne, alloue
    la matrice de donne et la remplie.
      La matrice est alloue par la procdure elle-mme.
    
      mat   : data matrix rsultat,
      pmat  : pointeur sur la matrice de mat.
      n     : taille de la matrice.
    */
    void TDataMatrix::GenerationSpontanee(unsigned int f)
      {
      if (!f)
        f=wFrequence;
      else
        Set(f);
      randomize();
      for (f=0; f<wFrequence*wFrequence; f++)
        Matrice[f]=random(2); /* 0 ou 1 font blanc ou noir. */
      }
    /*
    data_matrix GeneSpont_MAT (int n)
      {
      int i;
      unsigned char *pmat;
      data_matrix mat;
    
      randomize();
      if (((mat.matrice)= malloc (n*n*sizeof(unsigned char)))==NULL)
        {
        Erreur("Erreur d'allocation (ref. 799)");
        return RAZ();
        }
      pmat=mat.matrice;
      mat.taille=n;
      for (i=0; i<n*n; i++)
        pmat[i]=random(2); /* 0 ou 1 font blanc ou noir. 
      return mat;
      }
    /*----------------------------------------------------------------------
    /* Alloue_MAT
      Gnration d'une matrice de taille spcifie et vide (tous lments  0).
      La matrice est alloue par la procdure elle-mme.
    
      mat   : data matrix rsultat,
      pmat  : pointeur sur la matrice de mat.
      n     : taille de la matrice.
    
    data_matrix alloue_MAT (int n)
      {
      unsigned char *pmat;
      data_matrix mat;
      int i;
    
      pmat= malloc (n*n);
      if (pmat==NULL) Erreurr("Erreur d'allocation",1340,TERMINAL);
      mat.matrice = pmat;
      mat.taille=n;
      for (i=0; i<n*n; i++)
        pmat[i]=0;
      return mat;
      }
    /*----------------------------------------------------------------------*/
    /* Encadrement
    Mise d'un cadre autour d'une matrice.
    
      La procdure prend la matrice du data matrix : taille + tableau
    de donnes carr de hauteur impaire et construit le symbole
    en rajoutant les deux rails et les crneaux.
      La matrice est alloue par la proc. elle-mme.
      mat   : data matrix de la matrice source;
      pmat  : pointeur sur la matrice mat;
      smb   : data matrix du symbole rsultat;
      Psmb  : pointeur sur le symbole rsultat;
      n             : taille de la matrice source;
      k             : taille du symbole (k=n+2).
    */
    BIT TDataMatrix::Encadrement ()
      {
      unsigned char *Psmb;
      int i=0, j=0, k=0;
    
      if (!Matrice && wFrequence)
        return MErreur("Tentative d'encadrement d'une matrice nulle.",1344);
      k=wFrequence+2; // is 2 if matrix is NULL (empty).
      if ((Psmb=(unsigned char *)malloc(k*k * sizeof(unsigned char)))==NULL)
        {
        Set();
        return MErreur("Erreur d'allocation",1426);
        }
      for (i=0; i<wFrequence; i++)
        for (j=0; j<wFrequence; j++)
          Psmb[(j+1)+(i+1)*k]=Matrice[j+i*wFrequence]; // No pass if  matrix is NULL (empty).
      for (i=0; i<k; i++)
        {
        Psmb[k*i]=NOIR; // 1e colonne
        Psmb[i+(k-1)*k]=NOIR; // ligne bas
        Psmb[i]=(i+1)%2; /* Ligne haut. i=0 (rail) fait 1 (noir) et ainsi de suite. */
        Psmb[(k-1)+i*k]=(i+k)%2; // Colonne droite. Astuce !
        }
      if (Matrice) free(Matrice);
      wFrequence=k;
      Matrice=Psmb;
      return SUCCES;
      }
    /*
    char Fabrique_SMBvBMP(char *filename, unsigned char *image)
      {
      char *loc;
      data_matrix symbole;
    
      if (!chem_nom_fichier_conforme(filename))
        {
        Erreurr ("Le nom de fichier n'est pas conforme.",127);
        return ECHEC;
        }
      if (!Extension_nom_etendu_est(filename,"smb"))
        {
        Erreurr ("Erreur dans l'extension du fichier (doit tre \".SMB\".",129);
        return ECHEC;
        }
      symbole=ChargeSymbole(filename,VRAI);
      if (!PreVisu2(symbole, image,'I'))
        {
        Erreurr("Erreur lors de la prvisualisation.",700);
        LibereSymbole(symbole);
        return ECHEC;
        }
      loc=strrchr(filename,'.');
      strcpy(loc+1,"bmp");
      Ecr_bmp(filename, image);
      LibereSymbole(symbole);
      return SUCCES;
      }
    /*-------------------------------------------------------------------------
    char FabriqueTP_SMBvBMP(char *filename, unsigned char *image)
      {
      char res;
      tracage=ARRET;
      P_execution_predefinie=NULL;
      res= Fabrique_SMBvBMP(filename, image);
      Eff(image);
      return res;
      }
    /*-------------------------------------------------------------------------
    void LibereSymbole(data_matrix smb)
      {
      if (smb.matrice == NULL)
        {
        Erreurr("Libration symbole impossible, risque de problme perte du noyau.",907);
        return;
        }
      else
        free(smb.matrice);
      }
    
    /*-------------------------------------------------------------
    /* Frise
      Renvoit une chane de caractre de longueur n remplie du caractre 178.
      La chane est alloue par la proc. elle-mme. 
    char *Frise (int n)
      {
      char *diazoma;
      int i;
    
      diazoma = malloc ((n+1)*sizeof(char));
      if (diazoma==NULL)
        {
        Erreur("Erreur d'allocation (ref. 1557)");
        return NULL;
        }
      diazoma[n]=0;
      for(i=0; i<n; i++)
        diazoma[i]=178;
      return diazoma;
      }
    /*-------------------------------------------------------------
    /* CoulDeCarGraph
      Renvoit le caractre  afficher (lors de l'affichage graphique sur cran)
    correspondant  la valeur du bit d'un symbole.
     La fonction concerne l'cran et renvoit un espace pour NOIR (1)
    et un pav pour BLANC (1). 
    char CoulDeCarGraph (unsigned char v)
      {
      if (v==NOIR)
        return 32;
      else if (v==BLANC)
        return 219;
      else
        {
        Erreurr("Couleur inconnue.",946,LEGER);
        return 176;
        }
      }
    
    /*-------------------------------------------------------------
    /* CoulDeCarASCII
      Renvoit le caractre  afficher (lors de la sortie sur fichier)
    correspondant  la valeur du bit d'un symbole.
     La fonction concerne l'cran et renvoit un espace pour NOIR (1)
    et un pav pour BLANC (1). 
    char CoulDeCarASCII (unsigned char v)
      {
      if (v==NOIR)
        return ''; /* 219 
      else if (v==BLANC)
        return ' ';
      else
        {
        Erreurr("Couleur inconnue.",965,LEGER);
        return ''; /* 176 
        }
      }
    
    /*-------------------------------------------------------------*/
    /* CouleurDePoint
      Renvoit le niveau de gris  afficher sur le moniteur correspondant
     la valeur du bit d'un symbole.
      Cas "vido" : V=VIDEO :
     La fonction concerne l'cran et renvoit 32 (gris fonc) pour NOIR (1),
    255 pour BLANC (1).
      cas "imprssion" : V=IMPRESSION ou ECRAN :
     La fonction concerne l'cran et renvoit 0 pour NOIR (1),
    255 pour BLANC (1). */
    
    unsigned char CouleurDePoint (unsigned char u, unsigned char uType)
      {
      switch (u)
        {
        case NOIR :
          switch  (uType)
            {
            case VIDEO :
              return 32;
            case IMPRESSION :
            case ECRAN :
              return 0;
            default :
              return random(256);
            }
        case BLANC :
          switch  (uType)
            {
            case VIDEO :
            case IMPRESSION :
            case ECRAN :
              return 255;
            default :
              return random(256);
            }
        case NB_INCONNU :
        default :
          return random(256);
        }
      }
    
    /*-------------------------------------------------------------*/
    /* Octavisation
       Renvoit la chane de caractres correspondant au regroupement en octets
    des bits de la matrice (donc : sans le cadre). Bit NOIR : 1. Le dernier
    octet incomplet est complt avec 7 zros dans ses bits de poids fort.
       Les caractres peuvent tre non imprimables, des caractres
    internes peuvent tre nuls (donc '\0' n'est pas forcment le fin de la
    chane.
      La chane de caractres n'est PAS alloue par la proc. elle-mme.
    */
    BIT Octavisation (TDataMatrix *pSymbole, char *acListeOctets, long lNbOct)
      {
    //  int n=pSymbole->wFrequence;
      unsigned char *Psmb=pSymbole->Matrice;
      int i=0, j=0, k=0, l=0;
      char arithmos; /* Octet courant. */
    
      if (!pSymbole->Matrice || !acListeOctets)
        return MErreur("Tentative de lecture d'un symbole nul ou d'allocation",1271);
      /* (n-2)/8 est forcment non entier car (n-2) est un multiple de 8
      plus 1. */
      arithmos=0;
      k=0; l=0;
      for (i=0; i<pSymbole->wFrequence; i++)
        for (j=0; j<pSymbole->wFrequence; j++)
          if (i&&j&&(i!=pSymbole->wFrequence-1)&&(j!=pSymbole->wFrequence-1)) /* Si le bit n'est pas du cadre... */
    	{   // No pass if void symbol (2*2)
    	arithmos=arithmos<<1;
    	arithmos=arithmos | ( *Psmb++ & 1) ;
    	k++;
    	if (k==8) /* Si arithmos est rempli par un octet... */
    	  { /* ...alors on l'affiche. */
    	  k=0;
    	  if (l>=lNbOct)
    	    return Erreur("Incohrence d'origine extra-terrestre (appellez Fox Mulder) pour l=",l,1065);
    	  acListeOctets[l]=arithmos;
    	  l++;   /* Dcompte du nombre d'octets (premier octet : 0). */
    	  arithmos = 0;
    /* (ceci est ncessaire  cause du dernier octet incomplet) */
    	  }
    	}
           else
    	 Psmb++;
       /* Nous sommes sorti du symbole, il reste peut-tre sept bits dans
       arithmos qui n'ont pas t affects mais qui sont nuls. */
       if (l>lNbOct)
         return Erreur("Incohrence d'origine extra-terrestre (appellez Danna Scully) pour l=",l,1077);
       else if (l<lNbOct) // Nothing if l==lNbOct (including 0==0)
         acListeOctets[l]=arithmos;
      // Chane alloue  lNbOct+1.
    //   acListeOctets[l]=0;
       return SUCCES;
       }
    
    BIT TDataMatrix::MakeOutOfWrappedString(char *sz)
      {
      char *szTamp=(char *)malloc(strlen(sz)+1);
      strcpy(szTamp,sz);
      BIT fRes= (Dewrappe(szTamp) && MakeOutOfString(szTamp));
      free(szTamp);
      return fRes;
      }
    BIT TDataMatrix::MakeOutOfString(char *sz)
      {
      if (!sz || !CutTrailingSpaces(sz))
        return ECHEC;
      unsigned int wF=FrequencePourTantDOctets(strlen(sz));  // return 2 for 0. All right.
      unsigned int wNbOct=NbOctetsPourTelleFrequence(wF);  // returns 0 for 2. All right.
      unsigned char *acListeCar=(unsigned char *)malloc(wNbOct+1);
      strcpy((char *)acListeCar, sz); // Unable to copy last '\0' if strlen(sz)==wNbOct
      for (unsigned int w=strlen(sz);w<wNbOct;w++)
        acListeCar[w]=' ';  // ' ' padding
      BIT fRes;
      if (!Binarisation(acListeCar,wF) || !Encadrement())
        {
        fRes=ECHEC;
        Set();
        }
      else
        fRes=SUCCES;
      free(acListeCar);
      return fRes;
      }
    /*-------------------------------------------------------------*/
    /* Binarisation
       Renvoit la liste de bits (unsigned char) correspondant  la dcomposition
    en binaire d'une liste d'octets (char).
      La matrice est alloue par la proc. elle-mme.
    
      mat :		matrice cible,
      n_oct :	nombre d'octets,
      n :		taille du symbole final,
      n_mat		taille de la matrice finale (n-2),
      k :		nombre de bits  lire (8*n_oct),
      k_mat :	nombre de bits de la matrice (n_mat=k_mat, k_mat = k-7),
      pmat :	pointeur sur la matrice,
      dromeus :	pointeur qui parcours pmat.
      */
    BIT TDataMatrix::Binarisation(unsigned char *acListeCaracteres, int iFreq)
      {
      int iFreqMat=0, d=0, i=0;
      unsigned char masque=0, arithmos, *dromeus;
    
    //  iNbOct=NbOctetsPourTelleFrequence(iFreq);
      iFreqMat=iFreq-2;
      if (iFreqMat<0)
        return MErreur("Asked for a negative sized matrix",1380); // The matrix is null
      if (wFrequence!=iFreqMat)
        Set(iFreqMat);
      if (!iFreqMat)
        return SUCCES; // Asked for a void matrix.
      if (Matrice==NULL)
        return MErreur("Erreur d'allocation",1696);
      dromeus=Matrice;
      masque=128;
    //  for(i=0; i<iNbOct-1; i++)
      for(i=0; i<iFreqMat*iFreqMat;)
        {
        arithmos = *acListeCaracteres++;
        for(d=0; d<8 && i<iFreqMat*iFreqMat; d++) /* Pour tous les bits... */
          {
          *dromeus++=(arithmos&masque)>>7; /* ...rcupration du premier bit... */
          arithmos=arithmos<<1; /* ...et dcalage. */
          i++;
          }
        }
      return SUCCES;
      }
    
    
    /*-------------------------------------------------------------
    /* CarAutFich (Caractre autoris dans fichier ASCII)
      Renvoit le caractre lui mme s'il est imprimmable, un code
    conventionnel dans les autres cas. Pour l'dition en fichier texte,
    accessible  l'impression, les caractre 0  31 ne sont pas autoriss, sauf
    les caractres 10 et/ou 13 dans les fichiers texte.
      stoicheion : le caractre. 
    char CarAutFich (char car)
      {
      unsigned char stoicheion;
    
      stoicheion = car;
    
      if (stoicheion<7)
        return 3;
      else if (stoicheion<15)
        return 4;
      else if (stoicheion<23)
        return 5;
      else if (stoicheion<31)
        return 6;
      else
        return car;
      }
    
    /*-------------------------------------------------------------*/
    /* IsWrappingSeparator (Caractre de csure)
      Renvoit 1 (vrai) si le caractre soumis est un caractre sur lequel on
    peut couper une ligne (espace, ponctuation...) et 0 (faux) sinon.
      On sait que le caractre est typographique.
      Renvoit FAUX pour "\0".*/
    BIT IsWrappingSeparator(char c)
      {
      switch (c)
        {
        case 32  : /* Caractre ' ' */
        case '!' :
        case '#' :
        case '$' :
        case '%' :
        case '&' :
        case ')' :
        case '*' :
        case ',' :
        case '-' :
        case '.' :
        case 47  : /* le caractre '/' */
        case ':' :
        case ';' :
        case '?' :
        case 91  :
        case 92  : /* le caractre '\' */
        case ']' :
        case '_' :
        case '|' :
        case '}' :
        case '~' :
        case 127 : /* caractre vide */
        case '' :
        case '' :
        case '' :
        case -1  : /* caractre 255 : ' ' */
    	       return VRAI;
        default  :
    	       return FAUX;
        }
      }
    
    /*-------------------------------------------------------------*/
    /* PrendRefLec (Prend la rfrence de lecture)
      Renvoit la forme de rfrence. Dans un fichier, le symbole est
    code sous trois formes. La forme de rfrence est la forme qui est valide.
    Les autres peuvent tre quelconques, voire non conforme  la syntaxe. */
    enum REF_LEC PrendRefLec(char *ligne)
      {
      if (ligne == NULL)
        return ERR;
    
      while (*ligne != ':')
        if (*ligne==0)
          return ERR;
        else
          ligne++;
      /* ligne est avanc jusqu'au ':'. */
    
      ligne++;
    
      return ReconnRefLec(ligne);
      }
    
    /*-------------------------------------------------------------*/
    /* ReconnRefLec (Reconnat la rfrence de lecture)
      Renvoit la rfrence de lecture d'une ligne.
      La ligne a un certain nombre d'espaces puis la rfrence.
      La rfrence peut tre suivie d'un espace et de texte. */
    enum REF_LEC ReconnRefLec(char *ligne)
      {
      char c1, c2, c3, c4;
    
      ligne = CompactEspace(ligne);
    
      if (ligne == NULL)
        return ERR;
    
      if (strlen(ligne)<3)
        {
        free(ligne);
        return ERR;
        }
    
      c1=ligne[0];
      c2=ligne[1];
      c3=ligne[2];
      c4=ligne[3];
      free(ligne);
      if (!IsSeparator(c4)) /* La rfrence doit tre suivie d'un
    				  sparateur ou d'une fin de ligne. */
        return ERR;
    
      if ( (c1=='S')&&(c2=='T')&&(c3=='D') )
        return STD;
      else  if ( (c1=='M')&&(c2=='A')&&(c3=='T') )
        return MAT;
      else  if ( (c1=='N')&&(c2=='U')&&(c3=='M') )
        return NUM;
      else  if ( (c1=='T')&&(c2=='X')&&(c3=='T') )
        return TXT;
      else
        return ERR;
      }
    /*-------------------------------------------------------------------------
    /* AffcontenuTxt_oct (Affichage contenu texte octets)
      Affichage du contenu d'un symbole sous forme de texte  partir du symbole en octets.
    
      L'ensemble des bits de la matrice
    est regroup en octets (ie en caractres).
    
    Le bit manquants au dernier octets est 0 ou 1 remplac par ' ' ou '_'.
    
      smb       : data matrix  diter,
      n         : taille de la matrice,
      n_oct     : nombre d'octets contenus dans la matrice;
      lgn 	    : n de la premire ligne (de 0  59)
    
    void AffContenuTxt_oct (char *catalogos, int n_oct, int lgn)
      {
      int i, l_recul, couleur_origine, l;
      int numero_ligne; /* numro de la ligne en cours d'affichage 
      char stoicheion, stichos[LONG_LGN_ECR+1];
      char pseudo_texte, affichage_non; /* boolens 
      unsigned char val_stoicheion;
    
      if (catalogos==NULL)
        Erreurr("Tentative de viol d'un symbole nul.",1436,TERMINAL);
      if (n_oct > 4800)
        Erreurr("Il n'y a pas la place pour le texte demand.",1438);
      else
        {
        couleur_origine=getcolor();
        setcolor(WHITE);
    /* Remplissage de l'espace textuel 
        if (catalogos[n_oct-1]) /* si le dernier octet est non nul 
          catalogos[n_oct-1]='_';
        else
          catalogos[n_oct-1]=' ';
    
    /* Test : la matrice porte t'elle un vrai texte (tous caractres sont
    typographiques) ou un pseudo-texte (certains
    sont graphiques ou non-imprimmables). 
        pseudo_texte=FAUX;
        for(l=0; l<n_oct; l++)
          {
          stoicheion=catalogos[l];
          val_stoicheion=stoicheion;
    /* stoicheion reprsente le caractre (char),
       val_stoicheion reprsente son code ASCII (unsigned char). 
          if (  (val_stoicheion <= 31)
    	 || ( (val_stoicheion >= 176)&&(val_stoicheion <= 223) )
    	 || (val_stoicheion == 244)
    	 || (val_stoicheion == 245)
    	 )
    	 {pseudo_texte=VRAI; l=n_oct;}
          }
    
        affichage_non=VRAI;
        while (affichage_non)
          {
          numero_ligne=lgn;
          l=0;
          while (l<n_oct) /* Tant qu'il reste des lignes... 
    	{
    	i=0;
    	while ((i<LONG_LGN_ECR)&&(l<n_oct))
    	  stichos[i++]=CarAutAff(catalogos[l++]); /* "LONG_LGN_ECR"=80 caract. dans la lgn. 
    	stichos[i]=0;
    	/* A la sortie de cette boucle, l pointe sur le caractre suivant. 
    	if (pseudo_texte)
    	  {
    	  outtextNxy(0, numero_ligne, stichos);
    	  numero_ligne++;
    	  }
    	else
    	  {
    	  l_recul=l;
    	  while ((i>0) && (!(CarCesure(stichos[i])))) /* Recherche d'un point de csure. 
    	    {i--; l_recul--;} /* Recul d'i et d'l d'1. 
    	  /* i et l_recul pointent sur le dernier sparateur de stichos, ou
    	 sur la premire lettre de stichos. 
    	  if (i==0)
    	  /* i pointe sur la premire lettre, il n'y a pas de caractre
    	  de csure dans la ligne. 
    	    {
    	    outtextNxy(0, numero_ligne, stichos);
    	    numero_ligne++;
    	    }
    	  else
    	  /* i et l_recul pointent sur un caractre de csure .
    	    {
    	    if (i+1<0 || i+1 >= LONG_LGN_ECR+1)
    	      {
    	      Erreur("Incohrence incohrente (LSYMBOLE) i+1=",i+1,1385);
    	      return;
    	      }
    	    stichos[i+1]=0; /* Fermeture de la chane aprs ce caractre. 
    	    outtextNxy(0, numero_ligne, stichos);
    	    l=l_recul+1; /* Acceptation du recul, l pointe sur le suivant du
    			 caractre de csure. 
    	    numero_ligne++;
    	    }
    	  }
    	}
          /* Toutes les lignes ont t affiches. 
          if (numero_ligne<haut_col_ecr)
          /* La dernire ligne du texte est hors cran, on recommence
          l'affichage en pseudo-texte (format sous lequel tout le texte rentre). 
    	{affichage_non = 0; pseudo_texte=1;}
          }
        setcolor(couleur_origine);
        }
      }
    /*-------------------------------------------------------------------------*/
    /* TextualiseListeOctets (Textualise Liste Octets)
      Fabrique une chaine de caractres imprimmables  partir d'une liste
    d'octets.
    
      L'ensemble des bits de la matrice
    est regroup en octets (ie en caractres).
    
    Le bit manquants au dernier octets est 0 ou 1 remplac par ' ' ou '_'.
    
      smb       : data matrix  diter,
      n         : taille de la matrice,
      n_oct     : nombre d'octets contenus dans la matrice;
      lgn 	    : n de la premire ligne (de 0  59)
    */
    BIT TextualiseListeOctets (char *acListeOctets, float xNbOctets)
      {
      int l=0; unsigned int wNbOctets=NCeilR(xNbOctets);
      if (!acListeOctets)
        return MErreur("Tentative de viol d'un symbole nul.",1436);
      else
        {
    /* Remplissage de l'espace textuel */
        if (wNbOctets!=NFloorR(xNbOctets)) /* si le dernier octet est non nul */
          acListeOctets[wNbOctets-1]=' ';
    
        for(l=0; l<wNbOctets; l++)
    //      stoicheion=catalogos[l];
      //    val_stoicheion=stoicheion;
    /* stoicheion reprsente le caractre (char),
       val_stoicheion reprsente son code ASCII (unsigned char). */
    /*      if (  (val_stoicheion <= 31)
    	 || ( (val_stoicheion >= 128)&&(val_stoicheion <= 144) )
    	 || ( (val_stoicheion >= 147)&&(val_stoicheion <= 160) )
    	 ) */
          acListeOctets[l]=CarAutAff(acListeOctets[l]);
        return SUCCES;
        }
      }
    /*-------------------------------------------------------------------------*/
    /* NumeraliseListeOctets (Numeralise Liste Octets)
      Fabrique une chaine de caractres contenant l'ensemble des valeurs des
    octets  partir d'un tableau d'octets.
    
    */
    BIT NumeraliseListeOctets (char *szTexteNum, char *acListeOctets, unsigned int wNbOct)
      {
      unsigned int l=0;
      char szTamp0[20];
    //  char stoicheion;
    //  unsigned char val_stoicheion;
      if (!acListeOctets || !szTexteNum)
        return MErreur("Tentative de viol d'un symbole nul.",1767);
      else
        {
        *szTexteNum=0;
        for(l=0; l<wNbOct; l++)
          strcat(strcat(szTexteNum,itoa((unsigned char)acListeOctets[l],szTamp0,10))," ");
        return SUCCES;
        }
      }
    /*-------------------------------------------------------------------------*/
    
    inline int OrdreFinDeLigneWrapping(unsigned int wNCdL, unsigned int wNombreCarParLgn)
      {
      return wNCdL>wNombreCarParLgn;
      }
    
    unsigned int CalculeFinDeLigne(char *LongText, unsigned int wNombreCarParLgn, unsigned int wlt)
      {
      if (!LongText || !wNombreCarParLgn  || !wlt)
        return MErreur("Erreur chanes vide",1774);
      else if (wNombreCarParLgn>= wlt)
        return wlt;
      else
        {
        unsigned int wNombreCarCetteLgn= wNombreCarParLgn;
        while(!IsWrappingSeparator(LongText[wNombreCarCetteLgn]) && wNombreCarCetteLgn)
          wNombreCarCetteLgn--;
        if (!wNombreCarCetteLgn)
          return wNombreCarParLgn;
        else
          return wNombreCarCetteLgn;
        }
      }
    BIT Dewrappe(char *szLongText)
      {
      unsigned int wS=0, wD=0;
      while (szLongText[wS])
        {
        if (szLongText[wS]!='\r' && szLongText[wS]!='\n')
          szLongText[wD++]=szLongText[wS];
        wS++;
        }
      szLongText[wD]=0;
      return SUCCES;
      }
    // wwt is at least one more than wlt to store last '\n'.
    BIT WrappText (char *LongText,unsigned int wlt,char *WrappedText,
        unsigned int wwt, unsigned int wNombreCarParLgn,
        unsigned char uTypeWrapping)
      {
      if (!wlt && wwt && WrappedText) // Ask to wrap a null text
        {
        *WrappedText=0;
        return SUCCESS;
        }
      if (!LongText || !WrappedText || !wwt || !wNombreCarParLgn)
        return ECHEC;
    
      unsigned int wNCdLT=0; // N de caractre dans le texte complet.
      unsigned int wNCdWT=0; // N de caractre dans le "wrapped" texte .
      unsigned int wNCdL=0; // N de caractre dans la ligne.
      unsigned int wNombreCarCetteLgn=wNombreCarParLgn;
      while (1)
        {
        wNCdL=0;
    //    while (wNCdL++<=wNombreCarParLgn)
        if (uTypeWrapping!=CONTINUOUS_WRAPPING)
          wNombreCarCetteLgn=CalculeFinDeLigne(LongText+wNCdLT,wNombreCarParLgn,wlt-wNCdLT);
        while (!OrdreFinDeLigneWrapping(wNCdL++,wNombreCarCetteLgn))
          {
          if (wNCdWT>=wwt-1) // Dernier caractere de la chane resultat.
            {
            WrappedText[wwt-1]=0;
            return ECHEC;
            }
          else if (wNCdLT==wlt) // Chane initiale sans zero terminal.
            {
            WrappedText[wNCdWT]=0;
            return SUCCES;
            }
          else if (!LongText[wNCdLT]) // Fin de chane source.
            {
            WrappedText[wNCdWT]=0;
            return SUCCES;
            }
          WrappedText[wNCdWT++]=LongText[wNCdLT++];
          }
        if (wNCdWT>=wwt-1)
          {
          WrappedText[wwt-1]=0; // wwt is
          return ECHEC;
          }
        else if (!LongText[wNCdLT])
          {
          WrappedText[wNCdWT]=0; // Coincidence fin de ligne - fin de chane.
          return SUCCES;
          }
        else
          {
          WrappedText[wNCdWT++]='\r';
          WrappedText[wNCdWT++]='\n';
          }
        }
      }
        /*
      numero_ligne=0;
      l=0;
      while (l<n_oct) /* Tant qu'il reste des lignes... 
        {
        i=0;
        while ((i<LONG_LGN_IMP )&&(l<n_oct))
          stichos[i++]=CarAutFich(catalogos[l++]); /* "LONG_LGN_IMP "=78 caract. dans la lgn. 
        stichos[i]=0;
        /* A la sortie de cette boucle, l pointe sur le caractre suivant. 
        if (pseudo_texte)
          {
          fprintf(Pexetasis, "%s\n", stichos);
          numero_ligne++;
          }
        else
          {
          l_recul=l;
          while ((i>0) && (!(CarCesure(stichos[i])))) /* Recherche d'un point de csure. 
    	{i--; l_recul--;} /* Recul d'i et d'l d'1. 
          /* i et l_recul pointent sur le dernier sparateur de stichos, ou
          sur la premire lettre de stichos. 
          if (i==0)
          /* i pointe sur la premire lettre, il n'y a pas de caractre
          de csure dans la ligne. 
    	{
    	fprintf(Pexetasis, "%s\n", stichos);
    	numero_ligne++;
    	}
          else
          /* i et l_recul pointent sur un caractre de csure .
    	{
    	stichos[i+1]=0; /* Fermeture de la chane aprs ce caractre. 
    	fprintf(Pexetasis, "%s\n", stichos);
    	l=l_recul+1; /* Acceptation du recul, l pointe sur le suivant du
    		     caractre de csure. 
    	numero_ligne++;
    	}
          }
        }
      /* Toutes les lignes ont t affiches. 
      free(stichos);
      free(catalogos);
      fclose(Pexetasis);
      return SUCCES;
      }
    */
    
    /* Acquier2Int (Prend la valeur)
      Renvoit la donne situe aprs le premier ':' dans une chane de
    caractre. Renvoit -1 en cas d'erreur.*/
    /* AcquierInt (Acquier int)
      Lit la donnee situee aprs le premier ':' dans une chane de
    caractre. Renvoit SUCCES ou ECHEC.
      Le nombre doit tre suivie d'un sparateur ou d'une fin de ligne.
      Conformment  d'anciennes spcifications, pValue est mis  -1 en cas
    d'erreur.
      Le pointeur "next" pointe aprs le sparateur ou sur NULL.
      Format autoris :
        des caractres quelconques sauf ':', ":", des espaces, un signe "+" ou
    "-", des chiffres, un sparateur (' ', '!', '.', ',', ':' ou ';') ou fin de
    ligne, et la suite est quelconque.
      Tout ce qui est aprs le ":" est trait par ExtractValue.
    */
    BIT AcquierInt (char *szLigne, int *pValue, char * *pNext)
      {
      unsigned int wNb=0;
    
      if (szLigne == NULL)
        {
        *pValue=-1;
        *pNext=NULL;
        return ECHEC;
        }
    
      while (szLigne[wNb] != ':')
        if (szLigne[wNb]==0)
          {
          *pValue=-1;
          *pNext=szLigne;
          return ECHEC;
          }
        else
          wNb++;
      /* szLigne est avanc jusqu'au ':'.   */
      return ExtractValue(szLigne+wNb+1, pValue,pNext);
      }
    int Acquier2Int (char *ligne) // Ex PrendVal
      {
      char *pcNext=NULL;
      int iRes;
      if (AcquierInt (ligne, &iRes, &pcNext))
        return iRes;
      else
        return -1;
      }
    //#if 0
      /* ChargeSymbole (Chargement d'un symbole)
      Lit dans un fichier un symbole unique selon le format dfinit
    dans la cahier de code. Seul le premier symbole du fichier est lu.
      En cas d'erreur terminale, un symbole vide est renvoy.
      Le symbole est allou par la procdure elle mme.
    
      n_oct : 	nombre d'octets,
      arithmos :    caractre courant,
      catalogos :	liste des octets,
      mat :		matrice rsulat.
      Psmb :	pointeur sur symbole rsultant,
      pmat		pointeur sur matrice rsultante (sans le cadre).
      */
    BIT ChargeSymboleAncienFormat (TDataMatrix *pSmb, char *szFileName, char fSymboleUnique)
      {
      FILE far *pExetasis; /* pointeur sur le fichier de chargement */
      char far *stichos, *rema;
      /* ligne courante, ligne aux espaces compacts et mot intermdiaire */
      int nombre_SMB, n, i, j, longueur_ligne, iNbOct, arithmos;
      enum REF_LEC ref, anaphero;
    //  TDataMatrix smb, *pmat;
    //  unsigned char *Psmb;
      unsigned char far *catalogos;
      if (!pSmb)
        return ECHEC;
    //  else
      //  pSmb->Set();
      if ((pExetasis=fopen (szFileName, "rt"))==NULL)
        return Erreur("Fichier de symbole non disponible: ",szFileName,249);
    /* Acquisition du nombre de symboles. */
      longueur_ligne=LONG_LGN_IMP ; /* Limite de la taille des lignes de la zone
    			prliminaire. */
    
      if (!fSymboleUnique)
        {
        stichos=fgetslline(pExetasis, longueur_ligne);
      /* (ligne non commentaire) */
        nombre_SMB = Acquier2Int(stichos);
        if (stichos != NULL) free(stichos);
        if (nombre_SMB<=0)
          {
    //      Erreur("Erreur au chargement lors de l'acquisition du nombre de symboles");
          MErreur("",1963);
          fclose(pExetasis);
          return ECHEC;
          }
        else if (nombre_SMB > 1)
    //      Erreur("Erreur au chargement : plusieurs symboles dtects");
          MErreur("",1969);
          /* Erreur non terminale, le premier symbole sera lu. */
        }
      nombre_SMB = 1;
    
    /* Acquisition du symbole unique. */
    /* Acquisition du nombre de symboles. */
      stichos=fgetslline(pExetasis, longueur_ligne);
      n = Acquier2Int(stichos);
      if (stichos != NULL) free(stichos);
      if (n<0)
        {
        MErreur("Erreur au chargement : taille lue non positive.",1982);
        fclose(pExetasis);
        return ECHEC;
        }
      else if (n==0) /* Taille adaptative */
        {
        stichos=fgetslline(pExetasis, longueur_ligne);
        ref = PrendRefLec(stichos);
        if (stichos != NULL) free(stichos);
        if (ref==ERR)
          {
    //      Erreur("Erreur au chargement : la forme de rfrence du symbole n'est pas claire.");
          fclose(pExetasis);
          return MErreur("",1995);;
          }
        else if (ref!=TXT)
          {
    //      Erreur("Erreur au chargement : la taille adaptative n'est permise qu'en texte.");
          fclose(pExetasis);
          return MErreur("",2001);
          }
        /* Taille adaptative en texte. */
        anaphero = ERR;
        /* Entre : stichos est libre. */
        stichos=(char *)malloc(longueur_ligne+2);
        while (anaphero!=TXT)
          {
          fgetlaline(pExetasis, longueur_ligne, stichos);
          anaphero=ReconnRefLec(stichos);
          }
        /* Texte localis et point */
        fgetlaline(pExetasis, longueur_ligne, stichos);
        /* Acquisition du '\n' restant. */
        iNbOct=fcontchar(pExetasis);
        if (iNbOct<0) MErreur("Anomalie inconnue", 317);
        n=2+NCeilR(sqrt(iNbOct*8));
        if ((n+1)%2) /* Si n+1 impair (n pair)... */
          n++; /* ...n est incrment. */
        fseek(pExetasis, 0, 0);
        anaphero = ERR;
        while (anaphero!=TXT)
          {
          fgetlaline(pExetasis, longueur_ligne, stichos);
          anaphero=ReconnRefLec(stichos);
          }
        /* Le fichier est repositionn sur la dclaration de la rfrence. */
        free(stichos);
        }
      else if ((n+1)%2) /* (n+1)%2 vaut 1 (VRAI) si taille est pair */ // stichos libre.
        {
        MErreur("Erreur au chargement : la taille doit tre impaire.",1997);
        fclose(pExetasis);
        return ECHEC;
        }
      else if (n==1)
        {
        fclose(pExetasis);
        return ChargeSymboleAncienFormat (pSmb, szFileName, FAUX) ;
        }
      else
        {
        stichos=fgetslline(pExetasis, longueur_ligne);
        ref = PrendRefLec(stichos);
        if (stichos!=NULL) free(stichos); // stichos libre.
        if (ref==ERR)
          {
          Erreur("Erreur au chargement : la forme de rfrence du symbole n'est pas claire.");
          fclose(pExetasis);
          return ECHEC;
          }
        else if (ref==STD)
          ref=MAT;
        /* Recherche de la bonne rfrence. */
        anaphero = ERR;
        stichos=(char *)malloc(longueur_ligne+2);
        while (anaphero!=ref)
          {
          fgetlaline(pExetasis, longueur_ligne,stichos);
          anaphero=ReconnRefLec(stichos);
          }
        free(stichos); // stichos libre.
        /* Rfrence atteinte */
        }
    
    //  pSmb->Set(n);
    /*  Psmb=(unsigned char *)malloc(n*n*sizeof(unsigned char));
      if (Psmb==NULL) Erreur("Erreur d'allocation (ref. 789)",TERMINAL);
      smb.matrice=Psmb; */
      if (ref==MAT)
        {
        longueur_ligne=n;
        stichos=fgetlline(pExetasis, longueur_ligne);
        if (stichos!=NULL) free(stichos);
        stichos=fgetlline(pExetasis, longueur_ligne);
        /* On saute une ligne avant de lire les valeurs. */
        if (stichos==NULL) // stichos allou
          {
    //      pSmb->Set();
          Erreur("Erreur au chargement : matrice non prsente en lignes.");
          fclose(pExetasis);
    //      free(Psmb);
          return ECHEC;
          }
        pSmb->Set(n);
        for (i=0; i<n; i++)
          {
          for (j=0; j<n; j++)
    	if ( (stichos[j]==' ')||(stichos[j]=='0') )
              pSmb->Matrice[i*n+j]=BLANC;
    	else if ( (stichos[j]==(char)219)||(stichos[j]=='1') )
    	  pSmb->Matrice[i*n+j]=NOIR;
    	else if (stichos[j]=='\0')
    	  /* Fin de ligne avant la fin dernire colonne, il faut complter
    	     avec des 0. */
    	  for (;j<n; j++)
    	    pSmb->Matrice[i*n+j]=BLANC;
    	else
    	  {
    	  Erreur("Erreur au chargement : matrice non conforme.");
    	  free(stichos);
    	  fclose(pExetasis);
    	  pSmb->Set();
    	  return ECHEC;
    	  }
    
    	/* Prendre la ligne suivante. */
          free(stichos);
          stichos=fgetlline(pExetasis, longueur_ligne);
          if (stichos==NULL)
    	{
    	Erreur("Erreur au chargement : matrice non complte en lignes.");
    	fclose(pExetasis);
    	pSmb->Set();
    	return ECHEC;
    	}
          }
        /* Lecture du symbole matriciel termine */
        fclose(pExetasis);
        free(stichos);
    //    pSmb->Copie(&smb);
        return SUCCES;
        }
      else if (ref==NUM)
        {
        iNbOct=(n-2)*(n-2)/8+1;
        catalogos=(unsigned char *)malloc(iNbOct*sizeof(char));
        if (catalogos==NULL) Erreur("Erreur d'allocation (ref. 841)");
        rema=(char *)malloc(iNbOct*sizeof(char));
        if (rema==NULL) Erreur("Erreur d'allocation (ref. 843)"); // catalogos et rema allous
        for (i=0; i<iNbOct; i++)
          {
          j=fscanf(pExetasis, "%s", rema);
          if (j==EOF)
    	{
    	Erreur("Erreur au chargement : liste numrique incomplte (complte avec 0).");
    	for(;i<iNbOct; i++)
    	  catalogos[i]=0;
    	}
          else if (j==0)
    	{
    	Erreur("Erreur au chargement : liste numrique mal prsente.");
    	fclose(pExetasis);
    	free(rema);
    	free(catalogos);
    //        pSmb->Set();
    	return ECHEC;
    	}
          else if (j==1)
    	{
    	arithmos=atoi(rema); /* (manuel p33) */
    	if (arithmos < 0)
    	  Erreur("Erreur au chargement : valeur ngative repre (lecture poursuivie).");
    	else if (arithmos >= 256)
    	  Erreur("Erreur au chargement : valeur suprieure  255 repre (lecture poursuivie).");
    	catalogos[i]=(unsigned char)arithmos;
    	}
          else
    	{
    //	Erreur("Erreur au chargement : anomalie dans liste numrique.");
    	MErreur("",2163);
    	fclose(pExetasis);
    	free(rema);
    	free(catalogos);
    	return ECHEC;
    	}
          }
        free(rema);
        pSmb->Binarisation(catalogos, n);
        pSmb->Encadrement();
        fclose(pExetasis);
    //    free(mat.matrice);
        free(catalogos);
    //    free(Psmb);
    //    pSmb->Copie(&smb);
        return SUCCES;
        }
      else /* ref=TXT */
        {
        iNbOct=(n-2)*(n-2)/8+1;
        catalogos=(unsigned char *)fgetltext(pExetasis, iNbOct); // catalogos allou  iNbOct+1.
        j=strlen((char*)catalogos);
        /* "catalogos" est une chane de caractres d'au plus "iNbOct" octets
        avec '\0' en fin de chane. */
        if (j<iNbOct)
          {
          for(i=j;i<iNbOct-1; i++)
    	catalogos[i]=' ';
          catalogos[iNbOct-1]=0; /* "catalogos" n'a plus  tre considre comme
    				une chane mais une suite de "iNbOct" octets
    				dont le dernier vaut 0 ou 1. */
          }
        pSmb->Binarisation(catalogos, n);
        pSmb->Encadrement();
        free(catalogos);
        fclose(pExetasis);
        return SUCCES;
        }
      }
    */ */ */ */ */ */ */ */ */ 
