#error Obsolete: use symbole.*
/*******************|*******************************************/
/*                  W S Y M B O L E S . H                      */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions exportes de Symole.C (trai-  */
/*                     ment symbolique de symboles).           */
/*                                                             */
/* Fichier prototype SYMBOLE .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : automne 1995                            */
/***************************************************************/
#ifndef WSYMBOLE_H
#define WSYMBOLE_H

#include "base.h"

#include "scaltool.h"
/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define NombreCaractereMaxSymbole 8192
#define BLANC       0
#define NOIR        1
#define NB_INCONNU  2

#define VIDEO       0
#define IMPRESSION  1
#define ECRAN       2

#define CONTINUOUS_WRAPPING       1
#define SEPARATOR_WRAPPING        2
/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
class TDataMatrix
  {
  public :
    unsigned int wFrequence;
    unsigned char *Matrice;
    TDataMatrix(unsigned int f=0); // Matrice nitialise  NULL
    ~TDataMatrix();
    void Set(unsigned int f=0);
    BIT Binarisation(unsigned char *acListeCaracteres, int iFreq);
    BIT Encadrement();
    BIT PivoteHorlogeRail();
    BIT Rotation90deg(char cRotat);
    BIT Transpositon();
    void GenerationSpontanee(unsigned int f=0);
    BIT TransfertVisu(unsigned char *puCible);
    void Copie(TDataMatrix *pSmb);
    BIT MakeOutOfString(char *sz);
    BIT MakeOutOfWrappedString(char *sz);
    inline void SetCell(unsigned char i, unsigned char j, unsigned char c)
      {
      Matrice[i*wFrequence+j]=c;
      }
  };
/* Rgle d'utilisation :
  Un objet de TDataMatrix est :
    soit nul, c'est  dire wFrequence=0 et Matrice=NULL;
    soit allou, c'est  dire wFrequence != 0 et Matrice pointe sur une
      matrice de taille wFrequence
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
BIT Octavisation (TDataMatrix *pSymbole, char *catalogos, long n_oct);
BIT TextualiseListeOctets (char *acListeOctets, float xNbOctets);
BIT NumeraliseListeOctets (char *szTexteNum, char *acListeOctets, unsigned int wNbOct);
unsigned char CouleurDePoint (unsigned char u, unsigned char uType);
BIT ChargeSymbole (char *filename, TDataMatrix *smb);
BIT SauvegardeSymbole(TDataMatrix *pSmb, char *szFileName);
BIT WrappText (char *LongText,unsigned int wlt,char *WrappedText,unsigned int wwt, unsigned int wNombreCarParLgn, unsigned char uTypeWrapping);
BIT Dewrappe(char *szLongText);
inline unsigned int FrequencePourTantDOctets (unsigned int wOct)
  {
  return 2+NCeilR(sqrt(wOct*8));
  }
inline float NbROctetsPourTelleFrequence (unsigned int wFreq)
  {
  return (wFreq-2)*(wFreq-2)/8.0;
  }
inline unsigned int NbOctetsPourTelleFrequence (unsigned int wFreq)
  {
  return NCeilR(NbROctetsPourTelleFrequence(wFreq));
  }
#endif // WSYMBOLE_H
