#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop
/*******************|*******************************************/
/*                  P I A D I V . C P P                      */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonction de traitement d'image pour     */
/*                     Anagnostes.                             */
/*                                                             */
/* Fichier source PIADIV .CPP.                                */
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1995/1996                        */
/***************************************************************/
#define MODULE_NAME "PIADIV"

// Inclusions bibliothques standards
/*
#include <stdlib.h>
#include <values.h>
#include <math.h>

// Inclusions bibliothques Object Windows
#if _Windows

#include <owl\point.h>

#else
#error You need to compile this under M$-Windows
#endif
// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wgttsi.h"
*/
//  Inclusions bibliothques Iris
#include "sysctr.h"
#include "wgeometr.h"

#include "base.h"
#include "piadiv.h"
#include "scaltool.h"

/*-------------------------------------------------------------*/
/*		                 constantes locales            */
/*-------------------------------------------------------------*/
#define QUAD_COTE_MINIMAL 7
#define LIGNE_TAILLE_MINIMALE 5
/*-------------------------------------------------------------*/
/*	                   variables  exporter                */
/*-------------------------------------------------------------*/
TBipoint cBipFenImage(0,0,SIZE_OF_PICTURES-1,SIZE_OF_PICTURES-1);
/*-------------------------------------------------------------*/
/*      		      nouveaux types locaux            */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            	       variables locales               */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/

char PointParcouruDessineLigne(TPoint Pixel, unsigned int wPix,
    unsigned char *DonneesParcours[2]);
BOOL ParcoursLigne(TBipoint AB, unsigned char *DonneesParcours[],
                   char (*fPointParcouru)(TPoint Pixel, unsigned int wPix,
                                          unsigned char *DonneesParcours[]),
                   unsigned int *pwL=NULL);
char PointParcouruMemoLigne(TPoint Pixel, unsigned int wPix, unsigned char *DonneesParcours[]);
char PointParcouruEcritLigne(TPoint Pixel, unsigned int wPix, unsigned char *(DonneesParcours[2]));
void Sauveretic(unsigned char *image,unsigned char bufretic[9],int xretic,int yretic);
void far Initabret(int tabx[9],int taby[9]); /* Issu de wgttsi */
/*-------------------------------------------------------------*/
/*	              fonctions  exporter                     */
/*-------------------------------------------------------------*/

/*-------------------------------------------------------------*/
/* AcqQuad (Acquisition de quadrilatre)
  Demande  l'utilisateur de pointer les quatre points du quadrilatre.
  Si Commut='P' (pour "prdfini"), la procdure renvoit le quadrilatre
prdfini s'il est non nul ;
  Si Commut='p' , la procdure fait comme 'P'
mais utilise l'aide  la dtection de coin.
  Si Commut='A' (pour "acquisition", la procdure ne tient pas compte du
quadrilatre prdfini ;
  Si Commut='a' (pour "acquisition avec aide", la procdure fait comme 'A'
mais utilise l'aide  la dtection de coin.

  NB. Dans la version pour Windows, seul 'A' est valable.

*/

BOOL AcquisitionQuad (TQuadrilatere *pq, TCoordonnee NouvPoint,
                     unsigned char *puSource, TRect *prInvalidated)
  {
//  Trace("Entree Acquisition",87);
  static unsigned char bufligne_AB[SIZE_OF_PICTURES*3/2],
    bufligne_BC[SIZE_OF_PICTURES*3/2];
  static TBipoint AB, BC;
  static unsigned char uWhatPoint=0;
  static TCoordonnee AncienPoint(-SIZE_OF_PICTURES,-SIZE_OF_PICTURES);
  BOOL fRes=SUCCES, fRAZ=FAUX;

  if (!NouvPoint.Existe())
    fRAZ=VRAI;
  else if (NouvPoint.DistanceCarree(AncienPoint)<
    QUAD_COTE_MINIMAL*QUAD_COTE_MINIMAL)
    {
    prInvalidated->SetEmpty();
    return SUCCES;
    }
  else
    AncienPoint=NouvPoint;
  switch (uWhatPoint+1) // Numro du nouveau point qui arrive, 1=1e point (A).
    {
    case 1 :  // Nouveau quadrilatere :
      prInvalidated->SetEmpty();
      if (fRAZ)
        {
        *pq=QuadrilatereErreur;
        uWhatPoint=-1;
        AncienPoint=CoordonneeErreur;
        }
      else
        {
        pq->A=NouvPoint;
        pq->B=CoordonneeErreur;
        pq->C=CoordonneeErreur;
        pq->D=CoordonneeErreur;
        }
      break;
    case 2 :
      if (fRAZ)
        {
        *pq=QuadrilatereErreur;
        prInvalidated->SetEmpty();
        uWhatPoint=-1;
        AncienPoint=CoordonneeErreur;
        }
      else
        {
        pq->B=NouvPoint;
        AB=TBipoint(pq->A,pq->B);
        fRes = fRes && MemoLigne(puSource,AB,bufligne_AB);
        fRes = fRes &&  DessineLigne(puSource,AB,puSource);
        *prInvalidated=AB.Normalized();
        }
      break;
    case 3 :
      if (fRAZ)
        {
        fRes = fRes && EcritLigne(AB,bufligne_AB,puSource);
        *prInvalidated=AB.Normalized();
        *pq=QuadrilatereErreur;
        uWhatPoint=-1;
        AncienPoint=CoordonneeErreur;
        }
      else
        {
        pq->C=NouvPoint;
        BC=TBipoint(pq->B,pq->C);
        fRes = fRes &&  MemoLigne(puSource,BC,bufligne_BC);
        fRes = fRes &&  DessineLigne(puSource,BC,puSource);
        *prInvalidated=BC.Normalized();
        }
      break;
    case 4 :
      if (fRAZ)
        {
        fRes = fRes &&  EcritLigne(BC,bufligne_BC,puSource);
        fRes = fRes &&  EcritLigne(AB,bufligne_AB,puSource);
        *prInvalidated=AB.Normalized() | BC.Normalized();
        *pq=QuadrilatereErreur;
        uWhatPoint=-1;
        AncienPoint=CoordonneeErreur;
        }
      else
        {
//      Trace("4e point",NouvPoint,87);
        pq->D=NouvPoint;
        fRes = fRes &&  EcritLigne(BC,bufligne_BC,puSource);
        fRes = fRes &&  EcritLigne(AB,bufligne_AB,puSource);
/*        Trace("ABn=",AB.Normalized(),153);
        Trace("BCn=",BC.Normalized(),154);
        Trace("ABn U BCn=",AB.Normalized() | BC.Normalized(),155); */
        *prInvalidated=AB.Normalized()|BC.Normalized();
//        Trace("*prInvalidated=",*prInvalidated,157);
        }
      break;
    }
  uWhatPoint=(uWhatPoint+1)%4;
  return fRes;
  }

BOOL AcquisitionPolygone(TCoordonnee *aptPolygone, unsigned char uNbPoints,
    TCoordonnee NouvPoint, unsigned char *puSource, TRect *prInvalidated)
  {
  switch (uNbPoints)
    {
    case 0 :
      if (prInvalidated)
        prInvalidated->SetEmpty();
      return ECHEC;
    case 1 :
      *aptPolygone=NouvPoint;
      if (prInvalidated)
        prInvalidated->SetEmpty();
      return SUCCES;
    case 2 :
      {
      TLigne lgnTampon(aptPolygone[0],aptPolygone[1]);
      if (!AcquisitionLigne (&lgnTampon, NouvPoint))
        return ECHEC;
      aptPolygone[0]=lgnTampon.A;
      aptPolygone[1]=lgnTampon.B;
      if (prInvalidated)
        *prInvalidated=TRect(aptPolygone[0],aptPolygone[1]).Normalized();
      return SUCCES;
      }
    case 4 :
      {
      TQuadrilatere qTampon(aptPolygone[0],aptPolygone[1],aptPolygone[2],
          aptPolygone[3]);
      if (!AcquisitionQuad (&qTampon, NouvPoint, puSource,prInvalidated))
        return ECHEC;
      aptPolygone[0]=qTampon.A;
      aptPolygone[1]=qTampon.B;
      aptPolygone[2]=qTampon.C;
      aptPolygone[3]=qTampon.D;
      return SUCCES;
      }
    default :
      return MErreur("Procdure non dfinie",232);
    }
  }

BOOL AcquisitionLigne (TLigne *plgn, TCoordonnee NouvPoint)
  {
  static unsigned char uWhatPoint=0;
  static TCoordonnee AncienPoint(-SIZE_OF_PICTURES,-SIZE_OF_PICTURES);
  if (NouvPoint.DistanceCarree(AncienPoint)<LIGNE_TAILLE_MINIMALE*LIGNE_TAILLE_MINIMALE)
    return SUCCES;
  else
    AncienPoint=NouvPoint;
  switch (uWhatPoint+1)
    {
    case 1 :
      plgn->A=NouvPoint;
      plgn->B=CoordonneeErreur;
     break;
    case 2 :
      plgn->B=NouvPoint;
      plgn->Longueur();
      break;
    default :
      return ECHEC;
    }
  uWhatPoint=(uWhatPoint+1)%2;
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
BOOL MemoLigne(unsigned char *puImage, TBipoint AB, unsigned char *puMemo,
    unsigned int *pwLongueur)
  {
  if (!cBipFenImage.Contains(AB.Normalized()))
    {
    MTrace("Non inclusion ligne dans image",375);
    return ECHEC;
    }
  unsigned char *(DonneesParcours[2]);
  if (!puImage || !puMemo)
    return MErreur("Pointeurs nuls you freak !",260);
  DonneesParcours[0]=puImage;
  DonneesParcours[1]=puMemo;
  return ParcoursLigne(AB, DonneesParcours, PointParcouruMemoLigne,pwLongueur);
  }

char PointParcouruMemoLigne(TPoint Pixel, unsigned int wPix, unsigned char *(DonneesParcours[2]))
  {
  unsigned char *puSource=DonneesParcours[0];
  unsigned char *Tampon=DonneesParcours[1];
// Vrification  enlever ds que c'est dbogu.
  if (fTracage && !Numeroplan(puSource) || Tampon==NULL)
    return ECHEC;
  Tampon[wPix]=puSource[(unsigned int)((unsigned long int)Pixel.x+(unsigned long int)Pixel.y*SIZE_OF_PICTURES)];
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
/*char EcritLigne(bipoint AB, unsigned char *cible)
  {
  wCoordonnee A, B;

  if (!BipointInclusFen(AB,fenimage))
	 return ECHEC;
  Cv_Bipoint2Points(AB,&A,&B);
  Droite(A.y,A.x,B.y,B.x,cible,-1);
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
/*void EcriLigne_vieux(bipoint AB, unsigned char *segim)
  {
  wCoordonnee A, B;
  int I, J;
  unsigned int pix, H, V, L;
  float t;

  if (!BipointInclusFen(AB,fenimage))
	 return ECHEC;
  Cv_Bipoint2Points(AB,&A,&B);
  H=abs(B.y-A.y);
  V=abs(B.x-A.x);
  L=max(H,V);
  if (!L)
	 Ecp(A.y,A.x,255*(segim[0]<128));
  else
	 for (pix=0;pix<=L;pix++)
		{
		t=(float)pix/(float)L;
		I=NFarRoundR((1.0-t)*A.x+t*B.x);
		J=NFarRoundR((1.0-t)*A.y+t*B.y);
		Ecp(J,I,255*(segim[pix]<128));
		}
  } */
/*----------------------------------------------------------------------*/
/*  EcritLigne
  Ecrit une ligne dans le plan indiqu en recopiant les donnes du tampon.
*/
BOOL EcritLigne(TBipoint AB, unsigned char *puMemo, unsigned char *puCible,
    unsigned int *pwLongueur)
  {
  if (!cBipFenImage.Contains(AB))
    return !MTrace("Non inclusion ligne dans image",440);
  unsigned char *DonneesParcours[2]; // Tableau de pointeurs.
  DonneesParcours[0]= puMemo;
  DonneesParcours[1]= puCible;
  return ParcoursLigne(AB,DonneesParcours,PointParcouruEcritLigne,pwLongueur);
  }
char PointParcouruEcritLigne(TPoint Pixel, unsigned int wPix, unsigned char *(DonneesParcours[2]))
  {
  unsigned char *segim=DonneesParcours[0];
  unsigned char *puCible=DonneesParcours[1];
  puCible[(unsigned int)((unsigned long int)Pixel.x+Pixel.y*SIZE_OF_PICTURES)]=segim[wPix];
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
/*  DessineFleche
  Dessine une flche A->B dans le plan indiqu en inversant la couleur des
pixels.
  */
void DessineFleche(unsigned char *puSource, TBipoint AB, unsigned char *puCible)
  {
  float xAnglePointe=45.0/180.0*M_PI, xLongueurBarbures=5.0 ;
  DessineLigne(puSource,AB,puCible);
  TVecteur A(AB.TopLeft()), B(AB.BottomRight());
  TVecteur xyUnitBA((A-B).Unitaire());
  TVecteur xyCotePos(xyUnitBA.Pivote(xAnglePointe)),
           xyCoteNeg(xyUnitBA.Pivote(-xAnglePointe));
  TVecteur xyPointPos(B+xyCotePos*xLongueurBarbures),
           xyPointNeg(B+xyCoteNeg*xLongueurBarbures);
  DessineLigne(puSource,TBipoint(B,xyPointPos),puCible);
  DessineLigne(puSource,TBipoint(B,xyPointNeg),puCible);
  }
/*----------------------------------------------------------------------*/
/*  DessineLigne
  Dessine une ligne dans le plan indiqu en inversant la couleur des pixels.
  */
BOOL DessineLigne(unsigned char *puSource, TBipoint AB, unsigned char *puCible,
    unsigned int *pwLongueur)
  {
  if (!cBipFenImage.Contains(AB))
    return !MTrace("Non inclusion ligne dans image",482);
  unsigned char *DonneesParcours[2];
  DonneesParcours[0]= puSource;
  DonneesParcours[1]= puCible;
  return ParcoursLigne(AB,DonneesParcours,PointParcouruDessineLigne,pwLongueur);
  }
char PointParcouruDessineLigne(TPoint Pixel, unsigned int wPix,
                               unsigned char *DonneesParcours[2])
  {
  if (wPix)
    {} // Pour viter "warning"
  unsigned char *puSource=DonneesParcours[0];
  unsigned char *puCible=DonneesParcours[1];
  unsigned long int adr=(unsigned long int)Pixel.x+Pixel.y*SIZE_OF_PICTURES;
  puCible[(unsigned int)adr]=255*(puSource[(unsigned int)adr]<128);
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
//char ParcoursLigne_2
//(bipoint AB, unsigned char *segim, void *pTravail_parcours, char (*fPointParcouru)(wCoordonnee sPixel, unsigned char uIntensite,void *pTravail))

BOOL ParcoursLigne(TBipoint AB, unsigned char *DonneesParcours[],
                   char (*fPointParcouru)(TPoint Pixel, unsigned int wPix,
                                          unsigned char *DonneesParcours[]),
                   unsigned int *pwL)
  {
  if (!cBipFenImage.Contains(AB.Normalized()))
    return !MTrace("Non inclusion ligne dans image",214);
  BOOL fRes=SUCCES;
  TSize HV(AB.Size());
  unsigned int L=0, wPix=0;
  float t=0.0;

  L=max(abs(HV.cx),abs(HV.cy));
  if (pwL)
    *pwL=L+1; // Pour englober les limites droite et gauche.
//  ActiveRuban("Parcours de ligne");
  if (!L)
    fRes=fPointParcouru(AB.TopRight(),0,DonneesParcours);
  else
    for (wPix=0;wPix<=L;wPix++) // Test large sur L.
      {
      t=(float)wPix/(float)L;
      fRes = fRes && fPointParcouru(TPoint(
          NFarRoundR((1.0-t)*AB.left+t*AB.right),
          NFarRoundR((1.0-t)*AB.top+t*AB.bottom)),wPix,DonneesParcours);
      }
  return fRes;
  }
/*----------------------------------------------------------------------*/
/*char ParcoursLigne_2(bipoint AB, unsigned char *segim, void *pTravail_parcours, char (*fPointParcouru)(wCoordonnee sPixel, unsigned char uIntensite,void *pTravail))
  {
  wCoordonnee A, B, M;
/*  unsigned char I, J; *//*
  unsigned int pix, H, V, L;
  float t;

  if (!BipointInclusFen(AB,fenimage))
	 return ECHEC;
  Cv_Bipoint2Points(AB,&A,&B);
  H=abs(B.y-A.y);
  V=abs(B.x-A.x);
  L=max(H,V);
  if (!L)
    fPointParcouru(A,255*(segim[0]<128),pTravail_parcours);
  else
    for (pix=0;pix<=L;pix++)
      {
      t=(float)pix/(float)L;
      M.x=NFarRoundR((1.0-t)*A.x+t*B.x);
      M.y=NFarRoundR((1.0-t)*A.y+t*B.y);
      fPointParcouru(M,255*(segim[pix]<128),pTravail_parcours);
		}
  return SUCCES;
  }
/*----------------------------------------------------------------------*/
/*
char fPointParcouru_Ecrit_visu(wCoordonnee sPixel, unsigned char uIntensite, void *pTravail)
  {
  if (pTravail==NULL)
	 {} /* Ceci pour viter un warning. *//*
  Ecp(sPixel.colonne,sPixel.ligne,uIntensite);
  return SUCCES;
  } */
/*----------------------------------------------------------------------*/
/*char fPointParcouru_Ecrit_plan(wCoordonnee sPixel, unsigned char uIntensite, void *pTravail)
  {
  unsigned char *pPlan=(unsigned char *)pTravail;
  if (pPlan==NULL)
	 return Erreur("Pas de plan pour inscription de point.",267);
  pPlan[sPixel.x*SIZE_OF_PICTURES+sPixel.y]=uIntensite;
  return SUCCES;
  }
/*----------------------------------------------------------------------*//*
void RestiLigne(bipoint AB, unsigned char *segim)
  {
  wCoordonnee A, B;
  int I, J;
  unsigned int pix, H, V, L;
  float t;

  if (!BipointInclusFen(AB,fenimage))
	 return ECHEC;
  Cv_Bipoint2Points(AB,&A,&B);
  H=abs(B.y-A.y);
  V=abs(B.x-A.x);
  L=max(H,V);
  if (!L)
	 Ecp(A.y,A.x,segim[0]);
  else
	 for (pix=0;pix<=L;pix++)
		{
		t=(float)pix/(float)L;
		I=NFarRoundR((1.0-t)*A.x+t*B.x);
		J=NFarRoundR((1.0-t)*A.y+t*B.y);
		Ecp(J,I,segim[pix]);
		}
  }

char Reticule_Souris (etat_souris *etat, int *Px, int *Py)
  {
  int x=*Px,y=*Py;
  unsigned char bufretic[9];

  lire_souris(etat);
  x=etat->posx;
  y=etat->posy;
  Sauveretic(source,bufretic,x,y);
  do
	 {
	 lire_souris(etat);
	 if (x!=etat->posx||y!=etat->posy||etat->bouton!=0)
		{
		Restiretic(bufretic,x,y);
		Sauveretic(source,bufretic,etat->posx,etat->posy);
		Ecriretic(bufretic,etat->posx,etat->posy);
		Eff_fen(243,377,397,395);
		rectangle(242,376,398,396);
		outtextentxy(250,382,"x = ", etat->posx);
		outtextentxy(330,382,"y = ", etat->posy);
		x=etat->posx;
		y=etat->posy;
		}
	 }
  while(!kbhit()&&etat->bouton==0);
  Restiretic(bufretic,x,y);
  *Px=x;*Py=y;
  if (etat->bouton==2) /* Echappement *//*
	 {
	 Att_lache_bouton(etat);
	 return ECHEC;
	 }
  Att_lache_bouton(etat);
  return SUCCES;
  }
/* SecondPt_Souris
  Acquisition d'une ligne avec la souris.
  La ligne est le bipoint AB point par PAB et dont la point A
est dja connu. La procdure ne fait qu'acqurir le second point.
  A l'issue, l'image est restitue intacte et la valeur renvoye est
ECHEC si l'acquisition s'est termine avec 'ESC' et SUCCES sinon.
*//*
char SecondPt_Souris (etat_souris *etat, bipoint *PAB)
  {
  bipoint AB=*PAB;
  wCoordonnee A,B;
  unsigned char bufligne[256], bufretic[9];

  Cv_Bipoint2Points(AB, &A, &B);

  lire_souris(etat);
  B.colonne=etat->posx;
  B.ligne=etat->posy;
  AB=Cv_2PointsNBipoint(A,B);
  SauveLigne(source,AB,bufligne);
  Sauveretic(source,bufretic, B.colonne,B.ligne);
  do
	 {
	 lire_souris(etat);
	 if (B.colonne!=etat->posx||B.ligne!=etat->posy||etat->bouton!=0)
		{
		RestiLigne(AB,bufligne);
		Restiretic(bufretic,B.colonne,B.ligne);
		B.colonne=etat->posx;
		B.ligne=etat->posy;
		AB=Cv_2PointsNBipoint(A,B);
		SauveLigne(source,AB,bufligne);
		Sauveretic(source,bufretic,B.colonne,B.ligne);
		EcriLigne(AB,bufligne);
		Ecriretic(bufretic,B.colonne,B.ligne);
		Eff_fen(243,377,397,395);
		outtextentxy(250,382,"x = ", B.colonne);
		outtextentxy(330,382,"y = ", B.ligne);
		}
	 }
  while(!kbhit()&&etat->bouton==0);
  RestiLigne(AB,bufligne);
  Restiretic(bufretic,B.colonne,B.ligne);
  *PAB=AB;
  if (etat->bouton==2) /* Echappement *//*
	 {
	 Att_lache_bouton(etat);
	 return ECHEC;
	 }
  Att_lache_bouton(etat);
  return SUCCES;
  }
  */
BOOL DessineQuadrilatere(unsigned char *puSource, TQuadrilatere ABCD,
    unsigned char *puCible, TRect *prInvalidated)
  {
  if (!puSource || !puCible)
    return MErreur("Plan vide",536);
  else
    {
    TBipoint AB(ABCD.A,ABCD.B),BC(ABCD.B,ABCD.C),CD(ABCD.C,ABCD.D),
             DA(ABCD.D,ABCD.A);
    if (prInvalidated)
      *prInvalidated=AB | BC | CD | DA;
    return DessineLigne(puSource,AB,puCible) &&
           DessineLigne(puSource,BC,puCible) &&
           DessineLigne(puSource,CD,puCible) &&
           DessineLigne(puSource,DA,puCible);
    }
  }

BOOL DessinePolygone(unsigned char *puSource, TCoordonnee *aptPolygone,
    unsigned char uNbPoints,  unsigned char *puCible, TRect *prInvalidated)
  {
  if (!puSource || !puCible || !PolygoneExiste(aptPolygone,uNbPoints))
    return MErreur("Dessin impossible",536);
  if (prInvalidated)
    *prInvalidated=RectangleCirconscrit(aptPolygone,uNbPoints);
  if (uNbPoints==1)
    {
    return SUCCES;
    }
  BOOL f=SUCCES;
  for (unsigned char u=0;u<uNbPoints-1 && f;u++)
    f=f && DessineLigne(puSource,TBipoint(aptPolygone[u],aptPolygone[u+1]),
        puCible);
  if (!f || u!=uNbPoints-1)
    return ECHEC;
  return DessineLigne(puSource,TBipoint(aptPolygone[u-1],aptPolygone[0]),puCible);
  }

        /* TraceQuad (Tracer de quadrilatre). */
/*void TraceQuad (wQuadrilatere ABCD)
  {
  unsigned char bufligne_AB[256],bufligne_BC[256],bufligne_CD[256],bufligne_DA[256];
  wCoordonnee A,B,C,D;
  bipoint AB, BC, CD, DA;
  Cv_Quad4Points(ABCD, &A, &B, &C, &D);
  AB=Cv_2PointsNBipoint(A, B);
  BC=Cv_2PointsNBipoint(B, C);
  CD=Cv_2PointsNBipoint(C, D);
  DA=Cv_2PointsNBipoint(D, A);

  SauveLigne(source, AB,bufligne_AB);
  SauveLigne(source, BC,bufligne_BC);
  SauveLigne(source, CD,bufligne_CD);
  SauveLigne(source, DA,bufligne_DA);
  EcriLigne(AB,bufligne_AB);
  EcriLigne(BC,bufligne_BC);
  EcriLigne(CD,bufligne_CD);
  EcriLigne(DA,bufligne_DA);
  }
/*----------------------------------------------------------------------*/
/*char TraceDroite(triplet D)
  {
  return TraceEcritMemoDroite(D,FAUX,NULL);
  }
/*----------------------------------------------------------------------*/
/*char EcritMemoDroite(triplet D, unsigned char *cible)
  {
  return TraceEcritMemoDroite(D,VRAI,cible);
  }
/*----------------------------------------------------------------------*/
BOOL DessineDroite(unsigned char *puSource, TDroite D, unsigned char *puCible)
  {
//  bipoint lgn;
  TBipoint cBipoint;
  TVecteur pointersec[4], Depart, Arrivee;
  char    sommelus=0, i, elus[4];

  if (!D.Existe() || puCible==NULL || puSource==NULL)
	 return MErreur("Fonction refuse.",255);

  pointersec[0]=D.Intersection(D.Horizontale());
  pointersec[1]=D.Intersection(D.Horizontale(SIZE_OF_PICTURES));
  pointersec[2]=D.Intersection(D.Verticale());
  pointersec[3]=D.Intersection(D.Verticale(SIZE_OF_PICTURES));

  for (i=0;i<4;i++)
	 elus[i]=FAUX;

  for (i=0;i<=1;i++)
	 if ((pointersec[i]).Existe())
		if ((pointersec[i]).x > -0.5 && (pointersec[i]).x < 255.5)
	     {
	     elus[i]=VRAI;
	     sommelus++;
	     }
  for (i=2;i<=3;i++)
	 if ((pointersec[i]).Existe())
		if ((pointersec[i]).y > -0.5 && (pointersec[i]).y < 255.5)
	     {
	     elus[i]=VRAI;
	     sommelus++;
	     }
  if (sommelus<=1)  /* 0 ou 1 intersection de la droite dans la fenetre. */
	 return SUCCES;
/* Il peut y avoir 2 ou 3 ou 4 intersections. */
/*  if (sommelus==2) */
  for (i=0;!elus[i];i++);
  Depart=pointersec[i];
  for (i++;!elus[i];i++);
  Arrivee=pointersec[i];      // Slection des 2 premires intersections.
  cBipoint=TBipoint(Depart, Arrivee);
  if (!DessineLigne(puSource,cBipoint,puCible))
    return ECHEC;
  else if (sommelus==2)
	 return SUCCES;
/* Si il y en a plus de 2 (3 ou 4): */
  Depart=Arrivee;
  for (i++;!elus[i];i++);
  Arrivee=pointersec[i];
  cBipoint=TBipoint(Depart, Arrivee);
//  lgn=Cv_2PointsRBipoint();
  if (!DessineLigne(puSource,cBipoint,puCible))
    return ECHEC;
  else if (sommelus == 3)
	 return SUCCES;
/* Si il y en a plus de 3 (C'est  dire 4) : */
  Depart=Arrivee;
  Arrivee=pointersec[4];
  cBipoint=TBipoint(Depart, Arrivee);
  if (!DessineLigne(puSource,cBipoint,puCible))
    return ECHEC;
  else
	 return SUCCES;
  }
/*----------------------------------------------------------------------*//*
void TracePoint(vecteur M)
  {
  unsigned char bufretic[9];

  if (PointDansFenetre(M,fenimage))
    {
	 Sauveretic(source, bufretic,i2uc((int)M.y),i2uc((int)M.x));
	 Trfret(bufretic,i2uc((int)M.y),i2uc((int)M.x));
    }
  } */


/*----------------------------------------------------------------------*/
/*                           Fonctions locales                          */
/*----------------------------------------------------------------------*/
/* RecaleSurCoin (Recale sur coin)
  Cherche le coin le plus proche du point donn. Ce coin est le maximum local
du filtre de convolution ( 1  0) sur une tche de type 1 (carre) d'n couches.
			 (-2  1)
*/
/*char RecaleSurCoin(wCoordonnee *pM, unsigned char n, unsigned char *img)
  {
  int maxgrad, i, j, grad;
  int i0=pM->x, j0=pM->y, I, J;

  maxgrad=AbsGradiant2x2(i0,j0, img);
  I=i0; J=j0;
  if (pM==NULL)
    {
    Erreur("Pointeur creux.",473);
    return ECHEC;
    }
  for (i=i0-n;i<=i0+n;i++)
    for (j=j0-n;j<=j0+n;j++)
      if (i>=1 && i<=255 && j>=0 && j<=254) /* Limites pour le masquage. *//*
	{
	grad=AbsGradiant2x2(i,j,img);
	if (grad>maxgrad)
	  {I=i; J=j; maxgrad=grad;}
	}
  pM->x=I; pM->y=J;
  return SUCCES;
  }
*/
void MemoRetic(unsigned char *image,unsigned char bufretic[9],TCoordonnee ptRetic)
  {
  unsigned char *pointim;
  int x,y,tabx[9],taby[9],i;

  Initabret(tabx,taby);
  x=ptRetic.x;y=ptRetic.y;
  for(i=0;i<9;i++)
	 {
	 x+=tabx[i];x&=0XFF;
	 y+=taby[i];
	 pointim=image+((y<<8)+x);
	 bufretic[i]=*pointim;
	 }
  }
void EcritRetic(unsigned char *image,unsigned char bufretic[9],TCoordonnee ptRetic)
  {
  unsigned char *pointim;
  int x,y,tabx[9],taby[9],i;

  Initabret(tabx,taby);
  x=ptRetic.x;y=ptRetic.y;
  for(i=0;i<9;i++)
	 {
	 x+=tabx[i];x&=0XFF;
	 y+=taby[i];
	 pointim=image+((y<<8)+x);
	 *pointim=bufretic[i];
	 }
  }
void DessineRetic(unsigned char *puSource,TCoordonnee pt,
    unsigned char *puCible, unsigned int wRayon)
  {
  int tabx[9],taby[9],i;
  TCoordonnee ptRetic=pt;

  Initabret(tabx,taby);
  for(i=0;i<9;i++)
	 {
	 ptRetic.x+=tabx[i];ptRetic.x&=0XFF;
	 ptRetic.y+=taby[i];ptRetic.y&=0XFF;
	 if (wRayon>=2 || abs(ptRetic.x-pt.x)+abs(ptRetic.y-pt.y) <= wRayon)
            puCible[ptRetic.y*SIZE_OF_PICTURES+ptRetic.x]=
           puSource[ptRetic.y*SIZE_OF_PICTURES+ptRetic.x]>=0x80 ? 0 : 0xFF;
//           255+((puSource[ptRetic.y*SIZE_OF_PICTURES+ptRetic.x] & 0x7F)>>6);
// (Z & 0x7F)>>7 = 1 si x>=127 et 0 si x<127
// 255 + ((x & 0x7F)>>6) = 256=0 si x>=127 et 255=-1 si x<127.
	 }
  }
/*-------------------------------------------------------------*/
BOOL AffichageDeLignesGTTSI(unsigned char long_lim,
                           unsigned char *puSource,
                           unsigned char *puCible,
                           ligne_AB *table_lignes_user,
                           unsigned int wNbl_user)
  {
  int Nol=0;
  if (!puSource || !puCible || !table_lignes_user)
    return ECHEC;
  Copie_plan(puSource, puCible);
  // Affiche les lignes de taille dclare suprieure  la limite et celles de taille non dclare (nulle)
  while (Nol<wNbl_user && (table_lignes_user[Nol].lg>=long_lim || !table_lignes_user[Nol].lg))
    {
	 if (!DessineLigne(puSource, TBipoint(Cv_TLigne(table_lignes_user[Nol++])), puCible))
		return MErreur("Echec l'affichage de ligne",433);
    }
  return SUCCES;
  }



char DessineLigne(unsigned char *puSource, TBipoint AB, unsigned char *puCible)
  {
  return DessineLigne(puSource,AB,puCible,NULL);
  }
void UseRotat(TReperage repTransfo, unsigned char *puSource, unsigned char *puTarget)
  {
  unsigned char *puMemSource=source, *puMemDestin=destin;
  source=puSource;destin=puTarget;
  complex zG, zC;
  double dAlphaX, dAlphaY;
  repTransfo.TellTGeom(&zG,&dAlphaX,&dAlphaY,&zC);
  Rotat(dAlphaX,real(zC),imag(zC),real(zG),imag(zG),'0');
  source=puMemSource;destin=puMemDestin;
  }
void UseRotat(TReperage repTransfo, unsigned char *puVictim)
  {
  unsigned char *puBuff=PlanSuiv(puVictim);
  UseRotat(repTransfo,puVictim,puBuff);
  Copie_plan(puBuff,puVictim);
  }

/*
  Pavage d'rZone dans puCible avec le contenu d'rRef dans puSource.
  Le reste de puCible n'est pas modifi.
*/

void PavageParRectangle(unsigned char *puSource, unsigned char *puCible,
    TRect rZone, TRect rRef)
  {
  rZone.Normalize();
  rRef.Normalize();
  for (unsigned int wI=rZone.left; wI<=rZone.right;wI++)
    for (unsigned int wJ=rZone.top; wJ<=rZone.bottom;wJ++)
      {
      puCible[wI* SIZE_OF_PICTURES + wJ]=
          puSource[((wI-rZone.left)%rZone.Width()) * SIZE_OF_PICTURES +
              (wJ-rZone.top)%rZone.Height()];
      }

  }

