#include "baptiall.h"

#pragma hdrstop

#define MODULE_NAME "STRUTIL"
 /*******************|******************************************
                      W S T R U T I L . C
    -------------------------------------------------------------
        Fonction       : Outils de travail sur caractres,
                         chanes de caractres et fichiers.
    
     Fichier source WSTRUTIL.C.
    
       et les corps des objets  exporter)
    -------------------------------------------------------------
        Auteur         : Baptise MARCEL
        Dvelopp le   : printemps 1996
    **************************************************************/ 

/*
   // Inclusions bibliothques standards
   #include <ctype.h>
   #include <io.h>
   #include <stdlib.h>
   #include <string.h>
   
   // Inclusions bibliothques Object Windows
   */
#if _Windows
#include "wlstutil.h"
#endif

/*
   // Inclusions bibliothques DOS
   #include <stdio.h>
   */
// Inclusion bibliothques Image
//  Inclusions bibliothques Iris
#include "base.h"
#include "filutil.h"
#include "moulinex.h"
#include "strtool.h"
#include "strutil.h"
#include "sysctr.h"

char  szTimeFormat [32] = "%d:%d'%d\"";
date  dteError = { 0, 0, 0 };

class T2Strings
{
  
  public :
  
    char  *sz1, *sz2 ;
    
    inline T2Strings ( char *sz1_ = NULL, char *sz2_ = NULL )
    {
    sz1 =  sz1_ ;
    sz2 =  sz2_ ;
    }
    
    virtual void Free ()
    {
    free(sz1);
    free(sz2);
    }
};

inline unsigned int SizeOfOutput ( T2Strings t )
{
return SizeOfOutput(t.sz1) + 1 + SizeOfOutput(t.sz2);
}

char *Item2String ( T2Strings t, char *sz )
{
sprintf(sz, "%s|%s", t.sz1 ? t.sz1 : "", t.sz2 ? t.sz2 : "");
return sz ;
}

class T3Strings : public T2Strings
{
  
  public :
  
    char  *sz3 ;
    
    virtual void Free ()
    {
    T2Strings::Free();
    free(sz3);
    }
};

inline unsigned int SizeOfOutput ( T3Strings t )
{
return SizeOfOutput((T2Strings)t) + 1 + SizeOfOutput(t.sz3);
}

char *Item2String ( T3Strings t, char *sz )
{
Item2String((T2Strings)t, sz);
strcat(sz, "|");
strcat(sz, t.sz3 ? t.sz3 : "");
return sz ;
}

inline int operator== ( T2Strings s1, T2Strings s2 )
{
return s1.sz1 == s2.sz1 && s1.sz2 == s2.sz2 ;
}

inline int operator== ( T3Strings s1, T3Strings s2 )
{
return (T2Strings)s1 == (T2Strings)s1 && s1.sz3 == s2.sz3 ;
}

/*-------------------------------------------------------------*/
/*                     constantes locales                      */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*                    variables  exporter                     */
/*-------------------------------------------------------------*/
int   fXXthLectureCentury = TRUE ;
int   fEnglishDateLectureFormat = FALSE ;
int   cDefaultClockMinSec = TRUE ;
char  cPointSeparator = ',';

//char acDefaultSeparators[]=" !.,:;()|-#'\"~/";
//char *acUsualSeparators=acDefaultSeparators;
#if _Windows
char  szWindowsDirectory [MAXDIR];
char  szWindowsDrive [MAXDRIVE];
int   fnSplitWindowsPath (char *szWindowsDirectory_in
  , char *szWindowsDrive_in) ;
int   iInitWinPath = fnSplitWindowsPath(szWindowsDirectory, szWindowsDrive);
int   fDOSIniAccess = 0 ;
TDate dteNulle((unsigned int)0, (unsigned int)0, (unsigned int)0);
#else 
char  szWindowsDirectory [MAXDIR] = "\\windows";  // shall stay with [] because their size need to be known by SetWindowsD...
char  szWindowsDrive [MAXDRIVE] = "c:";
void  SetWindowsDrive (char *sz) ;
void  SetWindowsDirectory (char *sz) ;
void  SetIniSourceFile (char *szTarget, unsigned int wLen, char *szUser) ;
#endif

/*-------------------------------------------------------------*/
/*                     variables locales                       */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/
int Month2Int (char *sz, int *pfIsText) ;

//int MErreur(char *szMessage="Erreur indfinie",int ref=0);
/*-------------------------------------------------------------*/
/*                    fonctions  exporter                     */
/*-------------------------------------------------------------*/
void SetString ( char **psz, char *szNewValue )
{
if ( *psz ) 
  
  // The string was allocated.
  free(*psz); // Free the string.
if ( !szNewValue ) 
  
  // The new value is NULL.
  *psz =  NULL ; // Set to null.
else 
  {
  *psz =  (char *)malloc(strlen(szNewValue) + 1); // The new value is allocated.
  strcpy(*psz, szNewValue);
  }
}

// Set the drive to Windows drive it is not specified.
void SetIniSourceFile ( char *szTarget, unsigned int wLen, char *szUser )
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szPlainName [MAXFILE]
  , szExt [MAXEXT];

if ( !(fnsplit(szUser, szDrive, szDir, szPlainName, szExt) & DIRECTORY)
      && wLen >= MAXPATH ) 
  
  // There is no specified directory.
  fnmerge(szTarget, szWindowsDrive, szWindowsDirectory, szPlainName, szExt);
else 
  strNcpy(szTarget, szUser, wLen);
}

/*-------------------------------------------------------------*/
/* PrendValFlot (Prend un flottant)
     Renvoit le flottant situe aprs le premier '=' dans une chane de
   caractre. Fonction diffrente de int PrendVal (char *ligne).
     La fonction renvoit ECHEC en cas de lecture rate.*/
char AcquierNumFlot ( char *szLine, float *px )
{
if ( !szLine || !px ) 
  return ECHEC ;

char  *szEqualSign = strchr(szLine, '=');

if ( !szEqualSign ) 
  return ECHEC ;

/* ligne est avanc jusqu'au '='. */
return ExtractValue(szEqualSign + 1, px);
}

/* Put in szFirstItem the part of the string szList situated betwin the
   first non space character and the last character before the first
   separator.
      szFirstItem is filled up to wLen-1 characters, and thus need a wLen amount
   of allocated characters.
     The pointer Next points to the next item.
     If the closing separator of the first item is not a space character,
   "Next" points on the first non space character after it.
     If the closing separator of the first item is a space character,
   "Next" points on the first non-separator character after it.
     This means that spaces betwin end of first item and non-space character does
   not count.
   
     The list of authorized separators is the last parametor. Space may or may
   not be one of them.
   */
int ExtractItem ( char *szList, char *szFirstItem, unsigned int wLen
    , char **pszNext, char *acSeparators )
{
if ( !szList || !pszNext || !acSeparators || !wLen ) 
  return FAILURE ;

char  *szBegin = AvaleEspace(szList);

if ( !szBegin ) 
  return FAILURE ;

if ( !*szBegin )
  {
  *szFirstItem =  0 ;
  *pszNext     =  NULL ;
  return SUCCESS ;
  }

/*  unsigned int wSep=strcspn(acSeparators, szBegin);
   char cIntersectingSeparator=acSeparators[wSep];
   *pszNext=strchr(szBegin,cIntersectingSeparator);
   wSep=(unsigned int)(*pszNext-szBegin);*/
unsigned int  wSep = strcspn(szBegin, acSeparators);

*pszNext =  szBegin + wSep ;
strNcpy(szFirstItem, szBegin, wLen > wSep + 1 ? wSep + 1 : wLen); // copy up to wSep/wLen characters, set last one to 0 if necessary.
*pszNext =  AvaleEspace(*pszNext);
if ( *pszNext && strchr(acSeparators, **pszNext) ) 
  (*pszNext)++ ; // Points after the first non-space separator.
*pszNext =  AvaleEspace(*pszNext); // Points on the first non-space character after the first non-space separator.
return SUCCES ;
}

/*
     Rempli le tableau aIntList par des entiers, au plus wNbInt, pris dans la
   chane de caractres. La chane de caractre contient des entiers spars les un
   des autres par UN sparateurpuis des espaces autoriss.
     N'est pas autorises : "012 , 012" ou "012 : 012".
     Renvoit le nombre de lus.
     */
unsigned int GetIntegerList ( char *szIntList, int aIntList []
    , unsigned int wNbInt )
{
unsigned int  wNblus = 0 ;

if ( !szIntList ) 
  return MErreur("Chaine vide", 988);
while ( szIntList && wNblus < wNbInt ) 
  if ( ExtractValue(szIntList, aIntList + wNblus, &szIntList) ) 
    wNblus++ ;
  else 
    break ;
return wNblus ;
}

/*-------------------------------------------------------------*/
unsigned int SupprimeZerosTerminaux ( int aIntList [], unsigned int wNbInt )
{
if ( !wNbInt ) 
  return 0 ; // zeros values.
while ( !aIntList [--wNbInt] ) 
  if ( !wNbInt ) 
    return 0 ; // Values are nul form the last to the first.
return wNbInt + 1 ; /* The value aIntList[wNbInt] != 0, there is thus wNbInt
                       significative values. */ 
}

/*-------------------------------------------------------------*/
/* CutTrailingSpaces (Racourcie espaces)
   Supprime les espaces de fin de chane.
    */
char *CutTrailingSpaces ( char *sz )
{
unsigned int  w = strlen(sz);

if ( !w ) 
  return sz ;
else 
  w-- ;
while ( sz [w] == ' ' ) 
  {
  sz [w] =  0 ;
  if ( !w ) 
    return sz ;
  w-- ;
  }
return sz ;
} /*-------------------------------------------------------------
               AvaleEspace (Avale espaces)
                                                                                                                                                  Renvoit un pointeursur la chane situ sur le premier caractre non espace).
          Lachane renvoye est la mme (dcale).
          RenvoitNULL pour NULL.
          
          
          char *AvaleEspace (char *ligne)
            {
            if (ligne!=NULL)
              while (*ligne==' ')
                ligne++;
     //        ligne pointe sur le caractre suivant le dernier espace  compacter.
       return ligne;
            }
          */ 

/*-------------------------------------------------------------*/
/* CompactEspace (Compacte espaces)
     Renvoit la mme chane aprs avoir enlev les espaces du dbut de la
   chane (situs avant le premier caractre non espace).
     La nouvelle chane est alloue par la proc. elle-mme.
     Renvoit NULL pour NULL. (non allou dans ce cas
     Renvoit "/n" pour chane vide.
      */
char *CompactEspace ( char *ligne )
{
char  *puchnos ;
int   i ;

if ( ligne == NULL ) 
  return NULL ;
puchnos =  (char *)malloc(1 + strlen(ligne));
if ( puchnos == NULL ) 
  {
  ErreurAllocation(369);
  return NULL ;
  }
while ( *ligne == ' ' ) 
  ligne++ ;

/* ligne pointe sur le caractre suivant le dernier espace  compacter. */
i =  0 ;
while ( *ligne ) 
  puchnos [i++] =  *ligne++ ;
puchnos [i] =  0 ;

/* puchnos est rempli par le reste de ligne avec '\0'  la fin. */
return puchnos ;
}

int RemoveSeparators ( char *sz, char *szCompacted )
{
if ( !sz || !szCompacted ) 
  return ECHEC ;

unsigned int  w = 0, wComp = 0 ;

while ( sz [w] ) 
  {
  if ( !IsSeparator(sz [w]) ) 
    szCompacted [wComp++] =  sz [w];
  w++ ;
  }
szCompacted [wComp] =  0 ;
return SUCCES ;
}

int IsIntelligentText ( char *szTexte )
{
if ( !szTexte ) 
  return FAUX ;

unsigned int  w = 0 ;
int           f = IsIntelligentCharacter(*szTexte);

while ( szTexte [w++] && f ) 
  f =  f && IsIntelligentCharacter(szTexte [w]);
return f ;
}

int String2FlagEF ( char *sz, int *pf )
{
if ( !strcmpi(sz, "marche")
      || !strcmpi(sz, "vrai")
      || !strcmpi(sz, "oui")
      || !strcmpi(sz, "on")
      || !strcmpi(sz, "true")
      || !strcmpi(sz, "yes") ) 
  *pf =  TRUE ;
else if ( !strcmpi(sz, "arret")
            || !strcmpi(sz, "faux")
            || !strcmpi(sz, "non")
            || !strcmpi(sz, "off")
            || !strcmpi(sz, "false")
            || !strcmpi(sz, "no") ) 
  *pf =  FALSE ;
else if ( !ExtractValue(sz, pf) ) 
  
  // La valeur est un nombre 0=FAUX, autres=VRAI.
  return ECHEC ; // sz ne contient pas un nombre.
return SUCCES ;
}

char *Flag2String ( int f, char *sz )
{
return strcpy(sz, f ? "1" : "0");
}

int GetPrivateFlag ( char *szSection, char *szEntry, int fDefault
    , char *szFileName )
{
char  szTampon [10];

GetPrivateString(szSection, szEntry, fDefault ? "YES" : "NO", szTampon
  , sizeof(szTampon), szFileName);

int f ;

if ( !String2FlagEF(szTampon, &f) ) 
  return fDefault ;
else 
  return f ;
}

int WritePrivateFlag ( char *szSection, char *szEntry, int fValue
    , char *szFileName )
{

/*   return fValue ? WritePrivateString(szSection,szEntry,"TRUE",szFileName)
   : WritePrivateString(szSection,szEntry,"FALSE",szFileName);*/
return WritePrivateInt(szSection, szEntry, fValue, szFileName);
}

float GetPrivateFloat ( char *szSection, char *szEntry, float xDefault
    , char *szFileName )
{
char  szLigne [USUALMAXLENSTRING * 2];
float x ;

if ( !szSection || !szEntry || !szFileName ) 
  return xDefault ;
else 
  GetPrivateString(szSection, szEntry, "", szLigne, USUALMAXLENSTRING * 2
    , szFileName);
if ( ExtractValue(szLigne, &x) ) 
  return x ;
else 
  return xDefault ;
}

int WritePrivateFloat ( char *szSection, char *szEntry, float xValue
    , char *szFilename )
{
char  szTamp [USUALMAXLENSTRING];

sprintf(szTamp, "%g", xValue);
return WritePrivateString(szSection, szEntry, szTamp, szFilename);
}

int WritePrivateInt ( char *szSection, char *szEntry, int iValue
    , char *szFilename )
{
char  szTamp [USUALMAXLENSTRING];

itoa(iValue, szTamp, 10);
return WritePrivateString(szSection, szEntry, szTamp, szFilename);
}

int WritePrivateIntList ( char *szSection, char *szEntry, int *aiValues
    , unsigned int wCount, char *szFilename )
{

//  #define BUFFER_SIZE 8
char  szOneIntBuffer [8 + 1];
char  *szBuff = (char *)malloc(wCount * 8 + 1);  // Each int: sign+5digits+separator+space

*szBuff         =  0 ;
*szOneIntBuffer =  0 ;
for ( unsigned w = 0 ; w < wCount ; w++ ) 
  {
  sprintf(szOneIntBuffer, "%d, ", aiValues [w]);
  strcat(szBuff, szOneIntBuffer);
  }

unsigned int  wLen = strlen(szBuff);

if ( wLen ) 
  szBuff [wLen - 2] =  0 ; // Remove last

int fRes = WritePrivateString(szSection, szEntry, szBuff, szFilename);

free(szBuff);
return fRes ;
}

/*BIT ExtractItem(char *szList,char *szFirstItem, unsigned int wLen, char **pszNext,
   char *acSeparators)*/
date String2Date ( char *sz )
{
date  dte = { 0, 0, 0 }; // Unexpandable inline

ExtractValue(sz, &dte);
return dte ;
}

/*
     int String2DateEF(char *szDate, date *pdte)
     {
     if (!pdte)
       return FAILURE;
   
     int ai[3];
     char szMonth[16];
     char *szNext=NULL, *szNNext=NULL;
     if (!ExtractItem(szDate,szMonth,16,&szNext,acUsualSeparators))
       *szMonth=0;
     int fFirstMonth=FALSE, fSecondMonth=FALSE;
     ai[0]=Month2Int(szMonth,&fFirstMonth);
     if (!ExtractItem(szNext,szMonth,16,&szNNext,acUsualSeparators))
       *szMonth=0;
     ai[1]=Month2Int(szMonth,&fSecondMonth);
     if (!ExtractValue(szNNext,ai+2,&szNext))
       ai[2]=0;
     if (!fSecondMonth && (fFirstMonth || fEnglishDateLectureFormat))
       {
       pdte->da_mon=ai[0];
       pdte->da_day=ai[1];
       }
     else if (!fSecondMonth || !fFirstMonth)
       {
       pdte->da_day=ai[0];
       pdte->da_mon=ai[1];
       }
     else
       return FAILURE;
   
   
     date dteToday;
     getdate(&dteToday);
     if (!ai[2])
       pdte->da_year=dteToday.da_year;
     else if (fXXthLectureCentury && ai[2] < 100)
       pdte->da_year=ai[2]+1900;
     else
       pdte->da_year=ai[2];
     return (pdte->da_mon>=1 && pdte->da_mon<=12 &&
         pdte->da_day>=1 && pdte->da_day<=31 &&
         pdte->da_year);
     }
   
   int ExtractValue(char *szDate, TDate *pdte, char **pcNext)
     {
     if (!pdte)
       return FAILURE;
     struct date dte={pdte->Year(),pdte->Day(),pdte->Month()};
     if (!ExtractValue(szDate,&dte,pcNext))
       return FAILURE;
     else
       *pdte=TDate(dte.da_day,dte.da_mon,dte.da_year);
     return SUCCESS;
     }
   */
int ExtractValue ( char *szDate, date *pdte, char **pcNext ) //  int String2DateEF(char *szDate, date *pdte)
{
if ( !pdte ) 
  return FAILURE ;

int   ai [3];
char  szMonth [16];
char  *szNext = NULL, *szNNext = NULL ;

if ( !ExtractItem(szDate, szMonth, sizeof(szMonth), &szNext
      , acUsualSeparators) ) 
  *szMonth =  0 ;

int fFirstMonth = FALSE, fSecondMonth = FALSE ;

ai [0] =  Month2Int(szMonth, &fFirstMonth);
if ( !ExtractItem(szNext, szMonth, 16, &szNNext, acUsualSeparators) ) 
  *szMonth =  0 ;
ai [1] =  Month2Int(szMonth, &fSecondMonth);
if ( !ExtractValue(szNNext, ai + 2, pcNext) ) 
  ai [2] =  0 ;
if ( !ai [0] || !ai [1] ) 
  return FALSE ;
if ( !fSecondMonth && (fFirstMonth || fEnglishDateLectureFormat) ) 
  {
  pdte -> da_mon =  ai [0];
  pdte -> da_day =  ai [1];
  }
else if ( !fSecondMonth || !fFirstMonth ) 
  {
  pdte -> da_day =  ai [0];
  pdte -> da_mon =  ai [1];
  }
else 
  return FAILURE ;

date  dteToday ;

getdate(&dteToday);
if ( ai [0] && ai [1] && !ai [2] ) 
  pdte -> da_year =  dteToday.da_year ;
else if ( fXXthLectureCentury && ai [2] < 100 ) 
  pdte -> da_year =  ai [2] + 1900 ;
else 
  pdte -> da_year =  ai [2];
return (pdte -> da_mon >= 1
          && pdte -> da_mon <= 12
          && pdte -> da_day >= 1
          && pdte -> da_day <= 31
          && pdte -> da_year);
}

int String2DateEF_Numeric ( char *szDate, date *pdte )
{
if ( !pdte ) 
  return FAILURE ;

int ai [3];
int fRes = GetIntegerList(szDate, ai, 3);

for ( unsigned char u = fRes ; u < 3 ; u++ ) 
  ai [u] =  0 ;
if ( fEnglishDateLectureFormat ) 
  {
  pdte -> da_mon =  ai [0];
  pdte -> da_day =  ai [1];
  }
else 
  {
  pdte -> da_day =  ai [0];
  pdte -> da_mon =  ai [1];
  }

date  dteToday ;

getdate(&dteToday);
if ( !ai [2] ) 
  pdte -> da_year =  dteToday.da_year ;
else if ( fXXthLectureCentury && ai [2] < 100 ) 
  pdte -> da_year =  ai [2] + 1900 ;
else 
  pdte -> da_year =  ai [2];
return (pdte -> da_mon >= 1
          && pdte -> da_mon <= 12
          && pdte -> da_day >= 1
          && pdte -> da_day <= 31
          && pdte -> da_year);
}

// N'autorise pas de valeur par dfaut (valeur par dfaut = <liste vide>)
unsigned int GetPrivateIntList ( char *szSection, char *szEntry
    , int *aiValues, unsigned int wCount, char *szFilename
    , unsigned int wStringBufferLen )
{
if ( !wStringBufferLen ) 
  wStringBufferLen =  wCount * 8 + 1 ;

char  *szBuff = (char *)malloc(wStringBufferLen); // Each int: sign+5digits+separator+space

GetPrivateString(szSection, szEntry, "", szBuff, wStringBufferLen
  , szFilename);
if ( !strlen(szBuff) ) 
  {
  free(szBuff);
  return 0 ;
  }
else if ( strlen(szBuff) == wStringBufferLen - 1 ) 
  {
  
  // Buffer not big enough
  free(szBuff);
  return GetPrivateIntList(szSection, szEntry, aiValues, wCount, szFilename
    , wStringBufferLen * 2);
  }

// Buffer big enough
unsigned int  wRes = GetIntegerList(szBuff, aiValues, wCount);

free(szBuff);
return wRes ;
}

/*
   date GetPrivateDate(char *szSection,char *szEntry, date dteDefault,
       char *szFileName);
   int WritePrivateDate(char *szSection,char *szEntry, date dte,
       char *szFileName);
   */
/*
   int WritePrivateItemDate(char *szSection,char *szEntry, date dte,
       char *szFileName)
     {
     char szBuffer[16];
     return WritePrivateString(szSection,szEntry,Item2String(dte,szBuffer),szFileName);
     }
   
   char *Date2String(date dte, char *sz)
     {
     sprintf(sz,"%d.%d.%d",dte.da_day, dte.da_mon, dte.da_year);
     return sz;
     }
   */
/*
   TPoint GetPrivatePoint(char *szSection, char * szEntry,
       TPoint ptDefault, char *szFileName)
     {
     char szLigne[USUALMAXLENSTRING*2];
     if (!szSection || !szEntry || !szFileName)
       return ptDefault;
     else
       GetPrivateString(szSection, szEntry, "",szLigne,
                           USUALMAXLENSTRING*2,szFileName);
     TPoint p;
     if (String2PointEF(szLigne,&p))
       return p;
     else
       return ptDefault;
       }
   BIT WritePrivatePoint(char *szSection, char *szEntry, TPoint pValue,
                          char *szFilename)
     {
     char sz[USUALMAXLENSTRING*2];
     wsprintf(sz,"%d,%d",pValue.x,pValue.y);
     return WritePrivateString(szSection, szEntry, sz,szFilename);
     }
     */
char GetPrivateLetter ( char *szSection, char *szEntry, char cDefault
    , char *szFileName )
{
char  szDef [2], szRed [5];

szDef [0] =  cDefault ;
szDef [1] =  0 ;
GetPrivateString(szSection, szEntry, szDef, szRed, 5, szFileName);
if ( szRed [1] ) 
  
  // Red string longer than one character -> failure
  return cDefault ;
else 
  return szRed [0];
}

int WritePrivateLetter ( char *szSection, char *szEntry, char c
    , char *szFileName )
{
char  sz [2];

sz [0] =  c ;
sz [1] =  0 ;
return WritePrivateString(szSection, szEntry, sz, szFileName);
}

/*-------------------------------------------------------------*/
/*                 fonctions locales                       */
/*-------------------------------------------------------------*/
int IsIntelligentCharacter ( unsigned char c )
{
return (c >= 32 && c <= 126) || c == 145 || c == 146 || c >= 192 ;
}

////////////////////////////////////////////////
int IsSection ( char *szLine, char *szSection ) // Say if the line is the given section title.
{

// szSection=NULL as default parameter.
char  *szShortLine = AvaleEspace(szLine);

if ( *szShortLine != '[' ) 
  return FALSE ;
if ( !strchr(szShortLine, ']') ) 
  return FALSE ;
else if ( !szSection ) 
  return TRUE ; // The first non blank character is '[' and there is a ']'. The characters after that are ignored.

char  *szCopy = (char *)malloc(1 + strlen(szShortLine));

strcpy(szCopy, szShortLine + 1); // Copy after the '['.

char  *szEndCopy = strchr(szCopy, ']'); // We know it exists.

*szEndCopy =  0 ; // Close the copy. The copy is just the section without the '[' or ']'.

int f = !strcmpi(szCopy, szSection);

free(szCopy);
return f ;
}

int IsAnySection ( char *szLine, char *szSection, unsigned int wLen ) // Say if the line is a section title and fills szSection with the section name if yes.
{
char  *szShortLine = AvaleEspace(szLine);

if ( *szShortLine != '[' ) 
  return FALSE ;

char  *szEndSection = strchr(szShortLine, ']');

if ( !szEndSection ) 
  return FALSE ;
else 
  *szEndSection =  0 ;
if ( szSection ) 
  strNcpy(szSection, szShortLine + 1, wLen);
*szEndSection =  ']';
return TRUE ;
}

////////////////////////////////////////////////
#if _Windows
int GetPrivateInt ( char *szSection, char *szEntry, int iValue
    , char *szFile )
{
if ( fDOSIniAccess ) 
  return Dos_GetPrivateInt(szSection, szEntry, iValue, szFile);
else 
  return GetPrivateProfileInt(szSection, szEntry, iValue, szFile);
}
#else 
int GetPrivateInt ( char *szSection, char *szEntry, int iValue
    , char *szFile )
{
return Dos_GetPrivateInt(szSection, szEntry, iValue, szFile);
}
#endif
#if _Windows
void GetPrivateString ( char *szSection, char *szEntry
    , char *szDefault
    , char *szBuffer, unsigned int wLen
    , char *szFileName )
{
if ( fDOSIniAccess ) 
  Dos_GetPrivateString(szSection, szEntry, szDefault, szBuffer, wLen
    , szFileName);
else 
  GetPrivateProfileString(szSection, szEntry, szDefault, szBuffer, wLen
    , szFileName);
}
#else 
void GetPrivateString ( char *szSection, char *szEntry
    , char *szDefaultValue, char *szValue, unsigned int wLen
    , char *szFileName )
{
Dos_GetPrivateString(szSection, szEntry, szDefaultValue, szValue, wLen
  , szFileName);
}
#endif
#if _Windows
#else 
void SetWindowsDrive ( char *sz )
{
strncpy(szWindowsDrive, sz, sizeof(szWindowsDrive));
}

void SetWindowsDirectory ( char *sz )
{
strncpy(szWindowsDirectory, sz, sizeof(szWindowsDirectory));
}
#endif

int InsertToFile ( char *szSection, void *pArgs )
{
fprintf((FILE *)pArgs, "[%s]\n", szSection);
return TRUE ;
}

int ExtractAllHeaders ( char *szSource, char *szTarget )
{
FILE  *pfilTarget = fopen(szTarget, "wt");

if ( !pfilTarget ) 
  return 0 ;

int fRes
  = ScanWindowProfileFile(szSource, (void *)pfilTarget
    , InsertToFile /* ex: BuildListOfEpisodeTitles */ , ScanWPFSayYes
    , ScanWPFSayYes, "Extracting headers");

fclose(pfilTarget);
return fRes ;
}

int ScanWPFIsTheSection ( char *szSection, void *pArgs )
{
void  **apArgs = (void **)pArgs ;

return !strcmpi(szSection, (char *)apArgs [0]); // Say if the line is the given section title.
}

int ScanWPFGetPrivateStringFromTheEntry ( char * /* szSection */ 
    , char *szEntry, char *szValue, void *pArgs )
{
void  **apArgs = (void **)pArgs ;

if ( !strcmpi(szEntry, (char *)apArgs [1]) ) 
  {
  *((int *)apArgs [2]) =  TRUE ;
  strNcpy((char *)apArgs [3], szValue, *((int *)apArgs [4]));
  return OFF ; // Arrt
  }
else 
  return ON ;
// Say if the line is the entry and gives its value.
}

void Dos_GetPrivateString ( char *szSection, char *szEntry
    , char *szDefaultValue, char *szValue, unsigned int wLen
    , char *szFileName )
{
if ( !szValue || !wLen ) 
  return ;

int   fFound = 0 ;
void  *apArgs [5]
  = {(void *)szSection, (void *)szEntry, (void *)&fFound, (void *)szValue
    , (void *)&wLen };

*szValue =  0 ;
ScanWindowProfileFile(szFileName, apArgs, ScanWPFSayYes
  , ScanWPFIsTheSection, ScanWPFGetPrivateStringFromTheEntry, NULL);
if ( !fFound ) 
  strNcpy(szValue, szDefaultValue, wLen);
}

int ScanWPFSayYes ( char *, void * )
{
return TRUE ;
}

int ScanWPFSayYes ( char *, char *, char *, void * )
{
return TRUE ;
}

int Dos_GetPrivateInt ( char *szSection, char *szEntry, int iValue
    , char *szFile )
{
char  sz [20], szDef [20];

Dos_GetPrivateString(szSection, szEntry, itoa(iValue, szDef, 10), sz
  , sizeof(sz), szFile);

int iRes ;

if ( !ExtractValue(sz, &iRes) ) 
  return iValue ;
else 
  return iRes ;
}

int Dos_WritePrivateString ( char *szSection, char *szEntry, char *szValue
    , char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char  *szLine = NULL ; // Important for error checking in StatFile.
FILE  *pflSource = NULL, *pflTarget = NULL ;

if ( access(szSource, 06) )
                              {
// Source file does not exist
                              pflSource =  fopen(szSource, "wt");
                              if ( !pflSource ) 
                                return FAILURE ;
                              fprintf(pflSource, "[%s]\n%s=%s\n", szSection
                                , szEntry, szValue);
                              fclose(pflSource);
                              return SUCCESS ;
                              }

unsigned int  wNbMaxCharPerLine = 1024 ; //(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

int fFound = FALSE ;

  {
  char  *pcEOFMarker = NULL ;
  while ( fgetlaline(pflSource, wNbMaxCharPerLine, szLine) ) 
    if ( IsSection(szLine, szSection) ) 
      {
      
      // Go find the entry
      fprintf(pflTarget, "%s\n", szLine);
      while ( (pcEOFMarker
                    = fgetlaline(pflSource, wNbMaxCharPerLine, szLine))
                  != NULL
                && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
        
        // Stops if it meets a section that is not the seeked section.
        if ( IsEntry(szLine, szEntry) ) 
          {
          if ( !fFound )
                          {
// do not give the entry twice if it is found twice
                          fFound =  TRUE ;
                          fprintf(pflTarget, "%s=%s\n", szEntry, szValue);
                          }
          }
        else if ( !IsSection(szLine) ) 
          
          // do not requote if it is the title of the section that was duplicated.
          fprintf(pflTarget, "%s\n", szLine);
      
      // Is stoped because end of file or new section
      if ( !fFound )
                      {
// Has not been seen
                      fFound =  TRUE ;
                      fprintf(pflTarget, "%s=%s\n", szEntry, szValue);
                      }
      if ( pcEOFMarker ) 
        fprintf(pflTarget, "%s\n", szLine);
      }
    else 
      fprintf(pflTarget, "%s\n", szLine);
  }
if ( !fFound ) 
  
  // Has not been seen, nor its section
  fprintf(pflTarget, "[%s]\n%s=%s\n", szSection, szEntry, szValue);
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);
return !rename(szTarget, szSource);
}

int Pre_WriteHook3edPrivateString ( char *szSection, char *szEntry
    , char *szValue, char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char  *szLine = NULL ; // Important for error checking in StatFile.
FILE  *pflSource = NULL, *pflTarget = NULL ;

if ( access(szSource, 06) )
                              {
// Source file does not exist
                              pflSource =  fopen(szSource, "wt");
                              if ( !pflSource ) 
                                return FAILURE ;
                              fprintf(pflSource, "[%s]\n%s=%s\n", szSection
                                , szEntry, szValue);
                              
                              //  ^^^^^^^
                              fclose(pflSource);
                              return SUCCESS ;
                              }

unsigned int  wNbMaxCharPerLine = 1024 ; //(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

int fFound = FALSE ;

  {
  char  *pcEOFMarker = NULL ;
  while ( fgetlaline(pflSource, wNbMaxCharPerLine, szLine) ) 
    if ( IsSection(szLine, szSection) ) //                        ^^^^^^^^^^
                                          {
                                          
                                          // Go find the entry
                                          fprintf(pflTarget, "%s\n", szLine);
  while ( (pcEOFMarker = fgetlaline(pflSource, wNbMaxCharPerLine, szLine))
              != NULL
            && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
    
    // Stops if it meets a section that is not the seeked section.
    // ^^^^^^^^^
    if ( IsEntry(szLine, szEntry) )
                                      {
//   ^^^^^^^
                                      if ( !fFound )
                                                      {
// do not give the entry twice if it is found twice
                                                      fFound =  TRUE ;
                                                      fprintf(pflTarget
                                                        , "%s=%s\n"
                                                        , szEntry, szValue); // ^^^^^^^
                                                      }
                                      }
    else if ( !IsSection(szLine) ) 
      
      // do not requote if it is the title of the section that was duplicated.
      fprintf(pflTarget, "%s\n", szLine); 
                                          
                                          // Is stoped because end of file or new section
                                          if ( !fFound )
                                                          {
// Has not been seen
                                                          fFound =  TRUE ;
                                                          fprintf(pflTarget
                                                            , "%s=%s\n"
                                                            , szEntry
                                                            , szValue); //        ^^^^^^^
                                                          }
                                          if ( pcEOFMarker ) 
                                            fprintf(pflTarget, "%s\n"
                                              , szLine); //                       ^^^^^^^
                                          }
    else 
      fprintf(pflTarget, "%s\n", szLine);
  //      ^^^^^^^^
  }
if ( !fFound ) 
  
  // Has not been seen, nor its section
  fprintf(pflTarget, "[%s]\n%s=%s\n", szSection, szEntry, szValue);

//  ^^^^^^^^                          ^^^^^^^^^^^^^^^^^
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);
return !rename(szTarget, szSource);
}

int ExistSection ( char *szSection, char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char          *szLine = NULL ;           // Important for error checking in StatFile.
FILE          *pflSource = NULL ;

/*  if (!StatFile(szSource,&dwNbChar,&dwNbLine,&dwNbMaxCharPerLine))
   return FALSE;*/
unsigned int  wNbMaxCharPerLine = 1022 ; //(unsigned int)(dwNbMaxCharPerLine>65535L?65535L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine + 2);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }

int fFound = FALSE ;

while ( fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine) && !fFound ) 
  if ( IsSection(szLine, szSection) ) 
    fFound =  TRUE ;
free(szLine);
fclose(pflSource);
return fFound ;
}

int ChangePrivateSectionName ( char *szOldSection, char *szNewSection
    , char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;
char          *szLine = NULL ;
FILE          *pflSource = NULL, *pflTarget = NULL ;

/*  if (!StatFile(szSource,&dwNbChar,&dwNbLine,&dwNbMaxCharPerLine))
   return FAILURE; // File does not exist. */
unsigned int  wNbMaxCharPerLine = 1022 ; //(unsigned int)(dwNbMaxCharPerLine>65535L?65535L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine + 2);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

int fFound = FALSE ;

while ( fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine) ) 
  if ( IsSection(szLine, szOldSection) ) 
    {
    fprintf(pflTarget, "[%s]\n", szNewSection);
    fFound =  TRUE ;
    }
  else 
    fprintf(pflTarget, "%s\n", szLine);
fclose(pflTarget);
fclose(pflSource);
unlink(szSource);
free(szLine);
return !rename(szTarget, szSource) && fFound ;
}

////////////////////////////////////////////////
int RemovePrivateSection ( char *szSection, char *szFileName )
{

//  Trace("Remove section ",szSection,646);
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char          *szLine = NULL ;           // Important for error checking in StatFile.
FILE          *pflSource = NULL, *pflTarget = NULL ;

/*  if (!StatFile(szSource,&dwNbChar,&dwNbLine,&dwNbMaxCharPerLine))
   return FAILURE;*/
unsigned int  wNbMaxCharPerLine = 1022 ; //(unsigned int)(dwNbMaxCharPerLine>65535L?65535L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine + 2);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

int fFound = FALSE ;

  {
  char  *pcEOFMarker = NULL ;
  while ( fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine) ) 
    if ( IsSection(szLine, szSection) ) 
      {
      fFound =  TRUE ;
      
      // Skip until the next section
      //  fprintf(pflTarget,"%s\n",szLine);
      while ( (pcEOFMarker
                    = fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine))
                  != NULL
                && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
        ; // Stops if it meets a section that is not the seeked section.
      
      // Is stopped because end of file or new section
      if ( pcEOFMarker ) 
        fprintf(pflTarget, "%s\n", szLine); // Copy the new section
      }
    else 
      fprintf(pflTarget, "%s\n", szLine);
  }
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);

//  char *szBackUpFile=tempnam("c:\\awbc45\\nitrate","rmbk");
//  rename(szSource,szBackUpFile);
//  Trace("Backup nitrate ",szBackUpFile,691);
//  free(szBackUpFile);
return !rename(szTarget, szSource) && fFound ;
}

////////////////////////////////////////////////
int RemovePrivateEntry ( char *szSection, char *szEntry, char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char          *szLine = NULL ;           // Important for error checking in StatFile.
FILE          *pflSource = NULL, *pflTarget = NULL ;

/*  if (!StatFile(szSource,&dwNbChar,&dwNbLine,&dwNbMaxCharPerLine))
   return FAILURE;*/
unsigned int  wNbMaxCharPerLine = 1022 ; //(unsigned int)(dwNbMaxCharPerLine>65535L?65535L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine + 2);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt");
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

// File is lost if already exist.
int   fFound = FALSE ;
char  *pcEOFMarker = NULL ;

while ( fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine) ) 
  if ( IsSection(szLine, szSection) ) 
    {
    
    // Go find the entry
    fprintf(pflTarget, "%s\n", szLine);
    while ( (pcEOFMarker
                  = fgetlaline(pflSource, wNbMaxCharPerLine + 2, szLine))
                != NULL
              && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
      
      // Stops if it meets a section that is not the seeked section.
      if ( IsEntry(szLine, szEntry) ) 
        fFound =  TRUE ;
      else if ( !IsSection(szLine) ) 
        
        // do not requote if it is the title of the section that was duplicated.
        fprintf(pflTarget, "%s\n", szLine);
    
    // Is stoped because end of file or new section
    if ( pcEOFMarker ) 
      fprintf(pflTarget, "%s\n", szLine);
    }
  else 
    fprintf(pflTarget, "%s\n", szLine);
fclose(pflTarget);
fclose(pflSource);
unlink(szSource);
free(szLine);
return !rename(szTarget, szSource) && fFound ;
}

// Says "YES" if szLine is Entry and fills filed szValue with the entry.
// Do not touch szValue otherwise.
int IsEntry ( char *szLine, char *szEntry, char *szValue, unsigned int wLen ) // Say if the line is the entry and gives its value.
{
char  *szEqualSign = strchr(szLine, '=');

if ( !szEqualSign ) 
  return FALSE ;

char  *szShortLine = AvaleEspace(szLine);

//  char *szCopy=(char *)malloc(1+strlen(szShortLine));
//  strcpy(szCopy,szShortLine);
//  char *szEqualSign=strchr(szShortLineCopy,'='); // We know it exists.
*szEqualSign =  0 ; // Close the copy. The copy is just the entry label.

int f = !strcmpi(szShortLine, szEntry);

if ( f ) 
  
  // the entry is the one
  if ( szValue ) 
    {
    strncpy(szValue, AvaleEspace(szEqualSign + 1), wLen);
    CutTrailingSpaces(szValue);
    }
*szEqualSign =  '='; // Restore
return f ;
}

/*
   name      nom-ANSI  nom-EOM   nom-7     code      cod-ANSI  nom-EOM   cod-7
   */
/*
   char szAllMonthNames[8*10*12+1]="\
   january   janvier   janvier   janvier   jan       jan       jan       jan     \
   february  fvrier   fvrier   fevrier   feb       fv       fv       fev     \
   march     mars      mars      mars      mar       mar       mar       mar     \
   april     avril     avril     avril     apr       avr       avr       avr     \
   may       mai       mai       mai       may       mai       mai       mai     \
   june      juin      juin      juin      jun       jui       jui       jui     \
   july      juillet   juillet   juillet   jul       jui       jui       jui     \
   august    aot      aot      aout      aug       ao       ao       aou     \
   september septembre septembre septembre sep       sep       sep       sep     \
   october   octobre   octobre   octobre   oct       oct       oct       oct     \
   november  novembre  novembre  novembre  nov       nov       nov       nov     \
   december  dcembre  dcembre  decembre  dec       dc       dc       dec     ";
   */
#define DATE_KnownNames 8

char  *szaAllMonthNames [DATE_KnownNames * 12]
  = { // month     mois ANSI     mois OEM    mois ASCII   mmm US       mmm ANSI     mmm OEM      mmm ASCII
     "january", "janvier", "janvier", "janvier", "jan", "jan", "jan"
    , "jan" "february", "fvrier", "fvrier", "fevrier", "feb", "fv"
    , "fv", "fev" "march", "mars", "mars", "mars", "mar", "mar", "mar"
    , "mar" "april", "avril", "avril", "avril", "apr", "avr", "avr"
    , "avr" "may", "mai", "mai", "mai", "may", "mai", "mai", "mai" "june"
    , "juin", "juin", "juin", "jun", "jui", "jui", "jui" "july", "juillet"
    , "juillet", "juillet", "jul", "jui", "jui", "jui" "august", "aot"
    , "aot", "aout", "aug", "ao", "ao", "aou" "september", "septembre"
    , "septembre", "septembre", "sep", "sep", "sep", "sep" "october"
    , "octobre", "octobre", "octobre", "oct", "oct", "oct"
    , "oct" "november", "novembre", "novembre", "novembre", "nov", "nov"
    , "nov", "nov" "december", "dcembre", "dcembre", "decembre", "dec"
    , "dc", "dc", "dec"};

int Month2Int ( char *sz, int *pfIsText )
{
if ( !sz ) 
  {
  if ( pfIsText ) 
    *pfIsText =  FALSE ;
  return 0 ;
  }

int iM = 0 ;

iM =  atoi(sz);
if ( iM ) // Numeric value !=0
            {
            if ( pfIsText ) 
              *pfIsText =  FALSE ;
            return iM ;
            }

char  *szM = (char *)malloc(strlen(AvaleEspace(sz)));

strcpy(szM, AvaleEspace(sz));
CutTrailingSpaces(szM);
for ( unsigned int w = 0 ; w < sizeof(szaAllMonthNames) ; w++ ) 
  if ( strcmpi(szaAllMonthNames [w], szM) ) 
    {
    iM =  w / DATE_KnownNames + 1 ;
    break ;
    }
free(szM);
if ( iM ) 
  {
  if ( pfIsText ) 
    *pfIsText =  TRUE ;
  return iM ;
  }
else 
  {
  if ( pfIsText ) 
    *pfIsText =  FALSE ;
  return 0 ;
  }
}

/*
     if (!strcmpi(sz,"january"))
       return 1;
     else if (!strcmpi(sz,"janvier"))
       return 1;
     else if (!strcmpi(sz,"jan"))
       return 1;
   
     else if (!strcmpi(sz,"february"))
       return 2;
   #if _Windows
     else if (!strcmpi(sz,"fvrier"))
   #else
     else if (!strcmpi(sz,"fvrier"))
   #endif
       return 2;
     else if (!strcmpi(sz,"fevrier"))
       return 2;
     else if (!strcmpi(sz,"fev"))
       return 2;
     else if (!strcmpi(sz,"feb"))
       return 2;
   
     else if (!strcmpi(sz,"march"))
       return 3;
     else if (!strcmpi(sz,"mar"))
       return 3;
     else if (!strcmpi(sz,"mar"))
       return 3;
   
     else if (!strcmpi(sz,"avril"))
       return 4;
     else if (!strcmpi(sz,"april"))
       return 4;
     else if (!strcmpi(sz,"apr"))
       return 4;
     else if (!strcmpi(sz,"avr"))
       return 4;
   
   
     else if (!strcmpi(sz,"mai"))
       return 5;
     else if (!strcmpi(sz,"may"))
       return 5;
   
     else if (!strcmpi(sz,"june"))
       return 6;
     else if (!strcmpi(sz,"juin"))
       return 6;
     else if (!strcmpi(sz,"jun"))
       return 6;
   
     else if (!strcmpi(sz,"july"))
       return 7;
     else if (!strcmpi(sz,"jui"))
       return 7;
     else if (!strcmpi(sz,"jul"))
       return 7;
   
   #if _Windows
     else if (!strcmpi(sz,"aot"))
   #else
     else if (!strcmpi(sz,"aot"))
   #endif
   
       return 8;
     else if (!strcmpi(sz,"aout"))
       return 8;
     else if (!strcmpi(sz,"august"))
       return 8;
     else if (!strcmpi(sz,"aou"))
       return 8;
     else if (!strcmpi(sz,"aug"))
       return 8;
   
   #if _Windows
     else if (!strcmpi(sz,"ao"))
   #else
     else if (!strcmpi(sz,"ao"))
   #endif
   
       return 8;
     else if (!strcmpi(sz,"september"))
       return 9;
     else if (!strcmpi(sz,"septembre"))
       return 9;
     else if (!strcmpi(sz,"sep"))
       return 9;
   
     else if (!strcmpi(sz,"octobre"))
       return 10;
     else if (!strcmpi(sz,"october"))
       return 10;
     else if (!strcmpi(sz,"oct"))
       return 10;
   
     else if (!strcmpi(sz,"novembre"))
       return 11;
     else if (!strcmpi(sz,"november"))
       return 11;
     else if (!strcmpi(sz,"nov"))
       return 11;
   
     else if (!strcmpi(sz,"december"))
       return 12;
     else if (!strcmpi(sz,"decembre"))
       return 12;
     else if (!strcmpi(sz,"dec"))
       return 12;
   
   #if _Windows
     else if (!strcmpi(sz,"dcembre"))
   #else
     else if (!strcmpi(sz,"dcembre"))
   #endif
   
       return 12;
     else
       {
       if (pfIsText) *pfIsText=FALSE;
       return 0;
       }
   */
char *Time2String ( struct time t, char *sz )
{
sprintf(sz, szTimeFormat, t.ti_hour, t.ti_min, t.ti_sec);
return sz ;
}

int String2TimeEF ( char *sz, struct time *p )
{
if ( !sz || !*sz ) 
  {
  struct time tt = { 0, 0, 0, 0 };
  *p =  tt ;
  return FAILURE ;
  }

char  *szOldSeparators = acUsualSeparators
  , *szNewSeparators = (char *)malloc(7 + strlen(acUsualSeparators));

strcat(strcpy(szNewSeparators, acUsualSeparators), "hmsHMS");
acUsualSeparators =  szNewSeparators ;

unsigned int  wParam [3];
char          acSeparators [3], *szIndex = sz ;
unsigned int  wNblus = 0 ;

while ( szIndex && wNblus < 3 ) 
  if ( ExtractValue(szIndex, wParam + wNblus, &szIndex) ) 
    acSeparators [wNblus++] =  szIndex ? *(szIndex - 1) : 0 ;
  else 
    break ;
acUsualSeparators =  szOldSeparators ;
free(szNewSeparators);
if ( !wNblus ) 
  {
  struct time tt = { 0, 0, 0, 0 };
  *p =  tt ;
  return FAILURE ;
  }
else if ( wNblus == 1 ) 
  {
  if ( acSeparators [0] && strchr("Hh:", acSeparators [0]) ) 
    {
    struct time tt = { 0, wParam [0], 0, 0 };
    *p =  tt ;
    return SUCCESS ;
    }
  else if ( acSeparators [0] && strchr("Mm'", acSeparators [0]) ) 
    {
    struct time tt = { wParam [0], 0, 0, 0 };
    *p =  tt ;
    
    //      *p=TTime(0,wParam[0],0);
    return SUCCESS ;
    }
  else 
    {
    struct time tt ; /// min, heur, centimes, secondes (uchar)
    tt.ti_hour =  wParam [0] / 3600 ;
    tt.ti_min  =  (wParam [0] % 3600) / 60 ;
    tt.ti_sec  =  (wParam [0] % 60);
    *p         =  tt ;
    
    //      *p=TTime(0,0,wParam[0]);
    return SUCCESS ;
    }
  }
else if ( wNblus == 2 ) // 2 int red on string
                          {
                          if ( acSeparators [0]
                                && strchr("Hh:", acSeparators [0]) ) 
                            {
                            struct time tt
                              = { wParam [1], wParam [0], 0, 0 };
                            *p =  tt ;
                            
                            //      *p=TTime(wParam[0],wParam[1],0);
                            return SUCCESS ;
                            }
                          else if ( acSeparators [0]
                                      && strchr("Mm'", acSeparators [0]) ) 
                            {
                            struct time tt
                              = { wParam [0], 0, 0, wParam [1]};
                            *p =  tt ;
                            
                            //      *p=TTime(0,wParam[0],wParam[1]);
                            return SUCCESS ;
                            }
                          else 
                          
                          // 1st id unknown
                            {
                            if ( acSeparators [1]
                                  && strchr("Hh", acSeparators [1]) ) // 2nd one is "hour"
                                                                        {
                                                                        struct time tt = { 0, wParam [1], 0, 0 };
                                                                        *p =  tt ;
                                                                        return FAILURE ;
                                                                        }
                            else if ( acSeparators [1]
                                        && strchr(":Mm'", acSeparators [1]) ) //2nd one is "minute"
{
struct time tt = { wParam [1], wParam [0], 0, 0 };
*p =  tt ;
return SUCCESS ;
}                           
                            else 
                            
                            // both unknown
                              {
                              struct time tt_ms
                                = { wParam [0], 0, 0, wParam [1]}; // min, hour, 0, sec
                              struct time tt_hm
                                = { wParam [1], wParam [0], 0, 0 }; // min, hour, 0, sec
                              *p =  cDefaultClockMinSec ? tt_ms : tt_hm ;
                              return SUCCESS ;
                              }
                            }
                          }
else if ( wNblus == 3 ) 
  {
  struct time tt = { wParam [1], wParam [0], 0, wParam [2]};
  *p =  tt ;
  
  //    *p=TTime(wParam[0],wParam[1],wParam[2]);
  return SUCCES ;
  }
else 
  return FAILURE ;
}

struct time String2stTimeEF ( char *sz )
{
struct time t ;

String2TimeEF(sz, &t);
return t ;
}

// Say if there is a matching section, and give the matching section
#if _Windows

class THook3er
{
  
  public :
  
    TListImp<T3Strings>   lsszProfiles ;
    char                  *szFileName ;
                          THook3er () ;
                          THook3er (char *szFile) ;
                          ~THook3er () ;
};

class TProfileSection
{
  
  public :
  
    char                  *szSection ;
    
    //    inline TProfileSection(char *sz=""){szSection=(char *)malloc(1+strlen(sz));}
    TListImp<T2Strings>   *plsszEntries ;
    
    void Free ()
    {
    free(szSection);
    szSection =  NULL ;
    if ( !plsszEntries -> IsEmpty() ) 
      MErreur("Unemptied profile list", 2091);
    else 
      delete plsszEntries ;
    }
};

inline int operator== ( TProfileSection s1, TProfileSection s2 )
{
return s1.szSection == s2.szSection && s1.plsszEntries == s2.plsszEntries ;
}

//////////////////////////////////////////////////////////////
//                 variables locales
//////////////////////////////////////////////////////////////
//TListImp<T3StringsPlusFileName> lsszPublicHook3edFileList;
TListImp<THook3er *>  lpsPublicHook3s ;
//char Hook3edFile[MAXPATH]="";
//  FILE *pfilHook3edStream;
//////////////////////////////////////////////////////////////
//              prototypes des fonctions locales
//////////////////////////////////////////////////////////////
//              prototypes des fonctions  exporter
int                   Hook3PrivateString (char *szSection, char *szEntry
  , char *szValue, THook3er *pHook3) ;
THook3er              *FindHook3er (char *szFile) ;
//////////////////////////////////////////////////////////////
//              Corps des fonctions  exporter
//////////////////////////////////////////////////////////////
// Sent all the profiles in the stream
void                  Hook3edStreamFlush (TListImp<T3Strings> *plszProfile
  , FILE *pflTarget) ;

// Sent all the profile of the given section in the stream
void                  Hook3edStreamFlush (char *szSection
  , TListImp<T3Strings> *plszProfile, FILE *pflTarget) ;

/* Say if there is a matching section, and give the matching section in
   the string szSection */
int                   SectionMatches (char *szLine
  , TListImp<T3Strings> *plszProfile, char *szSection) ;

// Give (and remove) the first {entry,value} that matches the section
int                   EntryMatches (char *szLine
  , TListImp<T3Strings> *plszProfile, char *szSection, char *szEntry
  , char *szValue) ; // Tells if the line matches one of the given profile and says which entry.

BOOL WritePrivateString ( char *szSection, char *szEntry, char *szValue
    , char *szFile )
{
THook3er  *pHook3er = FindHook3er(szFile);

if ( pHook3er ) 
  return Hook3PrivateString(szSection, szEntry, szValue, pHook3er);
else 
  {
  if ( fDOSIniAccess ) 
    return Dos_WritePrivateString(szSection, szEntry, szValue, szFile) ? 
         1
      : 0 ;
  else 
    return WritePrivateProfileString(szSection, szEntry, szValue, szFile) ? 
         1
      : 0 ;
  }
}

//////////////////////////////////////////////////////////////
//              Corps des fonctions locales
//////////////////////////////////////////////////////////////
int fnSplitWindowsPath ( char *szWindowsDirectory_in
    , char *szWindowsDrive_in )
{
char  szPlainName [MAXFILE], szExt [MAXEXT];
char  szWindowsPath [MAXPATH];

GetWindowsDirectory(szWindowsPath, MAXPATH);
if ( FILENAME
      & fnsplit(szWindowsPath, szWindowsDrive_in, szWindowsDirectory_in
        , szPlainName, szExt) ) 
  strcat(szWindowsDirectory_in, szPlainName);
return SUCCESS ;
}

char *Time2String ( TTime t, char *sz )
{
wsprintf(sz, "%d:%d'%d\"", t.Hour(), t.Minute(), t.Second());
return sz ;
}

BOOL String2TimeEF ( char *sz, TTime *p )
{
if ( !sz || !*sz ) 
  {
  *p =  TTime(0, 0, 0);
  return FAILURE ;
  }

char  *szOldSeparators = acUsualSeparators
  , *szNewSeparators = (char *)malloc(7 + strlen(acUsualSeparators));

strcat(strcpy(szNewSeparators, acUsualSeparators), "hmsHMS");
acUsualSeparators =  szNewSeparators ;

unsigned int  wParam [3];
char          acSeparators [3], *szIndex = sz ;
unsigned int  wNblus = 0 ;

while ( szIndex && wNblus < 3 ) 
  if ( ExtractValue(szIndex, wParam + wNblus, &szIndex) ) 
    acSeparators [wNblus++] =  szIndex ? *(szIndex - 1) : 0 ;
  else 
    break ;
acUsualSeparators =  szOldSeparators ;
free(szNewSeparators);
if ( !wNblus ) 
  {
  *p =  TTime(0, 0, 0);
  return FAILURE ;
  }
else if ( wNblus == 1 ) 
  {
  if ( acSeparators [0] && strchr("Hh:", acSeparators [0]) ) 
    {
    *p =  TTime(wParam [0], 0, 0);
    return SUCCESS ;
    }
  else if ( acSeparators [0] && strchr("Mm'", acSeparators [0]) ) 
    {
    *p =  TTime(0, wParam [0], 0);
    return SUCCESS ;
    }
  else 
    {
    *p =  TTime(0, 0, wParam [0]);
    return SUCCESS ;
    }
  }
else if ( wNblus == 2 ) 
  {
  if ( acSeparators [0] && strchr("Hh:", acSeparators [0]) ) 
    {
    *p =  TTime(wParam [0], wParam [1], 0);
    return SUCCESS ;
    }
  else if ( acSeparators [0] && strchr("Mm'", acSeparators [0]) ) 
    {
    *p =  TTime(0, wParam [0], wParam [1]);
    return SUCCESS ;
    }
  else 
  
  // 1st id unknown
    {
    if ( acSeparators [1] && strchr("Hh", acSeparators [1]) ) 
      {
      *p =  TTime(wParam [1], 0, 0);
      return FAILURE ;
      }
    else if ( acSeparators [1] && strchr(":Mm'", acSeparators [1]) ) 
      {
      *p =  TTime(wParam [0], wParam [1], 0);
      return SUCCESS ;
      }
    else 
      {
      *p =  TTime(0, wParam [0], wParam [1]);
      return SUCCESS ;
      }
    }
  }
else if ( wNblus == 3 ) 
  {
  *p =  TTime(wParam [0], wParam [1], wParam [2]);
  return SUCCES ;
  }
else 
  return FAILURE ;
}

TTime String2TimeEF ( char *sz )
{
TTime t ;

String2TimeEF(sz, &t);
return t ;
}

void IterSectionMatches ( T3Strings &sszProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

if ( !*((int *)apArg [2]) && IsSection((char *)apArg [0], sszProfile.sz1) ) 
  {
  *((int *)apArg [2]) =  TRUE ;
  strNcpy((char *)apArg [1], sszProfile.sz1, STRLEN_OperatingProfile);
  }
}

int SectionMatches ( char *szLine, TListImp<T3Strings> *plszProfile
    , char *szSection )
{
if ( !IsSection(szLine) ) 
  return FALSE ;
else 
  {
  int   f = FAILURE ;
  void  *apArg [3] = {(void *)szLine, (void *)szSection, (void *)&f };
  plszProfile -> ForEach(IterSectionMatches, (void *)apArg);
  return f ;
  }
}

// Say if there is a matching section, and give the matching section
void IterEntryMatches ( T2Strings &sszEntVal, void *pArg )
{
void  **apArg = (void **)pArg ;

if ( !*((int *)apArg [1]) && !strcmpi(sszEntVal.sz1, (char *)apArg [0]) ) 
  {
  *((int *)apArg [1])       =  TRUE ;
  *((T2Strings *)apArg [2]) =  sszEntVal ;
  }
}

void IterEntryMatches ( T3Strings &sszProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

if ( !*((int *)apArg [2])
      && !strcmpi(sszProfile.sz1, (char *)apArg [0])
      && !strcmpi(sszProfile.sz2, (char *)apArg [1]) ) 
  {
  *((int *)apArg [2])       =  TRUE ;
  *((T3Strings *)apArg [3]) =  sszProfile ;
  }
}

// Give (and remove) the first {entry,value} that matches the section
int EntryMatches ( char *szLine, TListImp<T3Strings> *plszProfile
    , char *szSection, char *szEntry, char *szValue )
{
int       f = FAILURE ;
T3Strings sszProfile ;
char      *szEqualSign = strchr(szLine, '=');

if ( !szEqualSign ) 
  return FALSE ;

char  *szShortLine = AvaleEspace(szLine); // ShortLine points on the Entry label

*szEqualSign =  0 ;

//               szEqualSign +1  points after the 1st '=' ie on the value.
void  *apArg [4]
  = {(void *)szSection, (void *)szShortLine, (void *)&f
    , (void *)&sszProfile };

/*  void *apArg[5]={(void *)szLine,(void *)szSection, (void *)szEntry,
   (void *)&sszProfile,(void *)&f};*/
plszProfile -> ForEach(IterEntryMatches, (void *)apArg);
*szEqualSign =  '=';
if ( f ) 
  {
  strNcpy(szValue, sszProfile.sz3, STRLEN_OperatingProfile);
  strNcpy(szEntry, sszProfile.sz2, STRLEN_OperatingProfile);
  sszProfile.Free();
  plszProfile -> Detach(sszProfile);
  }
return f ;
}

void IterHook3edStreamFlush ( T3Strings &sszProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

if ( !strcmpi(sszProfile.sz1, (char *)apArg [0]) ) 
  {
  fprintf((FILE *)apArg [1], "%s=%s\n", sszProfile.sz2, sszProfile.sz3);
  
  //    fprintf(pfilHook3edStream,"%s=%s\n",sszProfile.sz2,sszProfile.sz3);
  ((TListImp<T3Strings> *)apArg [2]) -> Add(sszProfile);
  }
}

//TListImp<T3Strings> lsszSections;
void IterAllSections ( T3Strings &sszProfile, void *plsszSections )
{
char  *sz = (char *)malloc(3 + strlen(sszProfile.sz1))
  , sz2 [STRLEN_OperatingProfile];

sprintf(sz, "[%s]", sszProfile.sz1);
if ( !SectionMatches(sz, (TListImp<T3Strings> *)plsszSections, sz2) ) 
  
  //  if (! SectionMatches(sz,&lsszSections,sz2))
  ((TListImp<T3Strings> *)plsszSections) -> Add(sszProfile);

//    lsszSections.Add(sszProfile);
free(sz);
}

void IterDetachFrom ( T3Strings &sszProfile, void *plszProfile )
{
sszProfile.Free();
((TListImp<T3Strings> *)plszProfile) -> Detach(sszProfile);
}

// Sent all the profile of the given section in the stream (de not sent the section header).
void Hook3edStreamFlush ( char *szSection, TListImp<T3Strings> *plszProfile
    , FILE *pflTarget )
{
TListImp<T3Strings>   lsszProcessed ;
void                  *apArg [3]
  = {(void *)szSection, (void *)pflTarget, (void *)&lsszProcessed };

plszProfile -> ForEach(IterHook3edStreamFlush, (void *)apArg);
lsszProcessed.ForEach(IterDetachFrom, (void *)plszProfile);
}

void IterProcessSection ( T3Strings &sszProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

fprintf((FILE *)apArg [1], "[%s]\n", sszProfile.sz1);
Hook3edStreamFlush(sszProfile.sz1, (TListImp<T3Strings> *)apArg [0]
  , (FILE *)apArg [1]);
}

void Hook3edStreamFlush ( TListImp<T3Strings> *plszProfile, FILE *pflTarget )
{
TListImp<T3Strings>   lsszSections ;

plszProfile -> ForEach(IterAllSections, (void *)&lsszSections);

void  *apArg [2] = {(void *)plszProfile, (void *)pflTarget };

lsszSections.ForEach(IterProcessSection, (void *)apArg);
lsszSections.Flush();
}

////////////////////////////////////////////////
// A list of {szSection,szEntry,szValue} is given as argument
int Hook3edFileFlush ( TListImp<T3Strings> *plszProfile, char *szFileName )
{
char  szSource [MAXPATH];
char  szSection [STRLEN_OperatingProfile]
  , szEntry [STRLEN_OperatingProfile], szValue [STRLEN_OperatingProfile];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;
char  *szLine = NULL ;
FILE  *pflSource = NULL, *pflTarget = NULL ;

if ( access(szSource, 06) ) 
  {
  
  // Source file does not exist
  pflTarget =  fopen(szSource, "wt");
  if ( !pflTarget ) 
    return FAILURE ;
  Hook3edStreamFlush(plszProfile, pflTarget);
  
  //    fprintf(pflSource,"[%s]\n%s=%s\n",szSection,szEntry,szValue);
  //    ^^^^^^^
  //    Sent all the profiles.
  fclose(pflTarget);
  return SUCCESS ;
  }

unsigned int  wNbMaxCharPerLine = STRLEN_OperatingProfile ; //(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

//  int fFound=FALSE;
char  *pcEOFMarker = fgetlaline(pflSource, wNbMaxCharPerLine, szLine);

while ( pcEOFMarker ) 
  if ( SectionMatches(szLine, plszProfile, szSection) ) 
    {
    
    // See if its match and give the name of the matching section.
    //                        ^^^^^^^^^^
    // If line is ONE of the profile, ie: if line matches One of the profile (and tell me which one)
    // Go find the entry
    fprintf(pflTarget, "%s\n", szLine);
    pcEOFMarker =  fgetlaline(pflSource, wNbMaxCharPerLine, szLine);
    while ( pcEOFMarker
              && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
      {
      
      //                                                  ^^^^^^^^^
      // Stops if it meets a section that is not the seeked section.
      // One can suppress this last test: if section header is repeated,
      // the value after will be ignored.
      if ( EntryMatches(szLine, plszProfile, szSection, szEntry, szValue) ) 
        
        // Tells if the line matches one of the given profile and says which entry.
        // If line matches one of the couples (section, entry)
        fprintf(pflTarget, "%s=%s\n", szEntry, szValue); // ^^^^^^^
                                                        // Process the matching line and section
      else if ( !IsSection(szLine) ) 
        
        // do not requote if it is the title of the section that was duplicated.
        //                ^^^^^^^^^^^^^^^^^^^  Ignore this check (suppose always true).
        fprintf(pflTarget, "%s\n", szLine);
      
      // Is stopped because end of file or new section
      pcEOFMarker =  fgetlaline(pflSource, wNbMaxCharPerLine, szLine);
      }
    Hook3edStreamFlush(szSection, plszProfile, pflTarget); // This is a new section header (or end of file)
    }
  else 
    {
    fprintf(pflTarget, "%s\n", szLine);
    
    //      ^^^^^^^^ (no matching section)
    pcEOFMarker =  fgetlaline(pflSource, wNbMaxCharPerLine, szLine);
    }

//  fclose(pflTarget);
//  pfilHook3edStream=pflTarget;
Hook3edStreamFlush(plszProfile, pflTarget);
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);
return !rename(szTarget, szSource);
}

int Hook3PrivateString ( char *szSection, char *szEntry, char *szValue
    , THook3er *pHook3 )
{
T3Strings sszP ;

sszP.sz1 =  (char *)malloc(strlen(szSection) + 1);
sszP.sz2 =  (char *)malloc(strlen(szEntry) + 1);
sszP.sz3 =  (char *)malloc(strlen(szValue) + 1);
strcpy(sszP.sz1, szSection);
strcpy(sszP.sz2, szEntry);
strcpy(sszP.sz3, szValue);
pHook3 -> lsszProfiles.Add(sszP);
return SUCCESS ;
}

int IsHook3ed ( char *szFile )
{
return !!FindHook3er(szFile);
}

int IsHooked ( char *szFile )
{
return IsHook3ed(szFile);
}

THook3er::~THook3er ()
{
if ( !lsszProfiles.IsEmpty() ) 
  {
  Erreur("Loss of profiles in unhooking of ", szFileName, 477);
  WritePrivateMultiLinedList("Loss of profiles in unhooking", "Bug"
    , &lsszProfiles, szNomTraceur);
  }
free(szFileName); //  delete plsszProfiles;
}

THook3er::THook3er ( char *szFile )
{

//  plsszProfiles=new TListImp<T3Strings>;
szFileName =  (char *)malloc(strlen(szFile) + 1);
strcpy(szFileName, szFile);
}

void IterFindHook3er ( THook3er *&psHook3er, void *pArgs )
{
void  **apArg = (void **)pArgs ;

if ( !strcmpi((char *)apArg [0], psHook3er -> szFileName) ) 
  *((THook3er **)apArg [1]) =  psHook3er ;
}

THook3er *FindHook3er ( char *szFile )
{
THook3er  *pHook3er = NULL ;
void      *apArg [2] = {(void *)szFile, (void *)&pHook3er };

lpsPublicHook3s.ForEach(IterFindHook3er, (void *)apArg);
return pHook3er ;
}

int Hook3 ( char *szFile )
{
THook3er  *pHook3er = FindHook3er(szFile);

if ( !pHook3er ) 
  {
  THook3er  *pHook3er = new THook3er(szFile);
  lpsPublicHook3s.Add(pHook3er);
  return SUCCES ;
  }
else 
  return Erreur("File is already hooked :", szFile, 450);
//    return !!strNcpy(Hook3edFile,szFile,sizeof(Hook3edFile));
}

int Hook ( char *szFile )
{
return Hook3(szFile);
}

int UnHook3 ( char *szFile )
{
THook3er  *pHook3er = FindHook3er(szFile);

if ( !pHook3er ) 
  return Erreur("File is not hooked :", szFile, 458);
else 
  {
  lpsPublicHook3s.Detach(pHook3er);
  if ( !pHook3er -> lsszProfiles.IsEmpty() ) 
    Hook3edFileFlush(&(pHook3er -> lsszProfiles), szFile);
  delete pHook3er ;
  return SUCCES ;
  }
}
#endif
#if _Windows
int UnHook ( char *szFile )
{
return UnHook3(szFile);
}
#else 
int WritePrivateString ( char *szSection, char *szEntry, char *szValue
    , char *szFileName )
{
return Dos_WritePrivateString(szSection, szEntry, szValue, szFileName);
}
#endif

// Say if there is a matching section, and give the matching section
#if _Windows
//////////////////////////////////////////////////////////////
//                 variables locales
//////////////////////////////////////////////////////////////
//TListImp<T3StringsPlusFileName> lsszPublicHook2edFileList;
//char Hook2edFile[MAXPATH]="";
//  FILE *pfilHook2edStream;
//////////////////////////////////////////////////////////////
//              prototypes des fonctions locales
//////////////////////////////////////////////////////////////
//              prototypes des fonctions  exporter
//////////////////////////////////////////////////////////////
//              Corps des fonctions  exporter
//////////////////////////////////////////////////////////////
/*
   inline int operator ==(T3Strings left, T3Strings right)
           {return left.sz1==right.sz1 && left.sz2==right.sz2 &&
             left.sz3==right.sz3;}
   */
/* Say if there is a matching section, and give the matching section in
   the string szSection */
TProfileSection FindMatchingSection (char *szLine
  , TListImp<TProfileSection> *plsProfile) ;

// Give (and remove) the first {entry,value} that matches the section
int             EntryMatches (char *szLine, TProfileSection *plsProfile
  , char *szEntry, char *szValue) ; // Tells if the line matches one of the given profile and says which entry.

//////////////////////////////////////////////////////////////
//              Corps des fonctions locales
//////////////////////////////////////////////////////////////
void IterHook2edStreamFlush ( T2Strings &sszProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

fprintf((FILE *)apArg [0], "%s=%s\n", sszProfile.sz1, sszProfile.sz2);
((TListImp<T2Strings> *)apArg [1]) -> Add(sszProfile);
}

//TListImp<T3Strings> lsszSections;
void IterDetachFrom ( T2Strings &sszProfile, void *plszProfile )
{
sszProfile.Free();
((TListImp<T2Strings> *)plszProfile) -> Detach(sszProfile);
}

// Sent all the profile of the given section in the stream (de not sent the section header).
void Hook2edStreamFlush ( TProfileSection *plsszEntries, FILE *pflTarget )
{
TListImp<T2Strings>   lsszProcessed ;
void                  *apArg [2] = {(void *)pflTarget, (void *)&lsszProcessed };

plsszEntries -> plsszEntries -> ForEach(IterHook2edStreamFlush
  , (void *)apArg);
lsszProcessed.ForEach(IterDetachFrom, (void *)plsszEntries -> plsszEntries);
lsszProcessed.Flush();
}

void IterProcessSection ( TProfileSection &sSection, void *pArg )
{
fprintf((FILE *)pArg, "[%s]\n", sSection.szSection);
Hook2edStreamFlush(&sSection, (FILE *)pArg);
sSection.Free();
}

void Hook2edStreamFlush ( TListImp<TProfileSection> *plsProfile
    , FILE *pflTarget )
{

//  TListImp<T3Strings> lsszSections;
//  plsProfile->ForEach(IterAllSections,(void *)&lsszSections);
//  void *apArg[2]={(void *)plszProfile,(void *)pflTarget};
plsProfile -> ForEach(IterProcessSection, (void *)pflTarget);
plsProfile -> Flush();
}

////////////////////////////////////////////////
// A list of {szSection,szEntry,szValue} is given as argument
int Hook2edFileFlush ( TListImp<TProfileSection> *plsProfile
    , char *szFileName )
{
char  szSource [MAXPATH];
char  szEntry [STRLEN_OperatingProfile], szValue [STRLEN_OperatingProfile];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;
char  *szLine = NULL ;
FILE  *pflSource = NULL, *pflTarget = NULL ;

if ( access(szSource, 06) ) // Source file does not exist
                              {
                              pflTarget =  fopen(szSource, "wt");
                              if ( !pflTarget ) 
                                return FAILURE ;
                              Hook2edStreamFlush(plsProfile, pflTarget);
                              
                              //    fprintf(pflSource,"[%s]\n%s=%s\n",szSection,szEntry,szValue);
                              //    ^^^^^^^
                              //    Sent all the profiles.
                              fclose(pflTarget);
                              return SUCCESS ;
                              }

unsigned int  wNbMaxCharPerLine = STRLEN_OperatingProfile ; //(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

//  int fFound=FALSE;
char  *pcEOFMarker = fgetlaline(pflSource, wNbMaxCharPerLine, szLine);

while ( pcEOFMarker ) 
  {
  TProfileSection sProfiles = FindMatchingSection(szLine, plsProfile);
  
  // See if its match,  give the name of the matching section and removes it from the list.
  if ( sProfiles.szSection ) // If line is ONE of the profile, ie: if line matches One of the profile (and tell me which one)
                              {
                              
                              // Go find the entry
                              fprintf(pflTarget, "%s\n", szLine);
                              pcEOFMarker
                                =  fgetlaline(pflSource, wNbMaxCharPerLine
                                  , szLine);
                              while ( pcEOFMarker
                                        && (!IsSection(szLine)
                                              || IsSection(szLine
                                                , sProfiles.szSection)) ) // Stops if it meets a section that is not the seeked section.
                                                                          // One can suppress this last test: if section header is repeated,
                                                                          // the value after will be ignored.
{
if ( EntryMatches(szLine, &sProfiles, szEntry, szValue) ) 
  
  // Tells if the line matches one of the given profile and says which entry.
  // If line matches one of the couples (section, entry)
  fprintf(pflTarget, "%s=%s\n", szEntry, szValue); // ^^^^^^^
                                                  // Process the matching line and section
else if ( !IsSection(szLine) ) 
  
  // do not requote if it is the title of the section that was duplicated.
  //                ^^^^^^^^^^^^^^^^^^^  Ignore this check (suppose always true).
  fprintf(pflTarget, "%s\n", szLine);

// Is stopped because end of file or new section
pcEOFMarker =  fgetlaline(pflSource, wNbMaxCharPerLine, szLine);
}                             
                              Hook2edStreamFlush(&sProfiles, pflTarget);
                              
                              // This is a new section header (or end of file)
                              sProfiles.Free();
                              }
  else 
    {
    fprintf(pflTarget, "%s\n", szLine);
    
    //      ^^^^^^^^ (no matching section)
    pcEOFMarker =  fgetlaline(pflSource, wNbMaxCharPerLine, szLine);
    }
  //  fclose(pflTarget);
  //  pfilHook2edStream=pflTarget;
  }
Hook2edStreamFlush(plsProfile, pflTarget);
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);
return !rename(szTarget, szSource);
}

// See if its match,  give the name of the matching section and removes it from the list.
void IterFindMatchingSection ( TProfileSection &sProfile, void *pArg )
{
void  **apArg = (void **)pArg ;

if ( !*((TProfileSection **)apArg [1])
      && IsSection((char *)apArg [0], sProfile.szSection) ) 
  *((TProfileSection **)apArg [1]) =  &sProfile ;
}

TProfileSection FindMatchingSection ( char *szLine
    , TListImp<TProfileSection> *plsProfile )
{
TProfileSection *psProfileSection = NULL ;

if ( IsSection(szLine) ) 
  {
  void  *apArgs [2] = {(void *)szLine, (void *)&psProfileSection };
  plsProfile -> ForEach(IterFindMatchingSection, (void *)apArgs);
  }

TProfileSection sProfileSection ;

if ( psProfileSection ) 
  {
  sProfileSection =  *psProfileSection ;
  plsProfile -> Detach(sProfileSection);
  }
else 
  sProfileSection.szSection =  NULL ;
return sProfileSection ;
}
#endif
#if _Windows
int ExtractValue ( char *sz, TDate *p, char **pcNext ) //int String2ItemEF(char *sz, TDate *p)
{
date  dte ;

if ( p ) 
  {
  int f = ExtractValue(sz, &dte, pcNext);
  *p =  TDate(dte.da_day, dte.da_mon, dte.da_year);
  return f ;
  }
else 
  return FALSE ;
}

char *Item2String ( TDate dte, char *sz )
{
sprintf(sz, "%d/%d/%d", dte.Day(), dte.Month(), dte.Year());
return sz ;
}
#endif

/* Replace szOld by szNew in szVictim.
   szOld must not be shorter than szNew;
   unsigned int wVictimLen is facultative and, if given, must be equal to strlen(szVictim).
   ChangeStringEqSiz is faster. Use ChangeStringEqSiz when szOld and szNew have the same size.
   In ChangeString, if szOld is shorter than szNew, proghramm assumes that there is enough allocated space in szVictim to copy it.
        */
int ChangeStringEqSiz ( char *szVictim, char *szOld, char *szNew
    , unsigned int wVictimLen )
{
if ( !szVictim || !szOld || !szNew || !*szOld || !*szNew ) 
  return FAILURE ;
if ( !*szVictim ) 
  return SUCCESS ;
if ( !wVictimLen ) 
  wVictimLen =  strlen(szVictim);

unsigned int  wRepLen = strlen(szOld);

if ( strlen(szOld) != wRepLen ) 
  return FAILURE ;

char  *szIndex = strstr(szVictim, szOld);

while ( szIndex ) 
  {
  strncpy(szIndex, szOld, wRepLen);
  szIndex =  strstr(szVictim, szIndex + wRepLen);
  }
return SUCCESS ;
}

int ChangeString ( char *szVictim, char *szOld, char *szNew
    , unsigned int wVictimLen )
{
if ( !szVictim || !szOld || !szNew || !*szOld ) 
  return FAILURE ;
if ( !*szVictim ) 
  return SUCCESS ;
if ( !wVictimLen ) 
  wVictimLen =  strlen(szVictim);

unsigned int  wRepLen = strlen(szOld);
char          *szIndex ;
char          *szStart = szVictim, *szTarget = (char *)malloc(1 + wVictimLen); // szEnd point on the 0.

*szTarget =  0 ;
do 
  {
  szIndex =  strstr(szStart, szOld);
  if ( !szIndex ) 
    strcat(szTarget, szStart);
  else 
    {
    strncat(szTarget, szStart, (unsigned int)(szIndex - szStart));
    strcat(szTarget, szNew);
    szStart =  szIndex + wRepLen ;
    }
  } 
while ( szIndex );
strcpy(szVictim, szTarget);
return SUCCESS ;
}

// THook2
#if _Windows

class THook2er
{
  
  public :
  
    TListImp<TProfileSection>   lsProfiles ;
    char                        *szFileName ;
                                THook2er () ;
                                THook2er (char *szFile) ;
                                ~THook2er () ;
};
TListImp<THook2er *>  lpsPublicHook2s ;
int                   Hook2PrivateString (char *szSection, char *szEntry
  , char *szValue, THook2er *pHook2) ;
THook2er              *FindHook2er (char *szFile) ;
int                   IsHook2ed (char *szFile) ;
int                   Hook2 (char *szFile) ;
int                   UnHook2 (char *szFile) ;

int Pre_WriteHook2edPrivateString ( char *szSection, char *szEntry
    , char *szValue, char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
char  szTarget [MAXPATH];

strcpy(szTarget, szSource);
SetFileExtension(szTarget, ".pre");

/* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;

char  *szLine = NULL ; // Important for error checking in StatFile.
FILE  *pflSource = NULL, *pflTarget = NULL ;

if ( access(szSource, 06) ) // Source file does not exist
                              {
                              pflSource =  fopen(szSource, "wt");
                              if ( !pflSource ) 
                                return FAILURE ;
                              fprintf(pflSource, "[%s]\n%s=%s\n", szSection
                                , szEntry, szValue);
                              
                              //  ^^^^^^^
                              fclose(pflSource);
                              return SUCCESS ;
                              }

unsigned int  wNbMaxCharPerLine = 1024 ; //(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return FAILURE ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  return FAILURE ;
  }
pflTarget =  fopen(szTarget, "wt"); // File is lost if already exist.
if ( !pflTarget ) 
  {
  free(szLine);
  fclose(pflSource);
  return FAILURE ;
  }

int fFound = FALSE ;

  {
  char  *pcEOFMarker = NULL ;
  while ( fgetlaline(pflSource, wNbMaxCharPerLine, szLine) ) 
    if ( IsSection(szLine, szSection) ) 
      {
      
      //                        ^^^^^^^^^^
      // Go find the entry
      fprintf(pflTarget, "%s\n", szLine);
      while ( (pcEOFMarker
                    = fgetlaline(pflSource, wNbMaxCharPerLine, szLine))
                  != NULL
                && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
        
        // Stops if it meets a section that is not the seeked section.
        // ^^^^^^^^^
        if ( IsEntry(szLine, szEntry) ) 
          {
          
          //   ^^^^^^^
          if ( !fFound ) 
            {
            
            // do not give the entry twice if it is found twice
            fFound =  TRUE ;
            fprintf(pflTarget, "%s=%s\n", szEntry, szValue); // ^^^^^^^
            }
          }
        else if ( !IsSection(szLine) ) 
          
          // do not requote if it is the title of the section that was duplicated.
          fprintf(pflTarget, "%s\n", szLine);
      
      // Is stoped because end of file or new section
      if ( !fFound ) 
        {
        
        // Has not been seen
        fFound =  TRUE ;
        fprintf(pflTarget, "%s=%s\n", szEntry, szValue); //        ^^^^^^^
        }
      if ( pcEOFMarker ) 
        fprintf(pflTarget, "%s\n", szLine); //                       ^^^^^^^
      }
    else 
      fprintf(pflTarget, "%s\n", szLine);
  //      ^^^^^^^^
  }
if ( !fFound ) 
  
  // Has not been seen, nor its section
  fprintf(pflTarget, "[%s]\n%s=%s\n", szSection, szEntry, szValue);

//  ^^^^^^^^                          ^^^^^^^^^^^^^^^^^
fclose(pflTarget);
fclose(pflSource);
free(szLine);
unlink(szSource);
return !rename(szTarget, szSource);
}

// Sent all the profiles in the stream
void  Hook2edStreamFlush (TListImp<TProfileSection> *plsProfile
  , FILE *pflTarget) ;

// Sent all the profile of the given section in the stream
void  Hook2edStreamFlush (TProfileSection *plsszEntries, FILE *pflTarget) ;

int Hook2PrivateString ( char *szSection, char *szEntry, char *szValue
    , THook2er *pHook2 )
{
T2Strings sszEnt((char *)malloc(strlen(szEntry) + 1)
  , (char *)malloc(strlen(szValue) + 1));

strcpy(sszEnt.sz1, szEntry);
strcpy(sszEnt.sz2, szValue);

char  *szBuff = (char *)malloc(strlen(szSection) + 3);

sprintf(szBuff, "[%s]", szSection);

TProfileSection sProfSec
  = FindMatchingSection(szBuff, &(pHook2 -> lsProfiles)); // Find and remove

//  TProfileSection sProfSec;
if ( !sProfSec.szSection ) 
  {
  
  //    sProfSec.szSection=NULL;
  SetString(&(sProfSec.szSection), szSection);
  sProfSec.plsszEntries =  new TListImp<T2Strings> ; //    psProfSec=& sProfSec;
                                                    //    psProfSec->szSection=NULL;
                                                    //    SetString(&psProfSec->szSection,szSection);
  }
sProfSec.plsszEntries -> Add(sszEnt);
pHook2 -> lsProfiles.Add(sProfSec);
return SUCCESS ;
}

int IsHook2ed ( char *szFile )
{
return !!FindHook2er(szFile);
}

THook2er::~THook2er ()
{
free(szFileName);
if ( !lsProfiles.IsEmpty() ) 
  MErreur("Loss of profiles in unhooking", 477); //  delete plsszProfiles;
}

THook2er::THook2er ( char *szFile )
{

//  plsszProfiles=new TListImp<T3Strings>;
szFileName =  (char *)malloc(strlen(szFile) + 1);
strcpy(szFileName, szFile);
}

void IterFindHook2er ( THook2er *&psHook2er, void *pArgs )
{
void  **apArg = (void **)pArgs ;

if ( !strcmpi((char *)apArg [0], psHook2er -> szFileName) ) 
  *((THook2er **)apArg [1]) =  psHook2er ;
}

THook2er *FindHook2er ( char *szFile )
{
THook2er  *pHook2er = NULL ;
void      *apArg [2] = {(void *)szFile, (void *)&pHook2er };

lpsPublicHook2s.ForEach(IterFindHook2er, (void *)apArg);
return pHook2er ;
}

int Hook2 ( char *szFile )
{
THook2er  *pHook2er = FindHook2er(szFile);

if ( !pHook2er ) 
  {
  THook2er  *pHook2er = new THook2er(szFile);
  lpsPublicHook2s.Add(pHook2er);
  return SUCCES ;
  }
else 
  return Erreur("File is already hooked :", szFile, 450);
//    return !!strNcpy(Hook2edFile,szFile,sizeof(Hook2edFile));
}

int UnHook2 ( char *szFile )
{
THook2er  *pHook2er = FindHook2er(szFile);

if ( !pHook2er ) 
  return Erreur("File is not hooked :", szFile, 458);
else 
  {
  lpsPublicHook2s.Detach(pHook2er);
  if ( !pHook2er -> lsProfiles.IsEmpty() ) 
    Hook2edFileFlush(&(pHook2er -> lsProfiles), szFile);
  delete pHook2er ;
  return SUCCES ;
  }
}

// Give (and remove) the first {entry,value} that matches the section
int EntryMatches ( char *szLine, TProfileSection *plsProfile, char *szEntry
    , char *szValue ) // Tells if the line matches one of the given profile and says which entry.
{
int       f = FAILURE ;
T2Strings sszEntVal ;
char      *szEqualSign = strchr(szLine, '=');

if ( !szEqualSign ) 
  return FALSE ;

char  *szShortLine = AvaleEspace(szLine); // ShortLine points on the Entry label

*szEqualSign =  0 ;

//               szEqualSign +1  points after the 1st '=' ie on the value.
void  *apArg [3] = {(void *)szShortLine, (void *)&f, (void *)&sszEntVal };

/*  void *apArg[5]={(void *)szLine,(void *)szSection, (void *)szEntry,
   (void *)&sszProfile,(void *)&f};*/
plsProfile -> plsszEntries -> ForEach(IterEntryMatches, (void *)apArg);
*szEqualSign =  '=';
if ( f ) 
  {
  strNcpy(szValue, sszEntVal.sz2, STRLEN_OperatingProfile);
  strNcpy(szEntry, sszEntVal.sz1, STRLEN_OperatingProfile);
  sszEntVal.Free();
  plsProfile -> plsszEntries -> Detach(sszEntVal);
  }
return f ;
}
#endif

char *strchri ( char *sz, unsigned char u )
{
char  *szBuff = (char *)malloc(strlen(sz) + 1);

strcpy(szBuff, sz);
strupr(sz);

char  *pcRes = strchr(sz, toupper(u));

strcpy(sz, szBuff);
free(szBuff);
return pcRes ;
}

char *NextNotSpaceSeparator ( char *sz )
{
unsigned int  wSep, w = strlen(sz);
char          *szSep = sz ;

do 
  {
  wSep  =  strcspn(szSep, acUsualSeparators);
  szSep += wSep ;
  } 
while ( *szSep == ' ' && szSep - sz < w );
if ( szSep - sz >= w ) 
  return NULL ;
else 
  return szSep ;
}

char *ObsNextNotSpaceSeparator ( char *sz )
{
char  *szWrapperSeparator = (char *)malloc(strlen(acUsualSeparators) + 1);

strcpy(szWrapperSeparator, acUsualSeparators);

char  *pcSpaceSep = strchr(acUsualSeparators, ' ');
char  *pcRes ;

if ( pcSpaceSep ) 
  {
  unsigned int  wNoSpaceSep = strcspn(acUsualSeparators, " ");
  if ( wNoSpaceSep >= strlen(acUsualSeparators) ) 
    
    // Only space separators!!!
    pcRes =  NULL ;
  else 
    {
    *pcSpaceSep =  acUsualSeparators [wNoSpaceSep]; // Replace the space separator by any non space separator.
    if ( !strchr(acUsualSeparators, ' ') ) 
      
      // There is still spaces
      pcRes =  NextNotSpaceSeparator(sz);
    else 
      pcRes =  NextSeparator(sz);
    }
  }
else 
  pcRes =  NextSeparator(sz);
strcpy(acUsualSeparators, szWrapperSeparator);
free(szWrapperSeparator);
return pcRes ;
}

int SayYesOnProfileScan ( char * /* szSection */ 
    , char * /* szEntry */ , char * /* pcValue */ 
    , void * /* pArgs */ )
{
return TRUE ;
}

int ScanWindowProfileFile ( char *szFileName, void *pArgs
    , int(*funcProcessTheSection)(char *szSection, void *pArgs)
    , // Specify what to do once the section has been scanned
      int(*funcIsInterestingSection)(char *szSection, void *pArgs)
    , // Say if the section is to be processed
      int(*funcProcessTheEntry)(char *szSection, char *szEntry
        , char *szValue, void *pArgs)
    , // Specify what to do once one entry has been found
      char *szTitreRuban )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

FILE  *pfilSource = fopen(szSource, "rt");

if ( !pfilSource ) 
  return 0 ;

long  lFileLen = filelength(fileno(pfilSource));

if ( !lFileLen ) 
  return SUCCESS ;

char  szLine [STRLEN_OperatingProfile]
  , szNewSection [STRLEN_OperatingProfile]
  , szActiveSection [STRLEN_OperatingProfile];

//    szEntry[STRLEN_OperatingProfile],
//    szValue[STRLEN_OperatingProfile];
*szActiveSection =  0 ;
if ( szTitreRuban ) 
  ActiveRuban(szTitreRuban);

int fGoesOn = TRUE ;

while ( fgetlaline(pfilSource, sizeof(szLine), szLine) ) // Returns the string or NULL
                                                          {
  if ( IsAnySection(szLine, szNewSection
        , // Recieve the value of the section
          STRLEN_OperatingProfile) ) 
    {
    if ( szTitreRuban ) 
      AvanceRuban(ftell(pfilSource) / (float)lFileLen * 100);
    
    // We enter a new section, all the known facts of the previous section must be flushed
    if ( *szActiveSection ) 
      if ( !funcProcessTheSection(szActiveSection, pArgs) ) 
        {
        fGoesOn =  0 ;
        break ;
        }
    
    // Check if the new section is valid.
    if ( funcIsInterestingSection(szNewSection, pArgs) ) 
      strNcpy(szActiveSection, szNewSection, sizeof(szActiveSection));
    else 
      *szActiveSection =  0 ;
    }
  else // We are IN a section
       if ( *szActiveSection ) // We are IN an interesting section
                                {
                                char  *pcEqual = strchr(szLine, '=');
                                if ( pcEqual ) 
                                  {
                                  *pcEqual =  0 ;
                                  fGoesOn  
                                    =  funcProcessTheEntry(
                                      szActiveSection, AvaleEspace(szLine)
                                      , pcEqual + 1, pArgs);
                                  *pcEqual =  '=';
                                  if ( !fGoesOn ) 
                                    break ;
                                  }
                                }                         
                                                          }
if ( fGoesOn ) 
  if ( *szActiveSection ) 
    funcProcessTheSection(szActiveSection, pArgs);
if ( szTitreRuban ) 
  FermeRuban();
fclose(pfilSource);
return 1 ;
}

#if 0 // Obsolete
void Dos_ObsoleteGetPrivateString ( char *szSection, char *szEntry
    , char *szDefaultValue, char *szValue, unsigned int wLen
    , char *szFileName )
{
char  szSource [MAXPATH];

SetIniSourceFile(szSource, sizeof(szSource), szFileName);

// We know exactly what file to write.
//  unsigned long dwNbChar, dwNbLine,
//  unsigned long dwNbMaxCharPerLine;
char          *szLine = NULL ;
FILE          *pflSource = NULL ;
/*
   if (!StatFile(szSource,&dwNbChar,&dwNbLine,&dwNbMaxCharPerLine))
     return;
   unsigned int wNbMaxCharPerLine=(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);
   */
unsigned int  wNbMaxCharPerLine = 1024 ; //max(wLen+strlen(szEntry)+16,strlen(szSection)+16);

szLine =  (char *)malloc(wNbMaxCharPerLine);
if ( !szLine ) 
  return ;
pflSource =  fopen(szSource, "rt");
if ( !pflSource ) 
  {
  free(szLine);
  strNcpy(szValue, szDefaultValue, wLen);
  return ;
  }
  {
  int fFound = FALSE ;
  
  //    unsigned int wNbMaxCharPerLine=(unsigned int)(dwNbMaxCharPerLine>65535L?65535L:dwNbMaxCharPerLine);
  while ( fgetlaline(pflSource, wNbMaxCharPerLine, szLine) && !fFound ) 
    if ( IsSection(szLine, szSection) ) 
      {
      
      // Go find the entry
      while ( fgetlaline(pflSource, wNbMaxCharPerLine, szLine)
                && (!IsSection(szLine) || IsSection(szLine, szSection)) ) 
        
        // Stops if it meets a section that is not the seeked section.
        if ( IsEntry(szLine, szEntry, szValue, wLen) ) 
          {
          fFound =  TRUE ;
          break ;
          }
      }
  if ( !fFound ) 
    strNcpy(szValue, szDefaultValue, wLen);
  }
free(szLine);
fclose(pflSource);
}
#endif

/*
   Analyse the argument line in search for /xxx+ or /xxx- where xxx is the parameter szMarker.
     If the argument exist and is understandable, function return the value (nul for '-' and not nul for '+').
     Read argument is removed from the argument list if fKillRead is true.
     If the argument does not exist or is not understanadable, return the default value.
     Not case sensitive.
     Last argument is read the marker is found several times.
   */
int CatchCommandLineFlagSign ( int iUserArguments, char **aszUserArguments
    , char *szMarker, int fDef, int fKillRead )
{
char  *szWord_p = (char *)malloc(strlen(szMarker) + 3)
  , *szWord_m = (char *)malloc(strlen(szMarker) + 3);

sprintf(szWord_p, "/%s+", szMarker);
sprintf(szWord_m, "/%s-", szMarker);

int f = fDef ;

for ( int i = 0 ; i < iUserArguments ; i++ ) 
  if ( !strcmpi(aszUserArguments [i], szWord_p)
        || !strcmpi(aszUserArguments [i], szWord_m) ) 
    {
    f =  aszUserArguments [i][strlen(szMarker) + 1] == '+'; // Is true if options contain /rk+
    if ( fKillRead ) 
      aszUserArguments [i][0] =  0 ; // Kills the option once it has been read.
    //      break;
    }
free(szWord_m);
free(szWord_p);
return f ;
}

/*
   Analyse the argument line in search for /xxx=yyy where xxx is the parameter szMarker and yyy is the result string put in the szVal argument.
     If the argument exist and is understandable, function return the value (nul for '-' and not nul for '+') and argument is removed from the argument list.
     If the argument does not exist or is not understandable, return the default value.
     Read argument is removed from the argument list if fKillRead is true.
     Not case sensitive in xxx.
     Last argument is read the marker is found several times.
     It is possible to give the same pointer in szDef and szVal;
   */
char *CatchCommandLineString ( int iUserArguments, char **aszUserArguments
    , char *szMarker, char *szDef, char *szVal, unsigned int wLen
    , int fKillRead )
{
unsigned int  wMrkLen = strlen(szMarker);
char          *szWord_e = (char *)malloc(wMrkLen + 3);

sprintf(szWord_e, "/%s=", szMarker);
if ( szVal != szDef ) 
  strNcpy(szVal, szDef, wLen);
for ( int i = 0 ; i < iUserArguments ; i++ ) 
  if ( !strncmpi(aszUserArguments [i], szWord_e, wMrkLen + 2) ) 
    {
    strNcpy(szVal, strchr(aszUserArguments [i], '=') + 1, wLen); // Copy everything which follows '='
    if ( fKillRead ) 
      aszUserArguments [i][0] =  0 ; // Kills the option once it has been read.
    //      break;
    }
free(szWord_e);
return szVal ;
}

unsigned int CatchCommandLineIntList ( int iUserArguments
    , char **aszUserArguments, char *szMarker, int *aiDef
    , unsigned int wDefLen, int *aiValues, unsigned int wLen, int fKillRead )
{
unsigned int  wV = wLen * SizeOfOutput(*aiValues)
  , wD = wDefLen * SizeOfOutput(*aiDef);
char          *szBuffV = (char *)malloc(wV), *szBuffD = (char *)malloc(wD);

;
if ( !szBuffV || !szBuffD ) 
  return 0 ;

char  szOneIntBuffer [8 + 1];

*szBuffD        =  0 ;
*szOneIntBuffer =  0 ;
for ( unsigned int w = 0 ; w < wDefLen ; w++ ) 
  {
  sprintf(szOneIntBuffer, "%d,", aiDef [w]);
  strNcat(szBuffD, szOneIntBuffer, wD);
  }
CatchCommandLineString(iUserArguments, aszUserArguments, szMarker, szBuffD
  , szBuffV, wV, fKillRead);

unsigned int  wRead = GetIntegerList(szBuffV, aiValues, wLen);

free(szBuffV);
free(szBuffD);
return wRead ;
}
