#include "myowlall.h"
#include "baptiall.h"

#pragma hdrstop

#define MODULE_NAME "SYMBOLE"
 /*******************|******************************************
                       W S Y M B O L E . C                        
    -------------------------------------------------------------
        Fonction       : Fonction de traitement symbolique pour  
                         symboles pour Iris       	       
                                                                 
     Fichier source wsymbole.C.                                  
      (contient les objets internes                               
      et les corps des objets  exporter)                        
    -------------------------------------------------------------
        Auteur         : Baptise MARCEL                          
        Dvelopp le   : printemps 1996                          
    **************************************************************/ 

// Inclusions bibliothques standards
/*
   #include <io.h>
   #include <math.h>
   #include <stdlib.h>
   #include <string.h>
   #include <values.h>
   
   // Inclusions bibliothques Object Windows
   //#include <owl\dc.h>
   #include <owl\framewin.h>
   #include <owl\point.h>
   
   // Inclusions bibliothques DOS
   #include <stdio.h>
   */
// Inclusion bibliothques Image
//  Inclusions bibliothques Iris
#include "base.h"
#include "filutil.h"
#include "scaltool.h"
#include "strutil.h"
#include "strtool.h"
#include "symbole.h"
#include "sysctr.h"
#include "wgeometr.h"

//#include "wsystool.h"
/*-------------------------------------------------------------
   		       constantes locales                      
   -------------------------------------------------------------
   
      #define LONG_LGN_ECR 80
      */
#define LONG_LGN_IMP 78
 // #define haut_col_ecr 60

/*-------------------------------------------------------------
   	              variables  exporter                     
   -------------------------------------------------------------*/
char         szSymbolDir [MAXDIR] = "";
char         szSymbolDrive [MAXDRIVE] = "";
/*-------------------------------------------------------------
   		      nouveaux types locaux                    
   -------------------------------------------------------------*/
enum REF_LEC { STD, MAT, NUM, TXT, ERRR };
/*-------------------------------------------------------------
   		       variables locales                       
   -------------------------------------------------------------
   -------------------------------------------------------------
                 prototypes des fonctions locales               
   -------------------------------------------------------------*/
enum REF_LEC  PrendRefLec (char *ligne) ;
enum REF_LEC  ReconnRefLec (char *ligne) ;
/*
   void AffContenuTxt_oct (char *catalogos, int n_oct, int lgn);
   char Compar(data_matrix smb1, data_matrix smb2, unsigned long *Pdelta_int, unsigned long *Pdelta_ext); */
BOOL         ChargeSymboleNouveauFormat (char *szFileName, TDataMatrix *smb) ;
BOOL         ChargeSymboleAncienFormat (TDataMatrix *pSmb
  , char *szFileName, char fSymboleUnique) ;
int          DecodeSampleSymbolName (char *szImageName, char *szSymbolName
  , char *szFoundPath = NULL) ;

/*-------------------------------------------------------------
   	              fonctions  exporter
   -------------------------------------------------------------*/
TMatrix::TMatrix ( unsigned int w ) // f=0 par dfaut
{
if ( w ) 
  puData =  (unsigned char *)malloc(w * w);
else 
  puData =  NULL ;
if ( puData ) 
  wSize =  w ;
else 
  wSize =  0 ;
}

void TMatrix::Set ( unsigned int f )
{
if ( wSize && !puData ) 
  {
  MErreur("Erreur de cohrence", 86);
  wSize  =  0 ;
  puData =  NULL ;
  }
if ( wSize != f ) // Seul cas o l'on doive intervenir.
                    {
                    wSize =  f ;
                    if ( puData != NULL ) 
                      free(puData);
                    if ( !f ) 
                      puData =  NULL ;
                    else 
                      {
                      puData =  (unsigned char *)malloc(f * f);
                      if ( !puData ) 
                        {
                        MErreur("Erreur d'allocation", 95);
                        wSize =  0 ;
                        }
                      }
                    }
}

TMatrix::~TMatrix ()
{
if ( wSize && !puData ) 
  MErreur("Erreur de cohrence", 119);
else if ( puData ) 
  free(puData);
}

void TMatrix::Copie ( TMatrix *pSmb )
{
if ( wSize != pSmb -> wSize ) 
  Set(pSmb -> wSize);

unsigned int  w ;

for ( w = 0 ; w < wSize * wSize ; w++ ) 
  puData [w] =  pSmb -> puData [w];
}

BOOL TDataMatrix::PivoteHorlogeRail ()
{
unsigned int  wPoidHaut = 0, wPoidBas = 0, wPoidDroite = 0, wPoidGauche = 0
  , i ;

for ( i = 0 ; i < wSize ; i++ ) 
  {
  wPoidGauche += puData [wSize * i]; // Rail vertical.
  wPoidBas    += puData [i + (wSize - 1) * wSize]; // Rail horizontal
  wPoidHaut   += puData [i]; // Horloge horizontale: i=0 (rail) fait 1 (noir) et ainsi de suite.
  wPoidDroite += puData [(wSize - 1) + i * wSize]; // Horloge verticale
  }

unsigned int  wPoidHG = wPoidHaut + wPoidGauche
  , wPoidHD = wPoidHaut + wPoidDroite, wPoidBG = wPoidBas + wPoidGauche
  , wPoidBD = wPoidBas + wPoidDroite
  , wPoidMax = max(max(wPoidHG, wPoidHD), max(wPoidBG, wPoidBD));

// Les sens de rotation sont par raport  un repre orthogonal direct li  la
// matrice, indpendant du repre de l'image.
if ( wPoidMax == wPoidBG ) 
  return SUCCES ;
else if ( wPoidMax == wPoidBD ) 
  return Rotation90deg( - 1);
else if ( wPoidMax == wPoidHD ) 
  return Rotation90deg(2);
else if ( wPoidMax == wPoidHG ) 
  return Rotation90deg(1);
else 
  return MErreur("Erreur Code", 154);
}

BOOL TMatrix::Rotation90deg ( char cRotat )
{
if ( !cRotat % 4 // Rotation de 0.
    || !wSize ) 
  return SUCCES ;

TDataMatrix dmSymb2 (wSize) ;

if ( !dmSymb2.wSize ) 
  return MErreur("Erreur d'allocation", 166);
if ( !RotationMatriceMod90(puData, dmSymb2.puData, wSize, (int)cRotat) ) 
  return MErreur("Erreur  la rotation", 169);

unsigned char *puSwap = puData ;

puData         =  dmSymb2.puData ;
dmSymb2.puData =  puSwap ; // Echange des matrices avant fin.

// Lors de la fin de cette procdure, la matrice de dmSymb2 sera
// automatiquement libre.
return SUCCES ;
}

BOOL TMatrix::Transpositon ()
{
if ( !wSize ) 
  return SUCCES ;

TDataMatrix dmSymb2 (wSize) ;

if ( !dmSymb2.wSize ) 
  return MErreur("Erreur d'allocation", 166);
if ( !Transposition_MAT(puData, dmSymb2.puData, wSize, wSize) ) 
  return MErreur("Erreur  la transposition", 169);

unsigned char *puSwap = puData ;

puData         =  dmSymb2.puData ;
dmSymb2.puData =  puSwap ; // Echange des matrices avant fin.

// Lors de la fin de cette procdure, la matrice de dmSymb2 sera
// automatiquement libre.
return SUCCES ;
}

/* Fonctions du menu Accs systme */
/* SortieFichier (Sortie vers un fichier)
   Sort dans un fichier le symbole dsign sous ses trois formes.
   n_oct : 	nombre d'octets,
   arithmos :    caractre courant,
   catalogos :	liste des octets,
   Psmb :	pointeur sur symbole  sortir,
   */
BOOL SauvegardeSymbole ( TDataMatrix *pSmb, char *szFileName )
{
FILE  *pExetasis ; /* pointeur sur le fichier de sortie */ 

if ( !pSmb || !IsFileExtension(szFileName, ".smb") ) 
  return ECHEC ;
pExetasis =  fopen(szFileName, "wt");
if ( !pExetasis ) 
  return ECHEC ;
fclose(pExetasis); // Vidange du fichier.
WritePrivateInt("configuration", "nombre de symboles", 1, szFileName);
WritePrivateInt("configuration", "taille", pSmb -> GetSize(), szFileName);
WritePrivateString("configuration", "type", "STD", szFileName);
pExetasis =  fopen(szFileName, "at");
fprintf(pExetasis
  , "--------------------------------------------------------------------------------\n");
fprintf(pExetasis, "-- Forme matricielle.\n");
fprintf(pExetasis, "MAT\n\n");

unsigned int  wi, wj, wS = pSmb -> GetSize();

for ( wi = 0 ; wi < wS ; wi++ ) 
  {
  for ( wj = 0 ; wj < wS ; wj++ ) 
    fprintf(pExetasis, "%c", pSmb -> GetCell(wi, wj) ? 'X' : ' ');
  fprintf(pExetasis, "\n");
  }

unsigned int  wNbOct = NbOctetsPourTelleFrequence(wS);
char          far *acTamponTexte = (char *)malloc(wNbOct + 1);
char          far *szTamponNumerique = (char *)malloc(4 * wNbOct + 1);
char          far *acTamponWrappedText = (char *)malloc(wNbOct + 15 + 1);
char          far *acTamponWrappedNumerList = (char *)malloc(4 * wNbOct + 15 + 1);
BOOL          fRes = SUCCES ;

do 
  {
  if ( !(fRes = Octavisation(pSmb, acTamponTexte, wNbOct)) ) 
    break ;
  
  /* Fabrique la liste des valeurs.*/
  if ( !(fRes
        = NumeraliseListeOctets(szTamponNumerique, acTamponTexte, wNbOct)) ) 
    break ;
  
  /* Fabrique le texte imprimmable.TextualiseListeOctets doit se faire apres car il modifie les caractres pour
     les rendre imprimmables.*/
  if ( !(fRes
        = TextualiseListeOctets(acTamponTexte
          , NbROctetsPourTelleFrequence(pSmb -> GetSize()))) ) 
    break ;
  unsigned int  wNumberOfCharPerLine = LONG_LGN_IMP ;
  if ( !(fRes
        = WrappText(acTamponTexte, wNbOct, acTamponWrappedText
          , wNbOct + 15, wNumberOfCharPerLine
          , IsIntelligentText(acTamponTexte) ? 
               CONTINUOUS_WRAPPING
            : SEPARATOR_WRAPPING)) ) 
    break ;
  if ( !(fRes
        = WrappText(szTamponNumerique, 4 * wNbOct
          , acTamponWrappedNumerList, 4 * wNbOct + 15, wNumberOfCharPerLine
          , SEPARATOR_WRAPPING)) ) 
    break ;
  } 
while ( FAUX );
if ( fRes ) 
  {
  fprintf(pExetasis, "\n-- Forme numrique.\n");
  fprintf(pExetasis, "NUM\n");
  fprintf(pExetasis, "%s", acTamponWrappedNumerList);
  fprintf(pExetasis, "\n-- Forme textuelle.\n");
  fprintf(pExetasis, "TXT\n");
  fprintf(pExetasis, "%s", acTamponWrappedText);
  }
free(acTamponWrappedNumerList);
free(acTamponWrappedText);
free(szTamponNumerique);
free(acTamponTexte);
fclose(pExetasis);
return fRes ;
}

/* ChargeSymbole (Chargement d'un symbole)
                               Lit dans un fichier un symbole unique selon le format dfinit
                             dans la cahier de code. Seul le premier symbole du fichier est lu.
                               En cas d'erreur terminale, un symbole vide est renvoy.
                               La matrice du symbole est allou par la procdure elle mme.
   
                               n_oct : 	nombre d'octets,
                               arithmos :    caractre courant,
                               catalogos :	liste des octets,
                               mat :		matrice rsulat.
                               Psmb :	pointeur sur symbole rsultant,
                               pmat		pointeur sur matrice rsultante (sans le cadre).
   
   FORMAT :
                               Le nombre de caractres par lignes est limit  LONG_LGN_IMP pour l'en-tte.
                               Le format est similaire  un format de fichier .INI.
                               [configuration]
                               nombre de symboles= ...
                               taille= ...   (-1 pour frquence adaptative)
                               type= ... (STD, MAT, TXT ou NUM)
                               puis le type en majuscule seul sur une ligne, puis une ligne vide, puis le contenu.
                             */
BOOL ChargeSymbole ( char *szFileName, TDataMatrix *smb )
{
if ( !ChargeSymboleNouveauFormat(szFileName, smb) ) 
  return ChargeSymboleAncienFormat(smb, szFileName, VRAI);
else 
  return SUCCES ;
}

BOOL ChargeSymboleNouveauFormat ( char *szFileName, TDataMatrix *smb )
{
FILE          *Pexetasis = NULL ;
char          szType [USUALMAXLENSTRING];
unsigned char *catalogos = NULL ;
int           nombre_SMB = 0, n_oct = 0, n = 0, i = 0, j = 0, arithmos = 0
  , longueur_ligne = 0 ;
enum REF_LEC   ref = ERRR, anaphero = ERRR ;
unsigned char *Psmb = NULL ;

/* pointeur sur le fichier de chargement */
char          *stichos = NULL, *rema = NULL ;

/* ligne courante, ligne aux espaces compacts et mot intermdiaire */
if ( access(szFileName, 04) ) 
  return ECHEC ;

/* Acquisition du nombre de symboles. */
longueur_ligne =  LONG_LGN_IMP ; /* Limite de la taille des lignes de la zone
                                    prliminaire. */ 

/* Acquisition du nombre de symboles. */
nombre_SMB     
  =  GetPrivateInt("configuration", "nombre de symboles", 1
    , szFileName);
if ( !nombre_SMB ) 
  nombre_SMB =  1 ;
if ( nombre_SMB != 1 ) 
  return ECHEC ;
n =  GetPrivateInt("configuration", "taille", 0, szFileName);
if ( !n || n < - 1 ) 
  return ECHEC ;
GetPrivateString("configuration", "type", "STD", szType, sizeof(szType)
  , szFileName);
ref =  ReconnRefLec(strupr(szType));
if ( ref == ERRR || (Pexetasis = fopen(szFileName, "rt")) == NULL ) 
  return ECHEC ;

// Ouverture Pexetasis
if ( n == - 1 ) /* Taille adaptative */ 
                  {
                  if ( ref != TXT ) 
                    {
                    fclose(Pexetasis);
                    return ECHEC ;
                    }
                  
                  /* Taille adaptative en texte. */
                  anaphero =  ERRR ;
                  
                  /* Entre : stichos est libre. */
                  stichos  =  (char *)malloc(longueur_ligne + 2);
                  
                  // Allocation stichos;
                  while ( anaphero != TXT ) 
                    {
                    fgetlaline(Pexetasis, longueur_ligne, stichos);
                    anaphero =  ReconnRefLec(stichos);
                    }
                  
                  /* Texte localis et point */
                  fgetlaline(Pexetasis, longueur_ligne, stichos);
                  
                  /* Acquisition du '\n' restant. */
                  n_oct =  fcontchar(Pexetasis);
                  if ( n_oct < 0 ) 
                    {
                    fclose(Pexetasis);
                    free(stichos);
                    return ECHEC ;
                    }
                  
                  //    n=2+NCeilR(sqrt(n_oct*8));
                  n =  FrequencePourTantDOctets(n_oct);
                  if ( (n + 1) % 2 ) 
                    
                    /* Si n+1 impair (n pair)... */
                    n++ ; /* ...n est incrment. */ 
                  fseek(Pexetasis, 0, 0);
                  anaphero =  ERRR ;
                  while ( anaphero != TXT ) 
                    {
                    fgetlaline(Pexetasis, longueur_ligne, stichos);
                    anaphero =  ReconnRefLec(stichos);
                    }
                  
                  /* Le fichier est repositionn sur la dclaration de la rfrence. */
                  free(stichos); // stichos libr
                  } /*  else if ((n+1)%2) // (n+1)%2 vaut 1 (VRAI) si taille est pair
                       {
                       fclose(Pexetasis);
                       return ECHEC;
                       } */ 
else if ( n == 1 ) 
  {
  fclose(Pexetasis);
  return ECHEC ;
  }
else 
  {
  if ( ref == STD ) 
    ref =  MAT ;
  
  /* Recherche de la bonne rfrence. */
  anaphero =  ERRR ;
  stichos  =  (char *)malloc(longueur_ligne + 2);
  
  // stichos allou
  while ( anaphero != ref ) 
    {
    fgetlaline(Pexetasis, longueur_ligne, stichos);
    anaphero =  ReconnRefLec(stichos);
    }
  free(stichos); // stichos libr
                /* Rfrence atteinte */ 
  }
if ( ref == MAT ) 
  {
  smb -> Set(n);
  
  // Symbole allou  n*n.
  Psmb =  smb -> GetData();
  if ( Psmb == NULL ) 
    {
    fclose(Pexetasis);
    smb -> Set();
    return ECHEC ;
    }
  longueur_ligne =  n ;
  stichos        =  fgetlline(Pexetasis, longueur_ligne);
  
  // stichos allou
  if ( stichos != NULL ) 
    free(stichos);
  
  // stichos libr
  stichos =  fgetlline(Pexetasis, longueur_ligne);
  
  // stichos allou
  /* On saute une ligne avant de lire les valeurs. */
  if ( stichos == NULL ) 
    {
    fclose(Pexetasis);
    smb -> Set();
    return ECHEC ;
    }
  for ( i = 0 ; i < n ; i++ ) 
    {
    for ( j = 0 ; j < n ; j++ ) 
      if ( (stichos [j] == ' ') || (stichos [j] == '0') ) 
        Psmb [i * n + j] =  SMB_CELL_Unmarked ;
      else if ( (stichos [j] == 'X') || (stichos [j] == '1') ) 
        Psmb [i * n + j] =  SMB_CELL_Marked ;
      else if ( stichos [j] == '\0' ) 
        
        /* Fin de ligne avant la fin dernire colonne, il faut complter
           avec des 0. */
        for (; j < n ; j++ ) 
          Psmb [i * n + j] =  SMB_CELL_Unmarked ;
      else 
        Psmb [i * n + j] =  SMB_CELL_Unknown ;
    
    /* Prendre la ligne suivante. */
    free(stichos);
    stichos =  fgetlline(Pexetasis, longueur_ligne);
    if ( stichos == NULL ) 
      {
      fclose(Pexetasis);
      smb -> Set();
      return ECHEC ;
      }
    }
  
  /* Lecture du symbole matriciel termine */
  fclose(Pexetasis);
  free(stichos);
  return SUCCES ;
  }
else if ( ref == NUM ) 
  {
  
  //    n_oct=(n-2)*(n-2)/8+1;
  n_oct     =  NbOctetsPourTelleFrequence(n);
  catalogos =  (unsigned char *)malloc(n_oct * sizeof(char));
  
  // catalogos allou
  if ( catalogos == NULL ) 
    {
    fclose(Pexetasis);
    smb -> Set();
    return ECHEC ;
    }
  rema =  (char *)malloc(n_oct * sizeof(char));
  
  // rema allou
  if ( rema == NULL ) 
    {
    fclose(Pexetasis);
    smb -> Set();
    free(catalogos);
    return ECHEC ;
    }
  for ( i = 0 ; i < n_oct ; i++ ) 
    {
    j =  fscanf(Pexetasis, "%s", rema);
    if ( j == EOF ) 
      {
      //	MErreur("Erreur au chargement : liste numrique incomplte (complte avec 0).");
      for (; i < n_oct ; i++ ) 
        catalogos [i] =  0 ;
      }
    else if ( j == 0 ) 
      {
      fclose(Pexetasis);
      free(rema);
      free(catalogos);
      smb -> Set();
      return ECHEC ;
      }
    else if ( j == 1 ) 
      {
      arithmos      =  atoi(rema); /* (manuel p33)
                                      if (arithmos < 0)
                                                                	  MErreur("Erreur au chargement : valeur ngative repre (lecture poursuivie).");
                                                                	else if (arithmos >= 256)
                                                                	  MErreur("Erreur au chargement : valeur suprieure  255 repre (lecture poursuivie).");
                                                                */ 
      catalogos [i] =  (unsigned char)arithmos ;
      }
    else 
      {
      fclose(Pexetasis);
      free(rema);
      free(catalogos);
      smb -> Set();
      return ECHEC ;
      }
    }
  free(rema);
  free(catalogos);
  
  // rema et catalogos libres.
  smb -> Binarisation(catalogos, n);
  smb -> Encadrement();
  fclose(Pexetasis);
  return SUCCES ;
  }
else 

/* ref=TXT */
  {
  n_oct     =  NbOctetsPourTelleFrequence(n);
  catalogos =  (unsigned char *)fgetltext(Pexetasis, n_oct);
  
  // catalogos allou.
  j         =  strlen((char *)catalogos);
  
  /* "catalogos" est une chane de caractres d'au plus "n_oct" octets
     avec '\0' en fin de chane. */
  if ( j < n_oct ) 
    {
    
    //      Erreur("Rapport de chargement : texte incomplet (complt avec ' ').",LEGER);
    rema      =  (char *)catalogos ;
    
    // rema recoit catalmogos (allou)
    catalogos =  (unsigned char *)malloc((n_oct + 1) * sizeof(char));
    
    // catalogos allou
    if ( catalogos == NULL ) 
      {
      fclose(Pexetasis);
      smb -> Set();
      return ECHEC ;
      }
    for ( i = 0 ; i < j ; i++ ) 
      catalogos [i] =  *rema++ ;
    for (; i < n_oct - 1 ; i++ ) 
      catalogos [i] =  ' ';
    catalogos [n_oct - 1] =  0 ; /* "catalogos" n'a plus  tre considre comme
                                    une chane mais une suite de "n_oct" octets
                                    dont le dernier vaut 0 ou 1. */ 
    free(rema); // rema libr
    }
  smb -> Binarisation(catalogos, n);
  free(catalogos);
  
  // catalogos libre.
  smb -> Encadrement();
  fclose(Pexetasis);
  return SUCCES ;
  }
}

/*TransfertVisu (Prepare Visualisation)
   Transforme un symbole en son image sous forme bitmap.
     La procdure reoit le symbole du data matrix et construit sous forme
   de damier l'image correspondante en ajustant la taille des cases de
   faon  ce que le damier occupe toute l'image.
     Paramtre V : selon que la visualisation est destine  l'impression ('I')
   ou  la visualiosation ('V');
   
     pimg  : pointeur sur l'image rsultat (tableau carr de taille 256,
   	    dja allou),
     Psmb  : pointeur sur le symbole source,
     n     : taille du symbole,
     N     : taille de l'image (N=256).
   */
BOOL TDataMatrix::TransfertVisu ( unsigned char *puCible )
{
unsigned int  l, i, j ;
float         r ;

if ( !wSize || !puData ) 
  return ECHEC ;
r =  (float)wSize / (float)SIZE_OF_PICTURES ;
for ( unsigned int k = 0 ; k < SIZE_OF_PICTURES ; k++ ) 
  for ( l = 0 ; l < SIZE_OF_PICTURES ; l++ ) 
    {
    i          =  NFloorR(k * r);
    j          =  NFloorR(l * r);
    *puCible++ 
      =  CouleurDePoint(puData [i * wSize + j], SMB_DISPLAY_PlanImage);
    }
return SUCCES ;
}

/* GeneSpont_MAT
     Gnration d'une matrice de manire alatoire quiprobable indpendante
   (AEI). Cette fonction reoit la taille de la matrice de donne, alloue
   la matrice de donne et la remplie.
     La matrice est alloue par la procdure elle-mme.
   
     mat   : data matrix rsultat,
     pmat  : pointeur sur la matrice de mat.
     n     : taille de la matrice.
   */
void TMatrix::GenerationSpontanee ( unsigned int f )
{
if ( !f ) 
  f =  wSize ;
else 
  Set(f);
randomize();
for ( f = 0 ; f < wSize * wSize ; f++ ) 
  puData [f] =  random(2) ? SMB_CELL_Marked : SMB_CELL_Unmarked ; /* 0 ou 1 font blanc ou noir. */ 
}

/* Encadrement
   Mise d'un cadre autour d'une matrice.
   
     La procdure prend la matrice du data matrix : taille + tableau
   de donnes carr de hauteur impaire et construit le symbole
   en rajoutant les deux rails et les crneaux.
     La matrice est alloue par la proc. elle-mme.
     mat   : data matrix de la matrice source;
     pmat  : pointeur sur la matrice mat;
     smb   : data matrix du symbole rsultat;
     Psmb  : pointeur sur le symbole rsultat;
     n             : taille de la matrice source;
     k             : taille du symbole (k=n+2).
   */
BOOL TDataMatrix::Encadrement ()
{
unsigned char *puMat ;
int           i = 0, j = 0, k = 0 ;

if ( !puData && wSize ) 
  return MErreur("Tentative d'encadrement d'une matrice nulle.", 1344);
k =  wSize + 2 ; // is 2 if matrix is NULL (empty).
if ( (puMat = (unsigned char *)malloc(k * k * sizeof(unsigned char)))
      == NULL ) 
  {
  Set();
  return MErreur("Erreur d'allocation", 1426);
  }
for ( i = 0 ; i < wSize ; i++ ) 
  for ( j = 0 ; j < wSize ; j++ ) 
    puMat [(j + 1) + (i + 1) * k] =  puData [j + i * wSize]; // No pass if  matrix is NULL (empty).
for ( i = 0 ; i < k ; i++ ) 
  {
  puMat [k * i]           =  SMB_CELL_Marked ; // 1e colonne
  puMat [i + (k - 1) * k] =  SMB_CELL_Marked ; // ligne bas
  puMat [i]               
    =  (i % 2) ? SMB_CELL_Unmarked : SMB_CELL_Marked ; //  (i+1)%2; /* Ligne haut. i=0 (rail) fait 1 (noir) et ainsi de suite. */
  puMat [(k - 1) + i * k] 
    =  ((i + k) % 2) ? SMB_CELL_Marked : SMB_CELL_Unmarked ; // Colonne droite. Astuce !
  }
if ( puData ) 
  free(puData);
wSize  =  k ;
puData =  puMat ;
return SUCCES ;
}

/*-------------------------------------------------------------
   CouleurDePoint
                               Renvoit le niveau de gris  afficher sur le moniteur correspondant
                              la valeur du bit d'un symbole.
                               Cas "vido" : V=VIDEO :
                              La fonction concerne l'cran et renvoit 32 (gris fonc) pour SMB_COUL_Noir (1),
                             255 pour SMB_COUL_Blanc (1).
                               cas "imprssion" : V=IMPRESSION ou ECRAN :
                              La fonction concerne l'cran et renvoit 0 pour SMB_COUL_Noir (1),
                             255 pour SMB_COUL_Blanc (1). */
unsigned char CouleurDePoint ( unsigned char u, unsigned char uType )
{
if ( uType != SMB_DISPLAY_PlanImage ) 
  {
  throw "Erreur code";
  ;
  }
else 
  return (u & SMB_CELL_Mark) ? 0 : 255 ;
}

/*-------------------------------------------------------------
   Octavisation
                                Renvoit la chane de caractres correspondant au regroupement en octets
                             des bits de la matrice (donc : sans le cadre). Bit SMB_COUL_Noir : 1. Le dernier
                             octet incomplet est complt avec 7 zros dans ses bits de poids fort.
                                Les caractres peuvent tre non imprimables, des caractres
                             internes peuvent tre nuls (donc '\0' n'est pas forcment le fin de la
                             chane.
                               La chane de caractres n'est PAS alloue par la proc. elle-mme.
                             */
BOOL Octavisation ( TDataMatrix *pSymbole, char *acListeOctets, long lNbOct )
{
unsigned char *puMat = pSymbole -> GetData();
int           i = 0, j = 0, k = 0, l = 0 ;
char          arithmos ; /* Octet courant. */ 

if ( !puMat || !acListeOctets ) 
  return MErreur("Tentative de lecture d'un symbole nul ou d'allocation"
    , 1271);

/* (n-2)/8 est forcment non entier car (n-2) est un multiple de 8
   plus 1. */
arithmos =  0 ;
k        =  0 ;
l        =  0 ;

unsigned int  wS = pSymbole -> GetSize();

for ( i = 0 ; i < wS ; i++ ) 
  for ( j = 0 ; j < wS ; j++ ) 
    if ( i && j && (i != wS - 1) && (j != wS - 1) ) /* Si le bit n'est pas du cadre... */ 
                                                      {
                                                      
                                                      // No pass if void symbol (2*2)
                                                      arithmos 
                                                        =  arithmos << 1 ;
  arithmos =  arithmos | (((*puMat++) & SMB_CELL_Mark) ? 1 : 0);
                                                      k++ ;
                                                      if ( k == 8 ) /* Si arithmos est rempli par un octet... */ 
                                                                      {
  
  /* ...alors on l'affiche. */
  k =  0 ;                                                            
  if ( l >= lNbOct ) 
    return Erreur(
      "Incohrence d'origine extra-terrestre (appellez Fox Mulder) pour l="
      , l, 1065);
  acListeOctets [l] =  arithmos ;                                     
                                                                      l++ ; /* Dcompte du nombre d'octets (premier octet : 0). */ 
  arithmos =  0 ;                                                     /* (ceci est ncessaire  cause du dernier octet incomplet) */ 
                                                                      }
                                                      }
    else 
      puMat++ ;

/* Nous sommes sorti du symbole, il reste peut-tre sept bits dans
   arithmos qui n'ont pas t affects mais qui sont nuls. */
if ( l > lNbOct ) 
  return Erreur(
    "Incohrence d'origine extra-terrestre (appellez Danna Scully) pour l="
    , l, 1077);
else if ( l < lNbOct ) 
  
  // Nothing if l==lNbOct (including 0==0)
  acListeOctets [l] =  arithmos ;

// Chane alloue  lNbOct+1.
//   acListeOctets[l]=0;
return SUCCES ;
}

BOOL TDataMatrix::MakeOutOfWrappedString ( char *sz )
{
char  *szTamp = (char *)malloc(strlen(sz) + 1);

strcpy(szTamp, sz);

BOOL  fRes = (Dewrappe(szTamp) && MakeOutOfString(szTamp));

free(szTamp);
return fRes ;
}

BOOL TDataMatrix::MakeOutOfString ( char *sz )
{
if ( !sz || !CutTrailingSpaces(sz) ) 
  return ECHEC ;

unsigned int  wF = FrequencePourTantDOctets(strlen(sz));  // return 2 for 0. All right.
unsigned int  wNbOct = NbOctetsPourTelleFrequence(wF);    // returns 0 for 2. All right.
unsigned char *acListeCar = (unsigned char *)malloc(wNbOct + 1);

strcpy((char *)acListeCar, sz); // Unable to copy last '\0' if strlen(sz)==wNbOct
for ( unsigned int w = strlen(sz) ; w < wNbOct ; w++ ) 
  acListeCar [w] =  ' '; // ' ' padding

BOOL  fRes ;

if ( !Binarisation(acListeCar, wF) || !Encadrement() ) 
  {
  fRes =  ECHEC ;
  Set();
  }
else 
  fRes =  SUCCES ;
free(acListeCar);
return fRes ;
}

/*-------------------------------------------------------------
   Binarisation
                                Renvoit la liste de bits (unsigned char) correspondant  la dcomposition
                             en binaire d'une liste d'octets (char).
                               La matrice est alloue par la proc. elle-mme.
                             
                               mat :		matrice cible,
                               n_oct :	nombre d'octets,
                               n :		taille du symbole final,
                               n_mat		taille de la matrice finale (n-2),
                               k :		nombre de bits  lire (8*n_oct),
                               k_mat :	nombre de bits de la matrice (n_mat=k_mat, k_mat = k-7),
                               pmat :	pointeur sur la matrice,
                               dromeus :	pointeur qui parcours pmat.
                               */
BOOL TDataMatrix::Binarisation ( unsigned char *acListeCaracteres
    , int iFreq )
{
int           iFreqMat = 0, d = 0, i = 0 ;
unsigned char masque = 0, arithmos, *dromeus ;

//  iNbOct=NbOctetsPourTelleFrequence(iFreq);
iFreqMat =  iFreq - 2 ;
if ( iFreqMat < 0 ) 
  return MErreur("Asked for a negative sized matrix", 1380); // The matrix is null
if ( wSize != iFreqMat ) 
  Set(iFreqMat);
if ( !iFreqMat ) 
  return SUCCES ; // Asked for a void matrix.
if ( puData == NULL ) 
  return MErreur("Erreur d'allocation", 1696);
dromeus =  puData ;
masque  =  128 ;

//  for(i=0; i<iNbOct-1; i++)
for ( i = 0 ; i < iFreqMat * iFreqMat ; ) 
  {
  arithmos =  *acListeCaracteres++ ;
  for ( d = 0 ; d < 8 && i < iFreqMat * iFreqMat ; d++ ) /* Pour tous les bits... */ 
                                                          {
  *dromeus++
    =  ((arithmos & masque) >> 7) ? SMB_CELL_Marked : SMB_CELL_Unmarked ; /* ...rcupration du premier bit... */ 
                                                          arithmos
                                                            =  arithmos
                                                              << 1 ; /* ...et dcalage. */ 
                                                          i++ ;
                                                          }
  }
return SUCCES ;
}

/*-------------------------------------------------------------
   PrendRefLec (Prend la rfrence de lecture)
                               Renvoit la forme de rfrence. Dans un fichier, le symbole est
                             code sous trois formes. La forme de rfrence est la forme qui est valide.
                             Les autres peuvent tre quelconques, voire non conforme  la syntaxe. */
enum REF_LEC PrendRefLec ( char *ligne )
{
if ( ligne == NULL ) 
  return ERRR ;
while ( *ligne != ':' ) 
  if ( *ligne == 0 ) 
    return ERRR ;
  else 
    ligne++ ;

/* ligne est avanc jusqu'au ':'. */
ligne++ ;
return ReconnRefLec(ligne);
}

/*-------------------------------------------------------------
   ReconnRefLec (Reconnat la rfrence de lecture)
                               Renvoit la rfrence de lecture d'une ligne.
                               La ligne a un certain nombre d'espaces puis la rfrence.
                               La rfrence peut tre suivie d'un espace et de texte. */
enum REF_LEC ReconnRefLec ( char *ligne )
{
char  c1, c2, c3, c4 ;

ligne =  CompactEspace(ligne);
if ( ligne == NULL ) 
  return ERRR ;
if ( strlen(ligne) < 3 ) 
  {
  free(ligne);
  return ERRR ;
  }
c1 =  ligne [0];
c2 =  ligne [1];
c3 =  ligne [2];
c4 =  ligne [3];
free(ligne);
if ( !IsSeparator(c4) ) 
  
  /* La rfrence doit tre suivie d'un
     sparateur ou d'une fin de ligne. */
  return ERRR ;
if ( (c1 == 'S') && (c2 == 'T') && (c3 == 'D') ) 
  return STD ;
else if ( (c1 == 'M') && (c2 == 'A') && (c3 == 'T') ) 
  return MAT ;
else if ( (c1 == 'N') && (c2 == 'U') && (c3 == 'M') ) 
  return NUM ;
else if ( (c1 == 'T') && (c2 == 'X') && (c3 == 'T') ) 
  return TXT ;
else 
  return ERRR ;
}

/* TextualiseListeOctets (Textualise Liste Octets)
     Fabrique une chaine de caractres imprimmables  partir d'une liste
   d'octets.
   
     L'ensemble des bits de la matrice
   est regroup en octets (ie en caractres).
   
   Le bit manquants au dernier octets est 0 ou 1 remplac par ' ' ou '_'.
   
     smb       : data matrix  diter,
     n         : taille de la matrice,
     n_oct     : nombre d'octets contenus dans la matrice;
     lgn 	    : n de la premire ligne (de 0  59)
   */
BOOL TextualiseListeOctets ( char *acListeOctets, float xNbOctets )
{
int           l = 0 ;
unsigned int  wNbOctets = NCeilR(xNbOctets);

if ( !acListeOctets ) 
  return MErreur("Tentative de viol d'un symbole nul.", 1436);
else 
  {
  
  /* Remplissage de l'espace textuel */
  if ( wNbOctets != NFloorR(xNbOctets) ) 
    
    /* si le dernier octet est non nul */
    acListeOctets [wNbOctets - 1] =  ' ';
  for ( l = 0 ; l < wNbOctets ; l++ ) 
    if ( !acListeOctets [l] ) 
      acListeOctets [l] =  ' ';
  return SUCCES ;
  }
}

/*-------------------------------------------------------------------------
   NumeraliseListeOctets (Numeralise Liste Octets)
                               Fabrique une chaine de caractres contenant l'ensemble des valeurs des
                             octets  partir d'un tableau d'octets.
                             
                             */
BOOL NumeraliseListeOctets ( char *szTexteNum, char *acListeOctets
    , unsigned int wNbOct )
{
unsigned int  l = 0 ;
char          szTamp0 [20];

//  char stoicheion;
//  unsigned char val_stoicheion;
if ( !acListeOctets || !szTexteNum ) 
  return MErreur("Tentative de viol d'un symbole nul.", 1767);
else 
  {
  *szTexteNum =  0 ;
  for ( l = 0 ; l < wNbOct ; l++ ) 
    strcat(
      strcat(szTexteNum
        , itoa((unsigned char)acListeOctets [l], szTamp0, 10))
      , " ");
  return SUCCES ;
  }
}

/*-------------------------------------------------------------------------*/
/* Acquier2Int (Prend la valeur)
                               Renvoit la donne situe aprs le premier ':' dans une chane de
                             caractre. Renvoit -1 en cas d'erreur.
   AcquierInt (Acquier int)
                               Lit la donnee situee aprs le premier ':' dans une chane de
                             caractre. Renvoit SUCCES ou ECHEC.
                               Le nombre doit tre suivie d'un sparateur ou d'une fin de ligne.
                               Conformment  d'anciennes spcifications, pValue est mis  -1 en cas
                             d'erreur.
                               Le pointeur "next" pointe aprs le sparateur ou sur NULL.
                               Format autoris :
                                 des caractres quelconques sauf ':', ":", des espaces, un signe "+" ou
                             "-", des chiffres, un sparateur (' ', '!', '.', ',', ':' ou ';') ou fin de
                             ligne, et la suite est quelconque.
                               Tout ce qui est aprs le ":" est trait par ExtractValue.
                             */
BOOL AcquierInt ( char *szLigne, int *pValue, char **pNext )
{
unsigned int  wNb = 0 ;

if ( szLigne == NULL ) 
  {
  *pValue =  - 1 ;
  *pNext  =  NULL ;
  return ECHEC ;
  }
while ( szLigne [wNb] != ':' ) 
  if ( szLigne [wNb] == 0 ) 
    {
    *pValue =  - 1 ;
    *pNext  =  szLigne ;
    return ECHEC ;
    }
  else 
    wNb++ ;

/* szLigne est avanc jusqu'au ':'.   */
return ExtractValue(szLigne + wNb + 1, pValue, pNext);
}

int Acquier2Int ( char *ligne ) // Ex PrendVal
{
char  *pcNext = NULL ;
int   iRes ;

if ( AcquierInt(ligne, &iRes, &pcNext) ) 
  return iRes ;
else 
  return - 1 ;
}

//#if 0
/* ChargeSymbole (Chargement d'un symbole)
     Lit dans un fichier un symbole unique selon le format dfinit
   dans la cahier de code. Seul le premier symbole du fichier est lu.
     En cas d'erreur terminale, un symbole vide est renvoy.
     Le symbole est allou par la procdure elle mme.
   
     n_oct : 	nombre d'octets,
     arithmos :    caractre courant,
     catalogos :	liste des octets,
     mat :		matrice rsulat.
     Psmb :	pointeur sur symbole rsultant,
     pmat		pointeur sur matrice rsultante (sans le cadre).
     */
BOOL ChargeSymboleAncienFormat ( TDataMatrix *pSmb, char *szFileName
    , char fSymboleUnique )
{

FILE          far *pExetasis ; /* pointeur sur le fichier de chargement */ 
char          far *stichos, *rema ;

/* ligne courante, ligne aux espaces compacts et mot intermdiaire */
int           nombre_SMB, n, i, j, longueur_ligne, iNbOct, arithmos ;
enum REF_LEC   ref, anaphero ;

//  TDataMatrix smb, *pmat;
//  unsigned char *Psmb;
unsigned char far *catalogos ;

if ( !pSmb ) 
  return ECHEC ;

//  else
//  pSmb->Set();
if ( (pExetasis = fopen(szFileName, "rt")) == NULL ) 
  return Erreur("Fichier de symbole non disponible: ", szFileName, 249);

/* Acquisition du nombre de symboles. */
longueur_ligne =  LONG_LGN_IMP ; /* Limite de la taille des lignes de la zone
                                    prliminaire. */ 
if ( !fSymboleUnique ) 
  {
  stichos    =  fgetslline(pExetasis, longueur_ligne);
  
  /* (ligne non commentaire) */
  nombre_SMB =  Acquier2Int(stichos);
  if ( stichos != NULL ) 
    free(stichos);
  if ( nombre_SMB <= 0 ) 
    {
    
    //      Erreur("Erreur au chargement lors de l'acquisition du nombre de symboles");
    MErreur("", 1963);
    fclose(pExetasis);
    return ECHEC ;
    }
  else if ( nombre_SMB > 1 ) 
    
    //      Erreur("Erreur au chargement : plusieurs symboles dtects");
    MErreur("", 1969); /* Erreur non terminale, le premier symbole sera lu. */ 
  }
nombre_SMB =  1 ;

/* Acquisition du symbole unique. 
   Acquisition du nombre de symboles. */
stichos    =  fgetslline(pExetasis, longueur_ligne);
n          =  Acquier2Int(stichos);
if ( stichos != NULL ) 
  free(stichos);
if ( n < 0 ) 
  {
  MErreur("Erreur au chargement : taille lue non positive.", 1982);
  fclose(pExetasis);
  return ECHEC ;
  }
else if ( n == 0 ) /* Taille adaptative */ 
                    {
                    stichos =  fgetslline(pExetasis, longueur_ligne);
                    ref     =  PrendRefLec(stichos);
                    if ( stichos != NULL ) 
                      free(stichos);
                    if ( ref == ERRR ) 
                      {
                      
                      //      Erreur("Erreur au chargement : la forme de rfrence du symbole n'est pas claire.");
                      fclose(pExetasis);
                      return MErreur("", 1995);
                      ;
                      }
                    else if ( ref != TXT ) 
                      {
                      
                      //      Erreur("Erreur au chargement : la taille adaptative n'est permise qu'en texte.");
                      fclose(pExetasis);
                      return MErreur("", 2001);
                      }
                    
                    /* Taille adaptative en texte. */
                    anaphero =  ERRR ;
                    
                    /* Entre : stichos est libre. */
                    stichos  =  (char *)malloc(longueur_ligne + 2);
                    while ( anaphero != TXT ) 
                      {
                      fgetlaline(pExetasis, longueur_ligne, stichos);
                      anaphero =  ReconnRefLec(stichos);
                      }
                    
                    /* Texte localis et point */
                    fgetlaline(pExetasis, longueur_ligne, stichos);
                    
                    /* Acquisition du '\n' restant. */
                    iNbOct =  fcontchar(pExetasis);
                    if ( iNbOct < 0 ) 
                      MErreur("Anomalie inconnue", 317);
                    n =  2 + NCeilR(sqrt(iNbOct * 8));
                    if ( (n + 1) % 2 ) 
                      
                      /* Si n+1 impair (n pair)... */
                      n++ ; /* ...n est incrment. */ 
                    fseek(pExetasis, 0, 0);
                    anaphero =  ERRR ;
                    while ( anaphero != TXT ) 
                      {
                      fgetlaline(pExetasis, longueur_ligne, stichos);
                      anaphero =  ReconnRefLec(stichos);
                      }
                    
                    /* Le fichier est repositionn sur la dclaration de la rfrence. */
                    free(stichos);
                    }
else if ( (n + 1) % 2 ) /* (n+1)%2 vaut 1 (VRAI) si taille est pair */ // stichos libre.
                          {
  MErreur("Erreur au chargement : la taille doit tre impaire.", 1997);
                          fclose(pExetasis);
                          return ECHEC ;
                          }
else if ( n == 1 ) 
  {
  fclose(pExetasis);
  return ChargeSymboleAncienFormat(pSmb, szFileName, FAUX);
  }
else 
  {
  stichos =  fgetslline(pExetasis, longueur_ligne);
  ref     =  PrendRefLec(stichos);
  if ( stichos != NULL ) 
    free(stichos); // stichos libre.
  if ( ref == ERRR ) 
    {
  Erreur(
    "Erreur au chargement : la forme de rfrence du symbole n'est pas claire.");
    fclose(pExetasis);
    return ECHEC ;
    }
  else if ( ref == STD ) 
    ref =  MAT ;
  
  /* Recherche de la bonne rfrence. */
  anaphero =  ERRR ;
  stichos  =  (char *)malloc(longueur_ligne + 2);
  while ( anaphero != ref ) 
    {
    fgetlaline(pExetasis, longueur_ligne, stichos);
    anaphero =  ReconnRefLec(stichos);
    }
  free(stichos); // stichos libre.
                /* Rfrence atteinte */ 
  }

//  pSmb->Set(n);
/*  Psmb=(unsigned char *)malloc(n*n*sizeof(unsigned char));
   if (Psmb==NULL) Erreur("Erreur d'allocation (ref. 789)",TERMINAL);
   smb.matrice=Psmb; */
if ( ref == MAT ) 
  {
  longueur_ligne =  n ;
  stichos        =  fgetlline(pExetasis, longueur_ligne);
  if ( stichos != NULL ) 
    free(stichos);
  stichos =  fgetlline(pExetasis, longueur_ligne);
  
  /* On saute une ligne avant de lire les valeurs. */
  if ( stichos == NULL ) // stichos allou
                          {
  
  //      pSmb->Set();
  Erreur("Erreur au chargement : matrice non prsente en lignes.");
                          fclose(pExetasis);
                          
                          //      free(Psmb);
                          return ECHEC ;
                          }
  pSmb -> Set(n);
  for ( i = 0 ; i < n ; i++ ) 
    {
    for ( j = 0 ; j < n ; j++ ) 
      if ( (stichos [j] == ' ') || (stichos [j] == '0') ) 
        pSmb -> SetCell(i, j, SMB_CELL_Unmarked);
      else if ( (stichos [j] == (char)219) || (stichos [j] == '1') ) 
        pSmb -> SetCell(i, j, SMB_CELL_Marked);
      else if ( stichos [j] == '\0' ) 
        
        /* Fin de ligne avant la fin dernire colonne, il faut complter
           avec des 0. */
        for (; j < n ; j++ ) 
          pSmb -> SetCell(i, j, SMB_CELL_Unmarked);
      else 
        {
        Erreur("Erreur au chargement : matrice non conforme.");
        free(stichos);
        fclose(pExetasis);
        pSmb -> Set();
        return ECHEC ;
        }
    
    /* Prendre la ligne suivante. */
    free(stichos);
    stichos =  fgetlline(pExetasis, longueur_ligne);
    if ( stichos == NULL ) 
      {
      Erreur("Erreur au chargement : matrice non complte en lignes.");
      fclose(pExetasis);
      pSmb -> Set();
      return ECHEC ;
      }
    }
  
  /* Lecture du symbole matriciel termine */
  fclose(pExetasis);
  free(stichos);
  
  //    pSmb->Copie(&smb);
  return SUCCES ;
  }
else if ( ref == NUM ) 
  {
  iNbOct    =  (n - 2) * (n - 2) / 8 + 1 ;
  catalogos =  (unsigned char *)malloc(iNbOct * sizeof(char));
  if ( catalogos == NULL ) 
    Erreur("Erreur d'allocation (ref. 841)");
  rema =  (char *)malloc(iNbOct * sizeof(char));
  if ( rema == NULL ) 
    Erreur("Erreur d'allocation (ref. 843)"); // catalogos et rema allous
  for ( i = 0 ; i < iNbOct ; i++ ) 
    {
    j =  fscanf(pExetasis, "%s", rema);
    if ( j == EOF ) 
      {
  Erreur(
    "Erreur au chargement : liste numrique incomplte (complte avec 0).");
      for (; i < iNbOct ; i++ ) 
        catalogos [i] =  0 ;
      }
    else if ( j == 0 ) 
      {
      Erreur("Erreur au chargement : liste numrique mal prsente.");
      fclose(pExetasis);
      free(rema);
      free(catalogos);
      
      //        pSmb->Set();
      return ECHEC ;
      }
    else if ( j == 1 ) 
      {
      arithmos =  atoi(rema); /* (manuel p33) */ 
      if ( arithmos < 0 ) 
  Erreur(
    "Erreur au chargement : valeur ngative repre (lecture poursuivie).");
      else if ( arithmos >= 256 ) 
  Erreur(
    "Erreur au chargement : valeur suprieure  255 repre (lecture poursuivie).");
      catalogos [i] =  (unsigned char)arithmos ;
      }
    else 
      {
      //	Erreur("Erreur au chargement : anomalie dans liste numrique.");
      MErreur("", 2163);
      fclose(pExetasis);
      free(rema);
      free(catalogos);
      return ECHEC ;
      }
    }
  free(rema);
  pSmb -> Binarisation(catalogos, n);
  pSmb -> Encadrement();
  fclose(pExetasis);
  
  //    free(mat.matrice);
  free(catalogos);
  
  //    free(Psmb);
  //    pSmb->Copie(&smb);
  return SUCCES ;
  }
else 

/* ref=TXT */
  {
  iNbOct    =  (n - 2) * (n - 2) / 8 + 1 ;
  catalogos =  (unsigned char *)fgetltext(pExetasis, iNbOct); // catalogos allou  iNbOct+1.
  j         =  strlen((char *)catalogos);
  
  /* "catalogos" est une chane de caractres d'au plus "iNbOct" octets
     avec '\0' en fin de chane. */
  if ( j < iNbOct ) 
    {
    for ( i = j ; i < iNbOct - 1 ; i++ ) 
      catalogos [i] =  ' ';
    catalogos [iNbOct - 1] =  0 ; /* "catalogos" n'a plus  tre considre comme
                                     une chane mais une suite de "iNbOct" octets
                                     dont le dernier vaut 0 ou 1. */ 
    }
  pSmb -> Binarisation(catalogos, n);
  pSmb -> Encadrement();
  free(catalogos);
  fclose(pExetasis);
  return SUCCES ;
  }
}

int DeduceSymbolName ( char szSymbolName [MAXFILE],
    char *szImageUtilisee
    , char *szAssociationLibrary )
{
if ( !szImageUtilisee ) 
  return FAILURE ;

char  szDrive [MAXDRIVE], szDir [MAXDIR], szImageName [MAXFILE]
  , szExt [MAXEXT];

fnsplit(szImageUtilisee, szDrive, szDir, szImageName, szExt);
if ( !*szImageName ) 
  {
  *szSymbolName =  0 ;
  return SUCCESS ;
  }
else if ( FindSymbolFile(szImageName) ) // Look in several directories if a symbol match that name.
                                          {
                                          strNcpy(szSymbolName, szImageName
                                            , MAXFILE);
                                          return SUCCESS ;
                                          }
else if ( DecodeSampleSymbolName(szImageName, szSymbolName) ) 
  return SUCCESS ;
else 
  {
  GetPrivateString("associations Image-Symbole"
    , szImageName // Nom du symbole (sans rpertoire ni extensions)
    , CONST_NoneSymbolMessage // valeur par dfaut ("none")
    , szSymbolName // Cible
    , MAXFILE
    , szAssociationLibrary);
  
  //    strNcpy(szSymbolName,CONST_NoneSymbolMessage,MAXFILE);
  //    strNcpy(szSymbolName,"none",MAXFILE);
  return strcmp(szSymbolName, CONST_NoneSymbolMessage); // false si "none"
  }
}

// int FindImageFile(char *szName, char *szPath) is in wirsutil.
int FindSymbolFile ( char *szName, char *szPath ) // Look in several directories if a symbol match that name.
{
char  szSymbolPath [MAXPATH];

fnmerge(szSymbolPath, szSymbolDrive, szSymbolDir, szName, "smb");
if ( !access(szSymbolPath, 04) ) 
  {
  if ( szPath ) 
    strcpy(szPath, szSymbolPath);
  return TRUE ;
  }
fnmerge(szSymbolPath, "", "", szName, "smb");
if ( !access(szSymbolPath, 04) ) 
  {
  if ( szPath ) 
    strcpy(szPath, szSymbolPath);
  return TRUE ;
  }
if ( szPath ) 
  *szPath =  0 ;
return FALSE ;
}

int DecodeSampleSymbolName ( char *szImageName, char *szSymbolName
    , char *szFoundPath )
{
if ( szFoundPath ) 
  *szFoundPath =  0 ;

char          cSampleName, cSpin ;
unsigned char uDate, uNumber, uFreq ;

if ( !SplitSampleSymbolName(szImageName, &cSampleName, &uDate, &uNumber
      , &cSpin, &uFreq) ) 
  return FALSE ;
else 
  sprintf(szSymbolName, "smb-%d", uNumber);
return FindSymbolFile(szSymbolName, szFoundPath);
}

int SplitSampleSymbolName (
    char *szImageName
    , char *pcSampleName // Nom de la srie d'chantillonnage
    , unsigned char *puDate // Date de la srie (No. du mois en hexa)
    , unsigned char *puNumber // Numro du symbole
    , char *pcSpin // Variante (lettre f-g-h...)
    , unsigned char *puFreq  // Frquence du symbole*
    )
{
if ( !szImageName ) 
  return FALSE ;

char  szImage [MAXFILE];

strNcpy(szImage, szImageName, sizeof(szImage));
strlwr(szImage);
if ( !islower(szImage [0]))
  // Exemple de nom d'chantillon:   a7n03f21.img
  return FALSE ;
if ( !IsDigit(szImage [1])
    && szImage [1] != 'a'
    && szImage [1] != 'b'
    && szImage [1] != 'c' )
  return FALSE ;
if ( szImage [2] != 'n' )
  return FALSE ;
if ( !IsDigit(szImage [3]) )
  return FALSE ;
if ( !IsDigit(szImage [4]) )
  return FALSE ;
if ( !islower(szImage [5]) )
  return FALSE ;
if ( !IsDigit(szImage [6]) )
  return FALSE ;
if ( !IsDigit(szImage [7]) )
  return FALSE ;
*pcSampleName =  szImage [0]; // Nom de la srie d'chantillonnage
*puDate       =  IsDigit(szImage [1])? szImage [1]- '0':szImage [1]-'a'+10; // Date de la srie (No. du mois en hexa)
*puNumber     =  (szImage [3] - '0') * 10 + (szImage [4] - '0'); // Numro du symbole
*pcSpin       =  szImage [5];
*puFreq       =  (szImage [6] - '0') * 10 + (szImage [7] - '0'); // Numro du symbole
return TRUE ;
}
