//#include "baptiall.h"
//#pragma hdrstop

#define MODULE_NAME "WGEOMETR.CPP"
 /*
    *******************|*******************************************
    *                  W G E O M E T R . C P P                    *
    *-------------------------------------------------------------*
    *    Fonction       : Fonction mathmatiques                  *
    *                                                             *
    *                                                             *
    * (contient les objets internes                               *
    *  et les corps des objets  exporter)                        *
    *-------------------------------------------------------------*
    *    Auteur         : Baptise MARCEL                          *
    *    Dvelopp le   : t    19941995                         *
    **************************************************************/

// Inclusions bibliothques standards
#include <math.h>
//#include <stdlib.h>
#include <values.h>

// Inclusions bibliothques Object Windows
#include <owl/point.h>

// Inclusions bibliothques DOS
#include <stdio.h>

// Inclusion bibliothques Image
//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "wsystool.h"
#include "scaltool.h"
#include "strutil.h"
#include "wgeometr.h"

/*
   -------------------------------------------------------------------------
   *		                 constantes locales            *
   -------------------------------------------------------------------------
   -------------------------------------------------------------------------
   *	                   variables  exporter                *
   -------------------------------------------------------------------------
   */
extern TVecteur VecteurNul;

/*
TVecteur  VecteurNul (float, float) ;
TVecteur3 Vecteur3Nul (float, float, float) ;
*/
TVecteur  VecteurNul (0.0, 0.0) ;
TVecteur3 Vecteur3Nul (0.0, 0.0, 0.0) ;


TBipoint  bipNul(0, 0, 0, 0);
TRect     rImage(0, 0, SIZE_OF_PICTURES - 1, SIZE_OF_PICTURES - 1)
  , rImageBorder(0, 0, SIZE_OF_PICTURES, SIZE_OF_PICTURES);

;

TCoordonnee   CoordonneeErreur (MAXINT, MAXINT) ;
TLigne        LigneErreur (CoordonneeErreur, CoordonneeErreur) ;
TBipoint      bipErreur (MAXINT, MAXINT, MAXINT, MAXINT) ;
TVecteur      VecteurErreur (MAXFLOAT, MAXFLOAT) ;
TDroite       DroiteErreur (MAXFLOAT, MAXFLOAT)
  , drPremiereBissectrice(1, - 1, 0), drDeuxiemeBissectrice(1, 1, 0)
  , drPremiereLimiteDroiteOblique( - sin(22.5 / 180 * M_PI)
    , cos(22.5 / 180 * M_PI))
  , drDeuxiemeLimiteDroiteOblique( - sin(67.5 / 180 * M_PI)
    , cos(67.5 / 180 * M_PI));
TQuadrilatere QuadrilatereErreur (CoordonneeErreur, CoordonneeErreur
  , CoordonneeErreur, CoordonneeErreur) ;

/*
   -------------------------------------------------------------------------
   *		                nouveaux types locaux           *
   -------------------------------------------------------------------------
   -------------------------------------------------------------------------
   *		                 variables locales             *
   -------------------------------------------------------------------------
   *              prototypes des fonctions locales               *
   -------------------------------------------------------------------------
   BOOL MErreur(char *szMessage,int ref=0);
   -------------------------------------------------------------------------
   *	                   fonctions  exporter                *
   -------------------------------------------------------------------------
   -------------------------------------------------------------------------
   *	                   fonctions scalaires                 *
   -------------------------------------------------------------------------
   -------------------------------------------------------------------------
   *	                   fonctions matricielles              *
   -------------------------------------------------------------------------
   */
char Transposition_MAT ( unsigned char *mat1, unsigned char *mat2
    , unsigned long m, unsigned long n )
{
unsigned long i, j ;

if ( mat1 == NULL || mat2 == NULL || n > 256 || m > 256 ) 
  return ECHEC ;
else 
  {
  for ( i = 0 ; i < m ; i++ ) 
    for ( j = 0 ; j < n ; j++ ) 
      mat2 [(unsigned int)(i * n + j)] =  mat1 [(unsigned int)(j * m + i)];
  return SUCCES ;
  }
}

char ImageAbsGrad2x2 ( unsigned char *source_user
    , unsigned char *destin_user )
{
int N = 256, i, j ;

if ( source_user == NULL || destin_user == NULL ) 
  {
  MErreur("Images non alloues.", 1284);
  return ECHEC ;
  }
for ( i = 0 ; i < N ; i++ ) 
  for ( j = 0 ; j < N ; j++ ) 
    destin_user [i * N + j] =  (AbsGradiant2x2(i, j, source_user) >> 1);
return SUCCES ;
}

int AbsGradiant2x2 ( unsigned char i, unsigned char j, unsigned char *img )
{
int N = 256 ;

if ( i == 0 ) 
  {
  if ( j == 255 ) 
    return 0 ;
  else 
    return abs( - img [i * N + j] + img [i * N + j + 1]);
  }
else 
  {
  if ( j == 255 ) 
    return abs( - img [i * N + j] + img [(i - 1) * N + j]);
  else 
    return abs( - img [i * N + j] + img [i * N + j + 1])
      + abs( - img [i * N + j] + img [(i - 1) * N + j]);
  }
}

//-------------------------------------------------------------------------
/*	                   fonctions sur courbes                */
//-------------------------------------------------------------------------
statistiques Statistiques_courbe ( unsigned char *x, long taille )
{
statistiques  stat_x = { 0, 0, 0, 0.0, 0.0, 0.0 };
long int      i = 0 ;

if ( x == NULL || taille < 0 ) 
  {
  MErreur("Statistiques d'une courbe vide", 2811);
  return stat_x ;
  }
stat_x.min        =  x [0];
stat_x.max        =  x [0];
stat_x.som        =  0 ;
stat_x.ecart_type =  0 ;
for ( i = 0 ; i < taille ; i++ ) 
  {
  if ( *x < stat_x.min ) 
    stat_x.min =  *x ;
  if ( *x > stat_x.max ) 
    stat_x.max =  *x ;
  stat_x.som        += *x ;
  stat_x.ecart_type += (float)*x * (float)*x ; /* somme des carrs */ 
  x++ ;
  }
stat_x.moy        =  (float)stat_x.som / (float)taille ;
stat_x.ecart_type 
  =  stat_x.ecart_type / (float)taille - stat_x.moy * stat_x.moy ;

/* variance = moy. des car. - car. de moy. */
stat_x.med        =  (float)(stat_x.min + stat_x.max) / 2.0 ;
stat_x.ecart_type =  (float)sqrt((double)stat_x.ecart_type);
return stat_x ;
}

statistiques Statistiques_courbe ( unsigned int *x, long taille )
{
statistiques  stat_x = { 0, 0, 0, 0.0, 0.0, 0.0 };
long int      i = 0 ;

if ( x == NULL || taille < 0 ) 
  {
  MErreur("Statistiques d'une courbe vide", 2811);
  return stat_x ;
  }
stat_x.min        =  x [0];
stat_x.max        =  x [0];
stat_x.som        =  0 ;
stat_x.ecart_type =  0 ;
for ( i = 0 ; i < taille ; i++ ) 
  {
  if ( *x < stat_x.min ) 
    stat_x.min =  *x ;
  if ( *x > stat_x.max ) 
    stat_x.max =  *x ;
  stat_x.som        += *x ;
  stat_x.ecart_type += (float)*x * (float)*x ; /* somme des carrs */ 
  x++ ;
  }
stat_x.moy        =  (float)stat_x.som / (float)taille ;
stat_x.ecart_type 
  =  stat_x.ecart_type / (float)taille - stat_x.moy * stat_x.moy ;

/* variance = moy. des car. - car. de moy. */
stat_x.med        =  (float)(stat_x.min + stat_x.max) / 2.0 ;
stat_x.ecart_type =  (float)sqrt((double)stat_x.ecart_type);
return stat_x ;
}

int Moyenne_Courbe ( TVecteur *axy, unsigned int wSize, TVecteur *pMean )
{
if ( !axy ) 
  return FAILURE ;
else 
  *pMean =  TVecteur(0, 0);
for ( unsigned long dw = 0 ; dw < wSize ; dw++ ) 
  *pMean =  *pMean + axy [(unsigned int)dw];
*pMean =  *pMean / wSize ;
return wSize ;
}

unsigned char Minimum_courbe ( unsigned char *x, long taille )
{
long int      i ;
unsigned char min ;

if ( x == NULL ) 
  return !MErreur("Calcul pour une courbe vide", 2844);
min =  x [0];
for ( i = 0 ; i < taille ; i++ ) 
  if ( *x++ < min ) 
    min =  *(x - 1);
return min ;
}

unsigned char Maximum_courbe ( unsigned char *x, long taille )
{
long int      i ;
unsigned char max ;

if ( x == NULL ) 
  return !MErreur("Calcul pour une courbe vide", 2858);
max =  x [0];
for ( i = 0 ; i < taille ; i++ ) 
  if ( *x++ > max ) 
    max =  *(x - 1);
return max ;
}

/*-------------------------------------------------------------*/
unsigned char Somme_courbe ( unsigned char *x, long taille )
{
long int  i ;
int       som = 0 ;

if ( x == NULL ) 
  return !MErreur("Calcul pour une courbe vide", 2871);
for ( i = 0 ; i < taille ; i++ ) 
  som += *x++ ;
return som ;
}

/*
   -------------------------------------------------------------**
   Fonction dfinie dans GTTSI
   *
   
   *
   float Moyenne_courbe (unsigned char *x, long int taille)
     {
     unsigned long int i;
     float moy=0.0;
   
     if (x==NULL) {MErreur("Calcul pour une courbe vide (ref. 279)."); return 0; }
     for(i=0;i<taille;i++)
       moy += x[i];
     return moy/(float)taille;
     }
   
   -------------------------------------------------------------
   */
float Mediane_courbe ( unsigned char *x, long taille )
{
int       min, max ;
long int  i ;

if ( x == NULL ) 
  return !MErreur("Calcul pour une courbe vide", 2881);
min =  x [0];
max =  x [0];
for ( i = 0 ; i < taille ; i++ ) 
  {
  if ( *x < min ) 
    min =  *x ;
  if ( *x > max ) 
    max =  *x ;
  x++ ;
  }
return (float)(min + max) / 2.0 ;
}

/*--------------------------------------------------------------------*/
char Courbe_plate ( unsigned char *x, long taille )
{
unsigned int  i ;

if ( x == NULL || taille <= 0 || taille > 65536L ) 
  {
  MErreur("Maudit soit Ford : la courbe est morlave.", 2438);
  return 0 ;
  }
for ( i = 0 ; i < taille - 1 ; i++ ) 
  if ( x [i] != x [i + 1] ) 
    return FAUX ;
return VRAI ;
}

/*--------------------------------------------------------------------*/
/* Loc_maximum_courbe (Localise le maximum d'une courbe)
     Prend une courbe et en localise le maximum.
     Si il y a plusieurs maximum, la fonction renvoit celui dont le plateau
   (i.e. la largeur du pic en son sommet) est le plus large. Si il y a plusieurs
   plateaux de mme largeur, le plus petit est choisit.
     C'est le centre du plateau (arrondi inf.) qui est renvoy.
   
     ap1, ap2 :	dbut et fin du prcdent plateau maximum,
     pc1, pc2 :	dbut et fin du plateau maximum en cours,
     cp :		centure du plateau choisi.
   */
unsigned char Loc_maximum_courbe ( unsigned char *courbe, unsigned int l )
{
long          ap1, ap2, cp ;
statistiques  stat_c ;
char          plateau_unique ;
long          i, pc1, pc2 ;

plateau_unique =  VRAI ;
if ( courbe == NULL || !l ) 
  {
  MErreur(
    "Pluie de souvoupes collantes en Arige. Veuillez regagner les abris."
    , 2633);
  return 0 ;
  }
stat_c =  Statistiques_courbe(courbe, l);
if ( stat_c.max == stat_c.min ) /* histogramme plat */ 
                                  {
                                  pc1 =  0 ;
                                  pc2 =  l - 1 ;
                                  }
else 
  {
  pc2 =  - 2 ;
  for ( i = 0 ; i < l ; i++ ) 
    if ( courbe [(unsigned int)i] == stat_c.max ) 
      
      /* Plateau haut. */
      if ( i == pc2 + 1 ) 
        
        /* Prolongation du plateau courant. */
        pc2++ ;
      else /* Tout premier plateau. */ if ( plateau_unique ) 
            {
            pc1            =  i ;
            pc2            =  i ;
            ap1            =  pc1 ;
            ap2            =  pc2 ;
            plateau_unique =  FAUX ;
            }
           else 
           
           /* Nouveau plateau. */
            {
            pc1 =  i ;
            pc2 =  i ;
            }
    else /* non max */ if ( i == pc2 + 1 ) 
          
          /* Sortie de plateau en descente. */
          if ( !plateau_unique ) 
            
            /* Il y avait dj un autre plateau de mme
               niveau. */
            if ( pc2 - pc1 + 1 > ap2 - ap1 + 1 ) /* Dernier plateau plus large. */ 
                                                  {
                                                  ap1 =  pc1 ;
                                                  ap2 =  pc2 ;
                                                  } /* Mmorisation du nouveau plateau. */ 
  
  /* Fin de boucle */
  if ( pc2 == l - 1 ) 
    
    /* Le dernier lment tait un maximum. */
    if ( !plateau_unique ) 
      
      /* Il y avait dj un autre plateau de mme
         niveau. */
      if ( pc2 - pc1 + 1 <= ap2 - ap1 + 1 ) /* Dernier plateau plus troit. */ 
                                              {
                                              pc1 =  ap1 ;
                                              pc2 =  ap2 ;
                                              } /* Mmorisation du nouveau plateau. */ 
  }

/* Ici, pc1 et pc2 encadrent le plateau choisit. */
cp =  NFarRoundR((float)(pc1 + pc2) / 2.0); /* Arrondi proche. */ 
return (unsigned int)cp ;
}

/*--------------------------------------------------------------------*/
/* Loc_minimum_courbe (Localise le minimum d'une courbe)
     Prend une courbe et en localise le minimum.
     Si il y a plusieurs minima, la fonction renvoit celui dont le plateau
   (i.e. la largeur de la valle en son fond) est le plus large. Si il y a
   plusieurs plateaux de mme largeur, le premier est choisit.
     C'est le centre du plateau (arrondi inf.) qui est renvoy.
   
     ap1, ap2 :	dbut et fin du prcdent plateau minimum,
     pc1, pc2 :	dbut et fin du plateau minimum en cours,
     cp :		centre du palteau choisit.
   */
//unsigned int LocMinimumTable (unsigned char *auTable, unsigned int wLen)
// Loc_minimum_courbe should be obsolete.
unsigned char Loc_minimum_courbe ( unsigned char *auTable
    , unsigned int wLen )
{
unsigned long ap1, ap2, cp ;
statistiques  stat_c ;
char          fPlateauUnique ;
long          i, pc1, pc2 ;

if ( !auTable || !wLen ) 
  return MErreur("Pardon me, but your teeth are in my neck.", 397);
fPlateauUnique =  VRAI ;
stat_c         =  Statistiques_courbe(auTable, wLen);
if ( stat_c.max == stat_c.min ) /* histogramme plat */ 
                                  {
                                  pc1 =  0 ;
                                  pc2 =  wLen - 1 ;
                                  }
else 
  {
  pc2 =  - 2 ;
  for ( i = 0 ; i < wLen ; i++ ) 
    if ( auTable [(unsigned int)i] == stat_c.min ) 
      
      /* Plateau bas. */
      if ( i == pc2 + 1 ) 
        
        /* Prolongation du plateau courant. */
        pc2++ ;
      else /* Tout premier plateau. */ if ( fPlateauUnique ) 
            {
            pc1            =  i ;
            pc2            =  i ;
            ap1            =  pc1 ;
            ap2            =  pc2 ;
            fPlateauUnique =  FAUX ;
            }
           else 
           
           /* Nouveau plateau. */
            {
            pc1 =  i ;
            pc2 =  i ;
            }
    else /* non min */ if ( i == pc2 + 1 ) 
          
          /* Sortie de plateau en monte. */
          if ( !fPlateauUnique ) 
            
            /* Il y avait dj un autre plateau de mme
               niveau. */
            if ( pc2 - pc1 + 1 > ap2 - ap1 + 1 ) /* Dernier plateau plus large. */ 
                                                  {
                                                  ap1 =  pc1 ;
                                                  ap2 =  pc2 ;
                                                  } /* Mmorisation du nouveau plateau. */ 
  
  /* Fin de boucle */
  if ( pc2 == wLen - 1 ) 
    
    /* Le dernier lment tait un maximum. */
    if ( !fPlateauUnique ) 
      
      /* Il y avait dj un autre plateau de mme
         niveau. */
      if ( pc2 - pc1 + 1 <= ap2 - ap1 + 1 ) /* Dernier plateau plus troit. */ 
                                              {
                                              pc1 =  ap1 ;
                                              pc2 =  ap2 ;
                                              } /* Mmorisation du nouveau plateau. */ 
  }

/* Ici, pc1 et pc2 encadrent le plateau choisit. */
cp =  NFarRoundR((float)(pc1 + pc2) / 2.0); /* Arrondi proche. */ 
return (unsigned int)cp ;
}

//-------------------------------------------------------------------------
//	             fonctions pour points (coordonnees)
//-------------------------------------------------------------------------
/*-------------------------------------------------------------*/
uCoordonnee Cv_uCoordonnee ( TVecteur U )
{
uCoordonnee sM = { NFarRoundR(U.x), NFarRoundR(U.y)};

return sM ;
}

/*-------------------------------------------------------------*/
uCoordonnee Cv_uCoordonnee ( TCoordonnee M )
{
uCoordonnee sM = { i2uc(M.x), i2uc(M.y)};

return sM ;
}

/*TPoint GetPrivatePoint(char *szSection, char * szEntry,
       TCoordonnee ptDefault, char *szFileName)
     {
     char szLigne[USUALMAXLENSTRING*2];
     int aIntList[2];
     if (!szSection || !szEntry || !szFileName)
       return ptDefault;
     else
       GetPrivateString(szSection, szEntry, "",szLigne,
                               USUALMAXLENSTRING*2,szFileName);
     if (GetIntegerList(szLigne,aIntList, 2)!=2)
       return ptDefault;
     else
       return TPoint(aIntList[0],aIntList[1]);
     }
   
   BOOL WritePrivatePoint(char *szSection, char *szEntry, TPoint pValue,
                              char *szFilename)
     {
     char sz[USUALMAXLENSTRING*2];
     wsprintf(sz,"%d,%d",pValue.x,pValue.y);
     return WritePrivateString(szSection, szEntry, sz,szFilename);
     }
   
     */
//-------------------------------------------------------------------------
//	             fonctions pour lignes (coordonnees)
//-------------------------------------------------------------------------
ligne_AB Cv_ligne ( TLigne l )
{
ligne_AB  l_out ;

l_out.A  =  Cv_uCoordonnee(l.A);
l_out.B  =  Cv_uCoordonnee(l.B);
l_out.lg =  l.lg ;
return l_out ;
}

double TLigne::Longueur ()
{
double  l = sqrt(LongueurCarree());

lg =  NFarRoundR(RReduceR(l, 0.0, 255.0)); // Initialisation d'lg, membre deTLigne.
return l ;
}

//-------------------------------------------------------------------------
//	              fonctions pour points (vecteurs)
//-------------------------------------------------------------------------
double Angle ( TVecteur U1, TVecteur U2 )
{
return (U1.EstNul() || U2.EstNul()) ? 0.0 : atan2(U1 ^ U2, U1 * U2); //  double xU1U2cos=U1*U2, xU1U2sin=U1^U2;
}

double tanAngle ( TVecteur U1, TVecteur U2 )
{
return (U1.EstNul() || U2.EstNul()) ? 0.0 : (U1 ^ U2) / (U1 * U2); // U1U2 sin/ U1U2 cos
}

double cosAngle ( TVecteur U1, TVecteur U2 )
{
return (U1.EstNul() || U2.EstNul()) ? 
     0.0
  : (U1 * U2) / U1.Module() / U2.Module();
}

double sinAngle ( TVecteur U1, TVecteur U2 )
{
return (U1.EstNul() || U2.EstNul()) ? 
     0.0
  : (U1 ^ U2) / U1.Module() / U2.Module();
}

TVecteur TVecteur::Barycentre ( TVecteur A, float a, TVecteur B, float b )
{
float s = a + b ;

if ( s == 0.0 ) 
  {
  MErreur("Barycentre coefficients tous nuls.", 870);
  return VecteurErreur ;
  }
return TVecteur((a * A.x + b * B.x) / (a + b)
  , (a * A.y + b * B.y) / (a + b));
}

/*--------------------------------------------------------------------*/
TVecteur TVecteur::Unitaire ()

// Le mme vecteur divis par sa norme.
{
float z = Module();

if ( z == 0.0 ) 
  {
  MTrace("Unitaire d'un vecteur nul", 540);
  return TVecteur(1.0, 0.0);
  }
else 
  return TVecteur(x / z, y / z);
}

/*--------------------------------------------------------------------*/
TVecteur TVecteur::Pivote ( float xAlpha )
{
static float  xMemoAlpha = 0.0 ;
static double x_cosAlpha = cos(xMemoAlpha);
static double y_sinAlpha = sin(xMemoAlpha);

if ( xAlpha != xMemoAlpha ) 
  {
  xMemoAlpha =  xAlpha ;
  x_cosAlpha =  cos(xMemoAlpha);
  y_sinAlpha =  sin(xMemoAlpha);
  }
return TVecteur(x * x_cosAlpha - y * y_sinAlpha
  , x * y_sinAlpha + y * x_cosAlpha);
}

/*--------------------------------------------------------------------*/
TVecteur TVecteur::Pivote ( TVecteur xyCentre, double dAlpha ) // Rotation autour d'un point.
{
return xyCentre + Pivote(dAlpha) - xyCentre.Pivote(dAlpha);
}

/*--------------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	              fonctions sur bipoints                   */
/*-------------------------------------------------------------*/
BOOL TBipoint::Existe ()
{
return !IsNull()
        && TCoordonnee(TopLeft()).Existe()
        && TCoordonnee(BottomRight()).Existe();
}

/*-------------------------------------------------------------*/
/*         Fonction de contrle sur bipoint.                   */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	                   fonctions pour vecteur 3D           */
/*-------------------------------------------------------------*/
TVecteur3::TVecteur3 ( float a_in, float b_in, float c_in )
{
a =  a_in ;
b =  b_in ;
c =  c_in ;
}

void TVecteur3::Set ( float a_in, float b_in, float c_in )
{
a =  a_in ;
b =  b_in ;
c =  c_in ;
}

char TVecteur3::EstNul ()
{
return a == 0.0 && b == 0.0 && c == 0.0 ;
}

/*-------------------------------------------------------------*/
/* OrdonneTriplet
   */
void TVecteur3::OrdonneCroissant ()
{
float Mab = max(a, b);

if ( c >= Mab ) 
  {
  Set(min(a, b), Mab, c);
  return ;
  }

float Mcb = max(c, b);

if ( a >= Mcb ) 
  Set(min(c, b), Mcb, a);
else 
  Set(min(c, a), max(c, a), b);
}

/*-------------------------------------------------------------*/
/*	              fonctions pour droites                   */
/*-------------------------------------------------------------*/
int InterpolationLineaireX ( TVecteur *axyM, unsigned int wSize
    , TDroite *pdrInterpol )
{
if ( !axyM || !pdrInterpol ) 
  return FAILURE ;

TVecteur  xyMoy, xyDeltaMean ;

Moyenne_Courbe(axyM, wSize, &xyMoy);

float xSxx = 0.0, xSxy = 0.0 ;

for ( unsigned long dw = 0 ; dw < wSize ; dw++ ) 
  {
  xyDeltaMean =  (axyM [(unsigned int)dw] - xyMoy);
  xSxy        += xyDeltaMean.x * xyDeltaMean.y ;
  xSxx        += xyDeltaMean.x * xyDeltaMean.x ;
  }
if ( xSxx != 0.0 ) 
  *pdrInterpol
    =  TDroite(xSxy / xSxx, - 1.0
      , xyDeltaMean.y - xSxy / xSxx * xyDeltaMean.x);
else 
  *pdrInterpol =  TDroite(1, 0, - xyDeltaMean.x);
return pdrInterpol -> Existe();
}

TVecteur TDroite::PointMembre ()
{
if ( FaiblePente() ) 
  return TVecteur(0, - c / b);
else 
  return TVecteur( - c / a, 0);
}

TVecteur TDroite::VecteurPorteur ()
{
return TVecteur( - b, a);
}

// Renvoit     return VecteurErreur; en cas de parallelisme.
TVecteur TDroite::Intersection ( TDroite D )
{
float determ ;

if ( !Existe() || !D.Existe() || Paralleles(D) ) 
  return VecteurErreur ;
else 
  {
  determ =  a * D.b - b * D.a ;
  return TVecteur(( - c * D.b + D.c * b) / determ
    , (c * D.a - D.c * a) / determ);
  }
}

char TVecteur::AppartientDroite ( TDroite D )
{
float DD = DistanceCarree(D);

return (DD == MAXFLOAT) ? 
     MErreur("Perdu. (MATHDIV)", 1058)
  : (DistanceCarree(D) <= epsilon * epsilon);
}

char TrianglePlat ( TVecteur A, TVecteur B, TVecteur C )
{
TDroite AB (A, B) ;

if ( A == B ) 
  return VRAI ;
else if ( !AB.Existe() ) 
  return MErreur("Big trouble (in little China). (MATHDIV.C)", 1014);
else 
  return C.AppartientDroite(AB);
}

// Dit si le point (*this) est  droite o  gauche de l'axe orient (A, A->B)

char TVecteur::DroiteOuGaucheDroite ( TVecteur A, TVecteur B )
{
return signe((*this - A) ^ (B - A)); // Positif pour le point  droite.
}

/* Distance algbrique d'un point  une droite oriente donne par deux
   points.
     Rsultat positif ou ngatif selonque le point est  droite ou  gache de la
   droite oriente.
   // Positif pour le point  droite.
   */
double TVecteur::DistanceAlgebriqueDroite ( TVecteur ptxA, TVecteur ptxB )
{
TVecteur  vAB (ptxA, ptxB) ;

return ((*this - ptxA) ^ vAB) / vAB.Module(); // Positif pour le point  droite.
}

BOOL TDroite::PlusRaide ( TDroite dr )
{
// La notion de FaiblePente/FortePente est au sens de sa valeur absolue.
if ( FaiblePente() ) // *this faible
                      {
                      if ( dr.FaiblePente() )
                        
                        // 2 faibles
                        return fabs(a / b) > fabs(dr.a / dr.b);
                      else 
                        
                        // *this faible et dr forte
                        return FAUX ;
                      }
else 

// *this forte
  {
  if ( dr.FaiblePente() ) 
    
    // *this forte et dr faible
    return VRAI ;
  else 
    return fabs(b / a) < fabs(dr.b / dr.a); // Inverses des pentes.
  }
}

BOOL TDroite::MoinsRaide ( TDroite dr )
{
if ( FaiblePente() ) // *this faible
                      {
                      if ( dr.FaiblePente() ) 
                        
                        // 2 faibles
                        return fabs(a / b) < fabs(dr.a / dr.b);
                      else 
                        
                        // *this faible et dr forte
                        return VRAI ;
                      }
else 

// *this forte
  {
  if ( dr.FaiblePente() )
    
    // *this forte et dr faible
    return FAUX ;
  else 
    return fabs(b / a) > fabs(dr.b / dr.a); // Inverses des pentes.
  }
}

/* Renvoit les 2 bissectrices d'un secteur angulaire. Ces deux droite sont
   perpendiculaire. */
BOOL TDroite::Bissectrice ( TDroite dr2, TDroite *pdrBiss1
    , TDroite *pdrBiss2 )
{
if ( !pdrBiss1 || !pdrBiss2 || !dr2.Existe() || Paralleles(dr2) ) 
  return ECHEC ;
else 
  {
  float xDenom = sqrt(a * a + b * b)
    , xDenom2 = sqrt(dr2.a * dr2.a + dr2.b * dr2.b);
  pdrBiss1 -> a =  a / xDenom + dr2.a / xDenom2 ;
  pdrBiss1 -> b =  b / xDenom + dr2.b / xDenom2 ;
  pdrBiss1 -> c =  b / xDenom + dr2.c / xDenom2 ;
  pdrBiss2 -> a =  a / xDenom - dr2.a / xDenom2 ;
  pdrBiss2 -> b =  b / xDenom - dr2.b / xDenom2 ;
  pdrBiss2 -> c =  b / xDenom - dr2.c / xDenom2 ;
  return SUCCES ;
  }
}

BOOL TDroite::EstDroiteEtPasOblique ()
{
// La raideur s'entend au sens de la valeur absolue de la pente. Deux droites symtriques par rapport  (O,x) ont la mme raideur.
return MoinsRaide(drPremiereLimiteDroiteOblique)
        || PlusRaide(drDeuxiemeLimiteDroiteOblique);
/*
drPremiereLimiteDroiteOblique: droite centrale d'argument 22,5
drDeuxiemeLimiteDroiteOblique: droite centrale d'argument 67,5
*/
}

/* Distance carre d'un point a une droite oriente dote d'un signe en fonction
   de la position du popint par rapport  la droite.
   // Positif pour le point  droite das un repre classique (O,x,y).
     Forme du repre :
     ^(y)
     |
     + - > (x)
   */
double TVecteur::DistanceCarreeAlgebriqueDroite ( TVecteur ptxA
    , TVecteur ptxB )
{
TVecteur  vAB (ptxA, ptxB) ;
float     xProduitScalaire = (*this - ptxA) ^ vAB ;

return xProduitScalaire * fabs(xProduitScalaire) / vAB.ModuleCarre(); // Positif pour le point  droite.
}

TDroite TDroite::Pivote ( double dAlpha )
{
TVecteur  xyM = PointMembre(), xyV = VecteurPorteur();

return TDroite(xyM.Pivote(dAlpha), xyV.Pivote(dAlpha), DROITE_POINT_VECTEUR);
}

TDroite TDroite::Pivote ( TVecteur xyOmega, double dAlpha )
{
TVecteur  xyM = PointMembre(), xyV = VecteurPorteur();

return TDroite(xyM.Pivote(xyOmega, dAlpha), xyV.Pivote(dAlpha)
  , DROITE_POINT_VECTEUR);
}

/*--------------------------------------------------------------------*/
/* Calcule le point ou la direction de fuite d'un faisceau de deux droites.
     Si les droites sont parallles, le commutateur "fini" est mis  VRAI et
   la valeur renvoye est un vecteur porteur de la direction de fuite. */
BOOL TDroite::CalculeFuiteFaisceau ( TDroite Dr1, TDroite Dr2
    , TVecteur *ptrF, int *Fini )
{
if ( !ptrF || !Dr1.Existe() || !Dr2.Existe() ) 
  return MErreur("Entits non dfinies.", 635);
*Fini =  !Dr1.Paralleles(Dr2);
if ( *Fini ) 
  {
  *ptrF =  Dr1.Intersection(Dr2);
  if ( !ptrF -> Existe() ) 
    return MErreur("Ratage intersectif malheureux.", 644);
  }
else 
  *ptrF =  Dr1.VecteurPorteur();
return SUCCES ;
}

/*--------------------------------------------------------------------*/
/*
     Rpond si deux droites sont parallles.
     Les droites sont parallles si leurs quatre intersections avec des limites
   parallles du domaine forment un paralllogramme (les distances sont gales 
   "epsilon" prs.
     Les limites considrs sont les lignes ou colonnes  -1 et 256.
   */
BOOL TDroite::Paralleles ( TDroite D )
{
float point1_0, point2_0, point1_MAX, point2_MAX ;

if ( !Existe() || !D.Existe() ) 
  return MErreur("Droites soumises au paralllismes non dfinies.", 417);
if ( FaiblePente() ) 
  {
  if ( D.EstVerticale() ) 
    
    /* Donc D.b /= 0. */
    return FAUX ;
  else 
    {
    point1_0   =  ( - a * ( - 1.0) - c) / b ;
    point2_0   =  ( - D.a * ( - 1.0) - D.c) / D.b ;
    point1_MAX =  ( - a * SIZE_OF_PICTURES - c) / b ;
    point2_MAX =  ( - D.a * SIZE_OF_PICTURES - D.c) / D.b ;
    return (fabs((point1_0 - point2_0) - (point1_MAX - point2_MAX))
      < epsilon);
    }
  }
else 

/* forte pente */
  {
  if ( D.EstHorizontale() ) 
    return FAUX ;
  else 
    {
    point1_0   =  ( - b * ( - 1.0) - c) / a ;
    point2_0   =  ( - D.b * ( - 1.0) - D.c) / D.a ;
    point1_MAX =  ( - b * SIZE_OF_PICTURES - c) / a ;
    point2_MAX =  ( - D.b * SIZE_OF_PICTURES - D.c) / D.a ;
    return (fabs((point1_0 - point2_0) - (point1_MAX - point2_MAX))
      < epsilon);
    }
  }
}

BOOL TDroite::EstVerticale ()
{
if ( !Existe() ) 
  return MErreur("Catastrophas.", 387);
else if ( FaiblePente() ) 
  return FAUX ;
else 
  
  /* a diffrent de zro. */
  return (fabs(b / a) < epsilon / SIZE_OF_PICTURES);
}

BOOL TDroite::EstHorizontale ()
{
if ( !Existe() ) 
  return MErreur("Catastrophas.", 684);
else if ( FortePente() ) 
  return FAUX ;
else 
  return (fabs(a / b) < epsilon / SIZE_OF_PICTURES);
}

/*--------------------------------------------------------------------*/
double TVecteur::Distance ( TDroite D )
{
if ( !D.Existe() ) 
  return MAXFLOAT ;
else 
  return fabs(D.a * x + D.b * y + D.c) / sqrt(D.a * D.a + D.b * D.b);
}

/*--------------------------------------------------------------------*/
double TDroite::Distance ( TVecteur v )
{
if ( !Existe() ) 
  return MAXFLOAT ;
else 
  return fabs(a * v.x + b * v.y + c) / sqrt(a * a + b * b);
}

/*--------------------------------------------------------------------*/
float TDroite::DistanceCarree ( TVecteur v )
{
if ( !Existe() ) 
  return MAXFLOAT ;
else 
  {
  float numer = a * v.x + b * v.y + c ;
  return numer * numer / (a * a + b * b);
  }
}

/*--------------------------------------------------------------------*/
float TVecteur::DistanceCarree ( TDroite D )
{
if ( !D.Existe() ) 
  return MAXFLOAT ;
else 
  {
  float numer = D.a * x + D.b * y + D.c ;
  return numer * numer / (D.a * D.a + D.b * D.b);
  }
}

/*-------------------------------------------------------------*/
//	                   fonctions gomtriques spcialises
/*-------------------------------------------------------------*/
/* AnglesTriangle3longu (Angles d'un tiangle connu par ses trois longueurs)
   */
BOOL AnglesTriangle3longu ( float AB, float BC, float CA, TVecteur3 *PABC )
{
float AB2 = AB * AB, BC2 = BC * BC, CA2 = CA * CA, cos_alpha, cos_beta
  , cos_gamma ;
char  T ;

T =  TypeTriangle3longu(AB, BC, CA);
if ( T == - 1 ) 
  {
  *PABC =  Vecteur3Nul ;
  return ECHEC ;
  }
else if ( T == 0 ) 
  {
  if ( AB >= max(BC, CA) ) 
    PABC -> Set(0.0, 0.0, M_PI);
  if ( BC >= max(AB, CA) ) 
    PABC -> Set(M_PI, 0.0, 0.0);
  if ( CA >= max(BC, AB) ) 
    PABC -> Set(0.0, M_PI, 0.0);
  return SUCCES ;
  }
cos_alpha =  (CA2 + BC2 - AB2) / 2.0 / CA / BC ;
cos_beta  =  (AB2 + CA2 - BC2) / 2.0 / AB / CA ;
cos_gamma =  (BC2 + AB2 - CA2) / 2.0 / BC / AB ;
if ( fabs(cos_alpha) > 1.0 || fabs(cos_beta) > 1.0 || fabs(cos_gamma) > 1.0 ) 
  {
  MErreur("Triangulation choue.", 392);
  *PABC =  Vecteur3Nul ;
  return ECHEC ;
  }
PABC -> Set((float)acos(cos_alpha), (float)acos(cos_beta)
  , (float)acos(cos_gamma));
return SUCCES ;
}

/*-------------------------------------------------------------*/
/* TypeTriangle3longu (Type Triangle connu par ses trois longueurs)
     Renvoit +1 pour un triangle correct, 0 pour un triangle plat, et -1
   pour un triangle impossible.
   */
char TypeTriangle3longu ( float AB, float BC, float CA )
{
TVecteur3 triangle (AB, BC, CA) ;

triangle.OrdonneCroissant();
if ( triangle.c > triangle.a + triangle.b + epsilon ) 
  return - 1 ;
else if ( triangle.c < triangle.a + triangle.b - epsilon ) 
  return 1 ;
else 
  return 0 ;
}

/*-------------------------------------------------------------*/
/* AireTriangle3longu (Aire d'un triangle connu par ses trois longueurs)
   */
char AireTriangle3longu ( float AB, float BC, float CA, float *P_aire )
{
char  T ;
float p, Surf2 ;

p =  (AB + BC + CA) / 2.0 ;
T =  TypeTriangle3longu(AB, BC, CA);
if ( T == - 1 ) 
  {
  *P_aire =  0.0 ;
  return ECHEC ;
  }
else if ( T == 0 ) 
  {
  *P_aire =  0.0 ;
  return SUCCES ;
  }
if ( (Surf2 = p * (p - AB) * (p - BC) * (p - CA)) < 0.0 ) 
  return MErreur("Pluis de grenouilles en Syldavie.", 624);
*P_aire =  (float)sqrt((double)Surf2);
return SUCCES ;
}

/*-------------------------------------------------------------*/
/* Fonction             sur quadrilatre                       */
/*-------------------------------------------------------------*/
void  ReOrgQuadMaxMax (unsigned int *pwSymbolProperties) ;

BOOL TQuadrilatere::DecCirc ( int i )
{
if ( i < 0 ) 
  i =  - (( - i) % 4);
else 
  i =  i % 4 ;

TCoordonnee M ;

while ( i-- ) 
  {
  M =  A ;
  A =  B ;
  B =  C ;
  C =  D ;
  D =  M ;
  }
return SUCCES ;
}

// Flip inverse les 2 opposs B et D.
int TQuadrilatere::Flip ()
{
TCoordonnee M (B) ;

B =  D ;
D =  M ;
return TRUE ;
}

/* FlipMaxEnSecond inverse ou pas les 2 opposs B et D afin  que:
   
   wCondition=TRUE: la longueur BC soit plus longue ou gale  la longueur AD
   wCondition=FALSE: la longueur BC soit plus petite ou gale  la longueur AD
   
   */
int TQuadrilatere::FlipMaxEnSecond ( BOOL wCondition )
{

//  if ((wCondition && dBCc<dDAc) || (!wCondition && dBCc>dDAc))
if ( (!wCondition) == (!B.DistanceCarree(C) < D.DistanceCarree(A)) ) 
  
  // both are true or both are false => Flip.
  return Flip();
else 
  return FALSE ;
}

//--------------------------------------------------------------------------
BOOL TQuadrilatere::DecCircMaxEnTete ( int *pi )
{
unsigned long int dABc, dBCc, dCDc, dDAc, maxlongc ;
int               i ;

if ( pi == NULL ) 
  pi =  &i ;
dABc     =  A.DistanceCarree(B);
dBCc     =  B.DistanceCarree(C);
dCDc     =  C.DistanceCarree(D);
dDAc     =  D.DistanceCarree(A);
maxlongc =  max(max(dABc, dBCc), max(dCDc, dDAc));
*pi      =  0 ;
if ( dABc == maxlongc ) 
  return SUCCES ;
DecCirc();
(*pi)++ ;
if ( dBCc == maxlongc ) 
  return SUCCES ;
DecCirc();
(*pi)++ ;
if ( dCDc == maxlongc ) 
  return SUCCES ;
DecCirc();
(*pi)++ ;
if ( dDAc == maxlongc ) 
  return SUCCES ;
return MErreur("Echec rotation quadrilatre \"max en tte\". (LANLFREQ)"
  , 1434);
}

//--------------------------------------------------------------------------
/*
   void Trace (char *szMessage, TQuadrilatere q, int ref)
     {
     char *sz=(char *)malloc(1+strlen(szMessage)+8*20+50);
     wsprintf(sz, "%s\n  ABCD.A=%d,%d;\n  ABCD.B=%d,%d;\n  ABCD.C=%d,%d;\n  ABCD.D=%d,%d.",szMessage,
         q.A.x,q.A.y,q.B.x,q.B.y,q.C.x,q.C.y,q.D.x,q.D.y);
     MTrace(szMessage,ref);
     }
   */
//--------------------------------------------------------------------------
BOOL TQuadrilatere::Pervers ()
{
return !Existe() || Plat() || !Convexe() || Croise();
}

BOOL TQuadrilatere::Existe ()
{
return A.Existe() && B.Existe() && C.Existe() && D.Existe();
}

BOOL TQuadrilatere::Plat ()
{
return TrianglePlat(TVecteur(A), TVecteur(B), TVecteur(C))
        && TrianglePlat(TVecteur(B), TVecteur(C), TVecteur(D));
}

/* Inverse B et D de facon a ce que le quadrilatre soit parcouru dans
   l'ordre trigonometrique.
     Rsultat non garanti si quadrilatere concave ou croise ou plat ou
   triangulaire.*/
int TQuadrilatere::FlipParcoursTrigo ()
{
if ( !IsParcoursTrigo() ) //  if (TVecteur(B).DroiteOuGaucheDroite(A,C)==GAUCHE)
                          // Inverser B et D si B est  gauche de la droite (AC)
                            {
                            TPoint  p (B) ;
                            B =  D ;
                            D =  p ;
                            return TRUE ;
                            }
else 
  return FALSE ;
}

//--------------------------------------------------------------------------
/* Renvoit VRAI si le quadrilatere est convexe.
     Vrai si ABCD tous confondus ou aligns, faux dans les autres cas de
   quadrilatere dgnrs.*/
BOOL TQuadrilatere::Convexe ()
{
char  cote ;

cote =  TVecteur(C).DroiteOuGaucheDroite(A, B);
return cote == TVecteur(D).DroiteOuGaucheDroite(A, C)
        && cote == TVecteur(D).DroiteOuGaucheDroite(A, B)
        && cote == TVecteur(D).DroiteOuGaucheDroite(B, C);
}

//--------------------------------------------------------------------------
/* Renvoit VRAI si le quadrilatere est crois.
   Rsultats non garantis pour quadrilatere triangle ou plat.*/
BOOL TQuadrilatere::Croise ()
{
char  cote ;

cote =  TVecteur(C).DroiteOuGaucheDroite(A, B);
return !(cote == TVecteur(D).DroiteOuGaucheDroite(A, C)
          || (cote == TVecteur(D).DroiteOuGaucheDroite(A, B)
                && cote == TVecteur(D).DroiteOuGaucheDroite(B, C)));
}

//--------------------------------------------------------------------------
/* Estime si un quadrilater est plutot droit ou plutot oblique en fonction
   de la direction de la bijectrice de ses diagonlaes.
   */
BOOL TQuadrilatere::EstDroitEtPasOblique ()
{
TDroite drDiagAC (A, C), drDiagBD (B, D) ; // Diagonales du quadrilatere.

if ( !drDiagBD.Existe()
      || !drDiagAC.Existe()
      || drDiagAC.Paralleles(drDiagBD) )
  return FAUX ; // grosse erreur, quadrilatere bizarode.

TDroite drDirGen1 (DroiteErreur), drDirGen2 (DroiteErreur), drDirGen ;

if ( !drDiagAC.Bissectrice(drDiagBD, &drDirGen1, &drDirGen2) )
  return FAILURE ;
drDirGen =  drDirGen1.FortePente() ? drDirGen2 : drDirGen1 ;

// Choix de la bissectrice de faible pente.
return drDirGen.EstDroiteEtPasOblique(); /*
                                            TVecteur xyCentreQuad=drDiagAC.Intersection(drDiagBD); // Intersec des diag.
                                            if (!xyCentreQuad.Existe())
                                              return VRAI;
                                            TDroite drRapporteeBD=drDiagBD.Pivote(xyCentreQuad,M_PI/2.0);  //
                                            TDroite drDiagMoy=drRapporteeBD.Bissectrice(drDiagAC);
                                            return drDiagMoy.FaiblePente();               */
}

//--------------------------------------------------------------------------
TQuadrilatere GetPrivateQuad ( char *szSection, char *szEntry
    , TQuadrilatere qDefault, char *szFileName )
{
if ( !szSection || !szEntry || !szFileName ) 
  return qDefault ;

TQuadrilatere ABCD ;
char          *szEntryQuad = (char *)malloc(strlen(szEntry) + 3);

wsprintf(szEntryQuad, "%s.A", szEntry);
ABCD.A
  =  GetPrivatePoint(szSection, szEntryQuad, CoordonneeErreur, szFileName);
wsprintf(szEntryQuad, "%s.B", szEntry);
ABCD.B
  =  GetPrivatePoint(szSection, szEntryQuad, CoordonneeErreur, szFileName);
wsprintf(szEntryQuad, "%s.C", szEntry);
ABCD.C
  =  GetPrivatePoint(szSection, szEntryQuad, CoordonneeErreur, szFileName);
wsprintf(szEntryQuad, "%s.D", szEntry);
ABCD.D
  =  GetPrivatePoint(szSection, szEntryQuad, CoordonneeErreur, szFileName);
free(szEntryQuad);
if ( !ABCD.Existe() ) 
  ABCD =  qDefault ;
return ABCD ;
}

BOOL WritePrivateQuad ( char *szSection, char *szEntry
    , TQuadrilatere qValue, char *szFileName )
{
if ( !szSection || !szEntry || !szFileName ) 
  return ECHEC ;

char  *szEntryQuad = (char *)malloc(strlen(szEntry) + 3);

wsprintf(szEntryQuad, "%s.A", szEntry);
WritePrivatePoint(szSection, szEntryQuad, qValue.A, szFileName);
wsprintf(szEntryQuad, "%s.B", szEntry);
WritePrivatePoint(szSection, szEntryQuad, qValue.B, szFileName);
wsprintf(szEntryQuad, "%s.C", szEntry);
WritePrivatePoint(szSection, szEntryQuad, qValue.C, szFileName);
wsprintf(szEntryQuad, "%s.D", szEntry);
WritePrivatePoint(szSection, szEntryQuad, qValue.D, szFileName);
free(szEntryQuad);
return SUCCES ;
}

//-------------------------------------------------------------------------
//	             fonctions pour polygones
//-------------------------------------------------------------------------
BOOL GetPrivatePolygon ( TCoordonnee *aptPolygon, unsigned char uNbPoints
    , char *szSection, char *szEntry, TPoint ptDefault, char *szFileName )
{
if ( !szSection || !szEntry || !szFileName || !aptPolygon || !uNbPoints ) 
  return ECHEC ;

char  *szEntryPolygon = (char *)malloc(strlen(szEntry) + 3);

for ( unsigned char u = 0 ; u < uNbPoints ; u++ ) 
  {
  wsprintf(szEntryPolygon, "%s.%c", szEntry, u + 'A');
  aptPolygon [u]
    =  TCoordonnee(
      GetPrivatePoint(szSection, szEntryPolygon, ptDefault, szFileName));
  }
free(szEntryPolygon);
return SUCCES ;
}

BOOL WritePrivatePolygon ( char *szSection, char *szEntry
    , TCoordonnee *aptPolygon, unsigned char uNbPoints, char *szFileName )
{
if ( !szSection || !szEntry || !szFileName || !aptPolygon || !uNbPoints ) 
  return ECHEC ;

char  *szEntryPolygon = (char *)malloc(strlen(szEntry) + 3);

for ( unsigned char u = 0 ; u < uNbPoints ; u++ ) 
  {
  wsprintf(szEntryPolygon, "%s.%c", szEntry, u + 'A');
  WritePrivatePoint(szSection, szEntryPolygon, aptPolygon [u], szFileName);
  }
free(szEntryPolygon);
return SUCCES ;
}

BOOL PolygoneExiste ( TCoordonnee *aptPolygone, unsigned char uNbPoints )
{
if ( !aptPolygone || !uNbPoints ) 
  return FAUX ;
else 
  {
  BOOL  f = VRAI ;
  for ( unsigned char u = 0 ; u < uNbPoints && f ; u++ ) 
    f =  f && aptPolygone [u].Existe();
  return f ;
  }
}

TRect RectangleCirconscrit ( TCoordonnee *aptPolygone
    , unsigned char uNbPoints )
{
if ( !PolygoneExiste(aptPolygone, uNbPoints) ) 
  return TRect(0, 0, 0, 0);
else if ( uNbPoints == 1 ) 
  return TRect(*aptPolygone, *aptPolygone);
else 
  {
  TRect r (aptPolygone [0], aptPolygone [1]) ;
  for ( unsigned char u = 1 ; u < uNbPoints - 1 ; u++ ) 
    {
    r =  r | TRect(aptPolygone [u], aptPolygone [u + 1]);
    }
  if ( u != uNbPoints - 1 ) 
    return TRect(0, 0, 0, 0);
  return r | TRect(aptPolygone [u - 1], aptPolygone [0]);
  }
}

/*
   From: orourke@cs.smith.edu (Joseph O'Rourke)
   Newsgroups: comp.graphics.algorithms,news.answers,comp.answers
   Subject: comp.graphics.algorithms Frequently Asked Questions
   Message-ID: <graphics/algorithms-faq-1-855994081@cs.smith.edu>
   Posted-By: auto-faq 3.2.1.4
   Archive-name: graphics/algorithms-faq
   Posting-Frequency: bi-weekly
   
   Welcome to the FAQ for comp.graphics.algorithms!
   
   Thanks to all who have contributed.  Corrections and contributions
   (to orourke@cs.smith.edu) always welcome.
   ----------------------------------------------------------------------
   Subject 2.03: How do I find if a point lies within a polygon?
   
       The definitive reference is "Point in Polyon Strategies" by
       Eric Haines [Gems IV]  pp. 24-46.
       The code in the Sedgewick book Algorithms (2nd Edition, p.354) is
       incorrect.
   
       The essence of the ray-crossing method is as follows.
       Think of standing inside a field with a fence representing the polygon.
       Then walk north. If you have to jump the fence you know you are now 
       outside the poly. If you have to cross again you know you are now 
       inside again; i.e., if you were inside the field to start with, the total 
       number of fence jumps you would make will be odd, whereas if you were 
       ouside the jumps will be even.
   
       The code below is from Wm. Randolph Franklin <wrf@ecse.rpi.edu>
       with some minor modifications for speed.
   */
//int IsWithinPolygon(int npol, float *xp, float *yp, float x, float y)
//TRect RectangleCirconscrit(TCoordonnee *aptPolygone,unsigned char uNbPoints)
int IsPointWithinPolygon ( TPoint *aptPolygone, unsigned char uNbPoints
    , TPoint pt )
{
int i, j, c = 0 ;

for ( i = 0, j = uNbPoints - 1 ; i < uNbPoints ; j =  i++ ) 
  {
  
  // Start with (0,uNbPoints-1) for side effect, follow-up with (i, i-1)
  if ( (((aptPolygone [i].y <= pt.y) && (pt.y < aptPolygone [j].y))
          || ((aptPolygone [j].y <= pt.y) && (pt.y < aptPolygone [i].y)))
        && (pt.x
          < (aptPolygone [j].x - aptPolygone [i].x)
              * (pt.y - aptPolygone [i].y)
              / (aptPolygone [j].y - aptPolygone [i].y)
            + aptPolygone [i].x) ) 
    c =  !c ;
  }
return c ;
}

//-------------------------------------------------------------------------
char *Item2String ( TVecteur3 xyz, char *sz )
{
sprintf(sz, "(a=%g, b=%g, c=%g)", xyz.a, xyz.b, xyz.c);
return sz ;
}

char *Item2String ( TQuadrilatere q, char *sz )
{
char  szPtA [STRLEN_Point], szPtB [STRLEN_Point], szPtC [STRLEN_Point]
  , szPtD [STRLEN_Point];

Item2String(q.A, szPtA);
Item2String(q.B, szPtB);
Item2String(q.C, szPtC);
Item2String(q.D, szPtD);
sprintf(sz, "(%s),(%s),(%s),(%s)", szPtA, szPtB, szPtC, szPtD);
return sz ;
}

char *Item2String ( TLigne l, char *sz )
{
char  szPtA [STRLEN_Point], szPtB [STRLEN_Point];

sprintf(sz, "(%s),(%s),%d", Item2String(l.A, szPtA)
  , Item2String(l.B, szPtB), l.lg);
return sz ;
} /*
     BOOL MErreur(char *szMessage,int ref)
       {
       char *MessageLocal;
       BOOL fRes;
       MessageLocal=(char *)malloc(strlen(szMessage)+20);
       wsprintf(MessageLocal,"%s (WGEOMETR.CPP)",szMessage);
       fRes= Erreur(MessageLocal,ref);
       free(MessageLocal);
       return fRes;
       }
     */ /*
           Polygon Scan Conversion
           
           
           by Hin Jang
           July 6, 1996
           
           The process of filling the interior region of a polygon is known as polygon
           scan conversion.
           Whereas the standard approach requires two data structures, a sorting
           procedure and is
           device-dependent [Foley90], the critical points method described herein is
           easy to implement,
           uses less space and is very fast [Gordon94]. We assume that the polygon has
           no intersecting edges
           ^^^^^^^^^^^^^^^^^^^^^
           and that its vertices are represented by two cyclic arrays X and Y.
                                                 ^^^^^^^^^^^^^
           The scan conversion algorithm begins with the Build_CR( ) procedure which
           determines the set CR
           of critical points of the polygon. A critical point is a vertex whose y
           coordinate is either a local
           minimum or is a representative of a set of consecutive vertices that
           together form a local minimum.
           After Build_CR( ), we initialise the active edge table (AET) to empty.
           
           >From every critical point whose y value is less than scanline S, each of the
           two polygon edges
           ascending from it is followed until either edge turns down before reaching S
           or it passes S. If the
           edge turns down, it is deleted from the AET, otherwise a new element is
           inserted into the AET. Each
           AET element contains
           
                the index of the highest of the vertices that is less than or equal to S
                the direction of advance (+1 or -1) along the arrays X and Y from the
           critical point
                the x coordinate of the intersection of the polygon edge with scanline S
           
           The polygon is then filled at the current scanline by traversing the AET and
           drawing lines between
           alternate pairs of AET elements.
           
           At the next scanline, the AET is updated. For every point currently in the
           AET, the edge is followed
           in the direction specified until it either turns down before the scanline or
           passes it. If the edge turns
           down, the edge is deleted from the AET, otherwise the information in the
           element is updated. The
           procedure MoveUp( ) determines whether an edge ascends to meet the scanline.
           If so, the
           intersection between the scanline and the edge is computed.
           
           The entire algorithm for the critical points method is shown below where c
           is the number of critical
           points and CR is an array of critical points. It is assumed that procedures
           Insert( ) and Delete( ) are
           available for the AET and that Paint( ) is available for drawing horizontal
           lines between alternate
           pairs of AET elements.
           */ /*
                 
                 CriticalPoints()
                 {
                 //  /* m:  the index to array CR
                 
                   Build_CR()
                   initialise AET to empty
                   m = 1
                 
                   for (each scan_line)
                     for (each AET element K) {
                       j  = k->index
                       di = k->direction
                       MoveUp(scan_line, j, di, s)
                       if (j == 0)
                         Delete(K)
                       else {
                         k->index = j;
                         k->x_val = s;
                       }
                     }
                 
                 //    /* insert new critical points when necessary
                     while (m <= c and y[CR[m]] <= scan_line) {
                       j = CR[m]
                       MoveUp(scan_line, j, -1, s)
                       if (j > 0) Insert(j, -1, s)
                       j = CR[m]
                       MoveUp(scan_line, j, 1, s)
                       if (j > 0) Insert(j, 1, s)
                       ++m
                     }
                     Paint()
                   }
                 }
                 
                 Build_CR()
                 {
                   candidate = 0
                 
                   for (i=1 to n) {
                     if (Y[i] > Y[i+1])
                        candidate = 1
                     else if (Y[i] < Y[i+1] and candidate) {
                        add i to cr
                        candidate = 0
                     }
                   }
                 
                   if (candidate and Y[1] < Y[2])
                     add 1 to cr
                 }
                 
                 MoveUp(scan_line, j, di, s)
                 {
                   /* j:  the current array index from which to
                          start the search
                      di: indicates the direction of advance from
                          j along the polygon arrays X and Y
                      s:  the x coordinate of the intersection point *
                 
                   j1 = j + di
                 
                 
                   while (Y[j1] <= scan_line) {
                     if (Y[j1] < y[j]) {           /* polygon turns down * /
                       j = 0
                       return
                     } else {                      /* move up * /
                       j = j1
                       j1 = j + di
                     }
                   }
                 
                   s = x coorindate of intersection of edge ( (X[j], Y[j])
                       (X[j1], Y[j1]) ) with scan_line
                 }
                 #endif
                 #pragma nopretty
                 
                 */
                 
                 /*
                 
                      [Foley90] Foley, J.D., A. van Dam, S.K. Feiner, and J.F. Hughs, Computer
                      Graphics Principles and Practice, Second Edition, Addison-Wesley, Reading,
                      1990, 92-99
                 
                      [Gordon94] Gordon, D., M.A. Peterson, and R.A. Reynolds, "Fast Polygon Scan
                      Conversion with Medical Applications," IEEE Computer Graphics and
                      Applications, 14(6), November 1994, 20-27
                 
                 
                 */

