#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop

#define MODULE_NAME "WINTRAC.CPP"
/*******************|*******************************************//*
/*                  W I N T R A C   . C P P                    *//*
/*-------------------------------------------------------------*//*
/*    Fonction       : Outils graphiques                       *//*
/*                                                             *//*
/* Fichier source WINTRAC .CPP                                 *//*
/* (contient les objets internes                               *//*
/*  et les corps des objets  exporter)                        *//*
/*-------------------------------------------------------------*//*
/*    Auteur         : Baptise MARCEL                          *//*
/*    Dvelopp le   : printemps 1996                          *//*
/***************************************************************/
/*
// Inclusions bibliothques standards
#include <complex.h>
#include <math.h>
#include <stdio.h>

//  Inclusions bibliothques Object Windows
#include <owl\point.h>
// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wsysutil.h"
#include "wappbase.h"
#include "wmain.h"
*/
//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "wintrac.h"
//#include "wirisctr.h"
//#include "scaltool.h"
/*-------------------------------------------------------------*/
/*		       constantes locales                      */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	              variables  exporter                     */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		       variables locales                       */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*                   Nouvelle classe TAssociatif                           */
/*--Systme----------------------------------------------------------------*/
/*-------------------------------------------------------------------------*/
/*                   Nouvelle classe TTraceurCourbe                        */
/*--Systme----------------------------------------------------------------*/
TTraceurCourbe::TTraceurCourbe(TWindow* parent, char *szTitre, char cType):
                  TAssociatif(parent,szTitre,cType),rep(),rZoneTracage()
  {
  fConsistance=FAUX;
  puCourbe=NULL;
  wNbElements=0;
  uRepMin=0, uRepMax=255, uOrdre=1;
  strcpy(szAbscisse,"");
  strcpy(szOrdonnee,"");
  xEtiqMin=0.0;xEtiqMax=1.0;yEtiqMin=0.0;yEtiqMax=1.0;
  xPremGrad=0.0; yPremGrad=0.0; xEcartGrad=1.0; yEcartGrad=1.0;
  fLegendePresente=FAUX;
  if (fLegendePresente)
    rZoneTracage=CoordFenTrac(TRect(TPoint(0,0),sEspaceUtile));
  else
    rZoneTracage=TRect(TPoint(0,0),sEspaceUtile);
  complex xyOrg(rZoneTracage.BottomLeft().x,rZoneTracage.BottomLeft().y);
  complex ux, uy;
  if (xEtiqMax!=xEtiqMin)
    ux=complex((float)rZoneTracage.Width()/(xEtiqMax-xEtiqMin),0.0);
  else
    ux=complex((float)rZoneTracage.Width()/0.000001,0.0);
  if (yEtiqMax!=yEtiqMin)
    uy=complex(0.0,-(float)rZoneTracage.Height()/(yEtiqMax-yEtiqMin));
  else
    uy=complex(0.0,-(float)rZoneTracage.Height()/0.000001);
  rep.SetRa(xyOrg,ux,uy);
  }
TTraceurCourbe::~TTraceurCourbe()
  {
  NouvelleCourbe();
  }
void TTraceurCourbe::Paint(TDC& dc, BOOL erase, TRect& rect)
  {
  TAssociatif::Paint(dc,erase,rect);
  if (wNbElements && puCourbe && fConsistance)
    {
    if (fLegendePresente)
      TraceLgdedCourbe(puCourbe, wNbElements, TRect(TPoint(0,0),sEspaceUtile), dc,
        szAbscisse,szOrdonnee,xEtiqMin,xEtiqMax,yEtiqMin,yEtiqMax,uRepMin, uRepMax,
        xPremGrad, yPremGrad, xEcartGrad, yEcartGrad, uOrdre, &rZoneTracage,
        &rep);
    else
      {
      rZoneTracage=TRect(TPoint(0,0),sEspaceUtile);
      TraceSplCourbe(puCourbe, wNbElements, rZoneTracage, dc,
          uRepMin, uRepMax, uOrdre,&rep);
      }
    }
  else
    rep.SetRa();
  }
void TTraceurCourbe::EvMouseMove(UINT, TPoint& point)
  {
  char szTamp0[120];

  complex xyPosSouris=rep.Rb2Ra(point);
/*  complex xyPosSouris((-real(xyOrg)+point.x)/rZoneTracage.Width()*(xEtiqMax-xEtiqMin)+xEtiqMin,
                       -(-imag(xyOrg)+point.y)/rZoneTracage.Height()*(yEtiqMax-yEtiqMin)+yEtiqMin); */
  if (uOrdre==0)
    sprintf(szTamp0, "X=%d,Y=%f", NFloorR(real(xyPosSouris)),imag(xyPosSouris));
  else
    {
    unsigned char uNbChar=4;
// Le nombre de dcimales dpend de la gradeur  afficher.
    sprintf(szTamp0, "X=%.*f,Y=%.5f",
            (uNbChar-NReduceR(ceil(log10(1e-15+fabs(real(xyPosSouris)))),1,uNbChar)),
            real(xyPosSouris),
            imag(xyPosSouris));
    }
  pZ1->SetText(szTamp0);
  }

void TTraceurCourbe::GenereMenuFlottant(TPopupMenu *pmnuFlot)
  {
  TAssociatif::GenereMenuFlottant(pmnuFlot);
  if (pmnuFlot)
    {
    if (uOrdre!=0)
      pmnuFlot->AppendMenu(MF_STRING, CM_ORDRE0, "Interpolation d'ordre 0");
    if (uOrdre!=1)
      pmnuFlot->AppendMenu(MF_STRING, CM_ORDRE1, "Interpolation linaire");
    }
  }

DEFINE_RESPONSE_TABLE1(TTraceurCourbe, TAssociatif)
  EV_COMMAND_AND_ID(CM_ORDRE0, CmChangeOptions),
  EV_COMMAND_AND_ID(CM_ORDRE1, CmChangeOptions),
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;
/*--Nouvelles fonctionnalits--------------------------------------------*/
void TTraceurCourbe::CmChangeOptions(WPARAM id)
  {
  switch (id)
    {
    case CM_ORDRE0 :
      uOrdre=0;
      break;
    case CM_ORDRE1 :
      uOrdre=1;
      break;
    }
  Invalidate();
  }

BIT TTraceurCourbe::NouvelleCourbe(unsigned int wNbElements_user)
  {
  if (!wNbElements_user && puCourbe)
    return fConsistance=ECHEC;
  if (puCourbe)
    free(puCourbe);
  if (wNbElements_user)
    {
    wNbElements=wNbElements_user;
    puCourbe = (unsigned char *)malloc(wNbElements);
    return (fConsistance=(puCourbe != NULL));
    }
  else
    {
    fConsistance=FAUX;
    wNbElements=0;
    puCourbe = NULL;
    return SUCCES;
    }
  }


/*-------------------------------------------------------------*//*
/*	              fonctions  exporter                     *//*
/*-------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/* CoordFenTrac (Coordonnes de la fentre de traage)
  Fonction qui reoit les coordonnes d'une fentre graphique et rend les
coordonnes de la fentre interne dans laquelle on peut tracer une courbe en
tenant compte des lgendes.
*/
TRect CoordFenTrac(TRect fen)
  {
  TRect sousfen(fen);
  sousfen.left += 3*uLargeurCar;
  sousfen.top += uHauteurLigne;
  sousfen.right += -uLargeurCar;
  sousfen.bottom += -uHauteurLigne;
  return sousfen;
  }
/*-------------------------------------------------------------*/
BIT TraceLgdedCourbe(unsigned char *puCourbe, unsigned int l,
		     TRect rEspace, TDC& dc,
                     char *szAbscisse, char *szOrdonnee,
                     float xEtiqMin, float xEtiqMax,
                     float yEtiqMin, float yEtiqMax,
                     unsigned char uRepMin, unsigned char uRepMax,
                     float xPremGrad, float yPremGrad,
                     float xEcartGrad, float yEcartGrad,
                     unsigned char uOrdre,
                     TRect *prTrace,
                     TReperage *prepTrace)
  {
//  Trace("TraceLgdedCourbe ",szOrdonnee,213);
  TRect rTrace=CoordFenTrac(rEspace);
  if (prTrace)
    *prTrace=rTrace;
  float xMargeDrGrad= (uOrdre==0 && l>1)?(xEtiqMax-xEtiqMin)*((float)l/(l-1)-1.0):0.0;
  return TraceLegende(rEspace,dc,szAbscisse,szOrdonnee,
                      xEtiqMin,xEtiqMax,yEtiqMin,yEtiqMax,
                      xPremGrad,yPremGrad,xEcartGrad,yEcartGrad,
                      xMargeDrGrad,prepTrace)
         && TraceSplCourbe(puCourbe,l,rTrace,dc,uRepMin,uRepMax,uOrdre);
  }
BIT TraceLegende(TRect rEspace, TDC& dc,
                 char *szAbscisse, char *szOrdonnee,
                 float xEtiqMin, float xEtiqMax,
                 float yEtiqMin, float yEtiqMax,
                 float xPremGrad, float yPremGrad,
                 float xEcartGrad, float yEcartGrad, float xMargeDrGrad,
                 TReperage *prep)
  {
//  Trace("TraceLegende ",szOrdonnee,247);
  TRect rTrace=CoordFenTrac(rEspace);
  dc.SetBkMode(TRANSPARENT);
  dc.MoveTo(rTrace.BottomLeft());
  dc.LineTo(rTrace.BottomRight());
  dc.MoveTo(rTrace.BottomLeft());
  dc.LineTo(rTrace.TopLeft());
// Flche X :
  dc.MoveTo(rTrace.BottomRight().OffsetBy(-2,-2));
  dc.LineTo(rTrace.BottomRight());
  dc.LineTo(rTrace.BottomRight().OffsetBy(-3,3));
// Flche Y :
  dc.MoveTo(rTrace.TopLeft().OffsetBy(-2,2));
  dc.LineTo(rTrace.TopLeft());
  dc.LineTo(rTrace.TopLeft().OffsetBy(3,3));
// Etiquettes d'axes.
  UINT mode=dc.SetTextAlign(TA_TOP | TA_CENTER);
  TPoint BottomMiddle((rTrace.left+rTrace.right)/2,rTrace.bottom);
  dc.TextOut(BottomMiddle,szAbscisse);
  dc.SetTextAlign(TA_BOTTOM | TA_LEFT);
  dc.TextOut(rTrace.TopLeft(),szOrdonnee);

  float xDyn=xEtiqMax-xEtiqMin+xMargeDrGrad;
  float yDyn=yEtiqMax-yEtiqMin;
  if (xDyn==0.0 || yDyn==0.0)
    {
    MTrace("Dynamique nulle lors du trac.",256);
    if (prep)
      prep->SetRa(complex(0.0,0.0),
        complex(1.0,0.0),
        complex(0.0,1.0));
    return ECHEC;
    }

  char szTamp0[USUALMAXLENSTRING];
  if (prep)
    prep->SetRa(complex(rTrace.left,rTrace.bottom),
        complex((float)rTrace.Width()/xDyn,0.0),
        complex(0.0,-(float)rTrace.Height()/yDyn));
  float xMargeDrGradLoc=xMargeDrGrad/xDyn*rTrace.Width();
  float xPremGradLoc=(xPremGrad-xEtiqMin)/xDyn*rTrace.Width();
  float yPremGradLoc=(yPremGrad-yEtiqMin)/yDyn*rTrace.Height();
  float xEcartGradLoc=xEcartGrad/xDyn*rTrace.Width();
  float yEcartGradLoc=yEcartGrad/yDyn*rTrace.Height();

  dc.SetTextAlign(TA_TOP | TA_RIGHT);
  dc.TextOut(rTrace.TopLeft(),gcvt(yEtiqMax,4,szTamp0));
  dc.SetTextAlign(TA_BOTTOM | TA_RIGHT);
  dc.TextOut(rTrace.BottomLeft(),gcvt(yEtiqMin,4,szTamp0));
  dc.SetTextAlign(TA_TOP | TA_LEFT);
  dc.TextOut(rTrace.BottomLeft(),gcvt(xEtiqMin,4,szTamp0));
  dc.SetTextAlign(TA_TOP | TA_RIGHT);
  dc.TextOut(rTrace.BottomRight().OffsetBy(NFarRoundR(-xMargeDrGradLoc),0),gcvt(xEtiqMax,4,szTamp0));
  dc.SetTextAlign(mode);
  unsigned int i=0;
  float xyGradLoc=0.0;
  while ((xyGradLoc=xPremGradLoc+i*xEcartGradLoc) >= 0.0 && xyGradLoc <= rTrace.Width())
    {
    dc.MoveTo(rTrace.BottomLeft().OffsetBy(NFarRoundR(xyGradLoc),2));
    dc.LineTo(rTrace.BottomLeft().OffsetBy(NFarRoundR(xyGradLoc),-2));
    i++;
    }
  i=0;
  while ((xyGradLoc=yPremGradLoc+i*yEcartGradLoc) >= 0.0
         && xyGradLoc <= rTrace.Height())
    {
    dc.MoveTo(rTrace.BottomLeft().OffsetBy(-2,-NFarRoundR(xyGradLoc)));
    dc.LineTo(rTrace.BottomLeft().OffsetBy(2,-NFarRoundR(xyGradLoc)));
    i++;
    }
  return SUCCES;
  }
BIT TraceSplCourbe(unsigned char *puCourbe, unsigned int l,
		     TRect rTrace, TDC& dc,
                     unsigned char uRepMin, unsigned char uRepMax,
                     unsigned char uOrdre,
                     TReperage *prep)
  {
//  Trace("TraceSplCourbe ",rTrace,247);
  unsigned int i=0;

  if (puCourbe==NULL)
    return MErreur("Trac d'une courbe vide", 2575);
  else if (!l)
    return SUCCES;
  else if (uOrdre != 0 && uOrdre != 1)
    return MErreur("Ordre d'interpolation inconnu.", 401);
  TReperage rep;
  if (uOrdre==0)
    {
    rep.SetRa(complex(rTrace.left,rTrace.bottom),
           complex((float)rTrace.Width()/l,0.0),
           complex(0.0,-(float)rTrace.Height()/(uRepMax-uRepMin)));
    dc.MoveTo(rep.NRa2Rb(0.0,0.0));
    for (i=0;i<l;i++)
      {
      dc.LineTo(rep.NRa2Rb(i,NReduceN(puCourbe[i]-uRepMin,0,uRepMax-uRepMin)));
      if (puCourbe[i] > uRepMax)
        dc.MoveTo(rep.NRa2Rb(i+1,NReduceN(puCourbe[i]-uRepMin,0,uRepMax-uRepMin)));
      else
        dc.LineTo(rep.NRa2Rb(i+1,NReduceN(puCourbe[i]-uRepMin,0,uRepMax-uRepMin)));
      }
    }
  else if (uOrdre==1)
    {
    if (l==1)
      {
      rep.SetRa(complex(rTrace.left,rTrace.bottom),
             complex((float)rTrace.Width(),0.0),
             complex(0.0,-(float)rTrace.Height()/(uRepMax-uRepMin)));
      dc.MoveTo(rep.NRa2Rb(rTrace.left,max(0,(int)puCourbe[0]-uRepMin)));
      dc.LineTo(rep.NRa2Rb(rTrace.right,max(0,(int)puCourbe[0]-uRepMin)));
      }
    else
      {
      rep.SetRa(complex(rTrace.left,rTrace.bottom),
             complex((float)rTrace.Width()/(l-1),0.0),
             complex(0.0,-(float)rTrace.Height()/(uRepMax-uRepMin)));
      TPoint *pptCourbe=(TPoint *)malloc(l*sizeof(TPoint));
      if (!pptCourbe)
        return MErreur("Allocation impossible", 502);
      for (i=0;i<l;i++)
        pptCourbe[i]=rep.NRa2Rb(i, max(0,(int)puCourbe[i]-uRepMin));
      dc.Polyline(pptCourbe,l);
      free(pptCourbe);
      }
    }
  else
    return MErreur("Ordre d'interpolation inconnu.", 401);
  if (prep)
    *prep=rep;
  return SUCCES;
  }
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/

