/*******************|*******************************************/
/*                  W I N T R A C   . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils graphiques                       */
/*                                                             */
/* Fichier prototype WINTRAC .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : printemps 1996                          */
/***************************************************************/
#ifndef WINTRAC_H
#define WINTRAC_H

#include "base.h"
#include "scaltool.h"
#include "wmain.h"

/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define CM_ORDRE0        650
#define CM_ORDRE1        651
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
TRect CoordFenTrac(TRect fen);
BIT TraceSplCourbe(unsigned char *puCourbe, unsigned int l,
		     TRect rTrace, TDC& dc,
                     unsigned char uRepMin=0, unsigned char uRepMax=255,
                     unsigned char uOrdre=1,
                     TReperage *prepTrace=NULL);
BIT TraceLegende(TRect rEspace, TDC& dc,
                     char *szAbscisse, char *szOrdonnee,
                 float xEtiqMin=0.0, float xEtiqMax=1.0,
                 float yEtiqMin=0.0, float yEtiqMax=1.0,
                 float xPremGrad=0.0, float xPremGrady=0.0,
                 float yEcartGrad=1.0, float yEcartGrady=1.0,
                 float xMargeDrGrad=0.0,
                 TReperage *prepTrace=NULL);
BIT TraceLgdedCourbe(unsigned char *puCourbe, unsigned int l,
		     TRect rEspace, TDC& dc,
                     char *szAbscisse, char *szOrdonnee,
                     float xEtiqMin=0.0, float xEtiqMax=1.0,
                     float yEtiqMin=0.0, float yEtiqMax=1.0,
                     unsigned char uRepMin=0, unsigned char uRepMax=255,
                     float xPremGrad=0.0, float xPremGrady=0.0,
                     float yEcartGrad=1.0, float yEcartGrady=1.0,
                     unsigned char uOrdre=1,
                     TRect *prTrace=NULL,
                     TReperage *prepTrace=NULL);

/*class TAssociatif : public TFramePrint
  {
  public:
    TAssociatif(TWindow* parent, char szTitre[], char cType,
                         TWindow* clientWnd = 0,
                         bool shrinkToClient = true, TModule* module = 0);
    BIT fConsistance;
  protected:
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void EvRButtonDown(UINT, TPoint&);
    virtual void EvMouseMove(UINT a, TPoint& point);
    TSize sEspaceUtile;
    DECLARE_RESPONSE_TABLE(TAssociatif);
 }; */
class TTraceurCourbe : public TAssociatif
  {
  public:
    BIT fConsistance;
    unsigned char *puCourbe;
    unsigned int wNbElements;
    unsigned char uRepMin, uRepMax, uOrdre;
    char szAbscisse[USUALMAXLENSTRING], szOrdonnee[USUALMAXLENSTRING];
    float xEtiqMin,xEtiqMax,yEtiqMin,yEtiqMax;
    float xPremGrad, yPremGrad, xEcartGrad, yEcartGrad;
    BIT fLegendePresente;
    TRect rZoneTracage;
    TReperage rep;
    TTraceurCourbe(TWindow* parent, char szTitre[], char cType);
    ~TTraceurCourbe();
    BIT NouvelleCourbe(unsigned int wNbElements_user=0);
  protected:
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void EvMouseMove(UINT, TPoint& point);
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    void CmChangeOptions(WPARAM id);
    DECLARE_RESPONSE_TABLE(TTraceurCourbe);
 };
#endif // WINTRAC_H


