#include "baptiall.h"
#include "cattoall.h"

#pragma hdrstop

#define MODULE_NAME "WIRIS.CPP"

#pragma (exestr,"Iris, copyright GTTSI-Baptiste Marcel 1995-1996-1997. All rights reserved.")

/**********************************************************************/
/*                       W I R I S       . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions conversationnelles pour Iris         */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      */
/*    Dvelopp le   : Printemps 1996                                 */
/*    Dernire modif.: voir date fichier                              */
/**********************************************************************/
/*
   // Inclusions bibliothques standards
   #include <dir.h>
   #include <io.h>
   #include <math.h>
   #include <values.h>
   
   //  Inclusions bibliothques Object Windows
   #include <owl\applicat.h>
   #include <owl\inputdia.h>
   #include <owl\combobox.h>
   #include <owl\scroller.h>
   
   // Inclusions bibliothques DOS
   #include <stdio.h>
   
   // Inclusion bibliothques Image
   #include "wsysutil.h"
   #include "wappbase.h"
   #include "wgttsi.h"
   #include "wmain.h"
   
   #include "wmaiconv.h"
   */
//  Inclusions bibliothques Iris
#include "anlfreq.h"
#include "anallec.h"
#include "base.h"
#include "contour.h"
#include "piadiv.h"
#include "scaltool.h"
#include "strutil.h"
#include "sysctr.h"
#include "symbole.h"
#include "wgeometr.h"
#include "wintrac.h"
#include "wiris.h"
#include "wirslign.h"
#include "wirssymb.h"
#include "wirsutil.h"
#include "wsystool.h"
#include "iris.rc"

//  Inclusions bibliothques Sbastien
#include "cortex.rch"
#include "wcortex.h"
#include "ctxoutil.h"

//-----------------------------------------------------------------------
/*                     Variables globales                                */
//-----------------------------------------------------------------------
TFenIris      *pFenetreIris = NULL ;
TAppIris      *pApplicationIris = NULL ;
TCadIris      *pCadreIris = NULL ;
char          far szImageAccueil [MAXPATH] = ""
  , szImageAccueilDef [MAXPATH] = "", szRepertoireDepartDef [MAXDIR] = "."
  , szNomTraceurDef [MAXPATH] = "iris.tmp"
  , szHardCopyFileNameDef [MAXPATH] = "hardcopy.img"
  , szReportFileDef [MAXPATH] = "report.txt";
//unsigned int wCommandePredefinie= 0;
unsigned char fRecordCommand = FAUX ;

int seuilzcTeXDef=60, seuil1Def=70, seuil2Def=140, seuil3Def=140;

int           fSauvegardeAuto = ARRET /* , fSauvegardeAutoDef = OFF */
  , fTracageDef = OFF, fRubansDef = ON, fFullScreenStartDef = ON
  , wPreselectedCommandDef = 0, fHardCopyDef = OFF, fDemarrCommandDef=OFF ;
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
/*                     Classe Fenetre (TFenIris)                         */
/*--Systme--------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1 (TFenIris, TFen) EV_COMMAND_AND_ID (
    CM_GradRect, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_GradXY, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_GradGTh, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_Laplacien, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_ZCLaplacien, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_RechercheRestauLignes, CmMenuLignes)
  , EV_COMMAND_AND_ID (CM_RechercheSymbole, CmMenuLignes)
  , EV_COMMAND_AND_ID (CM_ContourPourChainage, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_ChainageIteratif, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_Amincissement, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_ContourEtChainage, CmMenuContour)
  , EV_COMMAND_AND_ID (CM_UtilitaireLignes, CmMenuLignes)
  , EV_COMMAND_AND_ID (CM_ComposeLignes, CmMenuLignes)
  , EV_COMMAND_AND_ID (CM_RechercheLignes, CmMenuLignes)
  , EV_COMMAND_AND_ID (CM_MultScal, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_MultScal128, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_ValAbs128, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_MorphoLevel, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_EstimateurDeCoin, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_AutoSeuil, CmPrimitivesImages)
  , EV_COMMAND_AND_ID (CM_PointageDeCoin, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_Predefinie, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_DemarrScript, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_EnregComm, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_DemarrComm, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_TextEditReport, CmMenuEnvironnement)

  , EV_COMMAND_AND_ID (CM_UtilitaireSymbole, CmMenuSymboles)
  , EV_COMMAND_AND_ID (CM_ChargeSymbole, CmMenuSymboles)
  , EV_COMMAND_AND_ID (CM_LectureSymbole, CmMenuSymboles)
  , EV_COMMAND_AND_ID (CM_SymbolComp, CmMenuSymboles)
  , EV_COMMAND_AND_ID (CM_SymbolReport, CmMenuSymboles)
  , EV_COMMAND_AND_ID (CM_RechercheLectureSymbole
    , CmRechercheLectureSymbole)
  , EV_COMMAND_AND_ID (CM_RechercheLectureSymboleEtAl
    , CmRechercheLectureSymbole)
  , EV_COMMAND_AND_ID (CM_ValidCOURBE, CmDiversTraceurs)
  , EV_COMMAND_AND_ID (CM_ValidScalaire, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_Valid1, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_Valid2, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_ValidAnalyseFreqLigne, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_AnalyseFreqQuad, CmDiversValide)
  , EV_COMMAND_AND_ID (CM_SauvegOptionsAuto, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_SauvegOptionsMaintenant, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_Tracage, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_Ruban, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_DemPleinEcr, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_ImageAccueil, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_HardCopyFile, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (ID_SaveImageAsBMP, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (ID_SaveImageAsIMG, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_ForceExit, CmMenuEnvironnement)
  , EV_COMMAND_AND_ID (CM_SEB_PREVIEW, CmMenuSebastien)
  , EV_COMMAND_AND_ID (CM_SEB_LOUPE, CmMenuSebastien)
  , EV_COMMAND_AND_ID (CM_SEB_REDUCTION, CmMenuSebastien)
  , EV_COMMAND_AND_ID (CM_REDUCTION, CmMenuSebastien)
  , EV_COMMAND_AND_ID (CM_AGRANDISSEMENT, CmMenuSebastien)
  , //	EV_COMMAND_AND_ID(CM_VISU, CmMenuSebastien),
    EV_WM_RBUTTONDOWN
  , END_RESPONSE_TABLE ;

TFenIris::TFenIris ()
  : TFen(NULL)
{
CalculeCaracteristiquesPolice(this);
pftDefaultArial      =  new TFont("Arial", uHauteurLigne);
Attr.Style           |= WS_HSCROLL | WS_VSCROLL ;
Scroller             
  =  new TScroller(this, 5, 5, iLargeurEcran / 5
    , iHauteurEcran / 5);
Scroller -> AutoMode =  TRUE ;
Scroller -> SetSBarRange();
pFenetreIris     =  this ;
pFenetreControle =  this ;
fEtatAscenseurs  =  ARRET ;
fDemarrCommand   =  FALSE ;
pmnuConfigIris   
  =  new TMenu((HINSTANCE)(*((TApplication *)pApplicationIris))
    , "ConfigIris");
pmnuApplications 
  =  new TMenu((HINSTANCE)(*((TApplication *)pApplicationIris))
    , "TraitementIris");
pmnuContours     
  =  new TMenu((HINSTANCE)(*((TApplication *)pApplicationIris))
    , "Contours");
pmnuIrisTools    
  =  new TMenu((HINSTANCE)(*((TApplication *)pApplicationIris))
    , "IrisTools");
}

void TFenIris::EvRButtonDown ( UINT, TPoint &p )
{
TPopupMenu  mnu_fl ; // crer un objet "menu flottant"

mnu_fl.AppendMenu(MF_STRING, CM_REDUCTION, "&Rduction"); // articles du menu flottant
mnu_fl.AppendMenu(MF_STRING, CM_AGRANDISSEMENT, "&Loupe");

//  mnu_fl.AppendMenu(MF_STRING, CM_VISU, "&Preview");
ClientToScreen(p);
mnu_fl.TrackPopupMenu(TPM_RIGHTBUTTON, p, 0, HWindow, NULL);
}

void TFenIris::SetupWindow ()
{
TFen::SetupWindow();
ChargeOptions();
ActiveTracage(fTracage);
FileData.InitialDir =  szRepertoireDepart ;

TSystemMenu mnuSys(Parent -> HWindow);

mnuSys.AppendMenu(MF_SEPARATOR);
mnuSys.AppendMenu(MF_STRING, ID_Ascenseurs, "Ascenseurs");

//  TMenu mnuPrincipal= TMenu(*Cadre);
//  TMenu mnuConfiguration(pmnuPrincipal->GetSubMenu(NumeroApplication));
// Lettres rserves GTTSI : I, M, O, C, T et  A.
pmnuPrincipal -> InsertMenu(NumeroApplication, MF_POPUP | MF_BYPOSITION
  , *pmnuContours, "Co&ntours");
pmnuPrincipal -> InsertMenu(NumeroApplication + 1, MF_POPUP | MF_BYPOSITION
  , *pmnuApplications, "I&ris");

// Lettres rserves GTTSI pour menu config. : M et P.
pmnuConfiguration -> AppendMenu(MF_POPUP, *pmnuConfigIris, "&Iris");
pmnuOutils -> AppendMenu(MF_SEPARATOR);
AppendWoleMenu(pmnuIrisTools, pmnuOutils);

//  unsigned char *puSource=source;
for ( unsigned char u = 0 ; u < nbplan ; u++ ) 
  Eff(PlanSuiv(source, u));
unlink(szReportFile);
InterpretCommandLine(); // Rgles quelques paramtres  partir de la ligne de commandes.
PostMessage(WM_COMMAND, CM_DemarrScript); // Appel (post) de la fonction qui excute (sent) les commandes prdfinies.
}

TFenIris::~TFenIris ()
{
if ( fSauvegardeAuto ) 
  SauvegardeOptions(); //  delete plwCommandesPredefinies;
                      /*  if (pLooper)
                         pLooper->ShutDownWindow();*/ 
}

//-----------------------------------------------------------------------
/*                     Classe application (TAppIris)                     */
/*--Systme--------------------------------------------------------------*/
TAppIris::TAppIris ()
  : TApp()
{
pApplicationIris =  this ;
fDemarrPleinEcr  
  =  GetPrivateFlag("options", "dmarrage plein cran"
    , fFullScreenStartDef, szINIFileName);
}

void TAppIris::InitMainWindow ()
{
TApp::InitMainWindow();
nCmdShow =  fDemarrPleinEcr ? SW_SHOWMAXIMIZED : SW_SHOW ;
pCadreIris -> SetIcon(this, "UBI_DM_SCAN");
}

//-----------------------------------------------------------------------
/*                     Classe Cadre (TCadIris)                           */
/*--Systme--------------------------------------------------------------*/
TCadIris::TCadIris ( TWindow *Parent, char far *Title, TWindow *Client
    , BOOL trackMenuSelection )
  : TCad(Parent, Title, Client, trackMenuSelection)
{
pCadreIris =  this ;
Attr.X     =  0 ;
Attr.Y     =  0 ;
Attr.H     =  iHauteurEcran / 2 ;
Attr.W     =  iLargeurEcran ;
}

DEFINE_RESPONSE_TABLE1 (TCadIris, TCad) EV_WM_SIZE, EV_WM_SYSCOMMAND
  , EV_WM_INITMENUPOPUP, END_RESPONSE_TABLE ;

void TCadIris::EvSysCommand ( UINT cmdType, TPoint &p_l )
{
if ( cmdType == ID_Ascenseurs ) 
  pFenetreIris -> Ascenseurs();
else if ( cmdType == ID_DetruitUtilitaire ) 
  {
  if ( TUtilPtr ) 
    TUtilPtr -> ShutDownWindow();
  }
else 
  TCad::EvSysCommand(cmdType, p_l);
}

void TCadIris::EvSize ( UINT sizeType, TSize &size )
{
static BIT  fGrandeTaille = VRAI ;

TCad::EvSize(sizeType, size);
if ( sizeType == SIZE_RESTORED ) 
  {
  if ( fGrandeTaille ) // Passage en petite taille.
                        {
                        pFenetreIris -> Ascenseurs(MARCHE);
                        fGrandeTaille =  FAUX ;
                        }
  }
else if ( sizeType == SIZE_MAXIMIZED ) // Passage en grande taille.
                                        {
                                        pFenetreIris -> Ascenseurs(ARRET);
                                        fGrandeTaille =  VRAI ;
                                        pFenetreIris -> Scroller
                                          -> ScrollTo(
                                          0, 0);
                                        }
}

void TCadIris::EvInitMenuPopup ( HMENU hPopupMenu, UINT index, BOOL sysMenu )
{
TCad::EvInitMenuPopup(hPopupMenu, index, sysMenu);
if ( (HMENU)(*(pFenetreIris -> pmnuConfigIris)) == hPopupMenu ) 
  {
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_Tracage
    , fTracage ? MF_CHECKED : MF_UNCHECKED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_Ruban
    , fRuban ? MF_CHECKED : MF_UNCHECKED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_DemPleinEcr
    , fDemarrPleinEcr ? MF_CHECKED : MF_UNCHECKED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_HardCopyFile
    , fHardCopy ? MF_CHECKED : MF_UNCHECKED);
  
  //    pFenetreIris->pmnuConfigIris->EnableMenuItem(CM_HardCopyFile,fRuban ? MF_GRAYED:MF_ENABLED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_SauvegOptionsAuto
    , fSauvegardeAuto ? MF_CHECKED : MF_UNCHECKED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_ImageAccueil
    , *szImageAccueil ? MF_CHECKED : MF_UNCHECKED);
  pFenetreIris -> pmnuConfigIris -> CheckMenuItem(CM_DemarrComm
    , pFenetreIris -> fDemarrCommand ? MF_CHECKED : MF_UNCHECKED);
  }
}

//-----------------------------------------------------------------------
//                     Classe Fenetre (TFenIris)
//--Nouvelles fonctionalits---------------------------------------------
int TFenIris::ChargeOptions ( void )
{
GetPrivateString("localisations", "rapports", szReportFileDef, szReportFile
  , sizeof(szReportFile), szINIFileName);
GetPrivateString("localisations", "accueil", szImageAccueilDef
  , szImageAccueil, sizeof(szImageAccueil), szINIFileName);
GetPrivateString("localisations", "rpertoire", szRepertoireDepartDef
  , szRepertoireDepart, sizeof(szRepertoireDepart), szINIFileName);
GetPrivateString("localisations", "nom traceur", szNomTraceurDef
  , szNomTraceur, sizeof(szNomTraceur), szINIFileName);
  {
  char  szSymbolPathDef [MAXPATH], szSymbolPath [MAXPATH];
  fnmerge(szSymbolPathDef, szSymbolDrive, szSymbolDir, "", "");
  GetPrivateString("localisations", "symboles", szSymbolPathDef, szSymbolPath
    , sizeof(szSymbolPath), szINIFileName);
  char  szName [MAXFILE], szExt [MAXEXT];
  fnsplit(szSymbolPath, szSymbolDrive, szSymbolDir, szName, szExt); // We know this is a directory, the last directory of the path will be put in szName.
  strNcat(szSymbolDir, szName, sizeof(szSymbolDir)); // Place the last directory in the SymbolDir string.
  }
  {
  char  szImagePathDef [MAXPATH], szImagePath [MAXPATH];
  fnmerge(szImagePathDef, szImageDrive, szImageDir, "", "");
  GetPrivateString("localisations", "images", szImagePathDef, szImagePath
    , sizeof(szImagePath), szINIFileName);
  char  szName [MAXFILE], szExt [MAXEXT];
  fnsplit(szImagePath, szImageDrive, szImageDir, szName, szExt);
  strNcat(szImageDir, szName, sizeof(szImageDir)); // Se upstairs.
  }
  {
  char  szScriptPath [MAXPATH], szScriptPathDef [MAXPATH];
  fnmerge(szScriptPathDef, szScriptDrive, szScriptDir, "", "");
  GetPrivateString("localisations", "symboles", szScriptPathDef, szScriptPath
    , sizeof(szScriptPath), szINIFileName);
  char  szName [MAXFILE], szExt [MAXEXT];
  fnsplit(szScriptPath, szScriptDrive, szScriptDir, szName, szExt); // We know this is a directory, the last directory of the path will be put in szName.
  strNcat(szScriptDir, szName, sizeof(szScriptDir)); // Place the last directory in the ScriptDir string.
  }
fTracage        
  =  GetPrivateFlag("options", "traage", fTracageDef
    , szINIFileName);
fRuban          
  =  GetPrivateFlag("options", "ruban", fRubansDef
    , szINIFileName);
fSauvegardeAuto 
  =  GetPrivateFlag("options", "sauvegarde automatique"
    , fSauvegardeAutoDef, szINIFileName);
wScriptLen  // Par dfaut: liste vide    
  =  GetPrivateIntList("options", "commandes prdfinies"
    , aiCommandesPredefinies, sizeof(aiCommandesPredefinies), szINIFileName);

/*  wCommandePredefinie=GetPrivateInt("options","commande predefinie",
   wPreselectedCommandDef,szINIFileName); */
fDemarrCommand  
  =  GetPrivateFlag("options", "dmarrage commande", fDemarrCommandDef
    , szINIFileName);
GetPrivateString("localisations", "nom copie physique"
  , szHardCopyFileNameDef, szHardCopyFile, sizeof(szHardCopyFile)
  , szINIFileName);
fHardCopy 
  =  GetPrivateFlag("options", "copie physique", fHardCopyDef
    , szINIFileName);
Visu [0]  
  =  GetPrivateInt("Cortex", "Contour de l'objet basse rsolution", VisuDef[0]
    , szINIFileName);
Visu [1]  
  =  GetPrivateInt("Cortex"
    , "Rsultat du dcodage de la chaine de Freeman", VisuDef[1] // 0
, szINIFileName);
Visu [2]  
  =  GetPrivateInt("Cortex", "Rsultat de la slection du quadrilatre"
    , VisuDef[2] // 0
	, szINIFileName);
Visu [3]  
  =  GetPrivateInt("Cortex"
    , "Rsultat de la correction du quadrilatre", VisuDef[3] // 2
	, szINIFileName);
Visu [4]  
  =  GetPrivateInt("Cortex", "Rsultat de la dtection", VisuDef[4] // 2
    , szINIFileName);
seuilzc   =  GetPrivateInt("Cortex", "Seuil ZC", seuilzcTeXDef, // 60
                                                          szINIFileName);
seuil1    
  =  GetPrivateInt("Cortex", "Seuil continuit", seuil1Def
    , // 70
      szINIFileName);
seuil2    
  =  GetPrivateInt("Cortex", "Seuil densit", seuil2Def, // 140
                                                      szINIFileName);
seuil3    
  =  GetPrivateInt("Cortex", "Seuil proximit", seuil3Def, // 140
                                                        szINIFileName);
return SUCCES ;
}

int TFenIris::SauvegardeOptions ( void )
{
char  szSymbolPath [MAXPATH], szImagePath [MAXPATH], szScriptPath [MAXPATH];

fnmerge(szSymbolPath, szSymbolDrive, szSymbolDir, "", "");
fnmerge(szImagePath, szImageDrive, szImageDir, "", "");
fnmerge(szScriptPath, szScriptDrive, szScriptDir, "", "");
return WritePrivateString("localisations", "accueil", szImageAccueil
          , szINIFileName)
        && WritePrivateString("localisations", "rapports", szReportFile
          , szINIFileName)
        && WritePrivateString("localisations", "rpertoire"
          , szRepertoireDepart, szINIFileName)
        && WritePrivateString("localisations", "nom traceur", szNomTraceur
          , szINIFileName)
        && WritePrivateString("localisations", "symboles", szSymbolPath
          , szINIFileName)
        && WritePrivateString("localisations", "images", szImagePath
          , szINIFileName)
        && WritePrivateString("localisations", "scripts", szScriptPath
          , szINIFileName)
        && WritePrivateFlag("options", "traage", fTracage, szINIFileName)
        && WritePrivateFlag("options", "ruban", fRuban, szINIFileName)
        && WritePrivateFlag("options", "dmarrage plein cran"
          , fDemarrPleinEcr, szINIFileName)
        && WritePrivateFlag("options", "sauvegarde automatique"
          , fSauvegardeAuto, szINIFileName)
        && WritePrivateIntList("options", "commandes prdfinies"
          , aiCommandesPredefinies, wScriptLen, szINIFileName)
        && WritePrivateFlag("options", "dmarrage commande"
          , fDemarrCommand, szINIFileName)
        && WritePrivateString("localisations", "nom copie physique"
          , szHardCopyFile, szINIFileName)
        && WritePrivateFlag("options", "copie physique", fHardCopy
          , szINIFileName)
        && WritePrivateInt("Cortex", "Contour de l'objet basse rsolution"
          , Visu [0], szINIFileName)
        && WritePrivateInt("Cortex"
          , "Rsultat du dcodage de la chaine de Freeman", Visu [1]
          , szINIFileName)
        && WritePrivateInt("Cortex"
          , "Rsultat de la slection du quadrilatre", Visu [2]
          , szINIFileName)
        && WritePrivateInt("Cortex"
          , "Rsultat de la correction du quadrilatre", Visu [3]
          , szINIFileName)
        && WritePrivateInt("Cortex", "Rsultat de la dtection", Visu [4]
          , szINIFileName)
        && WritePrivateInt("Cortex", "Seuil ZC", seuilzc, szINIFileName)
        && WritePrivateInt("Cortex", "Seuil continuit", seuil1, szINIFileName)
        && WritePrivateInt("Cortex", "Seuil densit", seuil2, szINIFileName)
        && WritePrivateInt("Cortex", "Seuil proximit", seuil3, szINIFileName);
}

void TFenIris::ChoisirImageAccueil ( void )
{
if ( (TFileOpenDialog(this, FileData)).Execute() == IDOK ) 
  {
  if ( RMN(FileData.FileName, destin) ) 
    {
    strcpy(szImageAccueil, FileData.FileName);
    Calsuiv();
    strcpy(TableFich [plan], szImageAccueil);
    Visim(this, 0, source);
    }
  }
else 
  *szImageAccueil =  0 ; // set to "".
WritePrivateString("localisations", "accueil", szImageAccueil
  , szINIFileName);
}

void TFenIris::CmDiversValide ( WPARAM id )
{
RecordCommand(id);

int u = 0 ;

//  TTraceurCourbe *pTraceurFreq, *pTraceurCrit;
switch ( id ) 
  {
  case CM_Valid1 : 
    {
    TQuadrilatere ABCD
      = GetPrivateQuad(STRING_TitreClasseLectureSymbole, "ABCD", QuadrilatereErreur
        , szINIFileName);
    if ( !ABCD.Pervers()
          && TransformationRaideVersMatriceCarree(ABCD, source
            , // image source 256*256
              destin
            , // matrice cible f*f
              256) ) 
      {
      Visim(this, 0, source);
      Visim(this, 1, destin);
      Calsuiv();
      }
    break ;
    }
  case CM_Valid2 : 
    {
    TPoint  pt ;
    if ( GetPointishValue(this, "Valide 8 classes", "coordonnes u,v", &pt) ) 
      Erreur("Classe ", Fast8ClasseArctan(pt.x, pt.y), 463);
    break ;
    }
  case CM_ValidScalaire : 
    if ( GetIntValue(this, "Valide Puissance de 2", "Entier  tester", &u) ) 
      {
      if ( EstUnePuissanceDe2(i2uc(u)) ) 
        MErreur("OUI", 0);
      else 
        MErreur("non", 0);
      }
    break ;
  case CM_ValidAnalyseFreqLigne : 
    (new TAnalyseLigne(this)) -> Create();
    break ;
  case CM_AnalyseFreqQuad : 
    (new TAnalyseQuad(this)) -> Create();
    break ;
  case CM_PointageDeCoin : 
    (new TDetecteCoin) -> Create();
    break ;
  default : MErreur("Erreur code", 229);
  }
}

void TFenIris::CmDiversTraceurs ( WPARAM id )
{
RecordCommand(id);

int             k ;
int             K = 10 ;
TTraceurCourbe  *pTraceurCourbe ;

(pTraceurCourbe = new TTraceurCourbe(this, "Courbe", ASS_DROITE)) -> Create();
switch ( id ) 
  {
  case CM_ValidCOURBE : 
    pTraceurCourbe -> NouvelleCourbe(K);
    for ( k = 0 ; k < K ; k++ ) 
      pTraceurCourbe -> puCourbe [k]
        =  i2uc(NReduceR(256.0 * cos((float)k / K * 4.0 * M_PI), 0, 255));
    pTraceurCourbe -> uRepMin          = 0 ;
    pTraceurCourbe -> uRepMax          = 255 ;
    pTraceurCourbe -> uOrdre           = 1 ;
    pTraceurCourbe -> fLegendePresente = VRAI ;
    strcpy(pTraceurCourbe -> szAbscisse, "theta");
    strcpy(pTraceurCourbe -> szOrdonnee, "sin(theta)");
    pTraceurCourbe -> xEtiqMin   = 0.0 ;
    pTraceurCourbe -> xEtiqMax   = 9.0 ;
    pTraceurCourbe -> yEtiqMin   = 0.0 ;
    pTraceurCourbe -> yEtiqMax   = 1.0 ;
    pTraceurCourbe -> xPremGrad  = 0.0 ;
    pTraceurCourbe -> yPremGrad  = 0.0 ;
    pTraceurCourbe -> xEcartGrad = 1 ;
    pTraceurCourbe -> yEcartGrad = 0.1 ;
    pTraceurCourbe -> Invalidate();
    break ;
  default : MErreur("Mauvais cas", 224);
  }
}

void TFenIris::CmMenuSebastien ( WPARAM id )
{
RecordCommand(id);
switch ( id ) 
  {
  case CM_SEB_PREVIEW : 
  
  /*    case CM_VISU:
     (new TPreview(this))->Create();
     break; */
  case CM_SEB_LOUPE : 
  case CM_AGRANDISSEMENT : 
    (new TLoupe(this)) -> Create();
    break ;
  case CM_SEB_REDUCTION : 
  case CM_REDUCTION : 
    (new TParametreProgramme("Rduction", 1, 255, 255, Reduction))
      -> Create();
    break ;
  default : ErreurCode(404);
  }
}

void TFenIris::CmMenuEnvironnement ( WPARAM id )
{
RecordCommand(id);
switch ( id ) 
  {
  case ID_SaveImageAsBMP : 
  case ID_SaveImageAsIMG : 
    {
    char  szPath [MAXPATH], szDrive [MAXDRIVE], szDir [MAXDIR]
      , szName [MAXFILE], szExt [MAXEXT];
    fnsplit(TableFich [plan], szDrive, szDir, szName, szExt);
    fnmerge(szPath, szDrive, szDir, szName
      , id == ID_SaveImageAsBMP ? "bmp" : "img");
    if ( id == ID_SaveImageAsBMP ) 
      Ecr_bmp(szPath, source);
    else 
      WMN(szPath, source);
    break ;
    }
  case CM_DemarrScript : 
    {
    unsigned int  wMemMessPause = wMessPause ;
    wMessPause =  0 ; // Coupe les messages d'erreur pendant l'excution du script
    if ( argc_ >= 2 && !access(argv_ [1], 04) ) 
      {
      
      // passage nom de fichier image; l'image charge dans TFen::SetupWindow, on excute la(les) commandes pour elle.
      if ( fDemarrCommand ) 
        
        // Utiliser sent.
        SendMessage(WM_COMMAND, CM_Predefinie); /* CM_DemarrScript a t appel par post. La fonction appelle mainetnant (send)
                                                   l'excuteur de commandes prdfinies.
                                                   */ 
      }
    else 
      {
      
      // Pas de fichier en paramtre, on excute la commande pour chaque image du masque d'accueil.
      char  szPath [MAXPATH], szDrive [MAXDRIVE], szDir [MAXDIR]
        , szName [MAXFILE], szExt [MAXEXT], szDriveCmp [MAXDRIVE]
        , szDirCmp [MAXDIR], szNameCmp [MAXFILE], szExtCmp [MAXEXT];
      fnsplit(szImageAccueil, szDrive, szDir, szName, szExt);
      struct ffblk sffblkImageAccueil ;
      if ( !findfirst(szImageAccueil, &sffblkImageAccueil, 0) ) 
        do 
          {
          int fBMP = 0 ;
          fnsplit(sffblkImageAccueil.ff_name, szDriveCmp, szDirCmp, szName
            , szExt); // ff_name : nom+"."+ext
          fnsplit(".bmp", szDriveCmp, szDirCmp, szNameCmp, szExtCmp);
          if ( !strcmpi(szExt, szExtCmp) ) 
            
            // sffblkImageAccueil.ff_name is *.BMP
            fBMP =  1 ;
          fnmerge(szPath, szDrive, szDir, szName, szExt);
          int fRes ;
          if ( fBMP ) 
            fRes =  Lec_bmp(szPath, destin);
          else 
            fRes =  RMN(szPath, destin);
          if ( fRes ) 
            {
            
            //              strcpy(TableFich[Numeroplan(destin)-'0'],sffblkImageAccueil.ff_name);
            strcpy(TableFich [Numeroplan(destin) - '0'], szPath);
            Calsuiv();
            }
          if ( fDemarrCommand ) 
            
            // Utiliser sent.
            SendMessage(WM_COMMAND, CM_Predefinie); // Appel (send) de la fonction CM_Predefinie qui excute (send) les commandes prdfinies.
          } 
        while ( !findnext(&sffblkImageAccueil) );
      
      // risque de non suivi dans un rpertoire distant
      Visim(this, 0, source);
      }
    wMessPause =  wMemMessPause ;
    break ;
    }
  case CM_TextEditReport :
    {
    char szL[256]="notepad ";
    strNcat(szL,szReportFile,sizeof(szL));
    WinExec(szL,SW_SHOWNORMAL);
    break;
    }
  case CM_DemarrComm : 
    fDemarrCommand = !fDemarrCommand ;
    break ;
  case CM_EnregComm : 
    fRecordCommand = VRAI ;
    break ;
  case CM_Predefinie : 
    {
    for ( unsigned int w = 0 ; w < wScriptLen ; w++ ) 
      SendMessage(WM_COMMAND, aiCommandesPredefinies [w]);
    break ;
    }
  case CM_Tracage : 
    ActiveTracage(fTracage = !fTracage);
    break ;
  case CM_Ruban : 
    fRuban = !fRuban ;
    break ;
  case CM_DemPleinEcr : 
    fDemarrPleinEcr = !fDemarrPleinEcr ;
    break ;
  case CM_SauvegOptionsAuto : 
    fSauvegardeAuto = !fSauvegardeAuto ;
    break ;
  case CM_SauvegOptionsMaintenant : 
    SauvegardeOptions();
    break ;
  case CM_ImageAccueil : 
    ChoisirImageAccueil();
    break ;
  case CM_HardCopyFile : 
    SelectHardCopyFile();
    break ;
  case CM_ForceExit : 
    CloseWindow();
    
    //        SendMessage(CM_EXIT);
    break ;
  default : ErreurCode(362);
  }
}

void TFenIris::CmPrimitivesImages ( WPARAM id )
{
RecordCommand(id);

BIT   f = ECHEC ;
float xyFacteur ;

if ( modcoul ) 
  {
  MErreur("Opration refuse (vrifier couleur)", 543);
  return ;
  }
switch ( id ) 
  {
  case CM_MultScal : 
    if ( !GetFloatValue(this, "Multiplication", "Facteur x ?", &xyFacteur) ) 
      break ;
    MultipliePlanScalaire(source, xyFacteur, destin);
    sprintf(TableFich [(plan + 1) % nbplan], "Multiplie par %g."
      , xyFacteur);
    f = SUCCES ;
    break ;
  case CM_MultScal128 : 
    if ( !GetFloatValue(this, "Multiplication", "Facteur x ?", &xyFacteur) ) 
      break ;
    MultiplieScalaire128(source, xyFacteur, destin);
    sprintf(TableFich [(plan + 1) % nbplan], "Multiplie (0 en 128) par %g"
      , xyFacteur);
    f = SUCCES ;
    break ;
  case CM_ValAbs128 : 
    f = ValeurAbsolue128(source, destin);
    sprintf(TableFich [(plan + 1) % nbplan], "Valeur absolue (0 en 128)");
    break ;
  case CM_MorphoLevel : 
    {
    unsigned char uLevel = 0 ;
    if ( !GetIntValue(this, "Morphologie", "Profondeur ?", &uLevel) ) 
      break ;
    (new TConvmorphoMultiLevel(this, uLevel)) -> Create();
    break ;
    }
  case CM_AutoSeuil : 
    {
    f =  AutoSeuillage(source, destin) >= 0 ;
    break ;
    }
  case CM_EstimateurDeCoin : 
    {
    f =  ECHEC ;
    char  c ;
    if ( AppelChoixDial(this, "Direction des dtecteurs ?"
          , "&Droit\n&Oblique", &c) ) 
      {
      sprintf(TableFich [(plan + 1) % nbplan], "Recherche de coins.");
      c =  toupper(c);
      (new TParametreProgramme(
          c == 'D' ? 
               "Recherche de coins droits"
            : "Recherche de coins obliques"
          , 0, 255, 128
          , c == 'D' ? 
               EstimateurImageCoinDroit
            : EstimateurImageCoinOblique))
        -> Create();
      }
    break ;
    }
  default : MErreur("Erreur code", 314);
  }
if ( f ) 
  {
  Calsuiv();
  Visim(this, 0, source);
  }
}

void TFenIris::CmMenuContour ( WPARAM id )
{
RecordCommand(id);

BIT           fRes ;
//int iRes;
int           iPartition ;
char          cTypeLaplacien ;
unsigned char uSeuilZC ;

if ( modcoul ) 
  MErreur("Mauvais mode couleur", 368);
else 
  switch ( id ) 
    {
    case CM_GradRect : 
      if ( !(fRes = ImageAbsGrad2x2(source, destin)) ) 
        MErreur("Echec dans la calcul du gradient", 376);
      else 
        sprintf(TableFich [(plan + 1) % nbplan], "Gradient");
      break ;
    case CM_GradXY : 
      {
      unsigned char *puGx = destin, *puGy = PlanSuiv(puGx)
        , *puVAGx = PlanSuiv(puGy), *puVAGy = PlanSuiv(puVAGx)
        , *puSVAG = PlanSuiv(puVAGy), *puEstimCoin = PlanSuiv(puSVAG);
      if ( !(fRes = 2 * CalculeGrad_xy(source, puGx, puGy)) ) 
        MErreur("Echec dans la calcul du gradient", 380);
      else 
        {
        ValeurAbsolue128(puGx, puVAGx);
        ValeurAbsolue128(puGy, puVAGy);
        float xDynamique = 255.0 / 256.0 ;
        for ( unsigned int i = 0 ; i < SIZE_OF_PICTURES ; i++ ) 
          for ( unsigned int j = 0 ; j < SIZE_OF_PICTURES ; j++ ) 
            {
            puSVAG [i * SIZE_OF_PICTURES + j]      
              =  ((unsigned int)puVAGx [i * SIZE_OF_PICTURES + j]
                  + puVAGy [i * SIZE_OF_PICTURES + j])
                * xDynamique ;
            puEstimCoin [i * SIZE_OF_PICTURES + j] 
              =  NReduceN(
                EstimateurPixelCoinDroit(source, TPoint(j, i), 128) / 3, 0
                , 255);
            }
        sprintf(TableFich [(plan + 1) % nbplan], "Gradient x");
        sprintf(TableFich [(plan + 2) % nbplan], "Gradient y");
        sprintf(TableFich [(plan + 3) % nbplan], "V.A. Gradient x");
        sprintf(TableFich [(plan + 4) % nbplan], "V.A. Gradient y");
        sprintf(TableFich [(plan + 5) % nbplan], "Somme V.A. gradients");
        sprintf(TableFich [(plan + 6) % nbplan], "Recherches coins droits");
        }
      }
    break ;
    case CM_GradGTh : 
      if ( !(fRes
            = GetIntValue(this, "Gradient polaire"
              , "Nombre de partition ?", &iPartition)) ) 
        break ;
      else if ( !(fRes
                = 2
                  * CalculeGradPolaire_2comp(source, destin
                    , PlanSuiv(destin), iPartition)) ) 
        MErreur("Echec dans la calcul du gradient", 384);
      else 
        {
        sprintf(TableFich [(plan + 1) % nbplan]
          , "Gradient (valeur absolue)");
        sprintf(TableFich [(plan + 2) % nbplan], "Gradient (directions)");
        }
      break ;
    case CM_Laplacien : 
      if ( !(fRes
            = AppelChoixDial(this, "Laplacien"
              , "33 v-&4\n33 v-&8\n44 &v-4", &cTypeLaplacien)) ) 
        break ;
      else 
        cTypeLaplacien
          =  cTypeLaplacien == '4' ? 
               LAPLACIEN_CHAR_4
            : (cTypeLaplacien == '8' ? LAPLACIEN_CHAR_4 : LAPLACIEN_4x4_v4);
      if ( !(fRes = CalculeLaplacien(cTypeLaplacien, source, destin))
            || !(fRes = RemplaceBord(destin)) ) 
        MErreur("Echec dans la calcul du laplacien", 527);
      else 
        sprintf(TableFich [(plan + 1) % nbplan], "Laplacien");
      break ;
    case CM_ZCLaplacien : 
      
      /*        if (!(fRes=AppelChoixDial(this,"Laplacien","int &4\nfloat &8",&cTypeLaplacien)))
           break;
         else
           cTypeLaplacien= cTypeLaplacien=='4'?LAPLACIEN_CHAR_4:LAPLACIEN_FLOAT_8; */
      if ( !(fRes
            = AppelChoixDial(this, "Laplacien"
              , "33 v-&4\n33 v-&8\n44 &v-4", &cTypeLaplacien)) ) 
        break ;
      else 
        cTypeLaplacien
          =  cTypeLaplacien == '4' ? 
               LAPLACIEN_CHAR_4
            : (cTypeLaplacien == '8' ? LAPLACIEN_CHAR_4 : LAPLACIEN_4x4_v4);
      if ( !(fRes = GetIntValue(this, "ZC Laplacien", "Seuil ?", &uSeuilZC)) ) 
        break ;
      if ( !(fRes
            = CalculeZCLaplacien(source, destin, cTypeLaplacien, uSeuilZC)) ) 
        MErreur("Echec dans la calcul du ZC laplacien", 538);
      else 
        sprintf(TableFich [(plan + 1) % nbplan]
          , "ZC Laplacien (seuil ZC : %d)", uSeuilZC);
      break ;
    case CM_ContourPourChainage : 
      if ( !(fRes
            = AppelChoixDial(this, "Laplacien", "int &4\nfloat &8"
              , &cTypeLaplacien)) ) 
        break ;
      else 
        cTypeLaplacien =  cTypeLaplacien - '0';
      if ( !(fRes = GetIntValue(this, "ZC Laplacien", "Seuil ?", &uSeuilZC))
            || !(fRes
              = GetIntValue(this, "Gradient polaire"
                , "Nombre de partition ?", &iPartition)) ) 
        break ;
      else if ( !(fRes
                = CalculeContoursChaineurIteratif(cTypeLaplacien, source
                  , PlanSuiv(source), PlanSuiv(source, 2), iPartition
                  , uSeuilZC)) ) 
        MErreur("Echec dans les contours", 350);
      else 
        {
        sprintf(TableFich [(plan + 1) % nbplan]
          , "Amplitude ZC Laplacien %d (seuil ZC : %d)", cTypeLaplacien
          , uSeuilZC);
        sprintf(TableFich [(plan + 2) % nbplan]
          , "Direction gradient (%d partitions)", iPartition);
        }
      break ;
    case CM_Amincissement : 
      if ( !AmincissementGradientFilaire(source, PlanSuiv(source)) ) 
        MErreur("Echec dans l'amincissement", 351);
      else 
        sprintf(TableFich [plan], "Image amincie");
      fRes = 0 ;
      break ;
    case CM_ChainageIteratif : 
      if ( !(fRes
            = ChaineurContours(source, PlanSuiv(source)
              , PlanSuiv(source, 2))) ) 
        MErreur("Echec dans le chanage", 359);
      else 
        sprintf(TableFich [(plan + 2) % nbplan], "Chanage des contours");
      break ;
    case CM_ContourEtChainage : 
      if ( !(fRes
            = AppelChoixDial(this, "Laplacien", "int &4\nfloat &8"
              , &cTypeLaplacien)) ) 
        break ;
      else 
        cTypeLaplacien =  cTypeLaplacien - '0';
      if ( !(fRes = GetIntValue(this, "ZC Laplacien", "Seuil ?", &uSeuilZC))
            || !(fRes
              = GetIntValue(this, "Gradient polaire"
                , "Nombre de partition ?", &iPartition)) ) 
        break ;
      else if ( !(fRes
                = ContoursEtChaineurContoursIteratif(cTypeLaplacien
                  , source, PlanSuiv(source), PlanSuiv(source, 2)
                  , PlanSuiv(source, 3), iPartition, uSeuilZC)) ) 
        MErreur("Echec dans les contour et chanage", 368);
      else 
        {
        sprintf(TableFich [(plan + 1) % nbplan]
          , "Amplitude ZC Laplacien %d (seuil ZC : %d)", cTypeLaplacien
          , uSeuilZC);
        sprintf(TableFich [(plan + 2) % nbplan]
          , "Direction gradient (%d partitions)", iPartition);
        sprintf(TableFich [(plan + 3) % nbplan], "Chanage des contours");
        }
      break ;
    default : 
      MErreur("Erreur code", 374);
      break ;
    }
if ( fRes == 1 ) 
  {
  Calsuiv();
  Visim(this, 1, source);
  }
else if ( fRes == 2 ) 
  {
  Calsuiv();
  Visim(this, 0, source);
  Calsuiv();
  Visim(this, 1, source);
  }
}

void TFenIris::CmMenuLignes ( WPARAM id )
{
RecordCommand(id);

BIT fMiseAJourPlan = SUCCES ;

if ( modcoul ) 
  {
  MErreur("Mauvais mode couleur", 657);
  return ;
  }
if ( !pDetectLignes ) 
  (new TDetectLignes(this)) -> Create();
pDetectLignes -> OutsiderReleveOptions();
switch ( id ) 
  {
  case CM_UtilitaireLignes : 
    fMiseAJourPlan = ECHEC ;
    break ;
  case CM_RechercheLignes : 
    pDetectLignes -> CmMenu(CM_DL_RechercheLignes);
    fMiseAJourPlan = FAUX ;
    break ;
  case CM_ComposeLignes : 
    {
    try
      {
      if ( !CompositionDeLignesGTTSI(source) ) 
        MErreur("Echec  la composition de ligne", 598);
      } catch ( int e ) 
      {
      if ( e == EXCEPT_LineQuantityLimitExceeded ) 
        MErreur("Dpassement de la capacit en nombre de lignes", 773);
      else 
        throw e ;
      ;
      ;
      }
    fMiseAJourPlan =  FAUX ;
    break ;
    }
  case CM_RechercheRestauLignes : 
    pDetectLignes -> CmMenu(CM_DL_RechercheRestauLignes);
    fMiseAJourPlan = FAUX ;
    break ;
  case CM_RechercheSymbole : 
    {
    BIT fTracDL = fTracage ;
    ActiveTracage(FAUX);
    CmMenuLignes(CM_RechercheRestauLignes);
    ActiveTracage(fTracDL);
    pDetectLignes -> SendMessage(WM_COMMAND, CM_DL_AnalyseLignes, 0);
    fMiseAJourPlan =  FAUX ;
    break ;
    }
  default : fMiseAJourPlan = MErreur("Commande non dfinie", 352);
  }
if ( !pDetectLignes ) 
  MErreur("Erreur non dfinie", 424);
else 
  {
  pDetectLignes -> cTypeLaplacienCalcule =  pDetectLignes -> cTypeLaplacien ;
  pDetectLignes -> Invalidate();
  }
if ( fMiseAJourPlan ) 
  {
  Calsuiv();
  Visim(this, 0, source);
  }
}

void TFenIris::CmRechercheLectureSymbole ( WPARAM id )
{
RecordCommand(id);
if ( modcoul )
  {
  MErreur("Mauvais mode couleur", 657);
  return ;
  }
switch ( id )
  {
  case CM_RechercheLectureSymboleEtAl :
    {
    CmRechercheLectureSymbole(CM_RechercheLectureSymbole);
    CmMenuSymboles(CM_SymbolComp);
    CmMenuSymboles(CM_SymbolReport);
    break;
    }

  case CM_RechercheLectureSymbole :
    {
    long lTDemarre, lTTransferDatas, lTReading, lTFinishedReading, lDuration;
    int iOldSrc = Numeroplan(source);
    if ( !pDetectLignes )
      (new TDetectLignes(this)) -> Create();

    lTDemarre=Caltime(); // Start chrono
    pDetectLignes -> CmMenu(CM_DL_RechercheRestauLignes);
    if ( fTracage )
      Calsuiv( - ((Numeroplan(source) - iOldSrc + nbplan) % nbplan));
    pDetectLignes -> CmMenu(CM_DL_AnalyseLignes);
    if ( fTracage )
      Calsuiv( - ((Numeroplan(source) - iOldSrc + nbplan) % nbplan));
    lTTransferDatas=Caltime(); // Interrupt chrono
    pDetectLignes -> SaveDatasToLectureSymbole();
    pDetectLignes -> ShutDownWindow();
    lTReading=Caltime(); // Resume chrono
    // Dans les deux cas, provoque la lecture du symbole:
    if ( !pLectureSymbole )
      CmMenuSymboles(CM_UtilitaireSymbole);
    else
      pLectureSymbole -> CmMenuEnvironnement(CM_PK_ChargePolygone);
    lTFinishedReading=Caltime(); // Stop chrono
    lDuration=lTTransferDatas-lTDemarre+lTFinishedReading-lTReading;
    char sz[80];
    gcvt((double)(lDuration)/100.,6,sz);
    WritePrivateString(STRING_TitreClasseLectureSymbole, "dure (s)", sz, szINIFileName);
//		Bauto->SetText(s2);       // Bauto -> TStatic
    break ;
    }
  default :
  {}
  }
}

void TFenIris::CmMenuSymboles ( WPARAM id )
{
RecordCommand(id);

int fMiseAJourPlan = SUCCES ;

if ( !pLectureSymbole )
  (new TLectureSymbole(this)) -> Create();
switch ( id )
  {
  case CM_UtilitaireSymbole : 
    
    // Ouverture outil
    fMiseAJourPlan = ECHEC ;
    break ;
  case CM_ChargeSymbole : 
    pLectureSymbole -> CmMenu(CM_LS_ChargeSymbole);
    fMiseAJourPlan = ECHEC ;
    break ;
  case CM_RechercheLectureSymbole : 
    pLectureSymbole -> CmMenu(CM_LS_LectureSymbole);
    if ( !fTracage ) 
      fMiseAJourPlan =  ECHEC ; // Pas d'affichage.
    else 
      sprintf(TableFich [(plan + 1) % nbplan], "Lecture de symbole");
    break ;
  case CM_SymbolComp : 
    pLectureSymbole -> CmSymbolComp();
    fMiseAJourPlan = ECHEC ;
    break ;
  case CM_SymbolReport : 
    pLectureSymbole -> CmMenu(CM_LS_SymbolReport);
    fMiseAJourPlan = ECHEC ;
    break ;
  default : fMiseAJourPlan = MErreur("Commande non dfinie", 353);
  }
if ( !pLectureSymbole ) 
  MErreur("Erreur non dfinie", 356);
else 
  pLectureSymbole -> Invalidate();
if ( fMiseAJourPlan ) 
  {
  Calsuiv();
  Visim(this, 0, source);
  }
}

void TFenIris::Ascenseurs ()
{
pFenetreIris -> Ascenseurs(!fEtatAscenseurs);
}

void TFenIris::Ascenseurs ( BIT fEtat )
{
ShowScrollBar(SB_BOTH, fEtatAscenseurs = fEtat); // Affectation du nouvel tat.
}

void TFenIris::RecordCommand ( WPARAM id )
{
if ( fRecordCommand ) 
  {
  fRecordCommand =  FAUX ;
  wScriptLen     =  0 ;
  if ( id != CM_EnregComm ) 
    aiCommandesPredefinies [wScriptLen++] =  id ;
  }
}

/*
   etatsouris=EtatBDSouris+(EtatBGSouris<<1)+
   			  (DragBDSouris<<2)+(DragBGSouris<<3);
    if(EtatBGSouris||EtatBDSouris) if(fAffPtr) fAffPtr(point,etatsouris);
   */
/*
   void Ev_ClicNouveauPoint(TPoint &,int etatsouris)    // une fonction
     {
     if (etatsouris & SOURIS_CLIC_BG)
       Indique_Fonction()->SendMessage(WM_COMMAND,CM_NouveauPoint);
     }
   */
void TFenIris::InterpretCommandLine ()
{
wScriptLen     
  =  CatchCommandLineIntList(argc_, argv_, "cp"
    , aiCommandesPredefinies, wScriptLen, // Default
                                          aiCommandesPredefinies
    , sizeof(aiCommandesPredefinies));
fDemarrCommand 
  =  CatchCommandLineFlagSign(argc_, argv_, "dc", fDemarrCommand);
}
