/**********************************************************************/
/*                       W I R I S       . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRIS_H
#define WIRIS_H

#include "base.h"
#include "wgeometr.h"
#include "wlstutil.h"
#include "wsysutil.h"
#include "symbole.h"

/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
/*--TCadIris-------------------------------------------------------------*/
class TCadIris : public TCad
  {
    virtual void EvSysCommand(UINT cmdType, TPoint& p_l);
    virtual void EvSize(UINT sizeType, TSize& size);
    virtual void EvInitMenuPopup(HMENU hPopupMenu, UINT index,BOOL sysMenu);
  public :
    TCadIris(TWindow *Parent, char far *Title, TWindow *Client,
				BOOL trackMenuSelection=FALSE);
    DECLARE_RESPONSE_TABLE(TCadIris);
  };
/*--TFenIris-------------------------------------------------------------*/
class TFenIris : public TFen
  {
  BOOL fEtatAscenseurs;
  virtual int SauvegardeOptions(void);
  virtual int ChargeOptions(void);
  void RecordCommand(WPARAM id);
  void InterpretCommandLine();
public:
  BOOL fDemarrCommand;
  int aiCommandesPredefinies[256];
  unsigned int wScriptLen;
//  TListImp<unsigned int> lwCommandesPredefinies;
//  TQuadrilatere far *pqSymb;
  TMenu *pmnuConfigIris, *pmnuContours, *pmnuIrisTools;
//  TScroller *pscrlMainScroller;
  TFenIris();
  ~TFenIris();
  void Ascenseurs();
  void Ascenseurs(BIT fEtat);
  void SetupWindow();
  void CmDiversTraceurs(WPARAM id);
  void CmDiversValide(WPARAM id);
  void CmMenuContour(WPARAM id);
  void CmMenuLignes(WPARAM id);
  void CmMenuSymboles(WPARAM id);
  void CmPrimitivesImages(WPARAM id);
  void CmMenuEnvironnement(WPARAM id);
  void CmMenuSebastien(WPARAM id);
  virtual void EvRButtonDown(UINT, TPoint&);
  void CmRechercheLectureSymbole(WPARAM id);
//  void CmDetectLectureSymbole();
  void ChoisirImageAccueil(void);
//  int CanClose();
protected :
  DECLARE_RESPONSE_TABLE(TFenIris);
  };
/*--TAppIris-------------------------------------------------------------*/
class TAppIris : public TApp
  {
public:
    TAppIris();
    virtual void InitMainWindow();
  };
/*-----------------------------------------------------------------------*/
/*                     Variables  exporter                              */
/*-----------------------------------------------------------------------*/
extern TFenIris *pFenetreIris;
extern TAppIris *pApplicationIris;
extern TCadIris *pCadreIris;

/*extern int iLargeurEcran;
extern int iHauteurEcran;*/
extern char far szImageAccueil[MAXPATH];
//extern char far szRepertoireDepart[MAXDIR];
//extern char far szNomTraceur[MAXPATH];


//extern BIT fDemarrPleinEcr;
// extern int fSauvegardeAuto;
//extern TSize sMarges;
//extern TRect rImage;
//



extern char szImageAccueilDef[MAXPATH],szRepertoireDepartDef[MAXDIR],
    szNomTraceurDef[MAXPATH],
    szHardCopyFileNameDef[MAXPATH];

extern int fSauvegardeAutoDef, fTracageDef, fRubansDef,
    fFullScreenStartDef, wPreselectedCommandDef, fHardCopyDef;

/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*/

#endif // WIRIS_H
