/*
#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop
*/
#define MODULE_NAME "WIRISSUP.CPP"
/**********************************************************************/
/*                       W I R I S S U P . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Support des classes d'Iris.                    */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      */
/*    Dvelopp le   : Printemps 1996                                 */
/**********************************************************************/
// Inclusions bibliothques standards

#include <values.h>
#include <math.h>

//  Inclusions bibliothques Object Windows
#include <owl\applicat.h>
#include <owl\combobox.h>

// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wgttsi.h"
#include "wsysutil.h"
#include "wappbase.h"
#include "wmain.h"

//  Inclusions bibliothques Iris

#include "base.h"
#include "scaltool.h"
#include "strutil.h"
#include "symbole.h"
#include "sysctr.h"
#include "wgeometr.h"
#include "wiris.h"
#include "wirssymb.h"
#include "wirissup.h"
#include "wirsutil.h"
#include "wintrac.h"

#include "cortex.rch"
#include "wcortex.h"
#include "ctxoutil.h"

/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*--TCadIris-------------------------------------------------------------*/
class TCadIrisSupport : public TCadIris
  {
  public :
    TCadIrisSupport(TWindow *Parent, char far *Title, TWindow *Client,
				BOOL trackMenuSelection=FALSE);
  };
/*--TFenIris-------------------------------------------------------------*/
class TFenIrisSupport : public TFenIris
  {
  TMenu *pmnuValidIris;
//  TMenu *pmnuSebastien;
  public:
    TFenIrisSupport();
    virtual void SetupWindow();
    void CmTexture( WPARAM id );
    void CmParametres();
    void CmOptions();
    DECLARE_RESPONSE_TABLE(TFenIrisSupport);
  };
/*--TAppIris-------------------------------------------------------------*/
class TAppIrisSupport : public TAppIris
  {
  public:
    TAppIrisSupport();
    void InitMainWindow();
  };
/*-----------------------------------------------------------------------*/
/*                     Variables globales                                */
/*-----------------------------------------------------------------------*/
TFenIrisSupport *pFenetreIrisSupport;
TAppIrisSupport *pApplicationIrisSupport;
TCadIrisSupport *pCadreIrisSupport;
/*-----------------------------------------------------------------------*/
/*                     Classe Fenetre (TFenIris)                         */
/*--Systme--------------------------------------------------------------*/
DEFINE_RESPONSE_TABLE1(TFenIrisSupport, TFenIris)
// wconv.cpp wcarconv.cpp wcomconv.cpp
	EV_COMMAND_AND_ID(CM_DENSITE, CmTexture),
	EV_COMMAND_AND_ID(CM_GRANULARITE, CmTexture),
	EV_COMMAND_AND_ID(CM_DISCONTINUITE, CmTexture),
	EV_COMMAND_AND_ID(CM_CONTINUITE, CmTexture),
	EV_COMMAND_AND_ID(CM_COMPACITE, CmTexture),
	EV_COMMAND_AND_ID(CM_PROXIMITE, CmTexture),
	EV_COMMAND_AND_ID(CM_DETECTION, CmTexture),
	EV_COMMAND_AND_ID(CM_VRAISSEMBLANCE, CmTexture),
	EV_COMMAND(CM_PARAMETRES, CmParametres),
	EV_COMMAND(CM_OPTIONS, CmOptions),
	EV_COMMAND_AND_ID(CM_TexQuad, CmTexture),
END_RESPONSE_TABLE;

TFenIrisSupport::TFenIrisSupport():TFenIris()
  {
  pFenetreIrisSupport=this;
  pmnuValidIris=new TMenu((HINSTANCE)(*((TApplication*)pApplicationIrisSupport)),"ValidIris");

  pmnuCortex=new TMenu((HINSTANCE)(*((TApplication*)Applicat)),"CortexMenu");
// Obsolete: pmnuSebastien=new TMenu((HINSTANCE)(*((TApplication*)pApplicationIrisSupport)),"Sebastien");
// moved to wirstool.cpp new TMenu((HINSTANCE)(*((TApplication*)Applicat)),"CortexMenu");
//  pTx=new TTexture();
  }
void TFenIrisSupport::SetupWindow()
  {
  TFenIris::SetupWindow();
//  LoadIsolatedMenus();
  pmnuApplications->AppendMenu(MF_SEPARATOR);
  pmnuApplications->AppendMenu(MF_POPUP, *pmnuCortex,"Te&xtures");
  pmnuApplications->AppendMenu(MF_POPUP, *(pFenetreIrisSupport->pmnuValidIris),"&Validations");
  }
//***** Appel d'une commande de texture
void TFenIrisSupport::CmTexture( WPARAM id )
  {
  switch (id)
    {
    case CM_TexQuad :
      new TTextureQuad(this)->Create();
      break;
    default :
      pTx->CallTexture(id, source, destin, PlanSuiv(destin));
      Visim( this, 1, destin );
      }
  }
//******** Boite de dialogue "parametres"
void TFenIrisSupport::CmParametres()
{	(new TParametres(this))->Create();
}
//******* boite de dialogue "Options"
void TFenIrisSupport::CmOptions()
{	(new TOptions(this))->Create();
}
/*-----------------------------------------------------------------------*/
/*                     Classe application (TAppIris)                     */
/*--Systme--------------------------------------------------------------*/
TAppIrisSupport::TAppIrisSupport() : TAppIris()
  {
  pApplicationIrisSupport=this;
  }

void TAppIrisSupport::InitMainWindow()
  {
  new TCadIrisSupport(NULL,TitreApplication,new TFenIrisSupport,TRUE);
  TAppIris::InitMainWindow();
  }
/*-----------------------------------------------------------------------*/
/*                     Classe Cadre (TCadIris)                           */
/*--Systme--------------------------------------------------------------*/
TCadIrisSupport::TCadIrisSupport(TWindow *Parent, char far *Title, TWindow *Client,
                   BOOL trackMenuSelection)
    : TCadIris (Parent, Title, Client, trackMenuSelection)
  {
  pCadreIrisSupport=this;
  }

/*-----------------------------------------------------------------------*/
/*               Prototypes fonctions locales                            */
/*-----------------------------------------------------------------------*/
void ChargeOptions();
/*-----------------------------------------------------------------------*/
/*                     Classe Fenetre (TFenIris)                         */
/*--Nouvelles fonctionalits---------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classe application (TAppIris)                     */
/*--Nouvelles fonctionalits---------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classe Cadre (TCadIris)                           */
/*--Nouvelles fonctionalits---------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                 Fonctions locales                                     */
/*-----------------------------------------------------------------------*/
void ChargeOptions()
  {
  }
/*-----------------------------------------------------------------------*/
/*       		   Programme OwlMain                             */
/*-----------------------------------------------------------------------*/
int OwlMain(int argc, char* argv [])
  {
  fDOSIniAccess=0; // Spcifie que les accs aux fichiers INI sont grs par M$W et non M$Dos.
  argc_=argc;                              // passages de paramtres OwlMain
  argv_=argv;
/*
Ne pas toucher  la ligne ci-dessous
[xVersion]
<!--

*/
float xVersion=2.6;
/*
[AVt892]
*/
char *szVersion="10/12/1997 at 14:10:25.61 (French Time)";

  if (DemarrageCarte())
    {
    strcpy(TitreApplication,"Iris - Analyse de codes symboliques");

    strcpy(TexteAbout,"Version ");
    gcvt(xVersion,10,TexteAbout+strlen(TexteAbout));

    strcat(strcat(strcat(TexteAbout,", date: "),szVersion),"\n Auteur: Baptiste Marcel");

    strcpy(FichierAide,"aide.HLP");
    strcpy(szINIFileName,"wiris.ini");
    fFullScreenStartDef=TRUE;
    return (new TAppIrisSupport())->Run();           // Lancement du programme
    }
  else
    return 0;
//  return TDrawApp().Run();
}
/*-----------------------------------------------------------------------*/
/*       	    Fonctions  exporter                                 */
/*-----------------------------------------------------------------------*/


