/*
#include "baptiall.h"
#include "cattoall.h"

#pragma hdrstop
*/

#define MODULE_NAME "WIRSLign"
 /*********************************************************************
    --------------------------------------------------------------------
        Fonction       : Fonctions conversationnelles pour Iris

    --------------------------------------------------------------------
        Auteur         : Baptiste MARCEL
        Dvelopp le   : Printemps 1996
         Dernire modif.: voir date fichier
    ********************************************************************/

    // Inclusions bibliothques standards
    #include <io.h>
    #include <stdio.h>
    #include <dir.h>
    //#include <math.h>
    #include <values.h>

    //  Inclusions bibliothques Object Windows
    #include <osl\geometry.h>


    //#include <owl\applicat.h>
    #include <owl\inputdia.h>

    //#include <owl\combobox.h>

    //#include <owl\scroller.h>

    #include <owl\dialog.h>
    #include <owl\dc.h>
    #include <owl\edit.h>
    #include <owl\framewin.h>


    // Inclusions bibliothques DOS


// Inclusion bibliothques Image
   #include "wappbase.rh"
   #include "wmain.h"
   #include "wconv.h"
   #include "wgttsi.h"
   #include "wappbase.h"
/*
   */
//  Inclusions bibliothques Iris
/*#include "wanlfreq.h"
   #include "wanallec.h"


   #include "base.h"
   #include "strutil.h"
   #include "sysctr.h"
   #include "wgeometr.h"
   #include "wirspick.h"
   */
//#include "wanallec.h"
#include "anlfreq.h"
#include "piadiv.h"
#include "contour.h"
#include "wintrac.h"
#include "wirslign.h"
#include "wirsutil.h"
#include "wirssymb.h"
#include "wsysutil.h"
#include "wsystool.h"
/*
   #include "scaltool.h"
   #include "wsymbole.h"

   */
#include "iris.rc"

//  Inclusions bibliothques Sbastien
#include "analtex.h"
#include "cortex.rch"
#include "ctxoutil.h"
#include "wcortex.h"

//-----------------------------------------------------------------------
#define DL_RecalageAbsent 0
#define DL_RecalageVoisinageSelectif 1
#define DL_RecalagePremierRecul 2

int iPartitionDef=8, cTypeLaplacienDef=4, iCoinsSeuilDef=128
    , iTypeRecalageDef=DL_RecalageVoisinageSelectif
    , fIsTexelCheckingDef=1
    , seuilzcDef=1;
float xRacParaDef=25.0, xRacParaOrtho=65.0
    , xSeuilRapportDeLongueursMaxSymboleDef =5.0/3.0;
unsigned int wLongueurMinimaleChaineDef=4
    , wSeuil_TailleMinimaleSymboleDef=10;
unsigned char uCoinsNoyauDef=3;



TDetectLignes far *pDetectLignes = NULL ;
DEFINE_RESPONSE_TABLE1 (TDetectLignes, TAssociatif)
    EV_COMMAND (CM_NouveauPoint, NouveauPoint)
  , EV_COMMAND (ID_DL_TexelSwitch, EvTexelSwitch)
  , EV_COMMAND_AND_ID (CM_DL_RechercheLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_RaccordeLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_UnifieLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_RaccordeEtUnifieLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_AfficheLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_AnalyseLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_CorrigeQuad, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_RechercheRestauLignes, CmMenu)
  , // Avec restauration
    EV_COMMAND_AND_ID (CM_DL_SauvegardeLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_ChargeLignes, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_SauvegardeQuad, CmMenu)
  , EV_COMMAND_AND_ID (CM_DL_LectureSymbole, CmSuicideMenu)
  , EV_COMMAND (ID_DL_TypeLaplacien8, ReleveOptions)
  , EV_COMMAND (ID_DL_TypeLaplacien4, ReleveOptions)
  , EV_COMMAND (ID_DL_TypeLaplacien4x4v4, ReleveOptions)
  , EV_COMMAND (ID_DL_TypeBinary, ReleveOptions)
  , EV_COMMAND (ID_DL_NbPart, ReleveOptions)
  , EV_COMMAND (ID_DL_ParamSeuilZC, ReleveOptions)
  , EV_COMMAND (ID_DL_SeuilEARaccPar, ReleveOptions)
  , EV_COMMAND (ID_DL_SeuilEARaccOrth, ReleveOptions)
  , //	EV_COMMAND_AND_ID(EV_TextureReplied, CmTextureCall),
    EV_COMMAND_AND_ID (CM_DENSITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_GRANULARITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_DISCONTINUITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_CONTINUITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_COMPACITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_PROXIMITE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_DETECTION, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_VRAISSEMBLANCE, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_PARAMETRES, CmTextureCall)
  , EV_COMMAND_AND_ID (CM_OPTIONS, CmTextureCall)
  , EV_COMMAND (ID_DL_PlanBitContour, CmPlanBitContour)
  , EV_COMMAND (ID_DL_PlanBitTexture, CmPlanBitTexture), END_RESPONSE_TABLE ;

void TDetectLignes::CmPlanBitTexture ()
{
(TConvplanbitPtr
    = new TConvplanbit(this, "Plan des textures"
      , "\
&4.  symbole\n\
&5.  inclus polygne\n\
&6.  contact polygne\n\
&7.  polygne"))
  -> Create();
if ( TConvplanbitPtr ) 
  for ( unsigned int w = 1 ; w <= 4 ; w++ ) 
    TConvplanbitPtr -> tab_bt [w] -> SetWindowFont(*pftDefaultArial, 0);
}

void TDetectLignes::CmPlanBitContour ()
{
(TConvplanbitPtr
    = new TConvplanbit(this, "Plan des contours"
      , "\
&7. Prd.\n\
&6. Prd.#2\n\
&5. Prd.#1\n\
&4. Prd.#0\n\
&3. Succ.\n\
&2. Succ.#2\n\
&1. Succ.#1\n\
&0. Succ.#0 (Explo)\
"))
  -> Create();
if ( TConvplanbitPtr ) 
  for ( unsigned int w = 1 ; w <= 8 ; w++ ) 
    TConvplanbitPtr -> tab_bt [w] -> SetWindowFont(*pftDefaultArial, 0);
}

void TDetectLignes::CmTextureCall ( WPARAM id )
{

//    Parent->SendMessage(WM_COMMAND,id);
if ( id == CM_PARAMETRES ) 
  (new TParametres(this)) -> Create();
else if ( id == CM_OPTIONS ) 
  (new TOptions(this)) -> Create();
else 
  {
  pTx -> CallTexture(id, source, destin, PlanSuiv(destin));
  Fenetre -> Visim(this, 1, destin);
  }
}

void TDetectLignes::OutsiderReleveOptions ()
{
ReleveOptions();
}

TDetectLignes::TDetectLignes ( TWindow *parent )
  : TAssociatif(parent, "Chercheur de lignes", ASS_DROITE),  Ligne()
    ,  rRechGlob(),  rMiscStates(),  rPteLgn(),  rRechSmb(),  ABCD()
{
Ajoute_Fonction(Ev_ClicNouveauPoint, 0, RETIC, this); // wmain
fConsistance      =  FAUX ;
fOptionsPresentes =  VRAI ;
pDetectLignes     =  this ;
wNbl              =  0 ;
uNoPlanImage      =  uNoPlanAmpl = uNoPlanDirExp = uNoPlanChain = 255 ;
wSepVert          =  sEspaceUtile.cx / 2 ;
wSepHor1          
  =  3 * uHauteurLigne + 3 * sMarges.cy + uHauteurEdit * 2 ;
wSepHor2          =  wSepHor1 + 6 * uHauteurLigne + 2 * sMarges.cy ;
wSepHor3          =  wSepHor2 + 5 * uHauteurLigne + sMarges.cy ;
rRechGlob.Set(0, 0, wSepVert, wSepHor1);

//  rConfig.Set(wSepVert,0,sEspaceUtile.cx,wSepHor1);
rPteLgn.Set(0, wSepHor1, wSepVert, wSepHor2);

TRect rStateLaplacian ;

rStateLaplacian.Set(wSepVert + sMarges.cx, 0, sEspaceUtile.cx - sMarges.cx
  , sMarges.cy + 4 * uHauteurLigne);
rMiscStates.Set(rStateLaplacian.left, rStateLaplacian.bottom
  , rStateLaplacian.right, rStateLaplacian.bottom + 2 * uHauteurEdit);
rRechSmb.Set(rMiscStates.left, rMiscStates.bottom, rMiscStates.right
  , rMiscStates.bottom + 7 * uHauteurLigne);
rRechGlob.Inflate( - sMarges);

//  rConfig.Inflate(-sMarges);
rPteLgn.Inflate( - sMarges);

//  rRechSmb.Inflate(-sMarges);
ABCD            =  QuadrilatereErreur ;
iNoLigneEnCours =  - 1 ;
AlloueTableDeLignes(1);
/*
   if (algnTableLignes)
     MErreur("Tableau non vide.",551);
   else
     {
     NLA=1500;
     algnTableLignes=(ligne_AB *)malloc(NLA *sizeof(ligne_AB));
     }
   */
//  rConfig.top += 2*uHauteurLigne; // Tout dcaler pour insrer 2 TRadioButton
pbtContourBinaire          
  =  new TRadioButton(this, ID_DL_TypeBinary, "Contour binaire"
    , rStateLaplacian.left + sMarges.cx, rStateLaplacian.top + sMarges.cy
    , rStateLaplacian.Width(), uHauteurLigne, NULL);
pOptionLaplacienChar4      
  =  new TRadioButton(this, ID_DL_TypeLaplacien4
    , "Laplacien 33 v-4", rStateLaplacian.left + sMarges.cx
    , rStateLaplacian.top + sMarges.cy + uHauteurLigne
    , rStateLaplacian.Width(), uHauteurLigne, NULL);
pOptionLaplacienFloat8     
  =  new TRadioButton(this, ID_DL_TypeLaplacien8
    , "Laplacien 33 v-8", rStateLaplacian.left + sMarges.cx
    , rStateLaplacian.top + sMarges.cy + uHauteurLigne * 2
    , rStateLaplacian.Width(), uHauteurLigne, NULL);
pOptionLaplacien4x4v4      
  =  new TRadioButton(this, ID_DL_TypeLaplacien4x4v4
    , "Laplacien 44 v-4", rStateLaplacian.left + sMarges.cx
    , rStateLaplacian.top + sMarges.cy + uHauteurLigne * 3
    , rStateLaplacian.Width(), uHauteurLigne, NULL);
pNbPart                    
  =  new TEditNumCR(this, ID_DL_NbPart, 0
    , rMiscStates.left + sMarges.cx + 66, rMiscStates.top, uLargeurCar * 4
    , uHauteurEdit, 10);
pParametreSeuilZC          
  =  new TEditNumCR(this, ID_DL_ParamSeuilZC, 0
    , rMiscStates.left + sMarges.cx + 66, rMiscStates.top + uHauteurEdit
    , uLargeurCar * 4, uHauteurEdit, 10);
pestLongueurMinimaleChaine 
  =  new TLabeledEditNum(this, "Long.Min.", 0, wLongueurMinimaleChaine
    , rMiscStates.left + 66 + uLargeurCar * 4 + sMarges.cx, rMiscStates.top
    , 9 * uLargeurCar, 5 * uLargeurCar, 10, 10);

unsigned char uDecTexteRaccUnif = 100 ;

peSeuilEARaccPar  
  =  new TEditNumCR(this, ID_DL_SeuilEARaccPar, 0
    , sMarges.cx + uDecTexteRaccUnif, sMarges.cy * 2 + 3 * uHauteurLigne
    , uLargeurCar * 5, uHauteurEdit, 10);
peSeuilEARaccOrth 
  =  new TEditNumCR(this, ID_DL_SeuilEARaccOrth, 0
    , sMarges.cx + uDecTexteRaccUnif
    , sMarges.cy * 2 + 3 * uHauteurLigne + uHauteurEdit, uLargeurCar * 5
    , uHauteurEdit, 10);
new TStatic(this, 0, "Coins :", sMarges.cx, wSepHor3 + uDLE
  , 7 * uLargeurCar, uHauteurLigne, 10);
pestDetecteCoinsSeuil            
  =  new TLabeledEditNum(this, "Seuil", ID_DL_CoinsSeuil
    , iCoinsSeuil, sMarges.cx + 7 * uLargeurCar, wSepHor3, 5 * uLargeurCar
    , 5 * uLargeurCar, 5, 10);
pestDetecteCoinsNoyau            
  =  new TLabeledEditNum(this, "Noyau", ID_DL_CoinsNoyau
    , uCoinsNoyau, sMarges.cx * 2 + 17 * uLargeurCar, wSepHor3
    , 6 * uLargeurCar, 4 * uLargeurCar, 5, 10);
pbtPlanBitContour                
  =  new TButton(this, ID_DL_PlanBitContour, "# contours"
    , sMarges.cx, wSepHor3 + uHauteurEdit, 10 * uLargeurCar, uHauteurLigne);
pbtPlanBitTexture                
  =  new TButton(this, ID_DL_PlanBitTexture, "# texture"
    , sMarges.cx * 2 + 10 * uLargeurCar, wSepHor3 + uHauteurEdit
    , 10 * uLargeurCar, uHauteurLigne);
wSepVert2                        =  sMarges.cx * 3 + 27 * uLargeurCar ;
pcmbRecalageQuad                 
  =  new TComboBoxItems(this, ID_DL_Recalage, wSepVert2
    , wSepHor2 + 2 * uHauteurLigne + sMarges.cy
    , sEspaceUtile.cx - wSepVert2 - sMarges.cx
    , uHauteurEdit + uHauteurLigne * 3, CBS_DROPDOWNLIST
    , USUALMAXLENSTRING / 2);

//  int iLabelWidth=19;
rTexels                          
  =  TRect(rRechSmb.left
    , rRechSmb.top + 4 * uHauteurLigne, rRechSmb.right
    , rRechSmb.top + 7 * uHauteurLigne + 4);
pchkAuthorizeTexels              
  =  new TCheckBox(this, ID_DL_TexelSwitch, "Texel :"
    , rTexels.left + 2, rTexels.top + 2, 10 * uLargeurCar, uHauteurLigne);
pstNbTexelsTotal                 
  =  new TStatic(this, 0, "", rTexels.left + 2
    , rTexels.top + 1 + uHauteurLigne, (rTexels.Width()) / 2, uHauteurLigne
    , 128);
pstNbTexelsSymbole               
  =  new TStatic(this, 0, "", rTexels.left + 2
    , rTexels.top + 1 + uHauteurLigne * 2, (rTexels.Width() - 4) / 2
    , uHauteurLigne, 128);
pstPeriodeTexels                 
  =  new TStatic(this, 0, ""
    , rTexels.left + rTexels.Width() / 2, rTexels.top + 1 + uHauteurLigne
    , (rTexels.Width() - 4) / 2, uHauteurLigne, 128);
pstPartSymbole                   
  =  new TStatic(this, 0, ""
    , rTexels.left + rTexels.Width() / 2
    , rTexels.top + 1 + uHauteurLigne * 2, (rTexels.Width() - 4) / 2
    , uHauteurLigne, 128);
pstNbTexelsTotal -> Attr.Style   |= SS_LEFTNOWORDWRAP ;
pstNbTexelsSymbole -> Attr.Style |= SS_LEFTNOWORDWRAP ;
pstPartSymbole -> Attr.Style     |= SS_LEFTNOWORDWRAP ;
pstPeriodeTexels -> Attr.Style   |= SS_LEFTNOWORDWRAP ;
/*
   pstNbTexelsValides= new TLabeledEditNum(this,"Texels de symbole :",
       ID_DL_TexelsValides,MINFLOAT,
       rRechSmb.left,rRechSmb.top+4*uHauteurLigne,
       iLabelWidth*uLargeurCar,6*uLargeurCar,128,128,0);
   pstNbPartTexture= new TLabeledEditNum(this,"Part de symbole (%):",
       ID_DL_PartTexture,MINFLOAT,
       rRechSmb.left,rRechSmb.top+4*uHauteurLigne+uHauteurEdit,
       iLabelWidth*uLargeurCar,6*uLargeurCar,128,128,0);
   */
cTypeLaplacienCalcule            =  LAPLACIEN_NON_DEF ;
cTypeLaplacien                   =  8 ;
uSeuilZC                         =  0 ;
iPartition                       =  8 ;
iCoinsSeuil                      =  128 ;
uCoinsNoyau                      =  3 ;
iTypeRecalage                    =  DL_RecalageAbsent ;
if ( RMN("Lignes.img", destin) ) 
  {
  ChargeTableLignes(destin, TableDeLignes()); //,algnTableLignes);
                                             //    ChargeTableLignes(destin,algnTableLignes);
  }
*szImageUtilisee                               =  0 ;
xSeuil_tanEcartAngulaireRaccordement0          =  tan(25.0 / 180 * M_PI);
xSeuil_tanEcartAngulaireRaccordement90
  =  tan(65.0 / 180.0 * M_PI);

xSeuil_tanEcartangulaireUnification
  =  xSeuil_tanEcartAngulaireRaccordement0;
wSeuil_TailleMinimaleSymbole=10;

int iOffsetLoc = sMarges.cx * 2 + uLargeurCar * 11 ;

peImageName
  =  new TEdit(this, 0, szImageUtilisee, iOffsetLoc
    , wSepHor2 + uHauteurLigne - uDLE
    , sEspaceUtile.cx - sMarges.cx - iOffsetLoc, uHauteurEdit, MAXPATH);
peImageName -> Attr.Style |= SS_LEFTNOWORDWRAP ;
fIsTexelChecking          =  1 ;
wPeriodeVraissemblanceMax =  wNbTexelsTotal = wNbTexelsValides = 0 ;
}

//-----------------------------------------------------------------------
TDetectLignes::~TDetectLignes ()
{
AlloueTableDeLignes(0);
/*
   free(algnTableLignes);
   algnTableLignes=NULL;
   */
pDetectLignes =  0 ;
delete pcmbRecalageQuad, delete pestDetecteCoinsNoyau ;
delete pestDetecteCoinsSeuil ;
delete pestLongueurMinimaleChaine ;
delete peSeuilEARaccOrth ;
delete peSeuilEARaccPar ;
delete pParametreSeuilZC ;
delete pNbPart ;
delete pOptionLaplacienChar4 ;
delete pOptionLaplacienFloat8 ;
delete pOptionLaplacien4x4v4 ;
delete pbtContourBinaire ;
Enleve_Fonction(this); // wmain
}

void TDetectLignes::SetupWindow ()
{
TAssociatif::SetupWindow();
pcmbRecalageQuad -> AddItem(DL_RecalageAbsent, "Pas de recalage");
pcmbRecalageQuad -> AddItem(DL_RecalageVoisinageSelectif
  , "Voisinage slectif");
pcmbRecalageQuad -> AddItem(DL_RecalagePremierRecul, "Premier recul");
peImageName -> SetReadOnly(TRUE);

//  pstNbPartTexture->e.SetReadOnly(TRUE);
//  pstNbTexelsValides->e.SetReadOnly(TRUE);
//  TFont *pft=new TFont("Arial",uHauteurLigne);
pstNbTexelsTotal -> SetWindowFont(*pftDefaultArial, 0);
pstNbTexelsSymbole -> SetWindowFont(*pftDefaultArial, 0);
pstPartSymbole -> SetWindowFont(*pftDefaultArial, 0);
pstPeriodeTexels -> SetWindowFont(*pftDefaultArial, 0);
pbtPlanBitContour -> SetWindowFont(*pftDefaultArial, 0);
pbtPlanBitTexture -> SetWindowFont(*pftDefaultArial, 0);
AfficheOptions();
}

//--Fonction locale Paint------------------------------------------------
void RedigeNoPlansTDetecteLignes ( char *szEtiquette, unsigned char uNoPlan
    , char *szTamp )
{
if ( uNoPlan == 255 ) 
  wsprintf(szTamp, "    %s", szEtiquette);
else 
  wsprintf(szTamp, "%d : %s", uNoPlan, szEtiquette);
}

//--Paint----------------------------------------------------------------void TDetectLignes::Paint(TDC& dc, BOOL erase, TRect& rect)
void TDetectLignes::Paint ( TDC &dc, BOOL erase, TRect &rect )
{
TAssociatif::Paint(dc, erase, rect);
dc.Rectangle(rTexels);
/*
   
   dc.Rectangle(rConfig);
   dc.Rectangle(rPteLgn);
   dc.Rectangle(rRechSmb);
   */
char      szTamp0 [USUALMAXLENSTRING], szTamp1 [USUALMAXLENSTRING];
float     xyAlpha ;
TVecteur  vAB (Ligne) ;
TPoint    ptAff(rRechGlob.TopLeft());

dc.SetBkMode(TRANSPARENT);
if ( cTypeLaplacienCalcule == LAPLACIEN_CHAR_4 ) 
  wsprintf(szTamp0, "Laplacien 33 v-4.");
else if ( cTypeLaplacienCalcule == LAPLACIEN_FLOAT_8 ) 
  wsprintf(szTamp0, "Laplacien 33 v-8.");
else if ( cTypeLaplacienCalcule == CONTOUR_BIN ) 
  wsprintf(szTamp0, "Contours morphologiques");
else if ( cTypeLaplacienCalcule == LAPLACIEN_4x4_v4 ) 
  wsprintf(szTamp0, "Laplacien 44 v-4.");
else 
  wsprintf(szTamp0, "Laplacien indtermin.");
dc.TextOut(ptAff, szTamp0);
wsprintf(szTamp0, "%d lignes.", wNbl);
/*
   TFont ft("Arial",uHauteurLigne, 0, 0, 0, FW_NORMAL, FF_DONTCARE | VARIABLE_PITCH,0,0,0,ANSI_CHARSET);
   dc.SelectObject(ft);
   */
dc.TextOut(ptAff.Offset(0, uHauteurLigne), szTamp0);
dc.TextOut(rMiscStates.TopLeft().OffsetBy(0, uDLE), "Partition :");
dc.TextOut(rMiscStates.TopLeft().OffsetBy(0, uHauteurEdit + uDLE)
  , "Seuil ZC :");
ptAff =  TPoint(sMarges.cx, sMarges.cy * 2 + 2 * uHauteurLigne);
dc.TextOut(ptAff, "Seuils carts angulaires ():");
dc.TextOut(ptAff.Offset(sMarges.cx, uHauteurLigne + uDLE), "racc. // :");
dc.TextOut(ptAff.Offset(0, uHauteurEdit), "racc. L :");

//  dc.TextOut(ptAff.Offset(0,uHauteurEdit),"unification :");
ptAff =  TPoint(sMarges.cx, wSepHor2);
dc.TextOut(ptAff, "Plans :");
if ( uNoPlanImage != 255 ) 
  wsprintf(szTamp0, "%d : image %s", uNoPlanImage, szImageUtilisee);
else 
  wsprintf(szTamp0, "     image %s", szImageUtilisee);
dc.TextOut(ptAff.Offset(sMarges.cx + uLargeurCar * 2, uHauteurLigne)
  , szTamp0);

// Position de l'affichage de l'image: (sMarges.cx*2+uLargeurCar*12,wSepHor2+uHauteurLigne);
RedigeNoPlansTDetecteLignes("amplitude (moniteur) ;", uNoPlanAmpl, szTamp0);
dc.TextOut(ptAff.Offset(0, uHauteurLigne + uDLE), szTamp0);
RedigeNoPlansTDetecteLignes("direction/exploration ;", uNoPlanDirExp
  , szTamp0);
dc.TextOut(ptAff.Offset(0, uHauteurLigne), szTamp0);
RedigeNoPlansTDetecteLignes("chanage.", uNoPlanChain, szTamp0);
dc.TextOut(ptAff.Offset(0, uHauteurLigne), szTamp0);
if ( !fConsistance ) 
  return ;
ptAff =  rPteLgn.TopLeft();

TPoint  ptAffx, ptAffy ;

if ( Ligne.EstNulle() ) 
  {
  wsprintf(szTamp0, "Pas de ligne en (%d,%d).", posx, posy);
  dc.TextOut(ptAff, szTamp0);
  }
else if ( (xyAlpha = vAB.Orientation()) == MAXFLOAT ) 
  {
  wsprintf(szTamp0, "MErreur au point (%d,%d).", posx, posy);
  dc.TextOut(ptAff, szTamp0);
  }
else 
  {
  wsprintf(szTamp0, "Recherche en (%d,%d).", posx, posy);
  dc.TextOut(ptAff, szTamp0);
  wsprintf(szTamp0, "Ligne n%d", iNoLigneEnCours);
  ptAff.Offset(0, uHauteurLigne);
  if ( iNoLigneEnCours >= 0 ) 
    dc.TextOut(ptAff, szTamp0);
  ptAffx =  ptAff.OffsetBy(0, uHauteurLigne);
  ptAffy =  ptAffx.OffsetBy(rPteLgn.Width() / 2, 0);
  wsprintf(szTamp0, "A.x : %d", Ligne.A.x);
  dc.TextOut(ptAffx, szTamp0);
  wsprintf(szTamp0, "A.y : %d", Ligne.A.y);
  dc.TextOut(ptAffy, szTamp0);
  wsprintf(szTamp0, "B.x : %d", Ligne.B.x);
  dc.TextOut(ptAffx.Offset(0, uHauteurLigne), szTamp0);
  wsprintf(szTamp0, "B.y : %d", Ligne.B.y);
  dc.TextOut(ptAffy.Offset(0, uHauteurLigne), szTamp0);
  wsprintf(szTamp0, "Longueur : %d px.", Ligne.lg);
  dc.TextOut(ptAffx.Offset(0, uHauteurLigne), szTamp0);
  wsprintf(szTamp0, "Orientation : %s"
    , gcvt(xyAlpha / M_PI * 180, 4, szTamp1));
  dc.TextOut(ptAffx.Offset(0, uHauteurLigne), szTamp0);
  }
AfficheValQuad(ABCD, rRechSmb.TopLeft(), dc);

//  sprintf(szTamp0,"  Texels : %d",wPeriodeVraissemblanceMax);
//  dc.TextOut(rTexels.TopLeft().OffsetBy(2,2),"  Texels :");
dc.SelectStockObject(NULL_BRUSH);
dc.Rectangle(rTexels);
}

//--Nouvelles fonctionnalits--------------------------------------------
void TDetectLignes::EvTexelSwitch ()
{
if ( pchkAuthorizeTexels -> GetCheck() & BF_CHECKED ) 
  {
  pstNbTexelsTotal -> Show(SW_SHOW);
  pstNbTexelsSymbole -> Show(SW_SHOW);
  pstPeriodeTexels -> Show(SW_SHOW);
  pstPartSymbole -> Show(SW_SHOW);
  }
else 
  {
  pchkAuthorizeTexels -> SetCheck(BF_UNCHECKED);
  pstNbTexelsTotal -> Show(SW_HIDE);
  pstNbTexelsSymbole -> Show(SW_HIDE);
  pstPeriodeTexels -> Show(SW_HIDE);
  pstPartSymbole -> Show(SW_HIDE);
  }
}

void TDetectLignes::CmMenu ( WPARAM id )
{
if ( FindImageFile(TableFich [plan]) ) 
  
  //  if (!access(TableFich[plan], 0)) // Renvoit 0 si accept
  strcpy(szImageUtilisee, TableFich [plan]);

BOOL  fMiseAJourPlan = SUCCES ;

ReleveOptions();
switch ( id ) 
  {
  case CM_DL_RechercheLignes : 
  
  // Sans restauration
    {
    uNoPlanImage  =  plan ;
    uNoPlanAmpl   =  (plan + 1) % nbplan ;
    uNoPlanDirExp =  (plan + 2) % nbplan ;
    uNoPlanChain  =  (plan + 3) % nbplan ;
    int f1 = 1
      , f0
        = ContoursEtChaineurContoursIteratif(cTypeLaplacien, source
          , PlanSuiv(source), PlanSuiv(source, 2), PlanSuiv(source, 3)
          , iPartition, uSeuilZC
          , cTypeLaplacien == CONTOUR_BIN ? 
               CTR_ChainageLibre
            : CTR_ChainageDirectionnel);
    try
      {
      if ( f0 ) 
        f1 =  CompositionDeLignesGTTSI(PlanSuiv(source, 3));
      if ( !f0 || !f1 ) 
        fMiseAJourPlan =  MErreur("Echec  la composition de lignes.", 598);
      } catch ( int e ) 
      {
      if ( e == EXCEPT_LineQuantityLimitExceeded ) 
        {
        MErreur("Dpassement de la capacit en nombre de lignes", 773);
        f1 =  SUCCESS ;
        }
      else 
        throw e ;
      ;
      ;
      }
    if ( f1 && f0 ) 
      {
      fMiseAJourPlan =  FAUX ;
      sprintf(TableFich [uNoPlanAmpl]
        , "Amplitude ZC Laplacien %d (seuil ZC : %d)", cTypeLaplacien
        , uSeuilZC);
      sprintf(TableFich [uNoPlanDirExp]
        , "Direction gradient (%d partitions)", iPartition);
      sprintf(TableFich [uNoPlanChain], "Chanage des contours");
      }
    break ;
    }
  case CM_DL_RechercheRestauLignes : 
  
  // Avec restauration
    {
    uNoPlanImage  =  plan ;
    uNoPlanAmpl   =  fTracage ? 255 : (plan + 1) % nbplan ;
    uNoPlanDirExp =  (plan + 2) % nbplan ;
    uNoPlanChain  =  (plan + 3) % nbplan ;
    if ( !ContoursEtChaineurContoursIteratif(cTypeLaplacien, source
          , PlanSuiv(source), PlanSuiv(source, 2), PlanSuiv(source, 3)
          , iPartition, uSeuilZC
          , cTypeLaplacien == CONTOUR_BIN ? 
               CTR_ChainageLibre
            : CTR_ChainageDirectionnel) ) 
      fMiseAJourPlan =  MErreur("Echec  la recherche de contours.", 598);
    try
      {
      if ( !CompositionDeLignesGTTSI(PlanSuiv(source, 3)) ) 
        fMiseAJourPlan =  MErreur("Echec  la composition de lignes.", 598);
      } catch ( int e ) 
      {
      if ( e == EXCEPT_LineQuantityLimitExceeded ) 
        MErreur("Dpassement de la capacit en nombre de lignes", 704);
      else 
        throw e ;
      ;
      ;
      }
    if ( !RestaurationJointiveLignesGTTSI() ) 
      fMiseAJourPlan =  MErreur("Echec  la restauration de lignes.", 331);
    else if ( !AppelRestaurationUnificatriceLignesGTTSI() ) 
      {
      fMiseAJourPlan =  MErreur("Echec  l'unification de lignes.", 334);
      break ;
      }
    if ( fTracage
          && !AffichageDeLignesGTTSI(4, source, destin, TableDeLignes()
            , wNbl) ) 
      fMiseAJourPlan =  MErreur("Echec  l'affichage des lignes", 337);
    else 
      {
      fMiseAJourPlan =  fTracage ;
      
      //        sprintf(TableFich[(plan+1)%nbplan],"Amplitude ZC Laplacien %d (seuil ZC : %d)",cTypeLaplacien,uSeuilZC);
      sprintf(TableFich [uNoPlanDirExp]
        , "Direction gradient (%d partitions)", iPartition);
      sprintf(TableFich [uNoPlanChain], "Chanage des contours");
      sprintf(TableFich [(plan + 1) % nbplan], "%d lignes", wNbl);
      }
    break ;
    }
  case CM_DL_RaccordeLignes : 
    {
    if ( !RestaurationJointiveLignesGTTSI() ) 
      fMiseAJourPlan =  MErreur("Echec  la restauration de lignes.", 296);
    else if ( !AffichageDeLignesGTTSI(4, source, destin, TableDeLignes()
              , wNbl) ) 
      fMiseAJourPlan =  MErreur("Echec  l'affichage des lignes", 295);
    else 
      {
      fMiseAJourPlan =  VRAI ;
      sprintf(TableFich [(plan + 1) % nbplan], "%d lignes restaures", wNbl);
      }
    break ;
    }
  case CM_DL_UnifieLignes : 
    {
    if ( !AppelRestaurationUnificatriceLignesGTTSI() ) 
      fMiseAJourPlan =  MErreur("Echec  l'unification de lignes.", 311);
    else if ( !AffichageDeLignesGTTSI(4, source, destin, TableDeLignes()
              , wNbl) ) 
      fMiseAJourPlan =  MErreur("Echec  l'affichage des lignes", 314);
    else 
      {
      fMiseAJourPlan =  VRAI ;
      sprintf(TableFich [(plan + 1) % nbplan], "%d lignes unifies", wNbl);
      }
    break ;
    }
  case CM_DL_RaccordeEtUnifieLignes : 
    {
#pragma message ("Les restauration ne conviennent pas aux contours d'image binaire, car les lignes ne sont pas orientes")
    if ( !RestaurationJointiveLignesGTTSI() ) 
      fMiseAJourPlan =  MErreur("Echec  la restauration de lignes.", 331);
    else if ( !AppelRestaurationUnificatriceLignesGTTSI() ) 
      fMiseAJourPlan =  MErreur("Echec  l'unification de lignes.", 334);
    else if ( !AffichageDeLignesGTTSI(4, source, destin, TableDeLignes()
              , wNbl) ) 
      fMiseAJourPlan =  MErreur("Echec  l'affichage des lignes", 337);
    else 
      {
      fMiseAJourPlan =  VRAI ;
      sprintf(TableFich [(plan + 1) % nbplan]
        , "%d lignes restaures et unifies", wNbl);
      }
    break ;
    }
  case CM_DL_AfficheLignes : 
    {
    if ( !AffichageDeLignesGTTSI(4, source, destin, TableDeLignes(), wNbl) ) 
      fMiseAJourPlan =  MErreur("Echec  l'affichage des lignes", 340);
    else 
      {
      fMiseAJourPlan =  VRAI ;
      sprintf(TableFich [(plan + 1) % nbplan], "%d lignes", wNbl);
      }
    break ;
    }
  case CM_DL_AnalyseLignes :

  // Dtection de symboles.
    {

    //      Ncessite une table de lignes aux longueurs calcules (AB.lg /=0).
    unsigned int  wFirstLine = 0, wSecondLine = 0 ;
    UINT          fTextureTrouvee = 0 ;
    do
      {
      if ( !AnalyseLignesRechercheSymbole(&ABCD, &wFirstLine, &wSecondLine) ) // Le premier point est le coin du L.
{
fConsistance =  fMiseAJourPlan
  = MErreur("Echec  l'analyse de lignes.", 410);
ABCD         =  QuadrilatereErreur ;
break ;
}

      //        Trace("Symbole suppos d'aprs les lignes:",ABCD,427);
      // Aprs l'analyse, on dessine le quad s'il y a eu tracage (et donc fMiseAJourPlan)
      fConsistance
        =  ABCD.Existe() && CorrigeQuadrilatere(source);
      fMiseAJourPlan            =  ECHEC ; //  priori: pas d'affichage.
      wPeriodeVraissemblanceMax =  wNbTexelsTotal = wNbTexelsValides = 0 ;
      if ( fConsistance // Un quadrilatre a t trouv.
          && fIsTexelChecking )
        {
        float         xSeuilApartenanceSymbole = 0.8 ;   // strict
        unsigned int  wSeuilSurfaceMinimaleSymbole = 1 ; // strict
// Libration des 5 bits MSB pour la carte de texture. 16/255=2^-5:
        MultipliePlanScalaire(source, 15.4999 / 255, PlanSuiv(destin, 3));

        // Analyse des textures dans le quad. propos
        TexVraissemblanceRelativeMaxMultiFrequence(
            &wNbTexelsTotal
          , &wNbTexelsValides
          , xSeuilApartenanceSymbole
          , wSeuilSurfaceMinimaleSymbole // Seuil strict.
          , source
          , PlanSuiv(destin, 3)// Plan pour afficher le rsultat. Carte des texels
          , destin
          , PlanSuiv(destin, 4)  // Plan pour stocker l'image de contour
          , ABCD // quadrilatre  l'chelle du pixel
          , &wPeriodeVraissemblanceMax);
        fTextureTrouvee
          =  wNbTexelsTotal > wSeuilSurfaceMinimaleSymbole
              && wNbTexelsValides / (float)wNbTexelsTotal
                > xSeuilApartenanceSymbole ;
        if ( !fTextureTrouvee )
                                  {
// Tant que la texture n'est pas trouve, on boucle.
                                  ABCD =  QuadrilatereErreur ;
                                  AuthorizeLink(wFirstLine, wSecondLine, 0); // Prpare pour chercher un autre symbole
                                  fMiseAJourPlan =  0 ;
                                  }
        }
      }
    while ( fIsTexelChecking && !fTextureTrouvee && fConsistance );
    if ( fTracage && fConsistance && ABCD.Existe() )
      {
      Copie_plan(source, destin); // Affichage si tracage.
      DessineQuadrilatere(source, ABCD, destin);
      sprintf(TableFich [(plan + 1) % nbplan]
        , "Quadrilatre parmis %d lignes", wNbl);
      fMiseAJourPlan =  fTracage ;
      }
    else
      fMiseAJourPlan =  ECHEC ;
    break ;
    }
  case CM_DL_CorrigeQuad : 
    
    // Correction de quad.
    fMiseAJourPlan = fConsistance = CorrigeQuadrilatere(source);
    if ( fConsistance && !fTracage ) 
      fMiseAJourPlan =  ECHEC ; // Pas d'affichage.
    else if ( fConsistance && fTracage ) // Tracage et succs
                                          {
                                          if ( ABCD.Existe() ) 
                                            {
                                            Copie_plan(source, destin); // Affichage si tracage.
                                            DessineQuadrilatere(source
                                              , ABCD, destin);
  sprintf(TableFich [(plan + 1) % nbplan]
    , "Quadrilatre parmis %d lignes", wNbl);
                                            }
                                          else 
                                            fMiseAJourPlan =  ECHEC ;
                                          }
    break ;
  /*
     fMiseAJourPlan=fConsistance=CorrigeQuadrilatere(source);
     if (fConsistance && !fTracage)
       fMiseAJourPlan=ECHEC;  // Pas d'affichage.
     else if (fConsistance && fTracage)// Tracage et succs
       {
       if (ABCD.Existe())
         {
         Copie_plan(source,destin);      // Affichage si tracage.
         DessineQuadrilatere(source,ABCD,destin);
         sprintf(TableFich[(plan+1)%nbplan],"Quadrilatre parmis %d lignes",wNbl);
         }
       else
         fMiseAJourPlan=ECHEC;
       }
     break;
     */
  case CM_DL_SauvegardeLignes : 
    {
    SauvegardeTableLignes(TableDeLignes(), destin);
    DessineQuadrilatere(source, ABCD, destin);
    break ;
    }
  case CM_DL_ChargeLignes : 
    {
    ChargeTableLignes(source, TableDeLignes());
    break ;
    }
  case CM_DL_SauvegardeQuad : 
    {
    
    //      WritePrivateQuad(Title, "ABCD",ABCD, szINIFileName);
    SaveDatasToLectureSymbole();
    Copie_plan(source, destin);
    if ( uNoPlanAmpl == (plan + 1) ) 
      uNoPlanAmpl =  255 ;
    if ( uNoPlanDirExp == (plan + 1) ) 
      uNoPlanDirExp =  255 ;
    if ( uNoPlanChain == (plan + 1) ) 
      uNoPlanChain =  255 ;
    fMiseAJourPlan =  fTracage && DessineQuadrilatere(source, ABCD, destin); // Ne dessine que si fTracage.
    break ;
    }
  default : fMiseAJourPlan = MErreur("MErreur Code", 735);
  }
cTypeLaplacienCalcule =  cTypeLaplacien ;
AfficheOptions();
Invalidate();
if ( fMiseAJourPlan ) 
  {
  Calsuiv();
  Fenetre -> Visim(this, 0, source);
  }
}

/*
   void TDetectLignes::CmCorrigeQuad(int &fMiseAJourPlan, int &fConsistance)
     {
     }
   */
void TDetectLignes::CmSuicideMenu ( WPARAM id )
{
switch ( id ) 
  {
  case CM_DL_LectureSymbole : 
  
  // Lecture de symboles.
    {
    fConsistance =  VRAI ;
    SaveDatasToLectureSymbole();
    if ( !pLectureSymbole ) 
      
      // Creation and (on creation) lecture
      Fenetre -> SendMessage(WM_COMMAND, CM_UtilitaireSymbole, 0);
    else 
      pLectureSymbole -> SendMessage(WM_COMMAND, CM_PK_ChargePolygone, 0);
    
    //        pLectureSymbole->SendMessage(WM_COMMAND,CM_LS_LectureSymbole,0);
    pLectureSymbole -> BringWindowToTop();
    pLectureSymbole -> SetFocus();
    break ;
    }
  default : ErreurCode();
  }
}

void TDetectLignes::GenereMenuFlottant ( TPopupMenu *pmnuFlot )
{
TAssociatif::GenereMenuFlottant(pmnuFlot);
if ( pmnuFlot ) 
  {
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_RechercheLignes
    , "Rec&herche de lignes"); // H
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_RaccordeLignes, "Raccorde&ment"); // M
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_UnifieLignes, "&Unification"); // U
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_RaccordeEtUnifieLignes
    , "Res&tauration"); // T
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_RechercheRestauLignes
    , "&Recherche et restau. lignes"); // R
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_AfficheLignes
    , "&Affichage des lignes"); // A
  pmnuFlot -> AppendMenu(MF_SEPARATOR);
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_ChargeLignes
    , "&Charge liste de lignes"); // C
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_SauvegardeLignes
    , "Sau&vegarde liste de lignes"); // V
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_AnalyseLignes
    , "Recherche de &symbole"); // S
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_CorrigeQuad
    , "C&orrection de quadrilatre"); // O
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_LectureSymbole
    , "&Lecture de symbole"); // L
  pmnuFlot -> AppendMenu(MF_STRING, CM_DL_SauvegardeQuad
    , "Exporte &quadrilatre"); // Q
  
  //    TMenu *pmnuCortex=new TMenu;
  //    if (!pmnuCortex)
  //      LoadIsolatedMenus();
  //  pmnuCortex=
  TMenu *pmnuFloatCortex
    = new TMenu((HINSTANCE)(*((TApplication *)Applicat)), "CortexMenu");
  pmnuFlot -> AppendMenu(MF_POPUP, *pmnuFloatCortex, "Corte&x");
  }
}

void TDetectLignes::AfficheOptions ()
{
UINT  Etat8, Etat4, EtatBin, Etat4x4v4 ;

Etat4x4v4 =  EtatBin = Etat4 = Etat8 = BF_UNCHECKED ;
switch ( cTypeLaplacien ) 
  {
  case LAPLACIEN_NON_DEF : break ;
  case LAPLACIEN_CHAR_4 : 
    Etat4 = BF_CHECKED ;
    break ;
  case LAPLACIEN_FLOAT_8 : 
    Etat8 = BF_CHECKED ;
    break ;
  case LAPLACIEN_4x4_v4 : 
    Etat4x4v4 = BF_CHECKED ;
    break ;
  case CONTOUR_BIN : 
    EtatBin = BF_CHECKED ;
    break ;
  default : ErreurCode();
  }
pOptionLaplacien4x4v4 -> SetCheck(Etat4x4v4);
pOptionLaplacienFloat8 -> SetCheck(Etat8);
pOptionLaplacienChar4 -> SetCheck(Etat4);
pbtContourBinaire -> SetCheck(EtatBin);
pchkAuthorizeTexels -> SetCheck(
  fIsTexelChecking ? BF_CHECKED : BF_UNCHECKED);
pNbPart -> SetValue(iPartition);
pParametreSeuilZC -> SetValue(uSeuilZC);
peSeuilEARaccPar -> SetValue(
  atan(xSeuil_tanEcartAngulaireRaccordement0) / M_PI * 180.0);
peSeuilEARaccOrth -> SetValue(
  atan(xSeuil_tanEcartAngulaireRaccordement90) / M_PI * 180.0);
pestDetecteCoinsSeuil -> e.SetValue(abs(iCoinsSeuil));
pestDetecteCoinsNoyau -> e.SetValue(uCoinsNoyau);
pcmbRecalageQuad -> SetSelItem(iTypeRecalage);
peImageName -> SetText(szImageUtilisee);

char  szBuff [1024] = "";

if ( wPeriodeVraissemblanceMax ) 
  sprintf(szBuff, "Total : %d tx", wNbTexelsTotal);
else 
  *szBuff =  0 ;
pstNbTexelsTotal -> SetText(szBuff);
if ( wPeriodeVraissemblanceMax ) 
  sprintf(szBuff, "Symb.: %d tx", wNbTexelsValides);
else 
  *szBuff =  0 ;
pstNbTexelsSymbole -> SetText(szBuff);
sprintf(szBuff, "Priode: %d px", wPeriodeVraissemblanceMax);
pstPeriodeTexels -> SetText(szBuff);
if ( wNbTexelsTotal ) 
  sprintf(szBuff, "Symb.: %.3g%c"
    , wNbTexelsValides / (float)wNbTexelsTotal * 100, '%');
else 
  *szBuff =  0 ;
pstPartSymbole -> SetText(szBuff);
}

void TDetectLignes::ReleveOptions ()
{
TAssociatif::ReleveOptions();
if ( pDetectLignes -> pOptionLaplacien4x4v4 -> GetCheck() & BF_CHECKED ) 
  cTypeLaplacien =  LAPLACIEN_4x4_v4 ;
else if ( pDetectLignes -> pOptionLaplacienFloat8 -> GetCheck()
          & BF_CHECKED ) 
  cTypeLaplacien =  LAPLACIEN_FLOAT_8 ;
else if ( pDetectLignes -> pOptionLaplacienChar4 -> GetCheck() & BF_CHECKED ) 
  cTypeLaplacien =  LAPLACIEN_CHAR_4 ;
else if ( pDetectLignes -> pbtContourBinaire -> GetCheck() & BF_CHECKED ) 
  cTypeLaplacien =  CONTOUR_BIN ;
else 
  cTypeLaplacien =  LAPLACIEN_NON_DEF ;

char  szTamp0 [USUALMAXLENSTRING];

if ( !pNbPart -> GetValue(&iPartition) ) 
  iPartition =  256 ;
pParametreSeuilZC -> GetText(szTamp0, sizeof(szTamp0));
if ( !pParametreSeuilZC -> GetValue(&uSeuilZC) ) 
  uSeuilZC =  0 ;

float xTampon = 0.0 ;

if ( peSeuilEARaccPar -> GetValue(&xTampon) ) 
  xSeuil_tanEcartAngulaireRaccordement0
    =  xTampon==90.0?MAXFLOAT:tan(xTampon / 180.0 * M_PI);
if ( peSeuilEARaccOrth -> GetValue(&xTampon) ) 
  xSeuil_tanEcartAngulaireRaccordement90
    =  xTampon==90.0?MAXFLOAT:tan(xTampon / 180.0 * M_PI);
xSeuil_tanEcartangulaireUnification
  =  xSeuil_tanEcartAngulaireRaccordement0;
if ( !pestDetecteCoinsSeuil -> e.GetValue(&iCoinsSeuil) ) 
  iCoinsSeuil =  128 ;
else 
  iCoinsSeuil =  abs(iCoinsSeuil);
if ( !pestDetecteCoinsNoyau -> e.GetValue(&uCoinsNoyau) ) 
  uCoinsNoyau =  3 ;
if ( !pestLongueurMinimaleChaine -> e.GetValue(&wLongueurMinimaleChaine) ) 
  wLongueurMinimaleChaine =  4 ;
iTypeRecalage    =  (int)pcmbRecalageQuad -> GetSelItem();
fIsTexelChecking =  pchkAuthorizeTexels -> GetCheck() & BF_CHECKED ;
}

bool TDetectLignes::CanClose ()
{
if ( TAssociatif::CanClose() ) 
  {
  SauvegardeTableLignes(TableDeLignes(), destin);
  WMN("Lignes.img", destin);
  return 1 ;
  }
else 
  return 0 ;
}

void TDetectLignes::ChargeOptions ()
{
TAssociatif::ChargeOptions();
cTypeLaplacien                                 
  =  GetPrivateInt(Title, "laplacien"
    , cTypeLaplacienDef, szINIFileName);
uSeuilZC                                       
  =  NReduceN(
    GetPrivateInt(Title, "seuil ZC", seuilzcDef, szINIFileName), 0, 255);
iPartition                                     
  =  PlusProchePuissanceDe2(
    GetPrivateInt(Title, "partitions", iPartitionDef, szINIFileName));
iCoinsSeuil                                    
  =  abs(
    GetPrivateInt(Title, "Seuil des coins", iCoinsSeuilDef, szINIFileName));
uCoinsNoyau                                    
  =  GetPrivateInt(Title
    , "Voisinage des coins (noyau)", uCoinsNoyauDef, szINIFileName);
iTypeRecalage
  =  NReduceN(
    GetPrivateInt(Title, "Type recalage", iTypeRecalageDef, szINIFileName), 0, 2);
// iTypeRecalageDef=DL_RecalageVoisinageSelectif
fIsTexelChecking                               
  =  GetPrivateFlag(Title
    , "Validation texel", fIsTexelCheckingDef, szINIFileName);
*szImageUtilisee                               =  0 ;
{
float xAngle=GetPrivateFloat(Title, "Seuil E.A. Raccordement //", xRacParaDef, szINIFileName);

xSeuil_tanEcartAngulaireRaccordement0
  =  xAngle==90.0?MAXFLOAT:tan(xAngle/ 180.0 * M_PI);
xAngle=GetPrivateFloat(Title, "Seuil E.A. Raccordement L", xRacParaOrtho, szINIFileName);
xSeuil_tanEcartAngulaireRaccordement90
  =  xAngle==90.0?MAXFLOAT:tan(xAngle/ 180.0 * M_PI);
xSeuil_tanEcartangulaireUnification
  =  xSeuil_tanEcartAngulaireRaccordement0;
}

uSeuilRaccordement=GetPrivateInt
    (Title, "Seuil raccordement"
  , SEUIL_RACCORDEMENT_DEFAUT
  , szINIFileName);


wSeuil_TailleMinimaleSymbole=GetPrivateInt
    (Title, "Seuil taille minimale symbole"
  , wSeuil_TailleMinimaleSymboleDef
  , szINIFileName);
xSeuilRapportDeLongueursMaxSymbole=GetPrivateFloat(Title
  , "Seuil Rapport de longueurs maximal symbole"
  , xSeuilRapportDeLongueursMaxSymboleDef // 5.0/3.0
  , szINIFileName);

wLongueurMinimaleChaine=GetPrivateInt(Title
    , "Longueur minimale de chane", wLongueurMinimaleChaineDef, szINIFileName);
}

void TDetectLignes::SauvegardeOptions ()
{
TAssociatif::SauvegardeOptions();
WritePrivateInt(Title, "laplacien", cTypeLaplacien, szINIFileName);
WritePrivateInt(Title, "seuil ZC", uSeuilZC, szINIFileName);
WritePrivateInt(Title, "partitions", iPartition, szINIFileName);
WritePrivateFloat(Title, "Seuil E.A. Raccordement //"
  , atan(xSeuil_tanEcartAngulaireRaccordement0) / M_PI * 180.0
  , szINIFileName);
WritePrivateFloat(Title, "Seuil E.A. Raccordement L"
  , atan(xSeuil_tanEcartAngulaireRaccordement90) / M_PI * 180.0
  , szINIFileName);
WritePrivateInt(Title, "Seuil raccordement"
  , uSeuilRaccordement
  , szINIFileName);

WritePrivateInt(Title, "Seuil taille minimale symbole"
  , wSeuil_TailleMinimaleSymbole
  , szINIFileName);
WritePrivateFloat(Title, "Seuil Rapport de longueurs maximal symbole"
  , xSeuilRapportDeLongueursMaxSymbole
  , szINIFileName);


WritePrivateFloat(Title, "Seuil des coins", iCoinsSeuil, szINIFileName);
WritePrivateFloat(Title, "Voisinage des coins (noyau)", uCoinsNoyau
  , szINIFileName);
WritePrivateFloat(Title, "Type recalage", iTypeRecalage, szINIFileName);
WritePrivateFlag(Title, "Validation texel", fIsTexelChecking, szINIFileName);
WritePrivateInt(Title
    , "Longueur minimale de chane", wLongueurMinimaleChaine, szINIFileName);
}

void TDetectLignes::NouveauPoint ()
{

//  TAssociatif::NouveauPoint();
fConsistance
  =  DesigneLigne(TCoordonnee(posx, posy), &Ligne, &iNoLigneEnCours);
Invalidate();
}

void TDetectLignes::SaveDatasToLectureSymbole ()
{
WritePrivateQuad(STRING_TitreClasseLectureSymbole, "ABCD", ABCD
  , szINIFileName);

char  szFullName [MAXPATH];

if ( FindImageFile(szImageUtilisee, szFullName) )

  //  if (!access(szImageUtilisee, 0)) // Renvoit 0 si accept
  WritePrivateString(STRING_TitreClasseLectureSymbole, "image utilise"
    , szFullName, szINIFileName);
char szPresentState[1024];
  sprintf(szPresentState,"Lgn:part=%1d,ZC=%1d,Lapl=%1d,//=%2.0f,L=%2.0f,Coins=%2d,Chan=%1d,noyau=%1d,recal=%c,Tex=%c",
      iPartition,uSeuilZC,cTypeLaplacien,atan(xSeuil_tanEcartAngulaireRaccordement0) / M_PI * 180.0,
      atan(xSeuil_tanEcartAngulaireRaccordement90) / M_PI * 180.0
      ,iCoinsSeuil,wLongueurMinimaleChaine, uCoinsNoyau,
      iTypeRecalage==DL_RecalageAbsent?' ':(iTypeRecalage==DL_RecalageVoisinageSelectif?'R':'P'),
      fIsTexelChecking?'Y':'N');
  WritePrivateString(STRING_TitreClasseLectureSymbole, "present state"
    , szPresentState, szINIFileName);
}

/*--Classe TAnalyseLigne---------------------------------------------------*/
TAnalyseLigne::TAnalyseLigne ( TWindow *parent, TLigne lgn_ )
  : TPickupLine(parent, "Analyse frquence ligne", ASS_DROITE_HAUT, lgn_)
    ,  rTraceLigne(),  repIntensiteLigne()
{
SetAffichagePolygone(SW_SHOW, TPoint(sMarges.cx, 0));
wHSep1 =  rAffichagePolygone.bottom ;
wHSep2 =  wHSep1 + 3 * uHauteurLigne ;

unsigned int  wHSep3 = wHSep2 + 2 * uHauteurLigne ;
unsigned int  wLCS1S3 = 110 ;

wVSep1                  =  sMarges.cx * 2 + wLCS1S3 ;
rTraceLigne             
  =  TRect(sMarges.cx, wHSep3 + sMarges.cy
    , sEspaceUtile.cx - sMarges.cx, sEspaceUtile.cy - sMarges.cy);
pstEqu3Dr               
  =  new TStatic(this, 0, "Droite :"
    , sMarges.cx * 2 + uLargeurAffichagePolygone, 1
    , sEspaceUtile.cx - sMarges.cx
      - (sMarges.cx * 2 + uLargeurAffichagePolygone)
    , uHauteurLigne, USUALMAXLENSTRING);
pstEqu3Dr -> Attr.Style |= SS_LEFTNOWORDWRAP ;
pstEqu2Dr               
  =  new TStatic(this, 0, "Eq2 :"
    , sMarges.cx * 2 + uLargeurAffichagePolygone, 1 + uHauteurLigne
    , sEspaceUtile.cx - sMarges.cx
      - (sMarges.cx * 2 + uLargeurAffichagePolygone)
    , uHauteurLigne, USUALMAXLENSTRING);
pstEqu2Dr -> Attr.Style |= SS_LEFTNOWORDWRAP ;

unsigned int  wDivDrX = sMarges.cx + uLargeurAffichagePolygone ;
unsigned int  wDivDrWidth = (sEspaceUtile.cx - wDivDrX) / 2 ;

pstOriDr                   
  =  new TStatic(this, 0, "Ori :"
    , wDivDrX + sMarges.cx, 1 + 2 * uHauteurLigne, wDivDrWidth - sMarges.cx
    , uHauteurLigne, USUALMAXLENSTRING);
pstLongLigne               
  =  new TStatic(this, 0, ""
    , wDivDrX + wDivDrWidth + sMarges.cx, 1 + 2 * uHauteurLigne
    , wDivDrWidth - sMarges.cx, uHauteurLigne, USUALMAXLENSTRING);
pstOriDr -> Attr.Style     |= SS_LEFTNOWORDWRAP ;
pstLongLigne -> Attr.Style |= SS_LEFTNOWORDWRAP ;
pstLL                      
  =  new TStatic(this, ID_AL_Static_LL, "Long."
    , sMarges.cx, wHSep1, wLCS1S3, uHauteurLigne, USUALMAXLENSTRING);
pstLL -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstFL                      
  =  new TStatic(this, ID_AL_Static_FL, "Freq."
    , sMarges.cx, wHSep1 + uHauteurLigne, wLCS1S3, uHauteurLigne
    , USUALMAXLENSTRING);
pstFL -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstPL                      
  =  new TStatic(this, ID_AL_Static_PL, "Priode"
    , sMarges.cx, wHSep1 + 2 * uHauteurLigne, wLCS1S3, uHauteurLigne
    , USUALMAXLENSTRING);
pstPL -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstET                      
  =  new TStatic(this, ID_AL_Static_ET, "Ec. type"
    , wVSep1, wHSep1, wLCS1S3, uHauteurLigne, USUALMAXLENSTRING);
pstET -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstPm                      
  =  new TStatic(this, ID_AL_Static_Pm, "Pr. min."
    , wVSep1, wHSep1 + uHauteurLigne, wLCS1S3, uHauteurLigne
    , USUALMAXLENSTRING);
pstPm -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstPM                      
  =  new TStatic(this, ID_AL_Static_PM, "Pr. max."
    , wVSep1, wHSep1 + uHauteurLigne * 2, wLCS1S3, uHauteurLigne
    , USUALMAXLENSTRING);
pstPM -> Attr.Style        |= SS_LEFTNOWORDWRAP ;
pstRac                     
  =  new TStatic(this, ID_AL_Static_Rac
    , "Raccourcissement", sMarges.cx, wHSep2, wLCS1S3 * 2 + sMarges.cx
    , uHauteurLigne, USUALMAXLENSTRING);
pstRac -> Attr.Style       |= SS_LEFTNOWORDWRAP ;
pstSRac                    
  =  new TStatic(this, ID_AL_Static_SRac, ""
    , sMarges.cx, wHSep2 + uHauteurLigne, wLCS1S3, uHauteurLigne
    , USUALMAXLENSTRING);
pstSRac -> Attr.Style      |= SS_LEFTNOWORDWRAP ;
pstCritere                 
  =  new TStatic(this, ID_AL_Static_Critere, ""
    , sMarges.cx + wLCS1S3 + sMarges.cx, wHSep2 + uHauteurLigne, wLCS1S3
    , uHauteurLigne, USUALMAXLENSTRING);
pstCritere -> Attr.Style   |= SS_LEFTNOWORDWRAP ;
for ( unsigned u = 0 ; u++ ; u < SIZE_OF_PICTURES * 2 ) 
  auLigne [u] =  0 ;
wLongueurLigne          =  0 ;
xValeurSeuilAnalyseFreq =  0.0 ;
}

void TAnalyseLigne::NouvelleLigne ()
{
TPickupLine::NouvelleLigne();
if ( !lgn.Existe() ) 
  goto Exception ;

// Bloc scuris
  {
  TBipoint  bipLgn (lgn) ;
  if ( !MemoLigne(source, bipLgn, auLigne, &wLongueurLigne) ) 
    goto Exception ;
  char  szTmp0 [USUALMAXLENSTRING];
  sprintf(szTmp0, "%d pixels", wLongueurLigne);
  pstLL -> SetText(szTmp0);
  TDroite dr (bipLgn) ;
  sprintf(szTmp0, "Droite : %g x %c %g y %c %g.", dr.a
    , dr.b >= 0 ? '+' : '-', fabs(dr.b), dr.c >= 0 ? '+' : '-', fabs(dr.c));
  pstEqu3Dr -> SetText(szTmp0);
  if ( dr.b ) 
    sprintf(szTmp0, "Equ. lin. : y= %g x %c %g.", - dr.a / dr.b
      , - dr.c / dr.b >= 0 ? '+' : '-', fabs( - dr.c / dr.b));
  else if ( dr.a ) 
    sprintf(szTmp0, "Equ. lin. : x= %g.", - dr.c / dr.a);
  else 
    *szTmp0 =  0 ;
  pstEqu2Dr -> SetText(szTmp0);
  if ( dr.Existe() ) 
    {
    float xOriDroite = dr.VecteurPorteur().Orientation() / M_PI * 180.0 ;
    if ( xOriDroite <= - 90.0 ) 
      xOriDroite += 90.0 ;
    else if ( xOriDroite > 90.0 ) 
      xOriDroite -= 90.0 ;
    sprintf(szTmp0, "Orient.: %g.", xOriDroite);
    pstOriDr -> SetText(szTmp0);
    }
  else 
    pstOriDr -> Clear();
  sprintf(szTmp0, "Long.: %g px.", lgn.Longueur());
  pstLongLigne -> SetText(szTmp0);
  InvalidateRect(rTraceLigne);
  int           iFreq = 0 ;
  float         xPeriode = 0.0, xEcartTypePeriode = 0.0 ;
  unsigned int  wPeriodeMin = 0, wPeriodeMax = 0 ;
  BOOL          fRacD = 0, fRacF = 0 ;
  float         xSeuilRejet = 0.0 ;
  BOOL          fCompatibilite = 0 ;
  xValeurSeuilAnalyseFreq =  Moyenne_courbe(auLigne, wLongueurLigne);
  unsigned int  wReadingProperties = 0 ;
  wReadingProperties &= ~SMB_PROP_OriginA_D ; // Position de l'orgine non connue
  wReadingProperties |= (SMB_PROP_Appearance | SMB_PROP_AppPositive); // Apparence connue et positive.
  if ( !AnalyseFrequenceLigne(auLigne, wLongueurLigne
          , xValeurSeuilAnalyseFreq, &iFreq, &xPeriode, &xEcartTypePeriode
          , &wPeriodeMin, &wPeriodeMax, &fCompatibilite, &fRacD, &fRacF
          , &xSeuilRejet, wReadingProperties)
        && !(fCompatibilite & ANLFREQ_MSG_NonCompatible) ) 
    goto Exception ;
  float xCritere = 1.0 ;
  if ( !(fCompatibilite & ANLFREQ_MSG_NonCompatible) ) 
    if ( !CritereValiditeFrequenceDUneLigne(iFreq, xPeriode
          , xEcartTypePeriode, wPeriodeMin > 255 ? 255 : wPeriodeMin
          , wPeriodeMax > 255 ? 255 : wPeriodeMax, &xCritere) ) 
      goto Exception ;
  sprintf(szTmp0, "Freq. : %d.", iFreq);
  pstFL -> SetText(szTmp0);
  sprintf(szTmp0, "Periode : %g.", xPeriode);
  pstPL -> SetText(szTmp0);
  sprintf(szTmp0, "Ec. type : %g.", xEcartTypePeriode);
  pstET -> SetText(szTmp0);
  sprintf(szTmp0, "Per. min. : %d.", wPeriodeMin);
  pstPm -> SetText(szTmp0);
  sprintf(szTmp0, "Per. max. : %d.", wPeriodeMax);
  pstPM -> SetText(szTmp0);
  if ( fCompatibilite & ANLFREQ_MSG_RaccAveugle ) 
    strcpy(szTmp0, "Raccourcissement aveugle.");
  else 
    sprintf(szTmp0, "Raccourcissement : %c %c .", fRacD ? 'D' : ' '
      , fRacF ? 'F' : ' ');
  pstRac -> SetText(szTmp0);
  sprintf(szTmp0, "Seuil rejet : %g.", xSeuilRejet);
  pstSRac -> SetText(szTmp0);
  sprintf(szTmp0, "Critre : %g.", xCritere);
  pstCritere -> SetText(szTmp0);
  return ;
  }
Exception : 
    {
    lgn =  LigneErreur ;
    pstLL -> SetText("Longueur");
    pstFL -> SetText("Frequence");
    pstPL -> SetText("Periode");
    pstET -> SetText("Ec. type");
    pstPm -> SetText("Per. min.");
    pstPM -> SetText("Per. max.");
    pstRac -> SetText("Raccourcissement");
    pstSRac -> SetText("Seuil rejet");
    }
  }

void TAnalyseLigne::Paint ( TDC &dc, BOOL erase, TRect &rect )
{
TPickupLine::Paint(dc, erase, rect);
dc.SetBkMode(TRANSPARENT);

TRect rMTrace ;

TraceLgdedCourbe(auLigne, wLongueurLigne, rTraceLigne, dc, "Indice"
  , "Luminance", 0, wLongueurLigne ? wLongueurLigne - 1 : 0, 0
  , 255, 0, 255, 0, 0, 10, 10, 0, &rMTrace, &repIntensiteLigne);

complex zDepBarreSeuil (0.0, xValeurSeuilAnalyseFreq)
  , zArrBarreSeuil (wLongueurLigne, xValeurSeuilAnalyseFreq) ;

dc.MoveTo(repIntensiteLigne.NRa2Rb(zDepBarreSeuil));
dc.LineTo(repIntensiteLigne.NRa2Rb(zArrBarreSeuil));
}

void TAnalyseLigne::EvMouseMove ( UINT a, TPoint &point )
{
if ( rTraceLigne.Contains(point) ) 
  {
  complex z = repIntensiteLigne.Rb2Ra(point);
  point =  TPoint(real(z), imag(z)); // Approximation par troncature.
  }
TPickupLine::EvMouseMove(a, point);
}

BOOL TDetectLignes::SauvegardeTableLignes ( ligne_AB *algnTable
    , unsigned char *puCible )
{
if ( !algnTable || !Numeroplan(puCible) ) 
  return ECHEC ;

unsigned int  *pwCible = (unsigned int *)puCible ;

*pwCible++ =  wNbl ;

ligne_AB  *plgnCible = (ligne_AB *)pwCible ;

for ( unsigned int w = 0 ; w < 65534L / sizeof(ligne_AB) && w < wNbl ; w++ ) 
  plgnCible [w] =  algnTable [w];
return SUCCES ;
}

BOOL TDetectLignes::ChargeTableLignes ( unsigned char *puSource
    , ligne_AB *algnTable )
{
if ( !Numeroplan(puSource) ) 
  return ECHEC ;

unsigned int  *pwSource = (unsigned int *)puSource ;

wNbl =  *pwSource++ ;

ligne_AB  *plgnSource = (ligne_AB *)pwSource ;

for ( unsigned int w = 0 ; w < 65534L / sizeof(ligne_AB) && w < wNbl ; w++ ) 
  algnTable [w] =  plgnSource [w];
return SUCCES ;
}

//-----------------------------------------------------------------------
//                   Nouvelle classe TDetecteCoin
//-----------------------------------------------------------------------
TDetecteCoin::TDetecteCoin ()
  : TPickupPoint("Dtecteur de coin", ASS_DROITE_BAS)
{
SetAffichagePolygone(SW_SHOW, TPoint(sMarges.cx, sMarges.cy));
Copie_plan(source, destin);
psteNoyau    
  =  (TLabeledEditNum *)new TLabeledEditNum(this, "Noyau :"
    , ID_DC_Noyau, 3, sMarges.cx, sMarges.cy * 2 + uHauteurEdit
    , 13 * uLargeurCar, 5 * uLargeurCar, 10, 15);
psteSeuilSat 
  =  (TLabeledEditNum *)new TLabeledEditNum(this, "Saturation :"
    , ID_DC_Noyau, 128, sMarges.cx, sMarges.cy * 2 + uHauteurEdit * 2
    , 13 * uLargeurCar, 5 * uLargeurCar, 10, 15);
}

TDetecteCoin::~TDetecteCoin ()
{
delete psteNoyau ;
delete psteSeuilSat ;
}

void TDetecteCoin::NouveauPolygone ()
{
TPickupPoint::NouveauPolygone();

TCoordonnee   p (pM) ;
unsigned char uNoyau ;
int           iSeuilSaturation ;

if ( !psteNoyau -> e.GetValue(&uNoyau) ) 
  {
  uNoyau =  3 ;
  psteNoyau -> e.SetValue(uNoyau);
  }
if ( !psteSeuilSat -> e.GetValue(&iSeuilSaturation) ) 
  {
  iSeuilSaturation =  128 ;
  psteSeuilSat -> e.SetValue(iSeuilSaturation);
  }
if ( RecaleSurCoin(&p, uNoyau, source, iSeuilSaturation) ) 
  DessineRetic(source, p, destin);
else 
  DessineRetic(source, pM, destin);
Fenetre -> Visim(this, 1, destin);
SetActiveWindow();
}

int TDetectLignes::CorrigeQuadrilatere ( unsigned char *puSource )
{
if ( !Numeroplan(puSource) || !ABCD.Existe() ) 
  return FAILURE ;
else if ( iTypeRecalage == DL_RecalagePremierRecul ) 
  {
  TQuadrilatere qCorrige ;
  EstimateurImageCoinDroit(puSource, iCoinsSeuil, PlanSuiv(puSource, 2));
  
  //    sprintf(TableFich[(plan+2)%nbplan],"Estimateur de coins");
  RechercheCoins(ABCD, PlanSuiv(puSource, 2), &ABCD);
  return SUCCESS ;
  }
else if ( iTypeRecalage == DL_RecalageVoisinageSelectif ) 
  return RecaleSpecifiqueHeliophobe4Coins(&ABCD, iCoinsSeuil, uCoinsNoyau
    , puSource, ABCD.EstDroitEtPasOblique());
else 
  return SUCCESS ;
}
