/**********************************************************************/
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRSLIGN_H
#define WIRSLIGN_H

#include "wsysutil.h"
#include "wirspick.h"
#include "symbole.h"

#define UTIL_DETECTLIGNES    10

/*--TDetectLignes--------------------------------------------------------*/
class TDetectLignes : public TAssociatif
  {
  public:
    char cTypeLaplacienCalcule;
    char cTypeLaplacien;
    int iNoLigneEnCours;
    int iPartition, iCoinsSeuil, iTypeRecalage;
    unsigned char uSeuilZC, uNoPlanImage, uNoPlanAmpl, uNoPlanDirExp,
        uNoPlanChain, uCoinsNoyau;
    unsigned int wNbTexelsTotal, wNbTexelsValides, wPeriodeVraissemblanceMax;

    BOOL fConsistance, fIsTexelChecking;
    char szImageUtilisee[USUALMAXLENSTRING];
    TQuadrilatere ABCD;
    TDetectLignes(TWindow* parent);
    ~TDetectLignes();
    void CmTextureCall( WPARAM id );
    void CmPlanBitContour();
    void CmPlanBitTexture();
    int CorrigeQuadrilatere(unsigned char *puSource);
   void CmMenu(WPARAM id);
//   void CmCorrigeQuad(int &fMiseAJourPlan, int &fConsistance);

    virtual void NouveauPoint();
    void SaveDatasToLectureSymbole();
    void OutsiderReleveOptions();
  protected:
    TCheckBox *pchkAuthorizeTexels;
    TRadioButton far *pOptionLaplacienChar4, *pOptionLaplacienFloat8, *pOptionLaplacien4x4v4, *pbtContourBinaire;
    TButton *pbtPlanBitContour, *pbtPlanBitTexture;
    TStatic *pstNbTexelsTotal, *pstNbTexelsSymbole, *pstPeriodeTexels, *pstPartSymbole;

    TLabeledEditNum far *pestDetecteCoinsSeuil, *pestDetecteCoinsNoyau,
        *pestLongueurMinimaleChaine;
//    TEditNum *pestNbPartTexture, *pestNbTexelsValides;
    TEdit *peImageName;
    TComboBoxItems *pcmbRecalageQuad;
    TEditNumCR far *pNbPart;
    TEditNumCR far *pParametreSeuilZC, *peSeuilEARaccPar, *peSeuilEARaccOrth;
//        *peSeuilEAUnification;
    TLigne Ligne;
    unsigned int wSepVert, wSepVert2, wSepHor1, wSepHor2, wSepHor3;
    TRect rRechGlob, rPteLgn, rRechSmb,rTexels, rMiscStates;
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void SetupWindow();
    virtual bool CanClose();
    virtual void ReleveOptions(void);
    virtual void AfficheOptions(void);
    virtual void SauvegardeOptions(void);
    virtual void ChargeOptions(void);
    BOOL SauvegardeTableLignes(ligne_AB *algnTable,unsigned char *puCible);
    BOOL ChargeTableLignes(unsigned char *puSource,ligne_AB *algnTable);
    void CmSuicideMenu(WPARAM id);
    void EvTexelSwitch();
    DECLARE_RESPONSE_TABLE(TDetectLignes);
 };
//--TAnalyseLigne-----------------------------------------------------------
class TAnalyseLigne : public TPickupLine
  {
  public:
    unsigned int wLongueurLigne;
    float xValeurSeuilAnalyseFreq;
    unsigned char auLigne[SIZE_OF_PICTURES*2];
    TAnalyseLigne(TWindow *parent, TLigne=LigneErreur);
    virtual void NouvelleLigne();
    private :
      unsigned int wHSep1, wHSep2, wVSep1;//, wVSep2, wVSep3;
      TStatic *pstLL, *pstFL, *pstPL, *pstET, *pstPm, *pstPM, *pstRac, *pstSRac,
          *pstCritere, *pstEqu3Dr, *pstEqu2Dr, *pstOriDr, *pstLongLigne;
      TRect rTraceLigne;
      TReperage repIntensiteLigne;
      virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
      virtual void EvMouseMove(UINT a, TPoint& point);
  };
//--TDetecteCoin-----------------------------------------------------------
class TDetecteCoin : public TPickupPoint
  {
  public :
    TDetecteCoin();
    ~TDetecteCoin();
    virtual void NouveauPolygone();
    TLabeledEditNum *psteNoyau, *psteSeuilSat;
  };
/*-----------------------------------------------------------------------*/
/*                     Variables  exporter                              */
/*-----------------------------------------------------------------------*/
extern TDetectLignes far *pDetectLignes;
#endif // 
