/**********************************************************************/
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRSPICK_H
#define WIRSPICK_H

#include "wgeometr.h"
#include "wsysutil.h"
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
//--TPickupPolygone---------------------------------------------------------
class TPickupPolygone : public TAssociatif
  {
  public:
    static unsigned char uLargeurAffichagePolygone;
    unsigned char uNbPoints;
    char szLibellePolygone[USUALMAXLENSTRING];
    BOOL fShowPolygon, fShowMenu, fLinkAffim; // Default is TRUE (inhibition flags).
    TRect rAffichagePolygone;
    TCoordonnee *aptPolygone;
    TEditCR **apstAffichagePolygone;
    TPickupPolygone(TWindow* parent, char szTitre[], unsigned char uNbPoints,
      char *szLibellePolygone_in, char cType=0);
    TIcon *picn;
    ~TPickupPolygone();
    virtual void GetWindowClass( WNDCLASS& wc );
    char *GetClassName();
    void SetAffichagePolygone(int cmdShow,TPoint ptAffichagePolygone);
    void CmMenuEnvironnement(WPARAM id);
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void SetupWindow();
    virtual void ModificationCoordonnee();
    virtual void NouveauPoint();
    virtual void NouveauPolygone();
    DECLARE_RESPONSE_TABLE(TPickupPolygone);
  };
/*--TPickupPoint----------------------------------------------------------*/
class TPickupPoint : public TPickupPolygone
  {
  public:
    TCoordonnee pM;
    TPickupPoint(char szTitre[], char cType=0);
    void NouveauPolygone();
  };
/*--TPickupLine----------------------------------------------------------*/
class TPickupLine : public TPickupPolygone
  {
  public:
    TLigne lgn;
    TPickupLine(TWindow* parent, char szTitre[], char cType=0,
        TLigne lgn_=LigneErreur);
    virtual void NouveauPolygone();
    virtual void NouvelleLigne();
  };
/*--TPickupQuad----------------------------------------------------------*/
class TPickupQuad : public TPickupPolygone
  {
  public:
    TQuadrilatere ABCD;
    TPickupQuad(TWindow* parent, char szTitre[], char cType=0);
    virtual void NouveauPolygone();
    virtual void NouveauQuad();
  };


/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*//*
*/
void AfficheValPoint(TPoint ptValue, TPoint ptPosition, TDC& dc, char cNom);
void AfficheValPoint(TPoint ptValue, TStatic *pstEtiquette);
void AfficheValLigne(TLigne lgn, TPoint ptPos, TDC& dc);
void AfficheValQuad(TQuadrilatere ABCD, TPoint ptPos, TDC& dc);
void AfficheValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TStatic **apstAffichagePolygone);
void AfficheValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TPoint ptPos, TDC& dc);
void ReleveValPoint(TPoint *pptValue, TStatic *pstEtiquette);
void ReleveValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TStatic **apstAffichagePolygone);
//BIT SelectHardCopyFile();
#endif // IRSOUTIL_H
