#include "myowlall.h"
#include "baptiall.h"

#pragma hdrstop

#define MODULE_NAME "wirsymb"
 /* **********************************************************************
    *                       W I R I S       . C P P                      *
    *--------------------------------------------------------------------*
    *    Fonction       : Fonctions conversationnelles pour Iris         *
    *                                                                    *
    *--------------------------------------------------------------------*
    *    Auteur         : Baptiste MARCEL       			 *    *
    *    Dvelopp le   : Printemps 1996                                 *
    *    Dernire modif.: voir date fichier                              *
    *********************************************************************/ 

/*
       // Inclusions bibliothques standards
   #include <io.h>
   #include <stdio.h>
   #include <dir.h>
   //#include <math.h>
   #include <values.h>
   
   //  Inclusions bibliothques Object Windows
   //#include <owl\applicat.h>
   #include <owl\inputdia.h>
   //#include <owl\combobox.h>
   //#include <owl\scroller.h>
   #include <owl\dialog.h>
   #include <owl\dc.h>
   #include <owl\edit.h>
   #include <owl\framewin.h>
   
   // Inclusions bibliothques DOS
   */
// Inclusion bibliothques Image
#include "wsysutil.h"
#include "wgttsi.h"
#include "wappbase.h"
#include "wappbase.rh"
#include "wmain.h"

//  Inclusions bibliothques Iris
/*
   #include "base.h"
   #include "strutil.h"
   #include "sysctr.h"
   #include "wcontour.h"
   #include "wgeometr.h"
   #include "wirspick.h"
   */
#include "anlfreq.h"
#include "filutil.h"
#include "anallec.h"
#include "piadiv.h"
#include "strtool.h"
#include "wintrac.h"
#include "wirslign.h"
#include "wirssymb.h"
#include "wirsutil.h"
#include "wsystool.h"

/* #include "scaltool.h"
   #include "wsymbole.h"
   #include "wsystool.h"
   
   */
#include "iris.rc"

//  Inclusions bibliothques Sbastien
#include "cortex.rch"
#include "analtex.h"
//#include "ctxoutil.h"
#include "poly.h"

//-----------------------------------------------------------------------

char szSymboleAccueilDef[MAXPATH]="";           
int fAutoRedressDef = 0, fSupportHorlogeDef=1
  ,  wReadingSymbolPropertiesDef = 
          SMB_PROP_Origin
	| SMB_PROP_AppPositive 
	| SMB_PROP_Appearance 
	| SMB_PROP_ClockWise
	| SMB_PROP_Clock  ; // 496 = 0x1F0=0b_0000_0001_1111_0000 = (16+32+64+128+256)d;


BOOL                AfficheMatriceSymbole (TMatrix *pSymbole, TRect rSymbole, TDC &dc) ;
BOOL                GetSymboleFileName (TWindow *pFenetrePorteuse
  , char szSymbolFileName [], BOOL MustExist) ;

int PickAssociatedFrequency (char *szImag,unsigned char *puFreq);

TLectureSymbole     far *pLectureSymbole = NULL ;
TComparateurSymbole *TComparateurSymbole::pw = NULL ;
//-----------------------------------------------------------------------
/*                   Nouvelle classe TDetectLignes                       */
/*--Systme--------------------------------------------------------------*/
//-----------------------------------------------------------------------
//                   Nouvelle classe TLectureSymbole
//--Systme--------------------------------------------------------------
                    DEFINE_RESPONSE_TABLE1 (TLectureSymbole, TPickupQuad) EV_COMMAND_AND_ID (
    CM_LS_ChargeSymbole, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_LectureSymbole, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_GeneSpont, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_Transfert, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_SymbolePleinImage, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_SauvegardeSymbole, CmMenu)
  , EV_COMMAND_AND_ID (CM_LS_DressageSymbole, CmMenu)
  , // Recadrage
    EV_COMMAND_AND_ID (CM_LS_Comparaison, CmMenu)
  , // Comparaison (avec recadrage)
    EV_COMMAND_AND_ID (CM_LS_ZoomSymbole, CmMenu)
  , // Aka Agrand
    EV_COMMAND_AND_ID (CM_LS_SymbolReport, CmMenu)
  , // Aka Agrand
    EV_COMMAND (ID_LS_SymbolComp, CmSymbolComp)
  , // Comparateur de symbole.
    EV_COMMAND (EV_NouvelleMatrice, NouvelleMatrice)
  , EV_COMMAND_AND_ID (ID_LS_Frequence, CmUserIntervention)
  , EV_COMMAND_AND_ID (ID_LS_NbOctets, CmUserIntervention)
  , EV_COMMAND_AND_ID (ID_LS_TexteSymbole, CmUserIntervention)
  , EV_COMMAND_AND_ID (ID_LS_NumSymbole, CmUserIntervention)
  , EV_COMMAND (ID_LS_ModifTexteSymbole, Ev_ModifTexteSymbole)
  , EV_COMMAND (ID_LS_ModifNumeriqueSymbole, Ev_ModifNumeriqueSymbole)
  , EV_WM_LBUTTONDBLCLK, END_RESPONSE_TABLE ;

void TLectureSymbole::SetupWindow ()
{
TPickupQuad::SetupWindow();
pcmbPariteFreq -> AddItem(ID_AQ_PariteFreq, "Parit inconnue");
pcmbPariteFreq -> AddItem(ID_AQ_PariteFreq + SMB_PROP_Parity, "Impaire");
pcmbPariteFreq -> AddItem(
  ID_AQ_PariteFreq + SMB_PROP_Parity + SMB_PROP_Even, "Paire");
// ^^^^^^... Ces ID ne sont que des numros  porte locale
fOptionsAccessibles =  TRUE ;
AfficheOptions();
if ( fConsistance )
  NouvelleMatrice();
}

TLectureSymbole::TLectureSymbole ( TWindow *parent )
  : TPickupQuad(parent, STRING_TitreClasseLectureSymbole, ASS_DROITE)
    ,  Symbole(),  rEspaceTxt(),  rTxt(),  rEspaceNum(),  rNum()
    ,  rEspaceDivComment(),  rDivComment(),  rValFreq(),  rEspaceSymbole()
    ,  rSymbole(),  rButtModifTxt(),  rButtModifNum(),  repSymbole()
{
fConsistance        =  FAUX ;
fOptionsPresentes   =  TRUE ;
fOptionsAccessibles =  FALSE ; // Indique que les options contenues dans les TControl (checkbox, TCombo... ne sont pas valides, elles le seront ds que le SetupWindow sera termin.
pLectureSymbole     =  this ;
fImageProcess = 1;

TPoint  ptAffABCD(sMarges.cx, sMarges.cy + uHauteurLigne);

SetAffichagePolygone(SW_SHOW, ptAffABCD);
wSepVert =  sEspaceUtile.cx / 2 ;
wSepHor0 =  rAffichagePolygone.bottom ;
wSepHor1 =  wSepHor0 + uHauteurEdit + 2 * sMarges.cy ;
rEspaceDivComment.Set(0, 0, wSepVert, wSepHor1);
rDivComment =  rEspaceDivComment.InflatedBy( - sMarges);
rFreq       
  =  TRect(
    TPoint(rEspaceDivComment.left + sMarges.cx
      , rDivComment.top + uHauteurLigne + uHauteurEdit * 4 + sMarges.cy
        + uDLE)
    , TSize(6 * uLargeurCar, uHauteurLigne));
wSepHor2    =  wSepHor1 + (sEspaceUtile.cy - wSepHor1) / 3 ;

/* Pour un mme symbole, la rep. numerique prend 4x plus de place que la
   representation textuelle.
   */
rEspaceTxt.Set(0, wSepHor1, sEspaceUtile.cx, wSepHor2);
rEspaceNum.Set(0, wSepHor2, sEspaceUtile.cx, sEspaceUtile.cy);
rTxt        =  rEspaceTxt.InflatedBy( - sMarges);
rTxt.bottom += sMarges.cy ;
rTxt.right  -= sMarges.cx * 2 ;
rNum        =  rEspaceNum.InflatedBy( - sMarges);
rNum.right  -= sMarges.cx * 2 ; // espace rserv pour les boutons.
rButtModifTxt.Set(rTxt.right, rTxt.top, rTxt.right + sMarges.cx * 2
  , rTxt.bottom);
rButtModifNum.Set(rNum.right, rNum.top, rNum.right + sMarges.cx * 2
  , rNum.bottom);
rEspaceSymbole.Set(wSepVert, 0, sEspaceUtile.cx, wSepHor1);
rSymbole =  rEspaceSymbole.InflatedBy( - sMarges);
if ( Symbole.GetSize() ) 
  repSymbole.SetRa(complex(rSymbole.left, rSymbole.top)
    , complex(0, (float)rSymbole.Height() / Symbole.GetSize())
    , complex((float)rSymbole.Width() / Symbole.GetSize(), 0));

char  sz0 [USUALMAXLENSTRING]; // ="Frq.:";

rValFreq
  =  TRect(
    TPoint(rDivComment.left + 6 * uLargeurCar
      , rDivComment.top + uHauteurLigne + uHauteurEdit * 4 + sMarges.cy)
    , TSize(uLargeurCar * 4, uHauteurEdit));
strcpy(sz0, "Nb. oct.:");
new TStatic(this, ID_LS_MotFrequence, sz0
  , rEspaceDivComment.left + rEspaceDivComment.Width() / 2
  , rDivComment.top + uHauteurLigne + uHauteurEdit * 4 + sMarges.cy + uDLE
  , rDivComment.Width() / 2, uHauteurLigne, 13);
rValNbOct                
  =  TRect(
    rValFreq.TopRight().OffsetBy(sMarges.cx + strlen(sz0) * uLargeurCar, 0)
    , TSize(uLargeurCar * 6, uHauteurEdit));
peTxtSmb                 
  =  new TEdit(this, ID_LS_TexteSymbole, "", rTxt.left
    , rTxt.top, rTxt.Width(), rTxt.Height(), NombreCaractereMaxSymbole + 1
    , TRUE);
peNumSmb                 
  =  new TEditNumCR(this, ID_LS_NumSymbole, MINFLOAT
    , rNum, NombreCaractereMaxSymbole * 4 + 1, TRUE);
pbModifTxt               
  =  new TButton(this, ID_LS_ModifTexteSymbole, ""
    , rButtModifTxt.left, rButtModifTxt.top, rButtModifTxt.Width()
    , rButtModifTxt.Height());
pbModifNum               
  =  new TButton(this, ID_LS_ModifNumeriqueSymbole, ""
    , rButtModifNum.left, rButtModifNum.top, rButtModifNum.Width()
    , rButtModifNum.Height());
pchkAutoRedress
  =  new TCheckBox(this, ID_CHILD, "Redress."
    , rAffichagePolygone.right + sMarges.cx, rAffichagePolygone.top
    , 14 * uLargeurCar, uHauteurLigne);

pchkSupportHorloge
  =  new TCheckBox(this, ID_CHILD, "Sup.Horloge"
    , rAffichagePolygone.right + sMarges.cx
    , rAffichagePolygone.top + uHauteurLigne, 14 * uLargeurCar
    , uHauteurLigne);


peNumSmb -> fInhibRC     =  MARCHE ;
peTxtSmb -> Attr.Style   |= ES_WANTRETURN ;
peNumSmb -> Attr.Style   |= ES_WANTRETURN ;
peFreq                   
  =  new TEditNumCR(this, ID_LS_Frequence
    , MINFLOAT // WSYSUTIL.H
    , rValFreq, 10, FALSE);
peNbOct                  
  =  new TEditNumCR(this, ID_LS_NbOctets, MINFLOAT
    , rValNbOct, 15, FALSE);
peNbOct -> Attr.Style    |= WS_BORDER ;
peTxtSmb -> Attr.Style   |= WS_BORDER ;
peNumSmb -> Attr.Style   |= WS_BORDER ;
peFreq -> Attr.Style     |= WS_BORDER ;
*szSymbolName            =  *szImageUtilisee = 0 ;
pbModifNum               
  =  new TButton(this, ID_LS_ModifNumeriqueSymbole, ""
    , rButtModifNum.left, rButtModifNum.top, rButtModifNum.Width()
    , rButtModifNum.Height());
pbtSymbolName            
  =  new TButton(this, ID_LS_SymbolComp, szSymbolName
    , rAffichagePolygone.right, rAffichagePolygone.top + uHauteurLigne * 3
    , rSymbole.left - rAffichagePolygone.right, uHauteurLigne);


pcmbPariteFreq
  =  new TComboBoxItems(this, ID_LS_PariteFreq
    , rAffichagePolygone.right, rAffichagePolygone.top + uHauteurLigne * 4
    , rSymbole.left - rAffichagePolygone.right
    , uHauteurEdit + uHauteurLigne * 3, CBS_DROPDOWNLIST
    , USUALMAXLENSTRING / 2);
}

//-----------------------------------------------------------------------
TLectureSymbole::~TLectureSymbole ()
{
pLectureSymbole =  NULL ;
if ( TComparateurSymbole::pw ) 
  TComparateurSymbole::pw -> ShutDownWindow();
delete pcmbPariteFreq ;
}

void TLectureSymbole::AfficheOptions ()
{
if ( !fOptionsAccessibles ) 
  return ; // Les TControls ne sont pas encore initialiss.

//  TPickupQuad::AfficheOptions();
pchkSupportHorloge -> Show(fImageProcess?SW_SHOW:SW_HIDE);
pchkSupportHorloge -> SetCheck(fSupportHorloge ? BF_CHECKED : BF_UNCHECKED);
pchkAutoRedress -> Show(fImageProcess?SW_SHOW:SW_HIDE);
pchkAutoRedress -> SetCheck(fAutoRedress ? BF_CHECKED : BF_UNCHECKED);

unsigned int  wPariteSymbole = ID_AQ_PariteFreq ;

if ( wReadingSymbolProperties & SMB_PROP_Parity )
  {
  wPariteSymbole += SMB_PROP_Parity ;
  if ( wReadingSymbolProperties & SMB_PROP_Even )
    wPariteSymbole += SMB_PROP_Even ;
  }
pcmbPariteFreq -> SetSelItem(wPariteSymbole);
pcmbPariteFreq -> Show(fImageProcess?SW_SHOW:SW_HIDE);
pbtSymbolName -> Show(fImageProcess?SW_SHOW:SW_HIDE);
}

void TLectureSymbole::Paint ( TDC &dc, BOOL erase, TRect &rect )
{
TPickupQuad::Paint(dc, erase, rect);

char  szTamp0 [USUALMAXLENSTRING];
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT]
  , szNameExt [MAXFILE + MAXEXT];

fnsplit(szImageUtilisee, szDrive, szDir, szName, szExt);
fnmerge(szNameExt, "", "", szName, szExt);
if ( *szName
      && (IsFileExtension(szExt, "img")
            || IsFileExtension(szExt, "bmp")
            || IsFileExtension(szExt, "smb")) )
  dc.TextOut(rAffichagePolygone.right + sMarges.cx
    , rAffichagePolygone.top + uHauteurLigne * 2, strlwr(szNameExt));
fnsplit(szSymbolName, szDrive, szDir, szName, szExt);
fnmerge(szNameExt, "", "", szName, szExt);
pbtSymbolName -> SetCaption(strlwr(szNameExt));
dc.TextOut(rFreq.TopLeft(), "Frq.:");
if ( wFreqForcee )
  {
  dc.SelectObject(TPen(TColor::LtRed));
  dc.MoveTo(rFreq.TopLeft());
  dc.LineTo(rFreq.BottomRight());
  dc.MoveTo(rFreq.TopRight());
  dc.LineTo(rFreq.BottomLeft());
  dc.RestorePen();
  }
/*
   new TStatic(this,ID_LS_MotFrequence,sz0,
               rDivComment.left,
               rDivComment.top+uHauteurLigne+uHauteurEdit*4+sMarges.cy+uDLE,
               rDivComment.Width()/2,uHauteurLigne,13);
   */
if ( fConsistance )
  {
  wsprintf(szTamp0, "Nouveau point (%d,%d).", posx, posy);
  if ( fLinkAffim )
    dc.TextOut(rDivComment.TopLeft(), szTamp0);
  }
//if ( Symbole.GetData() )
fConsistance =  AfficheMatriceSymbole(&Symbole, rSymbole, dc);
}

void TLectureSymbole::EvLButtonDblClk ( uint modKeys, TPoint &point )
{
if ( rSymbole.Contains(point) && Symbole.GetSize() )
  {
  complex       z = repSymbole.Rb2Ra(point);
  unsigned int  i = NFloorR(real(z)), j = NFloorR(imag(z));
  unsigned char u = Symbole.GetCell(i, j);
  if ( u & SMB_CELL_Mark )
    Symbole.SetCell(i, j, u & ~SMB_CELL_Mark); // Switch to "unmarked"
  else 
    Symbole.SetCell(i, j, u | SMB_CELL_Mark); // Switch to "marked"
  InvalidateMatrice();
  }
TPickupQuad::EvLButtonDblClk(modKeys, point);
}

void TLectureSymbole::EvMouseMove ( UINT a, TPoint &point )
{
if ( rSymbole.Contains(point) && Symbole.GetSize() ) 
  {
  complex z = repSymbole.Rb2Ra(point);
  point =  TPoint(real(z), imag(z)); // Approximation par troncature.
  TPickupQuad::EvMouseMove(a, point);
  }
else 
  TPickupQuad::EvMouseMove(a, point);
}

/*--Nouvelles fonctionnalits--------------------------------------------*/
void TLectureSymbole::InvalidateMatrice ()
{
if ( TComparateurSymbole::pw ) 
  TComparateurSymbole::pw -> ProcessStat(); // This one will call (NouvelleMatrice)
else 
  NouvelleMatrice();
}

void TLectureSymbole::CmUserIntervention ( WPARAM id )
{

//  static int i=0, j=0,k=0;
//  MTrace("CmUserIntervention",i++,1030);
ReleveOptions();

unsigned int  wFreq = 0, wOct = 0 ;
float         xOct = 0.0 ;

switch ( id ) 
  {
  case ID_LS_Frequence : 
    
    //      MTrace("ID_LS_Frequence n",j++,1030);
    if ( peFreq -> GetValue(&wFreq) && wFreq >= 3 ) 
      {
      Symbole.GenerationSpontanee(wFreq - 2);
      if ( !(fConsistance = Symbole.Encadrement()) ) 
        Symbole.Set();
      wFreqForcee =  0 ;
      InvalidateRect(rFreq.InflatedBy(1, 1), TRUE);
      strNcpy(szSymbolName, ">random", sizeof(szSymbolName));
      }
    InvalidateMatrice();
    break ;
  case ID_LS_NbOctets : 
    
    //      MTrace("ID_LS_NbOctets n",k++,1030);
    if ( peNbOct -> GetValue(&xOct) ) 
      {
      wOct =  NFloorR(xOct >= 0.0 ? xOct : 0.0);
      peFreq -> SetValue(
        FrequencePourTantDOctets(wOct <= MAXINT ? wOct : MAXINT));
      CmUserIntervention(ID_LS_Frequence);
      }
    else 
      InvalidateMatrice();
    break ;
  default : 
    MErreur("MErreur code", 863);
    break ;
  }
}

void TLectureSymbole::NouvelleMatrice ( void )
{
BOOL  fRes = SUCCES ;

if ( Symbole.GetData() ) 
  {
  if ( fAutoRedress ) 
    Symbole.PivoteHorlogeRail();
  repSymbole.SetRa(complex(rSymbole.left, rSymbole.top)
    , complex(0, (float)rSymbole.Height() / Symbole.GetSize())
    , complex((float)rSymbole.Width() / Symbole.GetSize(), 0));
  float         xNbOct = NbROctetsPourTelleFrequence(Symbole.GetSize());
  unsigned int  wNbOct = NbOctetsPourTelleFrequence(Symbole.GetSize());
  char          far *acTamponTexte = (char *)malloc(wNbOct + 1);
  char          far *szTamponNumerique = (char *)malloc(4 * wNbOct + 1);
  char          far *acTamponWrappedText = (char *)malloc(wNbOct + 15 + 1);
  char          far *acTamponWrappedNumerList = (char *)malloc(4 * wNbOct + 15 + 1);
  do 
    {
    if ( !(fConsistance = fRes
          = Octavisation(&Symbole, acTamponTexte, wNbOct)) ) 
      break ;
    
    /* Fabrique la liste des valeurs.*/
    if ( !(fRes = fConsistance
          = NumeraliseListeOctets(szTamponNumerique, acTamponTexte, wNbOct)) ) 
      break ;
    
    /* Fabrique le texte imprimmable.TextualiseListeOctets doit se faire apres car il modifie les caractres pour
       les rendre imprimmables.*/
    if ( !(fRes = fConsistance
          = TextualiseListeOctets(acTamponTexte, xNbOct)) ) 
      break ;
    unsigned int  wNumberOfCharPerLine
      = (rTxt.Width() - uLargeurAscenseurs - 2 * uMargeTEdit)
        / uLargeurCar * 97 / 100 ;
    WrappText(acTamponTexte, wNbOct, acTamponWrappedText, wNbOct + 15
      , wNumberOfCharPerLine
      , IsIntelligentText(acTamponTexte) ? 
           CONTINUOUS_WRAPPING
        : SEPARATOR_WRAPPING);
    WrappText(szTamponNumerique, 4 * wNbOct, acTamponWrappedNumerList
      , 4 * wNbOct + 15, wNumberOfCharPerLine, SEPARATOR_WRAPPING);
    } 
  while ( 0 );
  if ( fRes ) 
    {
    peTxtSmb -> SetText(acTamponWrappedText);
    peNumSmb -> SetText(acTamponWrappedNumerList);
    peFreq -> SetValue(Symbole.GetSize());
    peNbOct -> SetValue(xNbOct);
    InvalidateRect(rSymbole, FALSE);
    }
  else 
    Symbole.Set();
  free(acTamponWrappedNumerList);
  free(acTamponWrappedText);
  free(szTamponNumerique);
  free(acTamponTexte);
  return ;
  }
else 
  {
  peTxtSmb -> Clear();
  peNumSmb -> Clear();
  peFreq -> Clear();
  peNbOct -> Clear();
  InvalidateRect(rSymbole, FALSE);
  return ;
  }
}

void TLectureSymbole::Ev_ModifTexteSymbole ( void )
{
ReleveOptions();

unsigned int  wNbCar = peTxtSmb -> GetTextLen();

if ( wNbCar ) 
  {
  char  *szTamponTexte = (char *)malloc(wNbCar + 1);
  peTxtSmb -> GetText(szTamponTexte, wNbCar + 1);
  if ( !Symbole.MakeOutOfWrappedString(szTamponTexte) ) 
    Symbole.Set();
  wFreqForcee =  0 ;
  free(szTamponTexte);
  InvalidateMatrice();
  }
}

void TLectureSymbole::Ev_ModifNumeriqueSymbole ( void )
{
ReleveOptions();

unsigned int  wNbCar = peNumSmb -> GetTextLen();

if ( wNbCar ) 
  {
  char  *szTamponNum = (char *)malloc(wNbCar + 1);
  int   *aiListeValeurs = (int *)malloc(wNbCar);
  peNumSmb -> GetText(szTamponNum, wNbCar + 1);
  Dewrappe(szTamponNum);
  unsigned int  wNbValues
    = GetIntegerList(szTamponNum, aiListeValeurs, wNbCar);
  wNbValues =  SupprimeZerosTerminaux(aiListeValeurs, wNbValues);
  unsigned int  wNbOct
    = NbOctetsPourTelleFrequence(FrequencePourTantDOctets(wNbValues));
  unsigned char *acListeOctets = (unsigned char *)malloc(wNbOct);
  for ( unsigned int w = 0 ; w < wNbValues ; w++ ) 
    acListeOctets [w] =  (unsigned char)aiListeValeurs [w];
  for ( w = wNbValues ; w < wNbOct ; w++ ) 
    acListeOctets [w] =  0 ;
  if ( !Symbole.Binarisation(acListeOctets
          , FrequencePourTantDOctets(wNbValues))
        || !Symbole.Encadrement() ) 
    Symbole.Set();
  wFreqForcee =  0 ;
  free(acListeOctets);
  free(aiListeValeurs);
  free(szTamponNum);
  InvalidateMatrice();
  }
}

void TLectureSymbole::GenereMenuFlottant ( TPopupMenu *pmnuFlot )
{
TPickupQuad::GenereMenuFlottant(pmnuFlot);
if ( pmnuFlot ) 
  {
  TMenu *pmnuMatrices = new TMenu ;
  pmnuMatrices -> AppendMenu(MF_STRING, CM_LS_GeneSpont, "&Gnration");
  pmnuMatrices -> AppendMenu(MF_STRING, CM_LS_Transfert, "&Transfert plan");
  pmnuMatrices -> AppendMenu(MF_STRING, CM_LS_SymbolePleinImage
    , "&Contenu du plan");
  pmnuMatrices -> AppendMenu(MF_STRING, CM_LS_Comparaison, "Comparaison");
  if ( fShowMenu ) 
    pmnuFlot -> AppendMenu(MF_SEPARATOR);
  if ( fLinkAffim ) 
    pmnuFlot -> AppendMenu(MF_STRING, CM_LS_LectureSymbole
      , "&Lecture symbole");
  pmnuFlot -> AppendMenu(MF_STRING, CM_LS_ChargeSymbole, "C&harge symbole");
  pmnuFlot -> AppendMenu(MF_STRING, CM_LS_SauvegardeSymbole
    , "Sauve&garde symbole");
  if ( fLinkAffim ) 
    pmnuFlot -> AppendMenu(MF_STRING, CM_LS_DressageSymbole
      , "&Recadrage symbole");
  if ( fLinkAffim ) 
    pmnuFlot -> AppendMenu(MF_STRING, CM_LS_ZoomSymbole
      , "&Agrandissement symbole");
  pmnuFlot -> AppendMenu(MF_POPUP, *pmnuMatrices, "&Matrices");
  }
}

void TLectureSymbole::CmMenu ( WPARAM id )
{
ReleveOptions();

BOOL  fNouvelleImage = FAUX ;

// Indique si l'on doit chager de plan  l'issue
BOOL  fNouvelleMatrice = FAUX ;

// Indique si l'on doit rafraichir l'affichage de la matrice  l'issue
char  szFilename [MAXPATH];

switch ( id ) 
  {
  case CM_LS_SymbolReport : 
    {
    
    // If first report, insert some information about configuration.
    /*
       Lecture symbole:
         Redressement auto
         Support d'horloge
           paire/impaire/inconnu
       
       Lgn:part=8,ZC=1,Lapl=4,//=25,L=85,Coins=85,Chan=4,noyau=3, recal=?,Tex=Y
       Lec:redress=,suppH=
       
       Charcheur de lignes:
       partitions=8.
       seuil ZC=1
       laplacien=4
       Seuil E.A. Raccordement //=25
       Seuil E.A. Raccordement L=85
       Seuil des coins=128
       Longueur minimale de chane=4
       Voisinage des coins (noyau)=3
       Type recalage=1
       Validation texel=1
       
       */
    if ( access(szReportFile, 00) ) 
      {
      
      // File does not exist (first rport)
      char  szLineState [1024];
      GetPrivateString(STRING_TitreClasseLectureSymbole, "present state"
        , "", szLineState, sizeof(szLineState), szINIFileName);
      FILE  *pfilReport = fopen(szReportFile, "at");
      if ( pfilReport ) 
        {
        TDate::HowToPrint h = TDate::SetPrintOption(TDate::EuropeanNumbers);
        
        //        enum HowToPrint{ Normal, Terse, Numbers, EuropeanNumbers, European };
        fprintf(pfilReport, "%s\n%s\n", TTime().AsString().c_str() // Now,
        , szLineState);
        TDate::SetPrintOption(h);
        unsigned int  wPariteSymbole = ID_AQ_PariteFreq ;
        if ( wReadingSymbolProperties & SMB_PROP_Parity ) 
          {
          wPariteSymbole += SMB_PROP_Parity ;
          if ( wReadingSymbolProperties & SMB_PROP_Even ) 
            wPariteSymbole += SMB_PROP_Even ; // Pair
          }
        fprintf(pfilReport, "Lec:redress=%c,suppH=%c,parit=%c\n"
          , fAutoRedress ? 'Y' : 'N', fSupportHorloge ? 'Y' : 'N'
          , wPariteSymbole == ID_AQ_PariteFreq ?
               ' '
            : (wPariteSymbole == ID_AQ_PariteFreq + SMB_PROP_Parity ?
                 'I'
              : 'P'));
        fclose(pfilReport);
        }
      }
    char  szReport [1024];
    ProduceReport(szReport, sizeof(szReport));
    FILE  *pfilReport = fopen(szReportFile, "at");
    if ( pfilReport )
      {
      fprintf(pfilReport, "%s\n", szReport); 
      fclose(pfilReport);
      }
    break ;
    }
  case CM_LS_ChargeSymbole :
    if ( !GetSymboleFileName(this, szFilename, TRUE)
          || !(fNouvelleMatrice = fConsistance
            = ChargeSymbole(szFilename, &Symbole)) )
      Symbole.Set();
    DeduceSymbolName(szSymbolName, szFilename,szINIFileName);
    wFreqForcee      = 0 ;
    *szImageUtilisee = 0 ;
    fNouvelleImage   = FAUX ;
    break ;
  case CM_LS_SauvegardeSymbole : 
    if ( GetSymboleFileName(this, szFilename, FALSE) ) 
      if ( !SauvegardeSymbole(&Symbole, szFilename) ) 
        MErreur("Echec  la sauvegarde", 1315);
      else 
        DeduceSymbolName(szSymbolName, szFilename,szINIFileName);
    break ;
  case CM_LS_LectureSymbole : 
    {
    wFreqForcee =  0 ;
    if ( ABCD.Pervers() ) 
      {
      fConsistance     =  0 ;
      fNouvelleMatrice =  1 ;
      Symbole.Set();
      }
    else 
      {
      if ( fTracage ) 
        {
        Copie_plan(source, destin); // Affichage si tracage.
        sprintf(TableFich [(plan + 1) % nbplan], "%s (copie)"
          , TableFich [plan]);
        }
      if ( !(fNouvelleImage = fNouvelleMatrice = fConsistance
            = //            LectureSymboleConnuPerspHF(ABCD, &Symbole, source, destin,0,PERSPECTIVE_HYPERBOLIQUE_SYMBOLE)))
              LectureSymboleConnuPerspHF(ABCD, &Symbole, source, destin
                , wReadingSymbolProperties, 0
                , fSupportHorloge ? 
                     GRILLE_2COTES_CONNUS
                  : PERSPECTIVE_HYPERBOLIQUE_SYMBOLE)) ) 
        {
        char  szDrive [MAXDRIVE], szDir [MAXDIR], szImag [MAXFILE]
          , szExt [MAXEXT];
        fnsplit(TableFich [plan], szDrive, szDir, szImag, szExt);
        char          cSampleName, cSpin ;
        unsigned char uDate, uNumber, uFreq ;
        int           i = 0 ;
        if ( SplitSampleSymbolName(szImag, &cSampleName, &uDate, &uNumber
              , &cSpin, &uFreq) || PickAssociatedFrequency(szImag,&uFreq))
          if ( wMessPause )
            
            // Pause autorise
            i =  GetIntishValue(this, "chec - Frquence non reconnue"
              , "Proposez une frquence", &wFreqForcee, (unsigned int)uFreq);
          else 
          
          // Pause interdite, on utilise uFreq.
            {
            i           =  1 ;
            wFreqForcee =  uFreq ;
            }
        else if ( wMessPause ) 
          {
          // Pause autorise
          i =  GetIntValue(this, "chec - Frquence non reconnue"
            , "Proposez une frquence", &wFreqForcee);

          if (wFreqForcee >= dMaxTailleEchantillonneur)
            Erreur("Matrice trop grande (limit  55) f=", wFreqForcee, 305);
          }
        if ( i && wFreqForcee < dMaxTailleEchantillonneur)
          fNouvelleImage =  fNouvelleMatrice = fConsistance
            = LectureSymboleConnuPerspHF(ABCD, &Symbole, source, destin
              , wReadingSymbolProperties, wFreqForcee
              , PERSPECTIVE_HYPERBOLIQUE_SYMBOLE);
        else 
          fNouvelleImage =  fNouvelleMatrice = fConsistance = 0 ;
        }
      if ( !fTracage ) 
        fNouvelleImage =  FALSE ; // Pas d'affichage.
      else 
        sprintf(TableFich [(plan + 1) % nbplan]
          , "Symbole lu (frquence %d)", Symbole.GetSize());
      }
    strNcpy(szImageUtilisee, TableFich [plan], sizeof(szImageUtilisee));
    DeduceSymbolName(szSymbolName, szImageUtilisee,szINIFileName);
    break ;
    }
  case CM_LS_GeneSpont : 
    if ( Symbole.GetSize() > 2 ) 
      {
      Symbole.GenerationSpontanee(Symbole.GetSize() - 2);
      Symbole.Encadrement();
      *szImageUtilisee =  0 ;
      strNcpy(szSymbolName, "random", sizeof(szSymbolName));
      wFreqForcee =  0 ;
      }
    fNouvelleImage   = FAUX ;
    fNouvelleMatrice = fConsistance = VRAI ;
    break ;
  case CM_LS_Transfert : 
    fNouvelleImage   = Symbole.TransfertVisu(destin);
    fConsistance     = VRAI ;
    fNouvelleMatrice = FAUX ;
    sprintf(TableFich [(plan + 1) % nbplan], "Symbole (frquence %d)"
      , Symbole.GetSize());
    break ;
  case CM_LS_SymbolePleinImage : 
    ABCD.Set(rImage); // A is top-right
    ABCD.DecCirc( - 1); // A is bottom-left
    CmMenu(CM_LS_LectureSymbole);
    break ;
  case CM_LS_Comparaison : 
    
    // recadrage puis comparaison
    //      AutoSeuillage(source, PlanSuiv(destin,2));
    TransformationRaideVersMatriceCarree(ABCD, source
      , // image source 256*256
        PlanSuiv(destin, 1)
      , // matrice cible f*f
        256);
    Symbole.TransfertVisu(PlanSuiv(destin, 2));
    
    // destin+1 contient l'aggrandissement, destin+2 contient symbole, .
    ///  Fonction : Opration entre 2 plans	(|source - c| -> destin) :
    // Oper(A,B,C) C<- B-A
    Opera(Numeroplan(PlanSuiv(destin, 2)), PlanSuiv(destin, 1), destin);
    
    // destin contient la diffrence
    //    Ero_dil(MORPHO_Ouverture,destin,PlanSuiv(destin,1),2,PlanSuiv(destin,2));
    fNouvelleImage = SUCCESS ;
    break ;
  case CM_LS_DressageSymbole : 
    
    // aka Recadrage
    fNouvelleImage   
      = !ABCD.Pervers()
          && TransformationRaideVersMatriceCarree(ABCD, source
            , // image source 256*256
              destin
            , // matrice cible f*f
              256);
    /*
         Qu'il soit entr par l'oprateur ou dtect par lignes, le quadrilatre
       a son origine connue (intersection du motif en L). Cette origine est sence tre A
       et doit se retrouver en bas  gauche aprs la transformation raide.
         TransformationRaideVersMatriceCarree(TQuad...) va mmoriser le sens de parcours d'ABCD,
       ainsi que les transformations effectues sur ABCD avant de procder  son dgrillage
       par l'intermdiaire d'TransformationRaideVersMatriceCarree(int ...)
       
       */
    fConsistance     = VRAI ;
    fNouvelleMatrice = FAUX ;
    break ;
  case CM_LS_ZoomSymbole : 
    
    // Aka Agrand
    if ( !ABCD.Pervers() ) 
      {
      int       fTrig = !ABCD.FlipParcoursTrigo();
      TVecteur  xyBA(ABCD.B, ABCD.A), xyBC(ABCD.B, ABCD.C);
      TReperage repSymb(complex(ABCD.B.x, ABCD.B.y)
        , complex(xyBC.x, xyBC.y) / 256, complex(xyBA.x, xyBA.y) / 256);
      complex   zG, zC ;
      double    dAlphaX, dAlphaY ;
      repSymb.TellTGeom(&zG, &dAlphaX, &dAlphaY, &zC);
      
      //        Rotat(10 /*+(dAlphaY-M_PI/2)*/,128,128,1,1,'0');
      Rotat(dAlphaX / M_PI * 180 /*+(dAlphaY-M_PI/2)*/ , real(zC)
        , imag(zC), real(zG), imag(zG), '0');
      
      //        float o=-(TVecteur(ABCD.A,ABCD.B).Orientation()),
      //          l=SIZE_OF_PICTURES/ABCD.A.Distance(ABCD.B), l2=SIZE_OF_PICTURES/ABCD.A.Distance(ABCD.D);
      fNouvelleImage   =  fConsistance = VRAI ;
      fNouvelleMatrice =  FAUX ;
      if ( !fTrig ) 
        ABCD.Flip();
      }
    break ;
  default : fNouvelleMatrice = fNouvelleImage = fConsistance
              = MErreur("Commande non dfinie", 831);
  }
if ( fNouvelleMatrice ) 
  
  //  fConsistance =  VRAI ;
  InvalidateMatrice();
Invalidate();
if ( fNouvelleImage ) 
  {
  Calsuiv();
  Fenetre -> Visim(this, 0, source);
  }
}

void TLectureSymbole::CmSymbolComp ()
{
ReleveOptions();

char  szFullPath [MAXPATH];

if ( FindSymbolFile(szSymbolName, szFullPath) ) 
  {
  TDataMatrix *psmb = new TDataMatrix ;
  if ( ChargeSymbole(szFullPath, psmb) )
    TComparateurSymbole::CreateNewComparateurSymbole(Parent, psmb, &Symbole
      , TRUE, FALSE);
  else 
    {
    delete psmb ;
    if (TComparateurSymbole::pw) TComparateurSymbole::pw -> ShutDownWindow();
  //CreateNewComparateurSymbole(Parent, NULL, &Symbole     , TRUE, FALSE);
    }
  }
}

void TLectureSymbole::ReleveOptions ( void )
{
if ( !fOptionsAccessibles )

  // TControls pas encore initialiss.
  return ;
fAutoRedress    =  pchkAutoRedress -> GetCheck() & BF_CHECKED ;
fSupportHorloge =  pchkSupportHorloge -> GetCheck() & BF_CHECKED ;



unsigned int  wPariteSymbole = (unsigned int)pcmbPariteFreq -> GetSelItem();

switch ( wPariteSymbole )
  {
  case (unsigned int) - 1 :

    // This occurs when action is lanch before SetupWindow.
    break ;
  case ID_AQ_PariteFreq :

    // Parit inconnue
    wReadingSymbolProperties &= ~SMB_PROP_Parity ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity :

    // Frquence impaire
    wReadingSymbolProperties |= SMB_PROP_Parity ;
    wReadingSymbolProperties &= ~SMB_PROP_Even ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity + SMB_PROP_Even : 
    
    // Frquence paire
    wReadingSymbolProperties |= (SMB_PROP_Parity | SMB_PROP_Even);
    break ;
  default : ErreurCode();
  }
}

void TLectureSymbole::SauvegardeOptions ( void )
{
TPickupQuad::SauvegardeOptions();
WritePrivateFlag(Title, "redressement auto", fAutoRedress, szINIFileName);
WritePrivateFlag(Title, "support horloge", fSupportHorloge, szINIFileName);
WritePrivateString(Title, "image utilise", szImageUtilisee, szINIFileName);
WritePrivateString(Title, "symbole associ", szSymbolName, szINIFileName);
WritePrivateString(Title, "symbole d'accueil", szSymboleAccueilDef, szINIFileName);
WritePrivateInt(Title, "Proprits de lecture de symbole (bit-wise)", wReadingSymbolProperties, szINIFileName);

}

void TLectureSymbole::ChargeOptions ( void )
{
TPickupQuad::ChargeOptions();
fAutoRedress
  =  GetPrivateFlag(Title, "redressement auto", fAutoRedressDef, szINIFileName);
fSupportHorloge
  =  GetPrivateFlag(Title, "support horloge", fSupportHorlogeDef, szINIFileName);

char  szSymboleAccueil [USUALMAXLENSTRING];

GetPrivateString(Title, "symbole d'accueil", szSymboleAccueilDef
  , szSymboleAccueil
  , sizeof(szSymboleAccueil), szINIFileName);
if ( !access(szSymboleAccueil, 04)
      && ChargeSymbole(szSymboleAccueil, &Symbole) )
  fConsistance =  VRAI ;
fConsistance =  ABCD.Existe() || fConsistance ;
GetPrivateString(Title, "image utilise", "", szImageUtilisee
  , sizeof(szImageUtilisee), szINIFileName);
GetPrivateString(Title, "symbole associ", "", szSymbolName
  , sizeof(szSymbolName), szINIFileName);
wReadingSymbolProperties=GetPrivateInt(Title
    
  , "Proprits de lecture de symbole (bit-wise)"
  // wReadingSymbolPropertiesDef = (SMB_PROP_Appearance | SMB_PROP_AppPositive)
  , wReadingSymbolPropertiesDef
  , szINIFileName);
}

//-----------------------------------------------------------------------
void TLectureSymbole::NouveauQuad ()
{
TPickupQuad::NouveauQuad();
wReadingSymbolProperties |= SMB_PROP_Clock ;
if ( ABCD.IsParcoursTrigo() )
  wReadingSymbolProperties &= ~SMB_PROP_ClockWise ;
else
  wReadingSymbolProperties |= SMB_PROP_ClockWise ;
CmMenu(CM_LS_LectureSymbole);
}

void TLectureSymbole::NouveauPoint ()
{
TPickupQuad::NouveauPoint();
fConsistance =  VRAI ;
InvalidateRect(
  TRect(rDivComment.TopLeft(), TSize(rDivComment.Width(), uHauteurLigne)));
}

/*--Classe TAnalyseQuad----------------------------------------------------*/
DEFINE_RESPONSE_TABLE1 (TAnalyseQuad, TPickupQuad) EV_COMMAND (
    ID_AQ_HistTracTabCrit, Cm_HistTracTabCrit)
  , EV_COMMAND (ID_AQ_HistTracTabFreq, Cm_HistTracTabFreq)
  , EV_COMMAND (CM_AQ_QuerySlice, Cm_QuerySlice), END_RESPONSE_TABLE ;

TAnalyseQuad::TAnalyseQuad ( TWindow *parent )
  : TPickupQuad(parent, "Analyse frquence de quadrilatre", ASS_DROITE)
    ,  rFigTabCrit(),  rFigTabFreq(),  repCrit(),  repFreq()
{
SetAffichagePolygone(SW_SHOW, TPoint(sMarges));

unsigned int  wHSep1 = rAffichagePolygone.bottom
  , wHSep2 = wHSep1 + uHauteurLigne + sMarges.cy
  , wHSep3 = wHSep2 + (sEspaceUtile.cy - wHSep2) / 2
  , wVSep1 = rAffichagePolygone.right ;


rFigTabCrit.Set(sMarges.cx, wHSep2, sEspaceUtile.cx - sMarges.cx * 2
  , wHSep3);
rFigTabFreq.Set(sMarges.cx, wHSep3 + uHauteurLigne + sMarges.cy
  , sEspaceUtile.cx - sMarges.cx * 2, sEspaceUtile.cy - sMarges.cy);
pstFreq
  =  new TStatic(this, ID_AQ_ValFreq, "", sMarges.cx, wHSep1
    , sEspaceUtile.cx - sMarges.cx, uHauteurLigne, 16);
pbHistTraceTabCrit
  =  new TButton(this, ID_AQ_HistTracTabCrit, "Trace critres (traceur)"
    , sMarges.cx, wHSep3 + sMarges.cx / 2, sEspaceUtile.cx / 2 - sMarges.cx
    , uHauteurLigne);
pbHistTraceTabFreq
  =  new TButton(this, ID_AQ_HistTracTabFreq
    , "Trace frquences (traceur)", sEspaceUtile.cx / 2
    , wHSep3 + sMarges.cx / 2, sEspaceUtile.cx / 2 - sMarges.cx
    , uHauteurLigne);


wFreq              =  0 ;
wSizeOfTables      =  SIZE_OF_PICTURES ;
wNbCoupes          =  0 ;
for ( int i = 0 ; i < wSizeOfTables ; i++ )
  auTabFreq [i] =  auTabCrit [i] = 0 ;
pestQuerySlice
  =  new TLabeledEditNum(this, "Rech. Coupe", CM_AQ_QuerySlice
    , MINFLOAT, wVSep1 + sMarges.cx, sMarges.cy, 12 * uLargeurCar
    , 5 * uLargeurCar);
wReadingSymbolProperties =  0 ; // RAZ
wReadingSymbolProperties |= (SMB_PROP_Appearance | SMB_PROP_AppPositive);
pcmbPariteFreq
  =  new TComboBoxItems(this, ID_AQ_PariteFreq
    , wVSep1 + sMarges.cx, sMarges.cy * 1.5 + uHauteurEdit
    , 17.5 * uLargeurCar, uHauteurEdit + uHauteurLigne * 3
    , CBS_DROPDOWNLIST, USUALMAXLENSTRING / 2);

pbt2eBalayage
  =  new TCheckBox(this, ID_CHILD + 3
    , "2e direction"
    , wVSep1 + sMarges.cx
    , sMarges.cy * 1.5 + uHauteurEdit*2
    , 12 * uLargeurCar
    , uHauteurLigne
    , NULL);
}

void TAnalyseQuad::SetupWindow ()
{
fOptionsPresentes =  TRUE ;
TPickupQuad::SetupWindow();
pcmbPariteFreq -> AddItem(ID_AQ_PariteFreq, "Parit inconnue");
pcmbPariteFreq -> AddItem(ID_AQ_PariteFreq + SMB_PROP_Parity, "Impaire");
pcmbPariteFreq -> AddItem(
  ID_AQ_PariteFreq + SMB_PROP_Parity + SMB_PROP_Even, "Paire");


pbt2eBalayage -> SetCheck(
  f2eBalayage ? BF_CHECKED : BF_UNCHECKED);

unsigned int  wPariteSymbole = ID_AQ_PariteFreq ;

if ( wReadingSymbolProperties & SMB_PROP_Parity ) 
  {
  wPariteSymbole += SMB_PROP_Parity ;
  if ( wReadingSymbolProperties & SMB_PROP_Even ) 
    wPariteSymbole += SMB_PROP_Even ;
  }
pcmbPariteFreq -> SetSelItem(wPariteSymbole);
}

TAnalyseQuad::~TAnalyseQuad ()
{
delete pestQuerySlice ;
delete pcmbPariteFreq ;
delete pbt2eBalayage;

}

void TAnalyseQuad::Paint ( TDC &dc, BOOL erase, TRect &rect )
{
TPickupQuad::Paint(dc, erase, rect);

TraceLgdedCourbe(auTabCrit, wNbCoupes, rFigTabCrit, dc, "N de coupe"
  , "Critre", 0, wNbCoupes ? wNbCoupes - 1 : 0, 0, 99, 0, 255, 0, 0, 5, 10
  , 0, &rTracTabCrit, &repCrit);

unsigned char u = Maximum_courbe(auTabFreq, wNbCoupes);

TraceLgdedCourbe(auTabFreq, wNbCoupes, rFigTabFreq, dc, "N de coupe"
  , "Frquence", 0, wNbCoupes ? wNbCoupes - 1 : 0, 0, u, 0, u, 0, 0, 5, 1
  , 0, &rTracTabFreq, &repFreq); //  MTrace("Fin de Paint",1725);
}

void TAnalyseQuad::EvMouseMove ( UINT a, TPoint &point )
{
char  szTamp0 [120];

if ( rFigTabFreq.Contains(point) ) 
  {
  complex xyPosSouris = repFreq.Rb2Ra(point);
  sprintf(szTamp0, "X=%d,Y=%f", NFloorR(real(xyPosSouris))
    , imag(xyPosSouris));
  pZ1 -> SetText(szTamp0);
  }
else if ( rFigTabCrit.Contains(point) ) 
  {
  complex xyPosSouris = repCrit.Rb2Ra(point);
  sprintf(szTamp0, "X=%d,Y=%f", NFloorR(real(xyPosSouris))
    , imag(xyPosSouris));
  pZ1 -> SetText(szTamp0);
  }
else
  TPickupQuad::EvMouseMove(a, point);
}

void TAnalyseQuad::SauvegardeOptions ( void )
{
TPickupQuad::SauvegardeOptions();
WritePrivateFlag(Title, "2e direction", f2eBalayage, szINIFileName);
}

void TAnalyseQuad::ChargeOptions ( void )
{
TPickupQuad::ChargeOptions();
  f2eBalayage=GetPrivateFlag(Title,"2e direction",0,szINIFileName);
}

void TAnalyseQuad::Cm_HistTracTabFreq ()
{
BOOL  f = fTracage ;

if ( !f ) 
  ActiveTracage(VRAI);
Trace("Courbe des frquences.", auTabFreq, wNbCoupes, 1957);
if ( !f ) 
  ActiveTracage(f);
}

void TAnalyseQuad::Cm_QuerySlice ()
{
TBipoint      bip ;
unsigned int  wTrancheAAnalyser ;
TQuadrilatere qABCDMod = ABCD ;
unsigned int  wPariteSymbole = (unsigned int)pcmbPariteFreq -> GetSelItem();

switch ( wPariteSymbole ) 
  {
  case ID_AQ_PariteFreq : 
    
    // Parit inconnue
    wReadingSymbolProperties &= ~SMB_PROP_Parity ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity : 
    
    // Frquence impaire
    wReadingSymbolProperties |= SMB_PROP_Parity ;
    wReadingSymbolProperties &= ~SMB_PROP_Even ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity + SMB_PROP_Even : 
    
    // Frquence paire
    wReadingSymbolProperties |= (SMB_PROP_Parity | SMB_PROP_Even);
    break ;
  default : ErreurCode();
  }
ReOrgQuadMaxMax(&qABCDMod, &wReadingSymbolProperties);
f2eBalayage = pbt2eBalayage -> GetCheck() & BF_CHECKED ;
  if (f2eBalayage)
    DecCirc(&qABCDMod, &wReadingSymbolProperties);
if ( wNbCoupes
      && pestQuerySlice -> e.GetValue(&wTrancheAAnalyser) < wNbCoupes
      && AnalFreqQuadGenerique(qABCDMod, &wTrancheAAnalyser, NULL
        , wReadingSymbolProperties, ANLFREQ_LocaliseTranche, NULL, NULL
        , NULL, NULL, &bip) )
  (new TAnalyseLigne(Parent, TLigne(bip))) -> Create();
}

void TAnalyseQuad::Cm_HistTracTabCrit ()
{
BOOL  f = fTracage ;

if ( !f ) 
  ActiveTracage(VRAI);
Trace("Courbe des critres.", auTabCrit, wNbCoupes, 1966);
if ( !f ) 
  ActiveTracage(f);
}

void PaintDestin ( TPoint pt, void * )
{
destin [pt.y * 256 + pt.x] =  0 ;
}

void TAnalyseQuad::NouveauQuad ()
{
TPickupQuad::NouveauQuad();

char  sz [USUALMAXLENSTRING];

wNbCoupes =  wSizeOfTables ;

unsigned int  wPariteSymbole = (unsigned int)pcmbPariteFreq -> GetSelItem();

f2eBalayage = pbt2eBalayage -> GetCheck() & BF_CHECKED ;


switch ( wPariteSymbole )
  {
  case (unsigned int) - 1 :

  // This occurs on startup when reading is asked and the TAnalyseQuad has not been llaunched yet.
  break ;
  case ID_AQ_PariteFreq :

    // Parit inconnue
    wReadingSymbolProperties &= ~SMB_PROP_Parity ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity : 
    
    // Frquence impaire
    wReadingSymbolProperties |= SMB_PROP_Parity ;
    wReadingSymbolProperties &= ~SMB_PROP_Even ;
    break ;
  case ID_AQ_PariteFreq + SMB_PROP_Parity + SMB_PROP_Even : 
    
    // Frquence paire
    wReadingSymbolProperties |= (SMB_PROP_Parity | SMB_PROP_Even);
    break ;
  default : ErreurCode();
  }
if ( ABCD.Pervers() ) 
  {
  *sz                      =  0 ;
  wNbCoupes                =  0 ;
  ABCD                     =  QuadrilatereErreur ;
  wNbCoupes                =  0 ;
  wReadingSymbolProperties &= ~SMB_PROP_Clock ;
  for ( int i = 0 ; i < wSizeOfTables ; i++ ) 
    auTabFreq [i] =  auTabCrit [i] = 0 ;
  wsprintf(sz, "Pas de quadrilatre.");
  }
else 
  {
  wReadingSymbolProperties |= SMB_PROP_Clock ;
  if ( ABCD.IsParcoursTrigo() )
    wReadingSymbolProperties &= ~SMB_PROP_ClockWise ;
  else
    wReadingSymbolProperties |= SMB_PROP_ClockWise ;
  TQuadrilatere qABCDMod = ABCD ;
  ReOrgQuadMaxMax(&qABCDMod, &wReadingSymbolProperties);
  if (f2eBalayage)
    DecCirc(&qABCDMod, &wReadingSymbolProperties);

  if ( AnalFreqQuadGenerique(qABCDMod, &wFreq, source
        , wReadingSymbolProperties, QUAD_INSPECTION, auTabFreq, auTabCrit
        , &wNbCoupes) )
    wsprintf(sz, "Frquence : %d.", wFreq);
  else
    {
    wsprintf(sz, "Echec frquence."); //      wNbCoupes=0;
    }
  DessineFlecheDAnalQuad();
  Calsuiv( - 1);
  
  //    ScanPolygon((TPoint*)aptPolygone,uNbPoints,TRect(0,0,255,555),PaintDestin,NULL);
  Calsuiv();
  Fenetre -> Visim(this, 0, source);
  }
pstFreq -> SetText(sz);
InvalidateRect(rFigTabCrit);
InvalidateRect(rFigTabFreq);
}

void TAnalyseQuad::DessineFlecheDAnalQuad ()
{
if ( ABCD.Pervers() ) 
  return ;

TQuadrilatere ABCDr = ABCD ;

ABCDr.ReOrgQuadMaxMax();
if (f2eBalayage)
    ABCDr.DecCirc();

TVecteur  xyA(ABCDr.A), xyB(ABCDr.B), xyC(ABCDr.C), xyD(ABCDr.D);
float xDistanceAuQuad=15;

TVecteur  xyA2(-1,-1);
TVecteur  xyB2(-1,-1);

while  (!rImage.Contains(TBipoint(xyB2, xyA2)) && xDistanceAuQuad > -SIZE_OF_PICTURES*2 )
  {
  xyA2 = xyA + (xyA - xyD).Unitaire() * xDistanceAuQuad ;
  xyB2 = xyB + (xyB - xyC).Unitaire() * xDistanceAuQuad ;
// Si hors de l'image: rapproche
  if (xDistanceAuQuad > 2)
    xDistanceAuQuad /= 2;
// Si proche de zro; passe ngatif
  else if (xDistanceAuQuad > -2)
    xDistanceAuQuad -= 2;
  else
// Si intrieur, augment dans les ngatifs
    xDistanceAuQuad *= 2;
  }



MultipliePlanScalaire(source, 1.0, destin);
DessineFleche(source, TBipoint(xyB2, xyA2), destin); // Parcours de B vers A.
Calsuiv();
sprintf(TableFich [plan], "%.40s (avec direction d\'chantillonnage)"
  , TableFich [(plan - 1) % nbplan]);
Fenetre -> Visim(this, 0, source);
}

BOOL AfficheMatriceSymbole ( TMatrix *pSymbole, TRect rSymbole, TDC &dc )
{
unsigned int  i = 0, j = 0 ;
TBrush        Pinceau (TColor::White) ;

/*  TBrush PinceauBlanc(TColor::White),PinceauCouleur(TColor::Black),
   PinceauIndetermine(TColor::Gray),PinceauMErreur(TColor::LtRed); */
if ( !pSymbole ) 
  return FALSE ;
if ( !pSymbole -> GetData() || !pSymbole -> GetSize() ) 
  {
  dc.FillRect(rSymbole, TBrush(TColor::LtGray));
  return SUCCESS ;
  }

TPoint  NewOrg(rSymbole.TopLeft()), OldOrg ;

dc.SetViewportOrg(NewOrg, &OldOrg);

/* Remplissage de l'espace matriciel */
/* Inscription des bits */
TVecteur      vWH((float)rSymbole.Width() / pSymbole -> GetSize()
  , (float)rSymbole.Height() / pSymbole -> GetSize());
TRect         rCase ;
unsigned int  wS = pSymbole -> GetSize();

for ( i = 0 ; i < wS ; i++ ) 
  for ( j = 0 ; j < wS ; j++ ) 
    {
    rCase.Set(NFarRoundR(vWH.x * j), NFarRoundR(vWH.y * i)
      , NFarRoundR(vWH.x * (j + 1)), NFarRoundR(vWH.y * (i + 1)));
    unsigned char u = pSymbole -> GetCell(i, j);
    TColor        c ;
    if ( u & SMB_CELL_Mark ) 
      if ( u & SMB_CELL_Error ) 
        c =  TColor(113, 0, 0); // Dark red
      else 
        c =  TColor::Black ;
    else if ( u & SMB_CELL_Error ) 
      c =  TColor(255, 172, 172); // Light red
                                 //          c=TColor::LtRed;
    else 
      c =  TColor::LtGray ;
    if ( u & SMB_CELL_Unknown ) 
      dc.FillRect(rCase, TBrush(c, HS_DIAGCROSS));
    else 
      dc.FillRect(rCase, TBrush(c));
    }
dc.SetViewportOrg(OldOrg);
return SUCCES ;
}

BOOL GetSymboleFileName ( TWindow *pFenetrePorteuse
    , char szSymbolFileName [], BOOL MustExist )
{
char                          Filter [] = "Fichier symbole (*.smb)|*.smb|Tous fichiers|*.*";
static char                   szRepertoireSymbole [MAXDIR] = "";
static TFileSaveDialog::TData SourceFile(
(MustExist ?  OFN_FILEMUSTEXIST  : OFN_OVERWRITEPROMPT)
    | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST // | OFN_NOVALIDATE
  , Filter);

if ( !strlen(szRepertoireSymbole) ) 
  {
  strcpy(szRepertoireSymbole, szRepertoireDepart);
  SourceFile.InitialDir =  szRepertoireSymbole ;
  }

TFileOpenDialog ofd(pFenetrePorteuse, SourceFile, 0, "Fichier symbole");
BOOL            f ;

if ( ofd.Execute() == IDOK ) 
  {
  strcpy(szSymbolFileName, SourceFile.FileName);
  f =  SUCCES ;
  }
else 
  f =  ECHEC ;

char  szDrive [MAXDRIVE];
char  szFile [MAXFILE];
char  szExt [MAXEXT];

fnsplit(SourceFile.FileName, szDrive, szRepertoireSymbole, szFile, szExt);
return f ;
}

int DemandeFrequenceOuAnnulle ( char *szTitre )
{
int   n = 0 ;
char  szTampon [USUALMAXLENSTRING] = "";

/*  if (P_execution_predefinie!=NULL)
   return P_execution_predefinie->frequence; */
do
  if ( (TInputDialog(pFenetreControle, szTitre
            , "Frquence du symbole ? (impaire ou 0)", szTampon
            , sizeof(szTampon)))
          .Execute()
        == IDOK ) 
  sscanf(szTampon, "%d", &n);
while ( n < 0 || (n && !(n & 1)) || n == 1 );

/* n est impair et suprieur  2 */
return n ;
}

/*--TTextureQuad---------------------------------------------------------*/
TTextureQuad::TTextureQuad ( TWindow *parent )
  : TPickupQuad(parent, "Analyse de texture de quadrilatre", ASS_DROITE)
{
SetAffichagePolygone(SW_SHOW, TPoint(sMarges));

int iLabelWidth = 20 ;
int iControlStacker = 0 ;

pestNbTexelsValides          
  =  new TLabeledEditNum(this, "Texels de symbole :", ID_CHILD
    , MINFLOAT, sMarges.cx
    , rAffichagePolygone.bottom + sMarges.cy
      + uHauteurEdit * (iControlStacker++)
    , iLabelWidth * uLargeurCar, 7 * uLargeurCar, 128, 128, 0);
pestNbPartTexture            
  =  new TLabeledEditNum(this, "Part de symbole (%):"
    , ID_CHILD + 1, MINFLOAT, sMarges.cx
    , rAffichagePolygone.bottom + sMarges.cy
      + uHauteurEdit * (iControlStacker++)
    , iLabelWidth * uLargeurCar, 7 * uLargeurCar, 128, 128, 0);
pbtAnalRec                   
  =  new TRadioButton(this, ID_CHILD + 2
    , "Analyse rectangle circonscrit"
    , rAffichagePolygone.right + sMarges.cx, sMarges.cy, 30 * uLargeurCar
    , uHauteurLigne, NULL);
pbtAnalPolyg
  =  new TRadioButton(this, ID_CHILD + 2
    , "Analyse ploygone inscrit", rAffichagePolygone.right + sMarges.cx
    , sMarges.cy + uHauteurLigne, 26 * uLargeurCar, uHauteurLigne, NULL);
fAnalyseRectangleCirconscrit =  TRUE ;
wNbTexelsValides             =  wNbTexelsTotal = 0 ;
}

void TTextureQuad::Refresh ()
{
pbtAnalRec -> SetCheck(
  fAnalyseRectangleCirconscrit ? BF_CHECKED : BF_UNCHECKED);
pbtAnalPolyg -> SetCheck(
  fAnalyseRectangleCirconscrit ? BF_UNCHECKED : BF_CHECKED);
pestNbPartTexture -> e.SetClearValue(
  wNbTexelsTotal ? 
       wNbTexelsValides / (float)wNbTexelsTotal * 100
    : wNbTexelsTotal);
pestNbTexelsValides -> e.SetClearValue(wNbTexelsValides);
}

void TTextureQuad::Lookup ()
{
fAnalyseRectangleCirconscrit =  pbtAnalRec -> GetCheck() & BF_CHECKED ;
}

void TTextureQuad::SetupWindow ()
{
TPickupQuad::SetupWindow();
pestNbTexelsValides -> e.SetReadOnly(true);
pestNbPartTexture -> e.SetReadOnly(true);
Refresh();
}

void TTextureQuad::NouveauQuad ()
{
Lookup();

//  unsigned int wNbTexelsValides, wNbTexelsTotal;
if ( fAnalyseRectangleCirconscrit ) 
  {
  TRect rAnalysed ;
  TexVraissemblanceRelative(&wNbTexelsTotal, &wNbTexelsValides, source
    , destin, PlanSuiv(destin), ABCD.RectangleCirconscrit(), &rAnalysed
    , TEX_VISU_SANS);
  DessineQuadrilatere(source, TQuadrilatere(rAnalysed), destin);
  }
else 
  TexVraissemblanceRelative(&wNbTexelsTotal, &wNbTexelsValides, source
    , destin, PlanSuiv(destin), ABCD);
Calsuiv();
Fenetre -> Visim(this, 0, source);
Refresh();
}

TTextureQuad::~TTextureQuad ()
{
delete pestNbTexelsValides ;
delete pestNbPartTexture ;
}

//--TComparateurSymbole--------------
void TComparateurSymbole::ProcessStat ()
{
if ( psDMLeft
      && psDMRight
      && psDMLeft -> GetSize() == psDMRight -> GetSize() ) 
  {
  unsigned int  wS = psDMRight -> GetSize();
  fFinderPattern =  0 ;
  fFinderPattern &= (psDMLeft -> AnalyseFinderPattern() >> DM_FP_Left);
  fFinderPattern &= (psDMRight -> AnalyseFinderPattern() >> DM_FP_Right);
  wDistance      =  0 ;
  
  //  int fModified=0;
  for ( unsigned int wi = 0 ; wi < wS ; wi++ ) 
    for ( unsigned int wj = 0 ; wj < wS ; wj++ ) 
      {
      unsigned char u = psDMRight -> GetCell(wi, wj);
      if ( (u & SMB_CELL_Mark)
            != (psDMLeft -> GetCell(wi, wj) & SMB_CELL_Mark) ) 
        {
        wDistance++ ;
        if ( !(u & SMB_CELL_Error) ) 
          
          /* fModified= */
          psDMRight -> SetCell(wi, wj, u | SMB_CELL_Error);
        }
      else // Both marked identical
           if ( (u & SMB_CELL_Error) ) // Unswitch error bit
                                        {
                                        psDMRight -> SetCell(wi, wj
                                          , u & ~SMB_CELL_Error); /* fModified=TRUE; */ 
                                        }
      }
  }
if ( pLectureSymbole ) 
  pLectureSymbole -> NouvelleMatrice();
InvalidateRect(rDMRight, FALSE);
InvalidateRect(rStat, TRUE);
}

TComparateurSymbole *TComparateurSymbole::CreateNewComparateurSymbole (
     TWindow *pwParent
    , TDataMatrix *psDMLe, TDataMatrix *psDMRi, int fAutoDeleteDMLe
    , int fAutoDeleteDMRi )
{
if ( pw ) 
  {
  if ( pw -> psDMLeft != psDMLe ) 
    {
    if ( pw -> fAutoDeleteDMLeft ) 
      delete pw -> psDMLeft ;
    pw -> psDMLeft =  psDMLe ;
    pw -> InvalidateRect(pw -> rDMLeft, FALSE);
    }
  pw -> fAutoDeleteDMLeft =  fAutoDeleteDMLe ;
  if ( pw -> psDMRight != psDMRi ) 
    {
    if ( pw -> fAutoDeleteDMRight ) 
      delete pw -> psDMRight ;
    pw -> psDMRight =  psDMRi ;
    pw -> InvalidateRect(pw -> rDMRight, FALSE);
    }
  pw -> fAutoDeleteDMRight =  fAutoDeleteDMRi ;
  pw -> SetFocus();
  pw -> BringWindowToTop();
  pw -> Show(SW_RESTORE);
  }
else 
  (pw = new TComparateurSymbole(pwParent, psDMLe, psDMRi, fAutoDeleteDMLe
      , fAutoDeleteDMRi))
    -> Create();
pw -> ProcessStat();
return pw ;
}

TComparateurSymbole::~TComparateurSymbole ()
{
if ( pw -> psDMRight && pw -> fAutoDeleteDMRight ) 
  delete pw -> psDMRight ;
if ( pw -> psDMLeft && pw -> fAutoDeleteDMLeft ) 
  delete pw -> psDMLeft ;
pw =  NULL ;
}

TComparateurSymbole::TComparateurSymbole ( TWindow *pwParent
    , TDataMatrix *psDMLe, TDataMatrix *psDMRi, int fAutoDeleteDMLe
    , int fAutoDeleteDMRi )
  : TAssociatif(pwParent, "Comparateur de symboles", ASS_GAUCHE_BAS)
{
psDMRight          =  psDMRi ;
psDMLeft           =  psDMLe ;
fAutoDeleteDMRight =  fAutoDeleteDMRi ;
fAutoDeleteDMLeft  =  fAutoDeleteDMLe ;
wVSepRL            =  sEspaceUtile.cx / 2 ;
wHSepPrivPub       =  sEspaceUtile.cy / 2 ;

TSize sS = TSize(wVSepRL - sMarges.cx, wHSepPrivPub - sMarges.cy);

rDMLeft  =  TRect(TPoint(sMarges.cx / 2, sMarges.cy / 2), sS); // Occupe tout l'espace left;
rDMRight =  TRect(TPoint(wVSepRL + sMarges.cx / 2, sMarges.cy / 2), sS); // Occupe tout l'espace right;
rStat    
  =  TRect(TPoint(0, wHSepPrivPub)
    , TSize(sEspaceUtile.cx, sEspaceUtile.cy / 2));
}

void TComparateurSymbole::Paint ( TDC &dc, bool /* erase */ 
    , TRect & /* rect */ )
{
TDataMatrix N ;

AfficheMatriceSymbole(psDMRight ? psDMRight : &N, rDMRight, dc);
AfficheMatriceSymbole(psDMLeft ? psDMLeft : &N, rDMLeft, dc);

TPoint  pt(sMarges.cx / 2, wHSepPrivPub);
char    szBuff [1024], szBuff1 [1024];

ProduceReport(szBuff, sizeof(szBuff));
dc.TextOut(pt, szBuff);


GetPrivateString(STRING_TitreClasseLectureSymbole
  , "dure (s)"
  , ""
  , szBuff
  , sizeof(szBuff)
  , szINIFileName);

  if (strlen(szBuff))
    {
    strNcat(strNcat(strcpy(szBuff1,"dure: "),szBuff, sizeof(szBuff1)), "s", sizeof(szBuff1));
    dc.TextOut(pt+TSize(0,uHauteurLigne), szBuff1);
    }

}

void TComparateurSymbole::ProduceReport ( char *szReport, unsigned int wLen )
{
char  szBuff [1024];

if ( !psDMRight || !psDMLeft ) 
  sprintf(szBuff, "Missing symbol");
else if ( !psDMRight -> GetSize() ) 
  sprintf(szBuff, "Right symbol missing");
else if ( !psDMLeft -> GetSize() ) 
  sprintf(szBuff, "Left symbol missing");
else if ( psDMRight -> GetSize() != psDMLeft -> GetSize() ) 
  sprintf(szBuff, "Frquences incompatibles: %d - %d"
    , psDMLeft -> GetSize(), psDMRight -> GetSize());
else 
  {
  if ( wDistance ) 
    {
    if ( psDMRight -> GetSize() > 2 ) 
      sprintf(szBuff, "Distance: %d (%g\%)", wDistance
        , (float)wDistance / (psDMRight -> GetSize() - 2)
          / (psDMRight -> GetSize() - 2) * 100);
    else 
      sprintf(szBuff, "Distance: %d", wDistance);
    }
  else 
    sprintf(szBuff, "Symboles identiques");
  }
strNcpy(szReport, szBuff, wLen);
}

void TLectureSymbole::ProduceReport ( char *szReport, unsigned int wLen )
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT];

fnsplit(szImageUtilisee, szDrive, szDir, szName, szExt);

char  szBuffer1 [1024], szBuffer2 [1024], szBuffer3 [1024];

/*
   sprintf(szBuffer1, "Img. %s ", szName);
   for (unsigned int w=strlen(szName);w<8;w++)
     strcat(szBuffer1, " ");
*/
sprintf(szBuffer1, "Img. %.8s%.*s ", szName
  , max(0, (int)(8 - strlen(szName))),
  "        ");

if ( Symbole.GetSize() )
  {
  sprintf(szBuffer2, "%s%cf=%3d%s t=%4.1f "
  , szBuffer1
  , wFreqForcee ? '(' : ' '
  , Symbole.GetSize()
  , wFreqForcee ? ")" : " "
  , ABCD.Circonference() / 4.0 / Symbole.GetSize() // Moyenne des priodes patiales
  );
  }
else
  sprintf(szBuffer2, "%sXXXXXXXXXXXXXX ", szBuffer1);
sprintf(szBuffer3, "%ssmb. %.8s.%.*s"
  , szBuffer2
  , szSymbolName
  , max(0, (int)(8 - strlen(szSymbolName)))
  , "        ");
/*
   sprintf(szBuffer3, "Image %s, %cfrequence %3d%s symbol %.8s.%.*s", szName
   , wFreqForcee ? '(' : ' ', Symbole.GetSize(), wFreqForcee ? ")," : ", "
   , szSymbolName, max(0, (int)(8 - strlen(szSymbolName))), "        ");
   */
if ( TComparateurSymbole::pw
      && strcmp(CONST_NoneSymbolMessage, szSymbolName) )
  {
  strNcat(szBuffer3, " ", sizeof(szBuffer3));
  TComparateurSymbole::pw -> ProduceReport(strchr(szBuffer3, 0)
    , sizeof(szBuffer3) - strlen(szBuffer3));
  strNcat(szBuffer3, ".", sizeof(szBuffer3));
  }


  char szDuration[80]="";
  GetPrivateString(STRING_TitreClasseLectureSymbole, "dure (s)", ""
  , szDuration
  , sizeof(szDuration)
  , szINIFileName);

  strNcat(szBuffer3, " Dure ", sizeof(szBuffer3));
  strNcat(szBuffer3, szDuration, sizeof(szBuffer3));
  strNcat(szBuffer3, "s", sizeof(szBuffer3));

strNcpy(szReport, szBuffer3, wLen);
}


int PickAssociatedFrequency(char *szImag,unsigned char *puFreq)
  {
  if (!puFreq)
    return 0;
  else
    *puFreq=0;
  char szSymbolName[MAXFILE]="", szFullPath[MAXPATH]="";
  if (DeduceSymbolName(szSymbolName, szImag,szINIFileName) &&
      FindSymbolFile(szSymbolName, szFullPath))
    {
    TDataMatrix smb;
    if ( ChargeSymbole(szFullPath, &smb) )
      *puFreq=smb.GetSize();
    }
  return *puFreq;
  }
