/**********************************************************************/
/*                       W I R I S       . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRSSYMB_H
#define WIRSSYMB_H

#include "wirspick.h"
#include "symbole.h"
/*
#include "wsysutil.h"


*/
//#define UTIL_DETECTLIGNES    10
#define UTIL_LECTURESYMBOLE  11

#define STRING_TitreClasseLectureSymbole "Lecture de symbole"

/*
#define SOURIS_CLIC_BD 0x01
#define SOURIS_CLIC_BG 0x02
#define SOURIS_DRAG_BD 0x04
#define SOURIS_DRAG_BG 0x08
*/
extern int wReadingSymbolPropertiesDef;
int DemandeFrequenceOuAnnulle(char *szTitre);
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
/*--TAnalyseQuad---------------------------------------------------------*/
class TAnalyseQuad : public TPickupQuad
  {
  public :
    unsigned int wFreq, wNbCoupes, wSizeOfTables, wReadingSymbolProperties;
    unsigned char auTabFreq[SIZE_OF_PICTURES], auTabCrit[SIZE_OF_PICTURES];
    virtual void NouveauQuad();
    TAnalyseQuad(TWindow* parent);
    void DessineFlecheDAnalQuad();
    void Cm_HistTracTabFreq();
    void Cm_HistTracTabCrit();
    void Cm_QuerySlice();
  private :
    TRect rFigTabCrit,rFigTabFreq,rTracTabCrit,rTracTabFreq;
    int f2eBalayage;
    TStatic *pstFreq;
    TButton *pbHistTraceTabCrit, *pbHistTraceTabFreq;
    TCheckBox *pbt2eBalayage;
    TLabeledEditNum *pestQuerySlice;
    TReperage repCrit,repFreq;
    TComboBoxItems *pcmbPariteFreq;
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void EvMouseMove(UINT a, TPoint& point);
    virtual void SetupWindow();
    virtual void SauvegardeOptions ( void );
    virtual void ChargeOptions ( void );

    ~TAnalyseQuad();
    DECLARE_RESPONSE_TABLE(TAnalyseQuad);
  };
/*--TCadIris-------------------------------------------------------------*/
class TComparateurSymbole : public TAssociatif
  {
  public:
    static TComparateurSymbole *CreateNewComparateurSymbole(
     TWindow *pwParent,
     TDataMatrix *psDMLe,
     TDataMatrix *psDMRi,
     int fAutoDeleteDMLe,
     int fAutoDeleteDMRi
     );
    static TComparateurSymbole *pw;
    void ProcessStat();
    void ProduceReport(char *szReport, unsigned int wLen);
  private :
    TComparateurSymbole(TWindow *pwParent, TDataMatrix *psDMRi, TDataMatrix *psDMLe,
                      int fAutoDeleteDMRi, int fAutoDeleteDMLe);
    ~TComparateurSymbole();

    TDataMatrix *psDMRight, *psDMLeft;
    int fAutoDeleteDMRight,fAutoDeleteDMLeft;
    unsigned int wVSepRL, // VSep right-left
               wHSepPrivPub; // Hsep entre zone dcoupe (en haut) et zone commune (res. de calc.) en bas.
    unsigned int fFinderPattern, wDistance;
    TRect rDMLeft, rDMRight, rStat;

    virtual void Paint(TDC& dc, bool erase, TRect& rect);
  };
class TLectureSymbole : public TPickupQuad
  {
  public:
    int fImageProcess;
    TDataMatrix Symbole;
    TLectureSymbole(TWindow* parent);
    ~TLectureSymbole();
    void CmMenu(WPARAM id);
    void CmSymbolComp();
    virtual void NouveauPoint();
    virtual void NouveauQuad();
    void NouvelleMatrice();
    void CmUserIntervention(WPARAM id);
    void InvalidateMatrice();
    void Ev_ModifTexteSymbole();
    void Ev_ModifNumeriqueSymbole();
    void ProduceReport(char *szReport, unsigned int wLen);

    virtual void AfficheOptions(void);

  protected :
    unsigned int wSepVert, wSepHor0, wSepHor1, wSepHor2;
    BOOL fConsistance,fAutoRedress,fSupportHorloge, wReadingSymbolProperties,fOptionsAccessibles;
    unsigned int wFreqForcee;
    char szImageUtilisee[MAXPATH], szSymbolName[MAXFILE];
    TRect rEspaceTxt, rTxt,rEspaceNum,rNum, rEspaceDivComment,rDivComment,
          rValFreq,rValNbOct,rEspaceSymbole,rSymbole,rButtModifTxt,
          rButtModifNum, rFreq;
    TReperage repSymbole;
    TEdit *peTxtSmb;
    TEditNumCR *peNumSmb, *peFreq, *peNbOct;
    TButton *pbModifTxt,*pbModifNum, *pbtSymbolName;
    TCheckBox *pchkAutoRedress, *pchkSupportHorloge;
    TComboBoxItems *pcmbPariteFreq;
    virtual void SetupWindow();
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void EvMouseMove(UINT a, TPoint& point);
    virtual void EvLButtonDblClk(uint modKeys, TPoint& point);
    virtual void ReleveOptions(void);
    virtual void SauvegardeOptions(void);
    virtual void ChargeOptions(void);

    DECLARE_RESPONSE_TABLE(TLectureSymbole);
 };
//--TAnalyseFreqQuad-----------------------------------------------------
/*
class TAnalyseFreqQuad : public TPickupQuad
  {
  public:
    TAnalyseFreqQuad::TAnalyseFreqQuad(TWindow *parent);
    virtual void NouveauQuad();
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
  };
*/
/*--TTextureQuad---------------------------------------------------------*/
class TTextureQuad : public TPickupQuad
  {
  public :
    int fAnalyseRectangleCirconscrit;
    unsigned int wNbTexelsValides, wNbTexelsTotal;

    TTextureQuad(TWindow* parent);
    ~TTextureQuad();
    virtual void NouveauQuad();
    virtual void SetupWindow();
//    DECLARE_RESPONSE_TABLE(TTextureQuad);
    TLabeledEditNum *pestNbPartTexture, *pestNbTexelsValides;
    TRadioButton *pbtAnalRec, *pbtAnalPolyg;
    void Refresh();
    void Lookup();
  };
extern TLectureSymbole far *pLectureSymbole;
#endif
