#include "myowlall.h"
#include "baptiall.h"
#pragma hdrstop

#define MODULE_NAME "wirsutil"
/**********************************************************************/
/*                       W I R I S       . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions conversationnelles pour Iris         */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      */
/*    Dvelopp le   : Printemps 1996                                 */
/*    Dernire modif.: voir date fichier                              */
/**********************************************************************/
/*
// Inclusions bibliothques standards
#include <io.h>
#include <stdio.h>
#include <dir.h>
//#include <math.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
//#include <owl\applicat.h>
#include <owl\inputdia.h>

//#include <owl\combobox.h>

//#include <owl\scroller.h>

#include <owl\dialog.h>
#include <owl\dc.h>
#include <owl\edit.h>
#include <owl\framewin.h>


// Inclusions bibliothques DOS

*/
// Inclusion bibliothques Image
#include "wsysutil.h"

#include "wgttsi.h"
#include "wappbase.h"
#include "wappbase.rh"
//#include "wlfilt.h"
#include "wmain.h"

//  Inclusions bibliothques Iris
/*#include "wanlfreq.h"
#include "wanallec.h"
*/
/*
#include "base.h"
#include "piadiv.h"
#include "strutil.h"

#include "wanallec.h"
#include "wanlfreq.h"
#include "wcontour.h"
#include "wintrac.h"
#include "wirspick.h"
*/
#include "lseubin.h"
#include "scaltool.h"
#include "sysctr.h"
#include "wgeometr.h"
#include "wirsutil.h"
#include "wsystool.h"
/*
#include "wsymbole.h"
*/
#include "iris.rc"


/*
//  Inclusions bibliothques Sbastien
#include "cortex.rch"
#include "ctxoutil.h"
*/
//-----------------------------------------------------------------------
TFont *pftPhysicalDefaultArial=new TFont("Arial",uHauteurLigne);
TFont *pftDefaultArial=pftPhysicalDefaultArial;


TMenu *pmnuCortex=NULL, *pmnuSebUtil=NULL;
// Utilises comme valeurs par dfaut
char far szReportFile[MAXPATH]=""
  , szRepertoireDepart[MAXDIR]=""
  , szImageDrive[MAXDRIVE]="c:"
  , szImageDir[MAXDIR]="."
  , szScriptDrive[MAXDRIVE]="c:"
  , szScriptDir[MAXDIR]=".";


void Ev_ClicNoDragNouveauPoint(TPoint &pt,int etatsouris)    // une fonction
  {
  if (!(etatsouris & (SOURIS_DRAG_BG | SOURIS_UP_BG)))
    Ev_ClicNouveauPoint(pt,etatsouris);
  }
/*
#pragma message "corps Ev_ClicNouveauPoint provisoire"

void Ev_ClicNouveauPoint(TPoint &,int iState)
  {
  if (iState & SOURIS_STATE_BG)
    Indique_Fonction()->SendMessage(WM_COMMAND,CM_NouveauPoint);
  }
*/
void LoadIsolatedMenus()
  {
  }

DEFINE_RESPONSE_TABLE1(TParametreProgramme, TAssociatif)
  EV_CHILD_NOTIFY_ALL_CODES(ID_PP_Ascenseur, EvAscenseur), // Scroll bar
  EV_COMMAND(ID_PP_KeyBValue,EvKeyBValue), // rponse  la bote d'dition.
  EV_COMMAND(ID_PP_TempsReel,EvTempsReel),
  EV_COMMAND(ID_PP_Application,EvApplication),
END_RESPONSE_TABLE;

TParametreProgramme::TParametreProgramme(char *szTitre, int iMin_in, int
        iMax_in, int iInit_in,
        BOOL (*fAction_in)(unsigned char *puSource, int iParametre, unsigned
            char *puDestination)    )
  : TAssociatif(pFenetreControle, szTitre, ASS_DROITE_BAS)
{
  char szTamp0[20];
  iMin=iMin_in;
  iMax=iMax_in;
  iInit=iInit_in;
  fAction=fAction_in;
  pscrParametre = new TScrollBar(this, ID_PP_Ascenseur, sEspaceUtile.cx/2-128,
      sMarges.cy*2+uHauteurEdit, 256, 0, TRUE);
// Affichage du minimum :
  itoa(iMin,szTamp0,10);
  new TStatic(this, ID_STATIC, szTamp0, sEspaceUtile.cx/2-128-2*uLargeurCar,
      sMarges.cy*2+uHauteurEdit, 1*uLargeurCar, 17, 0);

  peParametre=new TEditNumCR(this, ID_PP_KeyBValue,
      iInit, sEspaceUtile.cx/2-25, sMarges.cy, 50, uHauteurEdit, 5);
// Affichage du maximum :
  itoa(iMax,szTamp0,10);
//  new TStatic(this, ID_STATIC, szTamp0, 240, 5, 50, 17, 0);
  new TStatic(this, ID_STATIC, szTamp0, sEspaceUtile.cx/2+128+sMarges.cx,
      sMarges.cy*2+uHauteurEdit, 4*uLargeurCar, 17, 0);
  pchkTempsReel =new TCheckBox(this, ID_PP_TempsReel, "Temps rel",
    sEspaceUtile.cx/2-128+sMarges.cx,sMarges.cy+uDLE,
    13*uLargeurCar, uHauteurLigne);
  pbtApplication=new TButton(this, ID_PP_Application, "Application",
    sEspaceUtile.cx/2+128-13*uLargeurCar-sMarges.cx,sMarges.cy+uDLE,
    13*uLargeurCar, uHauteurLigne+2);
  }

void TParametreProgramme::SetupWindow()
  {
  TAssociatif::SetupWindow();
  pscrParametre->SetRange(iMin,iMax);
  AfficheParametres(iInit);
  pchkTempsReel->SetCheck(BF_CHECKED);
  pbtApplication->Show(SW_HIDE);
  }

void TParametreProgramme::AfficheParametres(int iParametre)
  {
  peParametre->SetValue(iParametre);
  pscrParametre->SetPosition(iParametre);
  }

void TParametreProgramme::EvAscenseur(UINT)
  {
  int iParametre;
  iParametre=pscrParametre->GetPosition();
  AfficheParametres(iParametre);
  Action(iParametre);
}

void TParametreProgramme::EvTempsReel()
  {
  if (pchkTempsReel->GetCheck() & BF_CHECKED)
    pbtApplication->Show(SW_HIDE);
  else
    {
    pchkTempsReel->SetCheck(BF_UNCHECKED);
    pbtApplication->Show(SW_SHOW);
    }
  }
void TParametreProgramme::EvKeyBValue()
  {
  int iParametre;
// Lecture du parametre
  peParametre->GetValue(&iParametre);
// Rajustement du paramtre
  iParametre=NReduceN(iParametre,iMin,iMax);
// Mise a jour paramtre (bote dition et esccensceur) :
  AfficheParametres(iParametre);
  Action(iParametre);
  }
void TParametreProgramme::EvApplication()
  {
  int iParametre;
// Lecture du parametre
  peParametre->GetValue(&iParametre);
// Rajustement du paramtre
  iParametre=NReduceN(iParametre,iMin,iMax);
// Mise a jour paramtre (bote dition et esccensceur) :
  AfficheParametres(iParametre);
  Action(iParametre,ON);
  }
// Action :
// Parametre fApplication = OFF par dfaut.
void TParametreProgramme::Action(int iParametre, BOOL fApplication)
  {
  if (fApplication || (pchkTempsReel->GetCheck() & BF_CHECKED))
    {
    fAction(source, iParametre, destin);
    Fenetre->Visim(this,1,destin);
    SetActiveWindow();
    }
  }
//-----------------------------------------------------------------------
//      		   Fonctions hors classes
//-----------------------------------------------------------------------
/*-------------------------------------------------------------*/
BOOL SelectHardCopyFile()
  {
    uint32 Flags=FileData.Flags ;
//    FileData.
    FileData.Flags &= ~OFN_FILEMUSTEXIST; // Autorise non existant.
    if((TFileOpenDialog(pFenetreControle, FileData)).Execute() == IDOK)
      {
      strcpy(szHardCopyFile,FileData.FileName);
      fHardCopy=ON;
      }
    else
      fHardCopy=OFF;
    Flags=FileData.Flags=Flags ;  // restitue contexte.
//    }
  return SUCCES;
  }


BOOL MultipliePlanScalaire(unsigned char *puSource, float x, unsigned char *puDestin)
  {
  for (unsigned int i=0;i<SIZE_OF_PICTURES;i++)
    for (unsigned int j=0;j<SIZE_OF_PICTURES;j++)
      puDestin[i*SIZE_OF_PICTURES+j]=
          NReduceR(x* puSource[i*SIZE_OF_PICTURES+j],0,255);
  return SUCCES;
  }
BOOL MultiplieScalaire128(unsigned char *puSource, float x, unsigned char *puDestin)
  {
  for (unsigned int i=0;i<SIZE_OF_PICTURES;i++)
    for (unsigned int j=0;j<SIZE_OF_PICTURES;j++)
      puDestin[i*SIZE_OF_PICTURES+j]=NReduceR(128.0+ x*
          ((int)puSource[i*SIZE_OF_PICTURES+j]-128),0,255);
  return SUCCES;
  }

BOOL ValeurAbsolue128(unsigned char *puSource, unsigned char *puDestin)
  {
  for (unsigned int i=0;i<SIZE_OF_PICTURES;i++)
    for (unsigned int j=0;j<SIZE_OF_PICTURES;j++)
      puDestin[i*SIZE_OF_PICTURES+j]=
          abs((int)puSource[i*SIZE_OF_PICTURES+j]-128);
  return SUCCES;
  }
int AutoSeuillage(unsigned char *puSrc, unsigned char *puDest)
  {
  unsigned int awHistogramme[256],awHistogrammeCumule[256];
  CalHistLoc(awHistogramme, awHistogrammeCumule, puSrc, rImage);
  int iAutoSeuil = Cal_seuil(awHistogramme);
  Seuillage(abs(iAutoSeuil),puSrc,puDest);
  return (iAutoSeuil);
  }

void AppendWoleMenu(TMenu *pmnuSource, TMenu *pmnuTarget)
  {
  char szBuffer[1024]="";
  uint wListLen=pmnuSource->GetMenuItemCount();
  for (uint w=0;w<wListLen;w++)
     {
     uint wID=pmnuSource->GetMenuItemID(w);
     uint wState=pmnuSource->GetMenuState(w,MF_BYPOSITION);
     pmnuSource->GetMenuString(w,szBuffer,sizeof(szBuffer),MF_BYPOSITION);
     pmnuTarget->AppendMenu(wState, wID,szBuffer);

     }
  }

void Ero_dil(char c,unsigned char  *ptsource=0,unsigned char  *ptdestin=0);

TConvmorphoMultiLevel::TConvmorphoMultiLevel(TWindow* parent, unsigned char u)
		: TChoixMenu(parent,"Morphologique multi-niveau",
		"&0 rosion\n&1 Dilatation\n&2 Fermeture\n&3 Ouverture")
{
  uLevel=u;
  char szTitle[1024];
  sprintf(szTitle,"%s (%d)",Title,u);
  SetCaption(szTitle);
}

void TConvmorphoMultiLevel::EvCommun(char c)
{
	Ero_dil(c,source,destin,uLevel,PlanSuiv(destin));
	Fenetre->Visim(this,1,destin);
	SetActiveWindow();
}



void Ero_dil(char c,unsigned char *ptsource,unsigned char *ptdestin, unsigned char uLevel, unsigned char *puBuffer)
  {
  if (c==MORPHO_Ouverture)// '3'
    {
      // Ouverture
      Ero_dil(MORPHO_Erosion,ptsource,puBuffer,uLevel,ptdestin);
      Ero_dil(MORPHO_Dilatation,puBuffer,ptdestin,uLevel,puBuffer);
      return;
    }
   else if (c==MORPHO_Fermeture)   //  '4' FERMETURE
     {
      Ero_dil(MORPHO_Dilatation,ptsource,puBuffer,uLevel,ptdestin);
      Ero_dil(MORPHO_Erosion,puBuffer,ptdestin,uLevel,puBuffer);
      return;
     }



  if (!uLevel)
    {
    Copie_plan(ptsource,ptdestin);
    return;
    }
  if (uLevel==1)
    Ero_dil(c,ptsource,ptdestin);
  else if (!puBuffer)
    return;
// uLevel > 1 et  puBuffer existe
  Ero_dil(c,ptsource,ptdestin);
  uLevel--;
// le transfert tombe pile
  for (unsigned char u=uLevel; u>=2; u-=2)
    {
    Ero_dil(c,ptdestin,puBuffer);
    Ero_dil(c,puBuffer,ptdestin);
    }
  if (u)
    {
    Ero_dil(c,ptdestin,puBuffer);
    Copie_plan(puBuffer,ptdestin);
    }
  }

int FindImageFile(char *szName, char *szPath)
// Look in several directories if a image match that name.
  {
  if (!access(szName,04)) // The file exist with its specified path
    {
    if (szPath) strcpy(szPath,szName);

    return SUCCESS;
    }
// Split the specified name and check in the following directories:
// Image, current and Scripts.

  char szLocalDrive[MAXDRIVE],szLocalDir[MAXDIR],szLocalName[MAXFILE],
      szLocalExt[MAXEXT],szImagePath[MAXPATH], szScriptPath[MAXPATH],
      szCurrentPath[MAXPATH];

  fnsplit (szName,szLocalDrive,szLocalDir,szLocalName,szLocalExt);

  fnmerge(szImagePath, szImageDrive, szImageDir, szLocalName, szLocalExt);
  if (!access(szImagePath,04))
    {
    if (szPath) strcpy(szPath,szImagePath);
    return TRUE;
    }
  fnmerge(szScriptPath, szScriptDrive, szScriptDir, szLocalName, szLocalExt);
  if (!access(szScriptPath,04))
    {
    if (szPath) strcpy(szPath,szScriptPath);
    return TRUE;
    }
  fnmerge(szCurrentPath, "", "", szLocalName, "smb");
  if (!access(szCurrentPath,04))
    {
    if (szPath) strcpy(szPath,szCurrentPath);
    return TRUE;
    }
  if (szPath) *szPath=0;
  return FALSE;
  }


