/**********************************************************************/
/*                       W I R I S       . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRSUTIL_H
#define WIRSUTIL_H

#include "wsysutil.h"
/*
#include "wirspick.h"
#include "symbole.h"
*/

#define MORPHO_Erosion    '0'
#define MORPHO_Dilatation '1'
#define MORPHO_Ouverture  '3'
#define MORPHO_Fermeture  '2'


/*
#define SOURIS_STATE_BD 0x01
#define SOURIS_STATE_BG 0x02
#define SOURIS_DRAG_BD 0x04
#define SOURIS_DRAG_BG 0x08
#define SOURIS_UP_BD 0x10
#define SOURIS_UP_BG 0x20
*/

//void Ev_ClicNouveauPoint(TPoint &,int); // provisoire
void Ev_ClicNoDragNouveauPoint(TPoint &,int etatsouris);    // une fonction
/*
#pragma message "prototype Ev_ActualClicNouveauPoint provisoire"
void Ev_ActualClicNouveauPoint(TPoint &,int iState);
*/
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
class TParametreProgramme : public TAssociatif {
  public:
    TParametreProgramme(char *szTitre, int iMin_in, int
        iMax_in, int iInit_in,
        BOOL (*fAction)(unsigned char *puSource, int iParametre, unsigned
            char *puDestination)    );
     virtual void Action(int iParametre, BOOL fApplication=OFF);
  protected:
    virtual void SetupWindow();
    virtual void EvKeyBValue();
    virtual void EvApplication();
    virtual void EvTempsReel();
    virtual void EvAscenseur(UINT);
    virtual void AfficheParametres(int uValue);
    int iMin, iMax, iInit;
    TScrollBar *pscrParametre;
    TEditNumCR *peParametre;
    TCheckBox *pchkTempsReel;
    TButton *pbtApplication;
    BOOL (*fAction)(unsigned char *puSource, int iParametre,
      unsigned char *puDestination);
  DECLARE_RESPONSE_TABLE(TParametreProgramme);
};

BOOL MultipliePlanScalaire(unsigned char *puSource, float x, unsigned char *puDestin);
BOOL MultiplieScalaire128(unsigned char *puSource, float x,
    unsigned char *puDestin);
BOOL ValeurAbsolue128(unsigned char *puSource, unsigned char *puDestin);
int AutoSeuillage(unsigned char *puSrc, unsigned char *puDest);
void Ero_dil(char c,unsigned char *ptsource,unsigned char far *ptdestin,
    unsigned char uLevel, unsigned char *puBuffer=NULL);

void AppendWoleMenu(TMenu *pmnuSource, TMenu *pmnuTarget);
int FindImageFile(char *szName, char *szPath=NULL);


extern TMenu *pmnuCortex, *pmnuSebUtil;

extern TFont *pftDefaultArial;

class TConvmorphoMultiLevel: public TChoixMenu
  {
  unsigned char uLevel;
  void EvCommun(char c);
  public :
    TConvmorphoMultiLevel(TWindow* parent, unsigned char u);
  };
/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*/
BOOL SelectHardCopyFile();
void LoadIsolatedMenus();
extern char far szRepertoireDepart[MAXDIR], szImageDrive[MAXDRIVE],
    szImageDir[MAXDIR],
    szReportFile[MAXPATH],
    szScriptDrive[MAXDRIVE],szScriptDir [MAXDIR];

#endif // IRSOUTIL_H
