/***************************************************************/
/*                       W L E X 1 . C P P                     */
/*-------------------------------------------------------------*/
/*    Fonction       : Montre des exemples d'oprations        */
/*                     sur des images                          */
/*-------------------------------------------------------------*/
/*    Auteurs        : MC                                      */
/*    Dvelopp le   :                                         */
/*    Dernire modif.:                                         */
/***************************************************************/


#include <stdlib.h>
#include "wgttsi.h"

/*----------------------------------------------*/
/*                                              */
/*              Constantes du programme         */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*              Variables du programme          */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*              Structures du programme         */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*              Variables externes              */
/*                                              */
/*----------------------------------------------*/

/*----------------------------------------------*/
/*                                              */
/*           Fonctions prototypes               */
/*                                              */
/*----------------------------------------------*/

void far Opera(char c);
void far Mirexy(char c,unsigned char far *image);
void far Surf(int xmin,int xmax,int ymin,int ymax,
					 long *sur,long *cgx,long *cgy,int msk);

/*-------------------------------------------------------------*/
/*  Fonction :                   O P E R A                     */
/*-------------------------------------------------------------*/
/*  Fonction : Opration entre 2 plans  (source - c -> destin) */
/*  Paramtres en entre : c = Numro du plan concern         */
/*  Valeur retourne : Aucune                                  */
/*-------------------------------------------------------------*/

void far Opera(char c)

{

unsigned char far *pointim1,*pointim2,*pointim3;
int a,b;
unsigned int i=0;

	pointim1=source;

	switch(c)
	{
	case '0':pointim2=image0;break;
	case '1':pointim2=image1;break;
	case '2':pointim2=image2;break;
	case '3':pointim2=image3;break;
	case '4':pointim2=image4;break;
	case '5':pointim2=image5;break;
	case '6':pointim2=image6;break;
	case '7':pointim2=image7;break;
	}

	pointim3=destin;

	do
	{
	a=*pointim1++;
	b=*pointim2++;
	*pointim3++=abs(a-b);
	}
	while(++i);

}

/*-------------------------------------------------------------*/
/*  Fonction :               M I R E X Y                       */
/*-------------------------------------------------------------*/
/*  Fonction : Ecriture d'une mire de gris suivant X ou Y dans */
/*             le buffer image                                 */
/*  Paramtres en entre : image = pointeur sur le buffer      */
/*                           c   = '0' mire suivant X          */
/*                               = '1' mire suivant Y          */
/*  Valeur retourne : Aucune                                  */
/*-------------------------------------------------------------*/

void far Mirexy(char c,unsigned char far *image)

{

unsigned char far *pointim;
int x,y;

		  pointim=image;

        for(y=0;y<256;y++)
        {
                for(x=0;x<256;x++)
                {
                if(c=='0') *pointim++=x;else *pointim++=y;
					 }
	   }
}

/*-------------------------------------------------------------*/
/*  Fonction :                 S U R F                         */
/*-------------------------------------------------------------*/
/*  Fonction : Calcul  de la surface et du CG d'un objet       */
/*             dans le plan destination                        */
/*  Paramtres en entre : (xmi, xma, ymi, yma) = cadre        */
/*                         *sur= surface                       */
/*                         *cgx= centre de gravit x           */
/*                         *cgy= centre de gravit y           */
/*                         msk= masque pour calcul             */
/*  Valeur retourne : Aucune                                  */
/*-------------------------------------------------------------*/

void far Surf(int xmin,int xmax,int ymin,int ymax,
			 long *sur,long *cgx,long *cgy,int msk)
{

int x,y;
unsigned char far *pointim,p;

		  *sur=*cgx=*cgy=0;

		  for(y=ymin;y<ymax+1;y++)
		  {pointim=destin+(y<<8)+xmin;
					 for(x=xmin;x<xmax+1;x++)
					 {
					 p=*pointim++;p&=msk;
			 if(p!=0){(*sur)++;(*cgx)+=x;(*cgy)+=y;}
					 }
			}
if((*sur)!=0){(*cgx)/=(*sur);(*cgy)/=(*sur);}

}

/*-------------------------------------------------------------*/

