/**********************************************************************/
/*                       W M O D E L E . C P P                        */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         :  			                  			      	 */
/*    Dvelopp le   :                                                */
/*    Dernire modif.:                                                */
/**********************************************************************/

#include "wgttsi.h"                    // Librairies Image

#include "wmain.h"
#include "wappbase.h"
#include "wmodele.rc"
#include "wmodele.h"

TFenPerso *FenetrePerso;               // Pointeurs sur les objets
TAppPerso *ApplicationPerso;
TCadPerso *CadrePerso;

//----------------------------------------------------------------------------
//						Programme principal : conversationnel TFenPerso
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TFenPerso, TFen)

	EV_COMMAND(CM_T0, CmT0),
	EV_COMMAND(CM_T1, CmT1),
	EV_COMMAND(CM_T2, CmT2),
	EV_COMMAND(CM_T3, CmT3),
END_RESPONSE_TABLE;

TFenPerso::TFenPerso(TWindow *Parent):TFen(Parent)
{
  FenetrePerso=this;
  pmnuApplications=new TMenu((HINSTANCE)(*((TApplication*)ApplicationPerso)),
  "TheApplication");
}

void TFenPerso::SetupWindow()
{
  TFen::SetupWindow();
  pmnuPrincipal->InsertMenu(NumeroApplication, MF_POPUP | MF_BYPOSITION,
	*(FenetrePerso->pmnuApplications),"&Applications");
}

void TFenPerso::CmT0(){MessageBox("Traitement 0",TitreApplication,MB_OK);}
void TFenPerso::CmT1(){MessageBox("Traitement 1",TitreApplication,MB_OK);}
void TFenPerso::CmT2(){MessageBox("Traitement 2",TitreApplication,MB_OK);}
void TFenPerso::CmT3(){MessageBox("Traitement 3",TitreApplication,MB_OK);}

//----------------------------------------------------------------------------

TAppPerso::TAppPerso() : TApp()
{
  ApplicationPerso=this;
}

void TAppPerso::InitMainWindow()
{
  new TCadPerso(NULL,TitreApplication,new TFenPerso,TRUE);
  TApp::InitMainWindow();
}

//----------------------------------------------------------------------------

TCadPerso::TCadPerso(TWindow *Parent, char far *Title, TWindow *Client,
							BOOL trackMenuSelection)
						  : TCad (Parent, Title, Client, trackMenuSelection)
{
  CadrePerso=this;
}

//----------------------------------------------------------------------------
//						Programme OwlMain
//----------------------------------------------------------------------------

int OwlMain(int argc, char* argv[])
{
  if(DemarrageCarte())               	// Initialisations
	{
  strcpy(TitreApplication,"Logiciel de traitement d'images");
  strcpy(TexteAbout,"Version : \n\nAuteur :");
  strcpy(FichierAide,"aide.HLP");    	// Optionnel

  argc_=argc;
  argv_=argv;

  return TAppPerso().Run();          	// Lancement du programme
	}
  else
  {
  MessageBox(0,"","ERREUR D'INITIALISATION",MB_OK | MB_ICONEXCLAMATION);
	return 0;                      	// Erreur
  }
}

//----------------------------------------------------------------------------

