// Inclus dans le paquetage Cattoen

/*******************|*******************************************/
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1997                             */
/***************************************************************/
#ifndef STRTOOL_H
#define STRTOOL_H

#define CONTINUOUS_WRAPPING       1
#define SEPARATOR_WRAPPING        2

#include <ctype.h>
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
// Pointer on the separators used by the string utilities functions.
// User can make it point towards its personnal character set.
// Default value is acDefaultSeparators.
extern char *acUsualSeparators;

// Character set of elligible separators for string utilities.
extern char acDefaultSeparators[];

/*-------------------------------------------------------------*/
/*                    Functions headers                        */
/*-------------------------------------------------------------*/
// AvaleEspace renvoit un pointeur sur le premier caractre non espace.
int WrappText (char *LongText // Long text to wrap
    ,unsigned int wlt // Length of LongText
    ,char *WrappedText, // Allocated string to place wrapped text
    unsigned int wwt, // Size of allocation of   WrappedText
     unsigned int wNombreCarParLgn,  // Number of charcater allowed in one line
    unsigned char uTypeWrapping); // Parameter

int Dewrappe(char *szLongText);

char *AvaleEspace (char *ligne);

// Substitute to strncpy. Set the maxlen-th character to 0.
// WILL BUG SEVERELY if the dest is allocated BELLOW maxlen
inline char *strNcpy(char *dest, char *src, unsigned int maxlen)
  {
  if (maxlen)
    {
    strncpy(dest,src,maxlen); // copy up to w characters.
    dest[maxlen-1]=0;
    }
  return src;
  }

/*-------------------------------------------------------------*/
/*                    Inline functions                         */
/*-------------------------------------------------------------*/
// The following functions are "inline" to produce fastest code.

// Say if c is digit ('0' to '9')
inline int IsDigit(unsigned char c)
  {
  return !!isdigit(c); // !! is for the case when isdigit replies 256.
  }

// Say if c is elligible for integer component string character ('0' to '9' and signe '-' or '+')
inline int IsNumericInt(char c)
  {
  return (IsDigit(c)|| c=='+' || c=='-' );
  }
// Say if c is elligible for float component string character
//('0' to '9', '-', '+' or '.')
inline int IsNumericFloat(char c)
  {
  return (IsNumericInt(c)|| c=='.');
  }

/*
  Extract value is a kind of "itoa" or "atof" with better error checking.
  ExtractValue scan the string for the first non space characters in it.
If this character is the first character of a number, then this number is read
from the string and stored in the pointer (2nd parameter).
  If the scanning and reading is successful, ExtractValue return non null value.
Otherwise,  ExtractValue returns 0.
  Dummy values may be stored in the pointer (2nd parameter) if scanning or
reading fails (ie when ExtractValue returns 0).

  The 3rd parameter is optionnal, is a pointer on string (char **). If this
parameter is given and not NULL, the pointed string will be set pointing to the
first character after the first separator which  follows the number
(set to NULL if end of string).
  This allows to process successive reading from the same string without
character handling on the string.

*/
int ExtractValue(char *szLigne, int *piValue, char **pNext=NULL);
int ExtractValue(char *szLigne, float *px, char **ppcNext=NULL);


template <class T> int ExtractIntishValue(char *szLigne, T *pValue, char **pNext=NULL)
  {
  int iValue;
  if (pValue && ExtractValue(szLigne,&iValue,pNext))
    {
    *pValue=(T)iValue;
    return 1;
    }
  else
    return 0;
  }
template <class T> int ExtractFloatishValue(char *szLigne, T *pValue, char **pNext=NULL)
  {
  float xValue;
  if (pValue && ExtractValue(szLigne,&xValue,pNext))
    {
    *pValue=(T)xValue;
    return 1;
    }
  else
    return ECHEC;
  }

inline int ExtractValue(char *szLigne, unsigned int *pwValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,pwValue,pNext);
  }
inline int ExtractValue(char *szLigne, unsigned char *puValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,puValue,pNext);
  }
inline int ExtractValue(char *szLigne, char *pcValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,pcValue,pNext);
  }
inline int ExtractValue(char *szLigne, double *pxValue, char **pNext=NULL)
  {
  return ExtractFloatishValue(szLigne,pxValue,pNext);
  }

inline int IsSeparator(char c)
  {
  return !!strchr(acUsualSeparators,c); // Returns TRUE for '/0'.
  }

#endif // STRTOOL_H
