/**********************************************************************/
/*                       W A N I M N B . H		                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 25/04/1997 			                            */
/*    Dernire modif.: 02/01/1998                               		 */
/**********************************************************************/
#if !defined(WANIMNB_H)
#define WANIMNB_H

#include "wlseqnb.h"

//----------------------------------------------------------------------------
//						Programme TCreaseq
//----------------------------------------------------------------------------

class TCreaseq : public TChoixMenu {
  public:

	 TCreaseq(TWindow* parent);
	~TCreaseq();

	 void Enregim();
	 void EvCommun(char c);
	 virtual void Acq_destin(void);
	 virtual void SetupWindow();

 protected:
	 void EvTimer(UINT timerId);
	 void Arret_Enreg(void);

	 int modecreaseq;      // mode cration de fichier sq
	 long numimag2;
	 int stop2;
	 long t01,t11,numimag1,n01,n11,vit_anim1;
	 TStatic* Bseq1,*Bseq2,*Bseq3,*Bseq4;
	 long numero11,numero21;
	 int indic_visu;
    long nbtotcod;
	 unsigned char far * bufcode;
	 int flag_enr;
	 int mode_test;

char nomgen1[12];
char driveseq1[MAXDRIVE];
char dirseq1[MAXDIR];
char fileseq1[MAXFILE];
char extseq1[MAXEXT];
TOpenSaveDialog::TData FileData2;    // Pour fichiers en lect. et ecr.

FILE *out1;                            // fichier de sortie

chaine_seqnb chaine1;                 // chanage
en_tete_image en_tete_im1;               // en-tte

  DECLARE_RESPONSE_TABLE(TCreaseq);
};

extern TCreaseq* TCreaseqPtr;        	// Fentre cration de squence

//----------------------------------------------------------------------------
//						Programme TSequencenb
//----------------------------------------------------------------------------

class TSequencenb : public TFrameWindow {
  public:

	TSequencenb(TWindow* parent,char titre[]);
	~TSequencenb();

	 virtual int EvCommun(char c);
	 virtual void SetupWindow();
	 virtual void Goto(long numim);
	 virtual void Goto_Anim(long numim);

	 long numimag;                     // Variables globales
	 int stop;
	 int pas;
	 int modboucle;
	 long nbtotimage;

  protected:

	 void EvTimer(UINT timerId);
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvLButtonDown(UINT, TPoint&);
	 void EvLButtonUp(UINT, TPoint&);
	 void EvMouseMove(UINT, TPoint&);
	 void EvMButtonDown(UINT, TPoint&);
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvH(WPARAM id);
	 void EvI(WPARAM id);
	 void EvJ(WPARAM id);
	 void Affim();
	 void Calimsuiv();
	 void Calnum(char file[],char nomgen[],long *num);
	 void Edit();
	 void Affcarim(long);
    void Arret();

	//BOOL modefich;
	long t0,t1,n0,n1;
	TStatic *Aseq,*Bseq,*Cseq,*Dseq,*Eseq,*Fseq,*Gseq,*Hseq;
	TGauge *SolidGauge;
	int flagsequence;                  // Pour souris

	TOpenSaveDialog::TData FileData2;    // Pour fichiers en lect. et ecr.
	TOpenSaveDialog::TData FileData5;    // Pour fichiers en lect. et ecr.

	char nomgen2[12];
	char driveseq2[MAXDRIVE];
	char dirseq2[MAXDIR];
	char fileseq2[MAXFILE];
	char extseq2[MAXEXT];

  DECLARE_RESPONSE_TABLE(TSequencenb);
};

extern TSequencenb* TSequencenbPtr;		  	// Fentre sequence

//----------------------------------------------------------------------------
//						Programme TAnima
//----------------------------------------------------------------------------

class TAnima : public TFrameWindow {
  public:

	 TAnima(TWindow* parent);
	~TAnima();

	 void Affim1();
	 void Calnum(char file[],char nomgen[],long *num);
 protected:
	 void EvClose();
	 void SetupWindow();
	 void EvTimer(UINT timerId);
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvLButtonDown(UINT, TPoint&);
	 void EvLButtonUp(UINT, TPoint&);
	 void EvMouseMove(UINT, TPoint&);
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvH(WPARAM id);
	 void EvI(WPARAM id);
	 void EvCommun(char c);

	 int flag11;
	 int finauto; 	  // Pour dernire image automatique
	 long t01,t11,n01,n11,vit_anim1;
	 int stop1;
	 int sens1;
	 int pas1;
	 long numimag1;
	 long nbtot1;
	 TStatic *Aseq1,*Bseq1,*Cseq1,*Dseq1,*Eseq1,*Fseq1,*Gseq1;
	 TGauge *SolidGauge1;
    TOpenSaveDialog::TData FileData6;
	 char nomgen[12];
	 long numero1,numero2;
	 char driveseq[MAXDRIVE];
	 char dirseq[MAXDIR];
	 char fileseq[MAXFILE];
	 char extseq[MAXEXT];

  DECLARE_RESPONSE_TABLE(TAnima);
};

extern TAnima* TAnimaPtr;        		// Fentre animation

//----------------------------------------------------------------------------
#endif  // WANIMNB_H
