/**********************************************************************/
/*                       W A P P B A S E . H		                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC et BM               			      	       */
/*    Dvelopp le   : 27/03/1996                                     */
/*    Dernire modif.: 26/11/1997                                     */
/**********************************************************************/
#if !defined(WAPPBASE_H)
#define WAPPBASE_H

#include <dir.h>

#include <owl\controlb.h>
#include <owl\decframe.h>
#include <owl\opensave.h>
#include <owl\statusba.h>
#include <owl\textgadg.h>

extern TTextGadget *pZ0,*pZ1,*pZ2,*pZ3;
extern TOpenSaveDialog::TData FileData;
extern char TexteAbout[];                    // A propos
extern char TitreApplication[];
extern char FichierAide[];
extern char TableFich[8][80];
extern int argc_;                              // passages de paramtres OwlMain
extern char **argv_;
extern BOOL F1Pressed;                         // pour aide

//----------------------------------------------------------------------------
//						Programme principal : conversationnel
//----------------------------------------------------------------------------

class TFen : public TWindow {
  public:
	 TFen(TWindow *parent = 0);     // Constructeur

	 TMenu *pmnuPrincipal, *pmnuImage, *pmnuMesures,
	 *pmnuOutils, *pmnuTraitements,*pmnuApplications,
	 *pmnuConfiguration;
	 int NumeroApplication;

	 void Visim(TWindow* parent,int type,unsigned char far *pointim);
	 virtual void CmSequence();
	 virtual void CmModenb();
	 virtual void CmModecoul();

 	 void Charge_image(char *string);
	 virtual void SetupWindow();
	 virtual BOOL CanClose();
	 virtual void EvLButtonUp(UINT, TPoint& );
	 virtual void EvLButtonDown(UINT, TPoint& );
	 BOOL CmHelp(uint);
	 
  protected:
	 void Efface_TableFich(void);
	 virtual void NewUtil(int modeutil);
	 virtual void EvTimer(UINT timerId);
	 void CmAcqui();
	 void CmFileOpen();
	 void CmFileSaveAs();
	 void CmAbout();
	 void SaveFile();
	 void OpenFile();
	 void CmMire();
	 void CmSeuil();
	 void Lecbin();
	 void CmFen();
	 void CmPrlig();
	 void CmPrcol();
	 void CmPerspec();
	 void CmNegat();
	 void CmGeom();
	 void CmPseudo();
	 void CmSource0();
	 void CmSource1();
	 void CmSource2();
	 void CmSource3();
	 void CmStat();
	 void CmCoocur();
	 void CmCovar();
	 void CmTache();
	 void CmEffac();
	 void CmDiff();
	 void CmHelpIndex();
	 void CmHelpHelp();
	 void CmConnex();
	 void CmInteg();
	 void CmAnima();
	 void CmHisto();
	 void CmTransfert();
	 void CmCreaseq();
	 void CmSource4();
	 void CmSource5();
	 void CmSource6();
	 void CmSource7();
	 void CmFilt();
	 void CmModif();
	 void CmCarac();
	 void CmConto();
	 void CmCompass();
	 void CmMedian();
	 void CmQuantif();
	 void CmPlanbit();
	 void CmResol();
	 void CmMorpho();
	 void CmMoyen();
	 void CmVisu();
	 void CmAnimaseq();
	 void CmModeauto();

	 int num_acqui;                          // Numro image acquise
	 int flag_droit;                         // pour cration fentre droite
	 char RepertoireCourant[MAXDIR];
    int modeauto;
	 DECLARE_RESPONSE_TABLE(TFen);

};

//----------------------------------------------------------------------------

class TApp : public TApplication {
  public:
	 TControlBar *cb;
	 TStatusBar* sb;             					// Status bar
	 TApp();
	 void InitInstance();
	 virtual void InitMainWindow();
	 virtual BOOL CanClose();
	 void EvDropFiles(TDropInfo dropInfo);
	DECLARE_RESPONSE_TABLE(TApp);

};

//----------------------------------------------------------------------------

class TCad : public TDecoratedFrame {
  public:
  TCad(TWindow *Parent, const char far *title, TWindow* clientWnd,
			  BOOL trackMenuSelection=FALSE);
    void EvEnterIdle(UINT source, HWND hWndDlg);

	 DECLARE_RESPONSE_TABLE(TCad);
};

//----------------------------------------------------------------------------

extern TCad *Cadre;      			// Fentre principale
extern TFen *Fenetre;      			// Fentre principale
extern TApp* Applicat;      			// Fentre principale

//----------------------------------------------------------------------------
#endif  // WAPPBASE_H
