/**********************************************************************/
/*                       W A P P C O N V . H	                         */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 03/10/1997                                     */
/*    Dernire modif.: 03/10/1997                                     */
/**********************************************************************/
#if !defined(WAPPCONV_H)
#define WAPPCONV_H

													 // Pointeurs sur les fentres
extern TChoixMenu* TConvhoughPtr;     	 // Fentre hough
extern TChoixMenu* TConvsegreduiPtr;    // Fentre seg couleur rduite
extern TChoixMenu* TConvcolorPtr;  		 // Fentre transf. color.

//----------------------------------------------------------------------------
//						Programme TSeuilC
//----------------------------------------------------------------------------

class TSeuilC : public TSeuil{
  public:

	TSeuilC(TWindow* parent,char titre[],int smin,int smax,int sinit);

	~TSeuilC();
	 virtual void EvCommun(int);

	};

//----------------------------------------------------------------------------
//						Programme TSeuilH
//----------------------------------------------------------------------------

class TSeuilH : public TSeuil{
  public:

	TSeuilH(TWindow* parent,char titre[],int smin,int smax,int sinit);

	~TSeuilH();
	 virtual void EvCommun(int);

	};

//----------------------------------------------------------------------------
//						Programme TConvcolor
//----------------------------------------------------------------------------

 class TConvcolor : public TChoixMenu  {
  public:

	 TConvcolor(TWindow* parent);
	~TConvcolor();
	 void EvCommun(char c);
  protected:
	 unsigned char far *im4,*im5,*im6;  // Pour allocation images temp.
};

//----------------------------------------------------------------------------
//						Programme TConvsegredui
//----------------------------------------------------------------------------

 class TConvsegredui : public TChoixMenu {
  public:

	 TConvsegredui(TWindow* parent);
	~TConvsegredui();
	 void EvCommun(char c);

  protected:
	 unsigned char far *im4,*im5,*im6;  // Pour allocation images temp.
};

//----------------------------------------------------------------------------
//						Programme TConvseg
//----------------------------------------------------------------------------

 class TConvseg : public TFrameWindow {
  public:

	 TConvseg(TWindow* parent);
	~TConvseg();

	 virtual void Execute();
	 virtual void NouveauPoint();
  protected:
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void EvCommun(char c);
	 void AfficheOptions(void);
	 TEdit *Rmin,*Rmax,*Vmin,*Vmax,*Bmin,*Bmax;
	int vmin,vmax,rmin,rmax,bmin,bmax;

  DECLARE_RESPONSE_TABLE(TConvseg);
};

extern TConvseg* TConvsegPtr;     	 // Fentre seg couleur

//----------------------------------------------------------------------------
//						Programme TConvhough
//----------------------------------------------------------------------------

 class TConvhough : public TChoixMenu {
  public:

	 TConvhough(TWindow* parent);
	~TConvhough();
	 void EvCommun(char c);
};


//----------------------------------------------------------------------------
#endif  //WAPPCONV_H
