/**********************************************************************/
/*                       W C O N V . H		                            */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/
#if !defined(WCONV_H)
#define WCONV_H

													 // Pointeurs sur les fentres
extern TWindow* TConvglisPtr;         // Fentre filt  moyen glis
extern TWindow* TConvfiltPtr ;      	 // Fentre filt
extern TChoixMenu* TConvhistPtr ;       // Fentre modif histo
extern TChoixMenu* TConvcontoPtr ;      // Fentre contours
extern TChoixMenu* TConvcompassPtr ;    // Fentre compass
extern TChoixMenu* TConvplanbitPtr ;    // Fentre plan bit
extern TChoixMenu* TConvquantifPtr ;    // Fentre quantif
extern TChoixMenu* TConvresolPtr ;      // Fentre resol
extern TChoixMenu* TConvmorphoPtr ;     // Fentre morpho
extern TChoixMenu* TConvmedianPtr ;     // Fentre mdian

//----------------------------------------------------------------------------
//						Programme TConvmedian
//----------------------------------------------------------------------------

 class TConvmedian : public TChoixMenu {
  public:

	 TConvmedian(TWindow* parent);
	~TConvmedian();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvmorpho
//----------------------------------------------------------------------------

 class TConvmorpho : public TChoixMenu {
  public:

	 TConvmorpho(TWindow* parent);
	~TConvmorpho();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvresol
//----------------------------------------------------------------------------

 class TConvresol : public TChoixMenu {
  public:

	 TConvresol(TWindow* parent);
	~TConvresol();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvplanbit
//----------------------------------------------------------------------------

 class TConvplanbit : public TChoixMenu {
  public:
//    static char * AffichageBoutons;

	 TConvplanbit(TWindow* parent, char *titre, char *AffichageBoutons);
	~TConvplanbit();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvquantif
//----------------------------------------------------------------------------

 class TConvquantif : public TChoixMenu  {
  public:

	 TConvquantif(TWindow* parent);
	~TConvquantif();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvcompass
//----------------------------------------------------------------------------

 class TConvcompass : public TChoixMenu  {
  public:

	 TConvcompass(TWindow* parent);
	~TConvcompass();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvconto
//----------------------------------------------------------------------------

 class TConvconto : public TChoixMenu {
  public:

	 TConvconto(TWindow* parent);
	~TConvconto();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvhist
//----------------------------------------------------------------------------

 class TConvhist : public TChoixMenu  {
  public:

	 TConvhist(TWindow* parent);
	~TConvhist();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
//						Programme TConvfilt
//----------------------------------------------------------------------------

class TConvfilt : public TFrameWindow {
  public:

	 TConvfilt(TWindow* parent);
	~TConvfilt();
  protected:
  int A0,A1,A2,A3,A4,A5,A6,A7,A8;
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void AfficheCoeff(void);
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvExec(UINT);
	 void EvCommun(char c);
    char commande;
	 TEdit *CA0,*CA1,*CA2,*CA3,*CA4,*CA5,*CA6,*CA7,*CA8;
	 TRadioButton *PB0,*PB1,*PB2,*PH0,*PH1,*PH2;

  DECLARE_RESPONSE_TABLE(TConvfilt);
};

//----------------------------------------------------------------------------
//						Programme TConvglis
//----------------------------------------------------------------------------

class TConvglis : public TFrameWindow {
  public:

	 TConvglis(TWindow* parent);
	~TConvglis();
	protected:
	 int ordrel,ordrec;
	 void SetupWindow();
	 void EvExec(UINT);
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void AfficheCoeff(void);
	 TEdit *Lig,*Col;
  DECLARE_RESPONSE_TABLE(TConvglis);
};

//----------------------------------------------------------------------------
#endif  //WCONV_H
