/**********************************************************************/
/*                       W M A I C O N V . H		                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 18/11/1996                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/
#if !defined(WMAICONV_H)
#define WMAICONV_H

extern TWindow* TConvocurPtr;         // Fentre coocur
extern TWindow* TFenPtr;            	// Fentre fen

//----------------------------------------------------------------------------
//						Programme TConvdiff
//----------------------------------------------------------------------------

 class TConvdiff : public TChoixMenu {
  public:

	 TConvdiff(TWindow* parent);
	~TConvdiff();
	 void EvCommun(char c);
};

extern TChoixMenu* TConvdiffPtr;     	// Fentre diffrence

//----------------------------------------------------------------------------
//						Programme TConvocur
//----------------------------------------------------------------------------

class TConvocur : public TFrameWindow {
  public:

	 TConvocur(TWindow* parent);
	~TConvocur();
	protected:
	 int depx,depy;
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void AfficheCoeff(void);
	 TEdit *Lig,*Col;
  DECLARE_RESPONSE_TABLE(TConvocur);
};


//----------------------------------------------------------------------------
//						Programme TConvhiscou
//----------------------------------------------------------------------------

 class TConvhiscou : public TChoixMenu {
  public:

	 TConvhiscou(TWindow* parent);
	~TConvhiscou();
	 void EvCommun(char c);
};

extern TChoixMenu* TConvhiscouPtr;     	// Fentre histo couleur

//----------------------------------------------------------------------------
//						Programme TPseudo
//----------------------------------------------------------------------------

class TPseudo : public TFrameWindow {
  public:

	 TPseudo(TWindow* parent);
	~TPseudo();
	 virtual void Execute();
	 virtual void NouveauPoint();
	 virtual void PointImage(TPoint&,int);
  protected:
	 void SetupWindow();
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvExec(UINT);
	 void EvCommun(char c);
	 void AfficheOptions(void);

	 char commande;
	 TScrollBar *Minx,*Maxx;
	 TStatic *Apseu,*Bpseu,*Cpseu,*Dpseu;
	 TRadioButton *Fpseu,*Gpseu,*Hpseu,*Ipseu,*Jpseu;

  DECLARE_RESPONSE_TABLE(TPseudo);
};

extern TPseudo* TPseudoPtr;          	// Fentre pseudo

//----------------------------------------------------------------------------
//						Programme TGeom
//----------------------------------------------------------------------------

class TGeom : public TFrameWindow {
  public:

	 TGeom(TWindow* parent);
	~TGeom();
	 virtual void Execute();
	 virtual void NouveauPoint();
	 virtual void PointImage(TPoint&,int);
  protected:
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvExec(UINT);
	 void EvCommun(char c);
	 void AfficheOptions(void);
    char commande;

	 TScrollBar *Angle,*Xcent,*Ycent,*Xgrand,*Ygrand;
	 TEdit *Ageom,*Bgeom,*Cgeom,*Dgeom,*Egeom;
	 TRadioButton *Fgeom,*Ggeom;

  DECLARE_RESPONSE_TABLE(TGeom);
};
extern TGeom* TGeomPtr;     			// Fentre geom

//----------------------------------------------------------------------------
//						Programme TUtil
//----------------------------------------------------------------------------

class TUtil : public TUtilitaire {
  public:
	 TUtil(TWindow* parent,char far titre[],int mode,BOOL affichinit);
	~TUtil();
	 virtual void Paint(TDC& dc, BOOL, TRect&);
	 virtual void NouveauPoint();
	 virtual void PointImage(TPoint&,int);
  protected:
	 virtual void EvSize(UINT sizeType, TSize& size);
	 virtual void EvMouseMove(UINT, TPoint&);
	 virtual void EvMButtonDown(UINT, TPoint &);
	int modeutil;
	TEdit *Px,*Py;
	BOOL fConsistanceUtil;
  DECLARE_RESPONSE_TABLE(TUtil);
};

//----------------------------------------------------------------------------
//						Programme TPrevisu
//----------------------------------------------------------------------------

class TPrevisu : public TFrameWindow
{
	public:
	TPrevisu(TWindow* parent);
	~TPrevisu();
	void MiseAJour();

	protected:
	void SetupWindow( void );
	void Reduit( void );
	void EvLButtonDown( UINT, TPoint& );
	void EvRButtonDown( UINT, TPoint& );
	void EvLButtonUp( UINT, TPoint& );
	void EvRButtonUp( UINT, TPoint& );
	void EvMouseMove( UINT, TPoint& );
	void EvSouris( UINT, TPoint& );

	virtual void Paint(TDC& ,BOOL , TRect& );

	unsigned char ecran[32768l];
	PBITMAPINFO pbmi;
	HANDLE hloc;
	int ImagePointee;
	TRect cad_imag[8];
	int EtatBG;
	int EtatBD;
	int DragBD;
	int DragBG;
	int ClickUpBG;
	int ClickUpBD;
 
	DECLARE_RESPONSE_TABLE(TPrevisu);
};

extern TPrevisu *TPrevisuPtr;

//----------------------------------------------------------------------------
#endif  //WMAICONV_H
