/**********************************************************************/
/*                       W M A I N . H		                            */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 20/12/1997                                     */
/**********************************************************************/
#if !defined(WMAIN_H)
#define WMAIN_H

#include <owl\inputdia.h>
#include <owl\scroller.h>
#include <owl\color.h>
#include <owl\gauge.h>
#include <owl\radiobut.h>
#include <owl\scrollba.h>
#include <owl\window.h>

#include "wsysutil.h"

#define OFFSET 69 // Pour dcalage fentres par rapport  fentre principale

#define ID_SEUIL 		 300
#define ID_STATIC 	 301
#define ID_BOUTON 	 302
#define ID_A			 303
#define ID_EXEC		 350

#define IM_GAUCHE 0
#define IM_DROITE 1

#define ASS_DROITE      1
#define ASS_DROITE_HAUT 2
#define ASS_DROITE_BAS  3
#define ASS_GAUCHE_BAS  4
#define ASS_BAS         5
#define CM_ASS_SauvegOptionsAuto       300
#define CM_ASS_SauvegOptionsMaintenant 301

#define LARGEUR_AFFIM 264
#define HAUTEUR_SYSTEME 91
#define HAUTEUR_AFFIM 282

#define GEO_RETICULE 1
#define GEO_LIGNE 2
#define GEO_COLONNE 3
#define GEO_FENETRE 4
#define GEO_DROITE 5

#define RESTI 0
#define SAUVE 1
#define ECRI 2

#define SOURIS_STATE_BD 0x01
#define SOURIS_STATE_BG 0x02
#define SOURIS_DRAG_BD 0x04
#define SOURIS_DRAG_BG 0x08
#define SOURIS_UP_BD 0x10
#define SOURIS_UP_BG 0x20

//typedef void(*typeFonction0)(void);// fonction recevant et renvoyant rien
typedef void(*typeFonction1)(TPoint&,int );// fonction recevant param

extern void Ajoute_Fonction(typeFonction1 p,int modefigint,TResId IdCurseur,TWindow* pt);
extern void Enleve_Fonction(TWindow* pt);
extern void Ev_ClicNouveauPoint(TPoint &,int);
extern TWindow* Indique_Fonction(void);
extern void fSetTracking(int f);
extern void fSetShifting(int f);

extern TWindow* TSeuilPtr;      			// Fentre seuil

extern int modeutil;                  // Fentre util

extern int EtatBGSouris;               // Fentres images
extern int EtatBDSouris;
extern int DragBDSouris;
extern int DragBGSouris;
extern int xfen0,yfen0;
extern int xfen1,yfen1;
extern int taillex,tailley;

extern TRect rFig;
extern BOOL fConsistanceUtil;

extern int posx,posy;
extern unsigned char far* ptr[2];
extern int modefig;

extern int pseudo;                             // Pseudo
extern int seuinf,seusup;

extern int iLargeurEcran;
extern int iHauteurEcran;
extern unsigned char uHauteurLigne;
extern unsigned char uLargeurCar;
extern unsigned char uHauteurBordure;
extern unsigned char uLargeurBordure;
extern unsigned char uHauteurBordureFine;
extern unsigned char uLargeurBordureFine;
extern unsigned char uHauteurMenu;
extern int iHauteurTitre;
extern TResId IdCurseur;
void NouveauCurseur(int NouvelId);
void CalculeCaracteristiquesPolice(TWindow *pwParent);

extern int fSauvegardeAutoDef;

//----------------------------------------------------------------------------
//						Programme AppelTChoixDial
//----------------------------------------------------------------------------

BOOL AppelChoixDial(TWindow *Parent,char titre[],char tabchoix[], char *pcRes, TRect fen=TRect(0,0,0,0));

//----------------------------------------------------------------------------
//						Programme TChoixDial
//----------------------------------------------------------------------------

class TChoixDial : public TDialog
{
 public :
  virtual void EvCommun(char );
  virtual void CloseWindow(int);
  virtual void SetupWindow();

  TChoixDial(TWindow *Parent,char titre[],char tabchoix[],TRect fen=TRect(0,0,0,0));
  void EvA();
  void EvB();
  void EvC();
  void EvD();
  void EvE();
  void EvF();
  void EvG();
  void EvH();
  void EvI();
  void EvJ();
  void EvBouton();
  protected :
  TRect Format;
  char tabret[10];

  DECLARE_RESPONSE_TABLE(TChoixDial);
};

//----------------------------------------------------------------------------
//						Programme TAssociatif
//----------------------------------------------------------------------------

class TAssociatif : public TFramePrint
  {
  public:
	 TAssociatif(TWindow* parent, char szTitre[], char cType=0);
	 BOOL fOptionsPresentes;
			BOOL fSauvegardeAuto;
  protected:
			~TAssociatif();
         virtual void SetupWindow();
	 virtual void EvSysCommand(UINT,TPoint&);
			virtual void EvInitMenuPopup(HMENU hPopupMenu, UINT index,BOOL sysMenu);
	 virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
	 virtual void EvRButtonDown(UINT, TPoint&);
	 virtual void EvMouseMove(UINT a, TPoint& point);
	 virtual void EvLButtonUp(UINT, TPoint& );
	 virtual void EvLButtonDown(UINT, TPoint& );
			void CmConfig(WPARAM id);
         virtual void ReleveOptions(void);
         virtual void SauvegardeOptions(void);
			virtual void ChargeOptions(void);
         TMenu *pmnuConfig;
	 TSize sEspaceUtile;
	 DECLARE_RESPONSE_TABLE(TAssociatif);
 };

//----------------------------------------------------------------------------
//						Programme TUtilitaire
//----------------------------------------------------------------------------

class TUtilitaire : public TAssociatif
{
  DECLARE_RESPONSE_TABLE(TUtilitaire);
  public:
	 TUtilitaire(TWindow* parent, char szTitre[], char cType=0);
	 ~TUtilitaire();
	 virtual void NouveauPoint();
	 virtual void PointImage(TPoint&,int);
};

extern TUtilitaire* TUtilPtr;            	// Fentre utilitaire

//----------------------------------------------------------------------------
//						Programme TChoix
//----------------------------------------------------------------------------

 class TChoix : public TFrameWindow {
  public:
	 TChoix(TWindow* parent,char titre[],char tabchoix[],TRect rFen);
	~TChoix();

	 virtual void EvCommun(char c);
	int nbchoix;
	TButton *tab_bt[11];
  protected:
	 void EvClose();
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvH(WPARAM id);
	 void EvI(WPARAM id);
	 void EvJ(WPARAM id);
	 void EvK(WPARAM id);
	 void EvExec(WPARAM id);

  protected :
  char tabret[10];
  char commande;
  DECLARE_RESPONSE_TABLE(TChoix);
};

//----------------------------------------------------------------------------
//						Programme TChoixMenu
//----------------------------------------------------------------------------

class TChoixMenu : public TChoix {
  public:

	 TChoixMenu(TWindow* parent, char titre[],char tabchoix[]);
	 ~TChoixMenu();
	 virtual void EvCommun(char );
	 };

//----------------------------------------------------------------------------
//						Programme TSeuil
//----------------------------------------------------------------------------

class TSeuil : public TFrameWindow {
  public:

	TSeuil(TWindow* parent,char titre[],int smin,int smax,int sinit);
	 virtual ~TSeuil();
	 virtual void EvCommun(int);
  protected:
	 void SetupWindow();
	 virtual void EvMButtonDown(UINT, TPoint &);
	 void EvClose();
	 void EvBouton(UINT);
	 void EvSeuil(UINT);
	 void AfficheSeuil(int);
	 void EvExec(UINT);
	 int seuil;
	 int seuilmin,seuilmax;
	 TScrollBar* Seuil;
	 TEdit *Eseuil;

  DECLARE_RESPONSE_TABLE(TSeuil);
};

//----------------------------------------------------------------------------
//						Programme TAffim
//----------------------------------------------------------------------------

class TAffim : public TFrameWindow {
  public:

	 TAffim(TWindow* parent,int type,char far titre[]);
	~TAffim();
	 void Traitfig(int modetrait,int modefig,TColor buffen[1024],int x0,int y0,
							int x1,int y1);
	 TColor buffen[1024];
	void Affiche(void);
 protected:
	 void EvGetMinMaxInfo(MINMAXINFO far& MinMaxInfo);
	 BOOL CanClose();
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvLButtonDown(UINT, TPoint&);
	 void EvMouseMove(UINT, TPoint&);
	 void EvLButtonUp(UINT, TPoint&);
	 void EvRButtonDown(UINT, TPoint&);
	 void EvRButtonUp(UINT, TPoint&);
	 void SetupWindow();
	 void EvSouris(UINT, TPoint& );
	 void Ecp(int x,int y,TColor color,TClientDC*);
	 TColor Lecp(int x,int y,TClientDC*);
	 TColor Cal_Color(TColor color);

	 int indic_first;
	 int xbd,ybd,xmem1,ymem1;
  private:
  int Type;
  DECLARE_RESPONSE_TABLE(TAffim);
};

extern TAffim* TAffimPtr[]; 				// Fentres images

//----------------------------------------------------------------------------
#endif  //WMAIN_H
