
/**********************************************************************/
/*                       W S Y S U T I L . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Divers utilitaires pour systme                */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC et BM                			      	       */
/*    Dvelopp le   : 26/07/1996                                     */
/*    Dernire modif.: 26/07/1996                                     */
/**********************************************************************/

#ifndef WSYSUTIL_H
#define WSYSUTIL_H

#include <dir.h>

#include <owl\combobox.h>
#include <owl\edit.h>
#include <owl\framewin.h>
#include <owl\printer.h>
#include <owl\window.h>

//#include "strtool.h"


/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define CM_NextFocus   298
#define CM_PredFocus   299

/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern int iLargeurEcran;
extern int iHauteurEcran;
extern unsigned char uHauteurLigne;
extern unsigned char uLargeurCar;
extern unsigned char uHauteurBordure;
extern unsigned char uLargeurBordure;
extern unsigned char uHauteurBordureFine;
extern unsigned char uLargeurBordureFine;
extern unsigned char uHauteurMenu;
extern int iHauteurTitre;
extern unsigned char uHauteurEdit;
extern unsigned char uDLE; // DcalageLigneEdition, pour centrer verticalement une ligne de TStatic et une ligne de TEdit.

extern TControl *pFocusedControl;  // Pointeur sur le TControl (de type TEditCR) qui a le focus

extern char far szINIFileName[MAXPATH];

void CalculeCaracteristiquesPolice(TWindow *pwParent);

//----------------------------------------------------------------------------
//						Programme TEditNumRC
//----------------------------------------------------------------------------
// Obsolete Utiliser  la place: TEditCR et TEditNumCR.
class TEditNumRC : public TEdit
{
  virtual void EvKeyUp(UINT key, UINT repeatCount, UINT flags);
  virtual void EvChar(UINT key, UINT repeatCount, UINT flags);
  virtual UINT EvGetDlgCode(MSG far *);

 public :
  TEditNumRC(int iMessage, TWindow *Parent, int Id, char far *Texte, int X, int Y,
			  int W, int H, UINT Taille=0, BOOL Multi=FALSE);

 protected :
  int code;
  TWindow *pt;

  DECLARE_RESPONSE_TABLE(TEditNumRC);
};

//----------------------------------------------------------------------------
//						Programme TFramePrint
//----------------------------------------------------------------------------

class TFramePrint : public TFrameWindow {
  TPrinter* Printer;
  public:

	 TFramePrint(TWindow* parent, const char* title, TModule* = 0);
	 ~TFramePrint();
	 void EvSysCommand(UINT,TPoint&);
	 void SetupWindow();
	 void CmFilePrint();
	 void CmFilePrinterSetup();

  DECLARE_RESPONSE_TABLE(TFramePrint);
};

//----------------------------------------------------------------------------
//						Programme TWindowPrintout
//----------------------------------------------------------------------------

class TWindowPrintout : public TPrintout {
  public:
	 TWindowPrintout(const char* title, TWindow* window);

	 void GetDialogInfo(int& minPage, int& maxPage,
							  int& selFromPage, int& selToPage);
	 void PrintPage(int page, TRect& rect, unsigned flags);
	 void SetBanding(BOOL b) {Banding = b;}
	 BOOL HasPage(int pageNumber) {return pageNumber == 1;}

  protected:
	 TWindow* Window;
	 BOOL     Scale;
};

/*-------------------------------------------------------------*/
/*                     Classes  exporter                      */
/*--TEditCR----------------------------------------------------*/
// CR=Carriage return
class TEditCR : public TEdit
  {
  public :
// Consructeur:
    TEditCR(TWindow *Parent, int Id, char far *Texte, int X, int Y,
	  int W, int H, UINT Taille=0, BOOL Multi=FALSE);
// Consructeur  partir de TRect:
    TEditCR(TWindow *Parent, int Id, char far *Texte,
            TRect rPosition, UINT Taille=0, BOOL Multi=FALSE);
    BOOL fInhibRC; // Inhibe la raction  la touche CR.
    BOOL fInhibTab; // Inhibe la changement de focus  la touche TAB.
  protected :
    int code; // Valeur de l'vnement  envoyer au parent
    TWindow *pt; // Pointeur vers le parent.
    virtual void EvKeyUp(UINT key, UINT repeatCount, UINT flags);
    virtual void EvChar(UINT key, UINT repeatCount, UINT flags);
    virtual UINT EvGetDlgCode(MSG far *);
    DECLARE_RESPONSE_TABLE(TEditCR);
};
/*--TEditNum---------------------------------------------------*/
// classe pour zone numrique

class TEditNumCR : public TEditCR
  {
  virtual void EvChar(UINT key, UINT repeatCount, UINT flags);
  public :
    TEditNumCR(TWindow *Parent, int Id, float xValue, int X, int Y,
           int W, int H, UINT Taille=0, BOOL Multi=FALSE);
    TEditNumCR(TWindow *Parent, int Id, float xValue, TRect r, UINT Taille=0, BOOL Multi=FALSE);
    void SetValue(float xyValue=0.0);
// Mets une valeur dans la bote d'dition. Si xyValue=MINFLOAT, alors le contenu est effac (TEdit::Clear())
    void SetClearValue(float xyValue=0.0);
// Metsune valeur dans la bote d'dition. Si xyValue=0.0, alors le contenu est effac (TEdit::Clear())
// GetValue lit la valeur dans la bote d'dition et la met dans la donne pointe. Renvoie 0 en cas d'chec, non nul en cas de succes.
    BOOL GetValue(unsigned char *puValue);
    BOOL GetValue(char *pcValue);
    BOOL GetValue(unsigned int *pwValue);
    BOOL GetValue(int *piValue);
    BOOL GetValue(float *pxyValue);


    DECLARE_RESPONSE_TABLE(TEditNumCR);
};
// ComboBox avec articles accessibles par tiquettes ("Item").
class TComboBoxItems : public TComboBox
  {
  public :
    TComboBoxItems(TWindow* parent, int id, int x, int y,
      int w, int h, uint32 style, uint textLen, TModule* module = 0);
    TComboBoxItems(TWindow* parent, int id, TRect rPosition,
      uint32 style, uint textLen, TModule* module = 0);
// GetSelItem renvoit l'ID de l'lment slectionn.
    virtual DWORD GetSelItem (void);
// AddItem isre une chane en spcifiant son ID.
    virtual int AddItem(DWORD dItemValue, const char * string);
// SetSelItem force la slection de l'lment d'ID spcifi.
    virtual int SetSelItem(DWORD dItemValue);
  };

/*--TLabeledEditNum---------------------------------------------*/
//
/*
TLabeledEdit(Num) is container of one TEdit(Num)CR and one TStatic.
  This container is supposed to make programmer's life easiest providing him default settings
for labeld one-lined TEdit control windows.
  The constructor needs:
     parent window, label (for TStatic), value (numeric or string for TEdit),
     position of the container, width of the label and the TEdit.
  The constructors computes the height of both TStatic and TEdit for one-line height.

  Programmer can access the member function "Show" that works the same as TWindow::Show.

*/
class TLabeledEdit
  {
  public :
    TEditCR e;
    TStatic st;
    TLabeledEdit(TWindow *pwParent, char *szEtiquette, int Id, char *szText,
           /* position: */int X, int Y,
           /* widths: */int iWst, int iWe, UINT Taille=0, uint textLen=0, BOOL Multi=FALSE,
           TModule* module=0):
           e(pwParent,Id,szText,X+iWst,Y,iWe,uHauteurEdit,Taille,Multi),
           st(pwParent,0,szEtiquette,X,Y+uDLE,iWst,uHauteurLigne, textLen, module){}
    void Show(int cmd){e.Show(cmd);st.Show(cmd);}
  };

class TLabeledEditNum
  {
  public :
    TEditNumCR e;
    TStatic st;
    TLabeledEditNum(TWindow *Parent, char *szEtiquette, int Id, float xValue, int X, int Y,
           int iWst, int iWe, UINT Taille=0, uint textLen=0, BOOL Multi=FALSE,
           TModule* module=0);
    void SetWindowFont(HFONT font, bool redraw){e.SetWindowFont(font,redraw);st.SetWindowFont(font,redraw);}
  };

inline TLabeledEditNum::TLabeledEditNum(TWindow *pwParent, char *szEtiquette, int Id, float xValue, int X, int Y,
           int iWst, int iWe, UINT Taille, uint textLen, BOOL Multi,
           TModule* module):
  e (pwParent,Id,xValue,X+iWst,Y,iWe,uHauteurEdit,Taille,Multi),
  st (pwParent,0,szEtiquette,X,Y+uDLE,iWst,uHauteurLigne, textLen, module){}

#endif // WSYSUTIL_H
