/*
> To:            rickh@westernwares.com
> From:          Baptiste <marcel@mygale.org>
> Subject:       Re: CC-RIDER and BC4

> *** Syntax error near '_hInstance', line 106 of C:\BC45\INCLUDE\OSL\DEFS.H
> 

It seems that the file WTYPES.H is not being pulled in (it defines 
HINSTANCE).

Try adding a dummy module first in your analysis that has this in it:
*/

#include <windows.h>
#include <ole2.h>
# include <print.h>      // Win16 printing and some general DC APIs
# include <osl/geometry.h>      // Win16 printing and some general DC APIs



/*
Turn on verbose logging to see that WTYPES.H is being pulled in 
before OSL\DEFS.H.
Also, try turning off "Separate Scopes"

The other bool-related errors should go away if you specify "No bool 
support".

Let me know if this does not resolve the problem...

Rick Hollinbeck (rickh@westernwares.com)
http://www.westernwares.com

*/
//////////////////////////////////////////
/*
Comments: Authenticated sender is <rickh@mail.independence.net>
From: "Rick Hollinbeck" <rickh@westernwares.com>
Organization: Western Wares
To: Baptiste <marcel@mygale.org>
Date: Wed, 21 Jan 1998 21:58:53 -0700
Subject: Re: CC-RIDER and BC4
Reply-to: rickh@westernwares.com
Priority: normal

> 
>   Here is the error file that goes with the other files.
> 

I'm looking at all these errors...

Meanwhile, the problem with LISTIMP.H is that Borland does not 
forward declare this template, as it should.

Add this either to LISTIMP.H or your dummy module...

template <class T,class Alloc> class TMSListImp;

You may find other templates that need to be forward declared, as BC4 
did not parse templates per the new ISO standard for C++.

Also, it seems that TProcInstance is not getting defined earlier.
If you cannot find out why, try just adding a typedef in your dummy 
module.
*/
typedef int TProcInstance;
/*
Also, if you have 'Separate Scopes' checked, uncheck it.

I do not know why the DECLARE_MESSAGE_MAP error happens.
I'll try to determine this...

BTW, BC5 is closer to standard C++...

 
Rick Hollinbeck (rickh@westernwares.com)
http://www.westernwares.com


*/