/////////////////////////////////////////////////////////////////
//                    N I T R A T E   . C P P
/////////////////////////////////////////////////////////////////
//    Fonction       :
/////////////////////////////////////////////////////////////////
//    Auteur         :  Baptiste Marcel (marce@len7.enseeiht.fr)
//        Written in Toulouse, France
//        All rights copyrighted
//    Cr le        : fin septembre 1996
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Headers
/////////////////////////////////////////////////////////////////
#ifndef DNITRATE_H
#define DNITRATE_H

#include <stdlib.h>
#include <stdio.h>
/////////////////////////////////////////////////////////////////
//                   Constantes du programme
/////////////////////////////////////////////////////////////////
#define STRLEN_Mesure          23
#define STRLEN_SeriesShortName 13
#define STRLEN_StringNumber    16
#define STRLEN_VideonKey      256
#define STRLEN_Gender           4
#define STRLEN_Flag             5
#define STRLEN_VersionLanguage 16
#define STRLEN_HasBeenSeen     STRLEN_Flag+4+STRLEN_VersionLanguage+1

////////////////////////////////////////////////////////////////
//                   Small classes (declarations)
//                   Structures
/////////////////////////////////////////////////////////////////
#define CHRONO       '='
#define MESURO       '~'
#define ESTIMO       '?'
#define PREC_UNKNOWN '!'

#define qA 'A'
#define qB 'B'
#define qC 'C'
typedef char quality ;
typedef char lenght_precision;
#define VL_Unknown          0
#define VL_VONoST           1
#define VL_VF               2
#define VL_VOSTF            3
#define VL_VOtherLangageSTF 4
#define VL_SpecialSilent    5
#define VL_SpecialVersion   6

#define NUMER_Unknown  0
#define NUMER_Plain    1
#define NUMER_Season   2
#define NUMER_Date     3
#define NUMER_DateNumber 4
#define NUMER_String     5

typedef unsigned char version_language;
enum videon_gender {SERIES, DOCUMENT, EPISODE, VOID_RECORD, DEFECT_TAPE, UNKNOWN} ;
struct has_been_seen {int fHasBeen; quality cQ ; version_language uVL  ;};
extern has_been_seen hsbNull;

typedef char lenght_precision;

class TMesure
  {
  public :
    unsigned int wT; // time value (in seconds)
    lenght_precision cP; // precision
    inline TMesure(unsigned int w=0, lenght_precision c=ESTIMO)
      {wT=w;cP=c;}
  };
extern TMesure mesNul,mesMinimumSpace;

char *Mesure2String(TMesure mes, char *sz);

int String2MesureEF(char *sz, TMesure *pmes, int *pfTwisted=NULL);
inline TMesure String2Mesure(char *sz, int *pfTwisted=NULL)
  {
  TMesure mes;
  String2MesureEF(sz, &mes,pfTwisted);
  return mes;
  }
extern char cDefaultMesureType;

inline int operator ==(TMesure A,TMesure B)
  {
  return A.wT==B.wT && A.cP==B.cP;
  }
char LessPrecise(lenght_precision cA,lenght_precision cB);
inline TMesure operator +(TMesure A,TMesure B)
  {
  return TMesure(A.wT+B.wT,LessPrecise(A.cP,B.cP));
  }
inline TMesure operator -(TMesure A,TMesure B)
  {
  return TMesure(A.wT-B.wT,LessPrecise(A.cP,B.cP));
  }
inline int operator !=(TMesure A,TMesure B)
  {
  return A.wT!=B.wT || A.cP!=B.cP;
  }
inline int operator <(TMesure A,TMesure B)
  {
  return A.wT<B.wT;
  }
inline int operator >(TMesure A,TMesure B)
  {
  return A.wT>B.wT;
  }
inline int operator <=(TMesure A,TMesure B)
  {
  return A.wT<=B.wT;
  }
inline int operator >=(TMesure A,TMesure B)
  {
  return A.wT>=B.wT;
  }
inline TMesure operator *(unsigned int w,TMesure mes)
  {
  return TMesure(w*mes.wT,mes.cP);
  }

inline lenght_precision Char2LenghtPrecision(unsigned char c)
  {
//  char r; //=toupper(c);
  if (c != CHRONO && c != MESURO &&  c != ESTIMO)
    return PREC_UNKNOWN;
  else
    return c;
  }
TMesure GetPrivateMesure(char *szSection,char *szEntry,
    TMesure mesDefault, char *szFileName);
int WritePrivateMesure(char *szSection,char *szEntry,
    TMesure mes, char *szFileName);

int SplitEpisodeTitle(char *szMetaTitle, char *szShortSeries, char *szNumber,
    char **pacTitleAddress);

int SplitDocumentKey(char *sz, videon_gender *peGender,
    char *szTitle, unsigned int wLen, unsigned int *pwYear);
int SplitEpisodeTitle(char *szMetaTitle, char *szShortSeries, char *szNumber,
    char *szEpisodeTitle);
int ExtractValue(char *szValue, videon_gender *pe, char **pcNext=NULL);
char *Item2String(videon_gender eValue, char *szValue, unsigned int wLen=0);

char *HasBeenSeen2CodeString(has_been_seen hsb, char *sz);
char *Item2String(has_been_seen hsb, char *sz);
inline char *HasBeenSeen2String(has_been_seen hsb, char *sz)
  {
  return Item2String(hsb,sz);
  }
//int String2HasBeenSeenEF(char *sz, has_been_seen *phsb);
int ExtractValue(char *sz, has_been_seen *phbs, char **pcNext=NULL);
inline has_been_seen String2HasBeenSeen(char *sz)
  {
  has_been_seen hsb;
  ExtractValue(sz, &hsb);
  return hsb;
  }

int ExtractValue_VersionLanguage(char *sz, version_language *pu,
     char **pszNext=NULL);
/*
char *VersionLanguage2String(version_language u, char *sz);
int String2VersionLanguageEF(char *sz, version_language *pu);
*/
char *VersionLanguage2CodeString(version_language u, char *sz);
char *ItemVersionLanguage2String(version_language u, char *sz);
inline version_language String2VersionLanguage(char *sz)
  {
  version_language u;
  ExtractValue_VersionLanguage(sz,&u);
  return u;
  }

quality GetPrivateQuality(char *szSection,char *szEntry,
    quality cDefault, char *szFileName);
int WritePrivateQuality(char *szSection,char *szEntry,
    quality cValue, char *szFileName);

int String2QualityEF(char *sz, quality *pcQ);
inline quality String2Quality(char *sz)
  {
  quality q=qC;
  String2QualityEF(sz,&q);
  return q;
  }
inline char *Quality2String(quality cQ, char *sz)
  {
  if (sz)
    sprintf(sz,"q%c",cQ);
  return sz;
  }

inline SizeOfOutput(has_been_seen &)
  {
  return STRLEN_HasBeenSeen;
  }


#endif
