#error Obsolete, replaced by WIrsUtil, WIrsSymb, WIrsLign
/**********************************************************************/
/*                       W I R I S       . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions pour Iris               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste Marcel                                */
/*    Dvelopp le   : printemps 1996                                 */
/*    Dernire modif.:                                                */
/**********************************************************************/
#ifndef WIRSTOOL_H
#define WIRSTOOL_H

#include "wedtderv.h"
#include "wirspick.h"
#include "wsymbole.h"

#define UTIL_DETECTLIGNES    10
#define UTIL_LECTURESYMBOLE  11
#define DL_RecalageAbsent            0
#define DL_RecalageVoisinageSelectif 1
#define DL_RecalagePremierRecul      2

#define STRING_TitreClasseLectureSymbole "Lecture de symbole"

#define SOURIS_CLIC_BD 0x01
#define SOURIS_CLIC_BG 0x02
#define SOURIS_DRAG_BD 0x04
#define SOURIS_DRAG_BG 0x08

int DemandeFrequenceOuAnnulle(char *szTitre);
#pragma message "prototype Ev_ClicNouveauPoint provisoire"
void Ev_ClicNouveauPoint(TPoint &,int); // provisoire
//void Ev_ClicNouveauPoint(TPoint &,int);    // une fonction
void Ev_ClicNoDragNouveauPoint(TPoint &,int etatsouris);    // une fonction
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*/
/*--TDetectLignes--------------------------------------------------------*/
class TDetectLignes : public TAssociatif
  {
  public:
    char cTypeLaplacienCalcule;
    char cTypeLaplacien;
    int iNoLigneEnCours;
    int iPartition, iCoinsSeuil, iTypeRecalage;
    unsigned char uSeuilZC, uNoPlanImage, uNoPlanAmpl, uNoPlanDirExp,
        uNoPlanChain, uCoinsNoyau;
    unsigned int wSepVert, wSepVert2, wSepHor1, wSepHor2, wSepHor3;
    BOOL fConsistance;
    char szImageUtilisee[USUALMAXLENSTRING];
    TRadioButton far *pOptionLaplacienChar4;
    TRadioButton far *pOptionLaplacienFloat8;
    TEditParametre far *pestDetecteCoinsSeuil, *pestDetecteCoinsNoyau;
    TComboBoxItems far *pcmbRecalageQuad;
    TQuadrilatere ABCD;
    TDetectLignes(TWindow* parent);
    ~TDetectLignes();
    void CmTextureCall( WPARAM id );
    void CmMenu(WPARAM id);
    virtual void NouveauPoint();
    void SaveDatasToLectureSymbole();
    void OutsiderReleveOptions();
  protected:
    TEditNumCR far *pNbPart;
    TEditNumCR far *pParametreSeuilZC, *peSeuilEARaccPar, *peSeuilEARaccOrth;
//        *peSeuilEAUnification;
    TLigne Ligne;
    TRect rRechGlob, rConfig, rPteLgn, rRechSmb;
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void SetupWindow();
    virtual bool CanClose();
    virtual void ReleveOptions(void);
    virtual void AfficheOptions(void);
    virtual void SauvegardeOptions(void);
    virtual void ChargeOptions(void);
    BOOL SauvegardeTableLignes(ligne_AB *algnTable,unsigned char *puCible);
    BOOL ChargeTableLignes(unsigned char *puSource,ligne_AB *algnTable);
    void CmSuicideMenu(WPARAM id);
    DECLARE_RESPONSE_TABLE(TDetectLignes);
 };
/*--TAnalyseQuad---------------------------------------------------------*/
class TAnalyseQuad : public TPickupQuad
  {
  public :
    unsigned int wFreq, wNbCoupes, wSizeOfTables;
    unsigned char auTabFreq[SIZE_OF_PICTURES], auTabCrit[SIZE_OF_PICTURES];
    TRect rFigTabCrit,rFigTabFreq,rTracTabCrit,rTracTabFreq;
    TStatic *pstFreq;
    TButton *pbHistTraceTabCrit, *pbHistTraceTabFreq;
    TReperage repCrit,repFreq;
    TAnalyseQuad(TWindow* parent);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void NouveauQuad();
    virtual void EvMouseMove(UINT a, TPoint& point);
    void DessineFlecheDAnalQuad();
    void Cm_HistTracTabFreq();
    void Cm_HistTracTabCrit();
    DECLARE_RESPONSE_TABLE(TAnalyseQuad);
  };
/*--TCadIris-------------------------------------------------------------*/
class TLectureSymbole : public TPickupQuad
  {
  public:
    TDataMatrix Symbole;
    TLectureSymbole(TWindow* parent);
    ~TLectureSymbole();
    void CmMenu(WPARAM id);
    virtual void NouveauPoint();
    virtual void NouveauQuad();
    void NouvelleMatrice();
    void CmUserIntervention(WPARAM id);
    void InvalidateMatrice();
    void Ev_ModifTexteSymbole();
    void Ev_ModifNumeriqueSymbole();
  protected :
    unsigned int wSepVert, wSepHor0, wSepHor1, wSepHor2;
    BOOL fConsistance;
    char szImageUtilisee[USUALMAXLENSTRING];
    TRect rEspaceTxt, rTxt,rEspaceNum,rNum, rEspaceDivComment,rDivComment,
          rValFreq,rValNbOct,rEspaceSymbole,rSymbole,rButtModifTxt,
          rButtModifNum;
    TReperage repSymbole;
    TEdit *peTxtSmb;
    TEditNumCR *peNumSmb, *peFreq, *peNbOct;
    TButton *pbModifTxt,*pbModifNum;
    virtual void SetupWindow();
    virtual void GenereMenuFlottant(TPopupMenu *pmnuFlot);
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void EvMouseMove(UINT a, TPoint& point);
    virtual void EvLButtonDblClk(uint modKeys, TPoint& point);
    DECLARE_RESPONSE_TABLE(TLectureSymbole);
 };

//--------------------------------------------------------------------------
//                     Nouvelles classes
//--TDetecteCoin-----------------------------------------------------------
class TDetecteCoin : public TPickupPoint
  {
  public :
    TDetecteCoin();
    ~TDetecteCoin();
    virtual void NouveauPolygone();
    TEditParametre *psteNoyau, *psteSeuilSat;
  };
//--TAnalyseLigne-----------------------------------------------------------
class TAnalyseLigne : public TPickupLine
  {
  public:
    unsigned int wHSep1, wHSep2, wVSep1;//, wVSep2, wVSep3;
    unsigned int wLongueurLigne;
    float xValeurSeuilAnalyseFreq;
    TStatic *pstLL, *pstFL, *pstPL, *pstET, *pstPm, *pstPM, *pstRac, *pstSRac,
        *pstCritere, *pstEqu3Dr, *pstEqu2Dr, *pstOriDr;
    TRect rTraceLigne;
    TReperage repIntensiteLigne;
    unsigned char auLigne[SIZE_OF_PICTURES*2];
    TAnalyseLigne(TWindow *parent);
    virtual void NouvelleLigne();
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
    virtual void TAnalyseLigne::EvMouseMove(UINT a, TPoint& point);
  };
//--TAnalyseFreqQuad-----------------------------------------------------
class TAnalyseFreqQuad : public TPickupQuad
  {
  public:
    TAnalyseFreqQuad::TAnalyseFreqQuad(TWindow *parent);
    virtual void NouveauQuad();
    virtual void Paint(TDC& dc, BOOL erase, TRect& rect);
  };

/*-----------------------------------------------------------------------*/
/*                     Variables  exporter                              */
/*-----------------------------------------------------------------------*/
extern TDetectLignes far *pDetectLignes;
extern TLectureSymbole far *pLectureSymbole;
extern TMenu *pmnuCortex, *pmnuSebUtil;


/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*/
BOOL SelectHardCopyFile();
void LoadIsolatedMenus();
//BOOL fHardCopy=OFF;
#endif // IRSOUTIL_H
