/*******************|*******************************************/
/*                  W M A T H D I V . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions mathmatiques.                */
/*                                                             */
/*                                                             */
/* Fichier prototype WSCALTOOL.H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : t     1994/1995                       */
/***************************************************************/
#if !defined(SCALTOOL_H)
#define SCALTOOL_H


#include "sysctr.h"
/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    Nouvelles classes  exporter               */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    Nouvelles classes  exporter               */
/*-------------------------------------------------------------*/
/*	                   fonctions pour changements de reperes
  Nous avons 2 repres dans le plan: Ra et Rb.
  On initialise les paramtres de TReperage en faisant
SetRa(complex zOrigine, complex zVecX, complex zVecY) en lui passant les
coordonnes de repre Ra (origine, vecteur unit Ex et Ey) dans le repre Rb.
  Les fonctions Ra2Rb donnent les coordonne d'un point dans l'autre repre.
  GetRa et GetRb donnent les coordonnes de repre Ra (exprimm par rapport
 Rb) et Rb (par rapport  Ra).

*/
class TReperage
  {
  public :
    complex zOa, zXa, zYa, zOb, zXb, zYb;
    TReperage(complex zAOrigine, complex zAVecX, complex zAVecY,
              complex zBOrigine, complex zBVecX, complex zBVecY)
      {zOa=zAOrigine ; zXa=zAVecX ; zYa=zAVecY ; zOb=zBOrigine ; zXb=zBVecX ; zYb= zBVecY;}
    void SetRa(complex zOrigine, complex zVecX, complex zVecY);
    void SetRa()
      {complex O(0.0,0.0),x(1.0,0.0),y(0.0,1.0);SetRa(O,x,y);}
    TReperage(complex zOrigine, complex zVecX, complex zVecY)
      {SetRa(zOrigine,zVecX,zVecY);}
    TReperage(){SetRa();}

    void SetRotat(double dAlpha)
      {SetRa(complex(0,0),complex(cos(dAlpha),sin(dAlpha)),
          complex(-sin(dAlpha),cos(dAlpha)));}
    void SetRaFromTGeom(complex zG, double dAlpha, complex zC);
    void GetRa(complex &zOrigine, complex &zVecX, complex &zVecY)
      {zOrigine=zOa;zVecX=zXa;zVecY=zYa;}
    void GetRb(complex &zOrigine, complex &zVecX, complex &zVecY)
      {zOrigine=zOb;zVecX=zXb;zVecY=zYb;}
    TReperage GetRb()
      {return TReperage(zOb,zXb,zYb,zOa,zXa,zYa);}
    complex Ra2Rb (complex za); // Change of coordinates fromRa to Rb
    complex Rb2Ra (complex zb);

    complex Transfo_b2a (complex z) {return Ra2Rb(z);}
      // Transformation that change Rb to Ra
    complex Transfo_a2b (complex z) {return Rb2Ra(z);}

    void SetSymetrieHoriz(double d);
    double TellTGeom(complex *zG, double *dAlphaX,double *dAlphaY, complex *zC);
#if _Windows
    complex Ra2Rb (TPoint pa);
    complex Transfo_b2a (TPoint z) {return Ra2Rb(z);}

    TPoint NRa2Rb (complex za);
    TPoint Transfo_Nb2a (complex z) {return NRa2Rb(z);}

    TPoint NRa2Rb (float xa, float ya);
    TPoint Transfo_Nb2a (float x, float y) {return NRa2Rb(x,y);}

    TPoint NRa2Rb (TPoint pa);
    TPoint Transfo_Nb2a (TPoint z) {return NRa2Rb(z);}

    complex Rb2Ra (TPoint pb);
    complex Transfo_a2b (TPoint z) {return Rb2Ra(z);}
    TPoint NRb2Ra (complex zb);
    TPoint Transfo_Na2b (complex z) {return NRb2Ra(z);}
    TPoint NRb2Ra (float xb, float yb);
    TPoint Transfo_Na2b (float x, float y) {return NRb2Ra(x,y);}
    TPoint NRb2Ra (TPoint pb);
    TPoint Transfo_Na2b (TPoint z) {return NRb2Ra(z);}
#endif
  };

/*	                   fonctions pour changements de reperes                   */
/*-------------------------------------------------------------*/
/*	                 prototypes de variables               */
/*-------------------------------------------------------------*/
extern float epsilon;
extern TReperage repSymetrieCentrale, repID;
//extern complex zOa, zXa, zYa, zOb, zXb, zYb;
/*-------------------------------------------------------------*/
/*	                 prototypes de fonctions               */
/*-------------------------------------------------------------*/
/*	                   fonctions de contrle               */
/*	                   fonctions scalaires                 */
unsigned int PlusProchePuissanceDe2(unsigned int i);
int EstUnePuissanceDe2(unsigned int u);
unsigned long long_random (unsigned long l);

double *TranfertMatrice(TReperage rep, double *pd);
TReperage TranfertMatrice(double *pd, TReperage rep);
TReperage operator * (TReperage repLeft, TReperage repRight);
//	              Inline functions

// This is defined if "< 0" and "> 0" are defined.
// This works as long as "> 0" returns "+1".

template <class T> inline int signe(T x)
  {
  return x<(T)0 ? -1 : x>(T)0;
  }
/*
inline char signe(int n)
  {
  return n<0 ? -1 : n>0;
  }
*/
// This is defined if "<" and ">" are defined.
// This works as long as ">" and "<" are *rather* coherent.
/*
template <class T> inline T _min (T first, T last)
  {
  return ( (first < last) ? first : last);
  }
#pragma message "possible misconception here: casting int->double may not be reversible: (int)(double)(int)i != (int)i"
template <class T1, class T2> inline double _max (T1 first, T2 last)
  {
  return ( (first > last) ? first : last);
  }
*/
/*
inline double max (double first, double second)
  {
  return _max(first,second);
  }
*/
#if _Windows
#else
inline float min (float first, float last)
  {
  return ( (first < last) ? first : last);
  }
inline float max (float first, float last)
  {
  return ( (first > last) ? first : last);
  }
#endif
/*template <class T> inline T min (T _1, T _2, T _3)
  {
  return min(min(_1,_2),_3);
  }*/
template <class T> inline T min (T _1, T _2, T _3, T _4)
  {
  return min(min(_1,_2,_3),_4);
  }
/*
template <class T> inline T max (T _1, T _2, T _3)
  {
  return max(max(_1,_2),_3);
  }
*/
template <class T> inline T max (T _1, T _2, T _3, T _4)
  {
  return max(max(_1,_2,_3),_4);
  }
/* NFloorR (floor (rel -> entier))
  Prend un flottant, l'arrondi par dfaut (vers l'entier infrieur) et le
renvoit en entier.
*/
inline int NFloorR (float x)
  {
#if SwitchManyCheckers
  if (x<-INT_MIN || x>=INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H",268);
#endif
  return floor(x);
  }

/* NCeilR (ceil (rel -> entier))
  Prend un flottant, l'arrondi par exces (vers l'entier suprieur) et le
renvoit en entier.
*/
inline int NCeilR (float x)
  {
#if SwitchManyCheckers
  if (x<INT_MIN || x>INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H.",279);
#endif
  return ceil(x);
  }

// abs
/* NFarRoundR (Round (rel-> entier))
  Prend un flottant, l'arrondi au plus proche (demi arrondi  l'unit la plus loin de 0)
et le renvoit en entier. Fonction configure pour les ngatifs avec arrondi de -0.5 donne -1.
*/
inline int NFarRoundR (float x)
  {
#if SwitchManyCheckers
  if (x<INT_MIN || x>INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H.",291);
#endif
  return x+ (x>0?0.5:-0.5);
  }
inline int NRoundR (float x)
  {
  return NFarRoundR (x);
  }
/* NUpRoundR (Round (rel-> entier))
  Prend un flottant, l'arrondi au plus proche (demi arrondi  l'unit sup.)
et le renvoit en entier. Fonction configure pour les ngatifs avec des
spcifications dont la fonction "PlusProcheImpair" dpend
(arrondi de -0.5 donne 0).
*/
inline int NUpRoundR (float x)
  {
#if SwitchManyCheckers
  if (x<INT_MIN || x>INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H.",291);
#endif
  {
  int iX=abs(x)+2;
  return NFarRoundR(x+iX)-iX;
  }
  }


/* RReduceR (R Reduce R)
  Renvoit le mme flottant si il est dans l'intervalle spcifi,
ramne sa valeur  la limite dpasse sinon.
  "first" doit tre infrieur  "last".
*/
inline float RReduceR (float x, float first, float last)
  {
  return max(first,min(last,x));
  }

inline int NReduceR (float x, int first, int last)
  {
  return NFarRoundR(max((float)first,min((float)last,x)));
  }

/* RReduceR (R Reduce R)
  Renvoit le mme flottant si il est dans l'intervalle spcifi,
ramne sa valeur  la limite dpasse sinon.
  "first" doit tre infrieur  "last".
*/
inline float NReduceN (int x, int first, int last)
  {
  return max(first,min(last,x));
  }
/* PlusProcheImpair (Plus proche impair)
  Renvoit l'entier impair le plus proche de la valeur donne (suprieur pour
les cas limite d'un argument entier pair. Par ex. : 2 -> 3, 0 -> 1 et
-2 -> -1).
  Attention : 255 renvoit 256 (ce qui est 0 si la variable cible est char.
*/
inline int PlusProcheImpair(float fr)
  {
  return  (NUpRoundR( (fr-1.0)/2.0)  * 2 + 1);
  }

inline unsigned char i2uc(int n)
  {
  if (n<0 || n>255)
    MErreur("Conversion hors champ from SCALTOOL.H.",343);
  return n;
  }

inline char i2c(int n)
  {
  if (n < -128 || n>127)
    MErreur("Conversion hors champ from SCALTOOL.H.",350);
  return (char)n;
  }

inline int l2i(long l)
  {
  if (l < INT_MIN || l > INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H.",156);
  return (int)l;
  }
inline int ul2i(unsigned long l)
  {
  if (l > INT_MAX)
    MErreur("Conversion hors champ from SCALTOOL.H.",156);
  return (int)l;
  }
inline unsigned int l2ui(long l)
  {
  if (l > UINT_MAX)
    MErreur("Conversion l-> ui hors champ from SCALTOOL.H.",168);
  return (unsigned int)l;
  }
template<class T> void ShiftTable(T *p, int wLen, int iShift)
  {
  ShiftTable(p, (unsigned int) wLen,iShift);
  }
/* Dcale les valeurs de la table  N lments.
  iShift positif = +s : dcale d's vers la droite les N-s lments de gauche
  iShift ngatif = -s : dcale d's vers la gauche les N-s lments de droite
*/
template<class T> void ShiftTable(T *p, unsigned int wLen, int iShift)
  {
  if (iShift>0)  // Shift to the right
    for(unsigned int w=wLen-iShift-1;w+1>0;w--) // w+1 >=0 => break when (int)w == -1
      p[w+iShift]=p[w];
  else // iShift ==0 or <0  Shift to the left // s=-iShift
    for(unsigned int w=0;w<wLen+iShift;w++)
      p[w]=p[w-iShift];
  }
template <class T> T *LocateSubTable(T *pTable, unsigned int wTLen,
    T *pSubTable, unsigned int wSubTLen)
  {
  long lIndex=0;
  for (lIndex=0;lIndex<wTLen;lIndex++)
    {
    long lEqualisor;
    for  (lEqualisor=0;
	lIndex+lEqualisor < wTLen
	&& lEqualisor < wSubTLen
	&& pTable[lIndex+lEqualisor]==pSubTable[lEqualisor];
	lEqualisor++);
    if (lEqualisor == wSubTLen)
      return pTable+lIndex+lEqualisor;
    else if (lIndex+lEqualisor == wTLen)
      return NULL;
    }
  return NULL;
  }

template <class T> T *LocateElement(T *pTable, unsigned int wTLen,
    T Elem)
  {
  return LocateSubTable(pTable,wTLen,&Elem,(unsigned int)1);
  }

inline double Determinant2colonnes(complex zc1, complex zc2)
  {
  return real(zc1)*imag(zc2)-real(zc2)*imag(zc1);
  }

inline complex TReperage::Ra2Rb (complex za)
  {
  return zOa+real(za)*zXa+imag(za)*zYa;
  }
inline complex TReperage::Rb2Ra (complex zb)
  {
  return zOb+real(zb)*zXb+imag(zb)*zYb;
  }

#if _Windows
inline complex TReperage::Rb2Ra (TPoint pb)
  {
  return Rb2Ra(complex(pb.x,pb.y));
  }
inline complex TReperage::Ra2Rb (TPoint pa)
  {
  return Ra2Rb(complex(pa.x,pa.y));
  }
inline TPoint TReperage::NRa2Rb (complex za)
  {
  complex zb=Ra2Rb(za);
  return TPoint(NFarRoundR(real(zb)),NFarRoundR(imag(zb)));
  }
inline TPoint TReperage::NRb2Ra (complex zb)
  {
  complex za=Rb2Ra(zb);
  return TPoint(NFarRoundR(real(za)),NFarRoundR(imag(za)));
  }
inline TPoint TReperage::NRa2Rb (float xa, float ya)
  {
  complex zb=Ra2Rb(complex(xa,ya));
  return TPoint(NFarRoundR(real(zb)),NFarRoundR(imag(zb)));
  }
inline TPoint TReperage::NRb2Ra (float xb, float yb)
  {
  complex za=Rb2Ra(complex(xb,yb));
  return TPoint(NFarRoundR(real(za)),NFarRoundR(imag(za)));
  }
inline TPoint TReperage::NRa2Rb (TPoint pa)
  {
  complex zb=Ra2Rb(complex(pa.x,pa.y));
  return TPoint(NFarRoundR(real(zb)),NFarRoundR(imag(zb)));
  }
inline TPoint TReperage::NRb2Ra (TPoint pb)
  {
  complex za=Rb2Ra(complex(pb.x,pb.y));
  return TPoint(NFarRoundR(real(za)),NFarRoundR(imag(za)));
  }
#endif // TPoint

template <class T, class wT> int MultMatrice(
    T *pLeft, wT wNbLgnLeft, wT wNbColLeft,
    T *pRight, wT wNbLgnRight, wT wNbColRight,
    T *pMult, wT wNbLgnMult=0, wT wNbColMult=0)
  {
  if (!pLeft || !pRight || !pMult)
    return ECHEC;

  if ( wNbColLeft != wNbLgnRight)
    return MErreur("Matrix sizes do not match for multiplication",564);
  else if (wNbLgnMult && wNbLgnMult!=wNbLgnLeft)
    return MErreur("Matrix sizes do not match for multiplication",567);
  else if (wNbColMult && wNbColMult!=wNbColRight)
    return MErreur("Matrix sizes do not match for multiplication",380);


/******************************************
     Return multiple of x and y in pMult
******************************************/
//   unsigned int n, nr, nc, i, j, k ;
   unsigned int i, j, k ;
//   T *r=pMult ;
/*   n  = wNbColLeft; //x.nCols() ;
   nr = wNbLgnLeft; //x.nRows() ;
   nc = wNbColRight; //y.nCols() ; */
//   T *x=pLeft, *y=pRight, *r=pMult;
//   reset( wNbLgnLeft, nc ) ;
   for ( i = 0 ; i < wNbLgnLeft ; i++ ) {
      for ( j = 0 ; j < wNbColRight ; j++ ) {
         pMult[i*wNbColRight+j] = (T)0 ;
         for ( k = 0 ; k < wNbColLeft ; k++ )
            pMult[(UINT)i*wNbColRight+j] += pLeft[(UINT)i*wNbColLeft+k] *
                pRight[(UINT)k*wNbColRight+j] ;
      } // for j
   } // for i
   return SUCCESS;
} // matrix multOf

template <class T, class Scalar, class wT> int MultMatriceScalaire(
    T *p, wT wNbLgn, wT wNbCol, Scalar x,
    T *pMult)
  {
  for (wT i=0;i<wNbLgn;i++)
    for (wT j=0;j<wNbCol;j++)
      pMult[i*wNbCol+j]=x * puSource[i*wNbCol+j]
  return SUCCES;
  }
#endif // SCALTOOL_H


