/*******************|*******************************************/
/*-------------------------------------------------------------*/
/*    Fonction       : Outils de travail sur caractres,       */
/*                     chanes de caractres et fichiers.      */
/*                                                             */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1994/1995                        */
/***************************************************************/
#ifndef STRUTIL_H
#define STRUTIL_H
/*
#include <dir.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>

#if !_Windows
#include <owl/point.h>
#include <classlib/time.h>
#include <classlib/date.h>
#else
#if !_Windows
#include "dpoint.h"
#endif
*/
#include "baptiall.h"

#if !_Windows
#include "dpoint.h"
#endif

#include "base.h"


/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
//#define STRLEN_ProfileBufferSize 1024

#define STRLEN_OperatingProfile  1024

#define STRLEN_Int               6
#define STRLEN_Point             14
#define STRLEN_Date              12


#define FLOAT_         1
#define DOUBLE_        2
#define INT_           3
#define UNSIGNED_INT_  4
#define CHAR_          5
#define UNSIGNED_CHAR_ 6
#define POINT_         7
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern int fXXthLectureCentury;
extern int fEnglishDateLectureFormat;
extern int cDefaultClockMinSec;
extern char szTimeFormat[32];

extern char *acUsualSeparators;
extern char acDefaultSeparators[];

extern char szWindowsDirectory[MAXDIR];
extern char szWindowsDrive[MAXDRIVE];
extern char cPointSeparator;
extern date dteError;

inline int operator == (date dteL, date dteR)
  {
  return dteL.da_day==dteR.da_day && dteL.da_mon==dteR.da_mon && dteL.da_year==dteR.da_year;
  }
inline int operator != (date dteL, date dteR)
  {
  return !(dteL == dteR);
  }
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
/*
  Scan the list of arguments (same type than argc, argv) and search for an
argument of type /sz+ or /sz- where sz is the string in char *szMarker.
  Return int fDef if no argument is fond; otherwise: returns FALSE for
  /sz- and not FALSE otherwise.
 Stop when the first matching argument is found.
 Remove the argument from the list (set to "") if found.
*/
unsigned int CatchCommandLineIntList(int iUserArguments, char **aszUserArguments,
    char *szMarker,
    int *aiDef,
    unsigned int wDefLen,
    int *aiValues,
    unsigned int wLen,
    int fKillRead=0);
char *CatchCommandLineString(int iUserArguments, char **aszUserArguments,
    char *szMarker,
    char *szDef,
    char *szVal,
    unsigned int wLen,
    int fKillRead=0);
int CatchCommandLineFlagSign(int iUserArguments, char **aszUserArguments,
   char *szMarker, int fDef, int fKillRead=0);

inline int CatchSignedArgumentOption(int iUserArguments, char **aszUserArguments, char *szMarker, int fDef);

inline int CatchSignedArgumentOption(int iUserArguments, char **aszUserArguments, char *szMarker, int fDef)
  {return CatchCommandLineFlagSign(iUserArguments,aszUserArguments,szMarker,fDef,TRUE);}

char *strchri(char *sz, unsigned char u); // Search character (cases insensitive)
void SetString(char **psz, char *szNewValue=NULL);

void GetPrivateString(char *szSection, char * szEntry, char *szDefaultValue,
    char *szValue, unsigned int wLen, char *szFileName);
int WritePrivateString(char *szSection, char *szEntry, char *szValue,
    char *szFilename);

inline void SetProfiledString(char **pszString, char *szSection,char *szEntry,
    char *szDefault, char *szFileName)
  {
  char szBuffer[1024];
  GetPrivateString(szSection,szEntry,szDefault,szBuffer,sizeof(szBuffer),szFileName);
  SetString(pszString,szBuffer); // Dynamic allocation.
  }

char *CompactEspace (char *ligne);
// AvaleEspace renvoit un pointeur sur le premier caractre non espace.
char *AvaleEspace (char *ligne);
// CompactEspace alloue et renvoit "ligne" sans les espaces du dbut".

/* ExtractValue met dans  "p?Value" le nombre crit au dbut de la chane
de carcatres "szLigne" (espaces autorises).
"pNext" pointe aprs le sparateur (si plusieurs nombres dans la chane).*/
/*
int ExtractValue(char *szLigne, int *piValue, char **pNext=NULL);
int ExtractValue(char *szLigne, float *px, char **ppcNext=NULL);
*/
int ExtractItem(char *szList,char *szFirstItem, unsigned int wLen, char **pszNext,
    char *acSeparators);
int ExtractValue(char *szDate, date *pdte, char **pcNext=NULL);

// Change each occurence of one string to an other
int ChangeString(char *szVictim,char *szOld, char *szNew, unsigned int wVictimLen=0);
int ChangeStringEqSiz(char *szVictim,char *szOld, char *szNew, unsigned int wVictimLen=0);
char *CutTrailingSpaces(char *sz);


int IsSeparator(char c);


int RemoveSeparators(char *sz, char *szCompacted);
char *NextSeparator(char *sz);
char *NextNotSpaceSeparator(char *sz);



// GetIntegerList lit une liste de nombres dans une chane de caractres.
unsigned int GetIntegerList(char *szIntList,int aIntList[], unsigned int wNbInt);
unsigned int SupprimeZerosTerminaux(int aIntList[], unsigned int wNbInt);

int IsIntelligentText(char *szTexte);
int IsIntelligentCharacter(unsigned char c);


float GetPrivateFloat(char *szSection, char * szEntry, float xDefault, char *szFileName);
int WritePrivateFloat(char *szSection, char *szEntry, float xValue,
			   char *szFilename);
int GetPrivateFlag(char *szSection, char * szEntry, int fDefault, char *szFileName);
int WritePrivateFlag(char *szSection, char * szEntry, int fValue, char *szFileName);

int GetPrivateInt(char *szSection, char *szEntry, int iDefaultValue,
			   char *szFilename);
int WritePrivateInt(char *szSection, char *szEntry, int iValue,
			   char *szFilename);
int WritePrivateIntList(char *szSection, char *szEntry, int *aiValues,
    unsigned int wCount, char *szFilename);
unsigned int GetPrivateIntList(char *szSection, char *szEntry,
    int *aiValues, unsigned int wCount, char *szFilename, unsigned int wStringBufferLen=0);

char GetPrivateLetter(char *szSection,char *szEntry, char cDefault,
    char *szFileName);
int WritePrivateLetter(char *szSection,char *szEntry, char c,
    char *szFileName);

date GetPrivateDate(char *szSection,char *szEntry, date dteDefault,
    char *szFileName);
int WritePrivateDate(char *szSection,char *szEntry, date dte,
    char *szFileName);

void Dos_GetPrivateString(char *szSection, char * szEntry, char *szDefaultValue,
    char *szValue, unsigned int wLen, char *szFileName);
int Dos_WritePrivateString(char *szSection,char *szEntry,
    char *szValue,char *szFileName);

int Dos_GetPrivateInt(char *szSection, char *szEntry, int iValue, char *szFile);
void SetIniSourceFile(char *szPhysicalTarget, unsigned int wLen, char *szUser);

int ExistSection(char *szSection, char *szFile);
//int IsAnySection(char *szLine, char *szSection, unsigned int wLen);
int IsAnySection(char *szLine, char *szSection=NULL, unsigned int wLen=0);
int RemovePrivateSection(char *szSection, char *szFile);
int RemovePrivateEntry(char *szSection,char *szEntry,char *szFileName);
int ScanWPFSayYes(char *, void *);
int ScanWPFSayYes(char *szSection, char *szEntry, char *szValue, void *pArgs);
int ExtractAllHeaders(char *szSource, char *sztarget); // Build the t	arget file with the headers of the source file.

int IsEntry(char *szLine, char *szEntry, char *szValue=NULL, unsigned int wLen=0);
 // Say if the line is the entry and gives its value.
int SayYesOnProfileScan(char * /* szSection */,
		     char * /* szEntry */,
		     char * /* pcValue */,
		     void * /* pArgs */);

int ScanWindowProfileFile(
    char *szSource,
    void *pArgs,
    int (*funcProcessTheSection)(char *szSection, void *pArgs),
    int  (*funcIsInterestingSection)(char *szSection, void *pArgs),
    int  (*funcProcessTheEntry)(char *szSection, char *szEntry,
	  char *szValue, void *pArgs),
    char *szTitreRuban=NULL
	  );

int ChangePrivateSectionName(char *szOldSection, char *szNewSection, char *szFile);
int IsSection(char *szLine, char *szSection=NULL); // Say if the line is the given section title.
int IsVoyel(char c);

//char *Date2String(date dte, char *sz);
//int String2DateEF(char *sz,date *sDate);
date String2Date(char *sz);

inline unsigned int SizeOfOutput(int)
  {
  return 6;
  }
inline unsigned int SizeOfOutput(char *sz)
  {
  return strlen(sz)+1;
  }
inline char *Item2String(char *szS, char *sz)
  {
  return strcpy(sz,szS);
  }
/*
inline int IsDigit(unsigned char c)
  {
  return !!isdigit(c); // !! is for the case when isdigit replies 256.
  }
inline int IsNumericInt(char c)
  {
  return (IsDigit(c)|| c=='+' || c=='-' );
  }
inline int IsNumericFloat(char c)
  {
  return (IsNumericInt(c)|| c=='.');
  }
*/
char *Flag2String(int f, char *sz);
int String2FlagEF(char *sz, int *pf);
inline int String2Flag(char *sz)
  {
  int f;
  String2FlagEF(sz, &f);
  return f;
  }
/*
inline int IsSeparator(char c)
  {
  return !!strchr(acUsualSeparators,c); // Returns TRUE for '/0'.
  }
*/
inline char *NextSeparator(char *sz)
  {
  if (!sz) return NULL;
  unsigned int wSep=strcspn(sz, acUsualSeparators);
  if (wSep >= strlen(sz))
    return NULL;
  else
    return sz+wSep;
  }


/* Substitute to strncat. Cat up to maxlen-strlen(dest)-1 characters,
and make sure the last one is 0.
// WIL BUG SEVERELY if the dest is allocated BELLOW maxlan
*/
inline char *strNcat(char *dest, char *src, unsigned int maxlen)
  {
  unsigned int w=strlen(dest);
  if (w+1>=maxlen) return dest;
  else
    return strncat(dest,src,maxlen-1-w);
  }
//char *Item2String(int i, char *sz);

char *Time2String(struct time t, char *sz);
int String2TimeEF(char *sz, struct time *p);
struct time String2stTimeEF(char *sz);

inline char *Item2String(int i, char *sz)
  {
  return itoa(i,sz,10);
  }
inline int TypeKind(float *)
  {
  return FLOAT_;
  }
inline int TypeKind(int *)
  {
  return INT_;
  }
inline int TypeKind(unsigned int *)
  {
  return UNSIGNED_INT_;
  }
inline int TypeKind(double *)
  {
  return DOUBLE_;
  }
inline int TypeKind(char *)
  {
  return CHAR_;
  }
inline int TypeKind(unsigned char *)
  {
  return UNSIGNED_CHAR_;
  }
#if 0 //_Windows
inline int TypeKind(TPoint *)
  {
  return POINT_;
  }
#endif


/*
int IsFloatish(float *);
int IsFloatish(double *);
int IsFloatish(char *);
int IsFloatish(unsigned char *);
int IsFloatish(int *);
int IsFloatish(unsigned int *);
*/

template <class T> int ExtractValue_obs(char *szLigne, T *pValue, char **pNext=NULL)
  {
  switch (TypeKind(pValue))
  {
  case FLOAT_:
  case DOUBLE_:
    float xValue;
    if (pValue && ExtractFloatValue(szLigne,&xValue,pNext))
      {
      *pValue=(T)xValue;
      return SUCCES;
      }
    else
      return ECHEC;
  case INT_:
  case UNSIGNED_INT_:
  case CHAR_:
  case UNSIGNED_CHAR_:
    int iValue;
    if (pValue && ExtractIntValue(szLigne,&iValue,pNext))
      {
      *pValue=(T)iValue;
      return SUCCES;
      }
    else
      return FAILURE;
#if _Windows
  case POINT_:
    TPoint ptValue;
    if (pValue && ExtractPointValue(szLigne,&ptValue,pNext))
      {
      *pValue=(T)ptValue;
      return SUCCES;
      }
    else
      return FAILURE;
#endif
  default :
    return ECHEC;
  }
  }
template <class T> int ExtractValue_old(char *szLigne, T *pValue, char **pNext=NULL)
  {
  switch (TypeKind(pValue))
  {
  case FLOAT_:
  case DOUBLE_:
    float xValue;
    if (pValue && ExtractFloatValue(szLigne,&xValue,pNext))
      {
      *pValue=(T)xValue;
      return SUCCES;
      }
    else
      return ECHEC;
  case INT_:
  case UNSIGNED_INT_:
  case CHAR_:
  case UNSIGNED_CHAR_:
    int iValue;
    if (pValue && ExtractIntValue(szLigne,&iValue,pNext))
      {
      *pValue=(T)iValue;
      return SUCCES;
      }
    else
      return FAILURE;
#if _Windows
  case POINT_:
    TPoint ptValue;
    if (pValue && ExtractPointValue(szLigne,&ptValue,pNext))
      {
      *pValue=(T)ptValue;
      return SUCCES;
      }
    else
      return FAILURE;
#endif
  default :
    return ECHEC;
  }
  }
/*
template <class T> int ExtractIntishValue(char *szLigne, T *pValue, char **pNext=NULL)
  {
  int iValue;
  if (pValue && ExtractValue(szLigne,&iValue,pNext))
    {
    *pValue=(T)iValue;
    return SUCCES;
    }
  else
    return FAILURE;
  }
template <class T> int ExtractFloatishValue(char *szLigne, T *pValue, char **pNext=NULL)
  {
  float xValue;
  if (pValue && ExtractValue(szLigne,&xValue,pNext))
    {
    *pValue=(T)xValue;
    return SUCCES;
    }
  else
    return ECHEC;
  }
  */
/*
inline int ExtractValue(char *szLigne, unsigned int *pwValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,pwValue,pNext);
  }
inline int ExtractValue(char *szLigne, unsigned char *puValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,puValue,pNext);
  }
inline int ExtractValue(char *szLigne, char *pcValue, char **pNext=NULL)
  {
  return ExtractIntishValue(szLigne,pcValue,pNext);
  }
inline int ExtractValue(char *szLigne, double *pxValue, char **pNext=NULL)
  {
  return ExtractFloatishValue(szLigne,pxValue,pNext);
  }
*/
inline unsigned int SizeOfOutput(TPoint &)
  {
  return 14;
  }
inline char *Point2String(TPoint pt, char *sz)
  {
  sprintf(sz,"%d%c%d",pt.x,cPointSeparator,pt.y);
  return sz;
  }
inline char *Item2String(TPoint pt, char *sz)
  {
  return Point2String(pt,sz);
  }
inline int String2PointEF(char *sz, TPoint *p)
  {
  return (GetIntegerList(sz,(int *)p, 2)==2);
  }
inline TPoint String2Point(char *sz)
  {
  TPoint p;
  GetIntegerList(sz,(int *)(&p), 2);
  return p;
  }
#if _Windows

extern TDate dteNulle;
int ExtractValue(char *szDate, TDate *pdte, char **pcNext=NULL);
inline unsigned int SizeOfOutput(TDate)
  {
  return STRLEN_Date;
  }

char *Time2String(TTime t, char *sz);
int String2TimeEF(char *sz, TTime *p);
TTime String2Time(char *sz);

//char *Date2String(TDate dte, char *sz);
//int String2DateEF(char *sz, TDate *p);
//int ExtractValue(char *szLigne, TDate *p, char **pcNext);

char *Item2String(TDate dte, char *sz);
//int String2ItemEF(char *sz, TDate *p);

int Hook(char *szFile);
int UnHook(char *szFile);
int IsHooked(char *szFile);


/*
inline int String2ItemEF(char *sz, TDate *p)
  {
  return String2DateEF(sz,p);
  }
  */
extern int fDOSIniAccess;
#endif // _Windows
// Implement GetPrivate... as long as String2Item exist.
template <class T> T GetPrivateItem(char *szSection, char * szEntry,
    T tDefault, char *szFileName)
  {
  char szLigne[1024];
  T t;
  if (!szSection || !szEntry || !szFileName)
    return tDefault;
  else
    GetPrivateString(szSection, szEntry, "",szLigne,
                            sizeof(szLigne),szFileName);
  if (ExtractValue (szLigne, &t))
    return t;
  else
    return tDefault;
  }
template <class T> int WritePrivateItem(char *szSection,char *szEntry, T t,
    char *szFileName)
  {
  char *szBuffer=(char *)malloc(SizeOfOutput(t));
  int f=szBuffer && WritePrivateString(szSection,szEntry,
    Item2String(t,szBuffer),szFileName);
  return f;
  }

#endif // STRUTIL_H
