#ifndef MODULE_NAME
#error You must define MODULE_NAME as name of the module before including sysctr.h
#endif
/*******************|*******************************************/
/*                  W C O N T R O L E . H                      */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils de contrle d'excution          */
/*                     (erreurs, traage...)                   */
/*                                                             */
/* Fichier prototype WCONTROLE.H.                              */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : printemps 1996                          */
/***************************************************************/
#ifndef SYSCTR_H
#define SYSCTR_H

/*
#include <dir.h>
#include <stdio.h>
*/

#include "strutil.h"
#include "base.h"
/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define NOM_TRACEUR "traceur.txt"
//#define SizeOfszINIFileName 256
/////////////////////////////////////////////////////////////////
// Classes
/////////////////////////////////////////////////////////////////
class iException
  {
  public :
    int  iVal;
    iException(int i=0){iVal=i;}
  };
inline int operator == (iException l, iException r)
  {
  return l.iVal==r.iVal;
  }
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern int fTracage, fRuban;
extern char far szNomTraceur[MAXPATH];
extern char szHardCopyFile[MAXPATH];
extern unsigned int wMessPause, wMessIconExclamation, wMessSystemModal;
extern unsigned int wErrorIcons;
extern char szErrorDefaultHeader[];
extern char *szErrorHeader;
extern int fErrorBLF, fErrorALF;
extern int fHardCopy;
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
int CopyTextFile(char *szSource,char *szTarget);
void TmpCopyTextFile(char *szSource);
void TmpCopyIniFile(char *szFile);

void SetErrorIcons(unsigned int fuStyle);
void SetErrorHeader(char *sz);
void SetErrorLineFeeds(int fBefore, int fAfter);

int Erreur(char far *szMessage);
int _Trace(char *szMessage, unsigned int wRef);
int _Erreur(char *szMessage, unsigned int wRef);

inline int Trace(char far *szMessage){return _Trace(szMessage,0);}
void Trace (char far *szMessage, unsigned char far *auTable, unsigned int w, unsigned int wRef=0);

int ErreurCode(unsigned int wRef=0);
int ErreurAllocation(unsigned int wRef=0);
int ActiveTracage(char T); // Met en marche en fonction de T. Coupe le tracage si echec  l'ouverture du fichier.

char ActiveRuban(char szTitre[]);
char AvanceRuban(unsigned char uAv);
char FermeRuban();

template  <class T> int AutoStringMerge
    (char *szMessage, T Value, unsigned int wRef,
    int (*fAction)(char *, unsigned int) )
  {
  char *szVal=(char *)malloc(SizeOfOutput(Value));
  if (!szVal) return FAILURE;
  char *szMessVal=(char *)malloc(strlen(szMessage)+SizeOfOutput(Value));
  if (!szMessVal) return FAILURE;
  sprintf(szMessVal,"%s%s",szMessage,Item2String(Value,szVal));

  int f=fAction(szMessVal,wRef);

  free(szMessVal);
  free(szVal);
  return f;
  }
template  <class T> int Erreur(char *szMessage, T Value, unsigned int wRef)
  {
  return AutoStringMerge(szMessage,Value,wRef,_Erreur);
  }
template  <class T> int Trace(char *szMessage, T Value, unsigned int wRef)
  {
  return AutoStringMerge(szMessage,Value,wRef,_Trace);
  }
template  <class T> int Trace(char *szMessage, T Value, int iRef)
  {
  return Trace(szMessage,Value,(unsigned int)iRef);
  }
template  <class T> int Erreur(char *szMessage, T Value, int iRef)
  {
  return Erreur(szMessage,Value,(unsigned int)iRef);
  }
int ModuleStringMerge
    (char *szModule, char *szMessage, unsigned int wRef,
    int (*fAction)(char *, unsigned int) );

inline int MErreur(char *szMessage,unsigned int wRef=0)
  {
  return ModuleStringMerge(MODULE_NAME,szMessage,wRef,_Erreur);
  }


inline int MTrace(char *szMessage,unsigned int wRef=0)
  {
  return ModuleStringMerge(MODULE_NAME,szMessage,wRef,_Trace);
  }
#endif // WCONTROL_H
