/*******************|*******************************************/
/*                  W I N U T I L   . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils graphiques                       */
/*                                                             */
/* Fichier prototype WINUTIL .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : printemps 1996                          */
/***************************************************************/
#ifndef WLSTUTIL_H
#define WLSTUTIL_H

#include <classlib\listimp.h>
#include <owl\static.h>

#include "base.h"
/*/////////////////////////////////////////////////////////////*/
/*			   constantes                          */
/*/////////////////////////////////////////////////////////////*/
/*/////////////////////////////////////////////////////////////*/
/*	            prototypes de variables                    */
/*/////////////////////////////////////////////////////////////*/

/*/////////////////////////////////////////////////////////////*/
/*	            prototypes de fonctions                    */
/*/////////////////////////////////////////////////////////////*/
template <class T> BOOL String2ListEF (char *sz, TListImp<T> *pList);
template <class T> TListImp<T> *String2List (char *sz, TListImp<T> *pList);

template <class T> char *List2String(TListImp<T> *pList, char *sz);
template <class T> BOOL List2StringEF(TListImp<T> *pList, char *sz);


template <class T> unsigned long CountItems (TListImp<T> *pList);
template <class T> TListImp<T> *GetList (TStatic *pst,TListImp<T> *pl);
template <class T> BOOL LogicalSplitList(TListImp<T> *pA, TListImp<T> *pB,
    TListImp<T> *pAAndB, TListImp<T> *pANotB);
template <class T> BOOL LogicalSplitList(TListImp<T> *pA, TListImp<T> *pB,
    TListImp<T> *pAAndB, TListImp<T> *pANotB, TListImp<T> *pBNotA);

//  LogicalSplitList(list *A, list *B, list *(objects of A and B), list*(objects of A and not B));
template <class T> void WriteList(TStatic *pst,TListImp<T> *pl);

template <class T> TListImp<T> *GetPrivateLinedList(char *szSection,
    char *szEntry,TListImp<T> *pList, char *szFileName, unsigned int wLen=32); // wLen=32
template <class T> BOOL WritePrivateLinedList(char *szSection,
    char *szEntry, TListImp<T> *pList, char *szFileName);

template <class T> TListImp<T> *GetPrivateMultiLinedList(char *szSection,
    char *szEntry,TListImp<T> *pList, char *szFileName);
template <class T> BOOL WritePrivateMultiLinedList(char *szSection,
    char *szEntry, TListImp<T> *pList, char *szFileName);
/*/////////////////////////////////////////////////////////////*/
/*                     Classes  exporter                      */
template <class T> void IterCountItems(T &/*rec*/, void *pArg);
//template <class T> int IterRecordKeyEquals(const T &t, void *pArg);
template <class T> void IterLogicalSplitList(T &t, void *pArg);
template <class T> void IterWritePrivateList(T &t, void *pArg);
//template <class T> void IterWritePrivate(T &t, void *pArg);
template <class T> void IterList2String(T &t, void *pArg);
//////////////////////////////////////////////////////////////
//              Corps des fonctions  exporter
//////////////////////////////////////////////////////////////
template <class T> TListImp<T> *String2List (char *sz, TListImp<T> *pList)
  {
  String2ListEF(sz,pList);
  return pList;
  }
template <class T> char *List2String(TListImp<T> *pList, char *sz)
  {
  List2StringEF(pList, sz);
  return sz;
  }
template <class T> BOOL LogicalSplitList(TListImp<T> *pA, TListImp<T> *pB,
    TListImp<T> *pAAndB, TListImp<T> *pANotB, TListImp<T> *pBNotA)
  {
  TListImp<T> lInterm;
  BOOL fRes=LogicalSplitList(pA,pB,(&lInterm),pANotB);
  lInterm.Flush();
  return fRes & LogicalSplitList(pB,pA,pAAndB,pBNotA);
  }

template <class T> BOOL LogicalSplitList(TListImp<T> *pA, TListImp<T> *pB,
    TListImp<T> *pAAndB, TListImp<T> *pANotB)
  {
  void *pArg[3];
  pArg[0]=(void *)pB;
  pArg[1]=(void *)pAAndB;
  pArg[2]=(void *)pANotB;

  if (pA && pB && pAAndB && pANotB)
    {
    pA->ForEach(IterLogicalSplitList,pArg);
    return SUCCESS;
    }
  else
    return FAILURE;
  }//  LogicalSplitList(list *A, list *B, list *(objects of A and B), list*(objects of A and not B));

template <class T> TListImp<T> *GetPrivateMultiLinedList(char *szSection,char *szEntry,
    TListImp<T> *pList, char *szFileName)
  {
  char *szBuff=(char *)malloc(strlen(szEntry)+7);
  wsprintf(szBuff,"%s?X",szEntry);
  int iRecordCounter=GetPrivateInt(szSection,szBuff,0,
      szFileName); // Number of elements of the list.
  pList->Flush(); // Empties the list
  for (int i=0;i<iRecordCounter;i++)
    {
    wsprintf(szBuff,"%s#%d",szEntry,i);
    pList->Add(GetPrivate(szSection,szBuff,T(),szFileName)); // Set to zero. // T() is the default constructor.
    }
  free(szBuff);
  return pList;
  }
template <class T> TListImp<T> *GetPrivateLinedList(char *szSection,char *szEntry,
    TListImp<T> *pList, char *szFileName, unsigned int wLen) // wLen=32
  {
  char *sz=(char *)malloc (wLen);
  GetPrivateString(szSection,szEntry,"",sz,wLen, szFileName);
  if (strlen(sz)==wLen-1) // Buffer too short.
    {
    free(sz);
    return GetPrivateLinedList(szSection,szEntry,pList, szFileName, wLen*2);
    }

  String2List(sz,pList);
  free(sz);
  return pList;
  }

template <class T> BOOL WritePrivateLinedList(char *szSection,char *szEntry,
    TListImp<T> *pList, char *szFileName)
  {
  if (!pList)
    return FAILURE;
  unsigned int w=(unsigned int)CountItems(pList);
  T t;
  char *sz=(char *)malloc(w * (SizeOfOutput(t)+2)+1);

  BOOL fRes=List2StringEF(pList,sz);
  WritePrivateString(szSection,szEntry,sz,szFileName);
  free(sz);
  return fRes;
  }
template <class T> BOOL WritePrivateMultiLinedList(char *szSection,
    char *szEntry, TListImp<T> *pList, char *szFileName)
  {
  if (!pList)
    return FAILURE;
  char *szCountOfRecords=(char *)malloc(strlen(szEntry)+6);
  wsprintf(szCountOfRecords,"%s?X",szEntry);
  BOOL fPreviouslyHooked=IsHooked(szFileName);
  if (fPreviouslyHooked)
    UnHook(szFileName);
//  ^^^^^^
  unsigned int iOldCountOfRecords=GetPrivateInt(szSection,
      szCountOfRecords,0,szFileName);
  int iIterRecordCounter=0;

/*  private_profile_data sDat, *psDat=&sDat;
  sDat.szSection=szSection;
  sDat.szEntry=szEntry;
  sDat.szFileName=szFileName; */
  char *asz[3]={szSection,szEntry,szFileName};

  void *pArg[2]={(void *)asz,(void *)&iIterRecordCounter};
  Hook(szFileName);
//^^^^
  pList->ForEach(IterWritePrivateList, pArg);
// Erase old records
  WritePrivateInt(szSection,szCountOfRecords,iIterRecordCounter,
      szFileName);
  free(szCountOfRecords);
  if (iIterRecordCounter<iOldCountOfRecords)
    {
    UnHook(szFileName);
    char *sz=(char *)malloc(strlen(szEntry)+7);
    for (int i=iIterRecordCounter;i<iOldCountOfRecords;i++)
      {
      wsprintf(sz,"%s#%d",szEntry,i);
      RemovePrivateEntry(szSection,sz,szFileName); // Set to zero.
      }
    free(sz);
    Hook(szFileName);
    }
  if (!fPreviouslyHooked)
    UnHook(szFileName);
  return SUCCESS;
  }

template <class T> BOOL String2ListEF(char *sz, TListImp<T> *pList)
  {
  T t;
  char *pNext=sz, *pFirst=sz;
  BOOL f=SUCCESS;
  pList->Flush();
  do
    // Important that pNext!=NULL
    if (!ExtractValue(pFirst, &t, &pNext))
      {pNext=NULL;f=FAILURE;}
    else
      {pList->Add(t);pFirst=pNext;}
  while (pNext);
  return f;
  }


/*    BIT String2RecordListEF(char *sz, TPointList *pList)
  {
  tape_number it=0;
  record_number ir=0;
//  record_key k;
  char *pNext=sz, *pFirst=sz;
  BIT f=SUCCESS;
  pList->Flush();
  do
    {
    // Important that pNext!=NULL
    if (!ExtractValue(pFirst, &it, &pNext)
        || !ExtractValue(pNext, &ir, &pFirst))
      {pFirst=NULL;f=FAILURE;}
    else
      pList->Add(TPoint(it,ir));
    }
  while (pFirst);
  return f;
  }
*/
template <class T> BOOL List2StringEF(TListImp<T> *pList, char *sz)
  {
  if (!sz)
    return FAILURE;
  *sz=0;
  if (!pList)
    return SUCCESS;
  void *pArg=(void *)sz;
  pList->ForEach(IterList2String, pArg);
// The last character is separator if list not empty.
  unsigned int w=strlen(sz);
  if (w)
    sz[w-1]=0; // Cut off the last separator.
  return SUCCESS;
  }

template <class T> void IterList2String(T &t, void *pArg)
  {
// Refrence argument, rec is in fact a pointer.
//  char *sz=(char *)pArg; // Stack
  char *szNext=strchr((char *)pArg,0);
//  char szRec[STRLEN_RecordKey];
  Item2String(t,szNext);
  szNext=strchr(szNext,0);
  *szNext='|';
  szNext[1]=0;
  }
template <class T> unsigned long CountItems (TListImp<T> *pList)
  {
  if (!pList)
    return 0;
  int iIterRecordCounter=0;
  pList->ForEach(IterCountItems, (void *)&iIterRecordCounter);
  return iIterRecordCounter;
  }


//////////////////////////////////////////////////////////////
//              Corps des fonctions locales
//////////////////////////////////////////////////////////////
template <class T> unsigned int Copy2StaticArray(TListImp<T> *pl,T *a)
  {
  unsigned int wCount=0;
  void *ppArg[2]={(void *)a,(void *)&wCount};
  pl->ForEach(IterCopy2StaticArray,ppArg);
  return wCount;
  }
template <class T> void IterCopy2StaticArray(T &t, void *pArg)
  {
  void **paArg=(void **)pArg;
  T *aBuffer=(T *)paArg[0];
  aBuffer[(*((unsigned int *)paArg[1]))++]=t;
  }
template <class T> int IterItemEquals(const T &t, void *pArg)
  {
  return t==*((T *)pArg);
  }
template <class T> T* GetItemAddress(TListImp<T> *pl, T t)
  {
  return pl->FirstThat(IterItemEquals, (void *)(&t));
  }
template <class T> BOOL Contains(TListImp<T> *pl, T t)
  {
  return !!GetItemAddress(pl, t);
  }
template <class T> void IterLogicalSplitList(T &t, void *pArg)
  {
  void **apArg=(void **)pArg;
  TListImp<T> *pB=(TListImp<T> *)apArg[0], *pAAndB=(TListImp<T> *)apArg[1],
    *pANotB=(TListImp<T> *)apArg[2];
  apArg[0]=(void *)pB;
  apArg[1]=(void *)pAAndB;
  apArg[2]=(void *)pANotB;
  if (pB->FirstThat(IterItemEquals,(void *)&t))
    pAAndB->Add(t);
  else
    pANotB->Add(t);
  }
//unsigned int SizeOfOutput(int &);
//unsigned int SizeOfOutput(TPoint &);
template <class T> void WriteList(TStatic *pst,TListImp<T> *pl)
  {
  unsigned int w=(unsigned int)CountItems(pl);
  T t;
  char *sz=(char *)malloc(w*(SizeOfOutput(t)+2)+1);
  pst->SetText(List2String(pl,sz));
  free(sz);
  }
template <class T> TListImp<T> *GetList (TStatic *pst,TListImp<T> *pl)
  {
  unsigned int wLen=pst->GetTextLen();
  char *sz=(char *)malloc(wLen+1);
  pst->GetText(sz,wLen+1);
  TListImp<T> *plRes=String2List(sz,pl);
  free(sz);
  return plRes;
  }

template <class T> void IterWritePrivateList(T &t, void *pArg)
  {
// Refrence argument, rec is in fact a pointer.
//  private_profile_data *psDat=(private_profile_data *)(((void **)pArg)[0]);
  char **asz=(char **)(((void **)pArg)[0]);
  int *piIterRecordCounter=(int *)(((void **)pArg)[1]);
  char *sz=(char *)malloc(strlen(asz[1])+7);
  wsprintf(sz,"%s#%d",asz[1],
      (*piIterRecordCounter)++);  // First one is zero
  WritePrivateItem(asz[0],sz,t,asz[2]);
  free(sz);
  }
template <class T> void IterCountItems(T &/*rec*/, void *pArg)
  {
  (*((int *)pArg))++;
  }

#endif //
