/**********************************************************************/
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions.                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         :  			                  			      	 */
/*    Dvelopp le   :                                                */
/*    Dernire modif.:                                                */
/**********************************************************************/
#if !defined WSYSTOOL_H
#define WSYSTOOL_H

#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>

#include "base.h"
#include "strutil.h"

//#define LARGEUR_AFFIM 264
//#define HAUTEUR_SYSTEME 91
//#define HAUTEUR_AFFIM 282

#define MARGE_H 8
#define MARGE_V 8

/*-----------------------------------------------------------------------*/
/*                     Variables  exporter                              */
/*-----------------------------------------------------------------------*/
//----------------------------------------------------------------------------
//						Programme AppelTChoixDial
//----------------------------------------------------------------------------

int AppelDialChoice(TWindow *Parent,char titre[],char tabchoix[], char *pcRes, TRect fen=TRect(0,0,0,0));

//----------------------------------------------------------------------------
//						Programme TDialChoice
//----------------------------------------------------------------------------

class TDialChoice : public TDialog
{
 public :
  virtual void EvCommun(char );
  virtual void CloseWindow(int);
  virtual void SetupWindow();

  TDialChoice(TWindow *Parent,char titre[],char tabchoix[],TRect fen=TRect(0,0,0,0));
  void EvA();
  void EvB();
  void EvC();
  void EvD();
  void EvE();
  void EvF();
  void EvG();
  void EvH();
  void EvI();
  void EvJ();
  void EvBouton();
  protected :
  TRect Format;
  char tabret[10];

  DECLARE_RESPONSE_TABLE(TDialChoice);
};
extern TWindow *pFenetreControle;

//extern unsigned char uHauteurEdit;
//extern unsigned char uDLE; // DcalageLigneEdition
extern unsigned char uLargeurAscenseurs;
extern unsigned char uHauteurAscenseurs;
extern unsigned char uMargeTEdit;
extern unsigned char uLargeurMaxCar;
extern TSize sMarges;
extern int fDemarrPleinEcr;
/*-----------------------------------------------------------------------*/
/*                     Fonctions  exporter                              */
/*-----------------------------------------------------------------------*/

int GetText(TWindow *parent, char *szTitre, char *szTexte,
    char *szReponse, unsigned int wLg);


int GetFloatValue(TWindow *parent, char *szTitre, char *szTexte, float *x);
int GetIntValue(TWindow *parent, char *szTitre, char *szTexte, int *pi,
    char *szDef=NULL);
//int GetIntValue(TWindow *parent, char *szTitre, char *szTexte, int *pi);
int GetIntValue(TWindow *parent, char *szTitre, char *szTexte, unsigned int *pw);
int GetIntValue(TWindow *parent, char *szTitre, char *szTexte, char *pc);
int GetIntValue(TWindow *parent, char *szTitre, char *szTexte, unsigned char *pu);

// Needed for inline functions.
void SetString(char **psz, TEdit *pe);

TPoint GetPrivate(char *szSection, char * szEntry, TPoint ptDefault, char *szFileName);
TPoint GetPrivatePoint(char *szSection, char * szEntry, TPoint ptDefault, char *szFileName);
int WritePrivatePoint(char *szSection, char *szEntry, TPoint pValue,
                           char *szFilename);

// Use this one for TPoint objects.
int ExtractPointValue(char *pcFirst, TPoint *ppt, char **ppcNext);

// Short access to ExtractPointValue
inline int ExtractValue(char *szLigne, TPoint *pptValue, char **pNext=NULL)
  {
  return ExtractPointValue(szLigne,pptValue,pNext);
  }

// Use this one for all the types that look like TPoint and which have a cast to TPoint available.
template <class T> int ExtractPointishValue(char *szLigne, T *pValue,
    char **pNext=NULL)
  {
  TPoint ptValue;
  if (pValue && ExtractPointValue(szLigne,&ptValue,pNext))
    {
    *pValue=(T)ptValue;
    return SUCCES;
    }
  else
    return FAILURE;
  }


template <class TPointLike> int GetPointishValue(TWindow *parent,
    char *szTitre, char *szTexte, TPointLike *ppt)
  {
  char szPoint[STRLEN_Point*2]="";
  return GetText(parent,szTitre,szTexte,szPoint,sizeof(szPoint)) &&
    ExtractPointishValue(szPoint, ppt);
  }

int IsPoint(TRect r);

int WritePrivate(char *szSection, char *szEntry, TPoint pValue,
                           char *szFilename);

template <class T> int GetIntishValue(TWindow *parent, char *szTitre,
    char *szTexte, T *p, char *szDef=NULL)
  {
  int i;
  char fRes;
  if ((fRes=GetIntValue(parent,szTitre,szTexte, &i,szDef))!=0)
    *p=(T)i;  // Uniquement si succes.
  return fRes;
  }
template <class T> int GetIntishValue(TWindow *parent, char *szTitre,
    char *szTexte, T *p, T def)
  {
  char szDef[USUALMAXLENSTRING];
  sprintf(szDef,"%g",(float)def);
  return GetIntishValue(parent,szTitre,szTexte,p,szDef);
  }

#endif // WSYSTOOL_H


