#include "baptiall.h"

#pragma hdrstop

#define MODULE_NAME "FILUTIL.CPP"
 /*******************|******************************************
                          W C R T X T F C . C                        
        -------------------------------------------------------------
            Fonction       : Outils de travail sur caractres,       
                             chanes de caractres et fichiers.      
                                                                     
         Fichier source WCRTXTFC.C.                                  
          (contient les objets internes                               
          et les corps des objets  exporter)                        
        -------------------------------------------------------------
            Auteur         : Baptise MARCEL                          
            Dvelopp le   : hivers 1994/1995                        
        ************************************************************
    // Inclusions bibliothques standards
    #include <dir.h>
    #include <ctype.h>
    #include <io.h>
    #include <stdlib.h>
    #include <string.h>
    
    // Inclusions bibliothques Object Windows
    
    //#include <owl\applicat.h>
    
    // Inclusions bibliothques DOS
    #include <stdio.h>
    */ 

// Inclusion bibliothques Image
//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "filutil.h"
#include "strutil.h"

/*-------------------------------------------------------------*/
/*                     constantes locales                      */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*                    variables  exporter                     */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*                     variables locales                       */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/
//BIT MErreur(char *szMessage="Erreur indfinie",int ref=0);
/*-------------------------------------------------------------*/
/*                    fonctions  exporter                     */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/* LigneOiseuse (Ligne oiseuse)
     Renvoit VRAI si la ligne est une ligne vide (que des ' ') ou
   un commentaire (commence par '--').
     Renvoit FAUX pour NULL.
   */
int LigneOiseuse ( char *ligne )
{
static char *puchnos = NULL ;
int         retour ;

puchnos =  CompactEspace(ligne);
if ( puchnos == NULL ) 
  return FAUX ;
else if ( puchnos [0] == 0 ) 
  retour =  VRAI ;
else if ( strlen(ligne) < 2 ) 
  retour =  FAUX ;
else if ( (ligne [0] == '-') && (ligne [1] == '-') ) 
  retour =  VRAI ;
else 
  retour =  FAUX ;
free(puchnos);
return retour ;
}

/*-------------------------------------------------------------*/
/* fgetlline ("file get limited line")
      Renvoit dans la chane de caractre "ligne" la ligne courante du
   fichier point par le flux "canal". La ligne courante est la ligne depuis
   l'lment point par le flux jusqu'au prochain caractre '\n'. L'lment
   '\n' est lu dans le canal, mais remplac par '\0' dans la chane.
     La chane reoit jusqu' "limite" caractres non nuls. Si la ligne en
   compte plus, ils seront tronqus et le canal pointera sur la prochane ligne.
     Les caractres non lus passeront dans la quatrime dimension.
   
     Si la ligne est vide, la chane rsultante sera "\0". Si le fichier est
   vide, la chane rsultante sera NULL. Si le fichier se termine sans
   caractre '\n', la chane est renvoye normalement (termine par '\0').
     La nouvelle ligne est alloue dans la proc. elle-mme.
   
     ligne :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane.
   */
char *fgetlline ( FILE *canal, int limite )
{
char  *ligne ;
int   i, C ;
char  c ;

ligne =  (char *)malloc((limite + 1) * sizeof(char));
for ( i = 0 ; i < limite + 1 ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    if ( i == 0 ) 
      {
      free(ligne);
      return NULL ; /* Plus de ligne dans le fichier. */ 
      }
    else 
      {
      ligne [i] =  '\0'; /* Marque de fin de chane. */ 
      return ligne ;
      }
  else if ( c == '\n' ) 
    {
    ligne [i] =  '\0'; /* Marque de fin de chane. */ 
    return ligne ;
    }
  else 
    ligne [i] =  c ; /* Retenue du caractre. */ 
  }

/* "limite" caractres ont t chargs sans que la fin de ligne ne
   soit dtecte. */
ligne [limite] =  '\0'; /* Fermeture de la chane (crasement du dernier
                           caractre lu). */ 
for (; (c != '\n') && (C != EOF) ; ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  }
return ligne ;
}

/*-------------------------------------------------------------*/
/* fgetlaline ("file get limited allocated line")
      Idem qu'fgetlline, mais c'est une chane dj alloue qui est passe
   en paramtre.
     Attention. En cas de fin de fichier, le pointeur renvoy sera NULL,
   mais la chane en paramtre vide.
   
     ATTENETION/ Les specs ont t chang. Ce n'est pas un max de "limite"
   caractres non nuls qui sont mis dans la chane, mais "limite"-1, ce qui
   veut dire qu'en cas de troncature, "limite"-1 caractres seront passs et
   le dernier sera mis  zro.
   
     ligne :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane. */
char *fgetlaline ( FILE *canal, int limite, char *ligne )
{
int iC, i ;

//  char c;
if ( !limite || !canal || !ligne ) 
  return NULL ;
for ( i  = 0, iC = fgetc(canal) ; i < limite ; i++, iC =  fgetc(canal) ) 
  {
  
  //    c=(char)();
  if ( iC == EOF ) 
    {
    ligne [i] =  0 ; /* Marque de fin de chane. */ 
    return i ? ligne : NULL ; // Plus de ligne dans le fichier.
    }
  else if ( (char)iC == '\n' ) 
    {
    ligne [i] =  0 ; /* Marque de fin de chane. */ 
    return ligne ;
    }
  else 
    ligne [i] =  (char)iC ; /* Retenue du caractre. */ 
  }

/* "limite" caractres ont t chargs sans que la fin de ligne ne
   soit dtecte. */
ligne [limite - 1] =  0 ; /* Fermeture de la chane (crasement du dernier
                             caractre lu). */ 
for (; ((char)iC != '\n') && (iC != EOF) ; ) 
  
  // Feed du stream jusqu'aprs le prochain \n ou EOF.
  iC =  fgetc(canal);
return ligne ;
}

/*-------------------------------------------------------------*/
/* fgetslline ("file get significative limited line")
      Renvoit dans la chane de caractre "ligne" la prochaine ligne
   significative (ni commentaire, ni vide) du fichier point par le flux
   "canal". Le caractre '\n' marque une fin de ligne. L'lment
   '\n' est lu dans le canal, mais remplac par '\0' dans la chane.
     La chane reoit jusqu' "limite" caractres non nuls. Si la ligne en
   compte plus, ils seront tronqus et le canal pointera sur la prochaine ligne.
     Les caractres non lus passeront dans la quatrime dimension.
     Si le fichier ne contient plus de lignes significatives, la chane
   rsultante sera NULL.
     La nouvelle chane est alloue par une sous-proc. de la procdure elle-mme.
   
     ligne :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane.
      */
char *fgetslline ( FILE *canal, int limite )
{
int   ligne_oiseuse = VRAI ;
char  *stichos = NULL ;

do 
  {
  stichos =  fgetlline(canal, limite);
  if ( LigneOiseuse(stichos) ) 
    free(stichos);
  else 
    ligne_oiseuse =  FAUX ;
  } 
while ( ligne_oiseuse );
return stichos ;
}

/*-------------------------------------------------------------*/
/* fgetltext ("file get limited text")
      Renvoit dans la chane de caractre "texte" la suite des caractres du
   fichier point par le flux "canal" jusqu' atteindre "limite" caractres.
   L'lment '\n' est lu dans le canal, mais pas transmis dans la chane.
     Si le fichier est trop court, la chane rsultante sera plus courte.
     La chane est alloue par la proc. elle-mme.
   
     texte :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane. */
char *fgetltext ( FILE *canal, int limite )
{
char  *texte ;
int   i, C ;
char  c ;

texte =  (char *)malloc((limite + 1) * sizeof(char));
if ( texte == NULL ) 
  {
  _Erreur("Erreur d'allocation (blocage imminent).", 413);
  return NULL ;
  }
for ( i = 0 ; i < limite + 1 ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    {
    texte [i] =  '\0'; /* Marque de fin de chane. */ 
    return texte ;
    }
  else if ( c == '\n' ) 
    i-- ;
  else 
    texte [i] =  c ; /* Retenue du caractre. */ 
  }

/* "limite" caractres ont t chargs sans que la fin de fichier ne
   soit dtecte. */
texte [limite] =  '\0'; /* Fermeture de la chane (crasement du dernier
                           caractre lu). */ 
return texte ;
}

/*-------------------------------------------------------------*/
/* fgetlltext ("file get limited lined text")
      Renvoit dans la chane de caractre "texte" la suite des caractres du
   fichier point par le flux "canal" jusqu' atteindre "limite" caractres.
   L'lment '\n' est lu dans le canal et transmis dans la chane.
     Si le fichier est trop court, la chane rsultante sera plus courte.
     La chane est alloue par la proc. elle-mme.
   
     texte :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane. */
char *fgetlltext ( FILE *canal, int limite )
{
char  *texte ;
int   i, C ;
char  c ;

texte =  (char *)malloc((limite + 1) * sizeof(char));
if ( texte == NULL ) 
  _Erreur("Erreur d'allocation.", 277);
for ( i = 0 ; i < limite ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    {
    texte [i] =  '\0'; /* Marque de fin de chane. */ 
    return texte ;
    }
  else 
    texte [i] =  c ; /* Retenue du caractre. */ 
  }

/* "limite" caractres ont t chargs sans que la fin de fichier ne
   soit dtecte. */
texte [limite] =  '\0'; /* Fermeture de la chane. */ 
return texte ;
}

/*-------------------------------------------------------------*/
/* fgetlaltext ("file get limited allocated lined text")
      Renvoit dans la chane de caractre "texte" la suite des caractres du
   fichier point par le flux "canal" jusqu' atteindre "limite-1" caractres non nuls.
   
     L'lment '\n' est lu dans le canal et transmis dans la chane.
     Si le fichier est trop court, la chane rsultante sera plus courte.
     La chane est alloue par la proc. elle-mme.
   
     texte :    chane de caractre cible,
     canal :    flux source,
     limite :   nombre maximal de caractres de la chane. */
char *fgetlaltext ( FILE *canal, unsigned int limite, char *texte )
{

//  char *texte;
int           C ;
unsigned int  i ;

//  texte =(char *) malloc ((limite+1)*sizeof(char));
if ( texte == NULL ) 
  _Erreur("Erreur d'allocation.", 277);
for ( i = 0 ; i < limite - 1 ; i++ ) 
  {
  C =  fgetc(canal);
  if ( C == EOF ) 
    {
    texte [i] =  '\0'; /* Marque de fin de chane. */ 
    return texte ;
    }
  else 
    texte [i] =  (char)C ; /* Retenue du caractre. */ 
  }

/* "limite" caractres ont t chargs sans que la fin de fichier ne
   soit dtecte. */
texte [limite - 1] =  '\0'; /* Fermeture de la chane. */ 
return texte ;
}

/*-------------------------------------------------------------*/
char *fGetLineContaining ( FILE *pfilSource, char *sz, unsigned int wLen
    , char *szMark )
{
while ( fgetlaline(pfilSource, wLen, sz) ) 
  if ( strstr(sz, szMark) ) 
    return sz ;
*sz =  0 ;
return NULL ;
}

/*-------------------------------------------------------------*/
/* fcontcharline (file cont character line)
   Compte le nombre max de caractres par ligne.
   */
int fcontcharline ( FILE *canal )
{
int   C = 0, i, l = 0, max = 0 ;
char  c, limite = FAUX ;

for ( i = 0 ; limite == FAUX ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    {
    limite =  VRAI ;
    if ( l > max ) 
      max =  l ;
    l =  0 ;
    }
  else if ( c == '\n' ) 
    {
    if ( l > max ) 
      max =  l ;
    l =  0 ;
    }
  else 
    l++ ;
  }
return max ;
}

/*-------------------------------------------------------------*/
/* fcontline (file count line)
   Compte les lignes restantes du fichier.
   */
int fcontline ( FILE *canal )
{
int   C = 0, i, l = 0 ;
char  c, limite = FAUX ;

for ( i = 0 ; limite == FAUX ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    limite =  VRAI ;
  else if ( c == '\n' ) 
    l++ ;
  }
if ( c != '\n' && i > 1 ) 
  l++ ;
return l ;
}

/*-------------------------------------------------------------*/
/*void intgcvt (int n, int taille, char *mot)
   {
   gcvt(n, taille, mot);
   }*/
/*-------------------------------------------------------------*/
/* fcontchar (file cont character)
     Compte les caractres restant du fichier (sans les '\n' ni les ' '
   terminaux).
     */
int fcontchar ( FILE *canal )
{
int   C = 0, i, vide_terminal = 0 ;
char  c, limite = FAUX ;

for ( i = 0 ; limite == FAUX ; i++ ) 
  {
  C =  fgetc(canal);
  c =  (char)C ;
  if ( C == EOF ) 
    limite =  VRAI ;
  else if ( c == '\n' ) 
    i-- ;
  else if ( c == ' ' ) 
    vide_terminal++ ; /* Compte le nombre de ' ' terminaux. */ 
  else 
    vide_terminal =  0 ;
  }
return i - vide_terminal - 1 ;
}

unsigned long CountRealChar ( FILE *canal )
{
for ( unsigned long l = 0 ; fgetc(canal) != EOF ; l++ ) 
  ;
return l ;
}

unsigned long CountRealCharCR ( FILE *canal )
{
int           C ;
unsigned long l = 0 ;

for (;;) 
  {
  C =  fgetc(canal);
  if ( C == EOF ) 
    break ;
  else if ( (char)C == '\n' ) 
    l++ ;
  l++ ;
  }
return l ;
}

int StatFile ( char *szFile, unsigned long *pdwNbChar
    , unsigned long *pdwNbLine, unsigned long *pdwNbMaxCharPerLine )
{

//  ffblk sffblk;
/*  if (findfirst(szFile, *sffblk,FA_RDONLY & FA_HIDDEN & FA-SYSTEM))
     return ECHEC;
   else
     {*/
if ( access(szFile, 04) ) 
  return 0 ;

FILE  *pfl = fopen(szFile, "rt");
BIT   f = StatFile(pfl, pdwNbChar, pdwNbLine, pdwNbMaxCharPerLine);

fclose(pfl);
return f ; // will be false if file does not exist.
          //    }
}

int StatFile ( FILE *pFileStream, unsigned long *pdwNbChar
    , unsigned long *pdwNbLine, unsigned long *pdwNbMaxCharPerLine )
{
if ( !pFileStream || !pdwNbChar || !pdwNbLine || !pdwNbMaxCharPerLine ) 
  return ECHEC ;

int iC ; // Valeur lue.

*pdwNbChar           =  0 ;
*pdwNbLine           =  0 ;
*pdwNbMaxCharPerLine =  0 ;

unsigned long dwNbCharThisLine = 0 ;

for (;;) 
  {
  if ( (iC = fgetc(pFileStream)) == EOF ) 
    break ;
  else if ( (char)iC == '\n' ) 
    {
    if ( dwNbCharThisLine > *pdwNbMaxCharPerLine ) 
      *pdwNbMaxCharPerLine =  dwNbCharThisLine ;
    dwNbCharThisLine =  0 ;
    (*pdwNbLine)++ ;
    }
  (*pdwNbChar)++ ; // Incrmentation mme si '\n'.
  dwNbCharThisLine++ ;
  }
return SUCCES ;
}

int chem_nom_fichier_conforme ( char *szFileName )
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT];

return fnsplit(szFileName, szDrive, szDir, szName, szExt) & FILENAME ;
}

int IsFileExtension ( char *szFileName, char *szExtension )
{
char  szDrive1 [MAXDRIVE], szDir1 [MAXDIR], szName1 [MAXFILE]
  , szExt1 [MAXEXT];
char  szDrive2 [MAXDRIVE], szDir2 [MAXDIR], szName2 [MAXFILE]
  , szExt2 [MAXEXT], szPath2 [MAXPATH];

fnsplit(szFileName, szDrive1, szDir1, szName1, szExt1);
fnmerge(szPath2, "", "", "", szExtension);
fnsplit(szPath2, szDrive2, szDir2, szName2, szExt2);
return !strcmpi(szExt1, szExt2);
}

void SetFileExtension ( char *szFileName, char *szExtention )
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT];

fnsplit(szFileName, szDrive, szDir, szName, szExt);
fnmerge(szFileName, szDrive, szDir, szName, szExtention);
}

int SetFileExtension ( char *szFileName, char *szExtention
    , unsigned int wLen ) // protected
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT]
  , szFullName [MAXPATH];

fnsplit(szFileName, szDrive, szDir, szName, szExt);
fnmerge(szFullName, szDrive, szDir, szName, szExtention);
if ( strlen(szFullName) >= wLen ) 
  return FAILURE ;
else 
  return (!!strcpy(szFileName, szFullName)); // !! for the case when the pointer == 256 or multiple
}

/*-------------------------------------------------------------*/
/*                     fonctions locales                       */
/*-------------------------------------------------------------*/
/*BIT MErreur(char *szMessage,int ref)
   {
   char *MessageLocal;
   BIT fRes;
   MessageLocal=(char *)malloc(strlen(szMessage)+20);
   sprintf(MessageLocal,"%s (FILUTIL.CPP)",szMessage);
   fRes= Erreur(MessageLocal,ref);
   free(MessageLocal);
   return fRes;
   }
   
   */
/*
   Split e text document in wSplit parts (<10).
   The last character of source ext is replaced by the number of the split.
    Example: s.txt -> s.tx1 and s.tx2
    Example: s.on -> s.on1 and s.on2
   */
int SplitTextFile ( char *szSource
    , unsigned int wSplit /* Number of parts */ 
    , unsigned long *pdwNbMaxCharPerLine )
{
if ( wSplit >= 10 ) 
  return MErreur("Cannot split above 9 parts", 558);

unsigned long dwNbChar = 0, dwNbLine = 0, dwNbMaxCharPerLine = 0 ;
char          szTarget [MAXPATH];

if ( !StatFile(szSource, &dwNbChar, &dwNbLine, &dwNbMaxCharPerLine) ) 
  return FAILURE ;
if ( dwNbLine / wSplit > UINT_MAX ) 
  return MErreur("File too long (split more may cure)", 566);
if ( dwNbMaxCharPerLine - 1 > UINT_MAX ) 
  return MErreur("File contaings lines too long", 568);

unsigned int  wLength = (unsigned int)(dwNbLine / wSplit);  // Approx
char          *szLine = (char *)malloc((unsigned int)dwNbMaxCharPerLine + 1);
FILE          *pfilSource = fopen(szSource, "rt");

for ( unsigned int wS = 0 ; wS < wSplit - 1 ; wS++ ) 
  {
  
  // For each part (except the last one)
  SplitTextFileTellFileName(szSource, wS + 1, szTarget);
  FILE  *pfilTarget = fopen(szTarget, "wt");
  for ( unsigned int wL = 0 ; wL < wLength ; wL++ ) // For all wLength lines
                                                      {
  if ( !fgetlaline(pfilSource, (unsigned int)dwNbMaxCharPerLine + 1
        , szLine) ) 
    return MErreur("Disfunction in splitting", 563);
                                                      fprintf(pfilTarget
                                                        , "%s\n", szLine);
                                                      }
  fclose(pfilTarget);
  }
  {
  SplitTextFileTellFileName(szSource, wS + 1, szTarget);
  FILE  *pfilTarget = fopen(szTarget, "wt");
  while ( fgetlaline(pfilSource, (unsigned int)dwNbMaxCharPerLine + 1
          , szLine) ) 
    fprintf(pfilTarget, "%s\n", szLine);
  fclose(pfilTarget);
  }
free(szLine);
fclose(pfilSource);
if ( pdwNbMaxCharPerLine ) 
  *pdwNbMaxCharPerLine =  dwNbMaxCharPerLine ;
return SUCCESS ;
}

/*
   Split a INI text document in 2 parts.
   The last character of source ext is replaced by the number of the split.
    Example: s.txt -> s.tx1 and s.tx2
    Example: s.on -> s.on1 and s.on2
   */
int SplitINITextFile ( char *szSource
    , unsigned int wSplit /* Number of parts */ ) //    unsigned long *pdwNbMaxCharPerLine)
{
unsigned long dwNbChar = 0, dwNbLine = 0, dwNbMaxCharPerLine = 0 ;
char          szTarget [MAXPATH];

if ( !StatFile(szSource, &dwNbChar, &dwNbLine, &dwNbMaxCharPerLine) ) 
  return FAILURE ;
if ( dwNbLine / wSplit > UINT_MAX ) 
  return MErreur("File too long (split more may cure)", 616);
if ( dwNbMaxCharPerLine - 1 > UINT_MAX ) 
  return MErreur("File contaings lines too long", 618);

unsigned int  wLength = (unsigned int)(dwNbLine / wSplit);  // Approx
char          *szLine = (char *)malloc((unsigned int)dwNbMaxCharPerLine + 1);
FILE          *pfilSource = fopen(szSource, "rt");
char          *fNoEndFile ;
unsigned int  wPart = 1, wLineNumber = 0 ;

do 
  {
  SplitTextFileTellFileName(szSource, wPart, szTarget);
  FILE  *pfilTarget = fopen(szTarget, "wt");
  if ( wPart > 1 ) 
    fprintf(pfilTarget, "%s\n", szLine); // Headers of cutting.
  do 
    {
    fNoEndFile
      =  fgetlaline(pfilSource, (unsigned int)dwNbMaxCharPerLine + 1
        , szLine);
    if ( fNoEndFile ) 
      {
      fprintf(pfilTarget, "%s\n", szLine);
      wLineNumber++ ;
      }
    } 
  while ( fNoEndFile
            && (wLineNumber < wPart * wLength
                  || wPart == wSplit /* last one */ ) );
  
  // Passed the number of lines for this part.
  if ( fNoEndFile ) 
    {
    char  fCut = FALSE ;
    do 
      {
      fNoEndFile
        =  fgetlaline(pfilSource, (unsigned int)dwNbMaxCharPerLine + 1
          , szLine);
      wLineNumber++ ;
      if ( fNoEndFile && !IsAnySection(szLine) ) 
        {
        fprintf(pfilTarget, "%s\n", szLine);
        fCut =  FALSE ;
        }
      else 
        fCut =  TRUE ;
      } 
    while ( !fCut );
    }
  fclose(pfilTarget);
  wPart++ ;
  } 
while ( fNoEndFile );
for ( unsigned int wP = wPart + 1 ; wP <= wSplit ; wP++ ) 
  {
  
  // Undone parts
  SplitTextFileTellFileName(szSource, wP, szTarget);
  if ( !access(szTarget, 06) ) 
    
    // This case: does exist but should not.
    unlink(szTarget);
  }
free(szLine);
fclose(pfilSource);
return SUCCESS ;
}

char *SplitTextFileTellFileName ( char *szSource, unsigned int wNumber
    , char *szSlice ) // Tell the filename of the part to process
{
char  szDrive [MAXDRIVE], szDir [MAXDIR], szName [MAXFILE], szExt [MAXEXT];

fnsplit(szSource, szDrive, szDir, szName, szExt);
if ( strlen(szExt) == 4 ) 
  szExt [3] =  wNumber + '0';
else 
  szExt [strlen(szExt)] =  wNumber + '0';
fnmerge(szSlice, szDrive, szDir, szName, szExt);
return szSlice ;
}
