/////////////////////////////////////////////////////////////////
//                    N I T R A T E   . C P P
/////////////////////////////////////////////////////////////////
//    Fonction       :
/////////////////////////////////////////////////////////////////
//    Auteur         :  Baptiste Marcel (marce@len7.enseeiht.fr)
//        Written in Toulouse, France
//        All rights copyrighted
//    Cr le        : fin septembre 1996
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Headers
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Constantes du programme
/////////////////////////////////////////////////////////////////
#include "dnitrate.h"
#include "strutil.h"
#include "strtool.h"

#include <limits.h>
#include <stdio.h>

char cDefaultMesureType=ESTIMO;
TMesure mesNul=TMesure(),mesMinimumSpace=(60,CHRONO);
has_been_seen hsbNull={0,qC,VL_Unknown};
//                   Small classes (declarations)
//                   Structures
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Global variables
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Variables externes                        //
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Fonctions prototypes                      //
/////////////////////////////////////////////////////////////////


////Mesures//////////////////////////////////////////////////////
int WritePrivateMesure(char *szSection,char *szEntry,
    TMesure mes, char *szFileName)
  {
  char sz[STRLEN_Mesure];
  return WritePrivateString(szSection,szEntry,Mesure2String(mes,sz),szFileName);
  }
TMesure GetPrivateMesure(char *szSection,char *szEntry,
    TMesure mesDefault, char *szFileName)
  {
  char sz[STRLEN_Mesure], szDef[STRLEN_Mesure];
//  char *pcNext;
  GetPrivateString(szSection,szEntry,
      Mesure2String(mesDefault,szDef),sz,STRLEN_Mesure,szFileName);
  TMesure mesRes;
  if (!String2MesureEF(sz,&mesRes))
    return mesDefault;
  else
    return mesRes;
  }
// Mesure
char *Mesure2String(TMesure mes, char *sz)
  {
  if (mes == mesNul)
    {
    *sz=0;
    return sz;
    }
  char szBuff[16]="";
//  TTime t(0,0,mes.wT);
  struct time t={(mes.wT%3600)/60,(mes.wT)/3600,0,(mes.wT)%60};
/*  t.t_min=(mes.wT%3600)/60;
  t.t_hour=mes.wT/3600;
  t.t_sec=mes.wT%60;
  t.t_hund=0;
//  ={,,0,(mes.wT)%60};*/
  Time2String(t, szBuff);

  sprintf(sz,"%c%s",mes.cP,szBuff);
  return sz;
  }
int String2MesureEF(char *sz, TMesure *pmes, int *pfTwisted)
  {
  if (!sz) return FAILURE;
  char *pcNext=AvaleEspace(sz);
//  char c;
  if (*pcNext=='-')
    {
    pcNext++;
    if (pfTwisted) *pfTwisted=TRUE;
    }
  else
    if (pfTwisted) *pfTwisted=FALSE;
  pmes->cP=Char2LenghtPrecision(*pcNext);
  if (pmes->cP == PREC_UNKNOWN)
    {
//    pcNext=sz;
    pmes->cP = *pcNext?cDefaultMesureType:ESTIMO; // NULL string forced to '?'
    }
  else
    pcNext++;
  struct time t={0,0,0,0};
  int f1=String2TimeEF(pcNext, &t);
  unsigned int w= t.ti_sec+60 * t.ti_min+ 3600*t.ti_hour;
//  int f1=String2TimeEF(pcNext, &w);
  pmes->wT=f1?w:0;
  return f1 && (pmes->cP != PREC_UNKNOWN);
  }
// Gender

/*
  Split the episode key.
  Return TRUE if it was an episode key.
*/
int SplitEpisodeTitle(
   char *szMetaTitle, // in: series#number~title
   char *szShortSeries, // out: allocated
   char *szNumber, // out: allocated
   char **pacTitleAddress) // out: poiter on the first character of epiosde title of string szMetaTitle.
  {
  int f=SUCCESS;
  char *pcNumber=strchr(szMetaTitle,'#');
  if (!pcNumber)
    {f=FAILURE;*szNumber=0;*szShortSeries=0;pcNumber=szMetaTitle-1;}
  else
    {
    *pcNumber=0;
    strNcpy(szShortSeries,szMetaTitle,STRLEN_SeriesShortName);
    *pcNumber='#';
    }
  *pacTitleAddress=strchr(pcNumber+1,'~');
  if (! *pacTitleAddress)
    {
    f=FAILURE;
    strNcpy(szNumber,pcNumber+1,STRLEN_StringNumber);
    *pacTitleAddress=strchr(szMetaTitle,0);
    }
  else
    {
    **pacTitleAddress=0;
    strNcpy(szNumber,pcNumber+1,STRLEN_StringNumber);
    **pacTitleAddress='~';
    (*pacTitleAddress)++;
    }
  return f;
  }

int SplitEpisodeTitle(
    char *szMetaTitle, // Full title series#number~epstitle
    char *szShortSeries, // Series name (short) must be allocated
    char *szNumber, // Must be allocated
    char *szEpisodeTitle) // Must be allocated
  {
  char *pcEpisodeTitle;

  int f = SplitEpisodeTitle(szMetaTitle, szShortSeries, szNumber,
    &pcEpisodeTitle) && pcEpisodeTitle ;
  if (f)
    strcpy(szEpisodeTitle,pcEpisodeTitle);
  return f;
  }
int SplitDocumentKey(char *sz, videon_gender *peGender,
    char *szTitle, unsigned int wLen, unsigned int *pwYear)
  {
  char *pcSep;
  if (!sz)
    return FALSE;
  else
    pcSep=strchr(sz,'|');
  int fRes=TRUE;
  if (!pcSep)
    return FALSE;
  else
    {
    *pcSep=0;
    fRes=fRes && ExtractValue(sz,peGender);
    *pcSep='|';
    }
  sz=pcSep+1;
  pcSep=strchr(sz,'|');
  if (!pcSep)
    return FALSE;
  else
    {
    *pcSep=0;
    strNcpy(szTitle,sz,wLen);
    *pcSep='|';
    }
  return fRes && ExtractValue(pcSep+1,pwYear);
  }

// Gender
int ExtractValue(char *szValue, videon_gender *pe, char **pcNext)
  {
  char szComparison[STRLEN_Gender];
  ExtractItem(szValue,szComparison,sizeof(szComparison),pcNext,acUsualSeparators);
  if (!strcmpi(szValue,Item2String(DOCUMENT,szComparison,STRLEN_Gender)))
    *pe= DOCUMENT;
  else if (!strcmpi(szValue,Item2String(SERIES,szComparison,STRLEN_Gender)))
    *pe= SERIES;
  else if (!strcmpi(szValue,Item2String(VOID_RECORD,szComparison,STRLEN_Gender)))
    *pe= VOID_RECORD;
  else if (!strcmpi(szValue,Item2String(EPISODE,szComparison,STRLEN_Gender)))
    *pe= EPISODE;
  else if (!strcmpi(szValue,Item2String(DEFECT_TAPE,szComparison,STRLEN_Gender)))
    *pe= DEFECT_TAPE;
  else if (!strcmpi(szValue,Item2String(UNKNOWN,szComparison,STRLEN_Gender)))
    *pe= UNKNOWN;
  else
    {
    *pe=UNKNOWN;
    return FAILURE;
    }
  return SUCCESS;
  }
char *Item2String(videon_gender eValue, char *szValue, unsigned int wLen)
//char *Item2String(videon_gender eValue, char *szValue, WORD wLen)
  {
  if (!szValue)
    return szValue;
  else if (wLen && wLen<STRLEN_Gender)
    {
    *szValue=0;
    return szValue;
    }
  switch (eValue)
    {
    case SERIES:
      strcpy(szValue,"ser");
      break;
    case DOCUMENT:
      strcpy(szValue,"doc");
      break;
    case VOID_RECORD:
      strcpy(szValue,"spc");
      break;
    case DEFECT_TAPE:
      strcpy(szValue,"def");
      break;
    case EPISODE:
      strcpy(szValue,"eps");
      break;
    case UNKNOWN:
    default:
      strcpy(szValue,"nul");
      break;
    }
  return szValue;
  }
char *Item2String(has_been_seen hsb, char *sz)
  {
//  char szBuf1[STRLEN_Flag];
  char szBuf2[STRLEN_VersionLanguage];
  if (hsb.fHasBeen)
    sprintf(sz,"yes: q%c,%s",hsb.cQ,
      ItemVersionLanguage2String(hsb.uVL,szBuf2));
  else
    *sz=0;
  return sz;
  }
char * HasBeenSeen2CodeString(has_been_seen hsb, char *sz)
  {
  if (!hsb.fHasBeen)
    strcpy(sz,"         ");
  else
    {
    char szVL[STRLEN_VersionLanguage];
    sprintf(sz,"Y-%c-%s",hsb.cQ ,VersionLanguage2CodeString(
    hsb.uVL,szVL));
    }
  return sz;
  }
//int ExtractValue(char *sz, has_been_seen *phbs)
int ExtractValue(char *sz, has_been_seen *phbs, char **pcNext)
  {
  if (!phbs)
    return FAILURE;
  else
    *phbs=hsbNull;
  char szBuffer[STRLEN_HasBeenSeen], *szNext, *szStart;
  int f=ExtractItem(sz,szBuffer,STRLEN_HasBeenSeen,&szNext,acUsualSeparators);
  int fHasBeen;
  if (!String2FlagEF(szBuffer,&fHasBeen) || !fHasBeen)
    {*phbs=hsbNull;return FAILURE;}
  else
    phbs->fHasBeen=fHasBeen;
  szStart=szNext;
  f=f && ExtractItem(szStart,szBuffer,STRLEN_HasBeenSeen,&szNext,acUsualSeparators);
  char cQ;
  if (String2QualityEF(szBuffer,&cQ))
    phbs->cQ=cQ;
  else
    {
    phbs->cQ=qC;
    f=FAILURE;
    }
  return f && ExtractValue_VersionLanguage(szNext,&(phbs->uVL),pcNext);
/*  version_language uVL;
  if (String2VersionLanguageEF(szNext,&uVL))
    phbs->uVL=uVL;
  else
    f=FAILURE;

  return f;
  */
  }

int String2QualityEF(char *sz, quality *pcQ)
  {
  if (!sz || !*sz)
    return FAILURE;
  char *szBuffer=(char *)malloc(strlen(sz)+1);
  strcpy(szBuffer,sz);
  char *szWord=AvaleEspace(szBuffer);
  CutTrailingSpaces(szWord);
  if (toupper(*szWord)=='Q')
    szWord++;
  char c=toupper(*szWord);
  int f=SUCCESS;
  if (c>=qA && c<=qC)
    f=*pcQ=c;
  else
    f=FAILURE;
  free(szBuffer);
  return f;
  }


// Version language
char *ItemVersionLanguage2String(version_language u, char *sz)
  {
  switch (u)
    {
    case  VL_VONoST :
      strcpy(sz,"V.O. nS.-T.");
      break;
    case VL_VF :
      strcpy(sz,"V.F.");
      break;
    case VL_VOSTF :
      strcpy(sz,"V.O. S.-T. F");
      break;
    case  VL_VOtherLangageSTF :
      strcpy(sz,"V.Other S.-T. F");
      break;
    case  VL_SpecialSilent :
      strcpy(sz,"Special Silent");
      break;
    case  VL_SpecialVersion :
      strcpy(sz,"Special version");
      break;
    case  VL_Unknown :
    default :
      strcpy(sz,"Unknown");
      break;
    }
  return sz;
  }
char *VersionLanguage2CodeString(version_language u, char *sz)
  {
  switch (u)
    {
    case  VL_VONoST :
      strcpy(sz,"VOnST");
      break;
    case VL_VF :
      strcpy(sz,"VF   ");
      break;
    case VL_VOSTF :
      strcpy(sz,"VOSTF");
      break;
    case  VL_VOtherLangageSTF :
      strcpy(sz,"VxSTF");
      break;
    case  VL_SpecialSilent :
      strcpy(sz,"SilMv");
      break;
    case  VL_SpecialVersion :
      strcpy(sz,"Spec.");
      break;
    case  VL_Unknown :
    default :
      strcpy(sz,"?    ");
      break;
    }
  return sz;
  }

int ExtractValue_VersionLanguage(char *sz, version_language *pu,
     char **pszNext)
  {
  if (!sz)
    {
    *pu=VL_Unknown;
    return FAILURE;
    }
  char *szNext=NULL;
  char *szCompacted=(char *)malloc(strlen(sz)+1);
  RemoveSeparators(sz,szCompacted);
  int f=SUCCES;
  if (!strcmpi(szCompacted,"VONST"))
    {
    *pu=VL_VONoST;
    szNext=strchri(sz,'t');
    }
  else if (!strcmpi(szCompacted,"VF"))
    {
    *pu=VL_VF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"VOSTF"))
    {
    *pu=VL_VOSTF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"VOtherSTF"))
    {
    *pu=VL_VOtherLangageSTF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"SpecialSilent"))
    {
    *pu=VL_SpecialSilent;
    szNext=strchri(sz,'t');
    }
  else if (!strcmpi(szCompacted,"SpecialVersion"))
    {
    *pu=VL_SpecialVersion;
    szNext=strchri(sz,'n');
    }
  else if (!strcmpi(szCompacted,"unknown"))
    {
    *pu=VL_Unknown;
    szNext=strchri(sz,'w')+1;
    }
  else
    {
    *pu=VL_Unknown;
    szNext=NULL;
    f=FAILURE;
    }
  free(szCompacted);
  if (f && !szNext)
    f=FAILURE;
  if (f)
    {
    szNext=NextNotSpaceSeparator(szNext+1);
    if (szNext) // Exist unspace separator otherwise, szNext=NULL
      szNext++;
    }
  if (pszNext)
    *pszNext=szNext;
  return f;
  }
int SplitEpisodeNumber(char *szNumber, char * /*szShortSeries */,
    int *piLocalNumber,
    int *piPhysicalNumber, int *piSeasonNumber)
  {
  int ai[2];
//  TPoint pt;
  *piPhysicalNumber=*piLocalNumber=*piSeasonNumber=INT_MIN;
  if (GetIntegerList(szNumber,ai,2)==2)
    {
    *piSeasonNumber=ai[0];*piLocalNumber=ai[1];
    return SUCCESS;
    }
  else if (ExtractValue(szNumber,piPhysicalNumber))
    return SUCCESS;
  else
    return FAILURE;
  }


