#define MODULE_NAME "MOULINEX.CPP"
#include "baptiall.h"
#include "filutil.h"
#include "strtool.h"
#include "moulinex.h"
#include "sysctr.h"

/////// Constantes du programme
////////*              Variables du programme          */
////////*/*              Fonctions prototypes            */
/*        Dbut de la procdure principale du programme        */

/* Choix d'une phrase dans le fichier source et affichage de cette phrase. */
int iUserArguments;
char **aszUserArguments;
int IsPossibleSource(char *szFile);

int IsPossibleSource(char *szFile)
  {
  return !access(szFile,04); // source exist
  }

int IsPossibleTarget(char *szFile)
  {
  if (!access(szFile,02)) // Writable
    return SUCCES;
  else if (!access(szFile,00)) // Exist without writing
    return FAILURE;
  else // Does not exist
    {
    FILE *pfilTry=fopen(szFile,"wt");
    if (!pfilTry) // Impossible target creation
      return FALSE;
    else
      {
      fclose(pfilTry);
      unlink(szFile);
      return TRUE;
      }
    }
  }

int Moulinette(int argc, char *argv[],
    int (*fMoulinette)(char *,char *,char *), unsigned int wOptions)
  {
  iUserArguments=argc;
  aszUserArguments=argv;
  char *szSource=NULL, *szTarget=NULL;

  if (argc==1)
    {
    if ((wOptions & MLX_AcceptNoSource) && (wOptions & MLX_AcceptNoTarget))
      {szSource=NULL; szTarget=NULL;}
    else
      {
      Erreur("Missing arguments");
      return !Erreur(szHelpMessage);
      }
    }
  else if (argc==2) // src ou target (defaut: src)
    {
    if (IsPossibleSource(argv[1]))
      {
      szSource=argv[1];
      szTarget=NULL;
      }
    else if (IsPossibleTarget(argv[1])) // Maybe the arg is target: test for file creation
      {
      szSource=NULL;
      szTarget=argv[1];
      }
    else
      {
      szSource=NULL;
      szTarget=NULL;
      }

    if (!szSource && !(wOptions & MLX_AcceptNoSource))
      return Erreur("Wrong source file. You asked : ",argv[1],28);

    if (!szTarget && !szSource && !(wOptions & MLX_AcceptNoSource))
      return Erreur("Wrong target file. You asked : ",argv[1],78);

    if (!szTarget && !szSource && !(wOptions & MLX_AcceptNoTarget))
      return Erreur("Too many not-file arguments. You asked : ",argv[1],78);
    }
  else if (argc>=3) // src ou target (defaut: src)
    {
    if (IsPossibleSource(argv[1]))
      {
      szSource=argv[1];
      if (IsPossibleTarget(argv[2]))
	 {
	 szTarget=argv[2];
	 }
      else // Source, No Target
	{
	if (!szTarget && !szSource && !(wOptions & MLX_AcceptNoSource))
	  return Erreur("Wrong target file. You asked : ",argv[1],78);
	}
      }
    else  // No source
      {
      szSource=NULL;
      if (!(wOptions & MLX_AcceptNoSource))
	return Erreur("Wrong source file. You asked : ",argv[1],28);
      if (IsPossibleTarget(argv[1]))
	 {
	 szTarget=argv[1];
	 }
      else // No Target, No source
	{
	if (!szTarget && !szSource && !(wOptions & MLX_AcceptNoSource))
	  return Erreur("Wrong target file. You asked : ",argv[1],78);
	}
      }
    if (argc > 3 && !(wOptions & MLX_AcceptMoreArguments)) // Spurrious args
      return MErreur("Too many arguments.",105);
    if ((!szSource || !szTarget) && !(wOptions & MLX_AcceptMoreArguments)) // Spurrious args
      return MErreur("Too many not-file arguments.",107);
    }

  if (szTarget && !(wOptions & MLX_NoCleanUpTarget)) // Clean target (erase) before processing.
    {
    if (!access(szTarget,02)) // Writable
      unlink(szTarget);
    if (!access(szTarget,00)) // Readable
      return Erreur("Unable to write on target file : ",szTarget,115);
    }
  if (!szSource)
    szSource="";
  if (!szTarget)
    szTarget="";
  return fMoulinette(szSource,szTarget,argc>=4?argv[3]:NULL);
  }



