#define MODULE_NAME "nitentit"
/////////////////////////////////////////////////////////////////
//                    N I T R A T E   . C P P
/////////////////////////////////////////////////////////////////
//    Fonction       :
/////////////////////////////////////////////////////////////////
//    Auteur         :  Baptiste Marcel (marce@len7.enseeiht.fr)
//        Written in Toulouse, France
//        All rights copyrighted
//    Cr le        : fin septembre 1996
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Headers
/////////////////////////////////////////////////////////////////
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>


#include "base.h"
#include "filutil.h"
//#include "scaltool.h"
#include "scaltool.h"
#include "stdio.h"
#include "strtool.h"
#include "strutil.h"
#include "sysctr.h"

#include "dnitrate.h"

#include "nitbasis.h"

void LoadEditors(char *szOldKey, char *szNewKey); // Special.
int CompleteTheVideonStartingWith(char *szBuffer, char *szVideonFile,
    unsigned int wLen);

/////////////////////////////////////////////////////////////////
//                   Constantes du programme
/////////////////////////////////////////////////////////////////
int iLastTape=0;
unsigned char uLabeledWidth;

char szDefaultFile[MAXPATH]=".\\datas.nit";
char szTapeFile[MAXPATH]=".\\tapes.nit";
char szVideonFile[MAXPATH]=".\\videons.nit";
char szRecordFile[MAXPATH]=".\\records.nit";
char szSeriesFile[MAXPATH]=".\\series.nit";

/////////////////////////////////////////////////////////////////
//                   Small classes (declarations)
//                   Structures
/////////////////////////////////////////////////////////////////
has_been_seen hsbNull={0,qC,VL_Unknown};
/////////////////////////////////////////////////////////////////
//                   Global variables
/////////////////////////////////////////////////////////////////

//TSeriesList *pInstancedSeriesList=new TSeriesList;
record_number iIterRecordCounter=0;
/////////////////////////////////////////////////////////////////
//                   Variables externes                        //
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Fonctions prototypes                      //
/////////////////////////////////////////////////////////////////
inline SizeOfOutput(has_been_seen &)
  {
  return STRLEN_HasBeenSeen;
  }


int SplitDocumentKey(char *sz, videon_gender *peGender,
    char *szTitle, unsigned int wLen, unsigned int *pwYear);
int SplitEpisodeTitle(char *szTitle, char *szShortSeries, char *szNumber,
    char **acTitleAddress);
int SplitEpisodeNumber(char *szNumber, char *szShortSeries, int *piLocalNumber,
    int *piPhysicalNumber, int *piSeasonNumber);
void IterAllRecordsExist(TPoint &recKey, void *pArg);
void IterLinkRecordTowardVideon(TPoint &rk, void *pArg);
//int LinkRecordTowardVideon(record_key rk, char *szVideon); // Notify the videon of the record the link to the record.
int LinkRecordTowardTape(tape_number iOldTape, record_number iNumber, tape_number iNewTape);
// Notify the videon of the record the link to the record.
//int ExistEntityInEditors(char *szKey, TEntityEdit *ExceptMe=NULL);
int LinkTapeTowardRecord(tape_number iTape, record_key rkOld, record_key rkNew); // Notify the tape the link to it
int LinkVideonTowardRecord(char *szVideon, record_key rkOld, record_key rkNew);

//int IterRecordKeyEquals(const TPoint &rk, void *pArg);
void IterCopy2StaticArray(int &i, void *pArg);
void IterLinkRecordTowardTape(TPoint &recKey, void *pArg);

int LinkRecordTowardVideon(record_key rk, char *szVideon); // Notify the videon of the record t0 link to the record.


/*
videon_gender GetPrivateGender(char *szSection,char *szEntry,
    videon_gender eDefault, char *szFileName);
int WritePrivateGender(char *szSection,char *szEntry,
    videon_gender eValue, char *szFileName);
*/
/*
videon_gender GetPrivateGender(char *szSection,char *szEntry,
    videon_gender eDefault, char *szFileName)
  {
  return GetPrivateItem(szSection,szEntry,eDefault,szFileName);
  }
int WritePrivateGender(char *szSection,char *szEntry,
    videon_gender eValue, char *szFileName)
  {
  return WritePrivateItem(szSection,szEntry,eValue,szFileName);
  }
*/
quality GetPrivateQuality(char *szSection,char *szEntry,
    quality cDefault, char *szFileName);
int WritePrivateQuality(char *szSection,char *szEntry,
    quality cValue, char *szFileName);

/////////////////////////////////////////////////////////////////
//                   Small classes (bodies)                    //
/////////////////////////////////////////////////////////////////
////Keys/////////////////////////////////////////////////////////
////TEntity//////////////////////////////////////////////////////
int TEntity::IsDeletionCode(){return FALSE;}
TEntity::TEntity()
  {
  }
void TEntity::Reset() // Set the fields to 0.
  {
  }
int TEntity::Load(char *szKey, char *szFile) // Load from database.
  { // virtual function.
  return !!szKey && !!szFile;
  }
int TEntity::CallLoad(char *szKey)
  {
  return !!Load(szKey,StoringFile());  // Ask virtual function
  }
int TEntity::Reload()
  {
  char sz[STRLEN_Key];
  return BuildStringKey(sz,STRLEN_Key) && CallLoad(sz);
  }
int TEntity::CallSave(char *szOldKey, char *szKnownKey)
// Parameter szNewKey is optional (default set to NULL)
// strlen(szOldKey)=0 means that the object did not exist before.
// szKnownKey==NULL means that the key has to be calculated;
// *szKnownKey==0 means that the object need just to be destroyed from the database
  {
  char *szNewKey;
  int f;
  if (szKnownKey) // Usuer gave the key
    szNewKey=szKnownKey;
  else // szKnownKey==NULL
    {
    szNewKey=(char *) malloc (STRLEN_Key);
    BuildStringKey(szNewKey,STRLEN_Key); // Programmer did not give the key
    }
  char *szFile=StoringFile();
  unsigned int wMode=0;
  wMode |= strlen(szOldKey)?ES_OldExist:0;
  wMode |= strlen(szNewKey)?ES_NewExist:0;
  wMode |= (strlen(szOldKey)
         && strlen(szNewKey)
         && strcmpi(szOldKey,szNewKey))? ES_ChangeKey:0;

  int f0= !access(szFile, 06);
  int f1= szOldKey && szNewKey;
//      Save(szOldKey,szNewKey,szFile,wMode);//  wMode may contain ES_ChangeKey=1, ES_OldExist, ES_NewExist
  f= f0 && f1 &&
      Save(szOldKey,szNewKey,szFile,wMode);//  wMode may contain ES_ChangeKey=1, ES_OldExist, ES_NewExist
  if (!szKnownKey)
    free(szNewKey);
  return !!f;
  }
int TEntity::IsConsistant(char */*sz*/, unsigned int /*wLen*/)
  {
  return SUCCESS;
  }
int TEntity::CheckExistence()
  {
  char sz[STRLEN_Key];
  BuildStringKey(sz,STRLEN_Key);
  return CheckExistence(sz);
  }
int TEntity::CheckExistence(char *sz)
  {
  return ExistSection(sz,StoringFile());
  }
int TEntity::Save(char *szOldKey, char * szNewKey, char *szFile, unsigned int wMode)
  {
/*  if (!IsConsistant())
    return MErreur("Not saved: Entity not consistant");
  else */
//  *pfChangeKey=!strcmpi(szOldKey,szNewKey);
//  Trace ("TEntitySave, szOldKey ",szOldKey,804);
//  Trace ("TEntitySave, szNewKey ",szNewKey,805);

  // TmpCopyIniFile(StoringFile());

//  void *pArg[2]={(void *)szOldKey,(void *)szNewKey};
//  EditorList.ForEach(fEditorListLoadCaller,pArg);
  LoadEditors(szOldKey,szNewKey);
  if (((wMode & ES_ChangeKey) && (wMode & ES_OldExist)) || !(wMode & ES_NewExist))
    return RemovePrivateSection(szOldKey,szFile);
  else return SUCCES;
  }
int TEntity::BuildStringKey(char *szKey, unsigned int wLen)
  {
  if (szKey && wLen)
    {
    *szKey=0;
    return SUCCESS;
    }
  else
    return FAILURE;
  }
char *TEntity::StoringFile()
  {
  return szDefaultFile;
  }
int SplitDocumentKey(char *sz, videon_gender *peGender,
    char *szTitle, unsigned int wLen, unsigned int *pwYear)
  {
  char *pcSep;
  if (!sz)
    return FALSE;
  else
    pcSep=strchr(sz,'|');
  int fRes=TRUE;
  if (!pcSep)
    return FALSE;
  else
    {
    *pcSep=0;
    fRes=fRes && ExtractValue(sz,peGender);
    *pcSep='|';
    }
  sz=pcSep+1;
  pcSep=strchr(sz,'|');
  if (!pcSep)
    return FALSE;
  else
    {
    *pcSep=0;
    strNcpy(szTitle,sz,wLen);
    *pcSep='|';
    }
  return fRes && ExtractValue(pcSep+1,pwYear);
  }
void IterLinkRecordTowardVideon(TPoint &rk, void *pArg)
  {
  LinkRecordTowardVideon(rk,(char *)pArg);
  }
char LessPrecise(lenght_precision cA,lenght_precision cB)
  {
  switch (cA)
    {
    case PREC_UNKNOWN:
      return PREC_UNKNOWN;
    case ESTIMO:
      return cB==PREC_UNKNOWN?PREC_UNKNOWN:ESTIMO;
    case MESURO:
      return (cB==PREC_UNKNOWN || cB==ESTIMO)?cB:MESURO;
    case CHRONO:
      return cB;
    default:
      return PREC_UNKNOWN;
    }
  }
  ////TRecord//////////////////////////////////////////////////////
      // Check and correct mesures for coherence.
int TRecord::IsDeletionCode()
  {
/*  int i= !iNumber && !iTape && !strcmpi(szVideon,"spc");
  int ii= (mesRelPos+mesAbsPos+mesRelLen+mesAbsLen)==mesNul); */
  return !iNumber && !iTape; // && !strcmpi(szVideon,"spc") && (mesRelPos+mesAbsPos+mesRelLen+mesAbsLen)<=mesNul;
  }
void TRecord::HarmonizePositions(
    int fTwistedRelLen, int fTwistedAbsLen,
    int fTwistedRelPos, int fTwistedAbsPos)
  {
  if (mesRelPos!=mesAbsPos)
    {
    if (mesRelPos==mesNul)
      {
      mesRelPos=mesAbsPos;
      fTwistedRelPos=fTwistedAbsPos;
      }
    else if (mesAbsPos==mesNul)
      {
      mesAbsPos=mesRelPos;
      fTwistedAbsPos=fTwistedRelPos;
      }
    }
  if (mesRelLen!=mesAbsLen)
    {
    if (mesRelLen==mesNul)
      {
      mesRelLen=mesAbsLen;
      fTwistedRelLen=fTwistedAbsLen;
      }
    else if (mesAbsLen==mesNul)
      {
      mesAbsLen=mesRelLen;
      fTwistedAbsLen=fTwistedRelLen;
      }
    }
  if (!fTwistedRelPos && fTwistedRelLen && mesRelLen.wT>mesRelPos.wT) // mesRelLen is in fact the ending address and not the lenght
    mesRelLen=mesRelLen -mesRelPos;
  if (!fTwistedAbsPos && fTwistedAbsLen && mesAbsLen.wT>mesAbsPos.wT) // mesAbsLen is in fact the ending address and not the lenght
    mesAbsLen=mesAbsLen-mesAbsPos;
  if (fTwistedRelPos && !fTwistedRelLen && mesRelPos.wT>mesRelLen.wT) // mesRelLen is in fact the ending address and not the lenght
    mesRelPos=mesRelPos-mesRelLen;
  if (fTwistedAbsPos && !fTwistedAbsLen && mesAbsPos.wT>mesAbsLen.wT) // mesAbsLen is in fact the ending address and not the lenght
    mesAbsPos=mesAbsPos-mesAbsLen;
  }


void TRecord::Reset() // Set the fields to 0.
  {
  TEntity::Reset();
  iNumber=0;
  iTape=0;
  mesRelPos=mesNul;
  mesAbsPos=mesNul;
  mesRelLen=mesNul;
  mesAbsLen=mesNul;
  SetString(&szVideon);
  SetString(&szNote);
  }
TRecord::TRecord(tape_key iTape_in, record_number iNumber_in,
        TMesure mesRelPos_in, TMesure mesAbsPos_in, TMesure mesRelLen_in,
        TMesure mesAbsLen_in):TEntity()
  {
  iNumber=iNumber_in;
  iTape=iTape_in;
  mesRelPos=mesRelPos_in;
  mesAbsPos=mesAbsPos_in;
  mesRelLen=mesRelLen_in;
  mesAbsLen=mesAbsLen_in;
  szVideon=NULL;
  szNote=NULL;
  }
TRecord::TRecord(TPoint pt, /*tape_key iTape_in, record_number iNumber_in */
        TMesure mesRelPos_in, TMesure mesAbsPos_in, TMesure mesRelLen_in,
        TMesure mesAbsLen_in):TEntity()
  {
  iNumber=pt.x; //iNumber_in;
  iTape=pt.y; //iTape_in;
  mesRelPos=mesRelPos_in;
  mesAbsPos=mesAbsPos_in;
  mesRelLen=mesRelLen_in;
  mesAbsLen=mesAbsLen_in;
  szVideon=NULL;
  szNote=NULL;
  }
TRecord::~TRecord()
  {
  if (szVideon)
    free(szVideon);
  if (szNote)
    free(szNote);
  }

int TRecord::Save(char *szOldKey, char *szNewKey, char *szFile, unsigned int wMode)
  {
/*  if (!TTape(iTape).CheckExistence())
    return MErreur("Not saved. The tape does not exist or is not consistant, you asked: ",iTape,899);
  else if (!TVideon().CheckExistence(szVideon))
    return MErreur("Not saved. The videon does not exist or is not consistent, you asked: ",szVideon,901); */
   // Member of TRecord.
//  int fChangeKey=FALSE;
  int fRes=SUCCES; // Say if the key has changed
// Save fields
  if (wMode & ES_NewExist)
    {
#if _Windows
    Hook(szFile);
#endif
         fRes=/*WritePrivateInt(szNewKey,"N",iNumber,szFile) &&*/
         WritePrivateMesure(szNewKey,"R@",mesRelPos,szFile) &&
         WritePrivateMesure(szNewKey,"A@",mesAbsPos,szFile) &&
         WritePrivateMesure(szNewKey,"R/",mesRelLen,szFile) &&
         WritePrivateMesure(szNewKey,"A/",mesAbsLen,szFile) &&
         WritePrivateString(szNewKey,"N",szNote?szNote:"",szFile);
#if _Windows
    UnHook(szFile);
#endif
    }
// Save links: object
  record_key rkOldRecordKey=(wMode & ES_OldExist)?
      String2RecordKey(szOldKey):record_key(0,0),
             rkCurrRecordKey=(wMode & ES_NewExist)?
      record_key(iTape,iNumber):record_key(0,0);
  char szOldVideon[STRLEN_VideonKey];
  if (wMode & ES_OldExist)
    GetPrivateString(szOldKey,"O","",szOldVideon,STRLEN_VideonKey,szFile);
  else
    *szOldVideon=0;
  int fVoidRecord=!strcmpi(szVideon,"nul") || !strcmpi(szVideon,"spc");
  if (strcmpi(szOldVideon,szVideon)) // They are different
    {
    if (wMode & ES_NewExist)
      {
      fRes=fRes && WritePrivateString(szNewKey,"O",szVideon,szFile);
// Newby
      if (!fVoidRecord) LinkVideonTowardRecord(szVideon,record_key(0,0),rkCurrRecordKey); // Set link from new videon
      }
// Losty
    if ((wMode & ES_OldExist) && !fVoidRecord)
      LinkVideonTowardRecord(szOldVideon,rkOldRecordKey,record_key(0,0)); // Cut link from old videon
    }
  else // Objects are the same
    {
    if (wMode & ES_ChangeKey)
      {
      if (wMode & ES_NewExist) fRes=fRes && WritePrivateString(szNewKey,"O",szVideon,szFile);  // This means coherence verification.
      LinkVideonTowardRecord(szOldVideon,rkOldRecordKey,rkCurrRecordKey); // Cut link from old videon
      }
    if (!(wMode & ES_NewExist))
      LinkVideonTowardRecord(szOldVideon,rkOldRecordKey,record_key(0,0)); // Cut link from old videon
    }
// Save links: tape
  tape_number iOldTape=0;
  if (wMode & ES_OldExist)
     ExtractValue(szOldKey,&iOldTape);
      /*GetPrivateInt(szOldKey,"tape",0,szFile)*/;
  tape_number iCurrTape=(wMode & ES_NewExist)?iTape:0;
  if (iOldTape!=iCurrTape) // They are different
    {
    if (wMode & ES_NewExist)
      {
//      fRes=fRes && WritePrivateInt(szNewKey,"tape",iCurrTape,szFile);
// Newby
      LinkTapeTowardRecord(iCurrTape,record_key(0,0),rkCurrRecordKey); // Set link from new tape
      }
// Losty
    if (wMode && ES_OldExist) LinkTapeTowardRecord(iOldTape,rkOldRecordKey,record_key(0,0)); // Cut link from old tape
    }
  else // tapes are the same
    {
    if (wMode & ES_ChangeKey)
      {
//      if (wMode & ES_NewExist) fRes=fRes && WritePrivateInt(szNewKey,"tape",iCurrTape,szFile);  // This means coherence verification.
      LinkTapeTowardRecord(iOldTape,rkOldRecordKey,rkCurrRecordKey); // Cut link from old tape
      }
    }

  return fRes && TEntity::Save(szOldKey,szNewKey,szFile,wMode);
  }
int TRecord::Load(char *szKey, char *szFile)
  {
  if (TEntity::Load(szKey,szFile))
    {
    record_key rk=String2Point(szKey);
    iTape=rk.x;//GetPrivateInt(szKey,"tape",0,szFile);
    iNumber=rk.y;//GetPrivateInt(szKey,"N",0,szFile);
    char sz[STRLEN_Key];
    GetPrivateString(szKey,"O","",sz,STRLEN_Key,szFile);
    SetString(&szVideon,sz);
    GetPrivateString(szKey,"N","",sz,STRLEN_Key,szFile);
    SetString(&szNote,sz);

    mesRelPos=GetPrivateMesure(szKey,"R@",mesNul,szFile);
    mesAbsPos=GetPrivateMesure(szKey,"A@",mesNul,szFile);
    mesRelLen=GetPrivateMesure(szKey,"R/",mesNul,szFile);
    mesAbsLen=GetPrivateMesure(szKey,"A/",mesNul,szFile);
    return SUCCESS;
    }
  else
    return ECHEC;
  }

int TRecord::IsConsistant(char *sz, unsigned int wLen)
  {
  if (!TEntity::IsConsistant(sz,wLen))
    return FAILURE;
/*  else if IsDeletionRecord()
    return TRUE;*/
  else if (iNumber<=0)
    return !strNcat(sz,"Number out of range\n",wLen);
  else if (!TTape(iTape).CheckExistence())
    return !strNcat(sz,"Tape does not exist\n",wLen);
  else if (!szVideon || (strcmpi(szVideon,"nul") && !TVideon().CheckExistence(szVideon)))
    return !strNcat(sz,"Videon does not exist\n",wLen);
  else return SUCCESS;
  }
char *TRecord::StoringFile()
  {
  return szRecordFile;
  }
char *TSeries::StoringFile()
  {
  return szSeriesFile;
  }
int TRecord::BuildStringKey(char *szKey, unsigned int )
  {
  record_key key(iTape,iNumber);
  RecordKey2String(key,szKey);
  return SUCCESS;
  }
int InterpretKey(char *szBuffer,unsigned int wLen, videon_gender e) // Ask for the key
  {
  char szGender[STRLEN_Gender];
  if (! (e == UNKNOWN) && strncmpi(szBuffer,"ser|",4) &&
      strncmpi(szBuffer,"doc|",4) && strcmpi(szBuffer,"spc") && strcmpi(szBuffer,"nul") &&
      strcmpi(szBuffer,"def") && strncmpi(szBuffer,"eps|",4)) // the key does not begin with "doc|" (real key or is _cancel_)
    {
    char *szTmpBuff=(char *)malloc(strlen(szBuffer)+5);
    sprintf(szTmpBuff,"%s|%s",
        Item2String(e,szGender,sizeof(szGender)),szBuffer);
    strNcpy(szBuffer,szTmpBuff,wLen);
    free(szTmpBuff);
    }
  if (!strncmpi(szBuffer,"ser|",4))
    return CompleteTheVideonStartingWith(szBuffer,szSeriesFile,wLen);
  else
    return CompleteTheVideonStartingWith(szBuffer,szVideonFile,wLen);

  }
int CompleteTheVideonStartingWith(char *szStart, char *szVideonFile,
    unsigned int wLen)
  {
  FILE *pfil=fopen(szVideonFile,"rt");
  if (!pfil)
    return FAILURE;
  char *szStartKey=(char *)malloc(strlen(szStart)+2);
  sprintf(szStartKey,"[%s",szStart);
  char *szFound=(char *)malloc(wLen+2);

  char *pcRes=fGetLineContaining(pfil, szFound, wLen+2, szStartKey);
  if (pcRes)
    {
    char *pc=strchr(szFound,']');
    if (pc) *pc=0;
    strNcpy(szStart,szFound+1,wLen);
    }
  free(szFound);
  free(szStartKey);
  fclose(pfil);
  return !!pcRes;
  }
int LinkVideonTowardRecord(char *szVideon, record_key rkOld, record_key rkNew) // Notify the videon of the record the link to the record.
  {
  TPointList L;
  TVideon t;
  GetPrivateRecordList(szVideon,"rk",&L,t.StoringFile());
  if (rkOld.x || rkOld.y) L.Detach(rkOld);
  if (rkNew.x && rkNew.y) L.Add(rkNew);
  WritePrivateRecordList(szVideon,"rk",&L,t.StoringFile());
//  void *pArg[2]={(void *)szVideon,(void *)szVideon};
//  EditorList.ForEach(fEditorListLoadCaller,pArg);
  LoadEditors(szVideon,szVideon);
  return SUCCESS;
  }
int LinkRecordTowardVideon(record_key rk, char *szVideon) // Notify the videon of the record the link to the record.
  {
  char szRecordKey[STRLEN_RecordKey], szOldVideon[STRLEN_VideonKey];
  GetPrivateString(RecordKey2String(rk,szRecordKey),"O","",szOldVideon,sizeof(szOldVideon),TRecord().StoringFile());
  if (*szOldVideon)
    LinkVideonTowardRecord(szOldVideon, rk, record_key(0,0)); // Notify the videon of the record the link to no record.
  WritePrivateString(szRecordKey,"O",*szVideon?szVideon:"nul",TRecord().StoringFile());
  if (! *szVideon) // Deletion of the videon => deletion of the record

//  void *pArg[2]={(void *)szRecordKey,(void *)szRecordKey};
//  EditorList.ForEach(fEditorListLoadCaller,pArg);
  LoadEditors(szRecordKey,szRecordKey);
  return SUCCESS;
  }
void IterAllRecordsExist(TPoint &recKey, void *pArg)
  {
  *((int *)pArg)=TRecord(recKey.x,recKey.y).CheckExistence();
  }
void IterLinkRecordTowardTape(TPoint &recKey, void *pArg)
  {
  LinkRecordTowardTape(recKey.x, recKey.y, *((int *)pArg));
  }
int LinkRecordTowardTape(tape_number iOldTape, record_number iNumber,
    tape_number iNewTape)
  {
  TRecord rec;

//  tape_number iOldTape=GetPrivateInt(szOldRecordKey,"tape",0,rec.StoringFile());
//  rec.iTape=iTape;
//  rec.Erase(szOldRecordKey);
  record_key rkOld(iOldTape,iNumber), rkNew(iNewTape,iNumber);
  char szOld[STRLEN_RecordKey],szNew[STRLEN_RecordKey];
  RecordKey2String(rkOld,szOld);
  RecordKey2String(rkNew,szNew);

  char szVideon[STRLEN_VideonKey];
  GetPrivateString(szOld,"O","",szVideon,sizeof(szVideon),rec.StoringFile());
  if (iNewTape)
    {
    ChangePrivateSectionName(szOld,szNew,rec.StoringFile());
//    WritePrivateInt(szNew,"tape",iNewTape,rec.StoringFile());
    }
  else  // Cut link from previous tape => no tape => record goes to trash.
    RemovePrivateSection(szOld,rec.StoringFile());
//  rec.CallSave(szNewRecordKey);
  LinkVideonTowardRecord(szVideon,rkOld,rkNew);
  LinkTapeTowardRecord(iNewTape,rkOld,rkNew); // Returns back in the tape after change of the key.
//  void *pArg[2]={(void *)szOld,(void *)szNew};
//  EditorList.ForEach(fEditorListLoadCaller,pArg);
  LoadEditors(szOld,szNew);
  return SUCCESS;
  }
// Go in the specified tape. Change remove rkOld if consistant, add rkNew if consistant.
int LinkTapeTowardRecord(tape_number iTape, record_key rkOld, record_key rkNew) // Notify the tape the link to it
  {
  TPointList L;
  TTape t(iTape); char szTapeKey[STRLEN_TapeKey];
  t.BuildStringKey(szTapeKey,STRLEN_TapeKey);
  GetPrivateRecordList(szTapeKey,"rk",&L,t.StoringFile());
  if (rkOld.x || rkOld.y) L.Detach(rkOld);
  if (rkNew.x && rkNew.y) L.Add(rkNew);
  WritePrivateRecordList(szTapeKey,"rk",&L,t.StoringFile());
//  void *pArg[2]={(void *)szTapeKey,(void *)szTapeKey};
//  EditorList.ForEach(fEditorListLoadCaller,pArg);
  LoadEditors(szTapeKey,szTapeKey);
  return SUCCESS;
  }
/////////////////////////////////////////////////////////////////
//                   Free functions (local)                    //
/////////////////////////////////////////////////////////////////
////File accesses////////////////////////////////////////////////
////Videon gender////////////////////////////////////////////////

quality GetPrivateQuality(char *szSection,char *szEntry,
    quality cDefault, char *szFileName)
  {
  char szValue[STRLEN_Quality];
  char szDefaultValue[STRLEN_Quality];
  GetPrivateString(szSection,szEntry,
      Quality2String(cDefault,szDefaultValue),szValue,
      STRLEN_Quality,szFileName);
  quality c;
  if (String2QualityEF(szValue,&c))
    return c;
  else
    return cDefault;
  }
int WritePrivateQuality(char *szSection,char *szEntry,
    quality cValue, char *szFileName)
  {
  char szValue[STRLEN_Quality];
  return WritePrivateString(szSection,szEntry,
      Quality2String(cValue,szValue),szFileName);

  }
/*
int _WritePrivateGender(char *szSection,char *szEntry,
    videon_gender eValue, char *szFileName)
  {
  char szValue[STRLEN_Gender];
//  Trace("Backup after writing gender of ",szSection,2156);
//  Trace("entry: ",szEntry,2165);
  int fRes= WritePrivateString(szSection,szEntry,
      Item2String(eValue,szValue, STRLEN_Gender),szFileName);
  // TmpCopyIniFile(szFileName);
//  Trace("-------------------fRes=",fRes,2169);
  return !!fRes;
  }
videon_gender _GetPrivateGender(char *szSection,char *szEntry,
    videon_gender eDefault, char *szFileName)
  {
  char szValue[STRLEN_Gender];
  char szDefaultValue[STRLEN_Gender];
  GetPrivateString(szSection,szEntry,
      Item2String(eDefault,szDefaultValue,STRLEN_Gender),szValue,
      STRLEN_Gender,szFileName);
  videon_gender e;
  if (ExtractValue(szValue,&e))
    return e;
  else
    return eDefault;
  }
*/
////Record///////////////////////////////////////////////////////
/*  {
  char szKey[STRLEN_RecordKey];
  char szDefaultKey[STRLEN_RecordKey];
  GetPrivateString(szSection,szEntry,
      RecordKey2String(kDefault,szDefaultKey),szKey, STRLEN_RecordKey,szFileName);
  record_key rk;
  if (String2RecordKeyEF(szKey, &rk))
    return rk;
  else
    return kDefault;
  }
int WritePrivateRecordKey(char *szSection,char *szEntry,
    record_key key, char *szFileName)
  {
  char szKey[STRLEN_RecordKey];
  return WritePrivateString(szSection,szEntry,RecordKey2String(key,szKey), szFileName);
  }
*/


////Mesures//////////////////////////////////////////////////////
////Has been seen////////////////////////////////////////////////
/*
has_been_seen GetPrivateItem /*Seen*//*(char *szSection,char *szEntry,
    has_been_seen hbsDef, char *szFileName)
  {
  char szBuffer[STRLEN_HasBeenSeen],szBufferDef[STRLEN_HasBeenSeen];
  HasBeenSeen2String(hbsDef,szBuffer);
  GetPrivateString(szSection,szEntry,
      HasBeenSeen2String(hbsDef,szBufferDef),
      szBuffer, STRLEN_HasBeenSeen,szFileName);

  has_been_seen shbs;
  if (!ExtractValue(szBuffer,&shbs))
    return hbsDef;
  else
    return shbs;
  }
*/
/*
int WritePrivateItem /*Seen*//*(char *szSection,char *szEntry,
    has_been_seen hbs, char *szFileName)
  {
  char sz[STRLEN_HasBeenSeen];
  return WritePrivateString(szSection,szEntry,
      HasBeenSeen2String(hbs,sz),szFileName);
  }
*/
////Objects converters///////////////////////////////////////////
// Record key
/*
char *RecordKey2String(record_key key, char *sz)
  {
  wsprintf(sz,"%d:%d",key.x,key.y); //  iTape,iNumber
  return sz;
  }
*/
// Record key (in one string)
// Mesure
// Gender
int ExtractValue(char *szValue, videon_gender *pe, char **pcNext)
  {
  char szComparison[STRLEN_Gender];
  ExtractItem(szValue,szComparison,sizeof(szComparison),pcNext,acUsualSeparators);
  if (!strcmpi(szValue,Item2String(DOCUMENT,szComparison,STRLEN_Gender)))
    *pe= DOCUMENT;
  else if (!strcmpi(szValue,Item2String(SERIES,szComparison,STRLEN_Gender)))
    *pe= SERIES;
  else if (!strcmpi(szValue,Item2String(VOID_RECORD,szComparison,STRLEN_Gender)))
    *pe= VOID_RECORD;
  else if (!strcmpi(szValue,Item2String(EPISODE,szComparison,STRLEN_Gender)))
    *pe= EPISODE;
  else if (!strcmpi(szValue,Item2String(DEFECT_TAPE,szComparison,STRLEN_Gender)))
    *pe= DEFECT_TAPE;
  else if (!strcmpi(szValue,Item2String(UNKNOWN,szComparison,STRLEN_Gender)))
    *pe= UNKNOWN;
  else
    {
    *pe=UNKNOWN;
    return FAILURE;
    }
  return SUCCESS;
  }
char *Item2String(videon_gender eValue, char *szValue, unsigned int wLen)
//char *Item2String(videon_gender eValue, char *szValue, WORD wLen)
  {
  if (!szValue)
    return szValue;
  else if (wLen && wLen<STRLEN_Gender)
    {
    *szValue=0;
    return szValue;
    }
  switch (eValue)
    {
    case SERIES:
      strcpy(szValue,"ser");
      break;
    case DOCUMENT:
      strcpy(szValue,"doc");
      break;
    case VOID_RECORD:
      strcpy(szValue,"spc");
      break;
    case DEFECT_TAPE:
      strcpy(szValue,"def");
      break;
    case EPISODE:
      strcpy(szValue,"eps");
      break;
    case UNKNOWN:
    default:
      strcpy(szValue,"nul");
      break;
    }
  return szValue;
  }

// Has been seen
//char *HasBeenSeen2String(has_been_seen hsb, char *sz)
char *Item2String(has_been_seen hsb, char *sz)
  {
//  char szBuf1[STRLEN_Flag];
  char szBuf2[STRLEN_VersionLanguage];
  if (hsb.fHasBeen)
    wsprintf(sz,"yes: q%c,%s",hsb.cQ,
      ItemVersionLanguage2String(hsb.uVL,szBuf2));
  else
    *sz=0;
  return sz;
  }
//int ExtractValue(char *sz, has_been_seen *phbs)
int ExtractValue(char *sz, has_been_seen *phbs, char **pcNext)
  {
  if (!phbs)
    return FAILURE;
  else
    *phbs=hsbNull;
  char szBuffer[STRLEN_HasBeenSeen], *szNext, *szStart;
  int f=ExtractItem(sz,szBuffer,STRLEN_HasBeenSeen,&szNext,acUsualSeparators);
  int fHasBeen;
  if (!String2FlagEF(szBuffer,&fHasBeen) || !fHasBeen)
    {*phbs=hsbNull;return FAILURE;}
  else
    phbs->fHasBeen=fHasBeen;
  szStart=szNext;
  f=f && ExtractItem(szStart,szBuffer,STRLEN_HasBeenSeen,&szNext,acUsualSeparators);
  char cQ;
  if (String2QualityEF(szBuffer,&cQ))
    phbs->cQ=cQ;
  else
    {
    phbs->cQ=qC;
    f=FAILURE;
    }
  return f && ExtractValue_VersionLanguage(szNext,&(phbs->uVL),pcNext);
/*  version_language uVL;
  if (String2VersionLanguageEF(szNext,&uVL))
    phbs->uVL=uVL;
  else
    f=FAILURE;

  return f;
  */
  }

int String2QualityEF(char *sz, quality *pcQ)
  {
  if (!sz || !*sz)
    return FAILURE;
  char *szBuffer=(char *)malloc(strlen(sz)+1);
  strcpy(szBuffer,sz);
  char *szWord=AvaleEspace(szBuffer);
  CutTrailingSpaces(szWord);
  if (toupper(*szWord)=='Q')
    szWord++;
  char c=toupper(*szWord);
  int f=SUCCESS;
  if (c>=qA && c<=qC)
    f=*pcQ=c;
  else
    f=FAILURE;
  free(szBuffer);
  return f;
  }


// Version language
char *ItemVersionLanguage2String(version_language u, char *sz)
  {
  switch (u)
    {
    case  VL_VONoST :
      strcpy(sz,"V.O. nS.-T.");
      break;
    case VL_VF :
      strcpy(sz,"V.F.");
      break;
    case VL_VOSTF :
      strcpy(sz,"V.O. S.-T. F");
      break;
    case  VL_VOtherLangageSTF :
      strcpy(sz,"V.Other S.-T. F");
      break;
    case  VL_SpecialSilent :
      strcpy(sz,"Special Silent");
      break;
    case  VL_SpecialVersion :
      strcpy(sz,"Special version");
      break;
    case  VL_Unknown :
    default :
      strcpy(sz,"Unknown");
      break;
    }
  return sz;
  }

int ExtractValue_VersionLanguage(char *sz, version_language *pu,
     char **pszNext)
  {
  if (!sz)
    {
    *pu=VL_Unknown;
    return FAILURE;
    }
  char *szNext=NULL;
  char *szCompacted=(char *)malloc(strlen(sz)+1);
  RemoveSeparators(sz,szCompacted);
  int f=SUCCES;
  if (!strcmpi(szCompacted,"VONST"))
    {
    *pu=VL_VONoST;
    szNext=strchri(sz,'t');
    }
  else if (!strcmpi(szCompacted,"VF"))
    {
    *pu=VL_VF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"VOSTF"))
    {
    *pu=VL_VOSTF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"VOtherSTF"))
    {
    *pu=VL_VOtherLangageSTF;
    szNext=strchri(sz,'f');
    }
  else if (!strcmpi(szCompacted,"SpecialSilent"))
    {
    *pu=VL_SpecialSilent;
    szNext=strchri(sz,'t');
    }
  else if (!strcmpi(szCompacted,"SpecialVersion"))
    {
    *pu=VL_SpecialVersion;
    szNext=strchri(sz,'n');
    }
  else if (!strcmpi(szCompacted,"unknown"))
    {
    *pu=VL_Unknown;
    szNext=strchri(sz,'w')+1;
    }
  else
    {
    *pu=VL_Unknown;
    szNext=NULL;
    f=FAILURE;
    }
  free(szCompacted);
  if (f && !szNext)
    f=FAILURE;
  if (f)
    {
    szNext=NextNotSpaceSeparator(szNext);
    if (!szNext)
      f=FAILURE;
    else if (! *szNext)
      szNext=NULL;
    else
      szNext++;
    }
  if (pszNext)
    *pszNext=szNext;
  return f;
  }
void SetString(char **psz, TEdit *pe)
  {
  unsigned int wLen=pe->GetTextLen();
  char *szBuffer=(char *)malloc(wLen+1);
  pe->GetText(szBuffer,wLen+1);  // Bug here (24.11.96)
  SetString(psz,szBuffer);
  free(szBuffer);
  }

int SplitEpisodeTitle(char *szMetaTitle, char *szShortSeries, char *szNumber,
    char **pacTitleAddress)
  {
  int f=SUCCESS;
  char *pcNumber=strchr(szMetaTitle,'#');
  if (!pcNumber)
    {f=FAILURE;*szNumber=0;*szShortSeries=0;pcNumber=szMetaTitle-1;}
  else
    {
    *pcNumber=0;
    strNcpy(szShortSeries,szMetaTitle,STRLEN_SeriesShortName);
    *pcNumber='#';
    }
  *pacTitleAddress=strchr(pcNumber+1,'~');
  if (! *pacTitleAddress)
    {
    f=FAILURE;
    strNcpy(szNumber,pcNumber+1,STRLEN_StringNumber);
    *pacTitleAddress=strchr(szMetaTitle,0);
    }
  else
    {
    **pacTitleAddress=0;
    strNcpy(szNumber,pcNumber+1,STRLEN_StringNumber);
    **pacTitleAddress='~';
    (*pacTitleAddress)++;
    }
  return f;
  }

int SplitEpisodeNumber(char *szNumber, char * /*szShortSeries */,
    int *piLocalNumber,
    int *piPhysicalNumber, int *piSeasonNumber)
  {
  TPoint pt;
  *piPhysicalNumber=*piLocalNumber=*piSeasonNumber=INT_MIN;
  if (ExtractValue(szNumber,&pt))
    {
    *piSeasonNumber=pt.x;*piLocalNumber=pt.y;
    return SUCCESS;
    }
  else if (ExtractValue(szNumber,piPhysicalNumber))
    return SUCCESS;
  else
    return FAILURE;
  }
/*
int TEpisodeNumeration::BuildStringLabel(int iPhysicalNumber, int iLocalNumber,
      int iSeasonNumber, TDate dteDate, char *szLabel, unsigned int wLabLen)
  {
  if (fModeRepresentation & NUMER_Plain)
    sprintf(szLabel,"%d",iPhysicalNumber);
  else if (fModeRepresentation & NUMER_Season)
    sprintf(szLabel,"%d.%d",iSeasonNumber,iLocalNumber);
  else if (fModeRepresentation & NUMER_Date)
    Item2String(TDate,szLabel);
  else if (fModeRepresentation & NUMER_Specific)
    {
    char szNumerKey[STRLEN_SeriesShortName+7], szNum[STRLEN_Int];
    sprintf(szNumerKey,"%s_Numer",szSeries);
    GetPrivateString(szNumerKey,itoa(iPhysicalNumber,szNum,10),"",szLabel,wLabLen);
    }
  }

  */
