Inhib
/*******************|*******************************************/
/*                  W S T R U T I L . C                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils de travail sur caractres,       */
/*                     chanes de caractres et fichiers.      */
/*                                                             */
/* Fichier source WSTRUTIL.C.                                  */
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : printemps 1996                          */
/***************************************************************/
// Inclusions bibliothques standards
// Inclusions bibliothques Object Windows
# include <dir.h>
# include <io.h>
# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include <osl/defs.h>
#include <classlib/listimp.h>

#include "base.h"
#include "filutil.h"
#include "strutil.h"
#include "sysctr.h"
#include "wstrutil.h"
//////////////////////////////////////////////////////////////
//		       constantes locales
//////////////////////////////////////////////////////////////
// We have to use the DOS version to read big big files in Nitrate.
//////////////////////////////////////////////////////////////
//	              variables  exporter
//////////////////////////////////////////////////////////////
class T3Strings
  {
  public:
    char *sz1, *sz2, *sz3;
    inline void Free() {free(sz1);free(sz2);free(sz3);}
  };

class THooker
  {
  public:
    TListImp<T3Strings> lsszProfiles;
    char *szFileName;
    THooker();
    THooker(char *szFile);
    ~THooker();
  };
//////////////////////////////////////////////////////////////
//		       variables locales
//////////////////////////////////////////////////////////////

//TListImp<T3StringsPlusFileName> lsszPublicHookedFileList;

TListImp<THooker *> lpsPublicHooks;
//char HookedFile[MAXPATH]="";
//  FILE *pfilHookedStream;
//////////////////////////////////////////////////////////////
//              prototypes des fonctions locales
//////////////////////////////////////////////////////////////
//              prototypes des fonctions  exporter
int HookPrivateString(char *szSection, char *szEntry, char *szValue,
    THooker *pHook);
THooker *FindHooker(char *szFile);
//////////////////////////////////////////////////////////////
//              Corps des fonctions  exporter
//////////////////////////////////////////////////////////////
inline int operator ==(T3Strings left, T3Strings right)
        {return left.sz1==right.sz1 && left.sz2==right.sz2 &&
          left.sz3==right.sz3;}

// Sent all the profiles in the stream
void HookedStreamFlush(TListImp<T3Strings> *plszProfile, FILE *pflTarget);

// Sent all the profile of the given section in the stream
void HookedStreamFlush(char *szSection, TListImp<T3Strings> *plszProfile, FILE *pflTarget);

/* Say if there is a matching section, and give the matching section in
the string szSection */
int SectionMatches(char *szLine, TListImp<T3Strings> *plszProfile,
    char *szSection);
// Give (and remove) the first {entry,value} that matches the section
int EntryMatches(char *szLine, TListImp<T3Strings> *plszProfile,
    char *szSection, char *szEntry, char *szValue); // Tells if the line matches one of the given profile and says which entry.



BOOL WritePrivateString(char *szSection, char *szEntry, char *szValue,
    char *szFile)
  {
  THooker *pHooker=FindHooker(szFile);
  if (pHooker)
    return HookPrivateString(szSection,szEntry,szValue,pHooker);
  else
    {
    if (fDOSINIAccess)
      return Dos_WritePrivateString(szSection, szEntry, szValue, szFile)?1:0;
    else
      return WritePrivateProfileString(szSection, szEntry, szValue, szFile)?1:0;
    }
  }
void GetPrivateString(char *szSection,char *szEntry, char *szDefault,
    char *szBuffer, unsigned int wLen, char *szFileName)
  {
  if (fDOSINIAccess)
    Dos_GetPrivateString(szSection,szEntry, szDefault,    szBuffer, wLen, szFileName);
  else
    GetPrivateProfileString(szSection,szEntry, szDefault,
        szBuffer, wLen, szFileName);
  }
//////////////////////////////////////////////////////////////
//              Corps des fonctions locales
//////////////////////////////////////////////////////////////
int fnSplitWindowsPath(char *szWindowsDirectory_in, char *szWindowsDrive_in)
  {
  char szPlainName[MAXFILE],szExt[MAXEXT];
  char szWindowsPath[MAXPATH];
  GetWindowsDirectory(szWindowsPath,MAXPATH);
  if (FILENAME & fnsplit(szWindowsPath,szWindowsDrive_in,szWindowsDirectory_in,szPlainName,szExt))
    strcat(szWindowsDirectory_in,szPlainName);
  return SUCCESS;
  }

char *Time2String(TTime t, char *sz)
  {
  wsprintf(sz,"%d:%d'%d\"",t.Hour(),t.Minute(),t.Second());
  return sz;
  }
BOOL String2TimeEF(char *sz, TTime *p)
  {
  if (!sz || !*sz)
    {
    *p=TTime(0,0,0);
    return FAILURE;
    }

  char *szOldSeparators=acUsualSeparators,
      *szNewSeparators=(char *)malloc(7+strlen(acUsualSeparators));
  strcat(strcpy(szNewSeparators,acUsualSeparators),"hmsHMS");
  acUsualSeparators=szNewSeparators;

  unsigned int wParam[3];
  char acSeparators[3], *szIndex=sz;

  unsigned int wNblus=0;
  while (szIndex && wNblus<3)
    if (ExtractValue(szIndex,wParam+wNblus,&szIndex))
      acSeparators[wNblus++]=szIndex? *(szIndex-1) : 0;
    else
      break;
  acUsualSeparators=szOldSeparators;
  free(szNewSeparators);

  if (!wNblus)
    {
    *p=TTime(0,0,0);
    return FAILURE;
    }
  else if (wNblus==1)
    {
    if (acSeparators[0] && strchr("Hh:",acSeparators[0]))
      {
      *p=TTime(wParam[0],0,0);
      return SUCCESS;
      }
    else if (acSeparators[0] && strchr("Mm'",acSeparators[0]))
      {
      *p=TTime(0,wParam[0],0);
      return SUCCESS;
      }
    else
      {
      *p=TTime(0,0,wParam[0]);
      return SUCCESS;
      }
    }
  else if (wNblus==2)
    {
    if (acSeparators[0] && strchr("Hh:",acSeparators[0]))
      {
      *p=TTime(wParam[0],wParam[1],0);
      return SUCCESS;
      }
    else if (acSeparators[0] && strchr("Mm'",acSeparators[0]))
      {
      *p=TTime(0,wParam[0],wParam[1]);
      return SUCCESS;
      }
    else  // 1st id unknown
      {
      if (acSeparators[1] && strchr("Hh",acSeparators[1]))
        {
        *p=TTime(wParam[1],0,0);
        return FAILURE;
        }
      else if (acSeparators[1] && strchr(":Mm'",acSeparators[1]))
        {
        *p=TTime(wParam[0],wParam[1],0);
        return SUCCESS;
        }
      else
        {
        *p=TTime(0,wParam[0],wParam[1]);
        return SUCCESS;
        }
      }
    }
  else if (wNblus==3)
    {
    *p=TTime(wParam[0],wParam[1],wParam[2]);
    return SUCCES;
    }
  else return FAILURE;
  }

TTime String2TimeEF(char *sz)
  {
  TTime t;
  String2TimeEF(sz, &t);
  return t;
  }
void IterSectionMatches(T3Strings &sszProfile, void *pArg)
  {
  void **apArg=(void **)pArg;
  if (! *((int*)apArg[2]) && IsSection((char *)apArg[0],sszProfile.sz1))
    {
    *((int*)apArg[2])=TRUE;
    strNcpy((char *)apArg[1],sszProfile.sz1,STRLEN_OperatingProfile);
    }
  }

int SectionMatches(char *szLine, TListImp<T3Strings> *plszProfile,
    char *szSection)
  {
  if (!IsSection(szLine))
    return FALSE;
  else
    {
    int f=FAILURE;
    void *apArg[3]={(void *)szLine,(void *)szSection,(void *)&f};
    plszProfile->ForEach(IterSectionMatches,(void *)apArg);
    return f;
    }
  }

// Say if there is a matching section, and give the matching section
void IterEntryMatches(T3Strings &sszProfile, void *pArg)
  {
  void **apArg=(void **)pArg;
  if (! *((int*)apArg[2]) && !strcmpi(sszProfile.sz1,(char *)apArg[0])
      && !strcmpi(sszProfile.sz2,(char *)apArg[1]) )
    {
    *((int*)apArg[2])=TRUE;
    *((T3Strings *)apArg[3])=sszProfile;
    }
  }

  // Give (and remove) the first {entry,value} that matches the section
int EntryMatches(char *szLine, TListImp<T3Strings> *plszProfile,
    char *szSection, char *szEntry, char *szValue)
  {
  int f=FAILURE;
  T3Strings sszProfile;

  char *szEqualSign=strchr(szLine,'=');
  if (!szEqualSign)
    return FALSE;

  char *szShortLine=AvaleEspace(szLine); // ShortLine points on the Entry label
  *szEqualSign=0;
//               szEqualSign +1  points after the 1st '=' ie on the value.
  void *apArg[4]={(void *)szSection,(void *)szShortLine,
      (void *)&f,(void *)&sszProfile};
/*  void *apArg[5]={(void *)szLine,(void *)szSection, (void *)szEntry,
      (void *)&sszProfile,(void *)&f};*/
  plszProfile->ForEach(IterEntryMatches,(void *)apArg);
  *szEqualSign='=';
  if (f)
    {
    strNcpy(szValue,sszProfile.sz3,STRLEN_OperatingProfile);
    strNcpy(szEntry,sszProfile.sz2,STRLEN_OperatingProfile);
    sszProfile.Free();
    plszProfile->Detach(sszProfile);
    }
  return f;
  }

void IterHookedStreamFlush(T3Strings &sszProfile, void *pArg)
  {
  void **apArg=(void **)pArg;
  if (!strcmpi(sszProfile.sz1,(char *)apArg[0]))
    {

    fprintf((FILE *)apArg[1],"%s=%s\n",sszProfile.sz2,sszProfile.sz3);
//    fprintf(pfilHookedStream,"%s=%s\n",sszProfile.sz2,sszProfile.sz3);
    ((TListImp<T3Strings> *)apArg[2])->Add(sszProfile);
    }
  }

//TListImp<T3Strings> lsszSections;
void IterAllSections(T3Strings &sszProfile, void *plsszSections)
  {
  char *sz=(char *)malloc(3+strlen(sszProfile.sz1)),
    sz2[STRLEN_OperatingProfile];
  sprintf(sz,"[%s]",sszProfile.sz1);
  if (! SectionMatches(sz,(TListImp<T3Strings> *)plsszSections,sz2))
//  if (! SectionMatches(sz,&lsszSections,sz2))
    ((TListImp<T3Strings> *)plsszSections)->Add(sszProfile);
//    lsszSections.Add(sszProfile);
  free(sz);
  }
void IterDetachFrom(T3Strings &sszProfile, void *plszProfile)
  {
  sszProfile.Free();
  ((TListImp<T3Strings> *)plszProfile)->Detach(sszProfile);
  }

// Sent all the profile of the given section in the stream (de not sent the section header).
void HookedStreamFlush(char *szSection, TListImp<T3Strings> *plszProfile,
    FILE *pflTarget)
  {
  TListImp<T3Strings> lsszProcessed;
  void *apArg[3]={(void *)szSection, (void *)pflTarget,
      (void *) &lsszProcessed};
  plszProfile->ForEach(IterHookedStreamFlush,(void *)apArg);
  lsszProcessed.ForEach(IterDetachFrom,(void*)plszProfile);
  }

void IterProcessSection(T3Strings &sszProfile, void *pArg)
  {
  void **apArg=(void **)pArg;
  fprintf((FILE *)apArg[1],"[%s]\n",sszProfile.sz1);

  HookedStreamFlush(sszProfile.sz1,(TListImp<T3Strings> *)apArg[0],
      (FILE *)apArg[1]);
  }

void HookedStreamFlush(TListImp<T3Strings> *plszProfile,
    FILE *pflTarget)
  {
  TListImp<T3Strings> lsszSections;
  plszProfile->ForEach(IterAllSections,(void *)&lsszSections);
  void *apArg[2]={(void *)plszProfile,(void *)pflTarget};
  lsszSections.ForEach(IterProcessSection,(void *)apArg);
  lsszSections.Flush();
  }


////////////////////////////////////////////////

// A list of {szSection,szEntry,szValue} is given as argument
int HookedFileFlush(TListImp<T3Strings> *plszProfile, char *szFileName)
  {
  char szSource[MAXPATH];
  char szSection[STRLEN_OperatingProfile],szEntry[STRLEN_OperatingProfile],
      szValue[STRLEN_OperatingProfile];
  SetIniSourceFile(szSource,sizeof(szSource),szFileName);
  // We know exactly what file to write.
  char szTarget[MAXPATH];
  strcpy(szTarget,szSource);
  SetFileExtension(szTarget,".pre");
  /* Read the source and produce the result in PRE file.
   Then replace ini by pre.
    */
//  unsigned long dwNbChar, dwNbLine, dwNbMaxCharPerLine;
  char *szLine=NULL;
  FILE *pflSource=NULL, *pflTarget=NULL;
  if (access(szSource,06)) // Source file does not exist
    {
    pflTarget=fopen(szSource,"wt");
    if (!pflTarget)
      return FAILURE;

    HookedStreamFlush(plszProfile, pflTarget);

//    fprintf(pflSource,"[%s]\n%s=%s\n",szSection,szEntry,szValue);
//    ^^^^^^^
//    Sent all the profiles.

    fclose(pflTarget);
    return SUCCESS;
    }
  unsigned int wNbMaxCharPerLine=STRLEN_OperatingProfile;//(unsigned int)(dwNbMaxCharPerLine>65533L?65533L:dwNbMaxCharPerLine);
  szLine=(char *)malloc(wNbMaxCharPerLine);
  if (!szLine) return FAILURE;
  pflSource=fopen(szSource,"rt");
  if (!pflSource)
    {
    free (szLine);
    return FAILURE;
    }
  pflTarget=fopen(szTarget,"wt"); // File is lost if already exist.
  if (!pflTarget)
    {
    free (szLine);
    fclose(pflSource);
    return FAILURE;
    }
//  int fFound=FALSE;
  char *pcEOFMarker=fgetlaline(pflSource,wNbMaxCharPerLine,szLine);
  while (pcEOFMarker)
    if (SectionMatches(szLine,plszProfile,szSection)) // See if its match and give the name of the matching section.
//                        ^^^^^^^^^^
// If line is ONE of the profile, ie: if line matches One of the profile (and tell me which one)

      {
	// Go find the entry
      fprintf(pflTarget,"%s\n",szLine);
      pcEOFMarker=fgetlaline(pflSource,wNbMaxCharPerLine,szLine);
      while (pcEOFMarker &&
          (!IsSection(szLine) || IsSection(szLine,szSection)))
//                                                  ^^^^^^^^^
	 // Stops if it meets a section that is not the seeked section.
// One can suppress this last test: if section header is repeated,
// the value after will be ignored.
        {
	if (EntryMatches(szLine,plszProfile,szSection,szEntry,szValue)) // Tells if the line matches one of the given profile and says which entry.
          // If line matches one of the couples (section, entry)
	  fprintf(pflTarget,"%s=%s\n",szEntry,szValue);
         // ^^^^^^^
// Process the matching line and section
	else if (!IsSection(szLine))  // do not requote if it is the title of the section that was duplicated.
//                ^^^^^^^^^^^^^^^^^^^  Ignore this check (suppose always true).
	  fprintf(pflTarget,"%s\n",szLine);
	// Is stopped because end of file or new section
        pcEOFMarker=fgetlaline(pflSource,wNbMaxCharPerLine,szLine);
        }
      HookedStreamFlush(szSection, plszProfile,  pflTarget);
// This is a new section header (or end of file)
      }
    else
      {
      fprintf(pflTarget,"%s\n",szLine);
//      ^^^^^^^^ (no matching section)
      pcEOFMarker=fgetlaline(pflSource,wNbMaxCharPerLine,szLine);
      }
//  fclose(pflTarget);
//  pfilHookedStream=pflTarget;
  HookedStreamFlush(plszProfile,  pflTarget);

  fclose(pflTarget);
  fclose(pflSource);
  free(szLine);
  unlink(szSource);
  return !rename(szTarget,szSource);
  }
int HookPrivateString(char *szSection, char *szEntry, char *szValue,
    THooker *pHook)
  {
  T3Strings sszP={(char *)malloc(strlen(szSection)+1),
      (char *)malloc(strlen(szEntry)+1),
      (char *)malloc(strlen(szValue)+1)};
  strcpy(sszP.sz1,szSection);
  strcpy(sszP.sz2,szEntry);
  strcpy(sszP.sz3,szValue);
  pHook->lsszProfiles.Add(sszP);
  return SUCCESS;
  }

int IsHooked(char *szFile)
  {
  return !!FindHooker(szFile);
  }
THooker::~THooker()
  {
  free(szFileName);
  if (!lsszProfiles.IsEmpty())
    Erreur("Loss of profiles in unhooking",477);
//  delete plsszProfiles;
  }
THooker::THooker(char *szFile)
  {
//  plsszProfiles=new TListImp<T3Strings>;
  szFileName=(char *)malloc(strlen(szFile)+1);
  strcpy(szFileName,szFile);
  }

void IterFindHooker(THooker* &psHooker, void *pArgs)
  {
  void **apArg=(void **)pArgs;
  if (!strcmpi((char *)apArg[0],psHooker->szFileName))
    *((THooker **)apArg[1])= psHooker;
  }

THooker *FindHooker(char *szFile)
  {
  THooker *pHooker=NULL;
  void *apArg[2]={(void *)szFile,(void *)&pHooker};
  lpsPublicHooks.ForEach(IterFindHooker,(void *)apArg);
  return pHooker;
  }

int Hook(char *szFile)
  {
  THooker *pHooker=FindHooker(szFile);
  if (!pHooker)
    {
    THooker *pHooker=new THooker(szFile);
    lpsPublicHooks.Add(pHooker);
    return SUCCES;
    }
  else
    return Erreur("File is already hooked :",szFile,450);
//    return !!strNcpy(HookedFile,szFile,sizeof(HookedFile));
  }

int UnHook(char *szFile)
  {
  THooker *pHooker=FindHooker(szFile);
  if (!pHooker)
    return Erreur("File is not hooked :",szFile,458);
  else
    {
    lpsPublicHooks.Detach(pHooker);
    if (!pHooker->lsszProfiles.IsEmpty())
      HookedFileFlush(&(pHooker->lsszProfiles), szFile);
    delete pHooker;
    return SUCCES;
    }
  }

