#include "myowlall.h"
#include "baptiall.h"
#pragma hdrstop

/**********************************************************************/
/*                       W S Y S U T I L . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Divers utilitaires lies au systme             */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC et BM                			      	       */
/*    Dvelopp le   : 26/07/1996                                     */
/*    Dernire modif.: 06/11/1996                                     */
/**********************************************************************/
/*
//  Inclusions bibliothques standards
#include <stdio.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
#include <owl\combobox.h>
#include <owl\dc.h>
#include <owl\edit.h>
#include <owl\editfile.rh>
*/

//  Inclusions bibliothques Baptiste
#include "wsysutil.h"
#include "strtool.h"

/*-------------------------------------------------------------*/
/*		       constantes locales                      */
/*-------------------------------------------------------------*/
#define INKEY_Return   13
#define INKEY_Backward  8
#define INKEY_Tab       9

int iLargeurEcran=GetSystemMetrics(SM_CXSCREEN);
int iHauteurEcran=GetSystemMetrics(SM_CYSCREEN);
int iHauteurTitre=GetSystemMetrics(SM_CYCAPTION);
unsigned char uHauteurBordure=GetSystemMetrics(SM_CYFRAME);
unsigned char uLargeurBordure=GetSystemMetrics(SM_CXFRAME);
unsigned char uHauteurBordureFine=GetSystemMetrics(SM_CYBORDER);
unsigned char uLargeurBordureFine=GetSystemMetrics(SM_CXBORDER);
unsigned char uHauteurMenu=GetSystemMetrics(SM_CYMENU);
unsigned char uHauteurLigne=16; // Valeurs provisoires (excuter "CalculeCaracteristiquesPolice").
unsigned char uLargeurCar=8; // "CalculeCaracteristiquesPolice" est lanc dans le constructeur de TFenIris.
char far szINIFileName[MAXPATH]="tpimag.ini";

TControl *pFocusedControl=NULL; // Variable globale qui mmorise le TControl qui a actuellement le focus.

void CalculeCaracteristiquesPolice(TClientDC &dc)
  {
  TEXTMETRIC sInfoPolice;
  dc.GetTextMetrics(sInfoPolice);
  uLargeurCar=sInfoPolice.tmAveCharWidth;
  uHauteurLigne=sInfoPolice.tmHeight+sInfoPolice.tmExternalLeading;
  }

void CalculeCaracteristiquesPolice(TWindow *pwParent)
  {
  TClientDC dc(*pwParent);
  CalculeCaracteristiquesPolice(dc);
  }

//----------------------------------------------------------------------------
//						Programme TEditNumCR
//----------------------------------------------------------------------------
void TEditNumCR::SetClearValue(float xyValue)
// Metsune valeur dans la bote d'dition. Si xyValue=0.0, alors le contenu est effac (TEdit::Clear())
  {
  if (xyValue)
    SetValue(xyValue);
  else
    SetText("");// Clear() does not work !!!   :-o
  }


//----------------------------------------------------------------------------
//						Programme TWindowPrintout
//----------------------------------------------------------------------------

TWindowPrintout::TWindowPrintout(const char* title, TWindow* window)
  : TPrintout(title)
{
  Window = window;
  Scale = TRUE;
}

void
TWindowPrintout::PrintPage(int, TRect& rect, unsigned)
{
  // Conditionally scale the DC to the window so the printout will
  // resemble the window
  //
  int    prevMode;
  TSize  oldVExt, oldWExt;

  if (Scale)
  {
	 prevMode = DC->SetMapMode(MM_ISOTROPIC);
	 //TRect windowSize = Window->GetClientRect();
	 TRect windowSize = TRect(0,0,GetSystemMetrics(SM_CXSCREEN),
	 GetSystemMetrics(SM_CYSCREEN));  // Rfrence : la dimension de l'cran
	 DC->SetViewportExt(PageSize, &oldVExt);
	 DC->SetWindowExt(windowSize.Size(), &oldWExt);
	 DC->IntersectClipRect(windowSize);
	 DC->DPtoLP(rect, 2);
  }

  // Call the window to paint itself
  Window->Paint(*DC, FALSE, rect);

  // Restore changes made to the DC
  if (Scale)
	{
	 DC->SetWindowExt(oldWExt);
	 DC->SetViewportExt(oldVExt);
	 DC->SetMapMode(prevMode);
	}
}

// Do not enable page range in the print dialog since only one page is
// available to be printed
//
void
TWindowPrintout::GetDialogInfo(int& minPage, int& maxPage,
										 int& selFromPage, int& selToPage)
{
  minPage = 0;
  maxPage = 0;
  selFromPage = selToPage = 0;
}

//----------------------------------------------------------------------------
//						Programme TFramePrint
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TFramePrint, TFrameWindow)
  EV_COMMAND(CM_FILEPRINT, CmFilePrint),
  EV_COMMAND(CM_FILEPRINTERSETUP, CmFilePrinterSetup),
  EV_WM_SYSCOMMAND,
END_RESPONSE_TABLE;

TFramePrint::TFramePrint(TWindow* parent, const char* title, TModule* module)
  : TFrameWindow(parent, title, 0, FALSE, module)
{
  Printer = new TPrinter;
}

void TFramePrint::SetupWindow()
{
  TWindow::SetupWindow();
  TSystemMenu mnuSys(HWindow);
  mnuSys.AppendMenu(MF_SEPARATOR);
  mnuSys.AppendMenu(MF_STRING,CM_FILEPRINT,"&Imprimer");
//  mnuSys.AppendMenu(MF_STRING,CM_FILEPRINTERSETUP,"&Configuration Imprimante");
}

void TFramePrint::EvSysCommand(UINT cmdType,TPoint& p)
{
	switch(cmdType)
	{
	case CM_FILEPRINT : CmFilePrint();break;
	case CM_FILEPRINTERSETUP : CmFilePrinterSetup();break;
	default :TFrameWindow::EvSysCommand(cmdType,p);break;
	}
}

TFramePrint::~TFramePrint()
{
  delete Printer;
}

void
TFramePrint::CmFilePrint()          // Execute File:Print command
{
  if (Printer) {
	 TWindowPrintout printout("", this);
	 printout.SetBanding(TRUE);
	 Printer->Print(this, printout, TRUE);
  }
}

void
TFramePrint::CmFilePrinterSetup()    // Execute File:Printer-setup command
{
  if (Printer) Printer->Setup(this);
}

/*-------------------------------------------------------------*/
/*                   Nouvelle classe TEditCR                   */
// CR=carriage return
/*--Systme----------------------------------------------------*/
DEFINE_RESPONSE_TABLE1(TEditCR, TEdit)
 EV_WM_CHAR,
 EV_WM_KEYUP,
 EV_WM_GETDLGCODE,
END_RESPONSE_TABLE;

TEditCR::TEditCR(TWindow *Parent, int Id, char far *Texte, int X, int Y,
			  int W, int H, UINT Taille, BOOL Multi)
	 : TEdit(Parent, Id, Texte, X, Y, W, H, Taille, Multi)
  {
  code=Id;
  pt=Parent;
  fInhibRC=0;
  fInhibTab=0;
  }
TEditCR::TEditCR(TWindow *Parent, int Id, char far *Texte,
                 TRect rPosition, UINT Taille, BOOL Multi)
	 : TEdit(Parent, Id, Texte, rPosition.left, rPosition.top, rPosition.Width(), rPosition.Height(), Taille, Multi)
  {
  code=Id;
  pt=Parent;
  fInhibRC=0;
  }

void TEditCR::EvKeyUp(UINT key, UINT repeatCount, UINT flags)
  {
  switch(key)
    {
    case VK_RETURN :
      EvChar(key, repeatCount, flags);
      break;
    default :
      TEdit::EvKeyUp(key, repeatCount, flags);
      break;
    }
  }

void TEditCR::EvChar(UINT key, UINT repeatCount, UINT flags)
  {
  static unsigned char f=0;
// Compteur semi inhibiteur : f pair => envoi
// Raison: un appui de la touche RC provoque 2 appels d'EvChar (suggestions pour clarifier ce problme bienvenues...)  :-(
  if (key==INKEY_Return && !fInhibRC)
    {
    if (f++ & 0x01) // Just one out of 2!
      {
      pFocusedControl=NULL;
      pt->SendMessage(WM_COMMAND,code,0);       // RC
      }
    }
 else if (key==INKEY_Tab && !fInhibTab)
    {
    pFocusedControl=this; // Changement de focus vers le suivant de la liste.
    pt->SendMessage(WM_COMMAND,GetKeyState(VK_SHIFT)<0?CM_PredFocus:CM_NextFocus,0);       // Tab
    }
  else
    TEdit::EvChar(key, repeatCount, flags);
  }

UINT TEditCR::EvGetDlgCode(MSG far *)
	 {
	 return DLGC_WANTALLKEYS;
	 }
/*-------------------------------------------------------------*/
/*                   Nouvelle classe TEditNumCR                */
/*--Systme----------------------------------------------------*/
// classe pour zone numrique

void TEditNumCR::EvChar(UINT key, UINT repeatCount, UINT flags)
  {
  if (IsNumericFloat(key)
    || key==INKEY_Backward ||  key==INKEY_Return ||  key==INKEY_Tab
    || key==' ')
    TEditCR::EvChar(key, repeatCount, flags);
  else
    MessageBeep(-1);
  }


inline void ConstructTEditNumCR(TEditNumCR *p, float x)
  {
  if (x!=MINFLOAT)
    p->SetValue(x);
  }
char* ConstructTEditNumCR(float x)
  {
  static char szBuff[25];
  if (x!=MINFLOAT)
    sprintf(szBuff,"%g",x);
  else
    * szBuff=0;
  return szBuff;
  }
TEditNumCR::TEditNumCR(TWindow *Parent, int Id, float xValue, int X, int Y,
           int W, int H, UINT Taille, BOOL Multi)
    : TEditCR(Parent, Id, ConstructTEditNumCR(xValue), X, Y, W, H, Taille, Multi)
  {
//  ConstructTEditNumCR(this,xValue);
  }
TEditNumCR::TEditNumCR(TWindow *Parent, int Id, float xValue, TRect r,
                   UINT Taille, BOOL Multi)
    : TEditCR(Parent, Id,ConstructTEditNumCR(xValue), r.left, r.top, r.Width(), r.Height(), Taille,
            Multi)
  {
//  ConstructTEditNumCR(this,xValue);
  }
DEFINE_RESPONSE_TABLE1(TEditNumCR, TEditCR)
 EV_WM_CHAR,
END_RESPONSE_TABLE;
/*--Nouvelles fonctionnalits----------------------------------*/

void TEditNumCR::SetValue(float xyValue)
  {
  char sz[25];
  sprintf(sz,"%g",xyValue);
  TEdit::SetText(sz);
  }
BOOL TEditNumCR::GetValue(unsigned int *pwValue)
  {
  if (!pwValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pwValue);
  }
BOOL TEditNumCR::GetValue(int *piValue)
  {
  if (!piValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,piValue);
  }
BOOL TEditNumCR::GetValue(char *pcValue)
  {
  if (!pcValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pcValue);
  }
BOOL TEditNumCR::GetValue(unsigned char *puValue)
  {
  if (!puValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,puValue);
  }
BOOL TEditNumCR::GetValue(float *pxyValue)
  {
  if (!pxyValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pxyValue);
  }
/*-------------------------------------------------------------*/
/*                   Nouvelle classe TComboBoxItems            */
/*--Systme----------------------------------------------------*/
TComboBoxItems::TComboBoxItems(TWindow* parent, int id, int x, int y,
      int w, int h, uint32 style, uint textLen, TModule* module):
                  TComboBox(parent, id, x, y, w, h, style, textLen,module){}
TComboBoxItems::TComboBoxItems(TWindow* parent, int id, TRect rPosition,
      uint32 style, uint textLen, TModule* module):
                  TComboBox(parent, id, rPosition.left, rPosition.top,
                    rPosition.Width(), rPosition.Height(), style, textLen,module){}
/*--Nouvelles fonctionnalits----------------------------------*/
DWORD TComboBoxItems::GetSelItem (void)
  {
  return GetItemData(GetSelIndex());
  }

int TComboBoxItems::AddItem(DWORD dItemValue, const char * string)
  {
  int iIndex=0;
  SetItemData(iIndex=AddString(string),dItemValue);
  return iIndex;
  }

int TComboBoxItems::SetSelItem(DWORD dItemValue)
  {
  int iN=GetCount();
  for (int k=0;k<iN;k++)
    {
    if (GetItemData(k)==dItemValue)
      return SetSelIndex(k);
    }
  return iN ? -iN:-1;
  }




// Obsolete, compatibilty purpose only
DEFINE_RESPONSE_TABLE1(TEditNumRC, TEdit)
 EV_WM_CHAR,
 EV_WM_KEYUP,
 EV_WM_GETDLGCODE,
END_RESPONSE_TABLE;

TEditNumRC::TEditNumRC(int iMessage, TWindow *Parent, int Id, char far *Texte, int X, int Y,
			  int W, int H, UINT Taille, BOOL Multi)
	 : TEdit(Parent, Id, Texte, X, Y, W, H, Taille, Multi)
{
  code=iMessage;
  pt=Parent;
}

void TEditNumRC::EvKeyUp(UINT key, UINT repeatCount, UINT flags)
{
	  switch(key)
		{
		case VK_RETURN :
		  EvChar(key, repeatCount, flags);
		  break;
		default :
		  TEdit::EvKeyUp(key, repeatCount, flags);
		  break;
		}
}

void TEditNumRC::EvChar(UINT key, UINT repeatCount, UINT flags)
  {
	if (key==8 || (key>='0' && key<='9') || key=='.' || key =='+' || key=='-')
	  TEdit::EvChar(key, repeatCount, flags);
	else if (key==13)
	{pt->SendMessage(WM_COMMAND,code,0);       // RC
	pt->SendMessage(code);}
	else MessageBeep(-1);
  }

UINT TEditNumRC::EvGetDlgCode(MSG far *)
	 {
	 return DLGC_WANTALLKEYS;
	 }

