//#include "baptiall.h"
//#pragma hdrstop

#define MODULE_NAME  "scaltool"
/*******************|*******************************************/
/*                  W M A T H D I V . C P P                    */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonction mathmatiques                  */
/*                                                             */
/*                                                             */
/* Fichier source WMATHDIV.CPP.                                */
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : t    1994/1995                        */
/***************************************************************/

// Inclusions bibliothques standards
#include <math.h>
#include <stdlib.h>
#include <string.h>

// Inclusions bibliothques Object Windows

// Inclusions bibliothques DOS
#include <stdio.h>

// Inclusion bibliothques Image

//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "scaltool.h"

#include "scaltool.h"
/*-------------------------------------------------------------*/
/*		                 constantes locales            */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	                   variables  exporter                */
/*-------------------------------------------------------------*/
float epsilon=0.01;
TReperage repSymetrieCentrale(complex(0,0),complex(-1,0),complex(0,-1)),
 repID(complex(0,0),complex(1,0),complex(0,1));
/*-------------------------------------------------------------*/
/*		                nouveaux types locaux           */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		                 variables locales             */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/
//int Escalmat(char *szMessage,int ref=0);
/*-------------------------------------------------------------*/
/*	                   fonctions  exporter                */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	                   fonctions scalaires                 */
/*-------------------------------------------------------------*/
unsigned long long_random (unsigned long l)
  {
  unsigned int base, degre0, degre1;

  if (l<=UINT_MAX)
    return (unsigned long)random((unsigned int)l);
  else
    {
    base =(unsigned int)sqrt((float)l);
    degre0=random(base);
    degre1=random(base);
    return degre1*base+degre0;
    }
  }
int EstUnePuissanceDe2(unsigned int u)
  {
  return u==2 || u==4 || u==8 || u==16 || u==32 || u==64 || u==128 ||
         u==256 || u==512 || u==1024 || u==2048 || u==4096 || u==8192 || u==16384;
  }
unsigned int PlusProchePuissanceDe2(unsigned int i)
  {
  if (!i)
    return 0;
  else
    return 1<<NFarRoundR(log(i)/M_LN2);
  }
/*-------------------------------------------------------------*/
/*	                   fonctions locales                   */
/*-------------------------------------------------------------*/
void TReperage::SetRa(complex zOrigine, complex zVecX, complex zVecY)
  {
  zXa=zVecX;
  zYa=zVecY;
  zOa=zOrigine;
  double dDeterminant=Determinant2colonnes(zXa,zYa);
  if (dDeterminant!=0.0)
    {
    zXb=complex(imag(zYa),-imag(zXa))/dDeterminant;
    zYb=complex(-real(zYa),real(zXa))/dDeterminant;
    zOb=complex(Determinant2colonnes(zYa,zOa),Determinant2colonnes(zOa,zXa))/dDeterminant;
    }
  else
    {
    zOb=zXb=zYb=complex(0.0,0.0);
    }
  }
void TReperage::SetRaFromTGeom(complex zG, double dAlpha, complex zC)
  {
  double dcos=cos(dAlpha), dsin=sin(dAlpha);
  zXa=256/real(zG)*complex(dcos,dsin);
  zYa=256/imag(zG)*complex(-dsin,dcos);
//  complex zVecx(dcos/zG.im,dsin/zG.re),  zVecy(-dsin/zG.re,dcos/zG.im);
  SetRa(zC-(zXa+zYa)/2,zXa,zYa);

//    imag(zC)-128*(imag(zVecx)+imag(zVecy))),zVecx,zVecy);
//  TReperage::SetRa(zC-128*(zVecx+zVecy),256*zVecx,256*zVecy);
//  complex zGx=complex(256/abs(zXa),256/abs(zYa));
  }

double TReperage::TellTGeom(complex *zG, double *dAlphaX, double *dAlphaY, complex *zC)
  {
  *dAlphaX=arg(zXa);
//  *dAlphaY=arg(zYa);
  *zG=complex(1/abs(zXa),1/abs(zYa));
  *zG =complex( real(*zG)* signe((real(zXa)+imag(zXa))/(cos(*dAlphaX)+sin(*dAlphaX))),
                imag(*zG)* signe((real(zYa)+imag(zYa))/(cos(*dAlphaX)-sin(*dAlphaX))));
//  *zC=zOa+128*(zXa+zYa);
  *zC=zOa+(zXa+zYa)*128;
  return fabs(*dAlphaY-*dAlphaX);
  }
double *TranfertMatrice(TReperage rep, double *pd)
  {
  pd[0]=real(rep.zXa);
  pd[1]=real(rep.zYa);
  pd[2]=real(rep.zOa);

  pd[3]=imag(rep.zXa);
  pd[4]=imag(rep.zYa);
  pd[5]=imag(rep.zOa);

  pd[6]=0;
  pd[7]=0;
  pd[8]=1;

  return pd;
  }
TReperage TranfertMatrice(double *pd, TReperage rep)
  {
  rep.SetRa(complex(pd[0],pd[3]),complex(pd[1],pd[4]),complex(pd[2],pd[5]));
  return rep;
  }
#if 0
#pragma message "Debug MultMatrice purposes only"
int MultdoubleMatrice(
    double *pLeft, UINT wNbLgnLeft, UINT wNbColLeft,
    double *pRight, UINT wNbLgnRight, UINT wNbColRight,
    double *pMult, UINT wNbLgnMult=0, UINT wNbColMult=0)
/*template <class double, UINT> int MultMatrice(
    double *pLeft, unsigned int wNbLgnLeft, unsigned int wNbColLeft,
    double *pRight, unsigned int wNbLgnRight, unsigned int wNbColRight,
    double *pMult, unsigned int wNbLgnMult=0, unsigned int wNbColMult=0)
*/
  {
  if ( wNbColLeft != wNbLgnRight)
    return MErreur("Matrix sizes do not match for multiplication",564);

  if (wNbLgnMult && wNbLgnMult!=wNbLgnLeft)
    return MErreur("Matrix sizes do not match for multiplication",567);
  if (wNbColMult && wNbColMult!=wNbColRight)
    return MErreur("Matrix sizes do not match for multiplication",567);

  if (!pLeft || !pRight || !pMult)
    return ECHEC;

/******************************************
     Return multiple of x and y in pMult
******************************************/
   unsigned int n, nr, nc, i, j, k ;
//   double *r=pMult ;
   n  = wNbColLeft; //x.nCols() ;
   nr = wNbLgnLeft; //x.nRows() ;
   nc = wNbColRight; //y.nCols() ;
   double *x=pLeft, *y=pRight, *r=pMult;
//   reset( nr, nc ) ;
   for ( i = 0 ; i < nr ; i++ ) {
      for ( j = 0 ; j < nc ; j++ ) {
         r[i*nc+j] = (double)0 ;
         for ( k = 0 ; k < n ; k++ )
            r[i*nc+j] += x[i*n+k] * y[k*nc+j] ;
      } // for j
   } // for i
   return SUCCESS;
} // matrix multOf

#endif


TReperage operator * (TReperage repLeft, TReperage repRight)
  {
  TReperage repMult;
  double  pdLeft[9], pdRight[9], pdMult[9];
  MultMatrice(TranfertMatrice(repLeft,pdLeft),3,3,
      TranfertMatrice(repRight,pdRight),3,3,
      pdMult,3,3);
  TranfertMatrice(pdMult,repMult);
#if 0 // obsolete
  double  pdLeft[3][3], pdRight[3][3], pdMult[3][3];
/*
  pdLeft[0][0]=zXa.Real();
  pdLeft[0][1]=zXa.Imag();
  pdLeft[0][2]=0;
  pdLeft[1][0]=zYa.Real();
  pdLeft[1][1]=zYa.Imag();
  pdLeft[1][2]=0;
  pdLeft[2][0]=zYa.Real();
  pdLeft[2][1]=zYa.Imag();
  pdLeft[2][2]=0;
*/
  pdLeft[0][0]=real(repLeft.zOa);
  pdLeft[1][0]=imag(repLeft.zOa);
  pdLeft[2][0]=0;
  pdLeft[0][1]=real(repLeft.zXa);
  pdLeft[2][1]=imag(repLeft.zXa);
  pdLeft[1][1]=0;
  pdLeft[0][2]=real(repLeft.zYa);
  pdLeft[1][2]=imag(repLeft.zYa);
  pdLeft[2][2]=1;

  pdRight[0][0]=real(repRight.zOa);
  pdRight[1][0]=imag(repRight.zOa);
  pdRight[2][0]=0;
  pdRight[0][1]=real(repRight.zXa);
  pdRight[2][1]=imag(repRight.zXa);
  pdRight[1][1]=0;
  pdRight[0][2]=real(repRight.zYa);
  pdRight[1][2]=imag(repRight.zYa);
  pdRight[2][2]=1;

#pragma message "Revoir code"

  double *pdKlaatu = &(pdLeft[0][0]);
  double *Barada = &(pdRight[0][0]);
  double *Nicto = &(pdMult[0][0]);
  MultMatrice(pdKlaatu,3,3,Barada,3,3,Nicto,3,3);

/*  repRight.zXa=complex(pdRight[0][0],pdRight[1][0]);
  repRight.zYa=complex(pdRight[0][1],pdRight[1][1]);
  repRight.zOa=complex(pdRight[0][2],pdRight[1][2]);*/

  repMult.SetRa(
      complex(pdRight[0][2],pdRight[1][2]),
      complex(pdRight[0][0],pdRight[1][0]),
      complex(pdRight[0][1],pdRight[1][1])
      );
#endif
  return repMult;
  }

void TReperage::SetSymetrieHoriz(double d)
  {
  SetRa(complex(0,2*d),complex(1,0),complex(0,-1));
  }

