#include "baptiall.h"
#pragma hdrstop

/*******************|*******************************************/
/*                  W C O N T R O L E . C                      */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils de contrle d'excution          */
/*                     (erreurs, traage...)                   */
/*                                                             */
/* Fichier source WCONTROLE.C.                                 */
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : t 1994/1995                           */
/***************************************************************/
#define MODULE_NAME "SYSCTR.CPP"

/*
// Inclusions bibliothques DOS
#include <conio.h>
#include <dir.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
*/
// Inclusion bibliothques Image

//  Inclusions bibliothques Iris
#include "base.h"

#include "sysctr.h"
#include "strutil.h"

#if _Windows
#include "wsysutil.h"
#include "wsystool.h"
#endif
/*-------------------------------------------------------------*/
/*		       constantes locales                                */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	              variables  exporter                          */
/*-------------------------------------------------------------*/
char far szNomTraceur[MAXPATH]="wtraceur.txt";
int fHardCopy=OFF;
int fTracage=MARCHE, fRuban=MARCHE;
int fErrorBLF=ON;
int fErrorALF=ON;
char szErrorDefaultHeader[]="Error";
char far szHardCopyFile[MAXPATH]="hardcopy.img";
char *szErrorHeader=NULL;
unsigned int wMessPause=1;

#if _Windows
/*
#include <owl\framewin.h>
#include <owl\point.h>
*/
unsigned int
    wMessIconExclamation=MB_ICONEXCLAMATION,
    wMessSystemModal=MB_SYSTEMMODAL;
//unsigned int wErrorIcons= wMessOK | wMessIconExclamation | wMessSystemModal;
//unsigned int wErrorIcons= wMessOK | wMessIconExclamation;
#else
unsigned char uRubanPosition=0;
unsigned char uRubanWidth=81;

unsigned int wMessIconExclamation=2, wMessSystemModal=4;
#endif
// unsigned int wMessOK=1 (bit) has been replaced by wMessPause (boolean)

unsigned int wErrorIcons= wMessIconExclamation; // | wMessSystemModal;
/*-------------------------------------------------------------*/
/*		       variables locales                       */
/*-------------------------------------------------------------*/
/////////////////////////////////////////////////////////////////
/*   Ces prototypes ont leurs fonctions dans wsysctr ou dsysctr
selon que le projet est crit pour DOS ou pour Windows. */
int ActiveRubanLocal(char szTitre[]);
int AvanceRubanLocal(unsigned char uAv);
int FermeRubanLocal();
/*-------------------------------------------------------------*/
/*	              fonctions  exporter                     */
/*-------------------------------------------------------------*/
void SetErrorLineFeeds(int fBefore, int fAfter)
  {
  fErrorBLF=fBefore;
  fErrorALF=fAfter;
  }
void SetErrorHeader(char *sz)
  {
  SetString(&szErrorHeader,sz);
  }

void SetErrorIcons(unsigned int fuStyle)
  {
  wErrorIcons=fuStyle;
  }
int _Erreur(char far *szMessage, unsigned int wRef)
  {
  if (wRef)
    {
    char *szMessRef=(char *)malloc(strlen(szMessage)+32);
    sprintf(szMessRef,"%s (Ref. %d).",szMessage,wRef);
    Erreur (szMessRef);
    free(szMessRef);
    }
  else
    {
    _Trace(szMessage,wRef);
    Erreur (szMessage);
    }
  return FAUX;
  }
/*
int Erreur(char far *szMessage, char *szTexte, unsigned int wRef)
  {
  char *szMessTxt=(char *)malloc(strlen(szMessage)+strlen(szTexte)+1);
  if (szMessTxt==NULL)
    return Erreur("Message d'erreur irralisable.");
  sprintf(szMessTxt,"%s%s",szMessage,szTexte);
  Erreur(szMessTxt,wRef);
  free(szMessTxt);
  return ECHEC;
  }

int Erreur(char far *szMessage, int iValue, unsigned int wRef)
  {
  char *szMessVal=(char *)malloc(strlen(szMessage)+16);
  if (szMessVal==NULL)
    return Erreur("Message d'erreur irralisable.");
  sprintf(szMessVal,"%s%d",szMessage,iValue);
  Erreur(szMessVal,wRef);
  free(szMessVal);
  return ECHEC;
  }
int Erreur(char far *szMessage, float xyValue, unsigned int wRef)
  {
  char *szMessVal=(char *)malloc(strlen(szMessage)+64);
  if (szMessVal==NULL)
    return Erreur("Message d'erreur irralisable.");
  sprintf(szMessVal,"%s%g",szMessage,xyValue);
  Erreur(szMessVal,wRef);
  free(szMessVal);
  return ECHEC;
  }
*/
/*-------------------------------------------------------------*/
int ErreurCode(unsigned int wRef)
  {
  return Erreur("Erreur code","",wRef);
  }
int ErreurAllocation(unsigned int wRef)
  {
  return Erreur("Erreur allocation","",wRef);
  }
/*-------------------------------------------------------------*/
int _Trace(char *szMessage, unsigned int wRef)
  {
  if (!fTracage) return SUCCESS;
  if (wRef)
    {
    char *szMessRef=(char *)malloc(strlen(szMessage)+32);
    sprintf(szMessRef,"%s (Ref. %d).",szMessage,wRef);
    _Trace(szMessRef,0);
    free(szMessRef);
    return SUCCESS;
    }

  FILE *traceur;
  traceur = fopen(szNomTraceur,"at");
  if (traceur==NULL) return FAILURE;
  fprintf(traceur, "%s\n", szMessage);
  fclose(traceur);
  return SUCCESS;
  }
/*-------------------------------------------------------------*/
/*
void Trace(char far *szMessage, char *szTexte, int wRef)
  {
  if (!fTracage) return;
  char *szMessTxt=(char *)malloc(strlen(szMessage)+strlen(szTexte)+1);
  if (szMessTxt==NULL)
    {
    Erreur("Traage irralisable.");
    return;
    }
  sprintf(szMessTxt,"%s%s",szMessage,szTexte);
  Trace(szMessTxt,wRef);
  free(szMessTxt);
  return;
  }

/*-------------------------------------------------------------*//*

void Trace(char far *szMessage, float xyValue, int wRef)
  {
  char *szMessVal=(char *)malloc(strlen(szMessage)+64);
  if (szMessVal==NULL)
    {
    Erreur("Message d'erreur irralisable.");
    return;
    }
  sprintf(szMessVal,"%s%g",szMessage,xyValue);
  Trace(szMessVal,wRef);
  free(szMessVal);
  return;
  }
/*-------------------------------------------------------------*/
void Trace (char far *szMessage, unsigned char far *auTable, unsigned int w,
    unsigned int wRef)
  {
  if (!auTable)
    Trace(szMessage,"(Table vide)",wRef);
  else
    {
    char szTamp[USUALMAXLENSTRING];
    _Trace(szMessage,wRef);
    for (unsigned wi=0;wi<w;wi++)
      {
      sprintf(szTamp,"%3d : %d",wi,auTable[wi]);
      Trace(szTamp);
      }
    }
  }
/*-------------------------------------------------------------*/
int ActiveTracage(char T)
  {
  FILE *traceur;
  fTracage=T;
  if (fTracage)
    {
    if ((traceur = fopen(szNomTraceur,"wt"))==NULL)
      return (fTracage=Erreur("Ouverture impossible du fichier de traage "));
    time_t tmElapsed;
    time(&tmElapsed);
    struct tm *tmLocal=localtime(&tmElapsed);
    fprintf(traceur, "Ouverture du traceur le %d/%d/%d  %d:%d\'%d\".\n",
        tmLocal->tm_mday, tmLocal->tm_mon, tmLocal->tm_year, tmLocal->tm_hour, tmLocal->tm_min, tmLocal->tm_sec);
    fclose(traceur);
    }
  return SUCCES;
  }
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
char ActiveRuban(char *szTitre)
  {
  return !fRuban || ActiveRubanLocal(szTitre);
  }
/*-------------------------------------------------------------*/
char AvanceRuban(unsigned char uAv)
  {
  static uAvancement=101;
  if (fRuban && uAv!=uAvancement)
    return  AvanceRubanLocal(uAvancement=uAv);
  else
    return SUCCES;
  }
/*-------------------------------------------------------------*/
char FermeRuban()
  {
  return !fRuban || FermeRubanLocal();
  }
/*-------------------------------------------------------------*/
int MemoTableau(unsigned char *pElement, unsigned int wN,
		unsigned char * &pMemoElement)
  {
  if ((pMemoElement = (unsigned char *)malloc(wN))!=NULL)
    {
    unsigned int i=0;
    do
      pMemoElement[i++]=*pElement++;
    while (i!=wN);
    return SUCCES;
    }
  else
    return ECHEC;
  }

int OublieTableau(unsigned char * &pMemoElement)
  {
  if (pMemoElement)
    {
    free(pMemoElement);
    pMemoElement=NULL;
    return SUCCES;
    }
  else
    return ECHEC;
  }


void TmpCopyIniFile(char *szFile)
  {
  char szTmpBackup[MAXPATH];
  SetIniSourceFile(szTmpBackup,sizeof(szTmpBackup),szFile);
  TmpCopyTextFile(szTmpBackup);
  }
void TmpCopyTextFile(char *szSource)
   {
   char *szTmpName=tempnam(".","back");
   Trace("Backup of ",szSource,285);
   Trace("... is in file: ",szTmpName,286);
   CopyTextFile(szSource,szTmpName);
   free(szTmpName);
   }
int CopyTextFile(char *szSource,char *szTarget)
  {
  FILE *pfilSource=fopen(szSource,"r+t"), *pfilTarget=fopen(szTarget,"w+t");
  if (!pfilSource || !pfilTarget)
    return FAILURE;
  int iC;
  while ((iC=getc(pfilSource))!=EOF)
    putc(iC,pfilTarget);
  fclose(pfilSource);
  fclose(pfilTarget);
  return SUCCESS;
  }
int ModuleErreur(char *szModuleName, char *szMessage,int ref)
  {
  char *MessageLocal;
  int fRes;
  MessageLocal=(char *)malloc(strlen(szMessage)+20);
  sprintf(MessageLocal,"%s (%s)",szModuleName,szMessage);
  fRes= _Erreur(MessageLocal,ref);
  free(MessageLocal);
  return fRes;
  }
#if _Windows
/*-----------------------------------------------------------------------*/
/*                     Classes  exporter                                */
/*--TRuban---------------------------------------------------------------*/
class TRuban : public TFrameWindow
  {
  unsigned char uPct;              // pourcentage d'affichage
  virtual void TRuban::Paint(TDC& dc, BOOL, TRect&);
  public :
    TRuban(TWindow *Parent, char *szTitre);
    ~TRuban();
    void Maj(unsigned char uPct_user);
  };

TRuban  far *pRuban=NULL;
/*-----------------------------------------------------------------------*/
/*                   Nouvelle classe TRuban                              */
/*--Systme--------------------------------------------------------------*/
TRuban::TRuban(TWindow *Parent, char *szTitre)
 : TFrameWindow(Parent,szTitre)
  {
  Attr.Style =WS_BORDER | WS_CAPTION |WS_VISIBLE | WS_OVERLAPPED |WS_POPUP;
  Attr.W = 200;
  Attr.H = 50+iHauteurTitre;
  Attr.X = Parent->Attr.W/2-Attr.W/2;
  Attr.Y = Parent->Attr.H/2-Attr.H/2;
  uPct = 0;
  Create();
  }
/*-----------------------------------------------------------------------*/
TRuban::~TRuban()
  {
  CloseWindow();
  }
/*-----------------------------------------------------------------------*/
void TRuban::Paint(TDC& dc, BOOL erase, TRect& rect)
  {
  TFrameWindow::Paint(dc, erase,rect);
  unsigned char uHaut=(Attr.H-iHauteurTitre)/3, uBas=(Attr.H-iHauteurTitre)*2/3, uGauche=16, uDroit=Attr.W-16;
  unsigned char uAbscisse=0;
  TSize  sTailleCadreBande(uDroit-uGauche+1,uBas-uHaut+1);

  dc.SelectStockObject(NULL_BRUSH);
  dc.Rectangle(TRect(uGauche,uHaut,uDroit,uBas));
  uAbscisse=(sTailleCadreBande.cx-2)*uPct/100;
  dc.FillRect(TRect(uGauche+1,uHaut+1,uGauche+1+uAbscisse,uBas-1),TBrush(TColor(118,190,243)));
  dc.FillRect(TRect(uGauche+1+uAbscisse,uHaut+1,uDroit-1,uBas-1),TBrush(TColor::White));
  dc.SetBkMode(TRANSPARENT); dc.SetTextAlign(TA_CENTER | TA_BOTTOM);
  char buf[10]; wsprintf(buf, "%d %%", uPct);
  dc.TextOut(Attr.W/2, uBas-1, buf);
  }
/*--Nouvelles fonctionalits---------------------------------------------*/
void TRuban::Maj(unsigned char uPct_user)
  {
  TClientDC dc(*this);
  uPct = uPct_user;
  Paint(dc,FALSE,TRect(0, 0, Attr.W, Attr.H));
  }
/*-----------------------------------------------------------------------*/
/*       		Fonctions  exporter                             */
/*-----------------------------------------------------------------------*/
int Erreur (char *message)
  {
  if (wMessPause)
    {
    if (!szErrorHeader)
      SetErrorHeader(szErrorDefaultHeader);
    if (pFenetreControle)
      pFenetreControle->MessageBox(message, szErrorHeader, wErrorIcons);
    else
      ::MessageBox(NULL,message, szErrorHeader, wErrorIcons);
    }
  return ECHEC;
  }
/*-----------------------------------------------------------------------*/
int ActiveRubanLocal(char szTitre[])
  {
  pRuban=new TRuban(pFenetreControle, szTitre);
  return SUCCES;
  }
/*-----------------------------------------------------------------------*/
int AvanceRubanLocal(unsigned char uAv)
  {
  if (!pRuban)
    return FAILURE;
  else
    {
    pRuban->Maj(uAv);
    return SUCCES;
    }
  }
/*-----------------------------------------------------------------------*/
int FermeRubanLocal()
  {
  if (!pRuban) return Erreur("Ruban dja ferm. (131)");
  delete pRuban;
  pRuban=NULL;
  return SUCCES;
  }
#else     // Version DOS
int Erreur (char *message)
  {
  if (!szErrorHeader)
    SetErrorHeader(szErrorDefaultHeader);
  printf("%s%s%s%s%s%s",fErrorBLF?"\n":"",
        strlen(szErrorHeader)?szErrorHeader:"",
        wErrorIcons&wMessIconExclamation?" [!!!] ":"",
        message,
	wErrorIcons&wMessPause?"\n(hit any key)":"",fErrorALF?"\n":"");
  if (wMessPause) getch();
  return 0;
  }
/*
0        1         2         3         4         5         6         7
123456789012345678901234567890123456789012345678901234567890123456789012345678901
  80 colonnes
*/
int ActiveRubanLocal(char *szTitre)
  {
  printf("\n%s",szTitre);
  uRubanWidth=80-strlen(szTitre)+1;  // We add "+1" for a nice ending effect.
//  xRubanStep=(float)uRubanWidth/100;
  uRubanPosition=0; // Number of points written
  return SUCCES;
  }
/*-----------------------------------------------------------------------*/
int AvanceRubanLocal(unsigned char uAv)
  {
  while ((float)uAv/100*uRubanWidth >= uRubanPosition+2)
    {printf(".");uRubanPosition++;}
  return SUCCES;
  }
/*-----------------------------------------------------------------------*/
int FermeRubanLocal()
  {
  printf("\n");
  uRubanPosition=0;
  uRubanWidth=81;
  return SUCCES;
  }


#endif // _Windows
int ModuleStringMerge
    (char *szModule, char *szMessage, unsigned int wRef,
    int (*fAction)(char *, unsigned int) )
  {
  char *szMessVal=(char *)malloc(15+strlen(szMessage)+strlen(szModule));
  if (!szMessVal) return FAILURE;
  sprintf(szMessVal,"(in module %s): %s",szModule,szMessage);
  int f=fAction(szMessVal,wRef);
  free(szMessVal);
  return f;
  }

